      subroutine addtxt 
!                                                                      
!    addtxt plottet zusaetzlichen Text im Bild                         
!                                                                      
!    M. Alflen   12.9.89                                               
!                                                                      
!      modifiziert fuer variablen offset zwischen Rahmen und Plot            
!      M. Alflen 15.12.89                                                    
!                                                                      
!      Steuerparametersatz erweitert (center, underline, box etc.)     
!      M. Alflen 4.7.1990                                              
!                                                                      
     use comalp
     implicit none 
                                                                       
     logical       l_ask,l_text,l_newcoo,l_top,l_topg,                 &
                   l_bot,l_botF,l_botgg,l_botG,l_box,l_boxB,           &
                   l_under,l_over,l_center,l_fort,l_next,l_noch,l_term 
     logical       b_exist 
     character*132 chin,querytype,chstr,chcom,filnam*75,               &
                   wrb*1,ch1*1,IBSL*1                                  
     character*256 ch256,textstore,ctext,cfield 
                                                                       
     real    xscal,yscal,G1,G2,G3,G4,G5,G6,dist,distb,WINKEL,          &
             ALPH,ALPHA,ALPHA0,ROT,ROTB                                
     integer i,j,iend,kch,ipp,n_frame,n_line,id,nn,                    &
             k,ktxt,nmult,nunit,istore,mstore,i0                       
     real    xtop,ytop,xbot,ybot,ybotF,xtopg,ytopg,xbotg,ybotg,        &
             yende,xende,yw,xw,yw1,xw1,                                &
             gg1,gg2,x1,y1,x2,y2,zh,bg1,hz,hw,                         &
             xd,yd,xd2,yd2,out,h,ux1,uy1,ux2,uy2,ox1,oy1,ox2,oy2,      &
             dx1,dy1,dx2,dy2                                           
     dimension out(32),textstore(48) 
                                                                       
                                                                       
     integer nold_pen,noldt_pen,n_textp,                               &
             n_topp,n_toppG,n_toppF,n_toppgg,                          &
             n_boxp,n_boxpB,n_underp,n_overp,mdir                      
                                                                       
!     l_def : default Werte nehmen                                      
!      write(6,'(a,10L3)')                                              
!     & '##### subroutine addtext',l_inter,l_def,l_scal                 
                                                                        
      IBSL=char(92) 
      i0=ichar('0') 
      l_ask= .not. (l_inter .and. l_def) 
      if (.not.l_inter.and.l_ask)wrb='r' 
      if (l_inter.and.l_ask)wrb='w' 
      if (l_inter.and..not.l_ask)wrb='d' 
!                                                                       
                        ! Startwerte berechnen                          
      if (l_scal) then 
                                     ! Skalierung                       
       xscal=gx/(xend-xanf) 
       yscal=gy/(yend-yanf) 
                                     ! Startpunkt linke obere Ecke      
       G1=GX+XRAND+xoff_r 
       G2=YRAND+yoff_b+gy 
                                     ! Buchstabengroesse                
       G3=HX 
       G4=HY 
                                      ! Zeilenabstand                   
       distb=1.5*hy 
       dist=distb 
                                     ! Winkel                           
       WINKEL=3.141593/180. 
       ALPH=270.*WINKEL 
       ALPHA=ALPH 
       ALPHA0=0. 
       ROT=0. 
       ROTB=0. 
       G5=COS(ALPHA) 
       G6=SIN(ALPHA) 
!      write(6,'(a,4f10.3)')' addtext ALPH,G5,G6=',ALPH,G5,G6           
                                                                        
                                     ! Wiederholungsfaktor              
       nmult=1 
       l_top=.false. 
       l_topg=.false. 
       l_botgg=.false. 
       l_botG=.false. 
       n_frame=4 
      end if 
                                                                        
!      xtop=-1.e6                                                       
!      ytop=1.e6                                                        
!      xbot=1.e6                                                        
!      ybot=-1.e6                                                       
!      xtopg=-1.e6                                                      
!      ytopg=1.e6                                                       
!      xbotg=1.e6                                                       
!      ybotg=-1.e6                                                      
                                                                        
! text: c/x,y,hx,hy,angle,dist,b,$,@,u,o,f,F/n; text     file=[ ]       
!* termination line for extra text  (first letter a *)                  
      querytype=                                                        &
     &'text: c/x,y,hx,hy,angle,dist,b,$,@,u,o,f,F/n; text    file=['    
       chstr=' ' 
       chcom='extra_text' 
       call ask1string(querytype,chstr,                                 &
     &                              chcom,NPL,NRD,NWR,NBA,wrb)          
       filnam=chstr 
       inquire(file=filnam,exist=b_exist) 
                              !  reading from term/batch file           
       if (.not.b_exist) then 
        nunit=nrd 
        if(wrb.eq.'r'.or.wrb.eq.'d')l_term=.true. 
       else 
        open(unit=lpr,file=filnam,status='old',err=300) 
        nunit=lpr 
        l_term=.false. 
       end if 
                                                                        
      istore=0 
      do while (.true.) 
       ctext=' ' 
       cfield=' ' 
       l_newcoo=.true. 
       istore=istore+1 
                                                                        
       if(nunit.eq.lpr) then 
        read(nunit,'(a)',end=198)cfield 
        if (cfield(1:1) .eq. '*') goto 198 
        goto 199 
  198   nunit=nrd 
       end if 
       cfield=' ' 
       if(wrb.ne.'d') read(nunit,'(a)',end=300)cfield 
       if(cfield.eq.' ')then 
         write(NBA,'(a)')                                               &
     &    '* termination line for extra text  (first letter  *)'        
                        !  end of additional text                       
        go to 300 
       end if 
  199  continue 
       if (.not. l_inter)         write(nwr,'(1x,a)')cfield 
       if (l_inter .and. l_term ) write(nba,'(a)')cfield 
                                                                        
       if (cfield(1:1) .eq. '*') then 
                                                                        
        if(l_inter .and. l_term )then 
!          write(6,'(a)')' backspace(NBA)'                              
          backspace(NBA) 
          write(NBA,'(a)')                                              &
     &    '* termination line for extra text  (first letter a *)'       
        end if 
                        !  end of additional text                       
        go to 300 
       end if 
                                                                        
                ! Zeichen vor ;                                         
       iend=1 
                ! gefundene Schaltzeichen                               
       kch=0 
       l_bot=.false. 
       l_center=.false. 
       l_fort=.false. 
       l_box=.false. 
       l_boxB=.false. 
       l_under=.false. 
       l_over=.false. 
       l_next=.false. 
       l_noch=.true. 
       n_textp=0 
       textstore(istore)=cfield 
                                                                        
       do while (iend .le. 80 .and. l_noch) 
        ch1=cfield(iend:iend) 
                                                                        
        mdir=+1 
                                                               ! Fortset
        if (ch1.eq.'+'.or.ch1.eq.'-'.or.ch1.eq.'&') then 
         kch=kch+1 
         cfield(iend:iend)=' ' 
         l_fort=.true. 
         if(ch1.eq.'-')mdir=-1 
         n_line=n_line+1 
        end if 
                                                                        
                                 ! Zentrieren                           
        if (ch1.eq.'c') then 
         kch=kch+1 
         cfield(iend:iend)=' ' 
         l_center=.true. 
         l_fort=.false. 
        end if 
                                                                        
!        write(6,'(a,a1)')' ch1=',ch1                                   
        if (ch1.eq.'b'.or.ch1.eq.'B'.or.ch1.eq.'u'.or.ch1.eq.'o'        &
        .or.ch1.eq.'f'.or.ch1.eq.'F'.or.ch1.eq.'g'.or.ch1.eq.'G'        &
     &   .or.ch1.eq.'@'.or.ch1.eq.'$') then                             
                                                                        
         kch=kch+1 
         cfield(iend:iend)=' ' 
         if (cfield(iend+1:iend+1).eq.' ') then 
          ipp=0 
         else 
          ipp=ichar(cfield(iend+1:iend+1))-i0 
          if (ipp .ge. 0 .and. ipp .le. 9)then 
!          number                                                       
           iend=iend+1 
           kch=kch+1 
           cfield(iend:iend)=' ' 
           i=ichar(cfield(iend+1:iend+1))-i0 
           if (i.ge.0.and.i.le.9) then 
!           second number follows                                       
            iend=iend+1 
            kch=kch+1 
            cfield(iend:iend)=' ' 
            ipp=10*ipp+i 
           end if 
          else 
           ipp=0 
          end if 
         end if 
                                                                        
         if (ch1.eq.'@')n_textp=ipp 
         if (ch1.eq.'B') then 
          l_boxB=.true. 
          l_under=.false. 
          l_over=.false. 
          n_boxpB=ipp 
         else if (ch1.eq.'b') then 
          l_box=.true. 
          l_under=.false. 
          l_over=.false. 
          n_boxp=ipp 
         else if (ch1.eq.'u') then 
          l_under=.true. 
          l_box=.false. 
          l_over=.false. 
          n_underp=ipp 
         else if (ch1.eq.'o') then 
          l_under=.false. 
          l_box=.false. 
          l_over=.true. 
          n_overp=ipp 
         else if (ch1.eq.'f'.or.ch1.eq.'F') then 
          if (ch1.eq.'f') then 
           l_bot=.true. 
           n_topp=ipp 
          else if (ch1.eq.'F') then 
           l_botF=.true. 
           n_toppF=ipp 
          end if 
          l_top=.true. 
          xtop=-1.e6 
          ytop=1.e6 
          xbot=1.e6 
          ybot=-1.e6 
          n_topp=ipp 
         end if 
         if (ch1.eq.'g'.or.ch1.eq.'G') then 
          if (ch1.eq.'g') then 
           l_botgg=.true. 
           n_toppgg=ipp 
          else if (ch1.eq.'G') then 
           l_botG=.true. 
           n_toppG=ipp 
          end if 
          l_topg=.true. 
          xtopg=-1.e6 
          ytopg=1.e6 
          xbotg=1.e6 
          ybotg=-1.e6 
         end if 
         if(ch1.eq.'$') then 
          nmult=ipp 
         end if 
        end if 
                                                                        
        if (ch1.eq.';') then 
         l_noch=.false. 
         kch=kch+1 
        else 
         iend=iend+1 
        end if 
       end do 
                                                                        
!                                                                       
       if (kch .eq. iend) l_next=.true. 
                                                  ! automatischer Vorsch
       l_next=l_next .and. .not.l_fort 
                                                   ! neue Koordinaten   
       l_newcoo= .not. (l_next .or. l_fort) 
!                                                                       
                                   ! text extrahieren                   
       id=min(npl,80-iend) 
       l_text=.false. 
       do i=1,id 
        ch1=cfield(i+iend:i+iend) 
        if (ch1.ne.' ') l_text=.true. 
        ctext(i:i)=ch1 
       end do 
!                                                                       
                                                                        
                                                    !  neue Koordinaten 
       if (l_newcoo) then 
         rot=ROTB 
         dist=distb 
        n_line=1 
        id=min(npl,iend-1) 
        i=1 
        j=1 
        chin=' ' 
        do while(i.le.id) 
!        chin=cfield(1:id)                                              
         chin(i:i)=cfield(j:j) 
         if(cfield(j:j).eq.','.and.cfield(j+1:j+1).eq.',') then 
          chin(i+1:i+1)='0' 
          i=i+1 
         end if 
         i=i+1 
         j=j+1 
        end do 
!        write(6,'(a)')chin(:50)                                        
        call trlch(id+1,chin,nn,OUT) 
                                                                        
        if(.not.l_center) then 
         if ( nn .ge. 1)                                                &
     &    G1=GX+XRAND+xoff_r-(OUT(1)-XANF)*XSCAL                        
        end if 
        if ( nn .ge. 2)                                                 &
     &   G2=YRAND+yoff_b+(OUT(2)-YANF)*YSCAL                            
        if ( nn .ge. 3 .and. out(3) .ge. 0.1) G3=OUT(3) 
         hx=G3 
        if ( nn .ge. 4 .and. out(4) .ge. 0.1) G4=OUT(4) 
         hy=G4 
                                                                        
        if ( nn .ge. 5 .and. out(5) .ge. 1.) then 
         rot=out(5)*winkel 
        end if 
         ALPHA=ALPH+ROT 
         G5=COS(ALPHA) 
         G6=SIN(ALPHA) 
        if ( nn .ge. 6 .and. out(6) .ge. 0.0) then 
          dist=out(6) 
        else 
         dist=1.5*hy 
        end if 
       end if 
                                                                        
       noldt_pen=-1 
       call pluma(noldt_pen) 
       call pluma(n_textp) 
                                                  ! Text plotten        
       if (l_text.and.ctext.ne.' ') then 
                                              ! Zeichenzahl bestimmen   
        k=256 
        do while (ctext(k:k).eq.' '.and. k.gt.1) 
         k=k-1 
        end do 
        ktxt=k 
!        write(6,'(a,a)')'ctext=',ctext(:ktxt)                          
        j=1 
        do while(ctext(j:j).eq.' ') 
         j=j+1 
        end do 
                                                                        
        if(k.gt.1)then 
        if(ctext(k-1:k-1).eq.IBSL.and.ctext(k:k).eq.'&') then 
         ktxt=ktxt-2 
  100    read(nunit,'(a)')cfield 
         j=index(cfield,'\\&') 
                                               ! Zeichenzahl bestimmen  
         k=256 
         do while (cfield(k:k).eq.' '.and. k.gt.1) 
          k=k-1 
         end do 
         if(ktxt+k.gt.256)then 
          write(NWR,'(2a,i3,a)')'**warning** characters lost ','        &
     &    (too many per line :',ktxt+k,' > 80)'                         
          k=256-ktxt 
         end if 
         do nn=1,k 
          ctext(ktxt+nn:ktxt+nn)=cfield(nn:nn) 
         end do 
         i=index(textstore(istore),';') 
         ch256=textstore(istore)(:i)//ctext 
         textstore(istore)=ch256 
!         write(6,'(a,a)')'ch256=',ch256                                
         if(j.gt.0)then 
          ktxt=ktxt+k-2 
          goto 100 
         end if 
         ktxt=ktxt+k 
        end if 
        end if 
                                                                        
!         write(6,'(a,i2,a2,/a)')'textstore(',istore,')=',              
!     &         textstore(istore)(:ktxt+j)                              
!        write(6,'(a,a)')'ctext=',ctext(:ktxt)                          
                                                                        
                                      ! text zentrieren                 
        if (l_center) then 
         CALL TXTPLO (0.,0.,-1,ctext,ktxt,G3,G4,0.,-1.,yw,xw,zh) 
         xw1=-xw 
         yw1=-yw 
         if (xw1 .gt. gx) then 
          write(nwr,9000)char(7) 
         else 
          xw=(gx-xw1-float(nmult)*0.0125)*0.5 
          g1=xrand+gx+xoff_r-xw 
         end if 
!        write(6,'(a,8f10.2)')' g1,xw,yw,gx,xrand,xoff_r=',             
!     &                         g1,xw,yw,gx,xrand,xoff_r                
        end if 
                                                                        
!        write(6,'(a,2l5,8f10.2)')'l_next,l_fort=',l_next,l_fort        
                                      ! automatischer Vorschub          
        if ( l_next ) then 
         l_newcoo=.false. 
         g1=g1-sin(rot)*dist*1.5 
         g2=g2-cos(rot)*dist*1.5 
        end if 
                                                                        
                                      ! Fortsetzungszeile               
        if (l_fort) then 
         g1=g1-mdir*sin(rot)*dist*1.5 
         g2=g2-mdir*cos(rot)*dist*1.5 
!         write(6,'(a,8f10.2)')' g2,g1=',g2,g1                          
        end if 
                                                                        
        do i=1,nmult 
         gg1=g1+float(i-1)*0.0125 
         gg2=g2+float(i-1)*0.0125 
         CALL TXTPLO (gg2,gg1,-1,ctext,ktxt,G3,G4,G5,G6,yende,xende,zh) 
        end do 
                                                                        
        if (l_top) then 
         xd=-g6*hx+g5*zh 
         yd=2.*g6*zh-g5*hx 
         xd2=-g6*hx+2.*g5*zh 
         yd2=g6*zh-g5*hx 
         if (g1+xd2 .gt. xtop) xtop=g1+xd2 
         if (g2+yd2 .lt. ytop) ytop=g2+yd2 
         if (xende-xd .lt. xbot) xbot=xende-xd 
         if (yende-yd .gt. ybot) ybot=yende-yd 
        end if 
                                                                        
        if (l_topg) then 
         xd=-g6*hx+g5*zh 
         yd=2.*g6*zh-g5*hx 
         xd2=-g6*hx+2.*g5*zh 
         yd2=g6*zh-g5*hx 
         if (g1+xd2 .gt. xtopg) xtopg=g1+xd2 
         if (g2+yd2 .lt. ytopg) ytopg=g2+yd2 
         if (xende-xd .lt. xbotg) xbotg=xende-xd 
         if (yende-yd .gt. ybotg) ybotg=yende-yd 
         if(l_top) then 
          h=float(n_frame*2)*0.0125 
          if (xtop+h .gt. xtopg) xtopg=xtop+h*4 
          if (ytop-h .lt. ytopg) ytopg=ytop-h*4 
          if (xbot-h .lt. xbotg) xbotg=xbot-h*4 
          if (ybot+h .gt. ybotg) ybotg=ybot+h*4 
         end if 
        end if 
!        write(6,'(a,4L4,i6)')' l_topg,l_botG,l_top,l_botgg,n_toppgg=', 
!     &                         l_topg,l_botG,l_top,l_botgg,n_toppgg    
       end if 
                           !  naechsten Text einlesen                   
      end do 
                           !  Textende                                  
  300 continue 
                                                                        
                           ! flaeche zeicnen                            
       if (l_botG) then 
        l_topg=.false. 
        call PFUMA(n_toppG) 
        call traa(ybotg,xbotg,0) 
        call traa(ybotg,xtopg,1) 
        call traa(ytopg,xtopg,1) 
        call traa(ytopg,xbotg,1) 
        nold_pen=n_toppG 
        call pluma(nold_pen) 
       end if 
                                                                        
                            ! Rahmen zeichnen   capital F               
       if (l_botgg) then 
        call pluma(n_toppgg) 
        do i=1,n_frame 
         xtopg=xtopg+float(i*2-1)*0.0125 
         xbotg=xbotg-float(i*2-1)*0.0125 
         ybotg=ybotg+float(i*2-1)*0.0125 
         ytopg=ytopg-float(i*2-1)*0.0125 
         call traa(ytopg,xtopg,0) 
         call traa(ytopg,xbotg,1) 
         call traa(ybotg,xbotg,1) 
         call traa(ybotg,xtopg,1) 
         call traa(ytopg,xtopg,1) 
        end do 
        nold_pen=-1 
        call pluma(nold_pen) 
       end if 
!###############################################################        
                                     ! Skalierung                       
       xscal=gx/(xend-xanf) 
       yscal=gy/(yend-yanf) 
                                     ! Startpunkt linke obere Ecke      
       G1=GX+XRAND+xoff_r 
       G2=YRAND+yoff_b+gy 
                                     ! Buchstabengroesse                
       G3=HX 
       G4=HY 
                                      ! Zeilenabstand                   
       distb=1.5*hy 
       dist=distb 
                                     ! Winkel                           
       WINKEL=3.141593/180. 
       ALPH=270.*WINKEL 
       ALPHA=ALPH 
       ALPHA0=0. 
       ROT=0. 
       ROTB=0. 
       G5=COS(ALPHA) 
       G6=SIN(ALPHA) 
!      write(6,'(a,4f10.3)')' addtext ALPH,G5,G6=',ALPH,G5,G6           
                                                                        
                                     ! Wiederholungsfaktor              
       nmult=1 
       l_top=.false. 
                                                                        
                                                                        
      mstore=istore-1 
      istore=0 
      do while (istore.lt.mstore) 
       istore=istore+1 
       cfield=textstore(istore) 
                                                                        
                ! Zeichen vor ;                                         
       iend=1 
                ! gefundene Schaltzeichen                               
       kch=0 
       l_bot=.false. 
       l_botF=.false. 
       l_center=.false. 
       l_fort=.false. 
       l_box=.false. 
       l_boxB=.false. 
       l_under=.false. 
       l_over=.false. 
       l_next=.false. 
       l_noch=.true. 
       n_textp=0 
                                                                        
       do while (iend .le. 80 .and. l_noch) 
        ch1=cfield(iend:iend) 
                                                                        
                                                 ! Fortsetzungszeile    
        if (ch1.eq.'+'.or.ch1.eq.'&') then 
         kch=kch+1 
         cfield(iend:iend)=' ' 
         l_fort=.true. 
         n_line=n_line+1 
        end if 
                                                                        
                                 ! Zentrieren                           
        if (ch1.eq.'c') then 
         kch=kch+1 
         cfield(iend:iend)=' ' 
         l_center=.true. 
         l_fort=.false. 
        end if 
                                                                        
!        write(6,'(a,a1)')' ch1=',ch1                                   
        if (ch1.eq.'b'.or.ch1.eq.'B'.or.ch1.eq.'u'.or.ch1.eq.'o'        &
        .or.ch1.eq.'f'.or.ch1.eq.'F'.or.ch1.eq.'g'.or.ch1.eq.'G'        &
         .or.ch1.eq.'@'.or.ch1.eq.'$') then                             
                                                                        
         kch=kch+1 
         cfield(iend:iend)=' ' 
         if (cfield(iend+1:iend+1).eq.' ') then 
          ipp=0 
         else 
          ipp=ichar(cfield(iend+1:iend+1))-i0 
          if (ipp .ge. 0 .and. ipp .le. 9)then 
!          number                                                       
           iend=iend+1 
           kch=kch+1 
           cfield(iend:iend)=' ' 
           i=ichar(cfield(iend+1:iend+1))-i0 
           if (i.ge.0.and.i.le.9) then 
!           second number follows                                       
            iend=iend+1 
            kch=kch+1 
            cfield(iend:iend)=' ' 
            ipp=10*ipp+i 
           end if 
          else 
           ipp=0 
          end if 
         end if 
                                                                        
                                                                        
         if (ch1.eq.'@')n_textp=ipp 
         if (ch1.eq.'B') then 
          l_boxB=.true. 
          l_under=.false. 
          l_over=.false. 
          n_boxpB=ipp 
         else if (ch1.eq.'b') then 
          l_box=.true. 
          l_under=.false. 
          l_over=.false. 
          n_boxp=ipp 
         else if (ch1.eq.'u') then 
          l_under=.true. 
          l_box=.false. 
          l_over=.false. 
          n_underp=ipp 
         else if (ch1.eq.'o') then 
          l_under=.false. 
          l_box=.false. 
          l_over=.true. 
          n_overp=ipp 
         else if (ch1.eq.'f'.or.ch1.eq.'F') then 
          if (ch1.eq.'f') then 
           l_bot=.true. 
           n_topp=ipp 
          else if (ch1.eq.'F') then 
           l_botF=.true. 
           n_toppF=ipp 
          end if 
          l_top=.true. 
          xtop=-1.e6 
          ytop=1.e6 
          xbot=1.e6 
          ybot=-1.e6 
         end if 
         if(ch1.eq.'$') then 
          nmult=ipp 
         end if 
        end if 
                                                                        
        if (ch1.eq.';') then 
         l_noch=.false. 
         kch=kch+1 
        else 
         iend=iend+1 
        end if 
       end do 
                                                                        
!                                                                       
       if (kch .eq. iend) l_next=.true. 
                                                  ! automatischer Vorsch
       l_next=l_next .and. .not.l_fort 
                                                   ! neue Koordinaten   
       l_newcoo= .not. (l_next .or. l_fort) 
!                                                                       
                                                                        
                                   ! text extrahieren                   
       id=min(npl,80-iend) 
       l_text=.false. 
       do i=1,id 
        ch1=cfield(i+iend:i+iend) 
        if (ch1.ne.' ') l_text=.true. 
       end do 
       ctext=cfield(iend+1:) 
                                                                        
                                                    !  neue Koordinaten 
       if (l_newcoo) then 
         rot=ROTB 
         dist=distb 
        n_line=1 
        id=min(npl,iend-1) 
        i=1 
        j=1 
        chin=' ' 
        do while(i.le.id) 
!        chin=cfield(1:id)                                              
         chin(i:i)=cfield(j:j) 
         if(cfield(j:j).eq.','.and.cfield(j+1:j+1).eq.',') then 
          chin(i+1:i+1)='0' 
          i=i+1 
         end if 
         i=i+1 
         j=j+1 
        end do 
        call trlch(id+1,chin,nn,OUT) 
                                                                        
        if(.not.l_center) then 
         if ( nn .ge. 1)                                                &
     &    G1=GX+XRAND+xoff_r-(OUT(1)-XANF)*XSCAL                        
        end if 
        if ( nn .ge. 2)                                                 &
     &   G2=YRAND+yoff_b+(OUT(2)-YANF)*YSCAL                            
        if ( nn .ge. 3 .and. out(3) .ge. 0.1) G3=OUT(3) 
         hx=G3 
        if ( nn .ge. 4 .and. out(4) .ge. 0.1) G4=OUT(4) 
         hy=G4 
                                                                        
        if ( nn .ge. 5 .and. out(5) .ge. 1.) then 
         rot=out(5)*winkel 
        end if 
         ALPHA=ALPH+ROT 
         G5=COS(ALPHA) 
         G6=SIN(ALPHA) 
        if ( nn .ge. 6 .and. out(6) .ge. 0.0) then 
          dist=out(6) 
        else 
         dist=1.5*hy 
        end if 
       end if 
                                                                        
       noldt_pen=-1 
       call pluma(noldt_pen) 
       call pluma(n_textp) 
                                                  ! Text plotten        
       if (l_text.and.ctext.ne.' ') then 
                                              ! Zeichenzahl bestimmen   
        k=256 
        do while (ctext(k:k).eq.' '.and. k.gt.1) 
         k=k-1 
        end do 
        ktxt=k 
!        write(6,'(a,a)')'ctext=',ctext(:ktxt)                          
        j=1 
        do while(ctext(j:j).eq.' ') 
         j=j+1 
        end do 
                                                                        
!       position vom ende der blaks                                     
        if(j.gt.1) then 
         CALL TXTPLO (g2,g1,-1,ctext,j-1,G3,G4,0.,-1.,hw,xw,hz) 
         bg1=xw 
        else 
         bg1=g1 
        end if 
                                                                        
                                                                        
                                      ! text zentrieren                 
        if (l_center) then 
         CALL TXTPLO (0.,0.,-1,ctext,ktxt,G3,G4,0.,-1.,yw,xw,zh) 
         xw1=-xw 
         yw1=-yw 
         if (xw1 .gt. gx) then 
          write(nwr,9000)char(7) 
         else 
          xw=(gx-xw1-float(nmult)*0.0125)*0.5 
          g1=xrand+gx+xoff_r-xw 
         end if 
!        write(6,'(a,8f10.2)')' g1,xw,yw,gx,xrand,xoff_r=',             
!     &                         g1,xw,yw,gx,xrand,xoff_r                
         if(j.gt.1) then 
          CALL TXTPLO (0.,0.,-1,ctext,j-1,G3,G4,0.,-1.,hw,xw,hz) 
          bg1=g1+xw 
          else 
           bg1=g1 
         end if 
        end if 
                                                                        
!        write(6,'(a,2l5,8f10.2)')'l_next,l_fort=',l_next,l_fort        
                                      ! automatischer Vorschub          
        if ( l_next ) then 
         l_newcoo=.false. 
         g1=g1-sin(rot)*dist*1.5 
         g2=g2-cos(rot)*dist*1.5 
        end if 
                                                                        
                                      ! Fortsetzungszeile               
        if (l_fort) then 
         g1=g1-mdir*sin(rot)*dist*1.5 
         g2=g2-mdir*cos(rot)*dist*1.5 
!         write(6,'(a,8f10.2)')' g2,g1=',g2,g1                          
        end if 
        j=-1 
        do i=1,nmult 
         j=-j 
         gg1=g1+float(i-1)*0.0125 
         gg2=g2+float(i-1)*0.0125 
         CALL TXTPLO (gg2,gg1,-1,ctext,ktxt,G3,G4,G5,G6,yende,xende,zh) 
        end do 
                                                                        
                                  ! Rahmen skalieren                    
        if (l_top) then 
         xd=-g6*hx+g5*zh 
         yd=2.*g6*zh-g5*hx 
         xd2=-g6*hx+2.*g5*zh 
         yd2=g6*zh-g5*hx 
         if (g1+xd2 .gt. xtop) xtop=g1+xd2 
         if (g2+yd2 .lt. ytop) ytop=g2+yd2 
         if (xende-xd .lt. xbot) xbot=xende-xd 
         if (yende-yd .gt. ybot) ybot=yende-yd 
        end if 
                                                                        
                            ! Rahmen Flaeche                            
        if (l_botF) then 
         l_top=.false. 
         l_botF=.false. 
         call pluma(n_toppF) 
         nn=abs(ytop-ybot)/pen*2 
         dy1=(ytop-ybot)/nn 
         ybotF=ybot 
         do i=1,nn 
          call traa(ybotF,xbot,0) 
          call traa(ybotF,xtop,1) 
          ybotF=ybotF+dy1 
         end do 
        nold_pen=-1 
         call pluma(nold_pen) 
        end if 
                                                                        
                                  ! Box Flaeche                         
        if (l_boxB) then 
         ux1=g1-(g6*hx+g5*zh)*0.4 
         uy1=g2+(g6*zh-g5*hx)*0.4 
         ux2=xende+(g6*hx-g5*zh)*0.4 
         uy2=yende+(g6*zh+g5*hx)*0.4 
         nold_pen=-1 
         h=-3.4*zh 
         ox1=g1-(g6*hx+g5*h)*0.4 
         oy1=g2+(g6*h-g5*hx)*0.4 
         ox2=xende+(g6*hx-g5*h)*0.4 
         oy2=yende+(g6*h+g5*hx)*0.4 
         call PFUMA(n_boxpB) 
         call traa(uy1,ux1,0) 
         call traa(uy2,ux2,1) 
         call traa(oy2,ox2,1) 
         call traa(oy1,ox1,1) 
         call pluma(n_boxpB) 
        end if 
        call pluma(n_textp) 
        do i=1,nmult 
         j=-j 
         gg1=g1+float(i-1)*0.0125 
         gg2=g2+float(i-1)*0.0125 
         CALL TXTPLO (gg2,gg1,1,ctext,ktxt,G3,G4,G5,G6,yende,xende,zh) 
        end do 
        nold_pen=-1 
        call pluma(nold_pen) 
!       fuehrende blanks werden nicht gezaehlt                          
                                                                        
                                                                        
                                   ! unterstreichen                     
        if (l_under) then 
         x1=g1-g6*(bg1-g1)-(g6*hx+g5*zh)*0.4 
         y1=g2-g5*(bg1-g1)+(g6*zh-g5*hx)*0.4 
         x2=xende+(g6*hx-g5*zh)*0.4 
         y2=yende+(g6*zh+g5*hx)*0.4 
         nold_pen=-1 
         call pluma(n_underp) 
         call traa(y1,x1,0) 
         call traa(y2,x2,1) 
         nold_pen=-1 
         call pluma(nold_pen) 
        end if 
                                  ! ueberstreichen                      
        if (l_over) then 
         h=-3.4*zh 
         x1=g1-g6*(bg1-g1)-(g5*h)*0.4 
         y1=g2-g5*(bg1-g1)+(g6*h)*0.4 
         x2=xende+(-g5*h)*0.4 
         y2=yende+(g6*h)*0.4 
         nold_pen=-1 
         call pluma(n_overp) 
         call traa(y1,x1,0) 
         call traa(y2,x2,1) 
         nold_pen=-1 
         call pluma(nold_pen) 
        end if 
                                                                        
                                 ! Box zeichnen                         
        if (l_box) then 
         ux1=g1-(g6*hx+g5*zh)*0.4 
         uy1=g2+(g6*zh-g5*hx)*0.4 
         ux2=xende+(g6*hx-g5*zh)*0.4 
         uy2=yende+(g6*zh+g5*hx)*0.4 
         nold_pen=-1 
         h=-3.4*zh 
         ox1=g1-(g6*hx+g5*h)*0.4 
         oy1=g2+(g6*h-g5*hx)*0.4 
         ox2=xende+(g6*hx-g5*h)*0.4 
         oy2=yende+(g6*h+g5*hx)*0.4 
         call pluma(n_boxp) 
         call traa(uy1,ux1,0) 
         call traa(uy2,ux2,1) 
         call traa(oy2,ox2,1) 
         call traa(oy1,ox1,1) 
         call traa(uy1,ux1,1) 
         nold_pen=-1 
         call pluma(nold_pen) 
        end if 
                                                                        
              ! text                                                    
       end if 
                                                                        
                          ! Rahmen zeichnen                             
       if (l_bot) then 
        l_top=.false. 
        l_bot=.false. 
        nold_pen=-1 
        call pluma(n_topp) 
        do i=1,n_frame 
         xtop=xtop+float(i*2-1)*0.0125 
         xbot=xbot-float(i*2-1)*0.0125 
         ybot=ybot+float(i*2-1)*0.0125 
         ytop=ytop-float(i*2-1)*0.0125 
         call traa(ytop,xtop,0) 
         call traa(ytop,xbot,1) 
         call traa(ybot,xbot,1) 
         call traa(ybot,xtop,1) 
         call traa(ytop,xtop,1) 
        end do 
        nold_pen=-1 
        call pluma(nold_pen) 
       end if 
                           !  naechsten Text einlesen                   
      end do 
!################################################################       
                                                                        
!        write(6,'(a,8f10.2)')'# xbot...ytop=',xbot,xtop,ybot,ytop      
      if (.not. l_term) close(unit=lpr) 
!                                                                       
                                                                        
      return 
!                                                                       
 5000 FORMAT(a) 
 5001 format(1h ,a) 
 5050 FORMAT(a) 
 5051 format(1h ,1a80) 
 1010 format(1h ,i5) 
 9000 Format(1h ,'   **** text exceeds plot range - no centering',      &
     &           ' ****',a1)                                            
!                                                                       
      END                                           
