#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h> 
#include <arpa/inet.h>
#include <sys/socket.h>

#include <time.h>
#include <unistd.h>

#define info info_
#define infouser infouser_

#define BUFL  512
#define FALSE 0
#define TRUE 1 
#define STRL 80

extern struct info{
      char  user[STRL],logname[STRL],date[STRL],hostid[STRL],
            host[STRL],net[STRL],disksize[STRL],
            hepath[STRL],utpath[STRL],term[STRL],editor[STRL],
            shell[STRL],colfile[STRL],workdir[132],
	effihome[STRL],userenv[132];
} info;

static int sockfd,iconnect;
/* struct tm{*/
/*                      int     tm_sec;     seconds */
/*                      int     tm_min;     minutes */
/*                      int     tm_hour;    hours */
/*                      int     tm_mday;    day of the month */
/*                      int     tm_mon;     month */
/*                      int     tm_year;    year */
/*                      int     tm_wday;    day of the week */
/*                      int     tm_yday;    day in the year */
/*                      int     tm_isdst;   daylight saving time */
/*              };*/

void address(long int i)
{
 struct sockaddr_in the_addr;
 
 the_addr.sin_family = AF_INET;
 the_addr.sin_port = htons(23);
 the_addr.sin_addr.s_addr = i; 

 if((sockfd = socket(AF_INET, SOCK_STREAM, 0))==-1){iconnect=-2;
 }else{
 iconnect=connect(sockfd,(struct sockaddr *)&the_addr,sizeof(struct sockaddr));
 close(sockfd);
 };
} 

void infouser(char *cinet) 
{
char name[STRL],envname[STRL];
 struct tm *tim;
 
  struct hostent *h;
  int i,in;
  long int j;
  char *datum;
  time_t zeit;


 j=inet_addr(cinet);
 /*printf("j=inet_addr(cinete) %d\n",j);*/

 /*address(j);*/ 
 /*printf("inet_addr(148.6.178.100)=%d sockfd=%d iconnect=%d \n",
   j,sockfd,iconnect);*/
 if (sockfd == -1){strcpy(name,"not existing");
  }else{
   if (iconnect == -1){strcpy(name," no connection");  
    }else{strcpy(name," reachable");};
  };
 strcpy(name," not checked");
  i=0; do{info.net[i]=name[i];i++;}while(name[i] != '\0'&& i<STRL);
  info.net[STRL-1]='\0';
  /*printf("info.net %s\n",info.net);*/


  /*getdomainname(name, STRL);
  do{info.domain[i]=name[i];i++;}while(name[i] != '\0'&& i<STRL);
  info.domain[STRL-1]='\0';*/

gethostname(name,STRL);
/*printf("gethostname %s\n",name);*/
 if ((h=gethostbyname(name)) == NULL) {
  strcpy(envname,"nohostname");strcpy(name,"nohostid");
 }else{
  strcpy(envname,h->h_name);
  strcpy(name,inet_ntoa(*((struct in_addr *)h->h_addr)));
 }
/*printf("getenvname %s\n",envname);*/
  i=0; do{info.host[i]=envname[i];i++;}while(envname[i] != '\0');
  i=0; do{info.hostid[i]=name[i];i++;}while(name[i] != '\0');
 
  /*  if((datum=getenv("HOSTTYPE"))!=NULL){
      i=0;do{info.hosttype[i]=datum[i];i++;} while(datum[i] != '\0');}*/  

  if((datum=getenv("USER"))!=NULL){
    i=0;do{info.user[i]=datum[i];i++;} while(datum[i] != '\0');}  

  if((datum=getenv("LOGNAME"))!=NULL){
    i=0;do{info.logname[i]=datum[i];i++;} while(datum[i] != '\0');}  

  if((datum=getenv("EFFIHEPATH"))!=NULL){
    i=0;do{info.hepath[i]=datum[i];i++;} while(datum[i] != '\0');}  

  if((datum=getenv("EFFIUTPATH"))!=NULL){
    i=0;do{info.utpath[i]=datum[i];i++;} while(datum[i] != '\0');}  

 if((datum=getenv("TERM"))!=NULL){
      i=0;do{info.term[i]=datum[i];i++;} while(datum[i] != '\0');} 

 if((datum=getenv("EDITOR")) !=NULL){
    i=0;do{info.editor[i]=datum[i];i++;} while(datum[i] != '\0');}

 if((datum=getenv("SHELL")) !=NULL){
    i=0;do{info.shell[i]=datum[i];i++;} while(datum[i] != '\0');}

 if((datum=getenv("COLORFILE")) !=NULL){
    i=0;do{info.colfile[i]=datum[i];i++;} while(datum[i] != '\0');}
 
if((datum=getenv("PWD")) !=NULL){
    i=0;do{info.workdir[i]=datum[i];i++;} while(datum[i] != '\0');}

if((datum=getenv("EFFIHOME")) !=NULL){
    i=0;do{info.effihome[i]=datum[i];i++;} while(datum[i] != '\0');}

  zeit = time(NULL); 
  datum= ctime(&zeit); 
  i=0;do{info.date[i+10]=datum[i];i++;}while(datum[i] !='\0');
  /*printf("datum  %s\n",datum);*/
  tim=localtime(&zeit);
  in=strftime(name,STRL,"%m %d %y",tim);
  /*printf("date: %s\n",name);*/
  for(i=0;i<in;i++) info.date[i]=name[i]; 
  /*printf("strftime  %s\n",info.date);*/
}
