      subroutine th_11index(isubthe,icase,iput,iget,info) 
! called by    stroboscopic transmission spectrum_3                     
!              stroboscopic reflection spectrum_3                       
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,ivstrf,icstrf,  &
                          maxscrd
      use comthe, only: array_fr,theoryname,mLG
      implicit none 
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info

      integer       ibe,nAS,idum1,nsampling,idum2,idum3,ien 
      real          srw8 
      common/strLOC/ibe(15),nAS,idum1,nsampling,idum2,idum3,srw8,ien(11)
                                                                        
      logical       b_vs,b_v_max,b_dumvsp 
      common/bvstrf/b_vs(4),b_v_max,b_dumvsp(ivstrf-5) 
      real          c1,gamnat,e_xsi,dumcm 
      common/acmaps/c1,gamnat,e_xsi,dumcm(icstrf-3) 
      real          avm,shift,dumvm 
      common/avmaps/avm(2),shift,dumvm(ivstrf-3) 
      logical       b_vm,b_shift,b_dumvm 
      common/bvmaps/b_vm(2),b_shift,b_dumvm(ivstrf-3) 
                                                                        
      logical   b_pc,b_Gauss 
      integer   iflag_Voigt,i,i1,i2,n,ni,jge 
      real      hti,srw 
      complex   hc,hci 
      real,    dimension(:), allocatable :: Eagd,rtr,w_Gauss,w_Lorentz 
      complex, dimension(:), allocatable:: cLG
                                                                        
      if(isubthe.lt.0) then 
       theoryname='1x1_ref_index_static     v=101' 
       c1=2*(nAS+1) 
       return 
      end if 
      if(icase.eq.0) print'(a)','icase not defined str routine'      
!     storage use n_sampling=1,2,4,8 for 4 complex numbers of r_ik      
                                                                        
      hci=cmplx(0.,1.) 
      iflag_Voigt=0 
      allocate(cLG(-nAS:nAS))
                                                                        
       call get_theory(isubthe,info) 
       if(info.gt.0)return 
!       write(6,'(a,2i4)') 'th_11refindex avsstrf 2 jge=',jge           
!       write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz             
                                                                        
        b_pc=b_v_max.or.isubthe.ge.0.or.b_vm(1) 
        if(.not.b_pc) then 
         isubthe=-abs(isubthe) 
         return 
        end if 
        isubthe=abs(isubthe) 
                                                                        
       i1=iget+1 
       jge=real(array_fr(i1)) 
       allocate(Eagd(jge),rtr(jge),w_Gauss(jge),w_Lorentz(jge))      


       i2=i1+jge 
       do i=1,jge 
        Eagd(i)=real(array_fr(i1+i))+shift 
        rtr(i)=aimag(array_fr(i1+i)) 
        w_Gauss(i)=real(array_fr(i2+i)) 
        w_Lorentz(i)=aimag(array_fr(i2+i)) 
       end do 
!       write(6,'(8f10.3)') (Eagd(i),i=1,jge)                           
!       write(6,'(8f10.3)') (rtr(i),i=1,jge)                            
       b_Gauss=.true. 
!      b_trans=.true.                                                   
                                                                        
                                                                        
                                                                        
        do n=iput+1,iput+(nAS+1)*2 
         array_fr(n)=(0.,0.) 
        end do 
        srw=srw8*float(nsampling) 
        do i=1,jge 
         if(rtr(i).gt.1.e-5) then 
          call aLORGAU(Eagd(i),gamnat,e_xsi,                            &
                    srw,w_Lorentz(i),w_Gauss(i),iflag_Voigt,nAS,cLG)       
                                                                        
!         write(6,'(a,3i5)')' nAS,iflag_Voigt=',nAS,iflag_Voigt,iput    
!         write(6,'(6g12.4)') (cLG(j),j=-5,5),                          
!     &          srw,gamnat,w_Lorentz(1),w_Gauss(1)                     
                                                                        
          hti=rtr(i)/2.0 
          do n=0,nAS 
           ni=iput+2*n 
           hc=cLG(n)                               
           array_fr(ni+1)=array_fr(ni+1)-hc*hti 
           hc=cLG(-n) 
           array_fr(ni+2)=array_fr(ni+2)-hc*hti 
          end do      ! n loop  
         end if 
        end do        ! i=1,jge       
!       write(6,'(a,2i6)') ' theory9 - absorber,iput=',iput,nAS         
!       write(6,'(i8,2g12.4)') (iput+n,array_fr(iput+n),n=0,nAS,16)        
        deallocate(cLG) 
      return 
      END                                           
