      subroutine th_relaxglobalsad(isubthe,icase,iput,iget,info) 
!     sad= source,absorber,detector : lstr1case=1,2,3  (comthe.for)     
      use glbconst, only: maxn,maxfr1,maxfr2,maxthss,maxscrd,ivstrf
      use comthe, only: array_fr,theoryname,lstr1case
      implicit none 
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info                                                                 
                                                                        
      integer       ibe,nLG,nAS,nSC,nsampling,ak8,sk8,nRL,istepcase,ien                    
      real          srw8 
      common/strLOC/ibe(14),nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,istepcase,&
                    ien(9)      
                                                                        
      integer,parameter :: mAS=2*maxn,idumscrd=maxscrd-4*(mAS+1) 
      real        sTr,yyr,dumscrd 
      common/scrd/sTr(-mAS:mAS+1),yyr(-mAS:mAS+1),dumscrd(idumscrd) 
                                                                        
      real          avm,dumvm 
      common/avmaps/avm(10),dumvm(ivstrf-10) 
      real          c1,dumc 
      common/acmaps/c1,dumc(ivstrf-1) 
                                                                        
      real      ym0,ym1,yp1,yp2,as,bs,cs,hr,hi 
      integer   i,i1,j,n,ni,sk2,lstr_case
      logical   b_pc 

      if(isubthe.lt.0) then 
       theoryname='1x1_ref_index_dynamic_sad' 
!      if(ak2.gt.sk2) then                                              
!       nAS=sk2+ak2+ib2                                                 
!       nSC=sk2+ib2                                                     
!      else                                                             
!       nSC=sk2+ak2+ib2                                                 
!       nAS=ak2+ib2                                                     
!      end if                                                           
       if(-isubthe.eq.1) then 
        c1=2*(nSC+1)+1 
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array 
       end if 
       if(-isubthe.eq.2) c1=2*(nAS+1) 
       if(-isubthe.eq.3) c1=2*(nSC+1) 
       return 
      end if 

       if(iget.eq.0) print'(a)','iget not defined'
                                                                        
!     storage use nst2_8 for 4 complex numbers of r_ik                  
       istepcase=icase
       lstr_case=lstr1case 
       if(lstr1case.eq.3)lstr_case=1
!--------------------------- source, detector ----------------------------------          
  select case(lstr_case)                                                                     
    case(1)                                                                        
!      srw=4.0*srw8                                                     
!      half srw for convolution                                         
!      calculation with 4*srw and interpolation for the slow subroutines
!      nRL half number of channels                                      
                                                                        
       if(icase.eq.1) then 
        nRL=nSC/4 
       else 
        nRL=nSC 
       end if 
       call get_theory(isubthe,info) 
                                                                        
       b_pc=isubthe.gt.0 
       if(.not.b_pc) then 
        isubthe=-abs(isubthe) 
        return 
       end if 
                                                                        
                                                                        
       i1=iget+1 
       if(icase.eq.1)then 
        do n=0,nRL+1 
         yyr(n)=real(array_fr(i1+n)) 
         yyr(-n)=aimag(array_fr(i1+n)) 
        end do 
        do n=-nRL,nRL-1 
!        h=f(yyr(n/4-1),yyr(n/4),yyr(n/4+1))                            
         ym0=yyr(n) 
         yp2=yyr(n+2)-ym0 
         yp1=yyr(n+1)-ym0 
         ym1=yyr(n-1)-ym0 
                                                                        
         as=(yp2-3.0*yp1-ym1)/24.0 
         bs=(ym1+yp1)/8.0 
         cs=-(yp2-6.0*yp1+2.0*ym1)/24.0 
                                                                        
         sTr(4*n)=ym0 
         sTr(4*n+1)=ym0+     as+    bs+    cs 
         sTr(4*n+2)=ym0+ 8.0*as+4.0*bs+2.0*cs 
         sTr(4*n+3)=ym0+27.0*as+9.0*bs+3.0*cs 
                     ! n loop                                           
        end do 
        sTr(4*nRL)=yyr(nRL) 
       else 
        do n=0,nRL 
         sTr(n)=real(array_fr(i1+n)) 
         sTr(-n)=aimag(array_fr(i1+n)) 
        end do 
       end if 
       do n=0,nSC 
        ni=iput+2*n 
        array_fr(ni+1)=cmplx(0.0,sTr(n)) 
        array_fr(ni+2)=cmplx(0.0,sTr(-n)) 
       end do  ! n loop   
!       write(6,'(8f10.3)') (sTr(n),n=0,64)                             
                                                                        
!       The sum of the Lorentz-Gauss curves of the jge lines            
!       have to be normalized to 1 for each subspectrum of the source   
!       iscpi=iscpr+2*nSC+1                                             
                                                                        
                                                                        
        ni=iput+2*(nSC+1)+1 
        if(nAS.lt.nSC) then 
         sk2=nSC-nAS 
         do i=0,sk2,2 
          hr=0. 
          hi=0. 
          do j=-nAS+1,nAS-1,2 
           hr=hr+ sTr(i+j)*2 
          end do 
          do j=-nAS+2,nAS-2,2 
           hr=hr+ sTr(i+j) 
          end do 
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i) 
                                                                        
          do j=-nAS+1,nAS-1,2 
           hi=hi+ sTr(-i+j)*2 
          end do 
          do j=-nAS+2,nAS-2,2 
           hi=hi+ sTr(-i+j) 
          end do 
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i) 
          array_fr(ni+i/2)=cmplx(hr,hi)/3. 
         end do 
!       write(6,'(a,4i5)')'theomoss nAS,NSC,sk2=',nAS,NSC,sk2           
!       write(6,'(8f10.3)') (array_fr(iscn+i),i=0,sk2,16)               
        else 
         hr=0. 
         do n=-nSC+1,nSC-1,2 
          hr=hr+ sTr(n)*2 
         end do 
         do n=-nSC+2,nSC-2,2 
          hr=hr+sTr(n) 
         end do 
         hr=hr*2.+ sTr(-nSC)+sTr(nSC) 
         array_fr(ni)=cmplx(hr/3.,0.0) 
!        write(6,'(a,i6,a,2f15.8)') '----th=',ni,' hr/3.=',hr/3.        
!        write(6,'(a,i6,2f15.8)') 'isource_sp snorm:i=',                
!    &      isource_sp,array_fr(isource_sp+1)                           
        end if 
!--------------------------- absorber -------------------------------             
   case(2)
!       srw=4.0*srw8                                                    
!       half srw for convolution                                        
!       calculation with 4*srw and interpolation for the slow subroutine
!       nRL half number of channels                                     
!       write(6,'(a,2i4)') 'th_mossrelax avmap 1 '                      
!       write(6,'(10f10.2)')avm                                         
                                                                        
        if(icase.eq.1) then 
         nRL=nAS/4 
        else 
         nRL=nAS 
        end if 
        call get_theory(isubthe,info) 
!       write(6,'(a,2i4)') 'th_mossrelax avmap 2 '                      
!       write(6,'(10f10.2)')avm                                         
                                                                        
       b_pc=isubthe.gt.0 
       if(.not.b_pc) then 
        isubthe=-abs(isubthe) 
        return 
       end if 
                                                                        
       i1=iget+1 
       if(icase.eq.1) then 
        do n=0,nRL+1 
         yyr(n)=real(array_fr(i1+n)) 
         yyr(-n)=aimag(array_fr(i1+n)) 
        end do 
!        write(6,'(a)') 'yyr='                                          
!        write(6,'(8f10.3)')(yyr(i),i=-nRL,nRL)                         
        do n=-nRL,nRL-1 
!        h=f(yyr(n/4-1),yyr(n/4),yyr(n/4+1))                            
         ym0=yyr(n) 
         yp2=yyr(n+2)-ym0 
         yp1=yyr(n+1)-ym0 
         ym1=yyr(n-1)-ym0 
                                                                        
         as=(yp2-3.0*yp1-ym1)/24.0 
         bs=(ym1+yp1)/8.0 
         cs=-(yp2-6.0*yp1+2.0*ym1)/24.0 
                                                                        
         sTr(4*n)=ym0 
         sTr(4*n+1)=ym0+     as+    bs+    cs 
         sTr(4*n+2)=ym0+ 8.0*as+4.0*bs+2.0*cs 
         sTr(4*n+3)=ym0+27.0*as+9.0*bs+3.0*cs 
!        write(6,'(i4,4f12.4)')4*n,ym0,sTr(4*n+1),sTr(4*n+2),sTr(4*n+3) 
        end do  ! n loop 
        sTr(4*nRL)=yyr(nRL) 
       else 
        do n=0,nRL 
         sTr(n)=real(array_fr(i1+n)) 
         sTr(-n)=aimag(array_fr(i1+n)) 
        end do 
     end if
     
       do n=0,nAS 
        ni=iput+2*n 
        array_fr(ni+1)=cmplx(0.0,sTr(n)) 
        array_fr(ni+2)=cmplx(0.0,sTr(-n)) 
       end do  ! n loop 
                                                                        
   end select                                                                        
   return 
   END                                           


      subroutine th_relaxspinhalfsad(isubthe,icase,iput,iget,info) 
!     sad= source,absorber,detector                                     
      use glbconst, only: maxn,maxfr1,maxfr2,maxthss,maxscrd,          &
                          icstrf,ivstrf,ivfr1trf,nwr
      use comthe, only: array_fr,theoryname
      implicit none 
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info                                                                 
                                                                        
                                                                         
      integer       ibe,nLG,nAS,nSC,nsampling,ak8,sk8,nRL,istepcase,ien
      real          srw8 
      common/strLOC/ibe(14),nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,istepcase,&
                    ien(9)
                                                                        
      logical         b_vfr1trf 
      common/bvfr1trf/b_vfr1trf(ivfr1trf) 
      real          avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p,dumvssp 
!                   ax,ay,az,gx,gy,gz                                   
!                   dl,eod,cube,fort,AL,BE,GA                           
      common/avmaps/avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p(7),    &
                    dumvssp(ivstrf-14)                                  
      logical       b_vm,b_Lwidth,b_matrix,                             &
                    b_iso,b_h0,b_dq,b_eta,b_gml,b_p,b_dumvssp           
      common/bvmaps/b_vm,b_Lwidth,b_iso,b_h0,b_dq,b_eta,b_gml,b_p(7),   &
                    b_dumvssp(ivstrf-14)                                
                                                                        
      real          c1,gamnat,e_xsi,aiset,aisym,temperature,dumc 
      common/acmaps/c1,gamnat,e_xsi,aiset,aisym,temperature,            &
                    dumc(icstrf-6)                                      
      logical       b_c1,b_dumc,b_pc 
      common/bcmaps/b_c1,b_dumc(icstrf-1) 
!     if one of the  constants changed the value all logical are .true. 
!     nuclear parameters are not used. Problem is solved only for iron57
                                                                        
!--------------------------------------------------------------------   
      real(kind=8) :: dq,eta,gml,ax,ay,az,a_hyp,orf,                    &
                      dl,eod,cube,fort,AL,BE,GA,te,dl21,dl31,dl32,rom
      real(kind=8),dimension(3)  :: gx3,gy3,gz3,ax3,ay3,az3,eq3,        &
                                    qx3,qy3,qz3,eta3,cr,cri,aw,bw,cw
      real(kind=8),dimension(3,3):: crys,ct,cti,cl,cli

      real(kind=8) :: dtheta,dphi,pi,pi2,gwidth,w,exp21,exp31,          &
                      vxx,vxy,vxz,vyz,vyy,vzz,qxx,qyy,qzz                        
                                                                        
!--------------------------------------------------------------------   
      integer,parameter :: nm=48,nm2=96,mAS=2*maxn,                     &
                 idumscrd=maxscrd-2*(mAS+1)-128*3-9*24-13*256           &
                          -nm*nm*2*6-256-5*nm*2-2*nm2*nm2-7*nm2  
      integer        iepk
      real           sTr,pwr,pwi,wrs,wis,eh,mat,dumscrd 
      real(kind=8):: wr,wi,hf,r,t,u,tl,ul,epk1,epk2,epk3,epk4,epk55,    &
                     h11,h22,h33                                          
      complex(kind=8):: d,dsum,vl1,vl2,vl3,vl4,vl5,vl6,                 &
                        vr1,vr2,vr3,vr4,vr5,vr6,pw                 
      common/scrd/sTr(-mAS:mAS+1),                                      &
                 d(8,8),dsum(8,8),wr(nm),wi(nm),                        &
                 pwr(nm),pwi(nm),wrs(nm),wis(nm),pw(nm),                &
                 vl1(8,8),vl2(8,8),vl3(8,8),vl4(8,8),                   &
                 vl5(8,8),vl6(8,8),vr1(8,8),vr2(8,8),                   &
                 vr3(8,8),vr4(8,8),vr5(8,8),vr6(8,8),                   &
                 hf(nm,nm),r(nm,nm),t(nm,nm),u(nm,nm),                  &
                 tl(nm,nm),ul(nm,nm),epk1(nm),epk2(nm),                 &
                 epk3(nm),epk4(nm2),epk55(nm2,nm2),iepk(nm2),           &
                 eh(3,128),mat(3,3,24),dumscrd(idumscrd)                
!                eh(3,128),mat(3,3,24) is used inside sphere()          
                                                                        
      real(kind=8),parameter :: zero=0.d0, one=1.d0, two=2.d0,          &
                                three=3.d0,pt5=0.5d0 
      real               dw,weight,h,h1,h2  
      complex(kind=8):: hc,z  
      integer    nop,npoints,ipoint,isym,iset,i,i1,j,j1,k,l,n 
      
      real, dimension(:), allocatable:: phi,theta,psiOM

                                                            
      if(isubthe.lt.0) then 
       theoryname='spin_half_refindex_dynamic' 
!      if(ak2.gt.sk2) then                                              
!       nAS=sk2+ak2+ib2                                                 
!       nSC=sk2+ib2                                                     
!      else                                                             
!       nSC=sk2+ak2+ib2                                                 
!       nAS=ak2+ib2                                                     
!      end if                                                           
!       D2 symmetry 6, D3 symmetry 4 out of 48                          
       iset=3 
       npoints=6*2**(iset+1) 
       if(icase.eq.1) then 
        n=1+npoints+16*2*npoints       ! storage for relaxation matrices
       else 
        n=1+npoints+48*2*npoints       ! storage for relaxation matrices
       end if                          ! and theta,phi
       if(-isubthe.eq.1) then 
        c1=2*(nSC+1)+3+n 
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array 
       end if 
       if(-isubthe.eq.2) c1=2*(nAS+1)+2+n 
       if(-isubthe.eq.3) c1=2*(nSC+1)+2+n 
       return 
      end if
    
!      write(6,'(a,6i6,f12.3,2i6)')'    LOC=',nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,istepcase
!      write(6,'(a,6f12.3)')' avmaps=',a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml                                                                
!      write(6,'(a,6f12.3)')' acmaps=',c1,aiset,aisym,temperature,gamnat
                                                                        
       b_pc=b_vm 
       if(.not.b_pc) then 
        isubthe=-abs(isubthe) 
        return 
       end if 

       if(iget.eq.0) print'(a)','iget not defined'
                                                                        
!       write(6,'(a,2i5)') 'th_mossrelax avmaps:: nRL=',nRL             
!       write(6,'(10f10.2)')avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p
      info=0                                                                  
      isym=aisym 
      iset=aiset 
      nop=nRL+1 
      if(istepcase.eq.2) then 
       dw=4.0*srw8 
      else 
       dw=16.0*srw8 
      end if 
!      write(6,'(a,i4,2f12.3)')'th-mossrelax nop,dw=',nop,dw            
!     write(6,'(a,4i4)')'th-mossrelax  isym,iset=',isym,iset            
                                                                        
      b_matrix=b_h0.or.b_dq.or.b_eta.or.b_gml 
      do k=1,7 
       b_matrix=b_matrix.or.b_p(k) 
      end do 
                                                                        
                                                                        
!      subroutine sphere(iset,isym,iOM,tetah,phih)                      
!      parameter (niset=128*24)                                         
!      dimension wh4(8),wh8(16),wh16(32),wh32(64),wh64(128),wh128(256), 
!     &          eh(3,128),tetah(niset),phih(niset),hmat(3,3)           
                                                                        
!     symmetry of the hamiltonian (subgroup of O)                       
!      data  nd4/1,5,8/                          ! D4 (C4 || z-axis)    
!      data  nd2/1,2,5,8,17,18/                  ! D2                   
!      data  nc2/1,2,3,4,5,7,8,13,17,18,19,22/   ! C2 (z-axis)          
!      data  nd3/1,2,3,4/                        ! D3 (C3 || {111}=z-axi
!      data nc2y/1,2,3,4,5,7,8,10,13,14,15,16/   ! c2 (y-axis)          
                                                                        
!     Directions  whi(teta,phi)  for the integration                    
!     over the sphere.                                                  
!     Optimized values are calculated by K. Knese and H. Spiering       
                                                                        
!     definition of isym (spezified by the calling routine):            
!     C4 || z-axis                     C3 || z-axis                     
!     cubic    isym=11                 cubic     isym=21                
!     D4       isym=12                 D3             22                
!     D2            13                 C2             23                
!     C2            14                 C1             24                
!     C1            15                                                  
                                                                        
!     iOM  (i-Omega) number of points, equal weights  dOM=1./iOM        
                                                                        
!     np: number of points on 1/48 sphere,  np=2**(iset+1)              
!       iset=3                                                          
!       npoints=6*2**(iset+1)                                           
!       n=1+npoints+16*2*npoints       ! storage for relaxation matrices

      allocate(phi(6144),theta(6144),psiOM(6144))

                                                                        
      i1=iput+1+nop+1 
      if(b_c1) then 
       if (isym.gt.0) then 
        call sphere(iset,isym,.false.,npoints,phi,theta,psiOM,eh,mat) 
                                                                        
        if(npoints.gt.96) then 
!        i=npoints/2**(iset+1)                                          
         i=96*2**(iset+1)/npoints/2 
         iset=-1 
         do while(i.gt.0) 
          i=i/2 
          iset=iset+1 
         end do 
        call sphere(iset,isym,.false.,npoints,phi,theta,psiOM,eh,mat) 
!         call sphere(iset,isym,npoints,theta,phi)                      
         write(nwr,'(a,i2)') '**sphere_set** iset is reduced to ',iset 
        end if 
       else 
        npoints=1 
        theta(1)=0.0 
        phi(1)=0.0 
       end if 
       weight=dw/6.28318/npoints 
!       write(6,'(a,2i6,g12.5)') 'theomoss3 i1,npoints,weight=',        
!     &                i1,npoints,weight                                
       array_fr(i1) =cmplx(float(npoints),weight) 
       do ipoint=1,npoints 
        array_fr(i1+ipoint) =cmplx(theta(ipoint),phi(ipoint)) 
       end do 
      else 
       npoints=real(array_fr(i1)) 
       weight=aimag(array_fr(i1)) 
!       write(6,'(a,2i6)') 'theomoss3 i1,npoints=',i1,npoints           
!       write(6,'(8f10.4)')(array_fr(i1+i),i=1,npoints)                 
       do ipoint=1,npoints 
        theta(ipoint)=real(array_fr(i1+ipoint)) 
        phi(ipoint)=aimag(array_fr(i1+ipoint)) 
       end do 
      end if 
                                                                        
      a_hyp= dble(a_h0)        ! hyperfine splitting, mm/s             
      dq= dble(a_dq)           ! quadrupole splitting, mm/s            
      eta=dble(a_eta)          ! quadrupole assymetry                  
      gml=dble(a_gml)          ! relaxation rate, mm/s (*11.625 MHz)   
      gwidth=pt5*dble(gamnat*(1.0+a_Lwidth)) ! linewidth, mm/s  
                                                                        
      pi    = 3.14159265358979324 
      pi2=  pt5*pi 
                                                                       
      do i=-nop,nop 
       sTr(i)=0.0 
      end do 

    if(b_matrix) then 

     if(icase.lt.3) then                                                                        
      ! S=1/2 Kramers doublet                          
       if(icase.eq.1) then 
        do i=1,3 
         gx3(i)=zero 
         gy3(i)=zero 
         gz3(i)=zero 
         aw(i)=zero 
         bw(i)=zero 
         cw(i)=zero 
        end do 
        ax= dble(a_p(1))         ! A-tensor
        ay= dble(a_p(2)) 
        az= dble(a_p(3)) 
        gx3(1)=dble(a_p(4))      ! g-tenso
        gy3(1)=dble(a_p(5)) 
        gz3(1)=dble(a_p(6)) 
!       write(6,'(a,6g12.5)')'ax,ay,az,gx,gy,gz=',                      
!     &                       ax,ay,az,gx3(1),gy3(1),gz3(1)             
!       CALCULATION OF THE QUADRUPOLE TENSOR                            
        qzz=dq*pt5/dsqrt(one+eta**2/three) 
        qxx=pt5*qzz*(eta-one) 
        qyy=-qxx-qzz 
                                                                        
       else  ! icase=2
!       CALCULATE CRYSTAL FIELD HAMILTONIAN, GRIFFITH                   
        dl=dble(a_p(1)) 
        rom=dble(a_p(2)) 
        call split(dl,rom,crys) 
        n=3 
        call diag(crys,ct,cti,cl,cli,                                   &
                  n,hf,r,wr,wi,t,u,tl,ul,                               &
                  epk1,epk2,epk3,epk4,epk55,iepk)                         
                                                                        
!        write(6,'(/,a)')'t'                                            
!        write(6,'(16g8.2)')((t(i,k),k=1,n),i=1,n)                      
!        write(6,'(/,a)')'u'                                            
!        write(6,'(16g8.2)')((u(i,k),k=1,n),i=1,n)                      
                                                                        
        do i=1,3 
         cr(i)=wr(i) 
         cri(i)=wi(i) 
        end do 
        call  sort(cr,cri,ct,cti,dl21,dl31,dl32) 
                                                                        
        orf=1.d0 
        call sptensor(ct,orf,gx3,gy3,gz3,ax3,ay3,az3,qx3,qy3,qz3,eta3) 
        do i=1,3 
         eq3(i)=dq*pt5/sqrt(qz3(i)**2+(qx3(i)-qy3(i))**2/three) 
         qx3(i)=qx3(i)*eq3(i) 
         qy3(i)=qy3(i)*eq3(i) 
         qz3(i)=qz3(i)*eq3(i) 
        enddo 
        ax=ax3(1) 
        ay=ay3(1) 
        az=az3(1) 
        qzz=qz3(1) 
        qxx=qx3(1) 
        qyy=-qxx-qzz 
       end if 
!       write(6,'(a,6g12.5)')'ax,ay,az,gx,gy,gz=',                      
!     &                       ax,ay,az,gx3(1),gy3(1),gz3(1)             
                                                                        
!      THIS SUBROUTINE CALCULATES Q-TENSOR IN  THE CASE OF PAS ROTATION 
!      VS. MOLECULAR SYSTEM. THE ROTATION ANGLES ALFA, BETA,GAMMA SHOULD
!      BE GIVEN THEN IN THE INPUT FILE                                  
                                                                        
!      alfa=zero    !Euler angles                                       
!      beta=zero                                                        
!      gamma=zero                                                       
                                                                        
       call tens(qxx,qyy,qzz,zero,zero,zero,                            &
                         vxx,vyy,vzz,vxy,vxz,vyz)                      
                                                                        
!       write(6,*) 'vii',vxx,vyy,vzz,vxy,vxz,vyz                        
                                                                        
!      POWDER AVERAGING                                                 
                                                                        
       i1=iput+1+nop+1+npoints 
       do ipoint=1,npoints 
!        write(6,'(a,2f10.4)')'theta,phi=',theta(ipoint),phi(ipoint)    
        j1=i1+(ipoint-1)*32 
                                                                        
                                                                        
!       CALCULATION OF THE INTENSITY MATRIX OF NUCLEAR TRANSITIONS      
                                                                        
!       EXTERNAL MAGNETIC FIELD IS PERPENDICULAR TO THE GAMMA-BEAM      
!       two direction for the average in the plane                      
                                                                        
        dtheta=dble(theta(ipoint))+pi2 
        dphi=dble(phi(ipoint)) 
        call dddd(dtheta,dphi,d) 
        do i=1,8 
         do k=1,8 
          dsum(i,k)=d(i,k) 
         end do 
        end do 
                                                                        
        dtheta=pi2 
        dphi=dble(phi(ipoint))+pi2 
        call dddd(dtheta,dphi,d) 
        do i=1,8 
         do k=1,8 
          dsum(i,k)=dsum(i,k)+d(i,k) 
         end do 
        end do 
        dtheta=dble(theta(ipoint)) 
        dphi=dble(phi(ipoint)) 
                                                                        
        n=16 
! ------------------------------------------------------                
        call relax(dtheta,dphi,gx3,gy3,gz3,ax,ay,az,a_hyp,              &
                   aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,                &
                   n,hf,r,wr,wi,t,u,tl,ul,                              &
                   epk1,epk2,epk3,epk4,epk55,iepk,                      &
                   vl1,vl2,vl3,vl4,vl5,vl6,                             &
                   vr1,vr2,vr3,vr4,vr5,vr6)                             
! -----------------------------                                         
                                                                        
!        write(6,'(a)')'((vl1(i,k)),k=1,8),i=1,8)'                      
!        write(6,'(8g10.2)')((dreal(vl1(i,k)),k=1,8),i=1,8)             
!        write(6,'(8g10.2)')((dimag(vl1(i,k)),k=1,8),i=1,8)             
                                                                        
!        write(6,'(a)')'((vr2(i,k)),k=1,8),i=1,8)'                      
!        write(6,'(8g10.2)')((dreal(vl2(i,k)),k=1,8),i=1,8)             
!        write(6,'(8g10.2)')((dimag(vl2(i,k)),k=1,8),i=1,8)             
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr1(l,i) 
          end do 
          z=z+hc*vl1(i,k) 
         end do 
         pw(i)=z*0.75d0 
        end do 
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr2(l,i) 
          end do 
          z=z+hc*vl2(i,k) 
         end do 
         pw(i+8)=z*0.75d0 
        end do 
                                                                        
!        z=(0.,0.)                                                      
!        do k=1,16                                                      
!         z=z+pw(k)                                                     
!        end do                                                         
                                                                        
!        write(6,'(a,2g12.5)') ' wr,wi='                                
!        write(6,'(8g10.2)')(wr(k),k=1,n)                               
!        write(6,'(8g10.2)')(wi(k),k=1,n)                               
!        write(6,'(a,2g10.3)')' pw=',z                                  
!        write(6,'(8g10.2)')(dreal(pw(i)),i=1,n)                        
!        write(6,'(8g10.2)')(dimag(pw(i)),i=1,n)                        
                                                                        
!        CALCULATION OF THE SPECTRUM ITSELF                             
        do j=1,n 
         wrs(j)=sngl(wr(j)) 
         wis(j)=sngl(wi(j)) 
         pwr(j)=sngl(dreal(pw(j))) 
         pwi(j)=sngl(dimag(pw(j))) 
        end do 
                                                                        
        do i=1,n 
         array_fr(j1+i)=cmplx(wrs(i),wis(i)) 
        end do 
        j=j1+n 
        do i=1,n 
         array_fr(j+i)=cmplx(pwr(i),pwi(i)) 
        end do 
                                                                        
        do i=-nop,nop 
         w=dw*float(i)-a_iso 
         h=0.0 
         do j=1,n 
          h1=w-wrs(j) 
          h2=gwidth-wis(j) 
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2) 
         end do 
         sTr(i)=sTr(i)+h*weight 
        end do 
       end do  ! ipoint

      else     ! S=5/2 3 Kramers doublets    ---------------------                                                                
                                                                        
       dl  = dble(a_p(1)) 
       eod = dble(a_p(2)) 
       cube= dble(a_p(3)) 
       fort= dble(a_p(4)) 
       AL  = dble(a_p(5))       ! EULER ANGLE
       BE  = dble(a_p(6)) 
       GA  = dble(a_p(7)) 
       rom   = eod*dl 
                                                                        
!      CALCULATION OF THE ZERO-FIELD HAMILTONIAN                        
       call splith(dl,rom,cube,fort,crys) 
       n=3 
       call diag(crys,ct,cti,cl,cli,                                    &
                 n,hf,r,wr,wi,t,u,tl,ul,                                &
                 epk1,epk2,epk3,epk4,epk55,iepk)                         
                                                                        
       do i=1,3 
        cr(i)=wr(i) 
        cri(i)=wi(i) 
       end do 
                                                                        
!      ORDERING OF THE ZERO-FIELD DOUBLETS IN ASCENDING ORDER           
!      AND CALCULATION OF THE ENERGY INTERVALS BETWEEN THE DOUBLETS     
                                                                        
       call  sort(cr,cri,ct,cti,dl21,dl31,dl32) 
!      write(6,*)'E(1),E(2),E(3)'                                       
!      write(6,*) cri(1),cri(2),cri(3)                                  
!      write(6,*)'dl21,dl31,dl32'                                       
!      write(6,*)dl21,dl31,dl32                                         
                                                                        
       do i=1,3 
        gx3(i)=zero 
        gy3(i)=zero 
        gz3(i)=zero 
        aw(i)=zero 
        bw(i)=zero 
        cw(i)=zero 
       end do 
                                                                        
!      CALCULATION OF THE G-TENSORS OF ALL KRAMERS DOUBLETS             
       call tenshs(cti,gx3,gy3,gz3,aw,bw,cw) 
                                                                        
!      write(6,*)'gx3,gy3,gz3'                                          
!      do i=1,3                                                         
!      write(6,*) i,abs(gx3(i)),abs(gy3(i)),abs(gz3(i))                 
!      enddo                                                            
                                                                        
!      BOLTZMANN POPULATION                                             
       te=dble(0.695*temperature) 
       exp21=exp(-dl21/te) 
       exp31=exp(-dl31/te) 
       h11=1.d0/(1.d0+exp21+exp31) 
       h22=exp21*h11 
       h33=exp31*h11 
                                                                        
!      CALCULATION OF THE QUADRUPOLE TENSOR                             
                                                                        
       qzz=dq*pt5/dsqrt(one+eta**2/three) 
       qxx=pt5*qzz*(eta-one) 
       qyy=-qxx-qzz 
                                                                        
!      THIS SUBROUTINE CALCULATES Q-TENSOR IN  THE CASE OF PAS ROTATION 
!      VS. MOLECULAR SYSTEM. THE ROTATION ANGLES ALFA, BETA,GAMMA SHOULD
!      BE GIVEN THEN IN THE INPUT FILE                                  
                                                                        
       call tens(qxx,qyy,qzz,AL,BE,GA,                                  &
                         vxx,vyy,vzz,vxy,vxz,vyz)                      
!      write(nout,*) 'vii',vxx,vyy,vzz,vxy,vxz,vyz                      
                                                                        
                                                                        
!      POWDER AVERAGING                                                 
                                                                        
       i1=iput+1+nop+1+npoints 
       do ipoint=1,npoints 
!        write(6,'(a,2f10.4)')'theta,phi=',theta(ipoint),phi(ipoint)    
        j1=i1+(ipoint-1)*96 
                                                                        
                                                                        
!       CALCULATION OF THE INTENSITY MATRIX OF NUCLEAR TRANSITIONS      
                                                                        
!       EXTERNAL MAGNETIC FIELD IS PERPENDICULAR TO THE GAMMA-BEAM      
!       two direction for the average in the plane                      
        dtheta=dble(theta(ipoint))+pi2 
        dphi=dble(phi(ipoint)) 
        call dddd(dtheta,dphi,d) 
        do i=1,8 
         do k=1,8 
          dsum(i,k)=d(i,k) 
         end do 
        end do 
                                                                        
        dtheta=pi2 
        dphi=dble(phi(ipoint))+pi2 
        call dddd(dtheta,dphi,d) 
        do i=1,8 
         do k=1,8 
          dsum(i,k)=dsum(i,k)+d(i,k) 
         end do 
        end do 
                                                                        
        dtheta=dble(theta(ipoint)) 
        dphi=dble(phi(ipoint)) 
        n=48 
! ------------------------------------------------------                
        call relax(dtheta,dphi,gx3,gy3,gz3,h11,h22,h33,a_hyp,           &
                   aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,                &
                   n,hf,r,wr,wi,t,u,tl,ul,                              &
                   epk1,epk2,epk3,epk4,epk55,iepk,                      &
                   vl1,vl2,vl3,vl4,vl5,vl6,                             &
                   vr1,vr2,vr3,vr4,vr5,vr6)                             
! -----------------------------                                         
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr1(l,i) 
          end do 
          z=z+hc*vl1(i,k) 
         end do 
         pw(i)=z*0.75d0 
        end do 
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr2(l,i) 
          end do 
          z=z+hc*vl2(i,k) 
         end do 
         pw(i+8)=z*0.75d0 
        end do 
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr3(l,i) 
          end do 
          z=z+hc*vl3(i,k) 
         end do 
         pw(i+16)=z*0.75d0 
        end do 
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr4(l,i) 
          end do 
          z=z+hc*vl4(i,k) 
         end do 
         pw(i+24)=z*0.75d0 
        end do 
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr5(l,i) 
          end do 
          z=z+hc*vl5(i,k) 
         end do 
         pw(i+32)=z*0.75d0 
        end do 
                                                                        
        do i=1,8 
         z=zero 
         do k=1,8 
          hc=zero 
          do l=1,8 
           hc=hc+dsum(k,l)*vr6(l,i) 
          end do 
          z=z+hc*vl6(i,k) 
         end do 
         pw(i+40)=z*0.75d0 
        end do 
                                                                        
!        hc=(0.0,0.0)                                                   
!        do k=1,n                                                       
!         hc=hc+pw(k)                                                   
!        end do                                                         
!        write(6,'(a,2g12.5)') ' sum pw=',hc                            
!        write(6,'(8g10.2)')(real(pw(k)),k=1,48)                        
!        write(6,'(8g10.2)')(dimag(pw(k)),k=1,48)                       
                                                                        
!       CALCULATION OF THE SPECTRUM ITSELF                              
        do j=1,n 
         wrs(j)=sngl(wr(j)) 
         wis(j)=sngl(wi(j)) 
         pwr(j)=sngl(dreal(pw(j))) 
         pwi(j)=sngl(dimag(pw(j))) 
        end do 
                                                                        
        do i=1,n 
         array_fr(j1+i)=cmplx(wrs(i),wis(i)) 
        end do 
        j=j1+n 
        do i=1,n 
         array_fr(j+i)=cmplx(pwr(i),pwi(i)) 
        end do 
                                                                        
        do i=-nop,nop 
         w=dw*float(i)-a_iso 
         h=0.0 
         do j=1,n 
          h1=w-wrs(j) 
          h2=gwidth-wis(j) 
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2) 
         end do 
         sTr(i)=sTr(i)+h*weight 
        end do 
       end do  ! ipoint loop
      end if    ! icase                                                                       

     else 
!      take aa,bb,pwi,wrs,weight from array_fr                          
       do i=-nop,nop 
        sTr(i)=0.0 
       end do 
       if(icase.eq.1) n=16 
       if(icase.eq.2) n=48 
                                                                        
       i1=iput+1+nop+1+npoints 
       do ipoint=1,npoints 
        j1=i1+(ipoint-1)*2*n 
        do i=1,n 
         wrs(i)=real(array_fr(j1+i)) 
         wis(i)=aimag(array_fr(j1+i)) 
        end do 
        j=j1+n 
        do i=1,n 
         pwr(i)=real(array_fr(j+i)) 
         pwi(i)=aimag(array_fr(j+i)) 
        end do 
        do i=-nop,nop 
         w=dw*float(i)-a_iso 
         h=0.0 
         do j=1,n 
          h1=w-wrs(j) 
          h2=gwidth-wis(j) 
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2) 
         end do 
         sTr(i)=sTr(i)+h*weight 
        end do 
       end do   ! ipoint loop
     end if 
                                                                        
!      h=0.0                                                            
!      do i=-nop,nop                                                    
!       h=h+sTr(i)                                                      
!      end do                                                           
!      write(6,'(i5,a,f12.4)') nop,'Sum sTr=',h                         
!      write(6,'(8f10.5)')(sTr(i),i=-nop,nop)                           
                                                                        
!-----------------------------------------------------------------      
    i1=iput+1 
    do n=0,nop 
     array_fr(i1+n)=cmplx(sTr(n),sTr(-n)) 
    end do 
    deallocate(phi,theta,psiOM)
    return 
    END                                           
                                                                        
                                                                        
      subroutine th_relaxtwostatesad(isubthe,icase,iput,iget,info) 
!     sad= source,absorber,detector                                     
      use glbconst, only: maxn,maxfr1,maxfr2,maxthss,maxscrd,          &
                          icstrf,ivstrf,ivfr1trf,ivfr2trf,infotext
      use comthe, only: array_fr,theoryname
      implicit none 
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info                                                                 
                                                                        
                                                                        
      integer       ibe,nLG,nAS,nSC,nsampling,ak8,sk8,nRL,istepcase,ien                    
      real          srw8 
      common/strLOC/ibe(14),nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL, &
                     istepcase,ien(9)
      
      real            avfr1,dfr1,B_ext,dumfr1 
      common/avfr1trf/avfr1,dfr1,B_ext,dumfr1(ivfr1trf-3) 
      logical         b_vfr1trf 
      common/bvfr1trf/b_vfr1trf(ivfr1trf) 
      real            acfr2,unufr2,temp,dumfr2 
      common/acfr2trf/acfr2,unufr2(4),temp,dumfr2(ivfr2trf-6) 
      real          avm,a_iso,hz1,hz2,dq,t_rate,popmom,forMofT,ai0,dumvssp                                             
      common/avmaps/avm,a_iso,hz1,hz2,dq,t_rate,popmom,forMofT,ai0,     &
                    dumvssp(ivstrf-9)                                   
      logical       b_vm,b_dumvssp 
      common/bvmaps/b_vm,b_dumvssp(ivstrf-1) 
                                                                        
      real          c1,gamnat,e_xsi,cTms,ajg,aje,amueg,amuee,QgdQe,     &
                    E2dM1,e1m1,temperature,Treference,dumc                          
      common/acmaps/c1,gamnat,e_xsi,cTms,ajg,aje,amueg,amuee,QgdQe,     &
                    E2dM1,e1m1,temperature,Treference,dumc(icstrf-13)               
      logical       b_c1,b_dumc,b_pc 
      common/bcmaps/b_c1,b_dumc(icstrf-1) 
!     if one of the  constants changed the value all logical are .true. 
!     nuclear parameters are not used. Problem is solved only for iron57
                                                                        
!--------------------------------------------------------------------   
      integer,parameter :: mAS=2*maxn,idumscrd=maxscrd-4*(mAS+1)
      real,  parameter  :: pi=3.141593

      integer nop,je,jg,me,mg,n,i1
      real    h,ug,ue,de1,de2,qh,qe,qg,ra11,ra22,ai,gam,                   &
              pi12,pi21,dw,clebsch,popr,dipole_T,hz1_T,hz2_T,fT            
      complex a11,a22,aint,denom 
      real, dimension(:), allocatable :: sTr
!      complex, dimension(-3:3,-1:1)::NdD      

!       real, dimension(-3:3)::CC1 !C1s
!       real, dimension(-1:1)::CC0
!       complex, dimension(-3:3,-1:1)::alp,alm
!       complex p
!       integer m
      if(isubthe.lt.0) then 
       theoryname='two_state_refindex_dynamic_pert' 
       c1=2*(nAS+2)+3 
       return 
      end if 
      allocate(str(-mAS:mAS+1))
      
!      write(6,'(a,6f12.4)')'avfr1,dfr1,B_ext,dumfr1=',                 
!     &          avfr1,dfr1,B_ext,dumfr1(1),dumfr1(2),dumfr1(3)         
                                                                        
       b_pc=b_vm.or.b_vfr1trf(1) 
       if(.not.b_pc) then 
        isubthe=-abs(isubthe) 
        return 
       end if 

       if(iget.eq.0) print'(a)','iget not defined'      
                                                                        
       if(icase.eq.1)then 
        popr=popmom
        hz1_T=hz1 
        hz2_T=hz2 
       else 
        if(temperature.le.0.) then 
         info=1 
         infotext(1)=' ' 
         infotext(2)='temperature has zero value (not included)' 
         infotext(3)='set up: include constant temperature for  ... [y]' 
         infotext(3)=' ' 
         return 
        end if 
        fT=1.0+forMofT*                                                 &
            (1.0-((temperature-Treference)/(300-Treference))**2)        
        hz1_T=hz1*fT 
        hz2_T=hz2*fT
        dipole_T=(hz1_T+hz2_T)/2.0 
        popr=exp(2.*popmom*(B_ext+dipole_T)/temperature) 
!        write(6,'(a,6f12.4)')'fT, popr,t_rate,H1,2=',fT,popr,t_rate,   
!     &               hz1_T+B_ext,hz2_T+B_ext                           
       end if 
!       0.0467 *B[kG]cm**-1 ; 0.695*T cm**-1 ; 2.24^=10**4 mu-Bohr*1kG/3
                                                                        
       nop=nRL+1 
       ug=amueg/ajg/cTms/2. 
       ue=amuee/aje/cTms/2. 
       jg=2.*ajg+0.001 
       je=2.*aje+0.001 
       gam=popr/(1.0+popr)     !     gam=pop1, 1-gam=pop2  
       pi12=(1.-gam)*t_rate    !     t_rate=pi12+pi21      
       pi21=gam*t_rate 
!        write(6,'(a,8f12.4)')'fT, popr,t_rate,H1,2=',fT,popr,t_rate, &  
!     &               B_ext,hz2_T+B_ext,pi12,pi21                 
       qe=-dq/24. 
       
       qg=QgdQe*qe 
       qh=-qg*jg*(jg+2)+qe*je*(je+2) 
       ra11=gamnat/2.+pi12 
       ra22=gamnat/2.+pi21 
                                                                        
       if(istepcase.eq.2) then 
        dw=4.0*srw8 
       else 
        dw=16.0*srw8
       end if 

       sTr=0.
       do mg=-jg,jg,2 
        do me=-je,je,2 
         if(mg-me.eq.0) then 
          ai=clebsch(1.0,0.,                                            &
                 ajg,float(mg)/2.,aje,float(me)/2.)**2*ai0              
!         write(6,'(a,2i3,2x,f10.3)')'0 mg,me, ai=',mg,me, ai           
         else if(abs(me-mg).eq.2) then 
          ai= clebsch(1.0,float(me-mg)/2.,                              &
                 ajg,float(mg)/2.,aje,float(me)/2.)**2                  
!         write(6,'(a,2i3,2x,f10.3)')'2 mg,me, ai=',mg,me, ai           
         else if(abs(me-mg).gt.2) then 
          ai=0. 
         end if 
         if(ai.gt.0) then
!         if(abs(me-mg).eq.2) then
  
          h=qh+3.*(qg*mg**2-qe*me**2)-a_iso 
          de2=ug*mg-ue*me
          de1=de2*(hz1_T+B_ext)+h 
          de2=de2*(hz2_T+B_ext)+h
          
          do n=-nop,nop 
           h=-float(n)*dw
           a11=cmplx(ra11,h+de1) 
           a22=cmplx(ra22,h+de2) 
           denom=a11*a22-cmplx(pi12*pi21,0.) 
           aint=gam*(a22+cmplx(pi12,0.))+(1.-gam)*(a11+cmplx(pi21,0.)) 
          sTr(n)=sTr(n)+real(aint/denom)*ai 
          end do 
         end if 
        end do 
     end do

       h=0. 
       do n=-nop+1,nop-1,2 
        h=h+ sTr(n)*2 
       end do 
       do n=-nop+2,nop-2,2 
        h=h+sTr(n)
       end do 
       h=h*2+ sTr(-nop)+sTr(nop) 
       h=abs(h)/3.*dw*4/pi/gamnat
!      the Lorentz-curve normalized to 1 (with stepwidth=1) has to be
!      multiplied by the factor 2/(gamnat*pi)*srw ; srw=2*dw       
       i1=iput+1 
       do n=0,nop 
          array_fr(i1+n)=cmplx(sTr(n),sTr(-n))/h
       end do 
       deallocate(sTr)       
       return 
      END                                           




      subroutine testcommon
      use glbconst, only: maxn,maxscrd
      implicit none

      integer,parameter :: nm=48,nm2=96,mAS=2*maxn,                     &
                 idumscrd=maxscrd-2*(mAS+1)-128*3-9*24                   &
                          -13*256-nm*nm*2*6-256-5*nm*2-2*nm2*nm2-7*nm2  
      integer        iepk
      real           sTr,pwr,pwi,wrs,wis,eh,mat,dumscrd 
      real(kind=8):: wr,wi,hf,r,t,u,tl,ul,epk1,epk2,epk3,epk4,epk55
      complex(kind=8):: d,dsum,vl1,vl2,vl3,vl4,vl5,vl6,                 &
                        vr1,vr2,vr3,vr4,vr5,vr6,pw                 
      common/scrd/sTr(-mAS:mAS+1),                                      &
                 d(8,8),dsum(8,8),wr(nm),wi(nm),                        &
                 pwr(nm),pwi(nm),wrs(nm),wis(nm),pw(nm),                &
                 vl1(8,8),vl2(8,8),vl3(8,8),vl4(8,8),                   &
                 vl5(8,8),vl6(8,8),vr1(8,8),vr2(8,8),                   &
                 vr3(8,8),vr4(8,8),vr5(8,8),vr6(8,8),                   &
                 hf(nm,nm),r(nm,nm),t(nm,nm),u(nm,nm),                  &
                 tl(nm,nm),ul(nm,nm),epk1(nm),epk2(nm),                 &
                 epk3(nm),epk4(nm2),epk55(nm2,nm2),iepk(nm2),           &
                 eh(3,128),mat(3,3,24),dumscrd(idumscrd)                

!      write(6,'(a,8i5)')' idumscrd,maxscrd=', idumscrd,maxscrd

       return
       end

       subroutine blumeTjonB(om,w,gamd2,ais,g1,g0,mueH,m1,m0,NdD)
       real, intent(in):: w,gamd2,om,ais,g1,g0,mueH
       complex, dimension(-3:3,-1:1), intent(out)::NdD       
       integer , intent(in)::m1,m0         

       real, dimension(-3:3)::CC1 !C1s
       real, dimension(-1:1)::CC0
       complex, dimension(-3:3,-1:1)::alp,alm
       complex p
       integer m


       p=cmplx(gamd2,-(om-ais))

       do m=-3,3,2
          CC1(m)=g1*m*mueH
       end do
!       C1s(-3)=g1*mueH; C1s(3)=-g1*mueH; C1s(-1)=3*g1*mueH; C1s(1)=-3*g1*mueH;
       CC0(-1)=-g0*mueH;  CC0(1)=g0*mueH;

       alm(m1,m0)=p-cmplx(w,CC1(m1)-CC0(m0))
       alp(m1,m0)=p+cmplx(w,CC1(m1)-CC0(m0))

       NdD(m1,m0)=(p+2*w)/(alm(m1,m0)*alp(m1,m0)-w**2)

       return
       end subroutine blumeTjonB
