     subroutine th_22indexsad(isubthe,icase,iput,iget,info) 
!    sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)      
     use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,icstrf,ivstrf,   &
                         enwr,nwr
     use comthe, only: array_fr,theoryname,nproc,mLG,ifrcase,lstr1case
     implicit none 
     integer, intent(inout):: isubthe   
     integer, intent(in)   :: icase,iput,iget 
     integer, intent(out)  :: info      
                                                                       
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,iposLG,iadd                                          
      common/struct/dstr(istr+1),iposLG,iadd(6)

      integer       ibe,jpolsource,jpolabsorber,iflag_basis,idum,    &
                    nLG,nAS,nSC,idum2,ak8,sk8,ien
      real          srw8 
      common/strLOC/jpolsource,jpolabsorber,ibe(10),iflag_basis,     &
                    idum,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(11)      

     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
!    storage use nst2_8 for 4 complex numbers of r_ik                  
     real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc 
     common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc(icstrf-6) 
     real          avm,sftr,aisom,w_Gauss,wLorentz,wGauss,dumv 
     logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz,b_wGauss,b_dumv 
     common/avmaps/avm,sftr,aisom,w_Gauss,wLorentz(8),wGauss(8),dumv(ivstrf-20) 
     common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz(8),b_wGauss(8), &
                   b_dumv(ivstrf-20)                                    
                                                                       
                                                                       
     logical   b_pc,b_polisp,bxx 
     integer   nE,iflag_SAMP,iflag_Voigt,ioffset,ige,jge,lge,jn,ip,      &
               i,ii,ir,k1,k2,n,ni,id,nd,nn,nget,nall,n_all,nst      
     real      Eagd,hr,hi,hti,w_Lorentz,wLor,wGau,     &
               azz,d_x2,aszz,dsx2,fd,srw,fs,sl_t,sl_s,htis,his,hrs
                 
     complex   hrtr,hrpm,ctr,cpm,cmp,hc,hci,trcp,ofcp

     real,    dimension(:), allocatable :: sTr,tint 
     complex, dimension(:), allocatable :: trint,ofint

     real, save :: start,finish, wstart,wfinish
     complex, dimension(:), allocatable :: cLG,temp
     complex, dimension(:,:), allocatable :: tempid
     integer, dimension(0:nproc-1):: first,last
     character(len=8) :: ch8
     integer OMP_GET_THREAD_NUM,nproc_local,nal,idp

      if(isubthe.lt.0) then 
       theoryname='2x2_ref_index_static_sad    v=101'
       if(ifrcase.le.4.or.ifrcase.eq.7) then 
        i=2 
        if(jpolsource.eq.1) i=4 
        if(-isubthe.eq.1) then 
         c1=i*(nSC+1)+1 
        end if 
        if(-isubthe.eq.2) then 
         c1=2*(nAS+1) 
         if(jpolabsorber.eq.1)c1=c1*4 
        end if 
        if(-isubthe.eq.3) c1=i*(nSC+1) 
       end if 

       if(ifrcase.eq.6) then 
        i=2 
        if(-isubthe.eq.2) then 
         c1=2*(nAS+1) 
         if(jpolabsorber.eq.1)c1=c1*4 
        end if 
        if(-isubthe.eq.3) c1=i*(nSC+1) 
       end if 

       if(ifrcase.eq.5) then 
        c1=2*(nAS+1) 
        if(jpolabsorber.eq.1) c1=c1*4 
       end if
       return 
      end if 
                                                                        
      hci=cmplx(0.,1.) 
      iflag_SAMP=flag_SAMP 
      iflag_Voigt=flag_Voigt 
      nst=4 

      call get_theory(isubthe,info) 
      if(info.gt.0) return 
!      write(6,'(a,5f7.2,5l2)')' th_22refindex avm,sftr,aisom,Gauss,Lorentz=',&
!           avm,sftr,aisom,w_Gauss,wLorentz(1),b_vm,b_sftr,b_isom,b_w_Gauss           
                                                                        
      nget=real(array_fr(iget+1)) 
      n_all=real(array_fr(nget+1)) 
      jge=aimag(array_fr(nget+1)) 
      bxx=real(array_fr(nget+2)).gt.0.01 

      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.isubthe.gt.0
      jn=jge; if(jn.gt.8)jn=8
      do i=1,jn
         b_pc=b_pc.or.b_wLorentz(i).or.b_wGauss(i)
      end do
      if(.not.b_pc.or.info.gt.0) then 
       isubthe=-abs(isubthe) 
       goto 400 
      else 
        isubthe=abs(isubthe) 
      end if 
                                                                        
      ioffset=offset 
!      write(6,'(a,5i8,l5)')&
!     '  2x2_ref_index_sad iget,nget,iput,lstr1case,ioffset=', &
!             iget,nget,iput,lstr1case,ioffset,bxx                           
      goto (100,200,300),lstr1case 
!---------------------- source ------------------------------------     
  100 continue 
!    write(6,'(a,L5)') 'jpolsource=',jpolsource 
      w_Lorentz=0.0
      w_Gauss=0.0
      ioffset=offset
      b_polisp=jpolsource.eq.1
      fs=0.
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                        
       if(enwr(7).eq.'fani') then 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
        fs=fs+fd 
        write(nwr,'(a,i2,a2,f10.3)')                                    &
          'anisotropic part of the f-source(',nall,')=',fd             
       end if 

       do jn=ip+1,ip+jge*3-2,3 
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8   
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')                 &
         '**** E(source)=',Eagd,' out of range ',sk8*srw8,'[mm/s]' 
       end do   ! jn=   
      end do   ! nall=1,n_all 
      if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')                      &
       'average over all sites and directions of f-source=',fs/n_all   
                                                                        
       i=2 
       if(b_polisp) i=4 
       do n=iput+1,iput+(nSC+1)*i 
        array_fr(n)=(0.,0.) 
       end do
       if(icase.eq.3) then
          w_Lorentz=w_Gauss
          b_wLorentz=b_wGauss
        ! w_Gauss(i) are at site 12-19  
       else   
        w_Lorentz=wLorentz(1) 
       end if


      if(iflag_SAMP.eq.1) then 

       if(icase.eq.1)call LORGAU(gamnat,e_xsi,                          &
                          srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)  
                                                                        
!       write(6,'(a,i6,/,4f12.5)') &                                     
!       ' *source* iposLG,array_fr(iposLG,+1)=',                        
!       iposLG,array_fr(iposLG),array_fr(iposLG+1)                      
                                                                        
                                                                        
       if(b_polisp) then 
                                                                        
        do nall=1,n_all 
         ip=nget+2+3*jge*(nall-1) 
                                                                        
         if(bxx) then 
          aszz=aimag(array_fr(ip+1)) 
          dsx2=aimag(array_fr(ip+4)) 
          azz =aimag(array_fr(ip+7)) 
          d_x2=aimag(array_fr(ip+10)) 
          fd=exp(-azz*d_x2-aszz*dsx2) 
         else 
          fd=exp(-aimag(array_fr(ip+13))) 
         end if 

        ige=0
        lge=0 
        do jn=ip,ip+jge*3-3,3 
         ige=ige+1
         if(icase.ge.2) then
          if(ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
            if(icase.eq.3)w_Gauss=wGauss(lge)  
           else 
            w_Lorentz=wLorentz(1)
            if(icase.eq.3)w_Gauss=wGauss(1)  
           end if
          end if
          call LORGAU(gamnat,e_xsi,                                       &
                       srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)        
         end if             

          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5) 
                                                                        
         if (iflag_basis.eq.1) then
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd 
         else
          hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
          hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
         end if

      if(enwr(7).eq.'3rho')then 
       print'(a,4f8.2)', 'Sl  rho=', real(hrtr)+aimag(hrtr) ,0., hrpm                     
       print'(a,4f8.2)', '        ', conjg(hrpm),real(hrtr)-aimag(hrtr),0. 
      end if
                                                                        
         do n=0,nSC 
          ni=iput+4*n 
                                                                        
          nd=abs(4*n-nE) 
          if(nd.le.nLG) then 
!          Sum;ab rpq(ab)/2*LG(E-Eab)  LG(E-Eab) on 1,3,...,2n+1        
           hi=aimag(array_fr(iposLG+nd)) 
           array_fr(ni+1)=array_fr(ni+1)-hi*hrtr 
           array_fr(ni+2)=array_fr(ni+2)-hi*hrpm 
          end if 
                                                                        
          nd=abs(-4*n-nE) 
          if(nd.le.nLG) then 
           hi=aimag(array_fr(iposLG+nd)) 
           array_fr(ni+3)=array_fr(ni+3)-hi*hrtr 
           array_fr(ni+4)=array_fr(ni+4)-hi*hrpm 
          end if 
         end do 
        end do ! jn=jge
        end do  ! n_all
       else 

        do nall=1,n_all 
         ip=nget+2+3*jge*(nall-1) 
                                                                        
         if(bxx) then 
          aszz=aimag(array_fr(ip+1)) 
          dsx2=aimag(array_fr(ip+4)) 
          azz =aimag(array_fr(ip+7)) 
          d_x2=aimag(array_fr(ip+10)) 
          fd=exp(-azz*d_x2-aszz*dsx2) 
         else 
          fd=exp(-aimag(array_fr(ip+13))) 
         end if 

         ige=0
         lge=0 
         do jn=ip,ip+jge*3-3,3 
          ige=ige+1
          if(icase.ge.2.and.ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
            if(icase.eq.3)w_Gauss=wGauss(lge)
           else 
            w_Lorentz=wLorentz(1)
            if(icase.eq.3)w_Gauss=wGauss(1) 
           end if
           call LORGAU(gamnat,e_xsi,                                       &
                        srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)        
          end if                       

          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5) 
          hrtr=array_fr(jn+2)*fd 
                                                                        
          do n=0,nSC 
           ni=iput+4*n 
                                                                        
           nd=abs(4*n-nE) 
           if(nd.le.nLG) then 
            array_fr(ni+1)=array_fr(ni+1)-hrtr*aimag(array_fr(iposLG+nd)) 
           end if 
           nd=abs(-4*n-nE) 
           if(nd.le.nLG) then 
            array_fr(ni+2)=array_fr(ni+2)-hrtr*aimag(array_fr(iposLG+nd)) 
           end if 
          end do 
         end do     ! jn
        end do      ! n_all
       end if 
      else   ! if(iflag_SAMP.eq.0) then
                                                                        
       allocate(tint(jge),trint(jge),ofint(jge),cLG(-nSC:nSC))
       srw=4.0*srw8 

       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
 
        ige=0
        lge=0
        if(enwr(7)(1:2).eq.'sl') then
         sl_t=0.
         do jn=ip,ip+jge*3-3,3 
          sl_t=sl_t+aimag(array_fr(jn+2))*fd 
         end do
         ch8=enwr(7)(3:4) 
         call c8toi(ch8,i) 
         k1=(i-1)*3; k2=i*3 -jge*3
        else
         k1=0; k2=0
        end if
        sl_s=0.0
        do jn=ip+k1,ip+k2+jge*3-3,3 
         ige=ige+1
         if(icase.ge.2) then
          if(ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
            if(icase.eq.3)w_Gauss=wGauss(lge)  
           else 
            w_Lorentz=wLorentz(1)
            if(icase.eq.3)w_Gauss=wGauss(1)  
           end if
          end if
          call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                            srw,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)     
         else
          call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                            srw,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)     
         end if 

         if (iflag_basis.eq.1) then
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd 
         else
          hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
          hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
         end if
         trint(ige)=hrtr; ofint(ige)=hrpm

!        write(6,'(f8.1,a,4f8.2)')real(array_fr(jn+1)), 's rho=',&
!         cmplx(aimag(hrtr)+ real(hrtr),0.),hrpm                     
!        write(6,'(i2,a,4f8.2)')iflag_basis,'            ', &
!         conjg(hrpm),cmplx(aimag(hrtr)-real(hrtr),0.)

         hti= aimag(hrtr)/2.0 
         ctr= real(hrtr)*hci/2.0 
         cpm= hrpm*hci/2.0 
         cmp= conjg(hrpm)*hci/2.0 
         sl_s=sl_s+aimag(array_fr(jn+2))*fd 
!         if(ige.ne.4.and.ige.ne.5) then
!          hrtr=(0.,0.); hrpm=(0.,0.)
!         end if                                                               
         Eagd=real(array_fr(jn+1))+aisom                               
      if(enwr(7).eq.'3rho')then 
       print'(a,4f8.2)', 'Slx rho=', real(hrtr)+aimag(hrtr),0.0,hrpm           
       print'(a,4f8.2)', '        ', conjg(hrpm),real(hrtr)-aimag(hrtr),0.0 
      end if
                                                                      
         if(b_polisp) then 
          do n=0,nSC 
           nn=iput+4*n 
           array_fr(nn+1)=array_fr(nn+1)- aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)- aimag(cLG(n ))*hrpm 
           array_fr(nn+3)=array_fr(nn+3)- aimag(cLG(-n))*hrtr 
           array_fr(nn+4)=array_fr(nn+4)- aimag(cLG(-n))*hrpm
          end do
        
         else 
          do n=0,nSC 
           nn=iput+2*n 
           array_fr(nn+1)=array_fr(nn+1)- aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)- aimag(cLG(-n))*hrtr 
          end do 
         end if
        end do       ! jn=
       if(enwr(7).eq.'rhom')then
        print '(a,i5)','(r11-r22,r11+r22) (1:4) source site=',n_all
        n=jge/2
        if(n.eq.0)n=1
        print '(4(3x,2f10.5))',(trint(i),i=1,n)
        print '(a,i5)','(r12)(1:jge/2):'
        print '(4(3x,2f10.5))',(ofint(i),i=1,n)
       end if
      end do         ! n_all
      deallocate(tint,trint,ofint,cLG)
      end if         ! iflag_SAMP 
                                                                        
!     The sum of the Lorentz-Gauss curves of the jge lines              
!     have to be normalized to 1 for each subspectrum of the source     
!     iscpi=iscpr+2*nSC+1                                               
                                                                        
        allocate(sTr(-nSC:nSC))
                
        if(b_polisp) then 
         do i=0,nSC 
          nn=iput+4*i 
          sTr(i)=aimag(array_fr(nn+1)) 
          sTr(-i)=aimag(array_fr(nn+3)) 
         end do 
        else 
         do i=0,nSC 
          nn=iput+2*i 
          sTr(i)=aimag(array_fr(nn+1)) 
          sTr(-i)=aimag(array_fr(nn+2)) 
         end do 
        end if 
!       write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',sTr(i),sTr(-i),i=0,5)
                                                                        
         hr=0. 
         do n=-nSC+1,nSC-1,2 
          hr=hr+ sTr(n)*2 
         end do 
         do n=-nSC+2,nSC-2,2 
          hr=hr+sTr(n) 
         end do 
         hr=hr*2.+ sTr(-nSC)+sTr(nSC); hr=hr/3. 
        if(b_polisp) then 
         do i=0,nSC 
          nn=iput+4*i 
          array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
          array_fr(nn+2)=array_fr(nn+2)/hr
          array_fr(nn+3)=cmplx(real(array_fr(nn+3)),sTr(-i))/hr 
          array_fr(nn+4)=array_fr(nn+4)/hr      
         end do 
        else 
         do i=0,nSC 
          nn=iput+2*i 
          array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
          array_fr(nn+2)=cmplx(real(array_fr(nn+2)),sTr(-i))/hr  
         end do 
        end if 

        if(enwr(7)(1:2).eq.'sl'.and.sl_t.gt.0.) hr=hr*sl_t/sl_s
        deallocate(sTr)
       goto 400 
!------------------------ absorber ----------------------------------   
  200  continue 
!       write(6,'(a,5i6)') '2x2_ref n_all,icase,iflag_SAMP=',   &
!                                  n_all,icase,iflag_SAMP,nAS 
!    write(6,'(a,L5)') 'jpolabsorber=',jpolabsorber

     b_polisp=jpolabsorber.eq.1    
     fs=0. 
     if(enwr(7).eq.'fEag')then
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                      
       if(bxx) then 
        aszz=aimag(array_fr(ip+1)) 
        dsx2=aimag(array_fr(ip+4)) 
        azz =aimag(array_fr(ip+7)) 
        d_x2=aimag(array_fr(ip+10)) 
        fd=exp(-azz*d_x2-aszz*dsx2) 
!        fd=1.-azz*d_x2-aszz*dsx2                                       
       else 
        fd=exp(-aimag(array_fr(ip+13))) 
!        fd=1.-aimag(array_fr(ip+13))                                   
       end if 
       fs=fs+fd 
       write(nwr,'(a,i2,a2,f10.3)')                                   &
        'anisotropic part of the f-absorber(',nall,')=',fd           

       do jn=ip+1,ip+jge*3-2,3 
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8 
        if (abs(nE).gt.ak8)write(nwr,'(2(a,f10.4),a)')                 &
        '**** E(absorber)=',Eagd,' out of range ',ak8*srw8,'[mm/s]'   
       end do  ! jn=  
      end do   !  nall=1,n_all  
      write(nwr,'(a,f10.3)')                     &
      'average over all sites and directions of f-absorber=',fs/n_all 
     end if

     i=2 
     if(jpolabsorber.eq.1) i=8
     do n=iput+1,iput+(nAS+1)*i 
      array_fr(n)=(0.,0.) 
     end do 

     if(icase.eq.3) then
!        w_Lorentz=w_Gauss
        wLorentz=wLorentz(1)        
!      b_wLorentz=b_wGauss
      ! w_Gauss(i) are at site 12-19  
     else   
        w_Lorentz=wLorentz(1)
        wLor=w_Lorentz; wGau=w_Gauss
     end if

!   write(6,'(i3,/,8f8.2,/,8f8.2)')icase,wGauss,wLorentz
    
    if(iflag_SAMP.eq.1) then 
                                                                      
      if(icase.eq.1) call LORGAU(gamnat,e_xsi,                       &
                          srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)
!     write(6,'(2a,/,5f10.4,5i8)')'gamnat,e_xsi,',    &                   
!     'srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG=', &         
!     gamnat,e_xsi,srw8*1000,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG
                       
                                                                      
     if(b_polisp) then 
                                                                    
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                      
       if(bxx) then 
        aszz=aimag(array_fr(ip+1)) 
        dsx2=aimag(array_fr(ip+4)) 
        azz =aimag(array_fr(ip+7)) 
        d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
!         fd=1.-azz*d_x2-aszz*dsx2 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
!         fd=1.-aimag(array_fr(ip+13))
       end if
 
       ige=0
       lge=0  
       do jn=ip,ip+jge*3-3,3 
        ige=ige+1
        if(icase.ge.2) then
         if(ige.ge.ioffset)then
          lge=lge+1
          if(lge.le.8) then
           w_Lorentz=wLorentz(lge)
            if(icase.eq.3)w_Gauss=wGauss(lge)  
          else 
           w_Lorentz=wLorentz(1)
           if(icase.eq.3)w_Gauss=wGauss(1)  
          end if
         end if
         call LORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)
        end if
        if (iflag_basis.eq.1) then
         hrtr=array_fr(jn+2)*fd 
         hrpm=array_fr(jn+3)*fd 
        else
         hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
         hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
        end if

!       Poincare decomposition of rho (mossbauer)                 
        hti= aimag(hrtr)/2.0 
        ctr= real(hrtr)*hci/2.0 
        cpm= hrpm*hci/2.0 
        cmp= conjg(hrpm)*hci/2.0 

       if(enwr(7).eq.'3rho')then 
        print'(a,4f8.2)', 'SL  rho=', real(hrtr)+aimag(hrtr) ,hrpm                     
        print'(a,4f8.2)', '        ', conjg(hrpm),real(hrtr)-aimag(hrtr) 
       end if
                                                            
!       nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)          
!       nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))          
!       b1=1/2 kz*(npm+nmp)                                           
!       b2=1/2 kz*(npm-nmp)*i                                         
!       b3=1/2 kz*(npp-nmm)                                           
!       the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2r
!       fLG=(4*n-nE)*srw8/(hga/2.) is written as                      
                                                                      
        Eagd=real(array_fr(jn+1))+aisom 
        nE=ifix(Eagd/srw8+0.5) 
!       write(6,'(2i8,a,8f10.4)')ip,lge,' E,p=',Eagd,w_Lorentz,w_Gauss         
                                                                      
        do n=0,nAS 
         ni=iput+8*n 
         nd=nst*n-nE                 ! +n                            
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=array_fr(iposLG+nd)
          else 
           hc=-conjg(array_fr(iposLG-nd)) 
          end if 
          array_fr(ni+1)=array_fr(ni+1)-hc*hti 
          array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
          array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
          array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
         end if 
         nd=-nst*n-nE                   ! -n 
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=array_fr(iposLG+nd) 
          else 
           hc=-conjg(array_fr(iposLG-nd)) 
          end if 
          array_fr(ni+5)=array_fr(ni+5)-hc*hti 
          array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
          array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
          array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
         end if 
        end do      ! nAS 
       end do       ! jn=  
      end do        ! n_all 
     else           ! if .not.polarized 
                                                                      


        
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                      
       if(bxx) then 
        aszz=aimag(array_fr(ip+1)) 
        dsx2=aimag(array_fr(ip+4)) 
        azz =aimag(array_fr(ip+7)) 
        d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
!         fd=1.-azz*d_x2-aszz*dsx2 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
!         fd=1.-aimag(array_fr(ip+13))
        end if
       ige=0
       lge=0

       do jn=ip,ip+jge*3-3,3 
        ige=ige+1
        if(icase.ge.2) then
         if(ige.ge.ioffset)then
          lge=lge+1
          if(lge.le.8) then
           w_Lorentz=wLorentz(lge)
            if(icase.eq.3)w_Gauss=wGauss(lge)  
          else 
           w_Lorentz=wLorentz(1)
           if(icase.eq.3)w_Gauss=wGauss(1)  
          end if
         end if
         call LORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)
        end if

        hrtr=array_fr(jn+2)*fd 
        hti = aimag(hrtr)/2.0 
                                                                      
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5) 
                                                                      
        do n=0,nAS 
         ni=iput+8*n 
         nd=nst*n-nE                  ! +n
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=array_fr(iposLG+nd) 
          else 
           hc=-conjg(array_fr(iposLG-nd)) 
          end if 
          array_fr(ni+1)=array_fr(ni+1)-hc*hti 
         end if 
         nd=-nst*n-nE                  ! -n 
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=array_fr(iposLG+nd) 
          else 
           hc=-conjg(array_fr(iposLG-nd)) 
          end if 
          array_fr(ni+2)=array_fr(ni+2)-hc*hti 
         end if 
        end do      ! nAS 
       end do       ! jn= 
      end do        ! n_all 
     end if         ! polarized 
                                                                      
    else     !flag sampling 
!    iflag_SAMP=0  
     srw=srw8*float(nst) 

     allocate(cLG(-nAS:nAS))
    trcp=(0.,0.); ofcp=(0.,0.)
    if(enwr(15).eq.'prnt') then
!    printing of quadrupole intensities/Polarizations of a single crytal        
     allocate(tint(jge),trint(jge),ofint(jge))
     do nall=1,n_all 
      ip=nget+2+3*jge*(nall-1) 
                                                                      
      if(bxx) then 
       aszz=aimag(array_fr(ip+1)) 
       dsx2=aimag(array_fr(ip+4)) 
       azz =aimag(array_fr(ip+7)) 
       d_x2=aimag(array_fr(ip+10)) 
       fd=exp(-azz*d_x2-aszz*dsx2) 
!       fd=1.-azz*d_x2-aszz*dsx2 
      else 
       fd=exp(-aimag(array_fr(ip+13))) 
!       fd=1.-aimag(array_fr(ip+13)) 
      end if 
      ige=0;  lge=0 
      htis=0.; his=0.; hrs=0.
      do jn=ip,ip+jge*3-3,3

         
       ige=ige+1
       if(icase.ge.2) then
         if(ige.ge.ioffset)then
          lge=lge+1
          if(lge.le.8) then
           w_Lorentz=wLorentz(lge)
            if(icase.eq.3)w_Gauss=wGauss(lge)  
          else 
           w_Lorentz=wLorentz(1)
           if(icase.eq.3)w_Gauss=wGauss(1)  
          end if
         end if
        call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                          srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)     
       else
        call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                          srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)     
       end if

       if (iflag_basis.eq.1) then
        hrtr=array_fr(jn+2)*fd 
        hrpm=array_fr(jn+3)*fd 
       else
        hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
        hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
       end if
       trint(ige)=array_fr(jn+2); ofint(ige)=array_fr(jn+3)
                                                                     
       if(enwr(7).eq.'3rho')then 
       print'(a,4f10.5)', 'Sa  rho=', real(hrtr)+aimag(hrtr),0.0 ,hrpm       
       print'(a,4f10.5)', '        ', conjg(hrpm),real(hrtr)-aimag(hrtr),0.0 
       end if

       hti= aimag(hrtr)/2.0 
       ctr= real(hrtr)*hci/2.0 
       cpm= hrpm*hci/2.0 
       cmp= conjg(hrpm)*hci/2.0 

!      write(6,'(i8,2f9.3,a,4f8.3)')jn,array_fr(jn+1)+aisom,&
!                   ' rho=',cmplx(aimag(hrtr)+ real(hrtr),0.),hrpm    
!      write(6,'(2i3,a,4f8.3)')iflag_basis,ige,'           ',&
!               conjg(hrpm),cmplx(aimag(hrtr)-real(hrtr),0.)
!      switch off off diagonal elements and polarization
!      cpm=(0.0); cpm=(0.0); ctr=(0.,0.);htis=htis+hti/fd

       tint(ige)=hti+real(hrtr)/2.0

       if(b_polisp) then 
        do n=0,nAS 
         ni=iput+8*n 
         hc=cLG(n) 
         array_fr(ni+1)=array_fr(ni+1)-hc*hti 
         array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
         array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
         array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
         hc=cLG(-n)
         array_fr(ni+5)=array_fr(ni+5)-hc*hti 
         array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
         array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
         array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
        end do 
       else 
        do n=0,nAS 
         ni=iput+2*n 
         hc=cLG(n) 
         array_fr(ni+1)=array_fr(ni+1)-hc*hti 
         hc=cLG(-n) 
         array_fr(ni+2)=array_fr(ni+2)-hc*hti 
        end do 
       end if
      end do       !   jn=
      if(jge.eq.8)then
!       his=his+tint(1)+tint(2)+tint(3)+tint(4) 
!       hrs=hrs+tint(5)+tint(6)+tint(7)+tint(8) 
!       hi=hi+his
!       hr=hr+hrs
       trcp=trint(1)+trint(2)+trint(3)+trint(4) 
!       ofcp=ofcp+ofint(1)+ofint(2)+ofint(3)+ofint(4) 
       ofcp=trint(5)+trint(6)+trint(7)+trint(8) 
       !      ofcp=ofcp+ofint(5)+ofint(6)+ofint(7)+ofint(8)
            print'(8f12.5)',fd,aimag(trcp)*2,aimag(ofcp)*2       
      end if
      if(enwr(7).eq.'intr'.and.ige.eq.8) &
!            print'(8f12.5)',his/fd,hrs/fd,(his+hrs)/fd,fd
            print'(8f12.5)',trcp,ofcp
     end do        ! nall=1,n_all 
!     if(jge.eq.8)then
!      if(enwr(7).eq.'intr') print'(8f12.5)',hi,hr, (hi+hr),hi/(hr+hi)
      if(enwr(7).eq.'rhom')then
       print '(a)','(r11-r22,r11+r22) sum(5-8), offdia sum(5-8), pol'
       hr=sqrt(ofcp*conjg(ofcp))/aimag(trcp)
       print '(2(4x,2f12.5),4x,f10.3)',trcp,ofcp,hr
      end if
      !     end if
      deallocate(tint,trint,ofint)
      else  ! standard capabilities  -------------------------------

     if(b_polisp) then
      allocate(temp(8*(nAS+1)),tempid(0:nproc-1,8*(nAS+1)))   
     else
      allocate(temp(2*(nAS+1)),tempid(0:nproc-1,2*(nAS+1)))
     end if
     if(enwr(15).eq.'time') then
        call cpu_time(start); call wall_time(wstart)
     end if

     
     ii=n_all/nproc; ir=n_all-ii*nproc
     do id=0,nproc-1
      first(id) = id*(n_all/nproc)+1
       last(id) = (id+1)*(n_all/nproc)
     end do
     if(ir.gt.0) then
      first(0)=1; last(0)=1+ii
      do id=1,ir-1
        first(id) = last(id-1)+1
         last(id) = first(id)+ii
      end do
      do id=ir,nproc-1
        first(id) = first(id)+ir
         last(id) = last(id)+ir
      end do
    end if
!print*, ' n_all:',n_all
!print*, ' first:',first
!print*, '  last:',last

nproc_local=nproc; if(ii.eq.0)nproc_local=ir 
CALL OMP_SET_NUM_THREADS(nproc_local)
!$OMP PARALLEL DEFAULT(NONE),  PRIVATE(id,nal,ip,aszz,azz,dsx2,d_x2,fd,jn) &
!$OMP PRIVATE(ige,lge,htis,his,hrs,hrtr,hrpm,hti,ctr,cpm,cmp,n,ni,hc)& 
!$OMP PRIVATE(w_Lorentz,w_Gauss,temp,cLG) & 
!$OMP SHARED(first,last,nget,jge,bxx,array_fr,icase,ioffset,wLorentz,wGauss) &
!$OMP SHARED(aisom,gamnat,e_xsi,srw,iflag_Voigt,nAS,wLor,wGau)   &
!$OMP SHARED(iflag_basis,b_polisp,hci,tempid,nproc_local)
!$OMP DO

   do idp=0,nproc_local-1
     id = OMP_GET_THREAD_NUM()
!    Print*,id,first(id),last(id)

     temp=(0.,0.)  
     DO nal=first(id),last(id) 
      ip=nget+2+3*jge*(nal-1) 
                                                                      
      if(bxx) then 
       aszz=aimag(array_fr(ip+1)) 
       dsx2=aimag(array_fr(ip+4)) 
       azz =aimag(array_fr(ip+7)) 
       d_x2=aimag(array_fr(ip+10)) 
       fd=exp(-azz*d_x2-aszz*dsx2) 
      else 
       fd=exp(-aimag(array_fr(ip+13))) 
      end if 

      ige=0;  lge=0 
      htis=0.; his=0.; hrs=0.
      do jn=ip,ip+jge*3-3,3
         
       ige=ige+1
       if(icase.ge.2) then
         if(ige.ge.ioffset)then
          lge=lge+1
          if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
            w_Gauss=0.0 
            if(icase.eq.3)w_Gauss=wGauss(lge)  
          else 
            w_Lorentz=wLorentz(1)
            w_Gauss=0.0              
           if(icase.eq.3)w_Gauss=wGauss(1)  
          end if
         end if
        call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                          srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)     
       else
         call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                             srw,wLor,wGau,iflag_Voigt,nAS,cLG)     
      end if
     
       if (iflag_basis.eq.1) then
        hrtr=array_fr(jn+2)*fd 
        hrpm=array_fr(jn+3)*fd 
       else
        hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
        hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
       end if

       hti= aimag(hrtr)/2.0 
       ctr= real(hrtr)*hci/2.0 
       cpm= hrpm*hci/2.0 
       cmp= conjg(hrpm)*hci/2.0 

       if(b_polisp) then 
        do n=0,nAS 
         ni=8*n 
         hc=cLG(n) 
         temp(ni+1)=temp(ni+1)-hc*hti 
         temp(ni+2)=temp(ni+2)-hc*ctr 
         temp(ni+3)=temp(ni+3)-hc*cpm 
         temp(ni+4)=temp(ni+4)-hc*cmp 
         hc=cLG(-n)
         temp(ni+5)=temp(ni+5)-hc*hti 
         temp(ni+6)=temp(ni+6)-hc*ctr 
         temp(ni+7)=temp(ni+7)-hc*cpm 
         temp(ni+8)=temp(ni+8)-hc*cmp
        end do 
       else 
        do n=0,nAS 
         ni=2*n 
         hc=cLG(n) 
         temp(ni+1)=temp(ni+1)-hc*hti
         hc=cLG(-n) 
         temp(ni+2)=temp(ni+2)-hc*hti
        end do 
       end if
      end do       !   jn=
      if(nal.eq.last(id))tempid(id,:)=temp
     end do        ! nal=
    end do
!$OMP END PARALLEL

     if(b_polisp) then
      do id=0,nproc_local-1 
       do n=1,(nAS+1)*8 
          array_fr(iput+n)=array_fr(iput+n)+tempid(id,n)
       end do
      end do
     else
      do id=0,nproc_local-1 
       do n=1,(nAS+1)*2 
         array_fr(iput+n)=array_fr(iput+n)+tempid(id,n)
       end do
      end do
   end if

   if(enwr(15).eq.'time') then
       call cpu_time(finish); call wall_time(wfinish)
       print '(" cpu/wall time = ",2f10.4," seconds.")',&
                    finish-start,wfinish-wstart
     end if
     deallocate(temp,tempid)
    end if  ! enwr(15)=prnt    

    deallocate(cLG)
   end if         ! iflag_SAMP
   goto 400 
                                                                      
!------------------------------detector-----------------------------------   
  300  continue 
      n_all=real(array_fr(nget+1)) 
      jge=real(array_fr(nget+2)) 
      bxx=aimag(array_fr(nget+2)).gt.0.01 
                                                                        
                                                                        
       do n=iput+1,iput+(nSC+1) 
        array_fr(n)=(0.,0.) 
       end do 
                                                                        
!      iflag_SAMP=0  

       allocate(cLG(-nSC:nSC))                                            
                                                                        
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
                                                                        
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
                                                                        
        do jn=ip,ip+jge*3-3,3 
         hrtr=array_fr(jn+2)*fd 
         call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                      srw8,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)  
         do n=0,nSC 
          ni=iput+n+1 
          array_fr(ni)=array_fr(ni)-                                    &
           cmplx(aimag(cLG(n)),aimag(cLG(-n)))*aimag(hrtr)              
         end do    ! n 
        end do     ! jn=  
       end do      !  nall=1,n_all  
       deallocate(cLG)
                                                                        
  400 return 
      END                                           



    subroutine th_poincare(isubthe,icase,iput,iget,info) 
!     sad= source,absorber,detector : lstr1case=1,2,3      
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,ivstrf,icstrf,enwr
      use comthe, only: array_fr,theoryname,mLG,lstr1case
      implicit none 

      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info
                                                               
      integer       ibe,iflag_basis,idum,nAS,nSC,ien                           
      common/strLOC/ibe(12),iflag_basis,idum(2),nAS,nSC,ien(15)
                                                                        
      logical       b_vs,b_dumvsp 
      common/bvstrf/b_vs(4),b_dumvsp(ivstrf-4) 
      real          c1,dumcm
      common/acmaps/c1,dumcm(icstrf-1) 
      real          avm,Pxsi,Peta,Pzeta,dumvm 
      common/avmaps/avm,Pxsi,Peta,Pzeta,dumvm(ivstrf-4) 
      logical       b_vm,b_dumvm 
      common/bvmaps/b_vm(4),b_dumvm(ivstrf-4) 

      complex,dimension(2,2):: trv,TSPCA,sph                 
      real,parameter :: sqrt2r=0.70710678
      complex hc
      real pp
      complex, dimension(4):: Arho
      integer   n,m,i,k,j
            
      if(isubthe.lt.0) then 
       theoryname='poincare        v=100' 
       if(-isubthe.eq.1) then 
        c1=2*(nSC+1)+1 +5 
       end if 
       if(-isubthe.eq.2) c1=2*(nAS+1)+5  
       if(-isubthe.eq.3) c1=2*(nSC+1)+5
       return 
      end if 

      if(.not.b_vm(1)) then 
       isubthe=-abs(isubthe) 
       return 
      end if 

   select case(lstr1case)
    case(1)
!---------------------------- source ---------------------------------          

    case(2)
!---------------------------- absorber ------------------------------ 
    case(3)
!---------------------------- detector/analyser-----------------------
       do n=iput+1,iput+(nSC+1) 
        array_fr(n)=(0.,0.) 
       end do
       pp=Pxsi**2+Peta**2+Pzeta**2
       
       Arho(1)=cmplx(1.+Pzeta,0.)/2. 
       Arho(3)=cmplx(Pxsi,-Peta)/2. 
       Arho(2)=cmplx(Pxsi,Peta)/2. 
       Arho(4)=cmplx(1.-Pzeta,0.)/2.
        if(iflag_basis.eq.0) then 
!        linear polarization basis                                        
         TSPCA(1,1)=cmplx( sqrt2r,0.); TSPCA(1,2)=cmplx(-sqrt2r,0.) 
         TSPCA(2,1)=cmplx(0.,-sqrt2r); TSPCA(2,2)=cmplx(0.,-sqrt2r) 

         sph(1,1)=Arho(1); sph(1,2)=Arho(3) 
         sph(2,1)=Arho(2); sph(2,2)=Arho(4) 
         do i=1,2 
         do k=1,2 
          hc=(0.,0.) 
          do j=1,2 
          do n=1,2 
           hc=hc+TSPCA(i,n)*sph(n,j)*conjg(TSPCA(k,j)) 
          end do 
          end do 
          trv(i,k)=hc 
         end do 
         end do 
         Arho(1)=trv(1,1) 
         Arho(3)=trv(1,2) 
         Arho(2)=trv(2,1) 
         Arho(4)=trv(2,2) 
        end if 

     n=iput+(nSC+1)
     do m=1,4 
      array_fr(n+m)=Arho(m)
     end do
     array_fr(n+5)=cmplx(pp,0)
     if(b_vm(1))array_fr(n+5)=cmplx(pp,1.)
     if(enwr(7).eq.'3rho')then      
      print'(a,4f8.2)', 'An  rho=', Arho(1),Arho(3)                     
      print'(a,4f8.2)', '        ', Arho(2),Arho(4) 
      print'(a,4f8.2)','cmplx(pp,1.)=',cmplx(pp,1.)
     end if

    end select
   return 
 END subroutine th_poincare
 
      subroutine th_11indexsad(isubthe,icase,iput,iget,info) 
!     sad= source,absorber,detector : lstr1case=1,2,3      
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,ivstrf,icstrf
      use comthe, only: array_fr,theoryname,mLG,lstr1case
      implicit none 

      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info
                                                               
      integer       ibe,nAS,nSC,idum,ien                                        
      real          srw8 
      common/strLOC/ibe(15),nAS,nSC,idum(3),srw8,ien(11)
                                                                        
      logical       b_vs,b_v_max,b_dumvsp 
      common/bvstrf/b_vs(4),b_v_max,b_dumvsp(ivstrf-5) 
      real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumcm 
      common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumcm(icstrf-5) 
      real          avm,shift,dumvm 
      common/avmaps/avm(2),shift,dumvm(ivstrf-3) 
      logical       b_vm,b_shift,b_dumvm 
      common/bvmaps/b_vm(2),b_shift,b_dumvm(ivstrf-3) 
                                                                        
      logical   b_pc 
      integer   iflag_Voigt,i,i1,i2,n,ni,nst,jge
      real      hr,hti,srw
      complex   hc,hci
      real,     dimension(:),allocatable :: Eagd,rtr,sTr,w_Gauss,w_Lorentz
      complex,  dimension(:),allocatable :: cLG
                                                                        
      if(isubthe.lt.0) then 
       theoryname='1x1_ref_index_static_sad       v=100' 
       if(-isubthe.eq.1) then 
        c1=2*(nSC+1)+1 
       end if 
       if(-isubthe.eq.2) c1=2*(nAS+1) 
       if(-isubthe.eq.3) c1=2*(nSC+1) 
!       write(6,'(a,3i6,f12.2)')'th_11refindex :',-isubthe,nSC,nAS,c1   
       return 
      end if 
!     storage use nst2_8 for 4 complex numbers of r_ik                  
                                                                        
      hci=cmplx(0.,1.) 
      iflag_Voigt=flag_Voigt 
      nst=4 
                                                                        
!     only line positions are taken                                     
!     write(6,'(a,2i4)') 'th_11refindex avsstrf 1 jge=',jge           
!     write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz             
       call get_theory(isubthe,info) 
       if(info.gt.0) return 
       b_pc=b_v_max.or.isubthe.ge.0.or.b_vm(1)
        if(.not.b_pc) then 
         isubthe=-abs(isubthe) 
         return 
        end if 
        isubthe=abs(isubthe) 
       if(icase.eq.0) print'(a)','icase not defined in str routine'
       
       i1=iget+1 
       jge=real(array_fr(i1)) 
       allocate(Eagd(jge),rtr(jge),w_Gauss(jge),w_Lorentz(jge))      

       i2=i1+jge 
       do i=1,jge 
        Eagd(i)=real(array_fr(i1+i))+shift 
        rtr(i)=aimag(array_fr(i1+i)) 
        w_Gauss(i)=real(array_fr(i2+i)) 
        w_Lorentz(i)=aimag(array_fr(i2+i)) 
       end do 
!       write(6,'(8f10.3)') (Eagd(i),i=1,jge), (w_Lorentz(i),i=1,jge)
!      write(6,'(8f10.3)') (rtr(i),i=1,jge)                            
                                                                        
!---------------------------- source ---------------------------------          
  select case(lstr1case)
    case(1)
     
        allocate(cLG(-nSC:nSC),sTr(-nSC:nSC))

!       write(6,'(a,i7)') 'ch_case(1:6).eq.source iput=',iput           
        do n=iput+1,iput+(nSC+1)*2 
         array_fr(n)=(0.,0.) 
        end do 
                                                                        
        srw=4.0*srw8 
        do i=1,jge 
         call aLORGAU(Eagd(i),gamnat,e_xsi,                             &
                       srw,w_Lorentz(i),w_Gauss(i),iflag_Voigt,nSC,cLG)    
!       write(6,'(a,i2,i5,a,6f12.4)')'i,nSC=',i,nSC,                   
!       ' th_subrmoss gamnat,srw,w_Lorentz,w_Gauss=',                  
!       gamnat,srw,w_Lorentz(i),w_Gauss(i)                           
         do n=0,nSC 
          ni=iput+2*n 
          array_fr(ni+1)=array_fr(ni+1)+cmplx(0.,-aimag(cLG(n))*rtr(i)) 
          array_fr(ni+2)=array_fr(ni+2)+cmplx(0.,-aimag(cLG(-n))*rtr(i)) 
         end do       ! n loop
        end do        ! i=1,jge
!       write(6,'(a,2i6)') ' th_11ref - source, iput,nSC=',iput,nSC     
!       write(6,'(4f15.6)') (rtr(i),i=1,jge)                            
                                                                        
!       The sum of the Lorentz-Gauss curves of the jge lines            
!       have to be normalized to 1 for each subspectrum of the source   
                                                                        
        do i=0,nSC 
         ni=iput+2*i 
         sTr(i)=aimag(array_fr(ni+1)) 
         sTr(-i)=aimag(array_fr(ni+2)) 
        end do 
                                                                        
        hr=0. 
        do n=-nSC+1,nSC-1,2 
         hr=hr+ sTr(n)*2 
        end do 
        do n=-nSC+2,nSC-2,2 
         hr=hr+sTr(n) 
        end do 
        hr=hr*2.+ sTr(-nSC)+sTr(nSC); hr=hr/3
!      Normierung: 2/(Gamma*pi)*srw*hr=1

        do n=0,nSC 
         ni=iput+2*n 
         array_fr(ni+1)=cmplx(real(array_fr(ni+1)),sTr(n))/hr 
         array_fr(ni+2)=cmplx(real(array_fr(ni+2)),sTr(-n))/hr  
        end do 

        deallocate(cLG,sTr)
!---------------------------- absorber ------------------------------ 
    case(2)
       allocate(cLG(-nAS:nAS))

        do n=iput+1,iput+(nAS+1)*2 
         array_fr(n)=0. 
        end do 
        srw=srw8*float(nst) 
        do i=1,jge 
         if(rtr(i).gt.1.e-5) then
          call aLORGAU(Eagd(i),gamnat,e_xsi,                            &
                       srw,w_Lorentz(i),w_Gauss(i),iflag_Voigt,nAS,cLG)     
          hti=rtr(i)/2.0
          do n=0,nAS 
           ni=iput+2*n 
           hc=cLG(n)                      
           array_fr(ni+1)=array_fr(ni+1)-hc*hti 
           hc=cLG(-n) 
           array_fr(ni+2)=array_fr(ni+2)-hc*hti 
          end do       ! n loop
         end if
        end do        ! i=1,jge
!       write(6,'(a,2i6)') ' th_11ref - absorber, iput,nAS=',iput,nAS   
!       write(6,'(4f15.6)') (rtr(i),i=1,jge)                            
!       write(6,'(6f12.6)') (aimag(array_fr(iput+i)),i=0,12)
        deallocate(cLG) 
!---------------------------- detector ----------------------------------
    case(3)
       allocate(cLG(-nSC:nSC))

        do n=iput+1,iput+(nSC+1) 
         array_fr(n)=(0.,0.) 
        end do 
        do i=1,jge 
         call aLORGAU(Eagd(i),gamnat,e_xsi,                             &
                       srw8,w_Lorentz(i),w_Gauss(i),iflag_Voigt,nSC,cLG)   
         do n=0,nSC 
          ni=iput+n+1 
          array_fr(ni)=array_fr(ni)-cmplx(aimag(cLG(n)),aimag(cLG(-n)))*rtr(i)
         end do ! n loop
        end do  ! i=1,jge
       deallocate(cLG)
    end select                                                            
   return 
   END                                           
                                                                        
                                                                     


     subroutine th_22indexsource(isubthe,icase,iput,iget,info) 
!    sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)      
     use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,icstrf,ivstrf,   &
                         enwr,nwr
     use comthe, only: array_fr,theoryname,mLG,lstr1case
     implicit none 
     integer, intent(inout):: isubthe   
     integer, intent(in)   :: icase,iput,iget
     integer, intent(out)  :: info      
                                                                       
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,iposLG,ipTHS,iadd                                          
      common/struct/dstr(istr+1),iposLG,ipTHS,iadd(5)

      integer       ibe,jpolsource,jpolabsorber,iflag_basis,idum,    &
                    nLG,nAS,nSC,idum2,ak8,sk8,isite,ien
      real          srw8 
      common/strLOC/jpolsource,jpolabsorber,ibe(10),iflag_basis,     &
                    idum,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(10),      &      
                    isite
     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
!    storage use nst2_8 for 4 complex numbers of r_ik                  
     real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset, &
                   dum1,mu_electronic,anz,dsfoil,dumc 
     common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset, &
                   dum1,mu_electronic,anz,dsfoil,dumc(icstrf-10) 
     real          avm,sftr,aisom,mu_57Fe,mu_iron,d1_ov_e,   &
                   wGauss,wLorentz,dumv 
     logical       b_vm,b_sftr,b_isom,b_mu57Fe,b_muiron,b_d1ove,  &
                   b_wGauss,b_wLorentz,b_dumv 
     common/avmaps/avm,sftr,aisom,mu_57Fe,mu_iron,d1_ov_e,     &
                   wGauss(8),wLorentz(8),dumv(ivstrf-22)
     common/bvmaps/b_vm,b_sftr,b_isom,b_mu57Fe,b_muiron,b_d1ove,    &
                   b_wGauss(8),b_wLorentz(8),b_dumv(ivstrf-22)                                    

!    mg/cm2xf/d1_ov_e  =strength(1)
    
     logical   b_polisp,bxx 
     integer   nE,iflag_SAMP,iflag_Voigt,ioffset,ige,jge,lge,jn,ip,   &
               i,n,nn,nget,nall,n_all,nst     
     real      Eagd,hr,hti,w_Gauss,w_Lorentz,r_d1ove,r_mu57Fe,r_muiron,&
               azz,d_x2,aszz,dsx2,fd,srw,fs

     complex   hrtr,hrpm,ctr,cpm,cmp,hc
!     complex, dimension(2,2):: trv,TSPCA,sph 
      complex, parameter :: Ci=cmplx(0.,1.), C0=cmplx(0.,0.)
     
     real,    dimension(:), allocatable :: sTr
     complex, dimension(:), allocatable :: cLG
                                           

      if(isubthe.lt.0) then 
       theoryname='2x2_rho_matrix_source    v=160' 
        if(-isubthe.eq.1) then 
         c1=8*(2*nSC+1)
!        2*(2*nSC+1):for source function of site number i
!        4*(2*nSC+1): for the source function of the sum over all sites
!        2*(2*nSC+1) for 4 real Poincare arrays        
!        6: for  constants transferred to rhoz
        end if 
       return 
      end if 
!            print*,'b_vm,b_sftr,b_isom,b_mu57Fe,b_muiron,b_d1ove=',  &
!           b_vm,b_sftr,b_isom,b_mu57Fe,b_muiron,b_d1ove
      
      iflag_SAMP=0
      iflag_Voigt=0
      nst=4
      call get_theory(isubthe,info) 
      if(info.gt.0) return
      
!     since the case ifrcase=6 :Mossbauer transmission_vS(6)
!     accumulates (see mossbauer_tmre()
!                      do isite=issa,isse
!                       if(ifrcase.eq.6)then
!                        ...
!                        end if
!                       end do             )
!     the 2x2 density matrices each calculation has to start at zero
      r_d1ove =0.0; if(b_d1ove) r_d1ove =1.0
      r_mu57Fe=0.0; if(b_mu57Fe)r_mu57Fe=1.0
      r_muiron=0.0; if(b_muiron)r_muiron=1.0

      nn=ipTHS+4*(2*nSC+1)+6*(isite-1)
      array_fr(nn+1)=cmplx(icase,anz)
      array_fr(nn+2)=cmplx(mu_electronic,dsfoil)
      array_fr(nn+3)=cmplx(d1_ov_e,r_d1ove)
      array_fr(nn+4)=cmplx(mu_57Fe,r_mu57Fe)      
      array_fr(nn+5)=cmplx(mu_iron,r_muiron)
      array_fr(nn+6)=cmplx(123.,456.)
!     print'(a,i6,i6,2(/,8f12.4))','index:',ipTHS,nn,(array_fr(nn+n),n=1,6)

!     these 4 constants are transferred to routine rhoz() or
!     rhoz_reverse in the subroutine mossbauer_tmre(b_total,info) 
!     print*,b_vm,b_sftr,b_isom,b_mu57Fe,b_muiron,b_d1ove
      b_vm=b_vm.or.b_v_max
      if(b_vm)then
       isubthe=abs(isubthe)  ! isubthe>0 : site is calculated
      else
       if(isubthe.lt.0) return 
      end if

      nget=real(array_fr(iget+1)) 
      n_all=real(array_fr(nget+1)) 
      jge=aimag(array_fr(nget+1)) 
      bxx=real(array_fr(nget+2)).gt.0.01 
                                                                        
      ioffset=offset 
!      write(6,'(a,5i8)')'  th_22indexsource isubthe,icase,iput,iget,info=', &    
!                          isubthe,icase,iput,iget,info
                                                                              
      if(lstr1case.gt.1)then
       print'(a,i3)',' lstr1case=',lstr1case
       return
      end if
!            print*,'b_vm,b_sftr,b_isom,b_mu57Fe,b_muiron,b_d1ove=',  &
!           b_vm,b_sftr,b_isom,b_mu57Fe,b_muiron,b_d1ove    
 
!---------------------- source ------------------------------------     
!     write(6,'(a,L5,6i8)') 'jpolsource,iput=',jpolsource,iput,icase,nget,nall
      ioffset=offset
      b_polisp=jpolsource.eq.1
      fs=0.
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                        
       if(enwr(7).eq.'fani') then 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
        fs=fs+fd 
        write(nwr,'(a,i2,a2,f10.3)')                                    &
          'anisotropic part of the f-source(',nall,')=',fd             
       end if 
                                                                        
       do jn=ip+1,ip+jge*3-2,3 
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8   
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')                 &
         '**** E(source)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'     
       end do   ! jn=   
      end do   ! nall=1,n_all 
      if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')                      &
       'average over all sites and directions of f-source=',fs/n_all   
                                                                        
       do n=iput+1,iput+(2*nSC+1)*6 
        array_fr(n)=(0.,0.) 
       end do 
       w_Lorentz=wLorentz(1) 
       w_Gauss=wGauss(1) 

       allocate(cLG(-nSC:nSC),sTr(-nSC:nSC)) 

       srw=4.0*srw8 
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 

        ige=0
        lge=0
        do jn=ip,ip+jge*3-3,3 
         ige=ige+1
         if(ige.ge.ioffset)then
          lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
            w_Gauss=wGauss(lge)
           else 
            w_Gauss=wGauss(1)
            w_Lorentz=wLorentz(1)
           end if
         end if
         call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                            srw,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)     

         if (iflag_basis.eq.1) then
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd 
         else
          hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
          hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
         end if
         if(icase.eq.1) then
          do n=-nSC,nSC 
           nn=iput+2*(n+nSC) 
           array_fr(nn+1)=array_fr(nn+1)- aimag(cLG(n))*hrtr
           array_fr(nn+2)=array_fr(nn+2)- aimag(cLG(n))*hrpm
          end do 
         else ! icase.ge.2
          ! mu_57Fe is the effective thickness of 1mue material (Rh)
          ! mu_iron is the effective thickness of 1mue iron
          ! of absorbing material (f_factor=1). f-factor of the source
          ! is multiplied in subroutine mossbauer_tmre(b_total,info) 
          hti= aimag(hrtr)/2.0
          ctr= real(hrtr)*Ci/2.0
          cpm= hrpm*Ci/2.0
          cmp= conjg(hrpm)*Ci/2.0
!         Eagd=real(array_fr(jn+1))+aisom                               
!         write(nwr,'(2i8,a,8f10.2)') &
!            jn,ige,' Esource=',Eagd,hti*100,hrpm*100,mu_electronic 

          do n=-nSC,nSC 
           nn=iput+6*(n+nSC) 
           array_fr(nn+1)=array_fr(nn+1)- aimag(cLG(n))*hrtr
           array_fr(nn+2)=array_fr(nn+2)- aimag(cLG(n))*hrpm 
           hc=cLG(n) 
           array_fr(nn+3)=array_fr(nn+3)-hc*hti 
           array_fr(nn+4)=array_fr(nn+4)-hc*ctr 
           array_fr(nn+5)=array_fr(nn+5)-hc*cpm 
           array_fr(nn+6)=array_fr(nn+6)-hc*cmp 
          end do 
         end if      ! icase
        end do       ! jn=
       end do        ! n_all
!     The sum of the Lorentz-Gauss curves of the jge lines              
!     have to be normalized to 1 for each subspectrum of the source     
                                                                        
!     The source is normalized to 1 -> integral Trace(rho) dE =1
       ip=6
       if(icase.eq.1)ip=2       
       do i=-nSC,nSC 
        nn=iput+ip*(i+nSC) 
        sTr(i)=aimag(array_fr(nn+1))
       end do

       hr=0. 
       do i=-nSC+1,nSC-1,2 
        hr=hr+ sTr(i)*2 
       end do 
       do i=-nSC+2,nSC-2,2 
        hr=hr+sTr(i) 
       end do 
       hr=hr*2.+ sTr(-nSC)+sTr(nSC); hr=hr/3. 

       do i=-nSC,nSC 
        nn=iput+ip*(i+nSC) 
        array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
        array_fr(nn+2)=array_fr(nn+2)/hr
       end do
     
       deallocate(cLG,sTr)
      return 
      END                                           

     subroutine rhoz(iget,isite,ipTHS,nSC,mAS,sTr,sP1,sP2,sP3,attenuation)
!    iget is the pointer iput of 
!    subroutine th_22indexsource(isubthe,icase,iput,iget,info)
!    of the first call (source site 1)
! icase.eq.2    Delta-distribution at depth=dsfoil
! icase.eq.3,5  calculation to a depth of 2.*d1_ov_e <= dsfoil
! icase.eq.4    calculation to a depth = dsfoil , homogeneous distribution 
     use comthe, only: array_fr
     implicit none 
     integer, intent(in) :: iget,isite,ipTHS,nSC,mAS
     real,   intent(out) :: attenuation
     real, dimension(-mAS:mAS), intent(out):: sTr,sP1,sP2,sP3
                                                                       
     integer   n,nn,jz,nz,icase    
     real      h1,h2,satrexpr,tdD,wt,delta,d1_ov_e,dsfoil,dfoildiffusion,  &
               mu_electronic,mu_57Fe,mu_iron,total_57Fe,depth,deff,t_depth

     complex  app,apm,amp
     complex, dimension(4)  :: aa,bb,dd,as,dr,Vv 
     complex, parameter:: C0=cmplx(0.,0.),C1=cmplx(1.,0.),Ci=cmplx(0.,1.)
     real,    parameter:: wpi=1.7724538/2.0
     real,    dimension(128)::prop,intprop
     logical   b_d1ove, b_mu57Fe,b_muiron,b_source
     
!      nn=ipTHS+6*(2*nSC+1)+6*(isite-1)
!      array_fr(nn+1)=cmplx(icase,anz)
!      array_fr(nn+2)=cmplx(mu_electronic,dsfoil)
!      array_fr(nn+3)=cmplx(d1_ov_e,b_d1ove)
!      array_fr(nn+4)=cmplx(mu_57Fe,b_mu57Fe)      
!      array_fr(nn+5)=cmplx(mu_iron,b_muiron)
!      array_fr(nn+6)=cmplx(b_source,456.)
     nn=ipTHS+4*(2*nSC+1)+6*(isite-1)
     icase=real(array_fr(nn+1))
     nz=aimag(array_fr(nn+1))
     mu_electronic=real(array_fr(nn+2))
     dsfoil=aimag(array_fr(nn+2))

     d1_ov_e=real(array_fr(nn+3)) 
     b_d1ove=int(aimag(array_fr(nn+3))).eq.1  
     mu_57Fe =real(array_fr(nn+4))
     b_mu57Fe=int(aimag(array_fr(nn+4))).eq.1
     mu_iron=real(array_fr(nn+5))     
     b_muiron=int(aimag(array_fr(nn+5))).eq.1
     b_source=int(real(array_fr(nn+6))).eq.1     
!    print'(a,i6,i6,2(/,8f12.4))','rhoz :',ipTHS,nn,(array_fr(nn+n),n=1,6)

!     write(6,'(a,/,3i6,5f10.4)') &
!        'nz,icase,nSC,mu_57Fe,d1_ov_e,mu_electronic,dsfoil=', &
!        nz,icase,nSC,mu_57Fe,d1_ov_e,mu_electronic,dsfoil

    total_57Fe=0.0 
    if(icase.eq.1)then
      do n=-nSC,nSC 
        nn=iget+2*(n+nSC)        
        sTr(n)=aimag(array_fr(nn+1))
        sP1(n)=real(array_fr(nn+2))
        sP2(n)=-aimag(array_fr(nn+2))
        sP3(n)=real(array_fr(nn+1))
      end do
      return 
     else if(icase.eq.2) then
        !case 2: calculation to a depth = dsfoil ,
        !        homogeneous distribution of 57Co/57Fe
       total_57Fe= mu_57Fe*dsfoil ! mu_57Fe value determines area
       t_depth=dsfoil
       delta=t_depth/float(nz)
       do jz=1,nz
        prop(jz)=1./float(nz)
       end do
       intprop(1)=prop(1)
       do jz=2,nz
        intprop(jz)=intprop(jz-1)+prop(jz)
       end do
       attenuation=0.
       do jz=1,nz
        depth=jz*delta
        attenuation=attenuation+prop(jz)*exp(-mu_electronic*depth)
       end do
       wt=0.0
       do jz=1,nz
        wt=wt+intprop(jz)*prop(jz)
       end do 
     else if(icase.eq.3) then
       ! calculation to a depth of 2.*d1_ov_e <= dsfoil
       ! case 3: 57Fe distribution emerge from 57Co distribution 
       !                            deff=t_depth*intprop(jz)*mu_57Fe
       ! total amount of 57Fe determines the area
       ! no control of 2.*d1_ov_e <= dsfoil 
       t_depth=d1_ov_e/dsfoil
       total_57Fe= mu_57Fe*dsfoil
       delta=1./float(nz) 
       wt=0; n=int(3*t_depth-1); if(n.lt.0)n=0
       do jz=1,nz
        depth=jz*delta
        prop(jz)=dfoildiffusion(n,depth,t_depth)  !*exp(-mu_electronic*depth) later
        wt=wt+prop(jz)
       end do
       do jz=1,nz
         prop(jz)=prop(jz)/wt
       end do   
       !  print*,'int=',wt/t_depth*delta/wpi
       intprop(1)=prop(1)                     !/t_depth*delta/wpi
       do jz=2,nz
        intprop(jz)=intprop(jz-1)+prop(jz)    !/t_depth*delta/wpi
       end do
       attenuation=0.
        delta=dsfoil/float(nz)
       do jz=1,nz
        depth=jz*delta
        attenuation=attenuation+prop(jz)*exp(-mu_electronic*depth)
       end do
       wt=0.0
       do jz=1,nz
        wt=wt+exp(-2.4*intprop(jz))*prop(jz)
        !write(11,'(i3,2x,i3,2x,3f12.3)')0,jz,wt,prop(jz),intprop(jz)
       end do 
       ! prop(jz) probability of of a Co57. intprop(jz) the fraction of 
       ! of 57Fe (from decay of 57Co) up to the depth jz*delta.
       ! Electronic attenuation (mu_electronic=0 =>attenuation=1)- 
       ! there are prop(jz) radiating 57Co at depth jz*delta  
     else if(icase.eq.4) then
        ! icase 4: Delta-distribution at depth= d1_ov_e
       total_57Fe= mu_57Fe*dsfoil 
       nz=1
       t_depth= d1_ov_e ! depth(mue) parameter
       delta=t_depth/float(nz)
       prop(nz)=1
       intprop(1)=prop(1)
       attenuation=exp(-mu_electronic*t_depth)
       ! prop(jz) probability  of a Co57 ( here 0,0,0,...,1 at depth)
       ! Electronic attenuation of the emitted  gamma travelling to 
       ! the surface from depth.
     else if(icase.eq.5) then
       ! calculation to a depth of 2.*d1_ov_e <= dsfoil
       ! case 5: 57Fe distribution is constant (57Co in iron)
       !                                deff=jz*t_depth/float(nz)       
       t_depth=2.*d1_ov_e
       total_57Fe= mu_57Fe*t_depth
       delta=t_depth/float(nz)
       wt=0
       attenuation=0.
       do jz=1,nz
        depth=jz*delta
        prop(jz)=exp(-(depth/d1_ov_e)**2)  !*exp(-mu_electronic*depth) later
        wt=wt+prop(jz)
       end do
       do jz=1,nz
        prop(jz)=prop(jz)/wt
       end do
       intprop(1)=prop(1)
       do jz=2,nz
        intprop(jz)=intprop(jz-1)+prop(jz)
       end do
       attenuation=0.
       do jz=1,nz
        depth=jz*delta
        attenuation=attenuation+prop(jz)*exp(-mu_electronic*depth)
       end do
       ! prop(jz) probability of of a Co57.
       ! Electronic attenuation (mu_electronic=0 =>attenuation=1)- 
       ! there are prop(jz) radiating 57Co at depth jz*delta  
     end if

     !     rho(E,d)=satrexpr*exp-iA)*rho*exp(iA+) 
!     rho(E,d)=satrexpr*exp-iA)*(Sum_i ps(i)sig(i))*exp(iA+) 
!     sig(0)=(1 0/0 1), 
!     sig(1)= (0 1 /1 0), sig(2)=(0 -i/i 0), sig(3)=1 0/0 -1) 
!     rho(E,d)=satrexpr*Sum_i ps(i)* {exp-iA)*ps(i)*exp(iA+)}

!     Fortran  ( 1 3 )     convention                                  
!              ( 2 4 ) 

      do n=-nSC,nSC 
       nn=ipTHS+4*(n+nSC)
       tdD=aimag(array_fr(nn+1)*2.0)
!write(11,'(i5,2x,f12.3)')n,tdD
       app=array_fr(nn+2)
       apm=array_fr(nn+3)
       amp=array_fr(nn+4)
!      if(n.eq.-NSC)write(6,*)nn,tdD,icase,intprop(1),total_57Fe
!      hermitian density matrix of source site number i
       nn=iget+6*(n+nSC)        
       h1=real(array_fr(nn+1)); h2=aimag(array_fr(nn+1))
       dr(1)=cmplx(h1+h2,0.); dr(4)=cmplx(-h1+h2,0.)
       dr(3)=array_fr(nn+2); dr(2)=conjg(dr(3))
!      (dr(1) dr(3))  
!      (dr(2) dr(4)) =  rho_r(E) is hermitian  

!      parameter d1_ov_e , 1/e of the exponential -> depth=d1_ov_e 
!      constants nz, mu_electronic=0.0558, muthick

       ! the 57Co in the nz layers radiate incoherently.
       ! source radiation with density matrix rho_z=dd*prop(jz)
       ! propagates through the absorber=> Tr(exp(-int)*rho_z*exp(in+t))
       ! Incoherent  Sum_z Tr(exp(-int)*rho_z*exp(in+t))=
       !       Tr(exp(-int)*(Sum_z rho_z)*exp(in+t))
       ! therefore Vv can be calculated for each site of the source           
       Vv=C0
       do jz=1,nz
        depth=jz*delta
        if(icase.eq.3)then
          ! 57Fe distribution emerge from 57Co distribution 
          deff=total_57Fe*intprop(jz)  
       else  ! icase=2,4,5
           ! 57Fe distribution is constant (57Co in iron)
         deff=depth*mu_iron+total_57Fe*intprop(jz)
        end if
!       if(n.eq.-NSC)write(6,*)nn,tdD,deff,exp(-mu_electronic*depth)
        satrexpr=exp(-tdD*deff)*exp(-mu_electronic*depth)
        call expo_22(app*deff,apm*deff,amp*deff,aa)

        dd=aa 
        bb(1)=conjg(dd(1)) 
        bb(4)=conjg(dd(4)) 
        bb(2)=conjg(dd(3)) 
        bb(3)=conjg(dd(2)) 
        call matprof(aa,dr,as); call matprof(as,bb,dd)
        dd=dd*satrexpr 
        Vv=Vv+dd*prop(jz)
       end do
       sTr(n)=real(Vv(1)+Vv(4))/2.
       sP1(n)=real(Vv(2))
       sP2(n)=-aimag(Vv(2))
       sP3(n)=real(Vv(1)-Vv(4))/2.
       end do   ! nSC
      return
     end

   
     subroutine rhoz_reverse(iget,isite,ipTHS,nSC,mAS,sTr,sP1,sP2,sP3,attenuation)
!    iget is the pointer iput of 
!    subroutine th_22indexsource(isubthe,icase,iput,iget,info)
!    of the first call (source site 1)
     use comthe, only: array_fr
     implicit none 
     integer, intent(in) :: iget,isite,ipTHS,nSC,mAS
     real,   intent(out) :: attenuation
     real, dimension(-mAS:mAS), intent(out):: sTr,sP1,sP2,sP3
                                                                       
     integer   n,nn,jz,nz,icase    
     real      h1,h2,satrexpr,tdD,wt,delta,dsfoil,d1_ov_e,  &
               mu_57Fe,mu_iron,mu_electronic,depth,heff

     complex  app,apm,amp
     complex, dimension(4)  :: aa,bb,dd,as,dr,Vv 
     complex, parameter:: C0=cmplx(0.,0.),C1=cmplx(1.,0.),Ci=cmplx(0.,1.)
     real,    dimension(128)::prop,intprop
     logical  b_d1ove,b_mu57Fe,b_muiron
     
     nn=ipTHS+4*(2*nSC+1)+6*(isite-1)
     icase=real(array_fr(nn+1))
     nz=aimag(array_fr(nn+1))
     mu_electronic=real(array_fr(nn+2))
     dsfoil=aimag(array_fr(nn+2))

     d1_ov_e=real(array_fr(nn+3))
     b_d1ove=int(aimag(array_fr(nn+3))).eq.1  
     mu_57Fe =real(array_fr(nn+4))
     b_mu57Fe=int(aimag(array_fr(nn+4))).eq.1
     mu_iron=real(array_fr(nn+5))     
     b_muiron=int(aimag(array_fr(nn+5))).eq.1
!print'(a,i6,i6,2(/,8f12.4))','rhoz :',ipTHS,nn,(array_fr(nn+n),n=1,6)
     if(icase.eq.1)then
       do n=-nSC,nSC 
        nn=iget+2*(n+nSC)        
        sTr(n)=aimag(array_fr(nn+1))
        sP1(n)=real(array_fr(nn+2))
        sP2(n)=-aimag(array_fr(nn+2))
        sP3(n)=real(array_fr(nn+1))
       end do
       return
     end if  

   !  if(icase.ne.5)then
   !   print'(a,i1,a,/,a)',' case=',icase,' reversed source only for case=5:',&
   !   ' 2x2 rho-source selfabsorption (diffusion profile)'
   !   return
   !  end if   
     
      delta=dsfoil/float(nz)
      wt=0
      attenuation=0.
      do jz=1,nz
       depth=dsfoil-jz*delta
       prop(jz)=exp(-(depth/d1_ov_e)**2)
       wt=wt+prop(jz)
      end do
      do jz=1,nz
       prop(jz)=prop(jz)/wt
      end do
!     write(6,'(a,f10.1,i4)')'propz=',dsfoil,nz
!     write(6,'(i4,2x,f10.4)')(jz,prop(jz),jz=1,nz)
      intprop(1)=prop(1)
      do jz=2,nz
       intprop(jz)=intprop(jz-1)+prop(jz)
      end do
      attenuation=0.
      do jz=1,nz
       depth=jz*delta
       attenuation=attenuation+prop(jz)*exp(-mu_electronic*depth)
      end do
!      write(6,'(a,f12.4)')'attenuation,intpropz=',attenuation
!      write(6,'(i2,3x,i4,2x,f10.4)')(0,jz,prop(jz),jz=1,nz)

      ! prop(jz) probability of of a Co57 times the probability that
      ! the emitted  gamma is not absorbed travelling to the surface
      ! from depth=jz*delta.

!     rho(E,d)=satrexpr*exp-iA)*rho*exp(iA+) 
!     rho(E,d)=satrexpr*exp-iA)*(Sum_i ps(i)sig(i))*exp(iA+) 
!     sig(0)=(1 0/0 1), 
!     sig(1)= (0 1 /1 0), sig(2)=(0 -i/i 0), sig(3)=1 0/0 -1) 
!     rho(E,d)=satrexpr*Sum_i ps(i)* {exp-iA)*ps(i)*exp(iA+)}

!     Fortran  ( 1 3 )     convention                                  
!              ( 2 4 ) 
      do n=-nSC,nSC 
       nn=ipTHS+4*(n+nSC)
       tdD=aimag(array_fr(nn+1)*2.0)
       app=array_fr(nn+2)
       apm=array_fr(nn+3)
       amp=array_fr(nn+4)
!      hermitian density matrix of source site number i
       nn=iget+6*(n+nSC)        
       h1=real(array_fr(nn+1)); h2=aimag(array_fr(nn+1))
       dr(1)=cmplx(h1+h2,0.); dr(4)=cmplx(-h1+h2,0.)
       dr(3)=array_fr(nn+2); dr(2)=conjg(dr(3))
!      (dr(1) dr(3))  
!      (dr(2) dr(4)) =  rho_r(E) is hermitian  
!      parameter d1_ov_e , 1/e of the exponential -> depth=d1_ov_e 
!      constants nz, mu_electronic=0.0558, muthick
        ! the 57Co in the nz layers radiate incoherently.
        ! source radiation with density matrix rho_z=dd*prop(jz)
        ! propagates through the absorber=> Tr(exp(-int)*rho_z*exp(in+t))
        ! Incoherent  Sum_z Tr(exp(-int)*rho_z*exp(in+t))=
        !       Tr(exp(-int)*(Sum_z rho_z)*exp(in+t))
        ! therefore Vv can be calculated for each site of the source           
        Vv=C0
        do jz=1,nz
         depth=jz*delta
         heff=depth*(mu_iron+mu_57Fe*intprop(jz))
         ! homogeneous density of 57Fe i iron + 57Fe from source
         satrexpr=exp(-tdD*heff)*exp(-mu_electronic*depth)

         call expo_22(app*heff,apm*heff,amp*heff,aa)
         dd=aa+cmplx(1.e-8,1.0e-8) 
         bb(1)=conjg(dd(1)) 
         bb(4)=conjg(dd(4)) 
         bb(2)=conjg(dd(3)) 
         bb(3)=conjg(dd(2)) 
         call matprof(aa,dr,as); call matprof(as,bb,dd)
         dd=dd*satrexpr 
         Vv=Vv+dd*prop(jz)
        end do
       sTr(n)=real(Vv(1)+Vv(4))/2.
       sP1(n)=real(Vv(2))
       sP2(n)=-aimag(Vv(2))
       sP3(n)=real(Vv(1)-Vv(4))/2.
      end do   ! nSC
      return
     end


     real function dfoildiffusion(nn,x,d4t)
     ! 0 < x=d/dfoil<1 , d4t= sqrt(D4t)/dsfoil
      real x,d4t,utx
      integer n,nn 
      utx=0.0 
      do n=0,nn
         utx=utx+exp(-((x+2.*float(n))/d4t)**2)+ &
                 exp(-((2.*float(n+1)-x)/d4t)**2)
      end do
      dfoildiffusion=utx
     return
    end function dfoildiffusion
