      subroutine thstr_22indexrefl(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     n_ik(E) refraction index (static)                                 
!     level 3 theory                                                    
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index reflection' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='2x2 refraction index (static)' 
       namepg(1)='2x2_refraction_index_static   plrs,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=7 <=max_nth
       ntheory(1)='stroboscopic reflection spectrum_32' 
       ntheory(2)='Nuclear double FG scattering_32' 
       ntheory(3)='Nuclear double GF scattering_31' 
       ntheory(4)='time differential reflection spectrum_3' 
       ntheory(5)='time integral - rocking curve-Fourier_3' 
       ntheory(6)='time integral - rocking curve_3' 
       ntheory(7)='time integral - rocking curve_fi_3' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(7))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
       call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
                                                                        
       thco(jc+1)='flag_SAMP  i_pos=1    include=y  0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt   i_pos=2    include=n   0 ' 
       jc=jc+2 
                                                                        
!       comment on the 2 instead of 1 (flag_Voigt is omitted):          
!       flag_Voigt is still in use in the Mossbauer=> the position      
!       of constants in the .par file are the same as in Mossbauer.     

!                     123456789012345678901234567                       
       ntrmt(jm+1)='A_thickness  intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        thpa(jp+1)='Axf             , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='Axf                     1     1  ' 
                                                                        
       ntrmt(jm+2)='position   matrix=(1,1)   include=[y]' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                2    1  ' 
                                                                        
       ntrmt(jm+3)='broadening   matrix=(2,2)   include=[n]' 
       ctrmt(jm+3)='broadening of the lines of the spectrum' 
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+3)='G_width                 3      1 0 ' 
        thvr(jv+4)='L_width                 4      0 1 ' 
       jm=jm+3 
       jp=jp+4 
       jv=jv+4 
       cova='_2_4'
       call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_22indexreflnosampl(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     n_ik(E) refraction index (static)                                 
!     level 3 theory                                                    
!     the routine "2x2_refraction_index_static" is called by case=2     
!     flag_sampl=0 and flag_Voigt=1  == aLORGAUS() is called            
!     aLORGAUS() does not store on array_fr()                           
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth  
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index offspec' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='2x2 refraction index (static)' 
       namepg(1)='2x2_refraction_index_static   plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='time integral - offspecular_3' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='flag_SAMP   i_pos=1   include=n  0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt  i_pos=2    include=n  0 ' 
       jc=jc+2 
                                                                        
!      comment on the 2 instead of 0 (flags_ are omitted):              
!      flags are in use in Mossbauer, etc => the position               
!      of constants in the .par file are in the same order as           
!      in Mossbauer, etc.                                               
                                                                        
!                     123456789012345678901234567                       
                                                                        
       ntrmt(jm+1)='A_thickness  intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        thpa(jp+1)='Axf             , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='Axf                     1     1  ' 
                                                                        
       ntrmt(jm+2)='position  matrix=(1,1)   include=[y]' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                2    1  ' 
                                                                        
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+3)='broadening of the lines of the spectrum' 
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+3)='G_width                 3      1 0 ' 
        thvr(jv+4)='L_width                 4      0 1 ' 
       jm=jm+3 
       jp=jp+4 
       jv=jv+4 
       cova='_2_4' 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
      subroutine thstr_22indextrm(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     n_ik(E) refraction index (static)                                 
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth
      character(len=4) :: cova 
 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index transmission' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='2x2 refraction index (static)' 
       namepg(1)='2x2_refraction_index_static   plrs,1 ' 
       nameth(2)='2x2 refraction index (f,t,spinham)' 
       namepg(2)='2x2_refraction_index_static   plrs,1 '
       nameth(3)='2x2 refraction index (static,f_anisotrop)' 
       namepg(3)='2x2_refraction_index_static   plrs,1 '
       nameth(4)='2x2 refraction index (Lwidth,f_anisotrop)' 
       namepg(4)='2x2_refraction_index_static   plrs,2 '
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=3 <=max_nth
       ntheory(1)='Nuclear double FG scattering_31' 
       ntheory(2)='Nuclear double GF scattering_32' 
       ntheory(3)='time differential transmission spectrum_31' 
       ntheory(4)='Nuclear double Ff scattering_3' 
       ntheory(5)='Nuclear double fF scattering_3' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(5))l_jth=4 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 

       thco(jc+1)='flag_SAMP   i_pos=1    include=[y]  0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt  i_pos=2    include=n  0 ' 
       jc=jc+2 

      if(l_jth.le.2)then                                                                      
                                                                        
       ntrmt(jm+1)='t_eff   intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        thpa(jp+1)='mg/cm2xf           , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='mg/cm2xf                1     1  ' 
                                                                        
       ntrmt(jm+2)='position  matrix=(1,1)   include=[y]' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                2    1  ' 
                                                                        
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+3)='broadening of the lines of the spectrum' 
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+3)='G_width                 3      1 0 ' 
        thvr(jv+4)='L_width                 4      0 1 ' 
       jm=jm+3 
       jp=jp+4 
       jv=jv+4 
       cova='_2_4'
      else if(l_jth.gt.2)then
                                                                         
       ntrmt(jm+1)='t_eff  intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        thpa(jp+1)='mg/cm2xf              , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='mg/cm2xf                 1     1  ' 
                                                                         
       ntrmt(jm+2)='position  matrix=(1,1)   include=[y]' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                 2    1  ' 
        jm=jm+2 
        jp=jp+2 
        jv=jv+2
  
       if(l_jth.eq.3)then                   
        ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]' 
        ctrmt(jm+1)='broadening of the lines of the spectrum' 
         thpa(jp+1)='G_width          , 0.0  0.0 0.0  0.1' 
         thpa(jp+2)='L_width          , 0.0  0.0 0.0  0.1' 
         thvr(jv+1)='G_width                 3      1 0 ' 
         thvr(jv+2)='L_width                 4      0 1 ' 
        jm=jm+1 
        jp=jp+2 
        jv=jv+2
        cova='_2_4'
       else if(l_jth.eq.4)then 
  
        thco(jc+1)='L_offset         i_pos=3  include=[n]   0' 
                  ! if more then 8 lines > L(ioffset),...,L(ioffset+7) 
        jc=jc+1 
        ntrmt(jm+1)='broadening  matrix=(1,1)   include=[n]' 
        ctrmt(jm+1)='Gauss broadening of all  lines of the spectrum' 
         thpa(jp+1)='G_width            , 0.0  0.0 0.0  0.1' 
         thvr(jv+1)='G_width                 3  1 ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1
  
        ntrmt(jm+1)='broadening  matrix=(8,8)   include=[n]' 
        ctrmt(jm+1)='Lorentz broadening of 8  lines of the spectrum' 
         thpa(jp+1)='L_width_1          , 0.0  0.0 0.0  0.1' 
         thpa(jp+2)='L_width_2          , 0.0  0.0 0.0  0.1' 
         thpa(jp+3)='L_width_3          , 0.0  0.0 0.0  0.1' 
         thpa(jp+4)='L_width_4          , 0.0  0.0 0.0  0.1' 
         thpa(jp+5)='L_width_5          , 0.0  0.0 0.0  0.1' 
         thpa(jp+6)='L_width_6          , 0.0  0.0 0.0  0.1' 
         thpa(jp+7)='L_width_7          , 0.0  0.0 0.0  0.1' 
         thpa(jp+8)='L_width_8          , 0.0  0.0 0.0  0.1' 
         thvr(jv+1)='L_width_1            4  1 0 0 0 0 0 0 0' 
         thvr(jv+2)='L_width_2            5  0 1 0 0 0 0 0 0' 
         thvr(jv+3)='L_width_3            6  0 0 1 0 0 0 0 0' 
         thvr(jv+4)='L_width_4            7  0 0 0 1 0 0 0 0' 
         thvr(jv+5)='L_width_5            8  0 0 0 0 1 0 0 0' 
         thvr(jv+6)='L_width_6            9  0 0 0 0 0 1 0 0' 
         thvr(jv+7)='L_width_7           10  0 0 0 0 0 0 1 0' 
         thvr(jv+8)='L_width_8           11  0 0 0 0 0 0 0 1' 
        jm=jm+1 
        jp=jp+8 
        jv=jv+8
        cova='_311'
       end if    

      end if     
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
