 subroutine helpc(i)
  integer, intent(in):: i
  character(len=132) :: chinput
  if(i.eq.0) chinput='effi/xmosplo/2d $'
  if(i.eq.1) chinput= 'effi/xmosplo/3d $'
  call  help(chinput) 
 return
 end

subroutine help(chinput) 
    use glbconst, only: nwr,nrd,pathvariable
    use comscd, only: ch256
    implicit none
    character(len=*):: chinput    
    character(len=132):: chin,ch132,chcom,helpfile
    character(len=80) :: helpthfile
    character(len=64) :: helppath,storepathvar
    character(len=32) :: nhandbook
    character(len=16) :: viewer
    character(len=4)  :: cmch
    character(len=3)  :: ch3
    character(len=1)  :: ch1,ch0
    logical b_exist 
    integer i,i0,ic,ihdb,j,jth,k,l_jth,l_nfrtheo,lstruct1,lstruct2,nfrtheo  

     chin=chinput
 1   nwr=6
     ch0=char(0) 
     i0=ichar('0') 
     i=index(chin,'$') 
      
     if(i.gt.0) then 
!      from c code                                                    
       chin(i:)=' ' 
     end if  
!    write(6,'(a,/,a)') ' subroutine help(chin):',TRIM(chin)               
!    theory/th110106/variable/1sp_____vcos1 

     i=index(chin,'parameter/') 
     if(i.gt.0)then 
      ch3=chin(i+10:) 
      ic=ichar(ch3(3:3))-ichar('0') 
      if(ch3(3:3).eq.'_'.or.(ic.ge.0.and.ic.le.9)) then 
       helpfile=chin(i+13:) 
       chin(i+10:)= helpfile 
      end if 
     end if 
                                                                      
     helpfile=' ' 
     chcom=' ' 
     if(chin(1:4).eq.'effi') then 
      helpfile='effi.help' 
      chcom=chin(5:130) 
     else if(chin(1:1).eq.'<')then 
      i=index(chin,'>') 
      helpfile=chin(2:i-1)//'.help' 
      chcom=chin(i+1:)
     else 
      if(chin(17:24).eq.'constant'.or.chin(17:24).eq.'variable') then 
!      theory/        /variable/2sc_____counts                        
!      theory/fr030105/constant/1                                     
       j=25 
       ch1=chin(26:26) 
       if(ch1.eq.'#'.or.(ichar(ch1).ge.48.and.ichar(ch1).le.57))then 
!       _ inside name   ( 0-9)                                              
        i=index(chin(j:),'_')+j 
        do while(chin(i:i).eq.'_') 
         i=i+1 
        end do 
        chcom=chin(1:25)//chin(i:) 
!       write(6,'(a/a)') 'help chin=',chcom(:80)                     
       else 
        chcom=chin 
       end if 
       chin=chcom 
      end if 
!      write(6,'(a/a)') 'help chin=',chin(:80)                        
     end if 
                                                                      
     if(chin(1:9).eq.'theory/fr') then 
      nfrtheo=10*(ichar(chin(10:10))-i0)+ichar(chin(11:11))-i0 
      cmch='name' 
      l_nfrtheo=1 
      call getfrstring(nfrtheo,l_nfrtheo,lstruct1,lstruct2,cmch,chcom)         
      
      jth=LEN_TRIM(chcom)
      k=0 
      do while(k.lt.jth) 
       k=k+1 
       if(chcom(k:k).eq.' ')then 
        if(chcom(k-1:k-1).eq.'-')then 
         helpfile=chcom(:k-1)//chcom(k+1:) 
         chcom=helpfile 
         jth=jth-1 
         k=k-1 
        else if(chcom(k+1:k+1).eq.'-')then 
         helpfile=chcom(:k-1)//chcom(k+1:) 
         chcom=helpfile 
         jth=jth-1 
         k=k-1 
        else 
         chcom(k:k)='_' 
        end if 
       end if 
      end do 
      helpfile=chcom(1:jth)//'.help' 
      chcom=chin(16:) 
                                                                      
     else if(chin(1:9).eq.'theory/th') then 
      jth=10*(ichar(chin(10:10))-i0)+ichar(chin(11:11))-i0 
      cmch='name' 
      call getthstring(jth,l_jth,cmch,chcom) 
!      write(6,'(2i4,2x,a)')jth,l_jth,chcom                           
      jth=index(chcom,'distribute') 
      if(jth.gt.0) chcom(jth-1:)=' ' 
                                                                      
      jth=LEN_TRIM(chcom)
      k=0 
      do while(k.lt.jth) 
       k=k+1 
       if(chcom(k:k).eq.' ')then 
        if(chcom(k-1:k-1).eq.'-')then 
         helpfile=chcom(:k-1)//chcom(k+1:) 
         chcom=helpfile 
         jth=jth-1 
         k=k-1 
        else if(chcom(k+1:k+1).eq.'-')then 
         helpfile=chcom(:k-1)//chcom(k+1:) 
         chcom=helpfile 
         jth=jth-1 
         k=k-1 
        else 
         chcom(k:k)='_' 
        end if 
       end if 
      end do 
                                                                      
      helpfile=chcom(1:jth)//'.help' 
      chcom=chin(16:) 
     else if(chin(1:9).eq.'theory/hb') then 
      ihdb=10*(ichar(chin(10:10))-i0)+ichar(chin(11:11))-i0 
      call gethdb(ihdb,nhandbook) 
      i=index(nhandbook,'.') 
      helpfile='handbook_'//nhandbook(1:i-1)//'.help' 
!     theory/hb010101/constant/0hdb11__Fe_uthick_w 
!             9       17    24                                           
      j=26 
      i=index(chin(j:),'_')+j 
      chcom='/'//chin(i:) 

     else if(chin(1:8).eq.'handbook') then 
      i=index(chin,'hb') 
      helpfile=chin(1:i-2)//'.help' 
                                                                      
      chcom=chin(i+4:) 
     else if(chin(1:8).eq.'messages') then 
      helpfile='messages.help' 
      chcom=chin(9:) 
     end if 
                                                                      
     if(helpfile.eq.' ') then 
      write(nwr,'(a)')'entry of helpfile  could not be identified' 
      return 
     end if 

     i=index(helpfile,'HEPATH')

     if(i.gt.0)then
      storepathvar=helpfile(1:i+5)
      ch132=helpfile(i+7:); helpfile=ch132
      CALL GET_ENVIRONMENT_VARIABLE(NAME=storepathvar,value=helppath,STATUS=i)
     else

!      write(6,*)' x  pathvariable=',pathvariable
      CALL GET_ENVIRONMENT_VARIABLE(NAME=pathvariable,value=helppath,STATUS=i)
      if(i.eq.1) then
      write(nwr,'(a,/,a)')' check environment variable '//TRIM(pathvariable),&
                      '(echo $'//TRIM(pathvariable)//')'
       return
      end if
     end if
     CALL GET_ENVIRONMENT_VARIABLE(NAME='VIEWER',value=viewer,STATUS=i)
     
     j= index(viewer,'xdvi')+ index(viewer,'xpdf')+index(viewer,'acroread') &
       +index(viewer,'evince')+index(viewer,'kpdf')+index(viewer,'okular')
     if(i.eq.1.or.j.eq.0) then
      chin='effi.help'; ch132='/more/viewer'; helpthfile='false'; viewer=' '
      ch256=TRIM(helppath)//'/effi.help'
      open(unit=3,file=ch256                                         &
                ,status='old'                                       &
                ,access='sequential'                                &
                ,form='formatted') 

      call effi_help(ch132,helpthfile,chin,helppath,viewer) 
      close(unit=3)
      write(nwr,'(a)') ' proceed with return'
      read(nrd,'(a)')
     end if

     viewer=TRIM(viewer)//' '//ch0
     helpthfile='false'             
     ch256=TRIM(helppath)//'/'//helpfile 
!    write(6,*)'path=',TRIM(ch256)
     inquire(file=ch256,exist=b_exist) 
     if(.not.b_exist) then
      helpthfile=helpfile
      call replace_helpfile(helpfile)
     end if 
     ch256=TRIM(helppath)//'/'//helpfile 
!     write(6,*)'path=',TRIM(ch256)
     inquire(file=ch256,exist=b_exist)
 
     if(b_exist) then
     open(unit=3,file=ch256                                         &
                ,status='old'                                       &
                ,access='sequential'                                &
                ,form='formatted') 
                                                                    
      call effi_help(chcom,helpthfile,helpfile,helppath,viewer) 
      close(unit=3)
      i=index(chcom,'>') 
      if(chcom(2:2).eq.'<'.and.i.gt.1)then
       chin=chcom(2:)
       goto 1 
      end if
     else 
      write(nwr,'(a,/,2a,/,2a)')' helpfile not found',              &
          ' PATH=',pathvariable,                                    &
          ' helpfile=',TRIM(helpfile)                              
     end if
     return 
    END                                           
                                                                        
      subroutine effi_help(chcom,helpthfile,helpfile,pathvariable,viewer) 
      use glbconst, only: maxco,nrd,nwr
      use compar, only: ncolwin,nwrwin,chterm
!      use comscd, only: ch256,queryar
      use comscd, only: ch256
      use comeff, only: id1,ncol,nrows,winfile
      implicit none
      logical b_exist 
      character(len=132),intent(inout):: chcom
      character(len=132),intent(in):: helpfile
      character(len=64), intent(in):: pathvariable
      character(len=80), intent(in):: helpthfile
      character(len=16), intent(in):: viewer 
 
      character(len=132):: cheader,ch132,cp132
      character(len=132), dimension(128)::queryar
      character(len=80),dimension(0:128)::que      
      character(len=5)  :: chred,chblue
      character(len=4)  :: chbold,chulin,chnorm
      character(len=6)  :: ch6      
      character(len=2)  :: ch2
      character(len=1)  :: chline,bsl 
      character(len=80) :: chdf,ch80,com80
      character(len=80),dimension(0:16) :: chdfi  
      character(len=1) :: ch0

      logical   b_star,b_xmosplo 
      integer   i,ic,ig,ih,il,ipos,iqloop,j,jj,k,kwin,l,lc,         &
                lk,lkk,lsel,lines,nrowwin,itp,lcount3

      integer,dimension(0:16):: nuque 

       ch0=char(0)
       bsl=char(92) 
       chred=char(27)//'[31m' 
       chblue=char(27)//'[34m' 
       chbold=char(27)//'[1m' 
       chnorm=char(27)//'[0m' 
       chulin=char(27)//'[4m' 

!       ext=' '
       itp=index(chcom,'][')
       ig=index(chcom,'/go')
       com80=chcom
!       write(6,*)'com80=',com80
       if(itp.gt.0)com80(itp:)=' '
       if(ig.gt.0)com80(ig:)=' ' 
       
       b_xmosplo=index(chcom,'xmosplo').eq.0.and.ig.eq.0 

       kwin=id1 
       if(kwin.gt.1) then 
        winfile=chterm(kwin) 
        nwrwin=10+kwin 
!        write(6,'(a,a)')' effi_hel winfile=',winfile                   
        open(nwrwin,file=winfile                                        &
                  ,status='old'                                         &
                  ,access='sequential'                                  &
                  ,form='formatted'                                     &
                  ,err=10)                                              
       else 
        nwrwin=nwr 
       end if 
       goto 20 
   10  continue 
       nwrwin=nwr 
       kwin=1 
   20  call window(kwin) 
       ncolwin=ncol(kwin) 
       nrowwin=nrows(kwin) 
       if(ncolwin.gt.132) ncolwin=132 
                                                                        

       lc=LEN_TRIM(com80)
       b_star=.false. 
       if(com80(lc:lc).eq.'*') then 
        b_star=.true. 
        lc=lc-1 
       end if 
       lsel=0 
       lkk=0 
       nuque=0

       queryar=' '                                              
       chline=' ' 
       do k=1,maxco 
!        queryar(k+maxco/2)=queryar(k) 
        queryar(k)='return'
       end do
       lcount3=0 
  100  continue 
       lcount3=lcount3+1
       if(lcount3.gt.16) then
        print '(a)','intrinsic loop in ...help file '
        print '(a)','/topic'
        print '(a)','/>topic'
        print '(a)','produces an endless loop'
        goto 200
       end if
       read(3,'(a)',end=200) ch80 
!      write(6,'(a,a)')' label 100 ', ch80(1:60)                      
       ic=LEN_TRIM(ch80)
       j=1 
       do while(ic.ne.lc.or.ch80(:ic).ne.com80(:lc)) 
        j=j+1 
        read(3,'(a)',end=199) ch80
        ic=LEN_TRIM(ch80)
       end do 
                                                                        
       if(b_star) then 
        write(nwrwin,'(a)') ch80 
        goto 100 
       end if 
       read(3,'(a80)',end=200) ch80 
!       write(6,'(a)') ch80                                             
!       write(6,'(a,i4)') 'nrowwin=',nrowwin                            
       lines=nrowwin 

       do while(lines.eq.nrowwin) 
                                                                        
        k=1 
        do while(k.lt.lines.and.ch80(1:1).ne.'/') 
         il=index(ch80,bsl)
         if(il.gt.0) then 
          ch2=ch80(il+1:il+2)
          if(ch2.eq.'bf')then
           ch6=chbold
           write(nwrwin,'(a5,a,a4)')ch6,TRIM(ch80(il+4:)),chnorm              
          else if(ch2.eq.'ul')then
           ch6=chulin
           write(nwrwin,'(a5,a,a4)')ch6,TRIM(ch80(il+4:)),chnorm              
          else if(ch2.eq.'bc')then
             ch6=chblue
           write(nwrwin,'(a6,a,a4)')ch6,TRIM(ch80(il+4:)),chnorm 
          else if(ch2.eq.'rc')then
             ch6=chred
           write(nwrwin,'(a6,a,a4)')ch6,TRIM(ch80(il+4:)),chnorm 
          end if
         else 
          write(nwrwin,'(a)') ch80 
         end if 
         read(3,'(a80)',end=200) ch80 
!         write(6,'(a,a)')' ch80=',ch80                                 
         k=k+1 
        end do 
                                                                        
        if(k.eq.1.and.ch80(1:2).eq.'/>') then 
         com80='/'//ch80(3:)
         lc=LEN_TRIM(com80)  
         rewind 3
         goto 100 
         
        end if 
        lines=k 
!        write(6,'(a,2i4)') ' k,lkk =',k,lkk                            
        if(k.eq.1) then 
         chdf='q' 
        else 
         if(b_xmosplo)read(nrd,'(a)') chdf 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        end if 
!        write(6,'(a,a)')' chdf=',chdf(1:10)                            
        if(chdf(1:1).eq.'q'.or.chdf(1:1).eq.'*')lkk=0 
       end do 
!       iqloop=1                   ! 20.08.07                           
                                                                        
       if(ch80(1:2).eq.'/#')then 
!          lkk.eq.0) then                                               
        k=1 
        iqloop=0 
        lkk=0 
        do while(ch80(1:2).eq.'/#') 
!         write(6,'(a,a)')' ch80=',ch80                                 
         k=k+1 
         que(k)=ch80(3:) 
         if(ch80(3:6).eq.'more')then 
          ch132=ch80(8:) 
          que(k)='more' 
          call nextchar(ch132,0,ipos,cp132,ih)
          ch256=TRIM(pathvariable)//'/dvifiles/'//cp132(:ih)//'/'//cp132(:ih)//'.dvi &'//char(0)  
         else if(ch80(3:9).eq.'details')then 
          ch132=ch80(11:) 
          que(k)='details' 
          call nextchar(ch132,0,ipos,cp132,ih) 
          ch256=TRIM(pathvariable)//'/'//cp132(:ih) 
         end if 
         read(3,'(a80)',end=200) ch80 
        end do 
!       k number of lines with /#, iqloop=0 lkk=0                       
!         write(6,'(a,15i3)')'a ',nuque                                  
        j=nuque(0) 
        if(j.gt.0) then 
         do l=nuque(1),1,-1 
          queryar(l+k)=queryar(l) 
         end do 
        end if 
        do l=1,k 
         queryar(l)=que(l) 
        end do 
        nuque(0)=j+1 
        j=nuque(0) 
        if(j.gt.8) then 
         write(nwrwin,'(a)')                                            &
          ' there was no way back to the preceeding level'              
         goto 500
        end if 
        do l=1,j 
         nuque(l)=nuque(l)+k 
        end do 
!        write(6,'(a,6i3)')'b ',nuque                                   
       else 
        if(nuque(0).eq.0) goto 200 
       end if 
!       write(6,'(a,2i4)') ' k.eq.1.and.lkk.eq.0 =',k,lkk               
!       if(k.eq.1.and.lkk.eq.0) goto 200                                
       if(lkk.eq.0) then 
        lk=k 
        lkk=k 
        lsel=k 
!        do k=1,lk 
!         ext(k)=' ' 
!        end do 
                                                                        
        queryar(1)='return' 
        chdfi(nuque(0))=queryar(1) 
!       write(6,'(a,3i4)')' effi_help query ncolwin=',ncolwin           
        cheader='further related information' 
       else 
        lk=lkk 
        if(lsel.lt.lkk) lsel=lsel+1 
        chdfi(nuque(0))=queryar(lsel) 
       end if 
                                                                        
       if(iqloop.eq.1) then 
        lk=lkk 
        lsel=lkk 
        chdfi(nuque(0))=queryar(1) 
        iqloop=0 
       end if 
       lsel=lk 
!       if(chline.ne.' ')                                               
!       write(nwr,'(1x,a1,a3)') char(27),'['//chline//'A'               
  188  continue 
!       write(6,'(a,a,3i4)')chdf(1:10),' lsel,lk=',lsel,lk,lkk          
       
       chdf=chdfi(nuque(0)) 
       chdf(80:80)='#' 
       call queryH(lsel,queryar,lk,cheader,chdf) 
       chline=char(ichar(chdf(80:80))+1) 
       chdfi(nuque(0))=queryar(lsel+1) 
!       write(6,'(a,a,3i4)')chdf(1:10),' lsel,lk,lkk=',lsel,lk,lkk      
       if(lsel.gt.1) then 
        com80='/'//queryar(lsel)
        lc=LEN_TRIM(com80) 

        if(queryar(lsel)(1:4).eq.'more') then 
          i=index(viewer,'xdvi')
          if(i.gt.0) then
           call viewdvi(ch256)
          else
           i= index(viewer,'xpdf')+index(viewer,'acroread') &
            +index(viewer,'evince')+index(viewer,'kpdf')+index(viewer,'okular')
           if(i.gt.0) then
            i=200
            do while(ch256(i:i).ne.'.')
             i=i-1
            end do          
            call viewpdf(viewer,ch256(:i)//'pdf'//ch0)
           else
              print'(a)',' environment variable viewer not defined !'
              print'(a)',' export viewer=xpdf or xdvi'              
           end if
          end if
          goto 188
        else if(queryar(lsel)(1:7).eq.'details') then 
         inquire(file=ch256,exist=b_exist) 
         if(b_exist) then 
          open(unit=2                                        &
                 ,file=ch256                                 &
                 ,status='unknown'                           &
                 ,access='sequential'                        &
                 ,form='formatted')                                     
         else 
          write(nwr,'(3a)')' file ',TRIM(ch256),' for details not found'              
          goto 200 
         end if 
                                                                        
  189    read(2,'(a)',end=190) ch80 
         write(nwrwin,'(a)')ch80 
         goto 189 
  190    close(unit=2) 
         goto 200 
        end if 
        write(nwrwin,'(/)') 
!        write(6,'(a,a)')'selected com80=',com80(1:50)                  
        if(lsel.eq.lkk)iqloop=1 
!        write(6,'(4(i3,2x,a))')(l,queryar(l)(1:24),l=1,24)             
        rewind 3 
        goto 100 
       else 
!        write(6,'(a,6i3)')' a200 ',nuque                               
        j=nuque(0) 
        if(j.gt.1) then 
                                                                        
         jj=nuque(j) 
         do l=1,nuque(1)-jj 
          queryar(l)=queryar(l+jj) 
         end do 
         do l=1,j-1 
          nuque(l)=nuque(l)-jj 
         end do 
                                                                        
         nuque(j)=0 
         nuque(0)=j-1 
         lk=nuque(j-1) 
         lkk=lk 
         lsel=nuque(j-1) 
!        write(6,'(i2,a,6i3)')lk,' b200 ',nuque                         
                                                                        
         cheader='related information ' 
         chdfi(j)=chdfi(j-1)
!         write(6,*)'nuque(0),j=',nuque(0),j 
         goto 188 
        end if 
        goto 200 
       end if 
                                                                        
  199  continue 
       if(itp.gt.0)goto 200
       ch256=TRIM(pathvariable)//'/'//helpfile 
       write(nwr,'(3a,/a)') 'no entry found for ',TRIM(com80),           &
           ' in helpfile:',TRIM(ch256)
        i=index(ch256,'effi.help')
        if(i.eq.0.and.TRIM(helpthfile).ne.'false') &
        write(nwr,'(a,/,a)')' redirected from ',helpthfile  
       goto 201 
  200  continue 
       write(nwrwin,'(a5,1x,a1,a3)') chred,char(27),'[1A' 
       write(nwrwin,'(2x,2a,a5)')' from help-file:',TRIM(helpfile),chnorm 
  201  continue 
       do k=1,maxco/2 
!        queryar(k)=queryar(k+maxco/2) 
       end do 
       chcom=com80
       ch256=com80
!        write(6,'(i3,a)')(ll,queryar(ll)(1:60),ll=1,10)                
       if(nwrwin.ne.nwr) close(unit=nwrwin) 
 500   continue
       return 

     END subroutine effi_help

     
      subroutine queryH(lq,queryar,lk,cheader,chdf)
!     warning: cheader(131 & 132) contain information (g & wrb)
!              controlling the subroutine
!     chdf(80:80)=#  list entries (queryar) by columns of equal width
!                =blank list row by row
!     beginning of chdf determines first(default) queryar 
      use glbconst,only: nwr,nrd 
!      use comscd , only: laenge
      use comeff,  only: npl,ncol  
      implicit none                                                                 
      logical   block 
      integer   lq,lk,key
      character(len=132), dimension(lq) :: queryar,type,helpar
      character(len=16),  dimension(lq) :: ext
      character(len=256):: chflen      
      character(len=132):: ch132,cp132,chblank,cheader,chin
      character(len=80) :: chdf,chin80
      character(len=1)  :: go,ch0,chh,wrb
      character(len=4)  :: chbold,chnorm
      character(len=5)  :: chred
      character(len=8)  :: ch8
      character(len=2)  :: ch2
      integer,   dimension(lq) :: ld,lw,laenge
      integer, dimension(0:lq) :: lpart
      integer i,i1,i0,i10,ii,iiq,ikey,iquit,iz,j,jq,jz,jk,jj,jjq,jqh,   &
               jsec,k,l,laengez,le,lkin,ll,lqin,lr,lapl,lcol,iwrl,      &
               npl_i,npx,ntrimto0, nulwr,maxco
      character(*), parameter :: nulunix='/dev/null'
      logical b_ig
      nulwr=nwr
      maxco=2*lq

       chbold=char(27)//'[1m' 
       chred=char(27)//'[31m' 
       chnorm=char(27)//'[0m' 
       ch0=char(0) 
       lqin=lq 
       lkin=lq 
       iiq=index(chdf,' quit') 
       if(iiq.gt.0)chdf(iiq:iiq+4)=' ' 
       chin80=chdf 
       jqh=0 
       wrb=cheader(132:132) 
!       write(6,'(a,a1)')' subroutine queryH wrb=',wrb                   

       b_ig=.false.;  if(cheader(131:131).eq.'i') b_ig=.true.
       if(b_ig.and.wrb.ne.'r')then
          nulwr=1
        open(nulwr,file=nulunix,status='replace', action='write')
       end if
       go=' ' 
       if(cheader(131:131).eq.'g') go='g'
       cheader(132:132)=' ' 

 1     npx=npl-3 
                                                                        
       if(wrb.eq.'w'.or.wrb.eq.'r'.or.wrb.eq.'l') npx=ncol(1)-3 
       if(npx.gt.130) npx=130 
!       write(6,'(a,8i4)') ' query lq,nwr,nrd,npl,ncol(1),npx=', &        
!                                 lq,nwr,nrd,npl,ncol(1),npx           
!      write(6,'(a)') (queryar(ii)(:80),ii=1,lq)                        
!      write(6,'(a)') 'type'
!      write(6,'(a)') (type(ii)(:80),ii=1,lq)

      i0=ichar('0') 
      iquit=0 
      chblank=' ' 
      npl_i=ncol(1)-3 
      if(npl_i.gt.129) npl_i=129 
      block=.false. 
      if(chdf(80:80).eq.'#') block=.true. 
      chin=chdf(:79) 
      ll=ntrimto0(chin) 
      le=ll 
      if(le.eq.0) lk=lq 
      chdf=chin 
!       write(6,'(a1,a)')'1', cheader(:80)                              
      if(cheader.eq.' ') then 
       do k=1,npx 
        chflen(k:k)='-' 
       end do 
      else 
       chh='-' 
       cheader(130:)=' ' 
       if(ncol(1).lt.131) cheader(ncol(1)+1:)=' ' 
       l=ntrimto0(cheader) 
       if(index(cheader,'information').eq.0)then 
        chflen=cheader(:l)//' (help:he)' 
        l=l+10 
       else 
        chflen=cheader(:l) 
       end if 
!       write(6,'(a,i4)') 'cheader',l    
!       write(6,'(a)') TRIM(cheader)                                      

       i=(npx-l)/2
       if(i.lt.0)i=0
       do k=l,1,-1 
        chflen(i+k:i+k)=chflen(k:k) 
       end do 
       do k=1,i 
        chflen(k:k)=chh 
       end do 
       k=i+l+1 
       do while(k.le.npx) 
        chflen(k:k)=chh 
        k=k+1 
       end do 
      end if 
                                                                        
      iwrl=0 
      write(nulwr,'(a)')chnorm//chflen(:npx) 
      iwrl=iwrl+1 
      if(wrb.eq.'w')write(10,'(a)') chflen(:npx) 
      if(wrb.eq.'r') then 
       read(10,'(a)')chflen 
      end if 
                                                                        
      do k=1,npx 
       chflen(k:k)='-' 
      end do 
      ext=' '
!      write(6,'(a)') ' query  label 5'                                 
      laengez=0 
      do k=1,lq 
       if(ext(k).eq.' ') then 
        ld(k)=0 
       else 
        chin=ext(k) 
        if(ncol(1).lt.131)chin(ncol(1)+1:)=' ' 
        ld(k)=ntrimto0(chin) 
       end if 
       chin=queryar(k) 
       if(ncol(1).lt.131)chin(ncol(1)+1:)=' ' 
       ll=ntrimto0(chin) 
       lw(k)=ll 
       queryar(k)=chin 
       if(chin(1:1).eq.'*') iquit=1 
!       write(6,'(a)') ch132(1:ll)                                      
       ll=ll+ld(k)+3 
       if(ll.gt.laengez) laengez=ll 
      end do 

      lpart(0)=0 
      lapl=0 
      if(block) then 
       laengez=laengez+2  ! 3  
       lapl=npx/laengez 
       if(lapl.eq.0) then 
        iz=0 
       else 
        iz=lq/lapl 
       end if 
       if(iz*lapl.lt.lq) iz=iz+1 
!       write(6,'(a,2i4)') ' lapl,iz',lapl,iz                           
   10  if(lapl.eq.0) goto 20 
       lr=lapl*iz-lq 
!       if(lr.ge.((lapl+1)/2)) then                                     
       if(lr.ge.(iz-1)) then 
        lapl=lapl-1 
        goto 10 
       end if 
       if(lr.lt.0) lapl=lapl+1 
       lr=lapl*iz-lq 
!      write(6,'(a,5i4)') 'lq,lk,lapl,iz,lr',lq,lk,lapl,iz,lr                            
      end if 
                                                                        
   20 if(lapl.eq.0) then 
       iz=1 
       laengez=0 
       lpart(iz)=0 
       do k=1,lq 
        laenge(k)=((lw(k)+5)/10+1)*10+ld(k) 
        if(laenge(k).lt.npx) then 
         laengez=laengez+laenge(k)+6 
!         write(6,'(a,i4)') ' laengez=',laengez                         
         lpart(iz)=lpart(iz)+1 
         if(laengez.ge.npx) then 
          if(laengez.gt.npx) then 
           laengez=laenge(k)+4 
           lpart(iz)=lpart(iz)-1 
           lpart(iz+1)=1 
          else 
           laengez=0 
           lpart(iz+1)=0 
!         write(6,'(a,i4)') ' *laengez=',laengez                        
          end if 
           if(k.le.lq) iz=iz+1 
!         write(6,'(a,2i4)') ' *k,iz=',k,iz                             
         end if 
        else 
         laenge(iz+1)=laenge(k) 
         lpart(iz+1)=1 
         if(k.le.lq) iz=iz+1 
        end if 
       end do 
      else 
       do k=1,lq 
        laenge(k)=laengez+5 
       end do 
       do k=1,iz-1 
        lpart(k)=lapl 
       end do 
       lpart(iz)=lapl-lr 
      end if 
                                                                        
!       write(6,'(a,8i4)') ' iz=',iz                                    
!       write(6,'(a,16i4)') ' lpart=',(lpart(i),i=0,iz)                 
!       write(6,'(a,16i4)') ' lw=',(lw(i),i=1,iz)                       
!       write(6,'(i3,a,15i4)') jqh,'=jqh  laenge=',(laenge(i),i=1,lq)   
      if(jqh.gt.0) goto 42 
       jjq=0 
       jq=0 
       jk=0 
       ikey=0 
   40 continue 
!      write(6,'(2a)') ' query  label 40',chdf(:le)                                
                                                                        
      if(le.gt.0.and.ikey.eq.0)then 
       k=jjq+1 
       do while(index(queryar(k),chdf(:le)).eq.0.and.k.le.lq)  
        k=k+1 
       end do 
       if(k.gt.lq) then 
        k=1 
        do while(index(queryar(k),chdf(:le)).eq.0.and.k.le.lq) 
         k=k+1 
        end do 
       end if 
       jj=k 
      else if(ikey.eq.1)then 
       jj=jjq+1 
       if(jj.gt.lq) jj=1 
      else if(ikey.eq.-1)then 
       jj=jjq-1 
       if(jj.lt.1) jj=lq 
      else 
       jj=0 
      end if

     if(jj.gt.lq)jj=1
      jz=0 
      do k=1,lq 
       if(jj.eq.k)then 
        jjq=k 
        jz=1 
        if(ld(k).gt.0) then 
         if(jq.eq.0) then 
          type(k)=chred//                                               &
     &    '['//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k))//']'            
          jq=k 
         end if 
        else 
         if(jq.eq.0) then 
          type(k)=chred//'['//queryar(k)(1:lw(k))//']' 
!          write(6,'(a)')type(k)                                        
          jq=k 
         end if 
        end if 
        chdf=queryar(k) 
       else 
        if(ld(k).gt.0) then 
         type(k)=chnorm//' '//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k)) 
        else 
         if(jq.eq.k) then 
          type(k)=chred//                                               &
     &    '['//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k))//']'            
         else 
          type(k)=chnorm//' '//queryar(k)(1:lw(k)) 
         end if 
        end if 
       end if 
      end do 
                                                                        
      if(wrb.eq.'r') then 
!       write(6,'(a)')'combuff query wrb.eq.r)'                         
        ch132=' ' 
        do while(ch132(3:5).ne.'---') 
         read(10,'(a)') ch132 
         lcol=ncol(1) 
         if(lcol.gt.132)lcol=132 
         write(nulwr,'(2a)')chnorm//ch132(:lcol) 
         iwrl=iwrl+1 
       end do 
       lq=ichar(ch132(1:1))-i0 
       chh=ch132(2:2) 
       if(chh.ne.'-') lq=10*lq+ichar(chh)-i0 
!       write(6,'(a,i4)')'combuff query --------------end',lq           
       goto 100 
      end if 
                                                                        
   42 continue 
                                                                        
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
!       write(6,'(a,4i4)')' maxco,ii,lpart(jz-1)=',maxco,ii,lpart(jz-1),npl_i          
       if(abs(ii).lt.maxco-lpart(jz)) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nulwr,'(a,/,1x,a)')type(ii+1)(1:npl_i-3),type(ii+1)(npl_i-2:)   
         iwrl=iwrl+2 
        else 
         call itoc8(ch8,lpart(jz)) 
         ch2=ch8(:2) 
!        write(ch2,'(i2)')lpart(jz)                                      
         write(nulwr,'('//ch2//'(a))')(type(ii+j)(1:laenge(j+ii)),j=1,lpart(jz))              
         iwrl=iwrl+1 
        end if 
       end if 
      end do 
      write(nulwr,'(a4,a4)')chnorm,char(27)//'[1A' 
                                                                        
!      write(nulwr,'(2a)')'----------------------------------------',     
!     &'----------------------------------------'                       
      do k=1,npx 
       chflen(k:k)='-' 
      end do 
      write(nulwr,'(a)')chnorm//chflen(1:npx) 
      iwrl=iwrl+1 
      jsec=0 
      if(iiq.gt.0)then 
       lq=jq 
       goto 100 
      end if 
                                                                        
      if(jqh.gt.0) goto 43 
      if(le.eq.0) goto 100 
   43 continue 
!      write(6,'(a)') ' query  label 41'                                
      if(lq.gt.1) then 
       if(b_ig.or.go.eq.'g') then 
        ch132=' ' 
       else 
        ikey=key() 
        if(ikey.lt.0) then 
         if(ikey.eq.-65) ikey=-1 
         if(ikey.eq.-66) ikey=+1 
!         if(ikey.gt.-67) goto 44                                       
         if(ikey.eq.-67) ikey=+1 
         if(ikey.eq.-68) ikey=-1 
          ch132='shift' 
          write(nulwr,'(a1)')' ' 
        else 
         if(char(ikey).eq.'@')then 
          ch132=' ' 
          write(nulwr,'(a1)')' ' 
         else 
          ch132(1:1)=char(ikey) 
                                                       ! for choice     
          read(nrd,'(a)') ch132(2:) 
         end if 
         ikey=0 
        end if 
       end if 
       jqh=0 
      else 
       ch132=' ' 
       write(nulwr,'(a)')chnorm//chflen(1:npx) 
       iwrl=iwrl+1 
      end if 
                                                                        
      if(wrb.eq.'w'.and.ch132(1:1).eq.' ') then 
        ii=0 
        do jz=1,iz 
         ii=ii+lpart(jz-1) 
         if(abs(ii).lt.maxco-lpart(jz)) then 
          if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
           write(10,'(a,/,1x,a)')                                       &
     &               type(ii+1)(1:npl_i-3),type(ii+1)(npl_i-2:)         
          else 
           call itoc8(ch8,lpart(jz)) 
           ch2=ch8(:2) 
!          write(ch2,'(i2)')lpart(jz)                                   
           write(10,'('//ch2//'(a))')                                   &
     &               (type(ii+j)(1:laenge(j+ii)),j=1,lpart(jz))         
          end if 
         end if 
        end do 
        if(jq.le.9) then 
         chflen(1:1)=char(jq+i0) 
        else 
         i10=jq/10 
         i1=jq-10*i10+i0 
         chflen(1:2)=char(i10+i0)//char(i1) 
        end if 
        write(10,'(a)')chflen(1:npx)
        if(b_ig)write(nulwr,'(a)')chnorm//chflen(1:npx) 
      end if 
                                                                        
      if(jsec.eq.1) then 
       write(nulwr,'(1x,a1,a3)') char(27),'[3A' 
       write(nulwr,'(a)') chblank(:npx) 
      else 
       write(nulwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nulwr,'(a)') chblank(:npx) 
      end if 
      write(nulwr,'(1x,a1,a3)') char(27),'[2A' 
      jsec=0 
      chin=ch132 
      chin(81:)=' ' 
      le=ntrimto0(chin) 
      if(le.eq.0)then 
       chdf=' ' 
      else 
       chdf=chin(1:le) 
      end if 
      cp132=' ' 
                                                                        
      if(chdf(1:3).eq.'he ') then 
       write(nulwr,'(a,a)') ' select by typing a substring, RET',         &
     & ' or by repeatedly using left/right shift keys'                  
      end if 
!      read(nrd,'(a)') chout                                            
       if(le.gt.80) le=80 
       call lc_character(ch132) 
       if(ch132(1:3).eq.'he '.and.                                      &
     &          index(cheader,'further related').eq.0) then             
        if(jq.gt.0) then 
         call help(helpar(jq)) 
         jq=0 
!         write(6,'(a,i4)')'call help(helpar(jq)) jq=',jq               
         lq=lqin 
         lk=lq 
         chdf=chin80 
         jqh=jq 
         le=2 
        end if 
!        write(nulwr,'(a)') chflen(:npx)                                  
        iwrl=iwrl+1 
                                                                        
        goto 1 
                                                                        
!        goto 40                                                        
       end if 
       chh=chdf(1:1) 
                                                                        
       if(chh.eq.' ') then 
        lk=jk 
        lq=jq 
!       write(6,'(a,2i4)') ' query lq,lk=',lq,lk                        
        if(lq.eq.0) then 
          goto 40 
        else 
         goto 100 
        end if 
       end if 
!       if(iquit.eq.0.and.chh.eq.'q') chh='*'                           
       if(chh.eq.'*'.or.chh.eq.'q') then 
        lq=0 
        lk=0 
        goto 100 
       end if 
                                                                        
      ii=0 
      write(nulwr,'(1x,a1,a3)') char(27),'[2A' 
      iwrl=iwrl-1 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nulwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nulwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nulwr,'(a,/,a)') chblank(:npl_i),chblank(:npl_i) 
         iwrl=iwrl+2 
        else 
         write(nulwr,'(a)') chblank(:npl_i) 
         iwrl=iwrl+1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nulwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nulwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      jq=0 
      goto 40 
  100 continue 
      chdf(80:80)=char(iwrl+i0) 
      write(nulwr,'(a5,a1,a3)') chnorm,char(27),'[1A'
      if(b_ig) close(unit=nulwr)     
      return 
    END subroutine queryH

     
!==============================================================    
                                                                        
     subroutine search(comline,chisqmin,kshand,info) 
      use glbconst, only: b_noask,maxs,maxpf,maxp,maxc,nwr,nrd
      use comdat, only: b_datset
      use comfrm, only: kcof,np,p,plast,pmin,mp,kp,minsets,mco,mc,mcs,up,op,ddp,kcp
      use comths, only: ntest,nfit,kf,i_opgtup,hopmp,hupmp,iterations,idfdpk
      use comscd, only: npanum
      use comeff, only: ndispmode,npl,pathwidth,converg
      implicit none
     integer kshandle,whandle,hold,idum  
     common/win/kshandle,hold,whandle(maxs),idum(18*maxs+404)
                                                                       
      
      character(len=132), intent(inout):: comline                                                                             
      integer, intent(inout)  :: kshand
      real,    intent(inout)  :: chisqmin
      integer, intent(out) :: info

      character(len=132):: chcom,chin
      character(len=512):: ch512 

      logical   b_dataone 
      real      out(32) 
      integer   kfw(maxpf)
      character(len=256):: chflen
      character(len=132):: ch132,cp132,querytype
      character(len=32) :: ch32
      character(len=4)  :: chft,chma,cmch
      character(len=1)  :: ch1
      character(len=7)  :: form
      character(len=16) :: exten
                                                                        
      integer i,ii,i0,ic,iter_count,ienter,                        &
              j,j1,jfit,jlen,k,kpf,ks,jj,                               &
              l,ldata,ledit,                                            &
              mf,mfw,mfout,mm,n,n1,nj,nn,nt,n_little,nrest,nblnumber         
                                                                        
      real alowlimit,uplimit,value,chisq,pathw,ochisq,chi_p,            &
           path1,path2,dchi,t                                  
                                                                        
      real,    dimension(:), allocatable :: wp,wup,wop,wdp 
      real,    dimension(:), allocatable :: chisq_s
      real,    dimension(:,:),allocatable :: p_array 
      integer, dimension(:), allocatable :: indx
      integer, dimension(:), allocatable :: nf
      integer, dimension(:), allocatable :: kpw
                                                                       
      call ks_select(comline,info) 
      if(comline(1:1).eq.'*'.or.comline(1:1).eq.'q') return 

      ntest(0)=npanum(2) 
      do k=1,ntest(0) 
       ntest(k)=npanum(k+2) 
      end do 

      nblnumber=0
      chft='newt' 
      chin='fc b1l' 
      ienter=1 
      call ft_condition(chin,ienter,chft,info) 
                                                                        
      cp132='p fr' 
      call paident(info,cp132) 
                                                                        
      mf=npanum(maxc+2) 
      do k=1,mf 
        kf(k)=npanum(maxc+2+k) 
      end do 

      allocate(kpw(maxp),wp(mf),wup(mf),wop(mf),wdp(mf),nf(mf)) 
                                                                       
      if(.not.b_noask) then 
       ledit=0 
       nn=2 
       chma=' ' 
       call parm(nn,ledit,chma,chisqmin) 
       if(nn.lt.0) then 
        info=abs(nn) 
        goto 1000
       end if 
      end if 
                                                                        
      chft='test' 
      do k=1,maxp 
       kpw(k)=0 
      end do 
      mfw=0 
      do j=1,mf 
       k=kf(j) 
       if(op(k)-up(k).gt.ddp(k).and.ddp(k).gt.0) then 
        mfw=mfw+1 
        wp(mfw)=p(k) 
        wup(mfw)=up(k) 
        wop(mfw)=op(k) 
        wdp(mfw)=ddp(k) 
        kfw(mfw)=k 
        kpw(k)=1 
       end if 
      end do 
      do k=1,mfw 
       kf(k)=kfw(k) 
      end do 
      mf=mfw 
                                                                        
      do k=1,mco 
        kcof(k)=0 
         do ic=1,mc(k) 
          j=kcp(mcs(k)+ic) 
          if(kpw(j).eq.1) then 
           kcof(k)=k 
           goto 208 
          end if 
         end do 
  208   continue 
      end do 
                                                                        
      nt=1 
      do k=1,mf 
       nf(k)=0 
        wp(k)=wup(k) 
       do while(wp(k).lt.wop(k)) 
!        write(6,'(a,4f12.3)')'0wp,wup,wop,wdp=',wp(k),wup(k),wop(k),wdp(k)
        wp(k)=wp(k)+wdp(k) 
        nf(k)=nf(k)+1 
       end do 
       nt=nf(k)*nt 
       write(nwr,'(4x,i5,a,a24)')                                       &
             nf(k),' parameter values for ',np(kf(k))                   
      end do 
      write(nwr,'(4x,i5,a,a24)') nt,' parameter sets' 

                                                                        
      n_little=nt/2 
      if(b_noask) then 
       ldata=-1 
      else 
       form='i4' 
       alowlimit=1 
       uplimit= 512 
       if(n_little.gt.512) n_little=512 
       value= n_little 
       querytype='number of ordered parameter sets to be stored' 
       chcom='effi/search/number_chi' 
       call  askvallim(querytype,form,                                 &
                       alowlimit,uplimit,value,chcom,npl,nrd,nwr)      
       if(querytype(1:1).eq.'*'.or.querytype(1:1).eq.'q') goto 1010
       n_little=value 
       if(n_little.le.1) goto 1010
       ldata=1 
      end if 
      i=nt; if(n_little.gt.nt)i=n_little
      allocate(chisq_s(i),indx(i), p_array(mf,i))

!     -------------                                                          
      chcom='effi/search/file' 
      chin='search.sea' 
      ch32='search' 
      exten='sea' 
      call rdfname(ch32,chin,exten,chcom,npl,nwr)
      if(ldata.eq.0) goto 1000 
                                                                       
      open(unit=2                                                      &
                ,file=chin                                             &
                ,status='unknown'                                      &
                ,access='sequential'                                   &
               ,form='formatted'                                       &
                ,err=1000)                                             
                                                                       
      open(unit=3                                                      &
                ,file='_search.sea'                                     &
                ,status='unknown'                                      &
                ,access='sequential'                                   &
                ,form='formatted'                                      &
                ,err=1000)                                             

      open(unit=4                                                      &
                ,file='search.dat'                                     &
                ,status='unknown'                                      &
                ,access='sequential'                                   &
                ,form='formatted'                                      &
                ,err=1000)                                             
                                                                        
      !-------------
      chflen=' '
      i0=ichar('0') 
      chflen(1:6)='(g12.4' 
      jlen=13 
      do k=1,mf 
       j=(k-1)*9+7 
!       chflen(j:j+8)=np(kf(k))(25:33)                                  
       chflen(j:j+8)=',1x,g12.3' 
!       ch2=np(kf(k))(29:30)                                            
       jlen=jlen+13
       
      end do 
      j=mf*9+7 
      chflen(j:j)=')' 
      chisq=0.0 
!     write(6,'(a,3i5)')' helpsearch nt,n_little=',nt,n_little        
      if(nt.lt.n_little) then 
       do j=1,nf(1) 
        do k=1,mf 
         p_array(k,j)=wup(k) 
        end do 
       end do 
                                                                        
       n=1 
       wp(1)=wup(1) 
       do while(wp(1).lt.wop(1)) 
        p_array(1,n)=wp(1) 
        wp(1)=wp(1)+wdp(1) 
        n=n+1 
       end do 
                                                                        
       n=nf(1) 
       do k=2,mf 
        nj=0 
        wp(k)=wup(k)+wdp(k) 
        do while(wp(k).lt.wop(k)) 
!         write(6,'(a,4f12.3)')'1wp,wup,wop,wdp=',wp(k),wup(k),wop(k),wdp(k)
         nj=nj+n 
         do j=1,n 
          do i=1,mf 
           p_array(i,nj+j)=p_array(i,j) 
          end do 
          p_array(k,nj+j)=wp(k) 
         end do 
         wp(k)=wp(k)+wdp(k) 
        end do 
        n=n*nf(k) 
       end do 
                                                                        
       do j=1,nt 
        write(2,chflen)chisq,(p_array(k,j),k=1,mf) 
       end do 
                                                                        
      else   ! nt.lt.n_little
                                                                        
       do j=1,nf(1) 
        do k=1,mf 
         p_array(k,j)=wup(k) 
        end do 
       end do 
                                                                        
       n=1 
       wp(1)=wup(1) 
       do while(wp(1).lt.wop(1)) 
        p_array(1,n)=wp(1) 
        wp(1)=wp(1)+wdp(1) 
        n=n+1 
       end do 
       do j=1,nf(1) 
        write(3,chflen)chisq,(p_array(k,j),k=1,mf)
        write(2,chflen)chisq,(p_array(k,j),k=1,mf) 
       end do 
                                                                        
       n=nf(1) 
       do k=2,mf 
        rewind 2 
        rewind 3 
        do j=1,n 
         read(3,'(a)')ch512(:jlen) 
         write(2,'(a)')ch512(:jlen) 
        end do 
        nj=0 
        wp(k)=wup(k)+wdp(k) 
        do while(wp(k).lt.wop(k)) 
!        write(6,'(i3,a,4f12.3)')mf,'=mf  2wp,wup,wop,wdp=',wp(k),wup(k),wop(k),wdp(k)
         nj=nj+n 
         rewind 2 
         do j=1,n 
          read(2,chflen)chisq,(out(i),i=1,mf) 
          out(k)=wp(k) 
          write(3,chflen)chisq,(out(i),i=1,mf) 
         end do 
         wp(k)=wp(k)+wdp(k) 
        end do 
        n=n*nf(k) 
       end do 
       rewind 2 
       rewind 3 
       do j=1,n 
        read(3,'(a)')ch512(:jlen) 
        write(2,'(a)')ch512(:jlen) 
       end do 
      end if   !nt.lt.n_little

      close(unit=2); close(unit=3)
      read(5,*)
      open(unit=2,file=chin,status='old',access='sequential',form='formatted')
      open(unit=3,file='_search.sea',status='old',access='sequential',form='formatted')
      
      n=1
      i=index(chflen,')') 
      do while(n.le.nt) 
       read(2,chflen,end=200)chisq,(p(kf(k)),k=1,mf) 
!       write(6,*)'##',kf(1),p(kf(1))      
       call calpl('free')
       call fit(chft,mf,mfout,iter_count,pathw,                               &
                chisqmin,ochisq,chisq,chi_p,path1,path2,info) 
       mf=mfout         
      read(5,*)
       do k=1,ntest(0) 
        ks=ntest(k) 
        if(whandle(ks).ge.0) then 
         n1=ndispmode(ks) 
         cmch='plot'; call frametheory(ks,cmch,n1,info) 
!        write(6,'(a,2i4)')' efficmd test ks,whandle=',ks,whandle(ks)    
         kshandle=ks 
         cmch='ple2'; call frametheory(ks,cmch,n1,info) 
        end if 
       end do 
       ch512='(i6,1x,'//chflen(2:i)
       write(nwr,ch512)n,chisq,(p(kf(k)),k=1,mf) 
       write(3,chflen)chisq,(p(kf(k)),k=1,mf) 
       n=n+1
      end do 
                                                                        
  200 continue 
      rewind 2 
      rewind 3

      do j=1,nt 
       read(3,'(a)')ch512(:jlen) 
       write(2,'(a)')ch512(:jlen) 
      end do 
      rewind 2 
      nblnumber= nblnumber+1 
      if(nt.lt.n_little) then
       do j=1,nt 
        read(2,chflen)chisq_s(j),(p_array(k,j),k=1,mf) 
!        write(6,chflen)chisq_s(j),(p_array(k,j),k=1,mf)                
       end do 
       call INDEXX(nt,chisq_s,indx) 
!       write(6,'(20i4)')(indx(j),j=1,nt)                               
       rewind 2 
        write(4,'(/,a,i3)')'block number ',nblnumber                                    
       do j=1,nt 
        i=indx(j) 
        write(2,chflen)chisq_s(i),(p_array(k,i),k=1,mf) 
        write(4,chflen)chisq_s(i),(p_array(k,i),k=1,mf) 
       end do 
       rewind 2 
!       do j=1,nt                                                       
!        read(2,chflen)chisq_s(j),(p_array(k,j),k=1,mf)                 
!       end do                                                          
      else   !nt.lt.n_little
       rewind 3 
       n=nt/n_little 
       nrest=nt-n_little*n 
       do j=1,n_little 
        read(2,chflen)chisq_s(j),(p_array(k,j),k=1,mf) 
!      write(6,chflen)chisq_s(j),(p_array(k,j),k=1,mf)                  
       end do 
                                                                        
       do l=1,n-1 
!        write(6,'(a,i3)')' l-th=',l                                    
        do j=1,n_little 
         jj=n_little+j 
         read(2,chflen)chisq_s(jj),(p_array(k,jj),k=1,mf) 
!         write(6,chflen)chisq_s(jj),(p_array(k,jj),k=1,mf)             
        end do 
!        write(6,'(a,i3)')'## l-th=',l                                  
!        do j=1,n_little*2                                              
!         write(6,chflen)chisq_s(j),(p_array(k,j),k=1,mf)               
!        end do                                                         
        call INDEXX(n_little*2,chisq_s,indx) 
!        write(6,'(20i3)')(indx(j),j=1,20)                              
        rewind 3
         
        write(4,'(/,a,i3)')'block number ',l                                    
        do j=1,n_little 
         i=indx(j) 
         write(3,chflen)chisq_s(i),(p_array(k,i),k=1,mf)
         write(4,chflen)chisq_s(i),(p_array(k,i),k=1,mf) 
        end do 
                                                                       
        rewind 3 
        do j=1,n_little 
         read(3,chflen)chisq_s(j),(p_array(k,j),k=1,mf) 
!         write(6,chflen)chisq_s(j),(p_array(k,j),k=1,mf)               
        end do 
       end do 
                                                                        
       if(nrest.gt.0) then
        write(4,'(/,a,i3)')'block number ',l 
        do j=1,nrest 
         jj=n_little+j 
         read(2,chflen)chisq_s(jj),(p_array(k,jj),k=1,mf) 
        end do 
        call INDEXX(nrest+n_little,chisq_s,indx) 
!       write(6,'(20i4)')(indx(j),j=1,nrest)                            
        rewind 2 
        do j=1,n_little 
         i=indx(j) 
         write(2,chflen)chisq_s(i),(p_array(k,i),k=1,mf) 
         write(4,chflen)chisq_s(i),(p_array(k,i),k=1,mf) 
        end do 
       else 
        rewind 2 
        do i=1,n_little 
         write(2,chflen)chisq_s(i),(p_array(k,i),k=1,mf) 
        end do 
                                                                        
       end if 
      end if    !nt.lt.n_little 
                                                                        
      close(unit=3);  close(unit=4) 
      call rmsea 
                                                                        
      if(.not.b_noask) then 
       querytype='start Marquardt fitting with parameter sets as start' 
       ch1='y' 
       chcom='effi/search/fit' 
       call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
       if(ch1.ne.'y') goto 1000 
      end if 
                                                                        
      nfit(0)=ntest(0) 
      do i=1,nfit(0) 
       nfit(i)=ntest(i) 
      end do 
                                                                        
      rewind 2 
      jfit=n_little 
      if(jfit.gt.nt) jfit=nt 
      write(nwr,'(a,i2,a)')                                            &
          'the first ',jfit,' smallest chi-square values'               
      do j=1,jfit 
       read(2,chflen)chisq_s(j),(p(kf(k)),k=1,mf) 
       write(nwr,chflen)chisq_s(j),(p(kf(k)),k=1,mf) 
      end do 
                                                                        
      do  mm=1,mf 
       k=kf(mm) 
       if(op(k)-up(k).gt.0.) then 
        i_opgtup(mm)=1 
       else 
        i_opgtup(mm)=0 
       end if 
       hopmp(mm)=op(k) 
       hupmp(mm)=up(k) 
      end do 
                                                                        
                                                                        
      chft='marq' 
      jfit=0 
      do while(jfit.le.n_little) 
       jfit=jfit+1 
       form='i6' 
       alowlimit=1 
       uplimit=n_little 
       if(b_noask) then 
        if(jfit.eq.4) goto 1000 
       else 
        value=jfit 
        chcom='effi/search/fit/select' 
        querytype='number of parameter set as start values' 
        call  askvallim(querytype,form,                                 &
                        alowlimit,uplimit,value,chcom,npl,nrd,nwr)      
        if(querytype(1:1).eq.'*'.or.querytype(1:1).eq.'q') goto 1000 
        jfit=value 
       end if 
                                                                        
       rewind 2 
       do j=1,jfit-1 
        read(2,'(a)') 
       end do 
       read(2,chflen)chisq_s(j),(p(kf(k)),k=1,mf) 
!       write(6,chflen)chisq_s(j),(p(kf(k)),k=1,mf)                     
                                                                        
       call calpl('free') 
       path2=0.001 
       pathw=pathwidth 
       iter_count=1 
!------------------------------------------------------------           
       do while(iter_count.le.iterations) 
        call fit(chft,mf,mfout,iter_count,pathw,                             &
                 chisqmin,ochisq,chisq,chi_p,path1,path2,info) 
        mf=mfout         
        if(info.gt.0) goto 1000
        do ii=1,mp 
         plast(ii)=p(ii) 
        end do 
                                                                        
        if(iter_count.gt.0) then 
         iter_count=iter_count+1 
         dchi=ochisq-chisq 
         if(dchi.gt.0.0) ochisq=chisq 
!                                                                       
!        store best parameter set                                       
!                                                                       
         if(chisq.lt.chisqmin) then 
          chisqmin=chisq
          ochisq=chisq
          do ii=1,mp 
           pmin(ii)=p(ii) 
          end do 
          do ii=0,nfit(0) 
           minsets(ii)=nfit(ii) 
          end do 
         end if 
         b_dataone=.false. 
         do i=1,ntest(0) 
          ks=ntest(i) 
          b_dataone=b_dataone.or.b_datset(ks) 
         end do 
         if(b_dataone) then 
          write(nwr,'(2x,a2,5x,a4,13x,a,12x,a,5x,a,e10.1,a1)')         &
                                'nu','name','value','d-value',         &
                                '%(df/dk*dk>fixf*error)'               
          do kpf=1,mf 
           k=kf(kpf) 
           write(nwr,'(1x,a1,i3,a1,2x,a16,f15.5,2x,f10.5,3x,32i4)')       &
           '(',k,')',np(k),p(k),p(k)-plast(k),                          &
           (int(idfdpk(kpf,nfit(i))),i=1,nfit(0))                       
          end do 
         end if 
        else 
         iter_count=-iter_count+1 
        end if 
                                                                        
        t=100. 
        if(chisq.lt.t.and.dchi.lt.t.and.path1.lt.t.and.path2.lt.t) then 
         ch132='(a,f9.6,a,f10.6,2x,f4.1,a,2(f8.3,a1))' 
        else 
         ch132='(a,e8.2,a,e10.4,2x,f4.1,a,2(e8.2,a1))' 
        end if 
        if(chft.eq.'grad'.or.chft.eq.'marq')then 
         write(nwr,ch132) ' chi**2=',chisq,'  d_chi**2=',dchi,          &
         chi_p,'% <sigma , step=(',path1,',',path2,')'                  
        else 
         write(nwr,ch132) ' chi**2=',chisq,'  d_chi**2=',dchi,          &
         chi_p,'% <sigma , step=(',path1,')'                            
        end if 
                                                                        
!       convergence reached ?                                           
                                                                        
        if (abs(dchi).lt.converg) then 
         write (nwr,'(a,f10.6,a)')                                      &
                'convergence (d_chi**2 <',converg,')reached'            
        end if 
       end do   ! iter_count   
       write (nwr,'(x,a)') 'termination without convergence' 
                                                                        
       do k=1,nfit(0) 
        ks=nfit(k) 
        cmch='test'; call frametheory(ks,cmch,j1,info) 
       end do 
!------------------------------------------------------------           
       if(.not.b_noask) then 
        querytype='plot for last parameter set' 
        ch1='n' 
        chcom='effi/search/plot' 
        call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
        if(ch1.eq.'y') then 
         do i=1,nfit(0) 
          ks=nfit(i) 
          n1=ndispmode(ks) 
          cmch='plot'; call frametheory(ks,cmch,n1,info) 
          n1=1 
          kshandle=ks 
          cmch='plex'; call frametheory(ks,cmch,n1,info) 
         end do 
        end if ! b_noask   
       end if ! asking for fit 
      end do 
 1000 continue 
      deallocate(chisq_s,indx,p_array)
 1010 continue 
      close(unit=2) 
      deallocate(kpw,wp,wup,wop,wdp,nf)
      return 
    END subroutine search


      
!========================================================================
   subroutine grepR
   use glbconst, only: nwr,nrd,ncl
   use comeff, only: winfile,npl
   use compar, only: nwrwin,chterm
   implicit none
!   integer, intent(in):: nwrwin
    
    character(len=192):: entryREAD
    character(len=80) :: string1,pathv,pathhome,chh
    character(len=132):: querytype,chin,ch132,cp132,searchresult,chcom,cheader
    character(len=80), dimension(4):: string
    character(len=28) :: prompt
    character(len=5)  :: chred,chblue,chnorm
    character(len=8)  :: ch8
    character(len=1)  :: ch0,ch1
    character(len=132), dimension(:), allocatable:: helpar 
    character(len=192), dimension(:), allocatable:: fileREAD 
    integer, dimension(:), allocatable:: npanum,mch
    character(len=48):: chwindim
      character(len=16), dimension(1:8)     :: chkill
    integer :: i,ih,is,item,j,k,nur,ifound,lq,lqin,i0
    integer :: iwin,ipos,readaline,nn,lcase
    integer, save :: kwin
    
    chred=char(27)//'[31m' 
    chblue=char(27)//'[34m' 
    chnorm=char(27)//'[0m'

    lqin=1
    i0=ichar('0')
    iwin=1
    ch0=char(0) 
    call clearhist() 
    call addhist('he'//ch0)
 
    querytype='search strings (<=4) seperated by blank'
    ch132='source absorber'
    chcom='effi/search/string' 
    call askstring(querytype,ch132,chcom,ncl,nwr)
    if(ch132(1:1).eq.'q') return    
    searchresult=ch132

    item=0
    ih=1
    do while(ih.gt.0)
     call nextchar(ch132,0,is,chcom,ih) 
     if(chcom.ne.' ')then
      item=item+1
      string(item)=chcom(:ih)
      ch132=chcom(ih+1:)
     end if
    end do

    ifound=3
    allocate(fileREAD(ifound),helpar(ifound))
10  lcase=1
     
    helpar(1)='/effi/greprdme'
    helpar(2)='/effi/grepdvi'
    helpar(3)='/effi/grephelp'
    fileREAD(1)='README-files'
    fileREAD(2)='dvi/pdf-files'
    fileREAD(3)='help-files'
    cheader='type of files   '
    call queryS(lcase,ifound,cheader,fileREAD,helpar)
    if(lcase.le.0.or.lcase.gt.3) goto 10 
    call clearhist() 
    call addhist('he'//ch0)   
    select case(lcase)
    case(1) 
     call greprdme(item,string,nur,pathv,pathhome,ifound)
    case(2)
     call  grepdvi(item,string,nur,pathv,pathhome,ifound)
    case(3)
     call grephelp(item,string,nur,pathv,pathhome,ifound)
    end select

    select case(lcase)
     case(1,3) 
      kwin=7 
      chwindim='84x46+10+10 -bg khaki1 -fg black' 
      call termprocess(chwindim,chkill(kwin),kwin) 
      if(chterm(kwin).eq.' ') goto 2610 
      winfile=chterm(kwin)

      call window(kwin) 
      nwrwin=10+kwin 
      open(nwrwin,file=winfile,status='old'               &
                 ,access='sequential',form='formatted',err=2610) 
 2610 continue
     end select

    deallocate(fileREAD,helpar)
    
    open(unit=nur,file='entry'//char(nur+i0)//'.txt'          &
               ,status='old'            &
               ,access='sequential'         &
               ,form='formatted')

    allocate(fileREAD(ifound))
   if(lcase.eq.3) then
    open(unit=10,file=pathhome    &
               ,status='old',access='sequential',form='formatted')
     do i=1,ifound    
      read(10,'(a)')fileREAD(i)
     end do
   else
    ih=LEN_TRIM(pathhome)+1; 
    do i=1,ifound    
     read(nur,'(a)')entryREAD
     fileREAD(i)='$'//TRIM(pathv)//entryREAD(ih:)
!    write(6,'(a)')TRIM(fileREAD(i))
    end do
    rewind(unit=nur)
   end if
       

   if(ifound.gt.0)then
    allocate(helpar(ifound),npanum(ifound+4),mch(132))

    lq=1
    do i=1,ifound
     helpar(i)='effi/select/searchresult'
    end do
    cheader='entries found for string: '//TRIM(searchresult)

  55  continue
      lq=lqin
      call queryS(lq,ifound,cheader,fileREAD,helpar)
      lqin=lq
      if(lq.eq.0) goto 100
      call itoc8(ch8,lq); 
      call addhist(ch8(:3)//ch0) 

 60   continue    
       prompt=chred//'i,k-j type of listing>'//ch0
       cp132=' '
       mch=0 
       i=readaline(mch,prompt) 
       write(nwr,'(a5,a1,a3)') chnorm,char(27),'[1A' 
       if(i.gt.0) then 
        do j=1,i 
         cp132(j:j)=char(mch(j)) 
        end do
        call addhist(TRIM(cp132)//ch0) 
       end if 
                                                                        
       if(cp132.eq.' ') goto 60 
       if(cp132(1:2).eq.'he') then 
        chcom='effi/parameter/corr/mp/list' 
        call help(chcom) 
       end if 
       call window(iwin) 
       call nextchar(cp132,0,ipos,ch132,ih) 
       if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
        goto 100 
       else 
        chin=cp132 
        i=1
        call panum(chin,ifound,npanum,i) 
        
        if(i.ne.1) then
         print'(2a)','error in the list:',TRIM(chin)
         goto 60
        end if         
        if(npanum(2).gt.ifound) npanum(2)=ifound 
       end if 
       nn=npanum(2)
       if(nn.eq.0) goto 60 
       if(nn.lt.ifound) then
        do i=3,ifound+2-nn
         npanum(i+nn)=-1
        end do
       end if        
!      write(6,'(8i4)')(npanum(i),i=1,8)
     chh='*****************************************'// &
         '*****************************************'

     select case(lcase)
     case(1)   !   case 1-----------         
      do i=1,nn
       j=npanum(i+2) 
       do k=1,j
        read(nur,'(a)')entryREAD 
!        write(6,'(a)')TRIM(entryREAD)
       end do
       open(unit=1,file=entryREAD &
                  ,status='old',access='sequential',form='formatted')
       write(nwrwin,'(/,a,/,a)')chh,fileREAD(j)
       
   90  read(1,'(a)',end=91)string1 
       write(nwrwin,'(a)')string1
       goto 90 
   91  continue 
       close(unit=1)
       rewind(unit=nur)  
      end do
     case(2)   !   case 2-----------
      do i=1,nn
       j=npanum(i+2)
       ih=LEN_TRIM(pathv)+2; 
       entryREAD=TRIM(pathhome)//fileREAD(j)(ih:)
       call systemcmd("xdvi "//entryREAD//ch0)
      end do
     case(3)   !   case 3-----------
      nn=nn+2
      i=3
      do while(i.le.nn) 
  92   read(nur,'(a)',end=93)string1 
       ch8=string1(1:3)
       call c8toi(ch8,item)
       if(item.eq.npanum(i))then
        write(nwrwin,'(a)')string1       
        read(nur,'(a)',end=93)string1; ch8=string1(1:8)
        write(nwrwin,'(a)')string1 
        do while(ch8.ne.'/-------')
         read(nur,'(a)',end=93)string1
         write(nwrwin,'(a)')string1
         ch8=string1(1:8)
        end do
        i=i+1
       end if
       goto 92
      end do
  93  continue
      rewind(nur)
     end select

     querytype='reading further items' 
     ch1='y' 
     chcom='effi/search/string/item' 
     call yesno(querytype,ch1,chcom,ncl,nrd,nwr) 
     if(ch1.eq.'y') goto 55
     close(unit=nur)
     deallocate(fileREAD,helpar,npanum,mch)
   end if
 100 continue
     call systemcmd("rm entry1.txt entry2.txt "//ch0)

     close(unit=nwrwin) 
    if(lcase.ne.2) then  
     call killwin(chkill(kwin)) 
     chkill(kwin)=' '
    end if 

  END subroutine


      subroutine queryS(lq,ifound,cheader,queryar,helpar)
      use glbconst,only: nwr,nrd 
      use comeff,  only: npl,ncol  
      implicit none 
      integer, intent(in):: ifound
      integer, intent(inout):: lq
      character(len=132), intent(inout):: cheader
      character(len=132), intent(in), dimension(ifound):: queryar 
      character(len=132), intent(in), dimension(ifound):: helpar
      character(len=192), dimension(ifound):: type
      character(len=256):: chflen,chblank
      character(len=132):: ch132,cp132,chin
      character(len=1)  :: ch0,chh,ch1
      character(len=4)  :: chbold,chnorm
      character(len=5)  :: chred
      character(len=8)  :: ch8
      character(len=2)  :: ch2
      integer, dimension(2*ifound)  ::lw,laenge
      integer, dimension(0:2*ifound)::lpart
      logical block
      integer i,i0,ii,iiq,ikey,iquit,iz,j,jq,jz,jk,jj,jjq,jqh,   &
               jsec,k,l,laengez,lk,ll,lqin,lr,lapl,iwrl,      &
               npl_i,npx,ntrimto0,maxco,key
       
       lk=ifound
       maxco=2*lk
       lqin=lq 
       lq=lk

       chbold=char(27)//'[1m' 
       chred=char(27)//'[31m' 
       chnorm=char(27)//'[0m' 
       ch0=char(0) 
       iiq=0
       jqh=0 
    1  npx=npl
       if(npx.gt.132) npx=132 
!       write(6,'(a,8i4)') ' query lq,nwr,nrd,npl,ncol(1),npx=', &        
!                                 lq,nwr,nrd,npl,ncol(1),npx           
      i0=ichar('0') 
      iquit=0 
      chblank=' ' 
      npl_i=ncol(1)-3 
      block=.true. 
      if(cheader.eq.' ') then 
       do k=1,npx 
        chflen(k:k)='-' 
       end do 
      else 
       chh='-' 
       cheader(130:)=' ' 
       if(ncol(1).lt.131) cheader(ncol(1)+1:)=' ' 
       l=ntrimto0(cheader) 
       if(index(cheader,'information').eq.0)then 
        chflen=cheader(:l)//' (help:he)' 
        l=l+10 
       else 
        chflen=cheader(:l) 
       end if 
       i=(npx-l)/2 
       do k=l,1,-1 
        chflen(i+k:i+k)=chflen(k:k) 
       end do 
       do k=1,i 
        chflen(k:k)=chh 
       end do 
       k=i+l+1 
       do while(k.le.npx) 
        chflen(k:k)=chh 
        k=k+1 
       end do 
      end if 
                                                                        
      iwrl=0 
      write(nwr,'(a)')chnorm//chflen(:npx) 
      iwrl=iwrl+1 
                                                                        
      do k=1,npx 
       chflen(k:k)='-' 
      end do 

!      write(6,'(a)') ' query  label 5'                                 
      laengez=0 
      do k=1,lq 
       lw(k)=LEN_TRIM(queryar(k)) 
       ch1=queryar(k)
       if(ch1.eq.'*') iquit=1 
       ll=lw(k)+3 
       if(ll.gt.laengez) laengez=ll 
      end do 

      lpart(0)=0 
      lapl=0 
      if(block) then 
       laengez=laengez+2  ! 3  
       lapl=npx/laengez 
       if(lapl.eq.0) then 
        iz=0 
       else 
        iz=lq/lapl 
       end if 
       if(iz*lapl.lt.lq) iz=iz+1 
!       write(6,'(a,2i4)') ' lapl,iz',lapl,iz                           
   10  if(lapl.eq.0) goto 20 
       lr=lapl*iz-lq 
!       if(lr.ge.((lapl+1)/2)) then                                     
       if(lr.ge.(iz-1)) then 
        lapl=lapl-1 
        goto 10 
       end if 
       if(lr.lt.0) lapl=lapl+1 
       lr=lapl*iz-lq 
!      write(6,'(a,2i4)') ' lapl,lr',lapl,lr                            
      end if 
                                                                        
   20 if(lapl.eq.0) then 
       iz=1 
       laengez=0 
       lpart(iz)=0 
       do k=1,lq 
        laenge(k)=((lw(k)+2)/10+1)*10 
        if(laenge(k).lt.npx) then 
         laengez=laengez+laenge(k)+6 
!         write(6,'(a,i4)') ' laengez=',laengez                         
         lpart(iz)=lpart(iz)+1 
         if(laengez.ge.npx) then 
          if(laengez.gt.npx) then 
           laengez=laenge(k)+4 
           lpart(iz)=lpart(iz)-1 
           lpart(iz+1)=1 
          else 
           laengez=0 
           lpart(iz+1)=0 
!         write(6,'(a,i4)') ' *laengez=',laengez                        
          end if 
           if(k.le.lq) iz=iz+1 
!         write(6,'(a,2i4)') ' *k,iz=',k,iz                             
         end if 
        else 
         laenge(iz+1)=laenge(k) 
         lpart(iz+1)=1 
         if(k.le.lq) iz=iz+1 
        end if 
       end do 
      else 
       do k=1,lq 
        laenge(k)=laengez+8 
       end do 
       do k=1,iz-1 
        lpart(k)=lapl 
       end do 
       lpart(iz)=lapl-lr 
      end if 
                                                                        
!       write(6,'(a,8i4)') ' iz=',iz                                    
!       write(6,'(a,16i4)') ' lpart=',(lpart(i),i=1,iz)                 
!       write(6,'(a,16i4)') ' lw=',(lw(i),i=1,iz)                       
!       write(6,'(i3,a,10i4)') jqh,'=jqh  laenge=',(laenge(i),i=1,lq)   
      if(jqh.gt.0) goto 42 
       jjq=lqin-1 
       jq=0 
       jk=0 
       ikey=0 
   40 continue 
      if(ikey.eq.0)then 
       k=jjq+1 
       jj=k 
      else if(ikey.eq.1)then 
       jj=jjq+1 
       if(jj.gt.lq) jj=1 
      else if(ikey.eq.-1)then 
       jj=jjq-1 
       if(jj.lt.1) jj=lq 
      else 
       jj=0 
      end if

      if(jj.gt.lq)jj=1
      jz=0 
      do k=1,lq 
       if(jj.eq.k)then 
        jjq=k 
        jz=1 
        if(jq.eq.0) then 
         type(k)=chred//'['//queryar(k)(1:lw(k))//']'//chnorm 
         jq=k 
        end if 
       else 
        if(jq.eq.k) then 
         type(k)=chred//'['//queryar(k)(1:lw(k))//']'//chnorm
        else 
         type(k)=chnorm//' '//queryar(k)(1:lw(k))//chnorm
        end if 
       end if 
      end do 

   42 continue 
       ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1)
       if(abs(ii).lt.maxco-lpart(jz)) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(i2,1x,a,/,1x,a)')   &
               jz,type(ii+1)(1:npl_i-3),type(ii+1)(npl_i-2:)
         iwrl=iwrl+2 
        else
         call itoc8(ch8,lpart(jz)) 
         ch2=ch8(:2) 
          write(nwr,'(1x,'//ch2//'(i2,1x,a))')   &
               (ii+j,type(ii+j)(1:laenge(j+ii)),j=1,lpart(jz))
         iwrl=iwrl+1 
        end if 
       end if 
      end do 
      write(nwr,'(a4,a4)')chnorm,char(27)//'[1A' 
!      write(nwr,'(2a)')'----------------------------------------',     
!     &'----------------------------------------'                       
      do k=1,npx 
       chflen(k:k)='-' 
      end do 
      write(nwr,'(a)')chnorm//chflen(1:npx) 
      iwrl=iwrl+1 
      jsec=0 
      if(iiq.gt.0)then 
       lq=jq 
       goto 100 
      end if 
                                                                        
      if(jqh.gt.0) goto 43 
   43 continue 
!      write(6,'(a)') ' query  label 41'                                
      if(lq.gt.1) then 
        ikey=key()
        if(ikey.lt.0) then 
         if(ikey.eq.-65) ikey=-1 
         if(ikey.eq.-66) ikey=+1 
!         if(ikey.gt.-67) goto 44                                       
         if(ikey.eq.-67) ikey=+1 
         if(ikey.eq.-68) ikey=-1 
          ch132='shift' 
          write(nwr,'(a1)')' ' 
        else 
         if(char(ikey).eq.'@')then 
          ch132=' ' 
          write(nwr,'(a1)')' ' 
         else 
          ch132(1:1)=char(ikey) 
          read(nrd,'(a)') ch132(2:)   ! for choice 
         end if 
         ikey=0 
       end if 
       jqh=0 
      else 
       ch132=' ' 
       write(nwr,'(a)')chnorm//chflen(1:npx) 
       iwrl=iwrl+1 
      end if

      if(jsec.eq.1) then 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       write(nwr,'(a)') chblank(:npx) 
      else 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nwr,'(a)') chblank(:npx) 
      end if 
      write(nwr,'(1x,a1,a3)') char(27),'[2A' 
      jsec=0 
      chin=ch132 
      cp132=' ' 
                                                                        
      if(chin(1:3).eq.'he ') then 
       write(nwr,'(a)') ' select using shift keys'                  
      end if 
!      read(nrd,'(a)') chout                                            
       call lc_character(ch132) 
       if(chin(1:3).eq.'he '.and.                                      &
     &          index(cheader,'further related').eq.0) then             
        if(jq.gt.0) then 
         call help(helpar(jq)) 
         jq=0 
         lq=lqin 
         lk=lq 
         jqh=jq 
        end if 
!        write(nwr,'(a)') chflen(:npx)                                  
        iwrl=iwrl+1 
        goto 1 
!        goto 40                                                        
       end if 
       chh=chin(1:1) 
                                                                        
       if(chh.eq.' ') then 
        lk=jk 
        lq=jq 
!       write(6,'(a,2i4)') ' query lq,lk=',lq,lk                        
        if(lq.eq.0) then 
          goto 40 
        else 
         goto 100 
        end if 
       end if 
!       if(iquit.eq.0.and.chh.eq.'q') chh='*'                           
       if(chh.eq.'*'.or.chh.eq.'q') then 
        lq=0 
        lk=0 
        return
       end if 

      ii=0 
      write(nwr,'(1x,a1,a3)') char(27),'[2A' 
      iwrl=iwrl-1 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(a,/,a)') chblank(:npl_i),chblank(:npl_i) 
         iwrl=iwrl+2 
        else 
         write(nwr,'(a)') chblank(:npl_i) 
         iwrl=iwrl+1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      jq=0
      goto 40 
  100 continue
      write(nwr,'(a5,a1,a3)') chnorm,char(27),'[1A' 
      return 
      END  subroutine queryS                                          
                                                                        


   subroutine greprdme(item,string,nuw,pathv,projecthome,ifound)
   implicit none
    integer, intent(in) :: item    
    character(len=80), dimension(4), intent(in):: string
    integer, intent(out):: nuw,ifound
    character(len=80), intent(out) :: pathv,projecthome

    character(len=192):: entryREAD
    character(len=80) :: string1,chh
    character(len=132):: chin
    character(len=1)  :: ch0
    character(len=132), dimension(:), allocatable:: readme
    integer :: i,ih,k,l,is,j,jt,n,nur,i0
    logical :: found
    
    i0=ichar('0')
    ch0=char(0) 
    string1=string(1)
    pathv='EFFIPROJPATH'
    CALL GET_ENVIRONMENT_VARIABLE(NAME=pathv,value=projecthome,STATUS=i)
    ih=LEN_TRIM(projecthome)
!    print *,ih,projecthome(:ih), "         Exit status  was ", i
!    call execute_command_line("find "//projecthome//" -name README > READ.txt")
    chin='find '//projecthome(:ih)//' -name README > READ.txt'//ch0
    call  systemcmd(chin)
  
       open(unit=1,file='READ.txt'           &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

      j=0
 1    read(1,'(a)',end=2) chin    
      j=j+1
      goto 1
 2    continue
      rewind(unit=1)
      allocate(readme(j))

      do k=1,j                                                       
       read(1,'(a)') entryREAD
       readme(k)=entryREAD(ih+1:)
      end do
      close(unit=1)
      call systemcmd("rm READ.txt"//ch0)

      open(unit=1,file='entry1.txt'            &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
      ifound=0
      is=LEN_TRIM(string1)
      do k=1,j
       entryREAD=projecthome(:ih)//TRIM(readme(k))
       i=LEN_TRIM(entryREAD)

       open(unit=3,file=entryREAD(:i)            &
                 ,status='old'                &
                 ,access='sequential'         &
                 ,form='formatted')
       found=.false.
       l=1
  26   read(3,'(a)',end=30)chh 
       if(index(chh,string1(1:is)).gt.0)found=.true.
!       write(6,'(a)')TRIM(chh)                 
       l=l+1
       goto 26
   30  continue
       close(unit=3)
       if(found) then
        ifound=ifound+1
        write(1,'(a)')TRIM(entryREAD)
!       write(6,'(a)')TRIM(entryREAD) 
       end if
      end do 

    deallocate(readme)
    close(unit=1)    

    nur=2;nuw=1
    if(item.eq.1) goto 50
    jt=1
 31 continue
    jt=jt+1
    print'(a,i1,a2,a)','item number ',jt,'= ',TRIM(string(jt))
    string1=string(jt)
    is=LEN_TRIM(string1)

      open(unit=1,file='entry1.txt'          &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

      open(unit=2,file='entry2.txt'          &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
     n=nur
     nur=nuw;nuw=n
     ifound=0

  35  read(nur,'(a)',end=45)entryREAD 
      open(unit=3,file=TRIM(entryREAD)       &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
       found=.false.
       l=1
   41  read(3,'(a)',end=40)chh 
       if(index(chh,string1(1:is)).gt.0)found=.true.
!       write(6,'(a)')TRIM(chh)                 
       l=l+1
       goto 41
   40  close(unit=3)
       if(found) then
        ifound=ifound+1
        write(nuw,'(a)')TRIM(entryREAD)
       end if
       goto 35
   45 continue
      close(2) 
      close(1)
      if(jt.lt.item) goto 31 
50  continue
    chh='entry'//char(nur+i0)//'.txt' 
    open(unit=nur,file=TRIM(chh)         &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
    chh='entry'//char(nuw+i0)//'.txt' 
    open(unit=nuw,file=TRIM(chh)             &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

    do i=1,ifound    
     read(nuw,'(a)')entryREAD
!     write(6,'(a)')TRIM(entryREAD)
     write(nur,'(a)')'$EFFIPROJPATH'//entryREAD(ih+1:)                        
    end do
    close(unit=nur);close(unit=nuw) 
   end subroutine 




   subroutine grepdvi(item,string,nuw,pathv,dvihome,ifound)
   implicit none
    integer, intent(in) :: item  
    character(len=80), dimension(4), intent(in):: string
    integer, intent(out):: nuw,ifound
    character(len=80), intent(out) :: dvihome,pathv

    character(len=192):: entryREAD
    character(len=132):: chin,chfile
    character(len=96):: effihepath,chh,string1
    character(len=132), dimension(:), allocatable:: dvidir,dvisubdir
    character(len=1)  :: ch0
    integer :: i,i0,is,id,ih,j,k,kk,l,n,nf,nur,jt
    logical b_exist
    
    
    i0=ichar('0')
    ch0=char(0) 
    string1=string(1)
    pathv='EFFIHEPATH'

    is=LEN_TRIM(string1)
    CALL GET_ENVIRONMENT_VARIABLE(NAME=pathv,value=effihepath,STATUS=i)
    ih=LEN_TRIM(effihepath)
    dvihome=effihepath(:ih)//'/'//'dvifiles/'
    ih=LEN_TRIM(dvihome)
!    print *,ih,dvihome(:ih), "         Exit status  was ", i
    chin='ls -f '//dvihome//' > dvi.txt'//ch0
    call  systemcmd(chin)

     open(unit=1,file= 'dvi.txt'            &
               ,status='unknown'            &
               ,access='sequential'         &
               ,form='formatted')
     j=0
 1   read(1,'(a)',end=2) chin    
     if(chin(1:1).ne.'.')j=j+1
     goto 1
 2  continue
    rewind(unit=1)
    allocate(dvidir(j))

    do k=1,j                                                       
     read(1,'(a)')entryREAD
     if(chin(1:1).eq.'.') read(1,'(a)') entryREAD
     dvidir(k)=entryREAD
    end do
    close(unit=1)
    call  systemcmd("rm dvi.txt"//ch0)

     open(unit=1,file= 'entry1.txt'         &
                 ,status='unknown'            &
                 ,access='sequential'         &
                 ,form='formatted')
    ifound=0
    do kk=1,j 
      chin=dvihome(:ih)//TRIM(dvidir(kk))//'/'
      id=LEN_TRIM(chin)
      call systemcmd("ls -f "//chin(:id)//" > dvi.txt"//ch0)

       open(unit=2,file= 'dvi.txt'            &
                 ,status='unknown'            &
                 ,access='sequential'         &
                 ,form='formatted')
      i=0
 10   read(2,'(a)',end=11) chin    
      if(chin(1:1).ne.'.')i=i+1
      goto 10
 11   continue
      rewind(unit=2)
      allocate(dvisubdir(i))

      l=0
      do k=1,i                                                       
       read(2,'(a)',end=20) chin
       if(chin(1:1).eq.'.')read(2,'(a)') chin
       if(index(chin,'.dvi').gt.0) then
        l=l+1
        dvisubdir(l)=chin
       end if
!       write(6,'(i3,a)')l,TRIM(chin)
      end do
  20  continue
      close(unit=2)

      chin=dvihome(:ih)//TRIM(dvidir(kk))//'/'
      id=LEN_TRIM(chin)
      do k=1,l 
       chfile=chin(:id)//dvisubdir(k) 
       call systemcmd("dvi2tty -o file "//TRIM(chfile)//ch0)
       call systemcmd("grep "//string1//" file > string.txt"//ch0)
       call systemcmd("find  string.txt -type f -empty -delete"//ch0)

       inquire(file='string.txt',exist=b_exist)
       if(b_exist)then
        write(1,'(a)')TRIM(chfile)
        ifound=ifound+1
       end if
       call systemcmd("rm file"//ch0) 
      end do
      deallocate(dvisubdir)
     end do
     close(unit=1)
    dvihome(ih:ih)=' '

    nur=2;nuw=1
    if(item.eq.1) goto 50
    jt=1
 31 continue
    nf=ifound; ifound=0
    jt=jt+1
    print'(a,i1,a2,a)','item number ',jt,'= ',TRIM(string(jt))
    string1=string(jt)
    is=LEN_TRIM(string1)

     open(unit=1,file= 'entry1.txt'        &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
     open(unit=2,file= 'entry2.txt'       &
               ,status='unknown'             &
               ,access='sequential'          &
               ,form='formatted')
    n=nur
    nur=nuw;nuw=n

     do k=1,nf 
      read(nur,'(a)')chfile
      call systemcmd("dvi2tty -o file "//TRIM(chfile)//ch0)
      call systemcmd("grep "//string1//" file > string.txt"//ch0)
      call systemcmd("find  string.txt -type f -empty -delete"//ch0)

      inquire(file='string.txt',exist=b_exist)
      if(b_exist)then
       write(nuw,'(a)')TRIM(chfile)
       ifound=ifound+1
      end if
      call systemcmd("rm file"//ch0) 
     end do
    close(2) 
    close(1)
    if(jt.lt.item)goto 31

 50 continue
    chh='entry'//char(nur+i0)//'.txt' 
    open(unit=nur,file=TRIM(chh)         &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
    chh='entry'//char(nuw+i0)//'.txt' 
    open(unit=nuw,file=TRIM(chh)             &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

    do i=1,ifound    
     read(nuw,'(a)')entryREAD
!     write(6,'(a)')TRIM(entryREAD)
     write(nur,'(a)')'$EFFIPROJPATH'//entryREAD(ih:)  
!     write(6,'(a)')'$EFFIPROJPATH'//entryREAD(ih:)                        
    end do
    close(unit=nur);close(unit=nuw) 
    
   end subroutine

!===============================================================

   subroutine grephelp(item,string,nur,pathv,helphome,ifound)
!   use glbconst, only: nwr,nrd,ncl
   implicit none
    integer, intent(in) :: item  
    character(len=80), dimension(4), intent(in):: string
    integer, intent(out):: nur,ifound
    character(len=80), intent(out) :: helphome,pathv

    character(len=192):: entryREAD
    character(len=132):: chin,chfile,entry,dirhelp
    character(len=80) :: string1,chh
    character(len=132), dimension(1:256):: contline
    character(len=132), dimension(:), allocatable:: helpfile
    character(len=8)  :: ch8
    character(len=3)  :: ch3
    character(len=2)  :: ch2
    character(len=1)  :: ch0,ch1

    integer :: i,i0,is,ih,j,k,l,ll,n,nuw,jt,lb
    logical found,b_file
   
    jt=1
    pathv='EFFIHEPATH'
      open(unit=10,file='entryhelp.txt'      &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

    ch0=char(0)
    i0=ichar('0')
    string1=string(1)
    is=LEN_TRIM(string1)
    CALL GET_ENVIRONMENT_VARIABLE(NAME=pathv,value=helphome,STATUS=i)
    ih=LEN_TRIM(helphome)
    chin='ls -f '//helphome(:ih)//' > helpfile.txt'//ch0
    call  systemcmd(chin)

     open(unit=1,file='helpfile.txt'        &
               ,status='unknown'            &
               ,access='sequential'         &
               ,form='formatted')
     j=0
 1   read(1,'(a)',end=2) chin    
     j=j+1
     goto 1
 2   continue
     rewind(unit=1)
     allocate(helpfile(j))
     
     i=0
     do k=1,j 
      read(1,'(a)') chin
      if(index(chin,'help').gt.0.and.index(chin,'~').eq.0)then
       i=i+1
       helpfile(i)=chin
      end if
     end do
     close(unit=1)
     j=i
     
     call systemcmd("rm helpfile.txt"//ch0)

     open(unit=1,file='entry1.txt'            &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

      ifound=0
      do k=1,j
       chfile=helphome(:ih)//'/'//TRIM(helpfile(k))
       j=LEN_TRIM(helpfile(k))-5
       dirhelp=helpfile(k)(1:j)           ! for <dirhelp>
       j=LEN_TRIM(chfile)
       inquire(file=chfile,exist=b_file)

       open(unit=3,file=chfile(:j)            &
                 ,status='old'                &
                 ,access='sequential'         &
                 ,form='formatted')
  25   continue                                                       
       found=.false.
       l=1
       ch2=' '
       do while(ch2.ne.'bf')
        read(3,'(a)',end=30)contline(l) 
        if(index(contline(l),string1(1:is)).gt.0)found=.true.
!        write(6,'(a)')TRIM(contline(l))                 
        ch2=contline(l)(2:3)
        l=l+1
       end do
       lb=l-1
       entry='<'//TRIM(dirhelp)//'>'//contline(lb-1)
       ch1=' '
       do while(ch1.ne.'/')
        read(3,'(a)',end=30)contline(l)
        ch1=contline(l) 
!        write(6,'(a1,a)')'#',TRIM(contline(l))   
        if(index(contline(l),string1(1:is)).gt.0)found=.true.
        l=l+1
       end do

       backspace(unit=3)
       if(found) then
        ifound=ifound+1
        call itoc8(ch8,ifound) 
        ch3=ch8(:3) 
        write(10,'(a)')TRIM(entry)
        if(item.eq.jt)then
         write(1,'(a3,a1,a)')ch3,' ',TRIM(entry)
        else
         write(1,'(a)')TRIM(entry)
!        write(6,'(a,2i4)')TRIM(entry),lb,l-2
        end if
        write(1,'(a)')(TRIM(contline(ll)),ll=lb,l-2)
        write(1,'(a,/)')'/------------------------------------------'
       end if
!        read(5,*)
       goto 25
   30  continue
       close(unit=3)
      end do ! k=1,j 
      close(1) 
      close(unit=10)

    nur=2;nuw=1
    if(item.eq.1) goto 50
 31 continue
    jt=jt+1
    print'(a,i1,a2,a)','item number ',jt,'= ',TRIM(string(jt))
    string1=string(jt)
    is=LEN_TRIM(string1)

      open(unit=10,file='entryhelp.txt'      &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
 
     ifound=0
     open(unit=1,file='entry1.txt'            &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
     open(unit=2,file='entry2.txt'            &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

      n=nur
      nur=nuw;nuw=n
       write(nuw,'(a)')
  35   continue                                                       
       found=.false.
       l=1
       ch2=' '
       do while(ch2.ne.'bf')
        read(nur,'(a)',end=40)contline(l) 
        if(index(contline(l),string1(1:is)).gt.0)found=.true.
!        write(6,'(a)')TRIM(contline(l))                 
        ch2=contline(l)(2:3)
        l=l+1
       end do
       lb=l-1
       entry=contline(lb-1)

       ch1=' '
       do while(ch1.ne.'/')
        read(nur,'(a)',end=40)contline(l)
        ch1=contline(l) 
!        write(6,'(a,a1)')TRIM(contline(l)),'#'   
        if(index(contline(l),string1(1:is)).gt.0)found=.true.
        l=l+1
       end do
       backspace(unit=nur)
       if(found) then
        ifound=ifound+1
        call itoc8(ch8,ifound) 
        ch3=ch8(:3) 
        write(10,'(a)')TRIM(entry)
        if(item.eq.jt)then
         write(nuw,'(a3,a1,a)')ch3,' ',TRIM(entry)
        else
         write(nuw,'(a)')TRIM(entry)
        end if
        write(nuw,'(a)')(TRIM(contline(ll)),ll=lb,l-2)
        write(nuw,'(a,/)')'/------------------------------------------'
       end if
       goto 35
  40  continue
    close(2) 
    close(1)
    close(10)
    if(jt.lt.item) goto 31 
50  continue
    chh='entry'//char(nur+i0)//'.txt' 
    open(unit=nur,file=TRIM(chh)         &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')
    chh='entry'//char(nuw+i0)//'.txt' 
    open(unit=nuw,file=TRIM(chh)             &
                ,status='unknown'            &
                ,access='sequential'         &
                ,form='formatted')

       
  90 read(nuw,'(a)',end=91)entryREAD
     write(nur,'(a)')TRIM(entryREAD)
     goto 90
  91 continue 
    helphome='entryhelp.txt'
    close(unit=nur);close(unit=nuw) 
  end subroutine


     subroutine explore(comline,chisqmin,kshand,info) 
      use glbconst, only: maxs,maxpf,maxp,maxc,nwr,nrd
      use comfrm, only: kcof,np,p,plast,pmin,mp,kp,minsets,mco,mc,mcs,ddp,kcp
      use comths, only: ntest,kf
      use comscd, only: npanum
      use comeff, only: ndispmode,npl
      implicit none
     integer kshandle,whandle,hold,idum  
     common/win/kshandle,hold,whandle(maxs),idum(18*maxs+404)
                                                                       
      
      character(len=132), intent(inout):: comline                                                                              
      integer, intent(inout)  :: kshand
      real,    intent(inout)  :: chisqmin
      integer, intent(out) :: info

      character(len=512):: ch512 

      character(len=256):: chflen
      character(len=132):: cp132,querytype,chcom
      character(len=4)  :: chft,cmch,cmpl
      character(len=7)  :: form
      character(len=1)  :: ch1      
      integer i,i0,ic,iter_count,j,jlen,k,ks,mf,mfout,n,n1
                                                                              
      real chisq,pathw,ochisq,chi_p,path1,path2,value
      real,    dimension(:),allocatable :: porg
      character(len=24),dimension(:),allocatable :: nporg
      
      call ks_select(comline,info) 
      if(comline(1:1).eq.'*'.or.comline(1:1).eq.'q') return 

      ntest(0)=npanum(2) 
      do k=1,ntest(0) 
       ntest(k)=npanum(k+2) 
      end do 

      cp132='p fr' 
      call paident(info,cp132) 
                                                                        
      mf=npanum(maxc+2) 
      do k=1,mf 
        kf(k)=npanum(maxc+2+k) 
      end do 
      allocate(porg(mf),nporg(mf))
      do j=1,mf 
       k=kf(j) 
       porg(j)=p(k)
       nporg(j)=np(k)
      end do 
      cp132=' '
      do j=0,mf-1 
       chcom=cp132(:j*16)//nporg(j+1)(1:16)
       cp132=chcom
      end do

      chft='test' 
      querytype='factor aplied to stepwidth' 
      form='f5.1' 
      chcom='effi/explore/factor' 
      value=1.0 
      call askvalue(querytype,form,value,chcom,npl,nrd,nwr)
      write(nwr,'(a,/)')'       chi**2   '//TRIM(cp132)
      n=0
100   continue
      cmpl='ple2'
      if(n.gt.0)call askvalue(querytype,form,value,chcom,npl,nrd,nwr)
      if(querytype(1:1).eq.'*') value=0.0
      if(value.eq.0.0)then
       cmpl='plrf'
       querytype='restore start parameters' 
       ch1='n' 
       chcom='effi/explore/restore'  
       call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
       if(ch1.eq.'y')then       
        do j=1,mf 
         k=kf(j) 
         p(k)=porg(j)
        end do 
        comline='&& re 6 '
        return
       else       
        querytype='                    exit' 
        ch1='y' 
        chcom='effi/explore/exit'  
        call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
        if(ch1.eq.'y')return       
        querytype='factor aplied to stepwidth'
        cmpl='plrf'
        value=1.0
        do j=1,mf 
         k=kf(j) 
         p(k)=p(k)-ddp(k) 
        end do           
       end if
      end if   

      do j=1,mf 
       k=kf(j) 
       p(k)=p(k)+ddp(k)*value 
      end do 

      do k=1,mco 
        kcof(k)=0 
         do ic=1,mc(k) 
           kcof(k)=k 
           goto 208 
         end do 
  208   continue 
      end do                                                                         

      i0=ichar('0') 
      chflen(1:6)='(f12.3' 
      jlen=13 
      do k=1,mf 
       j=(k-1)*9+7 
!       chflen(j:j+8)=np(kf(k))(25:33)                                  
       chflen(j:j+8)=',1x,g16.3' 
!       ch2=np(kf(k))(29:30)                                            
       jlen=jlen+13
      end do 
      j=mf*9+7 
      chflen(j:j)=')' 
      chisq=0.0                                                                         
      i=index(chflen,')') 
      
      call calpl('free')
       call fit(chft,mf,mfout,iter_count,pathw,                               &
                chisqmin,ochisq,chisq,chi_p,path1,path2,info) 
       mf=mfout         

       do k=1,ntest(0) 
        ks=ntest(k) 
        if(whandle(ks).ge.0) then 
         n1=ndispmode(ks) 
         cmch='plot'; call frametheory(ks,cmch,n1,info) 
!        write(6,'(a,2i4)')' efficmd test ks,whandle=',ks,whandle(ks)    
         kshandle=ks 
         cmch=cmpl; call frametheory(ks,cmch,n1,info) 
        end if 
       end do

       ch512='(a1,a3,1x,'//chflen(2:i)
       write(nwr,ch512)char(27),'[1A',chisq,(p(kf(k)),k=1,mf)
       n=1
       goto 100
      return 
      END subroutine                                          
