      subroutine pcinsert(nerror,ms,mss,numco,ird,icd,mplth,neinord) 
      use glbconst, only: maxco,maxs,maxthss,infotext
      use compar, only:  maxsto,maxdimco
      use comfrm, only: ncon,con,icladd,mconcor,kpl,pl,ipladd,nthpl,    &
                        pl,kcp,np,kp,p,up,op,ddp,mr,mc,mp,mrce,mcs,     &
                        mrces,mrs,mcl,mco,mplths,mpadds,mcths,mkadds,   &
                        mpl,mrcet,mcthsp,mcthss,ncor,mplthsp,           &
                        mplthss,mplths,mpaddsp,mkaddsp,mpaddss,mkaddss, &
                        fpstor,cpstor
      use comdas, only: ktheo
      use comsto, only: nconh,conh,icladdh,&
! mrold,mcold,mrceold,mrcesold, &
                        kplh,nthplh,plh,ipladdh,kcph,nph,kph,           &
                        ph,uph,oph,ddph,cph,fph 
      use comscd, only: scratch,fscratch
      implicit none                                        
      integer   nerror,ms,mss,numco,ird,icd,mplth,neinord   

      real      rn 
      character(len=24):: ch24,cp24,chl,chr,cah,cbh
      character(len=4) :: ch4,cp4
      character(len=7) :: form
      character(len=1) :: ch1,chn
      character(len=2) :: ch2
      character(len=32):: ca32,cb32

      integer  i,i0,i1,i10,i2,i9,ic,ic1,ic2,ica,ichn,mcl_o,mcbeginn,    &
               idnk,ie,ihvk,ii,im,info,ir,j,jc,jco,jh,jj,               &
               ipvk,jo,jol,js,jm,k,kk,ks,kss,kssth,ksth,l,nt,           &
               l_,lb,lhash,m,mc1,mcu,mkk,mp1,mplu,mpu,mthss,ncth,       &
               nplth,nn  
      integer, dimension(maxco):: mrold,mcold,mrceold,mrcesold 
      nerror=0 
!      write(6,'(a,i4)') 'insert neinord=',neinord                      
!       write(6,'(20f6.2)')(cpstor(i),i=1,40)                           
!       write(6,'(20a6)')(fpstor(i),i=1,40)                             
!       write(6,'(20a6)')(fpstorh(i),i=1,20)                            
                                                                        
                                                                        
                                                                        
      mcl_o=mcl 
      mcbeginn=0 
      if(numco.gt.0) then 
       nt=mr(numco)*icd+mc(numco)*ird+ird*icd 
       if(nt+mrcet.gt.maxsto) then 
         form='i3' 
         rn=nt+mrcet-maxsto 
         call trlnu(form,rn,chr,nn,chl,im) 
         infotext(1)='effi/structure/transmatrix/split' 
         infotext(2)='*** fatal error *** quit the program' 
         infotext(3)=                                                   &
         'number of elements of all transformation matrices '           
         infotext(4)='exceeds maximal number by '//chl(1:im) 
         infotext(5)='help:split transformation matrices' 
         infotext(6)=' ' 
         nerror=12 
        goto 500 
       end if 
       mcbeginn=mc(numco) 
       if(mco.lt.numco) mco=numco 
!       write(6,'(a,5i3)')'insert mss,mco,numco,mc(numco)=',            
!     &                           mss,mco,numco,mc(numco)               
       do j=1,mco 
        mrold(j)=mr(j) 
        mcold(j)=mc(j) 
        mrceold(j)=mrce(j) 
        mrcesold(j)=mrces(j) 
       end do 
       if(icd.eq.0.and.neinord.eq.1) goto 400 
      else 
!      constants                                                        
       if(mss.eq.0) then 
        ncth=mcthsp(ms) 
       else 
        ncth=mcthss(ms,mss) 
       end if 
       mcu=mcths(ms,mss) 
       mcl=mcl+ncth 
       do j=mcl,mcu+ncth+1,-1 
         ncon(j)=ncon(j-ncth) 
          con(j)=con(j-ncth) 
          icladd(j)=icladd(j-ncth) 
                                                 !  29.08.07            
          mconcor(j)=mconcor(j-ncth) 
       end do 
       do j=1,ncth 
         ncon(j+mcu)=nconh(j) 
          con(j+mcu)=conh(j) 
         icladd(j+mcu)=icladdh(j) 
                                                   !  29.08.07          
         mconcor(j+mcu)=j+mcu 
!       write(6,'(i3,2x,a,f10.3)')j,nconh(j),conh(j)                    
       end do 
!       write(6,'(a,i2,2x,20i3)') 'insert icladdh(1..ncth)=',mcu,       
!     &   (icladdh(j),j=1,ncth)                                         
       icd=0 
       goto 400 
      end if 
                                                                        
!     kpl(i) numbers                                                    
                                                                        
!       write(6,'(a,2i2,a2,i3,a,2i4)')'insert mplths(',                 
!    &  ms,mss,')=', mplths(ms,mss),' ird,mplth=',ird,mplth             
!      write(6,'(a,5i3)') ' kcp='                                       
!      write(6,'(10i3)') (kcp(k),k=1,mp)                                
       mplu=mplths(ms,mss)+mplth-ird 
       mpu=0 
       do kk=1,mco 
         do j=1,mr(kk) 
          if(kpl(mrs(kk)+j).le.mplu) then 
           mkk=mrces(kk)+(j-1)*mc(kk) 
           do ic=1,mc(kk) 
!             if(cpstor(mkk+ic).ne.0) then                              
                i=mcs(kk)+ic 
               if(kcp(i).gt.mpu) mpu=kcp(i) 
!             end if                                                    
           end do 
          end if 
         end do 
       end do 
                                                                        
!      write(6,'(a,4i3)') ' insert..mpu,mplu=',mpu,mplu                 
!       write(6,'(a,20i3)') '1 insert..mc=',(mc(kk),kk=1,14)            
!       write(6,'(a,20i3)') '1 insert..mcs=',(mcs(kk),kk=1,14)          
!       write(6,'(a,20i3)') '1 insert..mrs=',(mrs(kk),kk=1,14)          
!       write(6,'(a,20i3)') '1 insert..mr =',(mr(kk),kk=1,numco)        
                                                                        
       do j=1,mpl 
        if(kpl(j).gt.mplu) kpl(j)=kpl(j)+ird 
!       write(6,'(a,4i3)')'insert..kpl(j),mplu,ird=',kpl(j),mplu,ird    
       end do 
                                                                        
       do ir=1,ird 
        j=mrs(numco)+mr(numco)+ir-1 
        if(mpl.gt.0) then 
         do l=mpl+1,j+1,-1 
                                                      ! 25.5.97         
          if(l.gt.1) kpl(l)=kpl(l-1) 
         end do 
        end if 
         kpl(j+1)=mplu+ir 
         mpl=mpl+1 
!       write(6,'(a,5i3)') ' insert.. mpl+1: numco,mplu,j,mpl,kpl(j+1)='
!     &                         numco,mplu,j,mpl,kpl(j+1)               
       end do 
                                                                        
!       write(6,'(a,i4)') 'insert ivaddsp ms=',ms                       
!       write(6,'(20i4)') (ivaddsp(ms,j),j=1,40)                        
                                                                        
!       write(6,'(a,/,60i4)')'1insert ipladd:',(ipladd(j),j=1,60)       
       do j=mpl,mplu+ird+1,-1 
          nthpl(j)=nthpl(j-ird) 
          pl(j)=pl(j-ird) 
          ipladd(j)=ipladd(j-ird) 
       end do 
!       write(6,'(a,/,60i4)')'2insert ipladd:',(ipladd(j),j=1,60)       
                                                                        
!       write(6,'(2i4,a,6i3)')mss,mplu,' insert..kplh(1..ird)=',        
!     &                         (kplh(j),j=1,ird)                       
       do j=1,ird 
          jh=kplh(j) 
          nthpl(j+mplu)=nthplh(jh) 
          pl(j+mplu)=plh(jh) 
          ipladd(j+mplu)=ipladdh(jh) 
!       write(6,'(a,3i3,2x,a)')'insert..j,kplh(j),ipladdh,nthplh(jh)=', 
!     &                    j,jh,ipladdh(jh),nthplh(j)                   
       end do 
!       write(6,'(a)') 'insert ipladdh:'                                
!       write(6,'(20i4)') (ipladdh(kplh(j)),j=1,ird)                    
!       write(6,'(a)') 'insert ipladd:'                                 
!       write(6,'(20i4)') (ipladd(i),i=1,100)                           
                                                                        
!      write(6,'(a,10i4)') ' insert kplh(1..)=',(kplh(i),i=1,ird)       
                                                                        
!     kcp(i) numbers                                                    
                                                                        
       do j=1,mp 
        if(kcp(j).gt.mpu) kcp(j)=kcp(j)+icd 
       end do 
                                                                        
        do ic=1,icd 
         j=mcs(numco)+mc(numco)+ic-1 
         if(mp.gt.0) then 
          do l=mp+1,j+1,-1 
                                                         ! 25.5.97      
           if(l.gt.1) kcp(l)=kcp(l-1) 
          end do 
         end if 
         kcp(j+1)=mpu+ic 
         mp=mp+1 
        end do 
!      write(6,'(i2,5x,10i3)')icd, (kcp(k),k=1,10)                      
                                                                        
       do j=mp,mpu+icd+1,-1 
         np(j)=np(j-icd) 
         kp(j)=kp(j-icd) 
          p(j)=p(j-icd) 
          up(j)=up(j-icd) 
          op(j)=op(j-icd) 
          ddp(j)=ddp(j-icd) 
       end do 
       do j=1,icd 
         jh=kcph(j) 
!         write(6,'(2i2,a,i3,1x,a)')j,jh,' insert kph,nph(jh)=',kph(jh),&
!              nph(jh)                                                 
         np(j+mpu)=nph(jh) 
         kp(j+mpu)=kph(jh) 
         p(j+mpu)=ph(jh) 
         up(j+mpu)=uph(jh) 
         op(j+mpu)=oph(jh) 
         ddp(j+mpu)=ddph(jh) 
       end do 
                                                                        
       mr(numco)=mr(numco)+ird 
       mc(numco)=mc(numco)+icd 
       do k=1,maxco 
         mrce(k)=mr(k)*mc(k) 
       end do 
        do k=2,maxco 
          mrs(k)=mrs(k-1)+mr(k-1) 
          mcs(k)=mcs(k-1)+mc(k-1) 
         mrces(k)=mrces(k-1)+mrce(k-1) 
        end do 
       mrcet=mrces(mco)+mrce(mco) 
!       write(6,'(4x,i2,2x,a,a,6i4)')numco,ncor(numco)(1:16),           
!     &                  ' mrcet,mc,mr=',mrcet,mc(numco),mr(numco)      
       if(mrcet.gt.maxsto.or.                                           &
         mr(numco).gt.maxdimco*2.or.mc(numco).gt.maxdimco) then        
         form='i3' 
         infotext(1)='effi/structure/transmatrix/split' 
         infotext(2)='*** error ***' 
         infotext(3)='dimension of transformation matrix '//ncor(numco)
         j=3 
         if(mr(numco).gt.maxdimco*2) then 
          rn=maxdimco*2 
          j=j+1 
          call trlnu(form,rn,chr,nn,chl,im) 
          infotext(j)='exceeds maximal row number '//chl(1:im) 
         end if 
         if(mc(numco).gt.maxdimco) then 
          j=j+1 
          rn=maxdimco 
          call trlnu(form,rn,chr,nn,chl,im) 
          infotext(j)='exceeds maximal column number '//chl(1:im) 
         end if 
         if(mrcet.gt.maxsto) then 
          j=j+1 
          rn=mrcet-maxsto 
          call trlnu(form,rn,chr,nn,chl,im) 
          infotext(j)='exceeds maxsto by '//chl(1:im) 
         end if 
         infotext(j+1)='help:split transformation matrices' 
         infotext(j+2)=' ' 
         nerror=12 
        goto 500 
       end if 
                                                                        
                                                                        
       do jco=1,mco 
        if(jco.eq.numco) then 
          m=numco 
          jm=mrces(m) 
           jo =mrcesold(m)-mcold(m) 
           do l=1,mr(m) 
           do k=1,mc(m) 
            jm=jm+1 
            if(l.le.mrold(m)) then 
             jol=jo+l*mcold(m) 
             if(k.gt.mcold(m))then 
              scratch(jm)=0. 
              fscratch(jm)='f030' 
             else 
              scratch(jm)=cpstor(jol+k) 
              fscratch(jm)=fpstor(jol+k) 
             end if 
            else 
             fscratch(jm)='f030' 
             scratch(jm)=0. 
            end if 
           end do 
           end do 
        else 
          m=jco 
          jm=mrces(m) 
          jo=mrcesold(m) 
          do l=1,mrce(m) 
            scratch(jm+l)=cpstor(jo+l) 
            fscratch(jm+l)=fpstor(jo+l) 
          end do 
        end if 
       end do 
                                                                        
!     inserting the matrix elements # 0                                 
!      position of index [io+ir,ko+ic,m]:                               
!                         jj=mrces(m)+(mrh(m)+ir-1)*mc(m)+mch(m)+ic     
!      (ir,ic) matrix                                                   
                                                                        
                                                                        
          m=numco 
          jj=mrces(m)+(mrold(m)-1)*mc(m)+mcold(m) 
          do ir=1,ird 
          mc1=mc(m)*ir 
          do ic=1,icd 
           scratch(jj+mc1+ic)=cph(ir,ic) 
           fscratch(jj+mc1+ic)=fph(ir,ic) 
          end do 
!          write(6,'(i4,12a6)')jj,(fph(ir,ic),ic=1,icd)                 
          end do 
                                                                        
       do k=1,mrcet 
         cpstor(k)=scratch(k) 
         fpstor(k)=fscratch(k) 
       end do 
                                                                        
       if(mss.eq.0) then 
        nplth=mplthsp(ms) 
       else 
        nplth=mplthss(ms,mss) 
       end if 
!        write(6,'(a,3i4)') 'nplth,mplth=', nplth,mplth                 
                                                                        
!      if(mplth.eq.nplth) then                                          
  400 if(neinord.eq.1) then 
!      write(6,'(a,i4)') ' neinord=',neinord                            
                                                                        
      do ks=1,maxs 
       ksth=ks 
       if(ktheo(ks,0,0).eq.0) ksth=0 
       mplths(ks,1)=mplths(ks,0)+mplthsp(ksth) 
       mpadds(ks,1)=mpadds(ks,0)+mpaddsp(ksth) 
       mcths(ks,1)=mcths(ks,0)+mcthsp(ksth) 
       mkadds(ks,1)=mkadds(ks,0)+mkaddsp(ksth) 
        do kss=2,maxthss 
         kssth=kss-1 
         if(ktheo(ks,kss-1,0).eq.0) kssth=0 
         mplths(ks,kss)=mplths(ks,kss-1)+mplthss(ks,kssth) 
         mpadds(ks,kss)=mpadds(ks,kss-1)+mpaddss(ks,kssth) 
         mcths(ks,kss)=mcths(ks,kss-1)+mcthss(ks,kssth) 
         mkadds(ks,kss)=mkadds(ks,kss-1)+mkaddss(ks,kssth) 
        end do 
         if(ks.lt.maxs) then 
         mthss=maxthss 
         if(ktheo(ks,maxthss,0).eq.0) mthss=0 
         mplths(ks+1,0)=mplths(ks,maxthss)+mplthss(ks,mthss) 
         mpadds(ks+1,0)=mpadds(ks,maxthss)+mpaddss(ks,mthss) 
         mcths(ks+1,0)=mcths(ks,maxthss)+mcthss(ks,mthss) 
         mkadds(ks+1,0)=mkadds(ks,maxthss)+mkaddss(ks,mthss) 
         end if 
      end do 
                                                                        
      if(icd.eq.0) goto 500 
              ! mplth=nplth                                             
      end if 
                                                                        
!       transformation of parameters of equal name                      
                                                                        
        if(mcbeginn.eq.0) goto 200 
        i0=ichar('0') 
        i9=ichar('9') 
                                                                        
!       write(6,'(a)') '  kcp='                                         
!       write(6,'(20i3)') (kcp(k),k=1,mp)                               
         ica=mcs(numco) 
!       write(6,'(a,i5)') 'transformation matrix ',numco                
                                                                        
         do i1=1,mc(numco) 
          ch24=np(kcp(ica+i1)) 
          l=0 
          ch1=' ' 
          do while(ch1.eq.' ') 
           l=l+1 
           ch1=ch24(l:l) 
          end do 
          if(l.gt.1) np(kcp(ica+i1))(:24)=ch24(l:) 
         end do 
!         write(6,'(a,i3)')'insert numco=',numco                        
!         write(6,'(a)')(np(kcp(ica+i1)),i1=1,mc(numco))                
                                                                        
!         do i1=1,mc(numco)-1                                           
         i1=0 
         do while(i1.lt.mc(numco)) 
          i1=i1+1 
          ic1=ica+i1 
          mp1=kcp(ic1) 
!         write(6,'(6(a,i2))') ' mc(',numco,')=',mc(numco), &            
!          ' ica=',ica,' ic1=',ic1,' mp1=',mp1,' mpl=',mpl             
          if(mp1.eq.0) goto 100 
          ch24=np(mp1) 
!          write(6,'(i3,a,2a24)')i1,'insert ch24=',ch24                 
          l=index(ch24,'#') 
          if(l.gt.0) then 
           chn=ch24(l+1:l+1) 
           chr=ch24(l+1:) 
           call nreplchar(0,chr) 
!          write(6,'(i3,a,2a24)')i1,'insert ch24,chr= ',ch24,chr        
           ch24=chr 
          else 
           chr=ch24 
           call nreplchar(0,chr) 
!           write(6,'(i3,a,2a24)')i1,'insert ch24,chr=',ch24,chr        
           ch24=chr 
          end if 
                                                                        
          i2=i1 
          do while(i2.lt.mc(numco)) 
           i2=i2+1 
           ic2=ica+i2 
           mpu=kcp(ic2) 
!          if(mpu.le.0) then                                            
!               write(6,'(8(a,i2))') ' i1=',i1,' i2=',i2,               
!     &     ' ica=',ica,' ic2=',ic2,' kcp(ic2)=',kcp(ic2),              
!     &     ' mc(',numco,')=',mc(numco)                                 
!          write(6,'(a)') '  kcp='                                      
!          write(6,'(20i3)') (kcp(k),k=1,mp)                            
!          end if                                                       
                                                                        
                                                                        
           cp24=np(mpu) 
!          write(6,'(2i3,a,2a24)')i1,i2,'insert ch,cp= ',ch24,cp24      
           lhash=index(cp24,'#') 
           if(lhash.gt.0) then 
            l=lhash 
!           write(6,'(2i3,a,2a24)')i1,i2,'insert cp= ',cp24             
            chn=cp24(l+2:l+2) 
            ichn=ichar(chn) 
            if(ichn.ge.i0.and.ichn.le.i9) then 
             chr=cp24(l+2:) 
             ch1=' ' 
             ch2=cp24(l+1:l+2) 
            else 
             chr=cp24(l+1:) 
             ch1=cp24(l+1:l+1) 
             ch2=' ' 
            end if 
            call nreplchar(0,chr) 
            cp24=chr 
!           write(6,'(a,a24,a1,a24)')'insert cp,ch=',cp24,':',ch24      
           end if 
           l=17 
           do while(cp24(l:l).eq.' ') 
            l=l-1 
           end do 
           if(ch24.eq.cp24.and.lhash.gt.0) then 
                                                                        
            if(ch2.eq.' ') then 
             print'(a,i3,a1,a24,a,a24)','parameter ',mp1,':',cp24, &
              ' correlated with',ch1//cp24(2:l)                        
            else 
             print'(a,i3,a1,a24,a,a24)','parameter ',mp1,':',cp24, &
             ' correlated with',ch2//cp24(2:l)                          
            end if 
            np(mp1)(:24)=cp24 
            kk=numco 
            do ir=1,mr(kk) 
             mkk=mrces(kk)+(ir-1)*mc(kk) 
             cpstor(mkk+i1)=cpstor(mkk+i1)+cpstor(mkk+i2) 
             ch4=fpstor(mkk+i1) 
             ihvk=10*(ichar(ch4(2:2))-i0)+ichar(ch4(3:3))-i0 
             idnk=ichar(ch4(4:4)) 
             cp4=fpstor(mkk+i2) 
             ipvk=10*(ichar(cp4(2:2))-i0)+ichar(cp4(3:3))-i0 
             idnk=idnk-ichar(cp4(4:4)) 
!             write(6,'(a,2a4,3i5)')' insert ch4,cp4,ihvk,ipvk,idnk=',  
!     &              ch4,cp4,ihvk,ipvk,idnk                             
             if(ihvk.gt.ipvk) then 
               if(idnk.lt.0) then 
                ihvk=ihvk-idnk 
                i10=ihvk/10 
                ch4(2:3)=char(i10+i0)//char(ihvk-10*i10+i0) 
                ch4(4:4)=cp4(4:4) 
               end if 
             else 
               if(idnk.lt.0) then 
                ch4=cp4 
               else 
                ipvk=ipvk+idnk 
                i10=ipvk/10 
                ch4(2:3)=char(i10+i0)//char(ipvk-10*i10+i0) 
               end if 
             end if 
!             write(6,'(a,a4)')' insert ch4=',ch4                       
             fpstor(mkk+i1)=ch4 
            end do 
            do i=mpu+1,mp 
             ii=i-1 
             ie=i 
             np(ii)=np(ie) 
             p(ii)=p(ie) 
             up(ii)=up(ie) 
             op(ii)=op(ie) 
             ddp(ii)=ddp(ie) 
            end do 
            do i=ic2,mp-1 
             kcp(i)=kcp(i+1) 
            end do 
            do i=1,mp-1 
             if(kcp(i).gt.mpu) kcp(i)=kcp(i)-1 
            end do 
            kcp(mp)=0 
                                                                        
            js=mrces(kk) 
            jc=js 
            do i=1,mr(kk) 
             do k=1,mc(kk) 
              jc=jc+1 
              js=js+1 
              scratch(js)=cpstor(jc) 
              fscratch(js)=fpstor(jc) 
              if(k.eq.i2)js=js-1 
!              write(6,'(4i5,a,2(a,f10.3))')i,k,jc,js,'f,c(jc,js)= ',   
!     &           fpstor(jc),cpstor(jc),fscratch(js),scratch(js)        
             end do 
            end do 
            if(kk.lt.mco) then 
             do i=mrces(kk+1)+1,mrcet 
              js=js+1 
              scratch(js)=cpstor(i) 
              fscratch(js)=fpstor(i) 
             end do 
            end if 
                                                                        
            mp=mp-1 
            mc(kk)=mc(kk)-1 
            mrce(kk)=mr(kk)*mc(kk) 
            do j=2,maxco 
             mcs(j)=mcs(j-1)+mc(j-1) 
             mrces(j)=mrces(j-1)+mrce(j-1) 
            end do 
            mrcet=mrcet-mr(kk) 
            do i=mrces(kk)+1,mrcet 
             cpstor(i)=scratch(i) 
             fpstor(i)=fscratch(i) 
            end do 
           end if 
          end do 
!          kcp(mp)=0                                                    
                                                                        
         end do 
  100   continue 
                                                                        
  200   continue 
       info=0 
       if(numco.gt.0) call coexam(numco,info) 
       if(info.gt.0) nerror=11 
                                                                        
  500 continue 
!        write(6,'(a,6i3)')'insert..nerror,ms,mss,numco,ird,icd,mplth=',
!     &      nerror,ms,mss,numco,ird,icd,mplth                          
         do i1=mcl_o+1,mcl 
          ch24=ncon(i1) 
          l=1 
          do while(ch24(l:l).eq.' ') 
           l=l+1 
          end do 
          if(l.gt.1) ncon(i1)(1:24)=ch24(l:) 
         end do 
                                                                        
         do i1=mcl_o+1,mcl 
          mconcor(i1)=i1                                !5.5.05  
         end do 
         do i1=mcl_o+1,mcl 
          ca32=ncon(i1) 
!          write(6,'(a,i3,2x,a)')'i1=  ',i1,ncon(i1)                    
          l=index(ca32,'hb') 
          if(l.gt.0) ca32(1:3)='0hd' 
          l=index(ca32,'#') 
          if(l.gt.0)ca32(1:1)='0' 
          if(ca32(1:1).eq.'0') then 
                                                                        
           l_=index(ca32,'_') 
           l=l_ 
           lb=1
           do while(ca32(l:l).eq.'_') 
            l=l+1 
           end do 
           cah=ca32(lb:l_)//ca32(l:24) 
!           write(6,'(a,i3,2x,a)')'i1=',i1,cah                          
                                                                        
           do i2=1,mcl_o 
            cb32=ncon(i2) 
            l=index(cb32,'hb') 
            if(l.gt.0) cb32(1:3)='0hd' 
            l_=index(cb32,'_') 
            l=l_ 
            lb=1
            do while(cb32(l:l).eq.'_') 
             l=l+1 
            end do 
            cbh=cb32(lb:l_)//cb32(l:24) 
!            write(6,'(a,i3,2x,a)')'  i2=',i2,cbh                       
                                                                        
            if(cah(2:24).eq.cbh(2:24)) then 
             l=24 
             do while(cb32(l:l).eq.' ') 
              l=l-1 
             end do 
             ncon(i1)(:32)=ca32 
             ncon(i2)(:32)=ca32 
             if(mconcor(i2).eq.i2)print'(a,i4,a,i3,1x,a)',     &
             ' constant ',i1,' correlated with ',i2,cb32(1:l)           
             mconcor(i1)=i2 
             goto 510 
            end if 
           end do 
  510      continue 
          end if 
         end do 
         do k=1,mcl 
                                                            ! 5.5.05    
          mconcor(k)=mconcor(mconcor(k)) 
         end do 
!         do k=1,mcl                                                    
!          write(6,'(a,i3,a,i3,2x,a)')'mconcor(',k,')=',                
!     &                                  mconcor(k),ncon(k)             
!         end do                                                        
!         read(5,'(a)')                                                 
       return 
      END                                           
                                                                        
      subroutine zerosto 
      use compar, only: idumplot
      use compar, only: maxscrs
      implicit none
       integer  in1,idum1
       common/plot/in1(maxscrs),idum1(idumplot) 
       in1=0 
       return 
      END                                           
                                                                        
      subroutine nreplchar(ks,ncharacter) 
      implicit none                                                                            
      character(len=24):: ncharacter,hch
      character(len=8) :: ch8
      character(len=1) :: ch1
      character(len=2) :: ch2
      integer    ks,i0,j,nh

       hch=ncharacter 
       i0=ichar('0') 
                                                                        
         j=ks/10 
         if(ks.lt.10)then 
          ch1=char(ks+i0) 
         else 
          ch2=char(j+i0)//char(ks-10*j+i0) 
         end if 
                                                                        
         ch8=ncharacter(1:2) 
         call c8toi(ch8,nh) 
                                                                        
         if(ch8(1:2).ne.' ') then 
          if(nh.gt.9) then 
           if(ks.le.9) then 
            ncharacter(1:1)=ch1 
            ncharacter(2:)=hch(3:) 
           else 
            ncharacter(1:2)=ch2 
           end if 
          else 
           if(ichar(hch(1:1)).gt.i0+9)then 
            if(ks.gt.9) then 
             ncharacter(1:2)=ch2 
             ncharacter(3:)=hch 
            else 
             ncharacter(1:1)=ch1 
             ncharacter(2:)=hch 
            end if 
           else 
            if(ks.gt.9) then 
             ncharacter(1:2)=ch2 
             ncharacter(3:)=hch(2:) 
            else 
             ncharacter(1:1)=ch1 
             ncharacter(2:)=hch(2:) 
            end if 
           end if 
          end if 
!          write(6,'(a)') ncharacter                                    
!          write(6,'(a,i3,2(3x,a))') ' ks=',ks,ncharacter,hch           
         else 
           if(ks.le.9) then 
            ncharacter(1:1)=ch1 
            ncharacter(2:)=hch 
           else 
            ncharacter(1:2)=ch2 
            ncharacter(3:)=hch 
           end if 
         end if 
         return 
      END                                           
