      subroutine mapspfr(ks) 
      use comeff, only: mcadds,mvadds,contrf
      use comthe, only: vartrf
      use comdas, only: cdata,i_cdata,vdata,i_vdata
      implicit none
      integer  ks,k                                                                 
       do k=1,i_cdata(ks,0) 
        contrf(mcadds(ks,0)+i_cdata(ks,k))=cdata(ks,k) 
       end do 
       do k=1,i_vdata(ks,0) 
        vartrf(mvadds(ks,0)+i_vdata(ks,k))=vdata(ks,k) 
       end do 
      return 
      END                                            
                                                                        
      subroutine mapcopa(jss) 
      use glbconst, only: maxfr1,maxfr2,maxtrf,maxthss,maxprd,         &
                          icstrf,icfr1trf,icfr2trf,icsstrf,            &
                          ivstrf,ivfr1trf,ivfr2trf,ivsstrf,enwr,nwr
      use comeff, only: contrf,ocontrf,nwrf
      use comthe, only: vartrf,ovartrf  
      implicit none 
      real     array_tr 
      integer  jss,inf_tr 
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 
                                                                        
      integer  ifrsto_s,mvpt,mcpt,jvp,ityp,mipt1,mipt2,mipt3,           &
               ksthe,kscp,ksm,iks,numis                                 
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),                       &
                  mipt1(0:maxfr1),mipt2(0:maxfr2),mipt3(0:maxthss),     &
                  ksthe(maxthss*3),kscp(maxthss*3),ksm(0:maxthss*2),    &
                  iks(-1:maxthss),numis(0:maxthss)                           
      real   cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,csstrf,vsstrf
      common/acstrf/ cstrf(icstrf) 
      common/avstrf/ vstrf(ivstrf) 
      common/acfr1trf/ cfr1trf(icfr1trf) 
      common/avfr1trf/ vfr1trf(ivfr1trf) 
      common/acfr2trf/ cfr2trf(icfr2trf) 
      common/avfr2trf/ vfr2trf(ivfr2trf) 
      common/acsstrf/ csstrf(icsstrf) 
      common/avsstrf/ vsstrf(ivsstrf) 
                                                                        
      logical b_cstrf,b_vstrf,b_cfr1trf,  b_vfr1trf,                    &
              b_cfr2trf,b_vfr2trf,b_csstrf,b_vsstrf,                    &
              b_variable,b_cst                                          
      common/bcstrf/ b_cstrf(icstrf) 
      common/bvstrf/ b_vstrf(ivstrf) 
      common/bcfr1trf/ b_cfr1trf(icfr1trf) 
      common/bvfr1trf/ b_vfr1trf(ivfr1trf) 
      common/bcfr2trf/ b_cfr2trf(icfr2trf) 
      common/bvfr2trf/ b_vfr2trf(ivfr2trf) 
      common/bcsstrf/ b_csstrf(icsstrf) 
      common/bvsstrf/ b_vsstrf(ivsstrf) 
      integer i,iss,j,j0,jks,k,kss 
      character(len=10):: fout
      
!---------------     ones for each sp
      fout='(8f10.3)'                                   
      if(nwrf.ne.nwr) fout='(6f12.6)'

      kss=jvp(jss) 
      jks=iks(kss-1) 
!      write(6,'(a,3i6)')' thxx kss,jss,ityp(kss)=',kss,jss,ityp(kss)
      
      inf_tr(3)=mvpt(kss)+kscp(jks+2)+1 
                                                                        
!      write(6,'(a,2i4,a,i4,2(a,2i4))') &                                
!       ' maprout mapcopa:jss, kss=',jss,kss,' itype=',ityp(kss), &      
!       '   kv=',mvpt(kss)+1,mvpt(kss+1), &                              
!       '   kc=',mcpt(kss)+1,mcpt(kss+1)                                
!      write(6,'(a)')'variable'                                         
!      write(6,'(10f10.3)')(vartrf(k),k=1,32)                           
!      write(6,'(a)')'constants'                                        
!      write(6,fout)(contrf(k),k=1,40)                            
                                                                        
      b_variable=.false. 
      b_cst=.false. 
                                                                         
      goto (100,200,300,400) ityp(kss)+1
  100 continue 
!      write(6,'(i5,10f10.3)')1749,(ovartrf(k),k=1749,1754)    
!      write(6,'(i5,10f10.3)')1832,(ovartrf(k),k=1832,1837)    
      iss=0 
      j0=1 
      do k=mvpt(iss)+1,mvpt(iss+1) 
       j0=j0+1 
       vstrf(j0) =vartrf(k) 
       b_vstrf(j0)=vartrf(k).ne.ovartrf(k)
       ovartrf(k)=vartrf(k) 
      end do 
      vstrf(1)=j0 
      do k=3,j0 
       b_variable=b_variable.or.b_vstrf(k) 
      end do 
      b_vstrf(1)=b_variable 
                                                                        
      j=1 
      do k=mcpt(iss)+1,mcpt(iss+1) 
       j=j+1 
       cstrf(j)=contrf(k) 
       b_cstrf(j)=contrf(k).ne.ocontrf(k) 
       b_cst=b_cst.or.b_cstrf(j) 
       ocontrf(k)=contrf(k) 
      end do 
      if(j.eq.1) b_cst=.true.
      cstrf(1)=j 
      b_cstrf(1)=b_cst 
                                                                        
      if(enwr(1)(1:1).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/acstrf/ iss=',jss 
       write(nwrf,fout) (cstrf(i),i=1,j) 
       write(nwrf,'(40l3)') (b_cstrf(i),i=1,j) 
      else if(enwr(2)(1:1).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/avstrf/ iss=',jss 
       write(nwrf,fout) (vstrf(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vstrf(i),i=1,j0) 
      end if 
      goto 500 
!---------------                                                        
                                                                        
  200 continue 
      j0=1 
      do k=mvpt(kss)+1,mvpt(kss+1) 
       j0=j0+1 
       vfr1trf(j0)=vartrf(k) 
       b_vfr1trf(j0)=vartrf(k).ne.ovartrf(k) 
       ovartrf(k)=vartrf(k) 
      end do 
      vfr1trf(1)=j0 
      do k=3,j0 
       b_variable=b_variable.or.b_vfr1trf(k) 
      end do 
       b_vfr1trf(1)=b_variable 
                                                                        
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       cfr1trf(j)=contrf(k) 
       b_cfr1trf(j)=contrf(k).ne.ocontrf(k) 
       b_cst=b_cst.or.b_cfr1trf(j) 
       ocontrf(k)=contrf(k) 
      end do 
      if(j.eq.1) b_cst=.true.
      cfr1trf(1)=j 
      b_cfr1trf(1)=b_cst 
                                                                        
      if(enwr(1)(2:2).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/acfr1trf/ iss=',jss 
       write(nwrf,fout) (cfr1trf(i),i=1,j) 
       write(nwrf,'(40l3)') (b_cfr1trf(i),i=1,j) 
      else if(enwr(2)(2:2).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/avfr1trf/ iss=',jss 
       write(nwrf,fout) (vfr1trf(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vfr1trf(i),i=1,j0) 
!       write(nwrf,'(4(i3,2f10.3,3x))') (i,ovartrf(i),vartrf(i),i=1,80) 
      end if 
!      do k=mvpt(kss)+1,mvpt(kss+1)                                     
!       ovartrf(k)=vartrf(k)                                            
!      end do                                                           
      goto 500 
                                                                        
  300 continue 
      j0=1 
      do k=mvpt(kss)+1,mvpt(kss+1) 
       j0=j0+1 
       vfr2trf(j0)=vartrf(k) 
       b_vfr2trf(j0)=vartrf(k).ne.ovartrf(k) 
       ovartrf(k)=vartrf(k) 
      end do 
      vfr2trf(1)=j0 
      do k=3,j0 
       b_variable=b_variable.or.b_vfr2trf(k) 
      end do 
      b_vfr2trf(1)=b_variable 
                                                                        
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       cfr2trf(j)=contrf(k) 
       b_cfr2trf(j)=contrf(k).ne.ocontrf(k) 
       b_cst=b_cst.or.b_cfr2trf(j) 
       ocontrf(k)=contrf(k) 
      end do 
      if(j.eq.1) b_cst=.true.
      cfr2trf(1)=j 
      b_cfr2trf(1)=b_cst 

      if(enwr(1)(3:3).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/acfr2trf/ iss=',jss 
       write(nwrf,fout) (cfr2trf(i),i=1,j) 
       write(nwrf,'(40l3)') (b_cfr2trf(i),i=1,j) 
      else if(enwr(2)(3:3).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/avfr2trf/ iss=',jss 
       write(nwrf,fout) (vfr2trf(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vfr2trf(i),i=1,j0) 
      end if 
      goto 500 
                                                                        
  400 continue 
      j0=1 
      do k=mvpt(kss)+1,mvpt(kss+1) 
       j0=j0+1 
       vsstrf(j0)=vartrf(k) 
       b_vsstrf(j0)=vartrf(k).ne.ovartrf(k) 
       b_variable=b_variable.or.b_vsstrf(j0) 
       ovartrf(k)=vartrf(k) 
      end do 
      vsstrf(1)=j0 
      b_vsstrf(1)=b_variable 
                                                                        
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       csstrf(j)=contrf(k) 
       b_csstrf(j)=contrf(k).ne.ocontrf(k) 
       b_cst=b_cst.or.b_csstrf(j) 
       ocontrf(k)=contrf(k) 
      end do 
      if(j.eq.1) b_cst=.true.
      csstrf(1)=j 
      b_csstrf(1)=b_cst 

      if(enwr(1)(4:4).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/acsstrf/ iss=',jss 
       write(nwrf,fout) (csstrf(i),i=1,j) 
       write(nwrf,'(40l3)') (b_csstrf(i),i=1,j) 
      else if(enwr(2)(4:4).eq.'y') then 
       write(nwrf,'(a,i4)') 'common/avsstrf/ iss=',jss 
       write(nwrf,fout) (vsstrf(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vsstrf(i),i=1,j0) 
      end if 
  500 continue 
                                                                        
      return 
      END                                           
                                                                        
      subroutine mapglobal 
      use glbconst, only: maxfr1,maxfr2,maxthss,icstrf,ivstrf
      use comeff, only: contrf                                                                        
      use comthe, only: vartrf      
      implicit none                                                        
      integer  ifrsto_s,mvpt,mcpt,jvp,ityp,idum,j,j0,iss,k 
      integer,parameter:: numsmpt=7+11*maxthss+maxfr2+maxfr1 
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),idum(numsmpt)               

      real   cstrf,vstrf
      common/acstrf/ cstrf(icstrf) 
      common/avstrf/ vstrf(ivstrf) 
                                                                        
      j0=1 
      iss=0 
      do k=mvpt(iss)+1,mvpt(iss+1) 
       j0=j0+1 
       vstrf(j0) =vartrf(k) 
      end do 
      vstrf(1)=j0 
      j=1 
      do k=mcpt(iss)+1,mcpt(iss+1) 
       j=j+1 
       cstrf(j)=contrf(k) 
      end do 
      cstrf(1)=j 
                                                                        
      return 
      END                                           
                                                                        
      subroutine mapcp(isubthe,b_pr) 
      use glbconst, only: maxfr1,maxfr2,maxthss,maxthlv,               &
                          icstrf,icfr1trf,icfr2trf,icsstrf,            &
                          ivstrf,ivfr1trf,ivfr2trf,ivsstrf,enwr,nwr
      use comfrm, only: nthpl,ncon,mcl,mpl,ivadd,icadd
      use comdas, only: ivdata,nvdata,icdata,ncdata
      use comdat, only: cdatas,vdatas
      use comeff, only: nwrf
      implicit none                                                                          
      logical b_pr 
      integer isubthe,kssthe,ksscp,kssm,ntheo,icase 
      common/msgtss/jss,kssthe(0:maxthlv),ksscp(0:2*maxthlv),           &
                     kssm(maxthlv)                                      
                                                                        
      integer     ifrsto_s,mvpt,mcpt,jvp,ityp,mipt1,mipt2,mipt3,        &
                  ksthe,kscp,ksm,iks,numis                                 
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),                       &
                  mipt1(0:maxfr1),mipt2(0:maxfr2),mipt3(0:maxthss),     &
                  ksthe(maxthss*3),kscp(maxthss*3),ksm(0:maxthss*2),    &
                  iks(-1:maxthss),numis(0:maxthss)                           
                                                                        
      real   cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,csstrf,vsstrf
      common/acstrf/ cstrf(icstrf) 
      common/avstrf/ vstrf(ivstrf) 
      common/acfr1trf/ cfr1trf(icfr1trf) 
      common/avfr1trf/ vfr1trf(ivfr1trf) 
      common/acfr2trf/ cfr2trf(icfr2trf) 
      common/avfr2trf/ vfr2trf(ivfr2trf) 
      common/acsstrf/ csstrf(icsstrf) 
      common/avsstrf/ vsstrf(ivsstrf) 
                                                                        
      logical b_cstrf,b_vstrf,b_cfr1trf,  b_vfr1trf,                    &
              b_cfr2trf,b_vfr2trf,b_csstrf,b_vsstrf,                    &
              b_variable,b_cst                                          
      common/bcstrf/ b_cstrf(icstrf) 
      common/bvstrf/ b_vstrf(ivstrf) 
      common/bcfr1trf/ b_cfr1trf(icfr1trf) 
      common/bvfr1trf/ b_vfr1trf(ivfr1trf) 
      common/bcfr2trf/ b_cfr2trf(icfr2trf) 
      common/bvfr2trf/ b_vfr2trf(ivfr2trf) 
      common/bcsstrf/ b_csstrf(icsstrf) 
      common/bvsstrf/ b_vsstrf(ivsstrf) 
                                                                        
!     kss is defined in the main routine (i.e. mossbau) where the       
!     loops over all levels are executed                                
!                                                                       
      real          cmapsub,vmapsub 
      common/acmaps/cmapsub(icstrf) 
      common/avmaps/vmapsub(ivstrf) 
      logical       b_cmapsub,b_vmapsub 
      common/bcmaps/b_cmapsub(icstrf) 
      common/bvmaps/b_vmapsub(ivstrf) 
      character(len=40):: c40,ch40
      character(len=20):: c20
      character(len=8) :: ch8
      character(len=10):: fout                                                                
      integer   i,ith,j,j0,jss,k,kss,l,lp

      fout='(8f10.3)'                                   
      if(nwrf.ne.nwr) fout='(6f12.6)'
                                                                  
      ntheo=kssthe(2*isubthe-1) 
      icase=kssthe(2*isubthe) 
                                                                        
      kss=jvp(jss) 
      ith=isubthe*2-1 
!      write(6,'(a,6i4)')'mapcp isubthe,ith,kssthe(0)=',                
!     &                isubthe,ith,kssthe(0)                            
!       write(6,'(a,6i4)')'c (j1,j2)=',ksscp(ith)+2,ksscp(ith+2)+1      
      if(ith.lt.1.or.kssthe(0).lt.ith) return 
!      write(6,'(4(a,2i4))')                                            
!     & ' maprout mapcp: jss,kss=',jss,kss,' itype=',ityp(kss)          
!     & '   ith=',ith,'   jks=',jks                                     
!       write(6,'(a,i2,4x,6i4)')'c (j1,j2) p(k1,k2)=',ityp(kss)+1,      
!     &    ksscp(ith)+2,ksscp(ith+2)+1,ksscp(ith+1)+2,ksscp(ith+3)+1    
                                                                        
      b_variable=.false. 
      b_cst=.false. 
                                                                        
      goto (100,200,300,400) ityp(kss)+1 
  100 continue 
      j0=1 
      do k=ksscp(ith+1)+2,ksscp(ith+3)+1 
       j0=j0+1 
       vmapsub(j0) =vstrf(k) 
       b_vmapsub(j0)=b_vstrf(k) 
       b_variable=b_variable.or.b_vmapsub(j0) 
      end do 
      vmapsub(1)=j0 
      do k=j0+1,int(vstrf(1)) 
       b_variable=b_variable.or.b_vstrf(k) 
      end do 
      b_vmapsub(1)=b_variable 
                                                                        
      j=1 
      do k=ksscp(ith)+2,ksscp(ith+2)+1 
       j=j+1 
       cmapsub(j) =cstrf(k) 
!      write(6,'(l5,a,i3,2x,f12.3)')b_pr,' 100:',j,cmapsub(j)          
       b_cmapsub(j)=b_cstrf(k) 
       b_cst=b_cst.or.b_cmapsub(j) 
      end do 
      if(j.eq.1) b_cst=.true.                 ! 24.10.2014 
      cmapsub(1)=j 
      b_cmapsub(1)=b_cst 
                                                                        
      if(enwr(4)(1:1).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
             'common/acstrf/'//'->/acmaps/... iss=',kss                 
       write(nwrf,fout) (cmapsub(i),i=1,j) 
       write(nwrf,'(40l3)') (b_cmapsub(i),i=1,j) 
      end if 
      if(enwr(5)(1:1).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
             'common/avstrf/'//'->/avmaps/... iss=',kss                 
       write(nwrf,fout) (vmapsub(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vmapsub(i),i=1,j0) 
      end if 
      goto 500 
!---------------                                                        
                                                                        
  200 continue 
      j0=1 
      do k=ksscp(ith+1)+2,ksscp(ith+3)+1 
       j0=j0+1 
!       write(6,'(i4,2x,f10.3)')k, vfr1trf(k)                           
       vmapsub(j0) =vfr1trf(k) 
       b_vmapsub(j0)=b_vfr1trf(k) 
       b_variable=b_variable.or.b_vmapsub(j0) 
      end do 
      vmapsub(1)=j0 
      do k=j0+1,int(vfr1trf(1)) 
       b_variable=b_variable.or.b_vfr1trf(k) 
      end do 
      b_vmapsub(1)=b_variable 
                                                                        
      j=1 
      do k=ksscp(ith)+2,ksscp(ith+2)+1 
       j=j+1 
       cmapsub(j) =cfr1trf(k) 
!       write(6,'(l5,a,i3,2x,f12.3)')b_pr,' 200:',j,cmapsub(j)          
       b_cmapsub(j)=b_cfr1trf(k) 
       b_cst=b_cst.or.b_cfr1trf(k) 
      end do 
      if(j.eq.1) b_cst=.true.
      cmapsub(1)=j 
      b_cmapsub(1)=b_cst 
                                                                        
      if(enwr(4)(2:2).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
            'common/acfr1trf/'//'->/acmaps/... iss=',kss               
       write(nwrf,fout) (cmapsub(i),i=1,j) 
       write(nwrf,'(40l3)') (b_cmapsub(i),i=1,j) 
      end if 
      if(enwr(5)(2:2).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
             'common/avfr1trf/'//'->/avmaps/... iss=',kss               
       write(nwrf,fout) (vmapsub(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vmapsub(i),i=1,j0) 
      end if 
      goto 500 
                                                                        
  300 continue 
!      enwr(5)='nnyn'                                                   
!       write(6,'(a,2i4)')'v-ksscp(ith+1)+2,ksscp(ith+3)+1=',           
!     &    ksscp(ith+1)+2,ksscp(ith+3)+1                                
      j0=1 
      do k=ksscp(ith+1)+2,ksscp(ith+3)+1 
       j0=j0+1 
       vmapsub(j0) =vfr2trf(k) 
       b_vmapsub(j0)=b_vfr2trf(k) 
       b_variable=b_variable.or.b_vmapsub(j0) 
      end do 
      vmapsub(1)=j0 
      do k=j0+1,int(vfr2trf(1)) 
       b_variable=b_variable.or.b_vfr2trf(k) 
      end do 
      b_vmapsub(1)=b_variable 
                                                                        
      j=1 
      do k=ksscp(ith)+2,ksscp(ith+2)+1 
       j=j+1 
       cmapsub(j) =cfr2trf(k) 
!       write(6,'(l5,a,i3,2x,f12.3)')b_pr,' 300:',j,cmapsub(j)          
       b_cmapsub(j)=b_cfr2trf(k) 
       b_cst=b_cst.or.b_cfr2trf(k) 
      end do 
      if(j.eq.1) b_cst=.true.
      cmapsub(1)=j 
      b_cmapsub(1)=b_cst 
                                                                        
      if(enwr(4)(3:3).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
             'common/acfr2trf/'//'->/acmaps/... iss=',kss               
       write(nwrf,fout) (cmapsub(i),i=1,j) 
       write(nwrf,'(40l3)') (b_cmapsub(i),i=1,j) 
      end if 
      if(enwr(5)(3:3).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
             'common/avfr2trf/'//'->/avmaps/... iss=',kss               
       write(nwrf,fout) (vmapsub(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vmapsub(i),i=1,j0) 
      end if 
      goto 500 
                                                                        
  400 continue 
      j0=1 
      do k=ksscp(ith+1)+2,ksscp(ith+3)+1 
       j0=j0+1 
       vmapsub(j0) =vsstrf(k) 
       b_vmapsub(j0)=b_vsstrf(k) 
       b_variable=b_variable.or.b_vmapsub(j0) 
      end do 
      vmapsub(1)=j0 
      do k=j0+1,int(vsstrf(1)) 
       b_variable=b_variable.or.b_vsstrf(k) 
      end do 
      b_vmapsub(1)=b_variable 
                                                                        
!      write(6,'(a,2i3)')'j0,vsstrf(1)=',j0,int(vsstrf(1))              
                                                                        
      j=1 
      do k=ksscp(ith)+2,ksscp(ith+2)+1 
       j=j+1 
       cmapsub(j) =csstrf(k) 
       b_cmapsub(j)=b_csstrf(k) 
       b_cst=b_cst.or.b_csstrf(k) 
      end do
      if(j.eq.1) b_cst=.true.
      cmapsub(1)=j 
      b_cmapsub(1)=b_cst 
                                                                        
      if(enwr(4)(4:4).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
             'common/acsstrf/'//'->/acmaps/... iss=',kss                
       write(nwrf,fout) (cmapsub(i),i=1,j) 
       write(nwrf,'(40l3)') (b_cmapsub(i),i=1,j) 
      end if

      if(enwr(5)(4:4).eq.'y') then 
       write(nwrf,'(a,i4)')                                             &
             'common/avsstrf/'//'->/avmaps/... iss=',kss                
       write(nwrf,fout) (vmapsub(i),i=1,j0) 
       write(nwrf,'(40l3)') (b_vmapsub(i),i=1,j0) 
      end if 
  500 continue 
                                                                        
      if(b_pr)then 
       if(enwr(3)(4:4).eq.'y') then 
        write(nwrf,'(a,i3,a,i2,a,i1)')'common/avmaps/',j0-1,            &
            ' variables         theo=',ntheo,' case=',icase             
        lp=0 
        do k=mvpt(kss)+ksscp(ith+1)+1,mvpt(kss)+ksscp(ith+3) 
         lp=lp+1 
         l=1 
         do l=1,ivdata(0) 
          if(k.eq.ivdata(l))then 
           ch40=nvdata(l) 
           ch8=ch40(25:26)//'str'//ch40(27:28) 
           c40=ch40(1:24)//ch8//' ca'//ch40(29:30) 
           if(ch40(33:33).eq.'i') then 
            c20='(i4,2x,a,5x,'//ch40(33:36) 
            write(nwrf,c20)lp,c40,int(vdatas(l)) 
           else 
            c20='(i4,2x,a,5x,'//ch40(33:38) 
            write(nwrf,c20)lp,c40,vdatas(l) 
           end if 
          end if 
         end do 
                                                                        
                                                       ! 8.2.06 unsave  
         do while(ivadd(l).ne.k.and.l.le.mpl) 
          l=l+1 
         end do 
         if(l.le.mpl) then 
          ch8=nthpl(l)(25:26)//'str'//nthpl(l)(27:28) 
          c40=nthpl(l)(1:24)//ch8//' ca'//nthpl(l)(29:30) 
          c20='(i4,2x,a,g12.2)' 
          write(nwrf,c20)lp,c40,vmapsub(lp+1) 
         end if 
        end do 
                                                                        
        write(nwrf,'(a,i3,a,i2,a,i1)')'common/acmaps/',j-1,             &
            ' constants         theo=',ntheo,' case=',icase             
        lp=0 
        do k=mcpt(kss)+ksscp(ith)+1,mcpt(kss)+ksscp(ith+2) 
         lp=lp+1 
                                                                        
         do l=1,icdata(0) 
          if(k.eq.icdata(l))then 
           ch40=ncdata(l) 
           ch8=ch40(25:26)//'str'//ch40(27:28) 
           c40=ch40(1:24)//ch8//' ca'//ch40(29:30) 
           if(ch40(33:33).eq.'i') then 
            c20='(i4,2x,a,5x,'//ch40(33:36) 
            write(nwrf,c20)lp,c40,int(cdatas(l)) 
           else 
            c20='(i4,2x,a,5x,'//ch40(33:38) 
            write(nwrf,c20)lp,c40,cdatas(l) 
           end if 
          end if 
         end do 
                                                                        
         l=1 
         do while(icadd(l).ne.k.and.l.le.mcl) ! 8.2.06 unsave
          l=l+1 
         end do 
                                                                        
         if(l.le.mcl) then 
          if(ncon(l)(25:26).eq.'hb') then 
           ch8=' hdbk'//ncon(l)(27:28) 
          else 
           ch8=ncon(l)(25:26)//'str'//ncon(l)(27:28) 
          end if 
          c40=ncon(l)(1:24)//ch8//' ca'//ncon(l)(29:30) 
          if(ncon(l)(33:33).eq.'i') then 
           c20='(i4,2x,a,5x,'//ncon(l)(33:36) 
           write(nwrf,c20)lp,c40,int(cmapsub(lp+1)) 
          else 
           c20='(i4,2x,a,5x,'//ncon(l)(33:38) 
           write(nwrf,c20)lp,c40,cmapsub(lp+1) 
          end if 
         end if 
        end do 
       end if 
      end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine mapfr0 
      use glbconst, only: maxfr1,maxfr2,maxthss,icstrf
      use comeff, only: contrf
      implicit none 
      integer  ifrsto_s,mvpt,mcpt,jvp,ityp,idum,kss,j,k 
      integer,parameter:: numsmpt=7+11*maxthss+maxfr2+maxfr1
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),idum(numsmpt)               
      real   cstrf 
      common/acstrf/ cstrf(icstrf) 
                                                                        
      kss=jvp(0) 
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       cstrf(j)=contrf(k) 
      end do 
      cstrf(1)=j 
                                                                        
      return 
      END                                           

      subroutine mapfr(jss) 
      use glbconst, only: maxfr1,maxfr2,maxthss,                       &
                          icstrf,icfr1trf,icfr2trf,icsstrf,            &
                          ivstrf,ivfr1trf,ivfr2trf,ivsstrf,enwr
      use comfrm, only: nthpl,ncon,mcl,mpl,ivadd,icadd
      use comdas, only: ivdata,nvdata,icdata,ncdata
      use comdat, only: cdatas,vdatas
      use comeff, only: contrf,nwrf 
      use comthe, only: vartrf                                                                          
      implicit none                                                                          
      integer    jss,ifrsto_s,mvpt,mcpt,jvp,ityp,idum,cl 
      integer,parameter :: numsmpt=7+11*maxthss+maxfr2+maxfr1 
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),idum(numsmpt)               
      real   cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,csstrf,vsstrf
      common/acstrf/ cstrf(icstrf) 
      common/avstrf/ vstrf(ivstrf) 
      common/acfr1trf/ cfr1trf(icfr1trf) 
      common/avfr1trf/ vfr1trf(ivfr1trf) 
      common/acfr2trf/ cfr2trf(icfr2trf) 
      common/avfr2trf/ vfr2trf(ivfr2trf) 
      common/acsstrf/ csstrf(icsstrf) 
      common/avsstrf/ vsstrf(ivsstrf) 
      logical b_cstrf,b_vstrf,b_cfr1trf,b_vfr1trf,                      &
              b_cfr2trf,b_vfr2trf,b_csstrf,b_vsstrf                     
      common/bcstrf/ b_cstrf(icstrf) 
      common/bvstrf/ b_vstrf(ivstrf) 
      common/bcfr1trf/ b_cfr1trf(icfr1trf) 
      common/bvfr1trf/ b_vfr1trf(ivfr1trf) 
      common/bcfr2trf/ b_cfr2trf(icfr2trf) 
      common/bvfr2trf/ b_vfr2trf(ivfr2trf) 
      common/bcsstrf/ b_csstrf(icsstrf) 
      common/bvsstrf/ b_vsstrf(ivsstrf) 
      character(len=40):: c40,ch40
      character(len=20):: c20
      character(len=8) :: ch8,cname

      integer  kss,itypes,j,j0,k,l,lp
                                                                
      kss=jvp(jss) 
      itypes=ityp(kss) 
!      write(6,'(2(a,i4),/,2(a,2i4))')                                  
!      write(6,'(2(a,i4))')                                             
!     & ' kss=',kss,' itype=',itypes,                                   
!     & '   kv=',mvpt(kss)+1,mvpt(kss+1),                               
!     & '   kc=',mcpt(kss)+1,mcpt(kss+1)                                
                                                                        
      goto (100,200,300,400) ityp(kss)+1 
  100 continue 
      j0=1 
      do k=mvpt(kss)+1,mvpt(kss+1) 
       j0=j0+1 
       vstrf(j0) =vartrf(k) 
       b_vstrf(j0) =.false. 
      end do 
      b_vstrf(1) =.false. 
      vstrf(1)=j0 
                                                                        
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       cstrf(j)=contrf(k) 
      end do 
       b_cstrf(1) =.false. 
      cstrf(1)=j 
                                                                        
      cname='strf/:' 
      cl=6 
      goto 500 
                                                                        
  200 continue 
      j0=1 
      do k=mvpt(kss)+1,mvpt(kss+1) 
       j0=j0+1 
       vfr1trf(j0)=vartrf(k) 
       b_vfr1trf(j0) =.false. 
      end do 
      b_vfr1trf(1) =.false. 
      vfr1trf(1)=j0 
                                                                        
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       cfr1trf(j)=contrf(k) 
       b_cfr1trf(j) =.false. 
      end do 
      b_cfr1trf(1) =.false. 
      cfr1trf(1)=j 
                                                                        
      cname='fr1trf/:' 
      cl=8 
      goto 500 
                                                                        
  300 continue 
      j0=1 
      do k=mvpt(kss)+1,mvpt(kss+1) 
       j0=j0+1 
       vfr2trf(j0)=vartrf(k) 
       b_vfr2trf(j0) =.false. 
      end do 
      b_vfr2trf(1) =.false. 
      vfr2trf(1)=j0 
                                                                        
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       cfr2trf(j)=contrf(k) 
       b_cfr2trf(j) =.false. 
      end do 
      b_cfr2trf(1) =.false. 
      cfr2trf(1)=j 
                                                                        
      cname='fr2trf/:' 
      cl=8 
      goto 500 
                                                                        
  400 continue 
      j0=1 
      do k=mvpt(kss)+1,mvpt(kss+1) 
       j0=j0+1 
       vsstrf(j0)=vartrf(k) 
       b_vsstrf(j0)=.false. 
      end do 
      vsstrf(1)=j0 
      b_vsstrf(1)=.false. 
                                                                        
      j=1 
      do k=mcpt(kss)+1,mcpt(kss+1) 
       j=j+1 
       csstrf(j)=contrf(k) 
       b_csstrf(j)=.false. 
      end do 
      b_csstrf(1)=.false. 
      csstrf(1)=j 
                                                                        
      cname='sstrf/:' 
      cl=7 
                                                                        
  500 continue 
                                                                        
      if(enwr(3)(4:4).eq.'y') then 
                                                                        
       if(ityp(kss).eq.0) then 
       write(nwrf,'(a)')' for help see: {he st} /common blocks' 
       write(nwrf,'(a,i3,a)')'common/av'//cname(:cl),j0-1,' variables' 
       else 
       write(nwrf,'(a,i3,a)')'common/av'//cname(:cl),j0-1,' variables' 
       end if 
       lp=0 
       do k=mvpt(kss)+1,mvpt(kss+1) 
        lp=lp+1 
        do l=1,ivdata(0) 
         if(k.eq.ivdata(l))then 
          ch40=nvdata(l) 
          ch8=ch40(25:26)//'str'//ch40(27:28) 
          c40=ch40(1:24)//ch8//' ca'//ch40(29:30) 
          if(ch40(33:33).eq.'i') then 
           c20='(i4,2x,a,5x,'//ch40(33:36) 
           write(nwrf,c20)lp,c40,int(vdatas(l)) 
          else 
           c20='(i4,2x,a,5x,'//ch40(33:38) 
           write(nwrf,c20)lp,c40,vdatas(l) 
          end if 
         end if 
        end do 
                                                                        
        l=1 
                                                       ! 8.2.06 unsave  
        do while(ivadd(l).ne.k.and.l.le.mpl) 
         l=l+1 
        end do 
        if(l.le.mpl) then 
          ch8=nthpl(l)(25:26)//'str'//nthpl(l)(27:28) 
          c40=nthpl(l)(1:24)//ch8//' ca'//nthpl(l)(29:30) 
          c20='(i4,2x,a,g12.2)' 
          write(nwrf,c20)lp,c40,vartrf(k) 
         end if 
       end do 
                                                                        
       write(nwrf,'(a,i3,a)')'common/ac'//cname(:cl),j-1,' constants' 
       lp=0 
       do k=mcpt(kss)+1,mcpt(kss+1) 
        lp=lp+1 
        do l=1,icdata(0) 
         if(k.eq.icdata(l))then 
          ch40=ncdata(l) 
          ch8=ch40(25:26)//'str'//ch40(27:28) 
          c40=ch40(1:24)//ch8//' ca'//ch40(29:30) 
          if(ch40(33:33).eq.'i') then 
           c20='(i4,2x,a,5x,'//ch40(33:36) 
           write(nwrf,c20)lp,c40,int(cdatas(l)) 
          else 
           c20='(i4,2x,a,5x,'//ch40(33:38) 
           write(nwrf,c20)lp,c40,cdatas(l) 
          end if 
         end if 
        end do 
                                                                        
        l=1 
                                                        ! 8.2.06 unsave 
        do while(icadd(l).ne.k.and.l.le.mcl) 
         l=l+1 
        end do 
        if(l.le.mcl) then 
          if(ncon(l)(25:26).eq.'hb') then 
           ch8=' hdbk'//ncon(l)(27:28) 
          else 
           ch8=ncon(l)(25:26)//'str'//ncon(l)(27:28) 
          end if 
          c40=ncon(l)(1:24)//ch8//' ca'//ncon(l)(29:30) 
          if(ncon(l)(33:33).eq.'i') then 
           c20='(i4,2x,a,5x,'//ncon(l)(33:36) 
           write(nwrf,c20)lp,c40,int(contrf(k)) 
          else 
           c20='(i4,2x,a,5x,'//ncon(l)(33:38) 
           write(nwrf,c20)lp,c40,contrf(k) 
          end if 
         end if 
       end do 
      end if 
      return 
      END                                           

      subroutine replace_wi(i,pwi,info) 
      use glbconst, only: maxfr1,maxfr2,maxthss,infotext
      use comthe, only: vartrf                                                                       
      implicit none  

      real pwi 
      integer i,info,                                             &
              ifrsto_s,mvpt,mcpt,jvp,ityp,mipt1,mipt2,mipt3,          &
              idum,ip,j,mipt                                              

      integer,parameter :: numsmpt=4+10*maxthss 
      common/smpt/ifrsto_s,mvpt(0:maxthss),mcpt(0:maxthss),             &
                  jvp(0:maxthss),ityp(0:maxthss),                       &
                  mipt1(0:maxfr1),mipt2(0:maxfr2),mipt3(0:maxthss),     &
                  idum(numsmpt)                                           
                                             ! 20.08.07                 
      mipt=0 
      if(abs(pwi).ge.0) then 
       ip=abs(i) 
       j=4 
       do while(ip.gt.0) 
        ip=ip-maxthss 
        j=j-1 
       end do 
       ip=ip+maxthss 
!       write(6,'(a,20i4)') 'replace_wi i,ip,j=',i,ip,j,                
!     &         mipt1(0),mipt2(0),(mipt3(jj),jj=0,3)                    
       if(j.eq.3) then 
         mipt=mipt3(ip) 
       else if(j.eq.2) then 
         mipt=mipt2(ip) 
       else if(j.eq.1) then 
         mipt=mipt1(ip) 
       end if 
       if(mipt.le.0) then 
        info=1 
        infotext(1)='effi/subspectra/structure' 
        infotext(2)='**error** wrong structure of subspectra' 
        infotext(3)='very likely a session file of another set' 
        infotext(4)=' ' 
        goto 100 
       end if 
       if(i.lt.0) then 
         pwi=vartrf(mipt) 
       else 
!       write(6,'(a,i6,f10.3)') 'replace_wi mipt,pwi=',mipt,pwi         
        vartrf(mipt)=pwi 
       end if 
      else 
       j=i 
       if(j.eq.3) then 
         i=mipt3(0) 
       else if(j.eq.2) then 
         i=mipt2(0) 
       else if(j.eq.1) then 
         i=mipt1(0) 
       end if 
                                                                        
      end if 
  100 continue 
      return 
      END                                           

      subroutine zerotrfarr 
      use glbconst, only: maxfr1,maxfr2,maxthss,                       &
                          icstrf,icfr1trf,icfr2trf,icsstrf,            &
                          ivstrf,ivfr1trf,ivfr2trf,ivsstrf
      use compar, only:   
      implicit none  
      integer idum,k
      integer,parameter :: numsmpt=12+15*maxthss+maxfr2+maxfr1 
      common/smpt/idum(numsmpt) 

      real cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,csstrf,vsstrf
      common/acstrf/ cstrf(icstrf) 
      common/avstrf/ vstrf(ivstrf) 
      common/acfr1trf/ cfr1trf(icfr1trf) 
      common/avfr1trf/ vfr1trf(ivfr1trf) 
      common/acfr2trf/ cfr2trf(icfr2trf) 
      common/avfr2trf/ vfr2trf(ivfr2trf) 
      common/acsstrf/ csstrf(icsstrf) 
      common/avsstrf/ vsstrf(ivsstrf) 
      real   cmapsub,fill                                                                      
      common/acmaps/cmapsub(icstrf) 
                                                                        
      fill=8888.88 
      do k=1,numsmpt 
        idum(k)=0 
      end do 
      do k=1,icstrf 
       cstrf(k)=fill 
      end do 
                                                                        
      do k=1,ivstrf 
       vstrf(k)=fill 
      end do 
      do k=1,icfr1trf 
       cfr1trf(k)=fill 
      end do 
      do k=1,icfr2trf 
       cfr2trf(k)=fill 
      end do 
      do k=1,icsstrf 
       csstrf(k)=fill 
      end do 
                                                                        
      do k=1,ivsstrf 
       vsstrf(k)=fill 
      end do 
                                                                        
      do k=1,icstrf 
       cmapsub(k)=fill 
      end do 
      return 
      END                                           

      subroutine l_structure(jss,l1,l2,l3) 
      use comeff, only: chiss                                                                        
      implicit none  
                                                                        
      integer  jss,l1,l2,l3,i0 
      i0=ichar('0') 
                                                                        
      l1=ichar(chiss(jss)(1:1))-i0 
      l2=ichar(chiss(jss)(2:2))-i0 
      l3=ichar(chiss(jss)(3:3))-i0 
                                                                        
      return 
      END                                           

      integer function iss_structure(ls1,ls2,ls3) 
      use comeff, only: chiss                                                                        
      implicit none  
      integer  ls1,ls2,ls3,iss,i0 
      character(len=4):: ch4 
                                                                        
      i0=ichar('0') 
      ch4=char(ls1+i0)//char(ls2+i0)//char(ls3+i0) 
      iss=0 
      do while(ch4(1:3).ne.chiss(iss)(1:3)) 
       iss=iss+1 
      end do 
      iss_structure=iss 
      return 
      END                                           
                                                                        
     subroutine structure_ks(ks,                                       &
                  mstruct1,numstr1,mstruct2,numstr2,mstruct3,numss)     
      use glbconst, only: maxfr1,maxfr2,maxthss
      use comdas, only: ktheo,istrss                                                                  
      implicit none                                                                         

      integer   ks,mstruct1,numstr1,mstruct2,numstr2,mstruct3,numss,    &
                k,iset,istruct1,istruct2,kststr,mssv,                   &
                lstruct1,lstruct2,itype,kvp,kpv
      dimension kvp(0:maxthss),kpv(0:maxthss),itype(0:maxthss),         &
                istruct1(0:maxfr1),istruct2(0:maxfr2),                  &
                kststr(maxthss),                                        &
                numstr1(maxfr1),numstr2(maxfr2),numss(maxthss)          
                                                                        
                                                                        
       if(ktheo(ks,0,0).eq.0) then 
        ks=-1 
        return 
       end if 
                                                                        
       do k=1,maxthss 
        kststr(k)=istrss(ks,k) 
       end do 
                                                                        
       call strkvp(kststr,kvp,kpv,itype,mstruct1,istruct1,istruct2) 
                                                                        
       mssv=0 
       mstruct2=0 
       mstruct3=0 
!---------------------------------                                      
!      calculation from globals                                         
       mssv=1 
!--------------------------                                             
!      calculation of fr1                                               
       do lstruct1=1,mstruct1 
        numstr1(lstruct1)=kvp(mssv) 
        mssv=mssv+1 
!--------------------                                                   
!       calculation of fr2                                              
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
         numstr2(lstruct2)=kvp(mssv) 
         mssv=mssv+1 
         mstruct2=mstruct2+1 
!--------------------------                                             
!        calculation of sites                                           
         do iset=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
          numss(iset)=mssv 
          mssv=mssv+1 
          mstruct3=mstruct3+1 
         end do 
        end do 
       end do 
!      write(6,'(a,10i4)') ' kvp=',(kvp(i),i=1,mssv)                    
!      write(6,'(a,10i4)') ' kpv=',(kpv(i),i=1,mssv)                    
!      write(6,'(a,10i4)') ' numstr0=',kvp(0)                           
!      write(6,'(a,10i4)') ' numstr1=',(numstr1(i),i=1,mstruct1)        
!      write(6,'(a,10i4)') ' numstr2=',(numstr2(i),i=1,mstruct2)        
!       write(6,'(a,10i4)') ' numss=',(numss(i),i=1,mstruct3)           
                                                                        
       return 
      END                                           

      subroutine strkvp(kststr,kvp,kpv,itype,                           &
                       mstruct1,istruct1,istruct2)                      
      use glbconst, only: maxfr1,maxfr2,maxthss
      implicit none
      integer  mstruct1
      integer, intent(in),  dimension(maxthss)  :: kststr
      integer, intent(out), dimension(0:maxthss):: kvp,kpv,itype
      integer, intent(out), dimension(0:maxfr1) :: istruct1       
      integer, intent(out), dimension(0:maxfr2) :: istruct2 
                                                                        
      integer  k,lstruct1,lstruct2,lstruct3,lst1,lst2,lst3,iss,istr,    &
               mss,mssv,issv,kss,ls,mstruct2,mstruct3 
 
      integer, dimension(:,:,:), allocatable :: levelstr
     
      allocate(levelstr(maxfr1,0:maxfr2,0:maxthss)) 
                                                                
      do k=0,maxfr1 
        istruct1(k)=0 
      end do 
      do k=0,maxfr2 
        istruct2(k)=0 
      end do 
                                                                        
      lstruct1=0 
      lstruct2=0 
      mstruct1=0 
      mstruct2=0 
      mstruct3=0 
      lst1=0 
      lst2=0 
      lst3=0 
      do iss=1,maxthss 
       istr=kststr(iss) 
       if(istr.ne.0) then 
        mss=iss 
        lstruct3=0 
        if(istr.lt.0) then 
         if(abs(istr).gt.100) then 
          lstruct1=-istr/100 
          lstruct2=-istr-100*lstruct1 
         else 
          lstruct1=-istr/10 
          lstruct2=-istr-10*lstruct1 
         end if 
        else 
         lstruct3=istr 
        end if 
        if(lstruct1.gt.lst1) lst1=lstruct1 
        if(lstruct1.le.maxfr1.and.lstruct2.le.maxfr2) then 
         if(lstruct1.gt.mstruct1) mstruct1=lstruct1 
         if(lstruct2.gt.mstruct2) mstruct2=lstruct2 
         if(lstruct3.gt.mstruct3) mstruct3=lstruct3 
         levelstr(lstruct1,lstruct2,lstruct3)=iss 
         if(lstruct2.ge.lst2) lst2=lstruct2 
         istruct1(lstruct1)=lst2 
         if(lstruct3.ge.lst3) lst3=lstruct3 
         if(lstruct2.gt.0) istruct2(lstruct2)=lst3 
        end if 
       end if 
      end do 
                                                                        
                                                                        
                                                                        
!     frame theory                                                      
      kpv(0)=0 
      kpv(1)=1 
      itype(0)=0 
      mssv=1 
      do lstruct1=1,mstruct1 
        kpv(mssv)=levelstr(lstruct1,0,0) 
        itype(mssv)=1 
        mssv=mssv+1 
      end do 
                                                                        
      do lstruct1=1,mstruct1 
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
        kpv(mssv)=levelstr(lstruct1,lstruct2,0) 
        itype(mssv)=2 
        mssv=mssv+1 
        do ls=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
         kpv(mssv)=levelstr(lstruct1,lstruct2,ls) 
         itype(mssv)=3 
         mssv=mssv+1 
        end do 
       end do 
      end do 
      kss=mssv-1 
                                                                        
      do issv=0,kss 
      do iss=0,kss 
       if(kpv(issv).eq.iss) kvp(iss)=issv 
      end do 
      end do 
      deallocate(levelstr)

!       write(6,'(a,10i4)') 'strkvp kvp=',(kvp(i),i=0,kss)              
!       write(6,'(a,10i4)') 'strkvp kpv=',(kpv(i),i=0,kss)              
!       write(6,'(a,10i4)') 'itype(0..)=',(itype(i),i=0,kss)            
      return 

    END subroutine strkvp


    subroutine maptrue 
      use glbconst, only: icstrf,icfr1trf,icfr2trf,icsstrf,            &
                          ivstrf,ivfr1trf,ivfr2trf,ivsstrf
      implicit none 
      logical b_cstrf,b_vstrf,b_cfr1trf,  b_vfr1trf,                    &
              b_cfr2trf,b_vfr2trf,b_csstrf,b_vsstrf                                    
      common/bcstrf/ b_cstrf(icstrf) 
      common/bvstrf/ b_vstrf(ivstrf) 
      common/bcfr1trf/ b_cfr1trf(icfr1trf) 
      common/bvfr1trf/ b_vfr1trf(ivfr1trf) 
      common/bcfr2trf/ b_cfr2trf(icfr2trf) 
      common/bvfr2trf/ b_vfr2trf(ivfr2trf) 
      common/bcsstrf/ b_csstrf(icsstrf) 
      common/bvsstrf/ b_vsstrf(ivsstrf) 
      logical       b_cmapsub,b_vmapsub 
      common/bcmaps/b_cmapsub(icstrf) 
      common/bvmaps/b_vmapsub(ivstrf) 

      b_cstrf(1)=.true. ;  b_vstrf(1)=.true.
      b_cfr1trf(1)=.true.; b_vfr1trf(1)=.true.
      b_cfr2trf(1)=.true.; b_vfr2trf(1)=.true.
      b_csstrf(1)=.true.; b_vsstrf(1)=.true.

      b_cmapsub(1)=.true.; b_vmapsub(1)=.true.

      return
    end subroutine maptrue
    


      
