      subroutine save(n1,n2,cmch,b_unify) 
      use glbconst, only: maxc,maxs,maxthss,nrd,nwr
      use comfrm, only: nthpl,cpstor,fpstor,np,mco,mp,mplthsp,mpaddsp, &
                        mcthsp,mkaddsp,mplths,ivadd,mcths,con,ncon,    &
                        icadd,mplthss,mcthss,mkaddss,mpaddss,   &
                        mconcor,ncor,mr,mc,mcl,mrces,kcp,kpl,mrs,kp,p,up,op,ddp
                        
      use comeff, only: mvadds,mcadds,nu_sdevice,npl,version
      use comdas, only: ktheo,istrss,i_cdata,i_vdata,cdata,vdata,      &
                        n_cdata,n_vdata
      use comscd, only: npanum,conwr,nconwr,iconwr,natcon,lencl,chflen
      use comthe, only: thfrcase,maxthfrcase
      implicit none
                                                      
      integer,intent(in):: n1,n2
      character(len=4),intent(in):: cmch
      logical, intent(in)::   b_unify 

      integer,dimension(0:maxthss):: kpv,kvp
      character(len=132):: ch132,querytype,chcom,name_theo,property
      character(len=24) :: chr,chl
      character(len=54) :: fprint
      character(len=12) :: devcomp
      character(len=8)  :: ch8,ncopa
      character(len=7)  :: form
      character(len=4)  :: ch4
      character(len=2)  :: ch2,ci2
      character(len=1)  :: ch1
      character(len=17),dimension(1:3):: formpr
                                                                        
      integer,parameter :: flen=256 
      integer   i,i0,i1,i2,ic,icd,icol,icole,ie,ii,im,imco,ip,i10,      &
                istr,ivd,j,j1,j10,jc,jcv,jk,jl,jle,icl,jmin,jst,k,k1,k2,&
                kl,klev,ko,ks,kss,l,l2,lcol,lcolumn,lexp,lt,lth,     &
                mscr1,msk,mskf,length,mski,mss,msto,nplc,nn,nth,nthar,  &
                ncolumn,ksfirst,isva,isco,info
      real      alowlimit,rn,uplimit,value
      real, dimension(32):: out
!     n1 output unit                                                    
!     saves (best) parameter set and/or transformation matrix           
!     on file for further run                                           
!     n2=1 save transformation matrix,constants,parameter               
!        2 save constants,parameter                                     
!        3 save parameter                                               
!     ncolumn number of columns printed                                 
!        ncolumn=5 gives (72) ( for print on screen) and                
!     ncolumn=10 (for save on files) 132                                
                                                                        
      i0=ichar('0') 
      querytype=                                                        &
     & 'number (<=132) of characters per line for write out structure'  
      form='i3' 
      chcom='effi/linelength' 
      value=npl 
      alowlimit=80 
      uplimit=130 
      if(n2.gt.3)then 
       value=alowlimit 
       nn=1 
      else 
       nn=n2 
      end if 
      if(value.gt.alowlimit)                                            &
       call askvallim(querytype,form,                                   &
                        alowlimit,uplimit,value,chcom,npl,nrd,nwr)      
      nplc=value 
      if(cmch.eq.'ccor')then
       do k=1,mcl
        if(mconcor(k).lt.k) ncon(k)=ncon(mconcor(k))
       end do
      end if

      goto ( 1,100,200),nn 
    1 continue 
      ksfirst=0
      do ks=1,maxs 
       call istkpvkvp(ks,kpv,kvp,mss) 
                                                                        
        nthar=abs(ktheo(ks,0,0)) 
        if(nthar.eq.0) goto 99 
        if(ksfirst.eq.0)ksfirst=ks 
        if(cmch.eq.'ccor')ksfirst=ks 
        istr=istrss(ks,0) 
        write(n1,'(2a,/,a,a)')'version=',version,                       &
                     ' ---------------------------------------',        &
                     ' ---------------------------------------'         
          write(n1,'(a,i2,a,i3)')' set',ks,                             &
          '  global structure',nthar                                    

          isco=0; isva=0
          nth=ktheo(ks,0,1) 
          lth=ktheo(ks,0,2) 
          call getfrnu_copa(nth,lth,ncopa,istr,info)
          ch132=ncopa
          call trlch(8,ch132,nn,out) 
          isco=isco+out(1); isva=isva+out(2)
!         print*,'ccccccc isco,out(1)=',isco,out(1),ncopa  
          call getnamev(0,nth,lth,property,name_theo) 
          write(n1,'(a,/a)')TRIM(property),TRIM(name_theo) 
!          write(6,'(a,/a)')TRIM(property),TRIM(name_theo) 

          if(nthar.gt.3) then 
           do klev=3,nthar,2 
            nth=ktheo(ks,0,klev) 
            lth=ktheo(ks,0,klev+1) 

            call getnu_copa(nth,lth,ncopa,info) 
            ch132=ncopa
            call trlch(8,ch132,nn,out) 
            isco=isco+out(1); isva=isva+out(2)
            call getnamev(1,nth,lth,property,name_theo) 
            lt=LEN_TRIM(name_theo) 
            j=1 
            l=1 
            l=index (thfrcase(j),'(')-1 
            do while(j.le.maxthfrcase.and.l.gt.0) 
              if(thfrcase(j)(:l).eq.name_theo(:lt)) then 
               name_theo=thfrcase(j)(:lt)//thfrcase(j)(lt+5:) 
               j=maxthfrcase+1 
              end if 
              j=j+1 
              if(j.le.maxthfrcase)l=index (thfrcase(j),'(')-1 
            end do 
            write(n1,'(a,/a)')TRIM(property),name_theo(:72) 
!            write(6,'(a2,a,/a,/a)')'p ',property(:lp),name_theo(:72)   
           end do 
          end if
          devcomp='header'

          call vaco_replace(isva,isco,ks,0,devcomp) 
        write(n1,'(4(a,1x,i2))')                                           &
        ' variables',mplthsp(ks),' of ',mpaddsp(ks),                    &
         ' , constants ',mcthsp(ks),' of ',mkaddsp(ks)                  
        write(n1,'(a,i2)')'  variables ',mplthsp(ks) 
                                                                        
        k1=mplths(ks,0)+1 
        k2=mplths(ks,1) 
        ii=0 
        if(ks.ge.2) ii=mvadds(ks-1,maxthss) 
!--------------                                                         
       jmin=0 
       icd=k2-k1+1 
       do k=k1,k2 
        j=24 
        do while(nthpl(k)(j:j).eq.' ') 
         j=j-1 
        end do 
        if(j.gt.jmin) jmin=j 
       end do 
                                                                        
       jle=jmin+7 
       ncolumn=nplc/jle 
       icl=icd/ncolumn 
       if(icl*ncolumn.lt.icd) icl=icl+1 
                                                                        
        lexp=jmin+7 
        jcv=k1 
        do kl=1,icl 
         ch132=' ' 
         jl=1 
         do while(jl.le.ncolumn.and.jcv-k1.lt.icd) 
          i1=lexp*(jl-1)+1 
          i2=i1+lexp 
          rn=ivadd(jcv)-ii 
          form='i2' 
          call trlnu(form,rn,chr,nn,chl,im) 
          ch132(i1:i2)=                                                 &
          '  '//nthpl(jcv)(1:jmin)//' ('//chr(:2)//')'                  
          jl=jl+1 
          jcv=jcv+1 
!         write(6,'(a,10i4)') 'jl,jcv=',jl,jcv                          
         end do 
         write(n1,'(a)') ch132(:i2) 
        end do 
                                                                        
!        write(n1,'(2(4x,a24,a1,i4,a1))')                               
!     &                   (nthpl(k)(1:24),'(',ivadd(k)-ii,')',k=k1,k2)  
!-----------------------------------------------------------------------
       write(n1,'(a,i2)')'  constants ',mcthsp(ks) 
       k1=mcths(ks,0)+1 
       k2=mcths(ks,1) 
       if(k2.ge.k1) then 
        ii=0 
        if(ks.ge.2) ii=mcadds(ks-1,maxthss) 
        jc=0 
        do k=k1,k2 
         jc=jc+1 
         conwr(jc)=con(k) 
         nconwr(jc)=ncon(k) 
         iconwr(jc)=icadd(k)-ii 
        end do 
        do k=1,jc 
         natcon(k)=k 
        end do 
        natcon(jc+1)=0 
        call fwradjust(length) 
        jmin=0 
        do k=1,jc 
         j=24 
         do while(nconwr(k)(j:j).eq.' ') 
          j=j-1 
         end do 
         j=j+1
         if(j.gt.jmin) jmin=j 
         if(ksfirst.eq.ks)then          
          if(nconwr(k)(1:1).eq.'0') nconwr(k)(1:1)='#'  !5.5.05  
         else
          i=index(nconwr(k),'0hd')
          if(i.gt.0) then
            nconwr(k)(i:i)='#'
          else 
           if(ks.le.9)then
              fprint=nconwr(k)(2:j)
             write(ch2,'(i2)')ks
             nconwr(k)(1:j+2)=ch2(2:2)//fprint(:j)
           else
            fprint=nconwr(k)(3:j)
            write(ch2,'(i2)')ks
            nconwr(k)(1:j+2)=ch2//fprint(:j)
           end if 

          end if
         end if
        end do 

        jle=jmin+8+length 
        ncolumn=nplc/jle 
        icl=jc/ncolumn 
        if(icl*ncolumn.lt.jc) icl=icl+1 
                                                                        
!        write(6,'(a,a2,3i4)') ' ch2,jmin,icl,length=',ch2,jmin,icl,leng
        lexp=jmin+1+7+length 
        jcv=1 
        do kl=1,icl 
         ch132=' ' 
         jl=1 
         do while(jl.le.ncolumn.and.jcv.le.jc) 
          i1=lexp*(jl-1)+1 
          i2=i1+lexp 
          j10=iconwr(jcv)/10 
          j1=iconwr(jcv)-10*j10 
          ch2=char(j10+i0)//char(j1+i0) 
          rn=conwr(jcv) 
          form=nconwr(jcv)(33:37) 
          call trlnu(form,rn,chr,nn,chl,im) 
!          if(ch2.eq.'04') write(6,'(a,f10.5,a7,2a24)')                 
!             'rn,form,chr,chl=',rn,form,chr,chl                        
          ch132(i1:i2)=                                                 &
          ' '//nconwr(jcv)(1:jmin)//' ('//ch2//')='//chr(:length)//' '  
          jl=jl+1 
          jcv=jcv+1 
!         write(6,'(a,10i4)') 'jl,jcv=',jl,jcv                          
!         write(6,'(a)') ch132(:i2)                                     
                                                                        
         end do 
         write(n1,'(a)') ch132(:i2) 
        end do 
!-----------------------------------------------------------------------
       icd=i_cdata(ks,0) 
       ivd=i_vdata(ks,0) 

       do k=1,icd 
         conwr(k)=cdata(ks,k) 
         nconwr(k)=n_cdata(ks,k) 
       end do 
       do k=1,ivd 
         conwr(icd+k)=vdata(ks,k) 
         nconwr(icd+k)=n_vdata(ks,k) 
       end do 
       jc=icd+ivd 
       do k=1,jc 
         natcon(k)=k 
       end do 
       natcon(jc+1)=0 
       if(jc.gt.0) call fwradjust(length) 
       jmin=0 
       do k=1,jc 
        j=24 
        do while(nconwr(k)(j:j).eq.' ') 
         j=j-1 
        end do 
!        write(6,'(2i4,1x,a)') j,jmin,nconwr(k)                         
        if(j.gt.jmin) jmin=j 
       end do 
       jle=jmin+9+length 
       ncolumn=nplc/jle 
       icl=icd/ncolumn 
       if(icl*ncolumn.lt.icd) icl=icl+1 
                                                                        
        write(n1,'(2(a,i2))') '  data information: constants ',icd,     &
                                               ', variables ',ivd       
!        write(6,'(a,a2,3i4)') ' ch2,jmin,icl,length=',ch2,jmin,icl,leng
        lexp=jmin+1+8+length 
        jcv=1 
        do kl=1,icl 
         ch132=' ' 
         jl=1 
         do while(jl.le.ncolumn.and.jcv.le.icd) 
          i1=lexp*(jl-1)+1 
          i2=i1+lexp 
          j10=i_cdata(ks,jcv)/10 
          j1=i_cdata(ks,jcv)-10*j10 
          ch2=char(j10+i0)//char(j1+i0) 
          rn=cdata(ks,jcv) 
          form=nconwr(jcv)(33:37) 
          call trlnu(form,rn,chr,nn,chl,im) 
          ch132(i1:i2)=                                                 &
          ' '//nconwr(jcv)(1:jmin)//' ('//ch2//')=['//chr(:length)//']' 
          jl=jl+1 
          jcv=jcv+1 
!         write(6,'(a,10i4)') 'jl,jcv=',jl,jcv                          
!         write(6,'(a)') ch132(:i2)                                     
                                                                        
         end do 
         write(n1,'(a)') ch132(:i2) 
        end do 
                                                                        
        icl=ivd/ncolumn 
        if(icl*ncolumn.lt.ivd) icl=icl+1 
        do kl=1,icl 
         ch132=' ' 
         jl=1 
         do while(jl.le.ncolumn.and.jcv.le.jc) 
          i1=lexp*(jl-1)+1 
          i2=i1+lexp 
          j10=i_vdata(ks,jcv-icd)/10 
          j1=i_vdata(ks,jcv-icd)-10*j10 
          ch2=char(j10+i0)//char(j1+i0) 
          rn=vdata(ks,jcv-icd) 
          form=nconwr(jcv)(33:37) 
          call trlnu(form,rn,chr,nn,chl,im) 
          ch132(i1:i2)=                                                 &
          ' '//nconwr(jcv)(1:jmin)//' ('//ch2//')=['//chr(:length)//']' 
          jl=jl+1 
          jcv=jcv+1 
         end do 
         write(n1,'(a)') ch132(:i2) 
        end do 
                                                                        
                                                                        
!        write(n1,'(a24,a1,i2,a3,f9.3,a1,1x,a24,a1,i2,a3,f9.3,a1)')     
!        (n_cdata(ks,k)(:24),'(',i_cdata(ks,k),')=[',                   
!        cdata(ks,k),']',k=1,i_cdata(ks,0))                             
!        write(n1,'(a24,a1,i2,a3,f9.3,a1,1x,a24,a1,i2,a3,f9.3,a1)')     
!        (n_vdata(ks,k)(:24),'(',i_vdata(ks,k),')=[',                   
!        vdata(ks,k),']',k=1,i_vdata(ks,0))                             
!..........                                                             
!         write(n1,'(2(x,a24,a1,i2,a2,g10.4))')                         
!              (ncon(k)(1:24),'(',icadd(k)-ii,')=',con(k),k=k1,k2)      
       end if 
                                                                        
       do kss=1,maxthss 
        nthar=ktheo(ks,kss,0) 
                                                                        
        istr=istrss(ks,kss) 
        if(istr.eq.0) goto 49 
!        write(6,'(a,i2,a1,i2,a2,i3)')' psave, ktheo(',ks,',',kss,')=',nthar  
!        write(6,'(a,i5)')'istrss(ks,kss)=',istrss(ks,kss)             
         if(istr.lt.0) then 
          i=istr/10 
          if(i*10.eq.istr.and.istr.gt.-100) then 
           ii=abs(i) 
           if(ii.gt.9)ii=ii/10 
           j=nu_sdevice(ks,ii) 
            write(n1,'(a,i2,a2,i1,a,a)')                                 &
                  '          device(',ii,')=',j,' -----------------',  &
                   ' ---------------------------------------'           
           write(n1,'(a,i3)')'device level    /',nthar 
          else 
           if(istr.lt.-100)then 
             i=i/10 
             ii=abs(istr-i*100) 
                                                                        
           else 
            ii=abs(istr-i*10) 
           end if 
           ch2=ci2(ii) 
          write(n1,'(a,a2,a)')                                          &
                     '                               module=',ch2,      &
                     ' ---------------------------------------'         
          write(n1,'(a,i3)')'module level    /',nthar 
          end if 
          nth=ktheo(ks,kss,1) 
          lth=ktheo(ks,kss,2) 

      isva=0; isco=0
      call getfrnu_copa(ktheo(ks,0,1),ktheo(ks,0,4),ncopa,istr,info)
      ch132=ncopa
      call trlch(8,ch132,nn,out) 
      isco=isco+out(1); isva=isva+out(2)

          call getnamev(0,nth,lth,property,name_theo) 
          write(n1,'(a,/a)')TRIM(property),TRIM(name_theo) 

!      nth=ktheo(ks,kss,3) 
!      lth=ktheo(ks,kss,4) 
!      call getnu_copa(nth,lth,ncopa,info) 
!      ch132=ncopa
!      call trlch(8,ch132,nn,out) 
!      isco=isco+out(1); isva=isva+out(2)

          if(nthar.gt.3) then 
           do klev=3,nthar,2 
            nth=ktheo(ks,kss,klev) 
            lth=ktheo(ks,kss,klev+1) 
            call getnamev(1,nth,lth,property,name_theo) 
            write(n1,'(a,/a)')TRIM(property),TRIM(name_theo) 

     call getnu_copa(nth,lth,ncopa,info) 
     ch132=ncopa 
     call trlch(8,ch132,nn,out) 
     isco=isco+out(1); isva=isva+out(2)

           end do 
          end if 
          devcomp='module='//ch2                                                              
          call vaco_replace(isva,isco,ks,kss,devcomp) 
          write(n1,'(4(a,i3))') '  variables ',                         &
          mplthss(ks,kss),' of ',mpaddss(ks,kss),                       &
          ' , constants ',mcthss(ks,kss),' of ',mkaddss(ks,kss)         
         end if 
         if(istr.gt.0) then 
          if(istr.lt.100) then 
           ch2=ci2(istr) 
           write(n1,'(2a,a2,a)')                                        &
                     '                                        ',        &
                   '      component=',ch2,' ---------------------'      
          else 
           ii=istr/100 
           i=istr-100*ii 
           ii=ii+i0 
           ch2=ci2(i) 
           write(n1,'(2a,a3,a)')                                        &
                     '                                        ',        &
          '      component=',char(ii)//ch2,' --------------------'      
          end if 
          write(n1,'(a,i3)') 'component level /',nthar 
         isco=0; isva=0                                                            
          do klev=1,nthar,2 
            nth=ktheo(ks,kss,klev) 
            lth=ktheo(ks,kss,klev+1)
!            write(6,'(a,3i5)')'nth,lth,kss=',nth,lth,kss 
            call getnamev(1,nth,lth,property,name_theo)
            write(n1,'(a,/a)')TRIM(property),TRIM(name_theo) 

           call getnu_copa(nth,lth,ncopa,info) 
           ch132=ncopa 
           call trlch(8,ch132,nn,out) 
           isco=isco+out(1); isva=isva+out(2)
          end do 
          devcomp='component='//char(ii)//ch2
          call vaco_replace(isva,isco,ks,kss,devcomp)                                                                         

          write(n1,'(5(a,i3))')                                         &
          '  variables ',mplthss(ks,kss),' of ',mpaddss(ks,kss),        &
          ' , constants ',mcthss(ks,kss),' of ',mkaddss(ks,kss)         
         end if 
        k1=mplths(ks,kss)+1 
        k2=k1+mplthss(ks,kss)-1 
         ii=mvadds(ks,kvp(kss))-mvadds(ks,0) 
         if(ks.ge.2) ii=mvadds(ks-1,maxthss)+ii 
!        write(6,'(5i3,5x,10i3)')kss,k1,k2,mplthss(ks,kss),ii,          
!              (ivadd(i)-ii,i=k1,k2)                                    
!        write(6,'(20i4)') (mvadds(ks,kvp(i)),i=1,19)                   
!        write(6,'(20i4)') (mplths(ks,i),i=1,9)                         
!        write(6,'(20i4)') (mplthss(ks,i),i=1,9)                        
!---------                                                              
       jmin=0 
       icd=k2-k1+1 
       do k=k1,k2 
        j=24 
        do while(nthpl(k)(j:j).eq.' ') 
         j=j-1 
         if(j.eq.0)goto 11 
        end do 
   11   if(j.gt.jmin) jmin=j 
       end do 
       jle=jmin+7 
       ncolumn=nplc/jle 
       icl=icd/ncolumn 
       if(icl*ncolumn.lt.icd) icl=icl+1 
                                                                        
        lexp=jmin+7 
        jcv=k1 
        do kl=1,icl 
         ch132=' ' 
         jl=1 
         do while(jl.le.ncolumn.and.jcv-k1.lt.icd) 
          i1=lexp*(jl-1)+1 
          i2=i1+lexp 
          rn=ivadd(jcv)-ii 
          form='i2' 
          call trlnu(form,rn,chr,nn,chl,im) 
          ch132(i1:i2)=                                                 &
          '  '//nthpl(jcv)(1:jmin)//' ('//chr(:2)//')'                  
          jl=jl+1 
          jcv=jcv+1 
!         write(6,'(a,10i4)') 'jl,jcv=',jl,jcv                          
         end do 
         write(n1,'(a)') ch132(:i2) 
        end do 
                                                                        
!         write(n1,'(x,a24,a1,i2,a1,12x,a24,a1,i2,a1)')                 
!     &                   (nthpl(k)(1:24),'(',ivadd(k)-ii,')',k=k1,k2)  
                                                                        
!      write(6,'(i4,a)') ks,'=ks  psave-mcths='                         
                                                                        
                                                                        
       k1=mcths(ks,kss)+1 
       k2=k1+mcthss(ks,kss)-1 
       if(k2.ge.k1) then 
        ii=mcadds(ks,kvp(kss))-mcadds(ks,0) 
        if(ks.ge.2) ii=mcadds(ks-1,maxthss)+ii 
        jc=0 
        do k=k1,k2 
         jc=jc+1 
         conwr(jc)=con(k) 
         nconwr(jc)=ncon(k) 
         iconwr(jc)=icadd(k)-ii 
        end do 
        do k=1,jc 
         natcon(k)=k 
        end do 
        natcon(jc+1)=0 
        call fwradjust(length) 
        jmin=0 
        do k=1,jc 
         j=24 
         do while(nconwr(k)(j:j).eq.' ') 
          j=j-1 
         end do 
         j=j+1
         if(j.gt.jmin) jmin=j 
         if(ksfirst.eq.ks)then  
          if(nconwr(k)(1:1).eq.'0') nconwr(k)(1:1)='#' 
         else
          i=index(nconwr(k),'0hd')
          if(i.gt.0) then
           nconwr(k)(i:i)='#'
          else 
           if(ks.le.9)then
             fprint=nconwr(k)(2:j)
             write(ch2,'(i2)')ks
             nconwr(k)(1:j+2)=ch2(2:2)//fprint(:j)
           else
            fprint=nconwr(k)(3:j)
            write(ch2,'(i2)')ks
            nconwr(k)(1:j+2)=ch2//fprint(:j)
           end if 
          end if
         end if
        end do 

        i0=ichar('0') 
        jle=jmin+8+length 
        ncolumn=nplc/jle 
        icl=jc/ncolumn 
        if(icl*ncolumn.lt.jc) icl=icl+1 
                                                                        
!        write(6,'(a,a2,3i4)') ' ch2,jmin,icl,length=',ch2,jmin,icl,leng
        lexp=jmin+1+7+length 
        jcv=1 
        do kl=1,icl 
         ch132=' ' 
         jl=1 
         do while(jl.le.ncolumn.and.jcv.le.jc) 
          i1=lexp*(jl-1)+1 
          i2=i1+lexp 
          j10=iconwr(jcv)/10 
          j1=iconwr(jcv)-10*j10 
          ch2=char(j10+i0)//char(j1+i0) 
          rn=conwr(jcv) 
          form=nconwr(jcv)(33:37) 
          call trlnu(form,rn,chr,nn,chl,im) 
          ch132(i1:i2)=                                                 &
          ' '//nconwr(jcv)(1:jmin)//' ('//ch2//')='//chr(:length)//' '  
          jl=jl+1 
          jcv=jcv+1 
         end do 
         write(n1,'(a)') ch132(:i2) 
        end do 
                                                                        
!         write(n1,'(2(x,a24,a1,i2,a2,g10.4))')                         
!     &         (ncon(k)(1:24),'(',icadd(k)-ii,')=',con(k),k=k1,k2)     
        end if 
   49   continue 
               ! 1 - maxthss                                            
       end do 
   99  continue 
               ! ms=1 - maxs                                            
      end do 
      if(b_unify) call saveh(n1,1,b_unify) 
                                                                        
      write(n1,'(a3,/)') ' ##' 
                                                                        
  100 if(n2.eq.2) then 
      if(n1.eq.nwr) goto 102 
  101  read(n1,'(a4)') ch4 
       if(index(ch4,'##').gt.0) goto 102 
       goto 101 
      end if 
                                                                        
                    ! 2 matrices listed per line                        
  102 imco=(mco)/2 
      ie=0 
      do i=1,imco 
       ii=2*(i-1)+1 
       ie=ii+1 
       write(n1,'(1h ,2(i4,1x,a16,1x,a1,i3,a1,i3,a1,2x))')              &
            (k,ncor(k),'(',mr(k),',',mc(k),')',k=ii,ie)                 
      end do 
       if(mco.gt.ie) then 
       ii=ie+1 
       write(n1,'(1h ,2(i4,1x,a16,1x,a1,i3,a1,i3,a1,2x))')              &
            (k,ncor(k),'(',mr(k),',',mc(k),')',k=ii,ii)                 
       end if 
      if(b_unify) call saveh(n1,4,b_unify) 
!       write(6,'(a,20i3)') ' save kcp=',(kcp(k),k=1,20)                
      msto=0 
!      do k=1,mco                                                       
!       if (mc(k).gt.0) then                                            
!         do j=1,mr(k)                                                  
!          jst=mrces(k)+(j-1)*mc(k)                                     
!          write(6,'(10a6)') (fpstor(jst+ic),ic=1,mc(k))                
!          msto=msto+mc(k)                                              
!         end do                                                        
!        end if                                                         
!       end do                                                          
!-------------                                                          
      msk=0 
      do ko=1,mco 
       mski=msk+1 
       if (mc(ko).gt.0) then 
        lcol=0 
        do ic=1,mc(ko) 
         length=4 
         do j=1,mr(ko) 
          jst=mrces(ko)+(j-1)*mc(ko) 
          l=10*(ichar(fpstor(jst+ic)(2:2))-i0)                          &
               +ichar(fpstor(jst+ic)(3:3))-i0                           
          if(l.gt.length) length=l 
         end do 
         lencl(ic)=length 
         lcol=lcol+length+2 
        end do 
!        write(6,'(a,20i3)')' lencl(1-)=',(lencl(ic),ic=1,mc(ko))       
!        write(6,'(a,20i3)')' lcol+29,nplc=',lcol+29,nplc               
        if(lcol+29.ge.nplc) then 
                                                                        
         length=29 
         ic=1 
         do while(ic.le.mc(ko).and.length.le.nplc) 
          length=length+lencl(ic)+2 
          ic=ic+1 
         end do 
         lcolumn=ic-1 
         i=(flen-8)/9-1 
         if(ic-1.gt.i) lcolumn=i 
                                                                        
         mskf=msk+lcolumn 
                                                                        
!        parameter number line                                          
         chflen(1:7)='(/,29x,' 
         lcol=8 
         do ic=1,lcolumn 
          l2=(lencl(ic)-3)/2 
          ch2=char(l2+i0+1)//'x' 
          if(lencl(ic)-3-2*l2.eq.0) then 
           ch8=ch2//',i3,'//char(l2+i0)//'x' 
          else 
           ch8=ch2//',i3,'//ch2 
          end if 
          chflen(lcol:lcol+8)=ch8//',' 
          lcol=lcol+9 
         end do 
!         write(6,'(a,i4)') 'psave 1 chflen(:lcol) lcol=',lcol          
         chflen(lcol-1:)=')' 
         write(n1,chflen) (kcp(ic),ic=mski,mskf) 
                                                                        
         do j=1,mr(ko) 
          jk=kpl(mrs(ko)+j) 
          jst=mrces(ko)+(j-1)*mc(ko) 
          chflen(1:11)='(i4,1x,a24,' 
          lcol=12 
          do ic=1,lcolumn 
           i10=lencl(ic)/10 
           i1=lencl(ic)-10*i10 
           ch2=char(i0+i10)//char(i0+i1) 
           ch1=fpstor(jst+ic)(1:1) 
           if(ch1.eq.'i') then 
            chflen(lcol:lcol+8)='1x,'//'f'//ch2//'.0,' 
           else 
            chflen(lcol:lcol+8)=                                        &
                      '1x,'//ch1//ch2//'.'//fpstor(jst+ic)(4:4)//','    
           end if 
           lcol=lcol+9 
          end do 
!            write(6,'(a,i4)') 'psave 2 chflen(:lcol) lcol=',lcol       
          chflen(lcol-1:)=')' 
           write(n1,chflen)                                             &
                 jk,nthpl(jk)(1:24),(cpstor(jst+ic),ic=1,lcolumn)       
                                                                        
                                                                        
!           write(n1,'(i3,1x,a24,10(x,g10.4))')                         
!     &           jk,nthpl(jk)(1:24),(cpstor(jst+ic),ic=1,lcolumn)      
         end do 
                             ! next block                               
         icol=0 
         do while(icol.le.mc(ko).and.lcolumn.gt.0) 
          icol=icol+lcolumn 
          length=6 
          lcolumn=0 
          ic=icol+1 
          do while(ic.le.mc(ko).and.length.le.nplc) 
           length=length+lencl(ic) 
           ic=ic+1 
           lcolumn= lcolumn+1 
          end do 
          i=(flen-6)/9-1 
                                          !lcolumn of new block         
          if(lcolumn.gt.i) lcolumn=i 
!          write(6,'(a,10i4)')' lencl=',(lencl(i),i=icol+1,icol+10)     
!          write(6,'(a,4i4)')'length,lcolumn,ic,icol=',length,lcolumn,ic
          if(lcolumn.gt.0) then 
           icole=icol+lcolumn 
           mski=mskf+1 
           mskf=mskf+lcolumn 
!          parameter number line                                        
           chflen(1:6)='(/,1x,' 
           lcol=7 
           do ic=icol+1,icole 
            l2=(lencl(ic)-3)/2 
            ch2=char(l2+i0+1)//'x' 
            if(lencl(ic)-3-2*l2.eq.0) then 
             ch8=ch2//',i3,'//char(l2+i0)//'x' 
            else 
             ch8=ch2//',i3,'//ch2 
            end if 
            chflen(lcol:lcol+8)=ch8//',' 
            lcol=lcol+9 
           end do 
!            write(6,'(a,i4)') 'psave 3 chflen(:lcol) lcol=',lcol       
           chflen(lcol-1:)=')' 
           write(n1,chflen) (kcp(ic),ic=mski,mskf) 
!           write(n1,'(/,6x,11(5x,i3,3x))') (kcp(i),i=mski,mskf)        
           do j=1,mr(ko) 
            jst=mrces(ko)+(j-1)*mc(ko) 
            chflen(1:4)='(1x,' 
            lcol=5 
            do ic=icol+1,icole 
             i10=lencl(ic)/10 
             i1=lencl(ic)-10*i10 
             ch2=char(i0+i10)//char(i0+i1) 
             ch1=fpstor(jst+ic)(1:1) 
             if(ch1.eq.'i') then 
              chflen(lcol:lcol+8)='1x,'//'f'//ch2//'.0,' 
             else 
              chflen(lcol:lcol+8)=                                      &
                      '1x,'//ch1//ch2//'.'//fpstor(jst+ic)(4:4)//','    
             end if 
             lcol=lcol+9 
            end do 
            chflen(lcol-1:)=')' 
!           write(6,'(a)') chflen(:lcol)                                
!            write(6,'(a,i4)') 'psave 4 chflen(:lcol) lcol=',lcol       
            write(n1,chflen) (cpstor(jst+ic),ic=icol+1,icole) 
!            write(n1,'(6x,11(x,g10.4))') (cpstor(jst+ic),ic=ii,ie)     
           end do 
          end if 
         end do 
                                                                        
         if(icol.lt.mc(ko)) then 
          lcolumn=mc(ko)-icol 
          mski=mskf+1 
          mskf=msk+mc(ko) 
          if(mskf.ge.mski) then 
!          parameter number line                                        
           chflen(1:6)='(/,6x,' 
           lcol=7 
           do ic=icol+1,mc(ko) 
            l2=(lencl(ic)-3)/2 
            ch2=char(l2+i0+1)//'x' 
            if(lencl(ic)-3-2*l2.eq.0) then 
             ch8=ch2//',i3,'//char(l2+i0)//'x' 
            else 
             ch8=ch2//',i3,'//ch2 
            end if 
            chflen(lcol:lcol+8)=ch8//',' 
            lcol=lcol+9 
           end do 
           chflen(lcol-1:)=')' 
!           write(6,'(a,i4)') 'psave 5 chflen(:lcol) lcol=',lcol        
           write(n1,chflen) (kcp(ic),ic=mski,mskf) 
!          write(n1,'(/,6x,11(5x,i3,3x))') (kcp(i),i=mski,mskf)         
           do j=1,mr(ko) 
            jst=mrces(ko)+(j-1)*mc(ko) 
            chflen(1:4)='(6x,' 
            lcol=5 
            do ic=icol+1,mc(ko) 
             i10=lencl(ic)/10 
             i1=lencl(ic)-10*i10 
             ch2=char(i0+i10)//char(i0+i1) 
             ch1=fpstor(jst+ic)(1:1) 
             if(ch1.eq.'i') then 
              chflen(lcol:lcol+8)='1x,'//'f'//ch2//'.0,' 
             else 
              chflen(lcol:lcol+8)=                                      &
                      '1x,'//ch1//ch2//'.'//fpstor(jst+ic)(4:4)//','    
             end if 
             lcol=lcol+9 
            end do 
!            write(6,'(a,i4)') 'psave 6 chflen(:lcol) lcol=',lcol       
            chflen(lcol-1:)=')' 
!           write(6,'(a)') chflen(:lcol)                                
            write(n1,chflen) (cpstor(jst+ic),ic=icol+1,mc(ko)) 
!           write(n1,'(9x,11(x,g10.4))') (cpstor(jst+ic),ic=ii,mc(ko))  
           end do 
          end if 
         end if 
        else 
         mskf=mski+mc(ko)-1 
         lcolumn=mc(ko) 
!        parameter number line                                          
         chflen(1:7)='(/,29x,' 
         lcol=8 
         do ic=1,lcolumn 
          l2=(lencl(ic)-3)/2 
          ch2=char(l2+i0+1)//'x' 
          if(lencl(ic)-3-2*l2.eq.0) then 
           ch8=ch2//',i3,'//char(l2+i0)//'x' 
          else 
           ch8=ch2//',i3,'//ch2 
          end if 
          chflen(lcol:lcol+8)=ch8//',' 
          lcol=lcol+9 
         end do 
         chflen(lcol-1:)=')' 
!         write(6,'(a,i4)') 'psave 7 chflen(:lcol) lcol=',lcol          
!         write(6,'(a)') chflen                                         
         write(n1,chflen) (kcp(ic),ic=mski,mskf) 
!         write(n1,'(/,25x,10(5x,i3,3x))') (kcp(i),i=mski,mskf)         
                                                                        
         do j=1,mr(ko) 
          jk=kpl(mrs(ko)+j) 
          jst=mrces(ko)+(j-1)*mc(ko) 
          chflen(1:11)='(i4,1x,a24,' 
          lcol=12 
          do ic=1,lcolumn 
           i10=lencl(ic)/10 
           i1=lencl(ic)-10*i10 
           ch2=char(i0+i10)//char(i0+i1) 
           ch1=fpstor(jst+ic)(1:1) 
           if(ch1.eq.'i') then 
            chflen(lcol:lcol+8)='1x,'//'f'//ch2//'.0,' 
           else 
            chflen(lcol:lcol+8)=                                        &
                      '1x,'//ch1//ch2//'.'//fpstor(jst+ic)(4:4)//','    
          end if 
           lcol=lcol+9 
          end do 
!          write(6,'(i4,a)') lcol,chflen(:lcol)                         
          chflen(lcol-1:)=')' 
!          write(6,'(a)') chflen(:lcol)                                 
          write(n1,chflen)                                              &
                 jk,nthpl(jk)(1:24),(cpstor(jst+ic),ic=1,lcolumn)       
                                                                        
                                                                        
!         write(n1,'(i3,1x,a24,10(x,g10.4))')                           
!     &          jk,nthpl(jk)(1:24),(cpstor(jst+ic),ic=1,mc(ko))        
         end do 
                                                                        
        end if 
              ! mc(ko)>0                                                
       end if 
       msk=msk+mc(ko) 
              ! ko=1,mco                                                
      end do 
      if(b_unify) then 
        call saveh(n1,5,b_unify) 
        goto 203 
      end if 
      write(n1,'(a3)') ' **' 
                                                                        
  200 if(n2.eq.3) then 
      if(n1.eq.nwr) goto 202 
  201  read(n1,'(a4)') ch4 
       if(index(ch4,'**').gt.0) goto 202 
       goto 201 
      end if 
                                                                        
  202 write(n1,'(1h ,/,a,i3)') ' number of parameters =',mp 
                                                                        
  203 continue 
      formpr(1)='(i1,3x,i2,1x,a24,' 
      formpr(2)='(i2,2x,i2,1x,a24,' 
      formpr(3)='(i3,1x,i2,1x,a24,' 
      mscr1=maxc 
      npanum(mscr1+2)=mp 
      do k=1,mp 
       npanum(mscr1+2+k)=k 
      end do 
      do k=1,4 
       call fvadjust(k,length) 
      end do 
       do k=1,mp 
!        write(6,'(i3,a)')k,np(k)                                       
       if(np(k)(1:1).eq.'0') np(k)(1:1)='#'  !5.5.05
       ip=3 
       if(k/100.eq.0)ip=2 
       if(k/10.eq.0) ip=1 
       if(index(np(k),')').eq.0) print'(a)',TRIM(np(k))
       fprint=formpr(ip)//np(k)(25:60)
!       write(6,'(i4,a,e10.3)')k,fprint,p(k)                            
       if(kp(k).eq.2) then 
        write(n1,fprint) k,kp(k),np(k),p(k) 
!        if(ddp(k).eq.0.0) then                                         
!      write(n1,fprint) k,kp(k),np(k),p(k),up(k),op(k)                  
        else 
      write(n1,fprint) k,kp(k),np(k),p(k),up(k),op(k),ddp(k) 
        end if 
       end do 
      if(b_unify) call saveh(n1,6,b_unify) 
      if(n1.ne.6)rewind n1 
      return 
      END                                           

      subroutine vaco_replace(isva,isco,ks,kss,devcomp) 
      use comfrm, only: mpaddsp,mkaddsp,mpaddss,mkaddss
      implicit none
      character(len=12), intent(in):: devcomp
      integer , intent(in)::isva,isco,ks,kss 
  
      if(kss.eq.0) then
       if(isva.ne.mpaddsp(ks))then
         print'(2a,2(i2,a))',devcomp,' number of variables ',mpaddsp(ks), &
                           ' replaced by ',isva,' from str_ (routine)'
         mpaddsp(ks)=isva
       end if
       if(isco.ne.mkaddsp(ks))then
        print'(2a,2(i2,a))',devcomp,' number of constants ',mkaddsp(ks), &
                          ' replaced by ',isco,' from str_ (routine)'
        mkaddsp(ks)=isco
       end if
      else
       if(isva.ne.mpaddss(ks,kss))then
        print'(2a,2(i2,a))',devcomp,' number of variables ',mpaddss(ks,kss),  &
                          ' replaced by ',isva,' from str_ (routine)'
        mpaddss(ks,kss)=isva
       end if
       if(isco.ne.mkaddss(ks,kss))then
        print'(2a,2(i2,a))',devcomp,' number of constants ',mkaddss(ks,kss), &
                          ' replaced by ',isco,' from str_ (routine)'
        mkaddss(ks,kss)=isco
       end if
     end if    
      return
      end
