      subroutine seltheory(levelth,cmch,nhelpentry,iquery_o,wrb,info) 
      use glbconst, only: maxcom,enwr,nwr,nrd
      use comscd, only: queryar,helpar,ext
      use comstr, only: nameth_as,nameth,itheory,nstruct,kssthe
      use comeff, only: npl
      implicit none 
                                                                        
      integer       levelth,info,                                       &
                    i,i0,i1,i10,iquery,ientry,j,jth,k,kth,              &
                    l,l_jth,lk,lksto,mthsl,ntrimto0,mask
      character(len=132):: nhelpentry,cheader,ch132
      character(len=80) :: chdf
      character(len=8)  :: ch8
      character(len=4)  :: ch4,cmch
      character(len=1)  :: ch1,wrb,go
      character(len=132),dimension(1:maxcom):: hname
      integer, dimension(1:8):: iquery_o 
      logical b_ig

!      l_jth=3;jp=i_theoset(i_theoset(0)); if(jp.gt.0.and.jp.lt.9)l_jth=jp
      i0=ichar('0') 
      b_ig=.false.; mask=ichar(nhelpentry(131:131))-i0;
      if(nhelpentry(131:131).eq.'i')b_ig=.true. 
      if(wrb.eq.'r')  b_ig=.false.
      go=nhelpentry(132:132);  nhelpentry(131:131)=' '

      ch132=nameth_as 
      l=ntrimto0(ch132) 
      if(l.gt.npl-27) then 
       l=npl-27 
       nstruct='theories for:'//ch132(:l)//'... ' 
      else 
       nstruct='theories for:'//ch132(:l) 
      end if 
                                                                        
      if(enwr(9)(1:1).eq.'a') &
           print'(a,i2,a,a4,/,2a,/,2a)',' seltheory levelth=',levelth,&
           ' cmch=',cmch,' nhelpentry=',TRIM(nhelpentry),             &
           ' nameth_as=',TRIM(nameth_as)      

      mthsl=0 
      jth=0 
      kth=1 
      do while(jth.le.kth) 
       jth=jth+1 
       kth=jth 
       cmch='name' 
       call getthstring(kth,l_jth,cmch,nhelpentry) 
       kth=jth 
       l_jth=0 
       cmch='theo' 
       call getthstring(kth,l_jth,cmch,nhelpentry) 
!       write(6,'(a,i2,2x,a4,2x,a)')'l_jth,cmch,nameth_as=', &
!                                     l_jth,cmch,TRIM(nameth_as)
       if(l_jth.gt.0.and.mthsl.lt.maxcom-l_jth) then 
!        write(6,'(a,3i4,2x,a)') 'thselect l_jth,kth,mthsl=',    &           
!                   l_jth,kth,mthsl,nameth_as                          
        do k=1,l_jth 
         mthsl=mthsl+1 
         hname(mthsl)=nameth(k) 
         queryar(mthsl)=nameth(k) 
         if(enwr(9)(2:2).eq.'a') write(nwr,'(a,3i4,a)')          &
                'thselect:',jth,l_jth,mthsl,nameth(k)(:60)              
         itheory(mthsl,1)=jth 
         itheory(mthsl,2)=k 
        end do 
       end if 
      end do 
!      write(6,'(a,i4,a)') 'thselect  mthsl,cmch=',mthsl,cmch
      if(mthsl.eq.0) cmch='ende' 
      if(cmch.eq.'name'.or.mthsl.eq.0) return 
      do k=1,mthsl 
       i1=itheory(k,1) 
       i10=i1/10 
       i1=i1-10*i10 
       ch8(1:4)='th'//char(i10+i0)//char(i1+i0) 
       i1=itheory(k,2) 
       i10=i1/10 
       i1=i1-10*i10 
       ch8(5:8)=char(i10+i0)//char(i1+i0)//'  ' 
       helpar(k)='theory/'//ch8//'/'//queryar(k) 
      end do 
                                                                        
!     -----------------------------------------------------------'      
      do k=1,mthsl 
        ext(k)=' ' 
      end do 
                                                     ! 30.03.07         
   10 if(iquery_o(levelth).gt.0.and.(go.eq.'g'.or.b_ig)) then 
       iquery=iquery_o(levelth) 
      else 
       iquery=1 
      end if 
                                                                        
      chdf=queryar(iquery) 
      chdf(80:80)='#' 
      if(wrb.eq.'w')then 
       write(10,'(a)')'[g]' 
      end if 
                                                                        
      if(wrb.eq.'r') then 
       read(10,'(a)')ch4 
       do while(ch4(3:3).eq.']') 
        if(ch4(2:2).eq.'b') then 
         wrb='w' 
         go=' ' 
         backspace 10 
         write(10,'(a3)')'[g]' 
        end if 
        if(wrb.eq.'r')then 
         read(10,'(a)')ch4 
        else 
         ch4='end' 
        end if 
       end do 
       if(wrb.eq.'r')backspace 10  
      end if 

 8    cheader=nstruct 
      if(mask.gt.0.and.mask.lt.9)mthsl=mask
      lk=mthsl; lksto=lk
      cheader(132:132)=wrb 
      if(b_ig)cheader(131:131)='i'
      if(go.eq.'g')cheader(131:131)='g'
      call query(mthsl,lk,cheader,chdf) 
                                                                        
      if(mthsl.eq.0) then 
        mthsl=lksto 
!        read(5,'(a)')                                                  
        goto 8 
       end if 
!      write(6,'(a,3i4)')' seltheory query mthsl=',mthsl                
                                                                        
      if(queryar(mthsl)(:4).eq.'skip') then 
       cmch='ende'
       goto 100 
      end if 
                                                                        
      if(mthsl.eq.0) then 
       write(nwr,'(2a,/,a)') '*error* no theory choosen ',              &
       '(do not use q,* ret but just ret)',                             &
       ' ret to go back'                                                
       lk=lksto 
       mthsl=lksto 
       read(nrd,'(a)') 
       goto 10 
      end if 
      iquery_o(levelth)=mthsl 
!     theory choosen                                                    
!     in order to search on that level the choosen theory:              
                                                                        
      if(enwr(9)(3:3).eq.'a')write(nwr,'(a,i4,2x,/,a,/2a)')             &
       '#thselect mthsl=',mthsl,TRIM(queryar(mthsl)),                   &
        '  nameth_as=',TRIM(nameth_as)                                   
!    -----------------------------------------------------------        
      ch1=' ' 
      nameth_as=hname(mthsl)(:npl-7) 
      nstruct='theory selected:'//queryar(mthsl)(:npl-7) 
      call chcenter(nstruct,ch1,npl) 
      if(lksto.gt.1) then 
!       write(nwr,'(1x,a1,a3)') char(27),'[2A'                          
       if(.not.b_ig) write(nwr,'(a)') nstruct(:npl) 
       if(wrb.eq.'w')write(10,'(a)') nstruct(:npl) 
       if(wrb.eq.'r') then 
       read(10,'(a)') ch132 
       end if 
      end if 

      jth=itheory(mthsl,1) 
      l_jth=itheory(mthsl,2) 
      j=2*levelth 
      kssthe(0)=j 
      kssthe(j-1)=itheory(mthsl,1) 
      kssthe(j)=itheory(mthsl,2) 
      levelth=levelth+1 
!      write(6,'(i2,a,16i4)')levelth,'=levelth ;seltheory kssthe(0..)=',&
!          (kssthe(i),i=1,j)                                      
                                                                        
!     call for constants from handbook                                  
      cmch='hdbk' 
      nhelpentry=' ' 
      kth=jth 
      call getthstring(kth,l_jth,cmch,nhelpentry) 
      i=index(nstruct,'handbook') 
      if(i.gt.0) then 
       ientry=0 
       call handbook(wrb,ientry,info) 
      end if 
      cmch='empt' 
      if(info.gt.0) return 
                                                                        
!     call for constants and parameters                                 
      cmch='copa' 
      kth=jth 
                                                                        
      call getthstring(kth,l_jth,cmch,nhelpentry) 
                                                                        
100   continue
      return 
      END                                           
                                                                        
                                                                        
       character*1 function chremove(chcom,text) 
       use glbconst, only: nrd,nwr
       implicit none 
       integer k 
       character(len=132):: ch132,chcom
       character(len=80) :: text
       character(len=1)  :: ch1
                                                                        
        do k=80,1,-1 
         if(text(k:k).ne.' ') goto 10 
        end do 
                                                                        
   10   ch1='y' 
   20   write(nwr,'(2a,3a1)') ' remove',text(1:k),'[',ch1,']' 
        read(nrd,'(a)') ch132 
        call lc_character(ch132) 
        if(ch132(1:2).eq.'he') then 
           call help(chcom) 
          goto 20 
        end if 
        if(ch132(1:1).eq.'y') then 
         ch1='y' 
         goto 20 
        end if 
        if(ch132(1:1).eq.'n') then 
         ch1='n' 
         goto 20 
        end if 
        if(ch1.eq.'y') write(nwr,'(2a)') text(1:k),' :fixed to zero ' 
        chremove=ch1 
        return 
      END                                           
                                                                        
     subroutine rearrangep 
     use glbconst, only: maxscr,maxco,        &
                         maxfr2,maxthss,maxcom,maxvaco,nrd,enwr
     use compar, only: maxsto
     use comeff, only: strtm,strth
     implicit none 
                                                                       
     character(len=132):: cp132,ch132
     character(len=24) :: chl,chr
     character(len=7)  :: form
     character(len=8)  :: ch8

     integer     i,i0,ipos,im,iout,j,jl,jco,jseq,jhr,jh_r,      &
                 k,l,nadd,nn,nads                                    
     real        rn 

     integer, dimension(maxco):: ind
     real,    dimension(32)   :: out


      form='i3' 
      jhr=0 
      jh_r=0 
      nadd=0 
      nads=0
      jseq=0 
      jco=0 
      i0=ichar('0') 
                                                                        
!      jtm=1                                                            
!      do while(strtm(jtm,1)(1:5).ne.'#beg#'.and.jtm.lt.16)             
!      do while(strtm(jtm,1)(1:5).ne.'#beg#')                           
!       write(6,'(a,i2,2a)')'p-ins strtm(',jtm,',1)=',strtm(jtm,1)(:60) 
!       jtm=jtm+1                                                       
!      end do                                                           
                                                                        
      j=1 
      do while(j.le.maxvaco.and.strtm(j,1)(1:5).ne.'#beg#') 
!       write(6,'(i4,a)') j,strtm(j,1)(:60)                             
                                                                        
       if(strtm(j,1)(1:5).eq.'#end#') then 
!       write(6,'(a,3i4,2x,a)')'##', j,jh_r,jhr,strtm(j,1)(:60)               
        k=LEN_TRIM(strtm(j,1))
        ch8= strtm(j,1)(k-1:k); call c8toi(ch8,k); nads=nads+k 
        do k=jh_r+1,jhr 
         i=index(strth(k,2),' ') 
         if(i.eq.0)then 
          print'(i4,a)', k,TRIM(strth(k,2)) 
          i=1 
         end if 
         ch132=strth(k,2)(i:) 
         call trlch(80,ch132,iout,out) 
         rn=nadd+out(1)+0.01
         call trlnu(form,rn,chr,nn,chl,im) 
         call nextchar(ch132,0,ipos,cp132,l) 
!         write(6,'(2i3,a,a)')ipos,l,' cp132=',cp132(1:20)              
         chr=strth(k,2)(1:i) 
         strth(k,2)(1:24)=chr 
         strth(k,2)(25:)=chl(1:3)//cp132(l+1:) 
        end do 
        jh_r=jhr 
        ch132=strtm(j,1)(6:) 
        call trlch(20,ch132,iout,out) 
        nadd=nadd+out(1)
        jseq=jseq+1 
       else 
        i=index(strtm(j,1),' ') 
        ch132=strtm(j,1)(i:) 
        call nextchar(ch132,0,ipos,cp132,l) 
        chr=strtm(j,1)(1:i) 
        strtm(j,1)=chr(1:24)//cp132 
        ch132=strtm(j,1)(24:) 
!        write(6,'(a,i4,2x,a)')'thselect ', j,strtm(j,1)(:60)           
                                                                        
        call trlch(24,ch132,iout,out) 
        jhr=jhr+out(1) 
        jco=jco+1 
        ind(jco)=j 
       end if 
       j=j+1 
       if(j-1.eq.maxco) goto 10 
      end do 
      jl=j-2
  10 jseq=jseq-1 
!     write(6,'(i3,a,20i3)')nadd,' thselect ind(1..jco)=',(ind(k),k=1,jco)      
                                                                        
      do k=1,jco 
       strtm(k,1)=strtm(ind(k),1) 
      end do 
      do k=1,jco 
       strtm(k,2)=strtm(ind(k),2) 
      end do
      if(nads.gt.nadd) then
       nadd=nads
      else if(nads.gt.0.and.nads.lt.nadd) then
       print'(2a,/,a)',' **mismatch**',  &
       'variable position nn in string "conn" is less than',   &
       ' last position in the common block defined by jp(>nn)' 
       if(jl.gt.0)then
        rn=nadd 
        call trlnu(form,rn,chr,nn,chl,im) 
        k=index(strtm(jl,1),'('); j=index(strtm(jl,1),')')
        print'(2(a,/),a)',&
        ' the last matrix which variables are added to the common block:',&
               strtm(jl,1)(1:24)//' matrix='//strtm(jl,1)(k:j),&
        '(in string "conn": nn should be>=: nn='//chl(1:3)//')'         
       if(enwr(15).eq.'cova') read(nrd,*) 
       end if
      end if
      rn=nadd 
      call trlnu(form,rn,chr,nn,chl,im) 
      strtm(jco+1,1)='#end# '//chl(1:3)
      strtm(jco+2,1)='#beg# ' 
                                                                        
      return 
      END                                           
                                                                         
     subroutine rearrangec 
     use glbconst, only: maxfr2,maxcom,maxvaco,maxthss,nrd,enwr
     use compar, only: maxsto
     use comeff, only: strco
     use comscd, only: scrstring
     implicit none 
                                                                       
     character(len=132):: ch132
     character(len=24) :: chl,chr
     character(len=7)  :: form
     character(len=8)  :: ch8

     integer  i,im,iout,j,jl,jco,jseq,k,nadd,nads,nadds,nn                  
                                                                       
     real        rn 
     integer, dimension(0:16) :: ns_seq
     real,    dimension(32)   :: out
!     write(6,'(a)')'rearrangec(nss_seq)'                              
      form='i3' 
      nadd=0 
      nads=0
      nadds=0
      jseq=1 
      jco=0 
      j=1
      do while(j.le.maxvaco.and.strco(j)(1:5).ne.'#beg#') 
!      write(6,'(i4,a)')j,TRIM(strco(j)) 
                                                                        
       if(strco(j)(1:5).eq.'#end#') then 
        k=LEN_TRIM(strco(j))
        ch8= strco(j)(k-3:k-2); call c8toi(ch8,k); nads=nads+k
        nadds=nadds+k 
        if(k.eq.0)then
         k=LEN_TRIM(strco(j))
         ch8= strco(j)(k-1:k); call c8toi(ch8,k); nadds=nadds+k
        end if
!        write(6,'(i4,a,2i5)')j,TRIM(strco(j)),nads,nadds
        !        ch132=strco(j)(6:) 
!        call trlch(15,ch132,iout,out) 
!        nadd=nadd+out(1) 
         nadd=nadds
        ns_seq(jseq)=jco  
        jseq=jseq+1 
       else 
        ch132=strco(j)(25:27) 
        call trlch(3,ch132,iout,out) 
        rn=nadd+out(1) 
        call trlnu(form,rn,chr,nn,chl,im) 
        strco(j)(25:27)=chl(1:3) 
        jco=jco+1 
        scrstring(jco)=strco(j) 
!        write(6,'(a,i4,a)')'###',jco,scrstring(jco)(:60)               
       end if 
       j=j+1 
       if(j-1.eq.maxvaco) goto 10 
      end do 
      jl=j-2
   10 jseq=jseq-1 
!      write(6,'(a,10i4)') '        jseq,jco,nadd=',jseq,jco,nadd            
!     write(6,'(a,16i4)') '  ns_seq(0:)=',(ns_seq(i),i=0,12)
        
      j=1 
      ns_seq(0)=0 
      do i=1,jseq 
       do k=ns_seq(i-1)+1,ns_seq(i) 
         strco(j)=scrstring(k) 
         j=j+1 
       end do 
      end do 
      if(nads.gt.nadd) then
       nadd=nads
      else if(nads.gt.0.and.(nads.lt.nadd.and.nadds.lt.nadd)) then
       rn=nadd 
       call trlnu(form,rn,chr,nn,chl,im) 
       print'(2a,/,a)',' **mismatch**',  &
       ' constant position nn in string cova="nnva" is less than',   &
       ' last position in the common block defined by ipos=m (>nn)' 
       if(jl.gt.0)print'(a,/,2a)',    &
        ' the last constant added to the common block:',strco(jl)(1:24)//&
        '(in string cova="nnva": nn should be>=: nn='//chl(1:3)//')'
       if(enwr(15).eq.'cova') read(nrd,*) 
      end if
      rn=nadd 
      call trlnu(form,rn,chr,nn,chl,im) 
                                                                        
      strco(j)='#end# '//chl(1:3) 
      strco(j+1)='#beg# ' 
!     write(6,'(a)') (strco(k)(:70),k=1,j+1)                           
      return 
      END                                           
                                                                        
      subroutine getprop(info) 
      use glbconst, only: maxfr1,maxfr2,maxthss,maxs,infotext,enwr
      use comfrm, only: mkaddsp,mpaddsp,mkaddss,mpaddss
      use comstr, only: namepg
      use comdas, only: ktheo,istrss
      use comeff, only: pointerks,pointerstr
      use comthe, only: theoryname
      implicit none 
                                                                        
      integer   info,kststr,kvp,kpv,itype,istruct1,istruct2 
      dimension kststr(maxthss),kvp(0:maxthss),kpv(0:maxthss),          &
                itype(0:maxthss),istruct1(0:maxfr1),istruct2(0:maxfr2)  
                                                                        
      real      out(32) 
      character(len=132):: cp132,chout,ch132
      character(len=80) :: nath
      character(len=14) :: ch14
      character(len=8)  :: ncopa
      character(len=4)  :: cmch
      character(len=1)  :: ch1
      integer    i,i0,iset,iss,ith0,icase,istr,i1,i10,ith,              &
                 isubthe_n,iput,iget,itheo,ipos,                        &
                 j,jss,jc,jv,k,ks,l,lt,llth,lh,l_theo,                  &
                 lstruct1,lstruct2,lstruct3,mstruct1,                   &
                 n,nn,nj,n_theo,nnth,ntheo
                                                                         
!      write(6,'(a)')'getprop(info)'                                    
!     ktheo(iset,iss,0)=0    iss empty                                  
!     istrss(iset,iss) <0  getfrstring, getthstring                     
!                        >0               getthstring                   
                                                                        
      i0=ichar('0') 
      jss=0 
      pointerks(0)=0 
      pointerstr=' '
      do iset=1,maxs 
       do iss=0,maxthss 
        ith0=ktheo(iset,iss,0) 
        if(ith0.gt.0) then 
         jss=jss+1 
!         write(6,'(a,i4)') ' getprop ktheo(iset,iss,0)=',ith0          
!         write(6,'(a,6i4)') ' ktheo(iset,iss,0..)=',   &                
!                                 (ktheo(iset,iss,i),i=0,ith0)  
                                
                                                                        
         if(iss.eq.0) then 
          ks=ks+1 
          do k=1,maxthss 
           kststr(k)=istrss(iset,k) 
          end do 
!          write(6,'(a,20i3)')' thselect kststr=',(kststr(k),k=1,10)    
          call strkvp(kststr,kvp,kpv,itype,mstruct1,istruct1,istruct2) 
          i1=ith0 
          i10=i1/10 
          i1=i1-10*i10 
          pointerstr(jss)='00000000 0'//char(i10+i0)//char(i1+i0) 
          jc=0 
          jv=0 
          do ith=3,ith0,2 
           cmch='name' 
           n_theo=ktheo(iset,0,ith) 
           l_theo=ktheo(iset,0,ith+1) 
!          write(6,'(a,i3,2x,4i3)')'ith,iset,n_theo,l_theo=',           
!     &                       ith,iset,n_theo,l_theo                    
                                                                        
           nnth=n_theo 
           llth=l_theo 
           namepg(l_theo)='nocall' 
           call getnu_copa(nnth,llth,ncopa,info) 
           call getthstring(n_theo,l_theo,cmch,chout) 
           chout=namepg(l_theo) 
           call nextchar(chout,0,ipos,ch132,lh) 
!          identification of the number of the theory in the            
!          distribution list by the name of the theory                  
!    ------------                                                       
           if(ch132(1:lh).eq.'nocall') then 
            ch14(1:14)='nono00000000n ' 
           else 
!    ------------                                                       
           isubthe_n=-16
           ntheo=0 
           nj=1 
           i=0 
           do while(ntheo.lt.nj) 
            ntheo=ntheo+1 
            n=ntheo 
            theoryname=' ' 
            nath=' '
            call distribth(isubthe_n,n,icase,iput,iget,nath,info) 
            nj=n 
            l=index(theoryname,'v=') 
            if(l.gt.0)then 
             lt=l-2 
            else 
             lt=72 
            end if 
            do while(theoryname(lt:lt).eq.' ') 
             lt=lt-1 
            end do 
!            write(6,'(a,a1/,a,2x,i6,2x,4i4)')theoryname(1:lt),'#',&     
!            ch132(1:lh),ntheo,lt,ichar(theoryname(lt:lt)),lh,ichar(ch132(lh:lh))                                   
            if(theoryname(1:lt).eq.ch132(1:lh)) then 
             itheo=ntheo 
             i=i+1 
            end if 
           end do 
           ntheo=itheo 
!          write(6,'(i3,2x,a)')iss,ch132(:80)                           
!          write(6,'(a,2i4)')' a thselect i,ntheo=',i,ntheo             
                                                                        
           if(i.eq.0) then 
            info=n_theo 
            lt=72 
!            do while(nameth(l_theo-1)(lt:lt).eq.' ')                   
!             lt=lt-1                                                   
!            end do                                                     
            infotext(1)='effi/structure/theory/name' 
            infotext(2)(1:19)='*** fatal error ***' 
            infotext(3)='theory name:'//ch132(1:lh)//' not found'
            infotext(4)='ntheo =(info), examine str_*.f ' 
            infotext(5)=' ' 
           else if(i.gt.1) then 
            info=ntheo 
            infotext(1)='effi/structure/theory/number' 
            infotext(2)(1:19)='*** fatal error ***' 
            infotext(3)=                                                &
              'theory name "'//ch132(1:lh)//'" found more than once'    
            infotext(4)=' ' 
           end if 
           i10=ntheo/10 
           i1=ntheo-10*i10 
           ch14(5:6)=char(i10+i0)//char(i1+i0) 
                                                                        
           call nextchar(ch132,2,ipos,cp132,lh) 
           ch14(1:4)=cp132(1:4) 
           ch132=cp132(5:8) 
           call trlch(6,ch132,nn,out) 
           if(nn.ne.1) then 
            info=nn 
            infotext(1)='effi/structure/theory/number' 
            infotext(2)(1:19)='*** fatal error ***' 
            infotext(3)='in set up of theory numbers:' 
            infotext(4)=chout 
            infotext(5)=' ' 
           end if 
           i1=out(1) 
           i10=i1/10 
           i1=i1-10*i10 
           ch14(7:8)=char(i10+i0)//char(i1+i0) 
                                                                        
            cp132=ncopa 
            call trlch(8,cp132,nn,out) 
!           k=index(chout,'nu-con_var=')                                
!           cp132=chout(k+11:k+20)                                      
           ch14(13:14)='t ' 
           jc=jc+out(1) 
           jv=jv+out(2) 
           do k=1,2 
            i1=out(k) 
            i10=i1/10 
            i1=i1-10*i10 
            i=(k-1)*2+1 
            i=(k-1)*2+9 
            ch14(i:i+1)=char(i10+i0)//char(i1+i0) 
           end do 

           end if ! nocall
           j=12+(ith-1)*7 
           pointerstr(jss)(j+1:j+14)=ch14 
          end do 
          ch14(1:4)='fram' 
          ch14(5:8)='0000' 
          ch14(13:14)='f ' 
          out(1)=mkaddsp(iset)-jc 
          out(2)=mpaddsp(iset)-jv 
          do k=1,2 
           i1=out(k) 
           i10=i1/10 
           i1=i1-10*i10 
           i=(k-1)*2+1 
           i=(k-1)*2+9 
           ch14(i:i+1)=char(i10+i0)//char(i1+i0) 
          end do 
          pointerstr(jss)(13:26)=ch14 
         else 
                                                                        
          istr=istrss(iset,iss) 
          if(istr.lt.0) then 
           if(abs(istr).gt.100) then 
            lstruct1=-istr/100 
            lstruct2=-istr-100*lstruct1 
           else 
            lstruct1=-istr/10 
            lstruct2=-istr-10*lstruct1 
           end if 
           lstruct3=0 
          else 
           lstruct3=istr 
          end if 
!          write(6,'(a,5i4)') ' iss,istr,lstruct1,2,3=', &               
!                        iss,istr,lstruct1,lstruct2, lstruct3 
          i1=lstruct1 
          i10=i1/10 
          i1=i1-10*i10 
!         ch14(1:6)=cstrss(iset,iss)                                    
          ch14(1:2)=char(i10+i0)//char(i1+i0) 
          i1=lstruct2 
          i10=i1/10 
          i1=i1-10*i10 
          ch14(3:4)=char(i10+i0)//char(i1+i0) 
          i1=lstruct3 
          i10=i1/10 
          i1=i1-10*i10 
          ch14(5:6)=char(i10+i0)//char(i1+i0) 
          i1=kvp(iss) 
          i10=i1/10 
          i1=i1-10*i10 
          ch14(7:8)=char(i10+i0)//char(i1+i0) 
          i1=itype(iss) 
          ch14(9:10)=' '//char(i1+i0) 
          i1=ith0 
          i10=i1/10 
          i1=i1-10*i10 
          pointerstr(jss)=ch14(1:10)//char(i10+i0)//char(i1+i0) 
                                                                        
          cmch='name' 
                                                                        
!         introduced 4.1.2005                                           
          jc=0 
          jv=0 
          do ith=3,ith0,2 
           n_theo=ktheo(iset,iss,ith) 
           l_theo=ktheo(iset,iss,ith+1) 
           nnth=n_theo 
           llth=l_theo 
           call getnu_copa(nnth,llth,ncopa,info) 
           cp132=ncopa 
           call trlch(8,cp132,nn,out) 
           jc=jc+out(1) 
           jv=jv+out(2) 
           ch14(13:14)='t ' 
          end do 
!         counting constants and variables of subtheories               
!         -subtracted below                                             
                                                                        
          do ith=1,ith0,2 
           n_theo=ktheo(iset,iss,ith) 
           l_theo=ktheo(iset,iss,ith+1) 
           if(ith.eq.1.and.lstruct3.eq.0) then        ! fr_not_fr 
             out(1)=mkaddss(iset,iss)-jc  ! 4.1.2005  
             out(2)=mpaddss(iset,iss)-jv  ! 4.1.2005  
!            write(6,'(a,2i2,a2,i4)')                                   
!     &      'thselect#### mkaddsp(',iset,iss,')=',mkaddsp(iset)        
            ch14(1:4)='fram' 
            ch14(5:8)='0000' 
            ch14(13:14)='f ' 
           else 
            nnth=n_theo 
            llth=l_theo 
            namepg(l_theo)='nocall' 
            call getnu_copa(nnth,llth,ncopa,info) 
            call getthstring(n_theo,l_theo,cmch,chout) 
            chout=namepg(l_theo) 
            call nextchar(chout,0,ipos,ch132,lh) 
!           ------------                                                
            if(ch132(1:lh).eq.'nocall') then 
             ch14(1:14)='nono00000000n ' 
            else 
!           ------------                                                
!            write(6,'(a,2x,a,2x,i4)')theoryname                        
!            write(6,'(a,2x,a,2x,i4)')ch132(1:lh)                       
                                                  ! nicht_wirklich_klar 

             if(enwr(15).eq.'nath') print'(/,2a)',  &
              'search for theoryname=',ch132(1:lh)

             isubthe_n=-16 
             ntheo=0 
             nj=1 
             i=0 

             do while(ntheo.lt.nj) 
              ntheo=ntheo+1 
              n=ntheo 
              theoryname=' ' 
              call distribth(isubthe_n,n,icase,iput,iget,nath,info) 
              nj=n 
              l=index(theoryname,'v=') 
              if(l.gt.0)then 
               lt=l-2 
              else 
               lt=72 
              end if 
              do while(theoryname(lt:lt).eq.' ') 
               lt=lt-1 
              end do 
              ch1=' '
              if(theoryname(1:lt).eq.ch132(1:lh)) then 
               itheo=ntheo 
               i=i+1
               ch1='*' 
              end if 
              if(enwr(15).eq.'nath') print'(a,a24,a,i2,a3,a1,2a)','subroutine ', &
               TRIM(nath),' (ntheo=',ntheo,')  ',ch1,'theoryname=',theoryname(1:lt) 
             end do 
             ntheo=itheo 
!            write(6,'(a,2i4)') 'b thselect i,ntheo=',i,ntheo           
                                                                        
             if(i.eq.0) then 
              info=ntheo 
              infotext(1)='effi/structure/theory/number' 
              infotext(2)(1:19)='*** fatal error ***' 
              infotext(3)='theory name :'//ch132(1:lh)//' not found' 
              infotext(4)='ntheo =(info), examine str_*.f ' 
              infotext(5)=' ' 
             else if(i.gt.1) then 
              info=ntheo 
              infotext(1)='effi/structure/theory/number' 
              infotext(2)(1:19)='*** fatal error ***' 
              infotext(3)=                                              &
              'theory name '//ch132(1:lh)//' found more than once'      
              infotext(4)=' ' 
             end if 
             i10=ntheo/10 
             i1=ntheo-10*i10 
             ch14(5:6)=char(i10+i0)//char(i1+i0) 
             call nextchar(ch132,2,ipos,cp132,lh) 
             ch14(1:4)=cp132(1:4) 
             ch132=cp132(5:8) 
             call trlch(6,ch132,nn,out) 
             if(nn.ne.1) then 
              info=nn 
              infotext(1)='effi/structure/theory/number' 
              infotext(2)(1:19)='*** fatal error ***' 
              infotext(3)='in set up of theory numbers:' 
              infotext(4)=chout 
              infotext(5)=' ' 
             end if 
             i1=out(1) 
             i10=i1/10 
             i1=i1-10*i10 
             ch14(7:8)=char(i10+i0)//char(i1+i0) 
                                                                        
             cp132=ncopa 
             call trlch(8,cp132,nn,out) 

!            k=index(chout,'nu-con_var=')                               
!            cp132=chout(k+11:k+20)                                     
             ch14(13:14)='t ' 
            end if 
           end if 
                                                                        
           do k=1,2 
            i1=out(k) 
            i10=i1/10 
            i1=i1-10*i10 
            i=(k-1)*2+9 
            ch14(i:i+1)=char(i10+i0)//char(i1+i0) 
           end do 
                                                                        
           j=12+(ith-1)*7 
           pointerstr(jss)(j+1:j+14)=ch14 
          end do 
         end if         ! iss > 0 
        end if          ! ith0 > 0 
       end do           ! iss  
       pointerks(iset)=jss 
                       ! iset                                           
      end do 
                                                                        
!      write(6,'(a,i4)') 'pointerks '                                   
!      write(6,'(i8)') (pointerks(i),i=0,3)                             
!      write(6,'(a,i4)') 'pointerstr jss=',jss                          
!      do k=1,jss                                                       
!       write(6,'(a)') pointerstr(k)(:80)                               
!      end do                                                           
                                                                        
      return 
      END                                           
                                                                        
     subroutine handbook(wrb,ientry,info) 
     use glbconst, only: maxco,maxvaco,infotext,nrd,nwr
     use comeff, only: strco,npl,utpath
     use comstr, only: nstruct,lp_handbook
     use comscd, only: helpar,queryar,ext,scrstring
     implicit none 
                                                                       
     integer   info 
     character(len=132):: nhelpentry,handbookfile,     &
                          cheader,ch132,ct132,cp132
     character(len=80) :: chdf
     character(len=32) :: nhandbook
     character(len=8)  :: ch8,chth
     character(len=2)  :: ch2
     character(len=1)  :: wrb

     integer, dimension(maxvaco):: nlist
     real,    dimension(32)     :: out

     integer     i,ientry,iquerry,iq,ihdb,ilist,iout,ii,imax,ig,ipos,  &
                 j,jc,jhb,k,l,lk,lksto,lh,lt,m,nu,ntrimto0
     logical b_exist 
!     nstruct=handbook  nuclear.hbk chth=thxxxxxx                       
!       write(6,'(a,a1,2x,i3,a)')'wrb,ientry,nstruct=',wrb,ientry,      
!     &  nstruct(:70)                                                   
      info=0 
                                                                        
       if(ientry.eq.-1) then 
        lp_handbook=0 
        ientry=0 
        return 
       end if 
                                                                        
                                                                        
       i=index(nstruct,'handbook=') 
       j=index(nstruct,'list=') 
       k=index(nstruct,'chth=') 
       m=index(nstruct,'.hdb') 
                                                                        
       nhandbook=nstruct(i+9:m+3) 
       nhelpentry=nstruct(j+5:k-1) 
       chth=nstruct(k+5:k+12) 
!       write(6,'(2a)') ' thselect  nhandbook=',nhandbook               
!       write(6,'(2a)') ' thselect nhelpentry=',nhelpentry(:60)         
!       write(6,'(2a)') ' thselect     chth=',chth                      
                                                                        
       l=LEN_TRIM(utpath) 
       if(l.gt.2) then 
        handbookfile=utpath(:l)//'/'//nhandbook 
       else 
        handbookfile=nhandbook 
       end if 
        inquire(file=handbookfile,exist=b_exist) 
!       write(6,'(a,L5,a)') 'comsub1 b_exist=',b_exist,cheader(1:l)     
                                                                        
       if(b_exist) then 
        nu=3 
        open(unit=nu,file=handbookfile                                  &
                ,status='old'                                           &
                ,access='sequential'                                    &
                ,form='formatted')                                      
       else 
        info=1 
        infotext(1)='effi/select/handbook' 
        infotext(2)(1:20)=' *** error ***' 
        infotext(3)='handbook file:'//TRIM(handbookfile)//' not found' 
        infotext(4)='check environment variable EFFIUTPATH' 
        infotext(5)=' ' 
        return 
       end if 
       cheader=nhandbook 
                                                                        
       if(ientry.eq.0) then 
        k=1 
!       write(6,'(2a)')' thselect strco(1)=',strco(1)(:40)              
        do while(strco(k)(:5).ne.'#beg#'.and.k.lt.maxvaco) 
!        write(6,'(2a)')' thselect strco(k)=',strco(k)(:40)             
         k=k+1 
        end do 
        jc=k-1 
                                                                        
        i=index(nhandbook,'.') 
        cp132='xx' 
        jhb=0 
        do while(cp132.ne.' ') 
         read(nu,'(a)')cp132 
!         write(6,'(a)')cp132(:80)                                      
         if(cp132(1:1).ne.'#') then 
          jhb=jhb+1 
          call itoc8(ch8,jhb) 
          ch8(1:1)='0' 
          queryar(jhb)=cp132 
                                                                        
          ct132='handbook_'//nhandbook(1:i-1)//'/hb' 
          if(jhb.lt.9) then 
           helpar(jhb)=ct132(1:i+11)//ch8(1:2)//'/select' 
          else 
           helpar(jhb)=ct132(1:i+11)//ch8(2:3)//'/select' 
          end if 
         end if 
        end do 
        jhb=jhb-1 
!       write(6,'(2a)') ' thselect-2 nhelpentry=',nhelpentry(:60)       
                                                                        
    9   if(lp_handbook.gt.0) then 
         iquerry=lp_handbook 
         iq=iquerry 
        else 
         iquerry=1 
         iq=jhb 
        end if 
        lk=jhb 
        lksto=lk 
        do k=1,lk 
         ext(k)=' ' 
        end do 
   10   chdf=queryar(iquerry) 
        chdf(80:80)='#' 
!       write(6,'(a,2i4,a)')' handbook,lk,chdf=',lk,lp_handbook,chdf    
!       write(6,'(2a)') ' thselect-2 nhelpentry=',nhelpentry(:60)       
                                                                        
        if(wrb.ne.'o')then 
         cheader(132:132)=wrb 
         call query(iq,lk,cheader,chdf) 
         if(iq.eq.0) goto 9 
                                                                        
         lp_handbook=iq 
         iquerry=iq 
        end if 
                                                                        
        if(jhb.le.0) then 
         write(nwr,'(2a,/,a)') '*error* no '//ch132(:lh-4)//' choosen ',&
     &   '(do not use: q/* ret, but just ret)',                         &
     &   ' to go back'                                                  
         iq=lksto 
         lk=lksto 
         jhb=lksto 
         read(nrd,'(a)') 
         goto 10 
        end if 
        ct132=queryar(iq) 
        lt=ntrimto0(ct132) 
       else 
        jhb=ientry 
        jc=0 
       end if 
                                                                        
       ihdb=0 
       call gethdb(ihdb,nhandbook) 
       call itoc8(ch8,ihdb) 
       ch8(1:1)='0' 
       if(ihdb.le.9) then 
        chth='hb'//ch8(1:2) 
       else 
        chth='hb'//ch8(2:3) 
       end if 
       call itoc8(ch8,lp_handbook) 
       ch8(1:1)='0' 
       if(lp_handbook.le.9) then 
        chth(5:8)=ch8(1:2) 
       else 
        chth(5:8)=ch8(2:3) 
       end if 
!      write(chth,'(2x,i2,i2,2x)') ihdb,lp_handbook                     
!      chth(1:2)='hb'                                                   
                                                                        
       close(unit=nu) 
       open(unit=nu,file=handbookfile                                   &
     &          ,status='old'                                           &
     &          ,access='sequential'                                    &
     &          ,form='formatted')                                      
                                                                        
   20 cp132='xx' 
      do while(cp132(1:4).ne.'case') 
       read(nu,'(a)')cp132 
!       write(6,'(i4,2a)') jhb,' p1 cp132=',cp132(:40)                  
      end do 
      ch132=cp132(6:) 
!      write(6,'(3a)')ch132(:lt),'..',ct132(:lt)                        
      if(ch132(:lt).ne.ct132(:lt)) goto 20 
                                                                        
                                                                        
      do i=1,maxvaco 
       nlist(i)=0 
      end do 
      j=0 
      ilist=0 
      cp132='xxx' 
      do while(cp132(1:7).ne.'endcase') 
       read(nu,'(a)')cp132 
!       write(6,'(a,i4)') cp132(:60),ilist                              
       if(cp132(1:1).ne.'#') then 
        if(cp132(1:4).eq.'list') then 
         ilist=ilist+1 
         nlist(ilist)=j 
        else 
         j=j+1 
         scrstring(j)=cp132 
        end if 
       end if 
      end do 
      nlist(ilist+1)=j-1 
!      write(6,'(a,i4)') 'thselect handbook ientry=',ientry             
      if(ientry.gt.0) then 
       jhb=0 
       ch132=nhelpentry 
       call trlch(npl,ch132,iout,out) 
!      write(6,'(2a)') ' thselect nhelpentry=',nhelpentry(:60)          
!      write(6,'(a,10i4)') ' thselect out(1:)=',(int(out(i)),i=1,iout)  
       if(iout.gt.0) then 
        do i=1,iout 
         ii=out(i) 
         do k=nlist(ii)+1,nlist(ii+1) 
          jhb=jhb+1 
         end do 
        end do 
       end if 
       ientry=jhb 
      else 
       jhb=jc 
       ch132=nhelpentry 
       call trlch(npl,ch132,iout,out) 
!      write(6,'(2a)') ' thselect nhelpentry=',nhelpentry(:60)          
!      write(6,'(a,10i4)') ' thselect out(1:)=',(int(out(i)),i=1,iout)  
       if(iout.gt.0.and.out(1).gt.0) then 
        j=0 
        imax=1 
        do i=1,iout 
         ii=out(i) 
         do k=nlist(ii)+1,nlist(ii+1) 
          j=j+1 
          cp132=scrstring(k) 
          if(cp132(1:4).ne.' ') then 
           jhb=jhb+1 
           strco(jhb)=' ' 
           ig=index(cp132,'=') 
           strco(jhb)(1:ig-1)=cp132(:ig-1) 
           ct132=cp132(ig+1:) 
           call nextchar(ct132,0,ipos,ch132,lh) 
           call nextchar(ch132,lh,ipos,ct132,lt) 
           call itoc8(ch8,j) 
           ch2=ct132(:lt) 
           if(ch2(2:2).eq.' ')then 
            chth(7:8)='0'//ch2 
           else 
            chth(7:8)=ch2 
           end if 
           strco(jhb)(33:)=ch132(:lh)//'/'//chth 
           strco(jhb)(25:27)=ch8 
           ct132=strco(jhb)(:24)//'='//ch132(:lh) 
           if(wrb.ne.'o')                                               &
           write(nwr,'(a,a)') ' included from handbook:',ct132(1:25+lh) 
          end if 
         end do 
        end do 
        call itoc8(ch8,j) 
        strco(jhb+1)='#end# '//ch8 
        strco(jhb+2)='#beg# ' 
       else 
        strco(1)='#end# '//'0 ' 
        strco(2)='#beg#' 
       end if 
      end if 
!     write(6,'(a,i4)') 'thselect  handbook jhb=',jhb                   
!     write(6,'(a)') (strco(k)(:70),k=1,jhb+2)                          
      close(unit=nu) 
      return 
      END                                           
                                                                        
                                                                        
      subroutine getfrnu_copa(nfrtheo,l_nfrtheo,ncopa,istr,info)
      use comeff, only: strco,strtm,strth
      use comstr, only: lp_handbook,nstruct
      implicit none 
                                                                        
      integer   nfrtheo,l_nfrtheo,istr,lstruct1,lstruct2, &
                info,ntheo,ltheo,i,ientry,k
      character(len=132):: chout
      character(len=8)  :: ncopa 
      character(len=4)  :: cmch,pa4,co4 
      character(len=1)  :: wrb
                                                                        
      strco(1)='#end#    0  ' 
      strco(2)='#beg#' 
                                                                        
      strtm(1,1)='#end#  0  ' 
      strtm(2,1)='#beg#' 
      strth(1,1)=' ' 
      strth(1,2)=' ' 
      lstruct1=0; lstruct2=0
      if(abs(istr).gt.100) then                                    
       lstruct1=-istr/100                                         
       lstruct2=-istr-100*lstruct1                                
        else                                                        
       lstruct1=-istr/10                                          
       lstruct2=-istr-10*lstruct1                                 
      end if  
                                                                       
      ntheo=nfrtheo 
      ltheo=l_nfrtheo 
      cmch='hdbk' 
      nstruct=' ' 
      chout=' ' 
      call getfrstring(ntheo,ltheo,lstruct1,lstruct2,cmch,chout) 
      i=index(nstruct,'handbook') 
      if(i.gt.0) then 
       if(lp_handbook.eq.0)lp_handbook=1 
       ientry=0 
       wrb='o' 
       call handbook(wrb,ientry,info) 
      end if 

      ntheo=nfrtheo 
      ltheo=l_nfrtheo 
      cmch='copa' 
      call getfrstring(ntheo,ltheo,lstruct1,lstruct2,cmch,chout) 
      call rearrangec
      call rearrangep 
      k=1      
      do while(strco(k)(:5).ne.'#beg#') 
!       write(6,'(i2,2x,a)')k,strco(k)(:60)                             
       k=k+1 
      end do 
      co4=strco(k-1)(7:) 
!      write(6,'(a4,i4,2x,a)')co4,k,strco(k-1)(7:)
      
      k=1 
      do while(strtm(k,1)(:5).ne.'#beg#') 
!      write(6,'(i2,2x,a)')k,strtm(k,1)(:60)                           
       k=k+1 
      end do 
      pa4=strtm(k-1,1)(7:) 
      ncopa=co4//pa4 
                                                                        
!      write(6,'(3i4,a)')k-1,nfrtheo,l_nfrtheo,' frnu-con_var='//ncopa
!      read(5,*)
      return 
      END                                           
                                                                        
      subroutine getnu_copa(n_theo,l_theo,ncopa,info) 
      use comeff, only: strco,strtm,strth
      use comstr, only: lp_handbook,nstruct
      implicit none 
                                                                        
      integer   n_theo,l_theo,info,ntheo,ltheo,i,ientry,k
      character(len=132):: chout
      character(len=8)  :: ncopa 
      character(len=4)  :: cmch,pa4,co4 
      character(len=1)  :: wrb
                                                                        
      strco(1)='#end#    0  ' 
      strco(2)='#beg#' 
                                                                        
      strtm(1,1)='#end#  0  ' 
      strtm(2,1)='#beg#' 
      strth(1,1)=' ' 
      strth(1,2)=' ' 
                                                                        
      ntheo=n_theo 
      ltheo=l_theo 
      cmch='hdbk' 
      nstruct=' ' 
      chout=' ' 
      call getthstring(ntheo,ltheo,cmch,chout) 
                                                                        
      i=index(nstruct,'handbook') 
      if(i.gt.0) then 
       if(lp_handbook.eq.0)lp_handbook=1 
       ientry=0 
       wrb='o' 
       call handbook(wrb,ientry,info) 
      end if 

      ntheo=n_theo 
      ltheo=l_theo
      cmch='copa' 
      call getthstring(ntheo,ltheo,cmch,chout) 
      call rearrangec
      call rearrangep 
      k=1 
      do while(strco(k)(:5).ne.'#beg#') 
!       write(6,'(i2,2x,a)')k,strco(k)(:60)                             
       k=k+1 
      end do 
      co4=strco(k-1)(7:) 
                                                                        
      k=1 
      do while(strtm(k,1)(:5).ne.'#beg#') 
!      write(6,'(i2,2x,a)')k,strtm(k,1)(:60)                           
       k=k+1 
      end do 
      pa4=strtm(k-1,1)(7:) 
      ncopa=co4//pa4 
                                                                        
!     write(6,'(2i4,2a)')n_theo,l_theo,' nu-con_var='//ncopa 
      return 
      END                                           
                                                                        
      subroutine convarmatpar(cccc,jc,jv,jm,jp,chth) 
      use comstr, only: strcmt,thco,thvr,thpa,ntrmt,ctrmt
      use comeff, only: strco,strtm,strth,jcb,jvb,jmb,jpb
      implicit none 
                                                                        
      integer jc,jv,jm,jp,j,iout,ipos,il,iy,ib,k,l,lt,li,lm,new
      real    out(32) 
      character(len=132)::ch132,ct132
      character(len=8) :: chth
      character(len=4) :: cccc,pa4,co4,ch4
      character(len=6) :: chxx,chyy,chzz
      character(len=80):: ch80
                                                                        
      if(cccc.eq.'coll') then 
                                                                        
       j=1 
       do while(strco(j)(:5).ne.'#beg#') 
       j=j+1 
       end do 
       jcb=j 
                                                                        
       k=1 
       do while(strth(k,2)(:5).ne.' ') 
        k=k+1 
       end do 
       jvb=k 

       k=1 
       do while(strtm(k,1)(:5).ne.'#beg#') 
        k=k+1 
       end do 
       jmb=k 
                                                                        
       k=1 
       do while(strth(k,1)(:5).ne.' ') 
        k=k+1 
       end do 
       jpb=k 
                                                                        
!      write(6,'(a,4i7)')' jcb,jmb,jpb,jvb=',jcb,jmb,jpb,jvb           
       jc=0 
       jv=0 
       jm=0 
       jp=0 
      else 
!      write(6,'(a4,a,4i7)')cccc,'=cccc jc,jv,jm,jp=',jc,jv,jm,jp 
!       ch132=cccc(1:2) 
!      call trlch(4,ch132,iout,out)
!      ch132=cccc(3:4) 
!      call trlch(4,ch132,iout,out)
 
       new=0 
       ch132=strcmt(0) 
       call trlch(32,ch132,iout,out) 
       j=1 
       if(iout.eq.2) j=out(2) 
                                                                        
       iout=index(strcmt(j),'n_set') 
!      dev1           (mstruct1= number of "devices";  []: ask)         
!      comment*24     used as header                                    
!      comment n_set=ab    number  0/uplimit:  comment  ab ##n number  0
!      comment n_set=ab   [number]    device:  comment  ab ##n number# d
!      comment n_set=[ab]  number  0/uplimit:  comment  ab ##  number  0
!      comment n_set=[ab] [number]    device:  comment  ab ##  number# d
       if(iout.gt.0)then
!        write(6,'(a)')TRIM(strcmt(j))               
        ch80=strcmt(j)(1:iout-1) 
        ch132=strcmt(j)(iout+6:) 
        call nextchar(ch132,0,ipos,ct132,lt) 
!        write(6,'(a1,2i3,a2,a)')'u',ipos,lt,' :',ct132(1:60)           
        call nextchar(ct132,lt,ipos,ch132,k) 
!        write(6,'(a1,2i3,a2,a)')'v',ipos,k,' :',ch132(1:60)            
        if(lt.eq.4) then 
         ch80(iout:iout+1)=ct132(2:3) 
         il=index(ch132,'[') 
         if(il.gt.0) then 
          ch80(iout+6:)='## '//ch132(2:k-1)//'# '//ch132(k+1:) 
         else 
          ch80(iout+6:)='## '//ch132(1:k+1)//' 0' 
         end if 
        else 
         ch80(iout:iout+1)=ct132(1:2) 
         il=index(ch132,'[') 
         if(il.gt.0) then 
          ch80(iout+6:)='##n '//ch132(2:k-1)//'# '//ch132(k+1:) 
         else 
          ch80(iout+6:)='##n '//ch132(1:k+1)//' 0' 
         end if 
        end if 
        strcmt(j)=ch80 
!        write(6,'(a)')ch80                                             
       end if 
!      write(6,'(a2,a)')('::',strcmt(j),j=0,10)                         
                                                                        
       iout=index(strcmt(j),'n_device') 
!     dev2,3,4     (istruct1= number of "modules"; []: ask)              
!     comment n_device=ab   number lowlimit                             
!                 :  comment  ab #n  number lowlimit                    
!c                the case ab  [number] lowlimit is not implemented     
!     comment n_device=[ab] [number] lowlimit                           
!                 :  comment  ab #  number# lowlimit                    
!     comment n_devicemodule=[ab] mi [number] lowlimit                   
!                 :  comment  ab  m #  number# lowlimit                 
!     comment n_device=[ab] mij=xx;yy [number] lowlimit                 
!                 :  comment  ab  m m1=xx mn=yy #  number# lowlimit     
!     comment n_device=[ab] mijk=xx;yy;zz [number] lowlimit             
!                 :  comment  ab  m m1=xx mi=yy mn=zz #  number# lowlimit
       if(iout.gt.0)then 
        li=index(strcmt(j),'mi') 
        ch80=strcmt(j)(1:iout-1) 
        ch132=strcmt(j)(iout+9:) 
        call nextchar(ch132,0,ipos,ct132,lt) 
!        write(6,'(a1,2i3,a2,a)')'u',ipos,lt,' :',ct132(1:60)           
        call nextchar(ct132,lt,ipos,ch132,k) 
!        write(6,'(a1,2i3,a2,a)')'v',ipos,k,' :',ch132(1:60)            
                                         ! no query                     
        if(lt.eq.2) then 
         ch80(iout:iout+1)=ct132(1:2) 
         ch80(iout+8:)='#n '//ch132(lt+1:) 
                  ! lt=4                 ! default value                
        else 
         ch80(iout:iout+1)=ct132(2:3) 
         ch80(iout+9:)='# '//ch132(1:) 
!         call nextchar(ch132,k,ipos,ct132,lt)                          
         lt=index(ch132,'[') 
         if(lt.gt.0)then 
          ib=index(ch132,'] ') 
          ch132(ib:ib)='#' 
          ch132(lt:lt)=' ' 
         end if 
         if(li.gt.0)then 
!          write(6,'(a1,2i3,a2,a)')'ww',ipos,lt,' :',ct132(1:60)        
          if(index(strcmt(j),'mij=').gt.0) then 
           chxx='m1='//ch132(5:6) 
           chyy='mn='//ch132(8:9) 
           ch80(iout+9:)=' m '//chxx//chyy//'  # '//ch132(k+1:) 
          else if(index(strcmt(j),'mijk').gt.0) then 
           chxx='m1='//ch132(6:7) 
           chyy='mi='//ch132(9:10) 
           chzz='mn='//ch132(12:13) 
           ch80(iout+9:)=chyy(4:4)//' '//chxx//chyy//chzz//             &
     &                                        ' # '//ch132(k+1:)        
          else 
           ch80(iout+9:)=' m #  '//ch132(k+1:) 
          end if 
         else 
          ch80(iout+9:)=' #  '//ch132 
         end if 
                                                                        
        end if 
!        write(6,'(a)')ch80                                             
        strcmt(j)=ch80 
       end if 
                                                                        
       iout=index(strcmt(j),'n_cmpt') 
!     dev2,3,4     (istruct2= number of "sites"; []: ask)               
!     comment n_cmpt=a   number lowlimit                                
!                 :  comment  a  #n  number lowlimit                    
!     comment n_cmpt=a   [number] lowlimit                              
!                 :  comment  a  #  number# lowlimit                    
!     comment n_cmpt=[a] number lowlimit                                
!                 :  comment  a #  number lowlimit                      
!     comment n_cmpt=[a] [number] lowlimit                              
!                 :  comment  a #  number# lowlimit                     
       if(iout.gt.0)then 
!        write(6,'(a)') ' old strcmt(j)='                               
!        write(6,'(a)')strcmt(j)                                        
        ch80=strcmt(j)(1:iout-1) 
        ch132=strcmt(j)(iout+7:) 
        call nextchar(ch132,0,ipos,ct132,lt) 
!        write(6,'(a1,2i3,a2,a)')'u',ipos,lt,' :',ct132(1:60)           
        call nextchar(ct132,lt,ipos,ch132,k) 
!        write(6,'(a1,2i3,a2,a)')'v',ipos,k,' :',ch132(1:60)            
        if(lt.eq.3) then 
         ch80(iout:iout+1)=ct132(2:2) 
         il=index(ch132,'[') 
         if(il.gt.0) then 
          ch80(iout+8:)='# '//ch132(il+1:il+k-2)//'# '//ch132(k+1:) 
         else 
          ch80(iout+8:)='# '//ch132 
         end if 
        else 
         ch80(iout:iout+1)=ct132(1:1) 
         il=index(ch132,'[') 
         if(il.gt.0) then 
          ch80(iout+8:)='#n '//ch132(2:k-1)//'# '//ch132(k+1:) 
         else 
          ch80(iout+8:)='#n '//ch132 
         end if 
        end if 
        strcmt(j)=ch80 
       end if 
!       write(6,'(a)') 'new strcmt(j)='                                 
!       write(6,'(a)')strcmt(j)                                         
                                                                        
                                                                        
       if(jc.ge.1) then 
!    name i_pos=m    include=[y]   x   : name                    m # y x
!    name i_pos=m    include=[n]   x   : name                    m # n x
!    name i_pos=m    include=y     x   : name                    m     x
!    name i_pos=m    include=n     x   : name                    m #n  x
                                                                        
!    name i_pos=m  from_data=[y]   x   : name                    m ## y 
!    name i_pos=m  from_data=[n]   x   : name                    m ## n 
!    name i_pos=m  from_data=y     x   : name                    m ##n  
!                                       name -> name~                   
                                                                        
        lm=0 
        do k=1,jc 
         ch132=thco(k) 
         iout=index(ch132,'i_pos') 
         if(iout.gt.0)then 
          ch80=ch132(:iout-1) 
          ct132=ch132(iout+6:) 
          ch80(25:26)=ct132(1:2) 
          li=index(ch132,'include') 
          if(li.gt.0)then 
           iy=index(ch132(li:),'y') 
           il=index(ch132(li:),'[') 
           if(il.eq.0) then 
            if(iy.gt.0)then 
             ch80(28:)=ch132(li+10:) 
            else 
             ch80(28:)='#n '//ch132(li+10:) 
            end if 
           else           ! [] 
            il=il+li 
            if(iy.gt.0)then 
             ch80(28:)='# y '//ch132(il+3:) 
            else 
             ch80(28:)='# n '//ch132(il+3:) 
            end if 
           end if 
          end if 
          li=index(ch132,'from_data') 
          if(li.gt.0)then 
           iy=index(ch132(li:),'y') 
           il=index(ch132(li:),'[') 
           if(il.eq.0) then 
            if(iy.gt.0)then 
             ch80(28:)='##n '//ch132(li+12:) 
            else 
!             write(nwr,'(a)') '*** error: case not implemented'        
!             write(nwr,'(a)')thco(k)                                   
             ch80(28:)='## n '//ch132(li+12:) 
            end if 
                   ! []                                                 
           else 
            il=il+li 
            if(iy.gt.0)then 
             ch80(28:)='## y '//ch132(il+3:) 
            else 
             ch80(28:)='## n  '//ch132(il+3:) 
            end if 
           end if 
           new=1 
          end if 
         else 
          call nextchar(ch132,12,ipos,ct132,lt) 
          ch80=thco(k) 
         end if 
         l=80 
         do while(ch80(l:l).eq.' ') 
          l=l-1 
         end do 
                                                                        
         ch4=ct132(1:2) 
         call trlch(4,ct132,iout,out) 
         if(out(1).gt.lm)then 
          co4=ch4 
          lm=out(1) 
         end if 
         strco(jcb+k-1)=ch80(:l)//'/'//chth 
!         write(6,'(a3,a,2x,a)')'ts ',TRIM(strco(jcb+k-1)),co4             
        end do 

        strco(jcb+jc)='#end# '//co4//cccc
        strco(jcb+jc+1)='#beg#' 
       else
       strco(jcb)='#end# '
      strco(jcb+1)='#beg#'         
       end if
                                                                        
       if(jm.ge.1) then 
        lm=0 
        do k=1,jv 
         ch132=ADJUSTL(thvr(k)) 
         call nextchar(ch132,12,ipos,ct132,lt) 
         ch4=ct132(1:2)
         call trlch(4,ct132,iout,out) 
         if(out(1).gt.lm)then 
          pa4=ch4 
          lm=out(1) 
         end if 
         strth(jvb+k-1,2)=thvr(k) 
!         write(6,'(a,i3,a2,a)')'#strth(',jpb+k-1,')=',TRIM(strth(jvb+k-1,2))                        
        end do 
        do k=1,jp 
         strth(jpb+k-1,1)=thpa(k) 
!         write(6,'(a,2x,a)')strth(jpb+k-1,1),pa4 
        end do 

!    parameters                           123456789012345678901234      
!    name matrix=(m,n)   include=[y]    : name                    # y m 
!    name matrix=(m,n)   include=[n]    : name                    # n m 
!    name matrix=(m,n)   include=y      : name                        m 
!    name matrix=(m,n)   include=n      : name                    #n  m 
                                                                        
!    name matrix=(m,n) from_data=[y]    : name                    ## y  
!    name matrix=(m,n) from_data=[n]    : name                    ## n  
!    name matrix=(m,n) from_data=y      : name                    ##n   
                                                                        
!    name intensity               x     : name                    #i 1 1
!                                                                       
                                                                        
        do k=1,jm 
         ch132=ntrmt(k) 
!         write(6,'(a)')ntrmt(k)                                        
         iout=index(ch132,'matrix') 
         if(iout.gt.0)then 
         ch80=ch132(:iout-1) 
         il=index(ch132(iout:),')')+iout 
         ct132=ch132(iout+7:il-1) 
         new=0 
         li=index(ch132,'include') 
         if(li.gt.0)then 
          iy=index(ch132(li:),'y') 
          il=index(ch132(iout:),'[') 
          if(il.eq.0) then 
           if(iy.gt.0)then 
            ch80(28:)=ct132 
           else 
            ch80(28:)='#n '//ct132 
           end if 
          else  ! []  
          if(iy.gt.0)then 
            ch80(28:)='# y '//ct132 
           else 
            ch80(28:)='# n '//ct132 
           end if 
          end if 
          new=1 
         end if
         li=index(ch132,'from_data') 
         if(li.gt.0)then 
          iy=index(ch132(li:),'y') 
          il=index(ch132(li:),'[') 
          if(il.eq.0) then 
           if(iy.gt.0)then 
            ch80(28:)='##n '//ct132 
           else 
            ch80(28:)='## n '//ct132 
           end if 
          else  ! []    
          if(iy.gt.0)then 
            ch80(28:)='## y '//ct132 
           else 
            ch80(28:)='## n '//ct132 
           end if 
          end if 
          new=1 
         end if 
         end if 
         li=index(ch132,'intensity') 
         if(li.gt.0)then 
          ch80=ch132(:li-1) 
          ch80(28:)='#i 1 1' 
          new=1 
         end if 
                                                                        
         if(new.eq.0)ch80=ntrmt(k) 
         l=80 
         do while(ch80(l:l).eq.' ') 
          l=l-1 
         end do 
         strtm(jmb+k-1,1)=ch80(:l)//'/'//chth 
         strtm(jmb+k-1,2)=ctrmt(k)
        end do
        pa4=cccc(3:4)
        strtm(jmb+jm,1)='#end# '//pa4//cccc
        strtm(jmb+jm+1,1)='#beg#' 
       end if 
                                                                        
      end if 
!      write(6,'(a,a5,4i7)')'cccc, jcb,jmb,jpb,jvb=',cccc,jc,jm,jp,jv
!     write(6,'(i4,a)')(j,TRIM(strco(j)),j=1,6)
      return 
      END                                           
                                                                        
      logical function name_eq_ntheo(mthparent) 
      use comstr, only: nameth_as,ntheory
      implicit none 
      character(len=80):: ntheo
      character(len=2) :: ct,ch 
      integer mthparent,k,l,ln 

      ln=80 
      do while(nameth_as(ln:ln).eq.' '.and.ln.gt.1) 
       ln=ln-1 
      end do
 
      name_eq_ntheo=.false. 
      do k=1,mthparent 
       ntheo=ntheory(k) 
       l=80 
       do while(ntheo(l:l).eq.' ') 
        l=l-1 
       end do 
       if(nameth_as(:ln).eq.ntheo(:l))then 
!        write(6,'(i4,2x,a,/,i4,2x,a)')ln,nameth_as,l,ntheo             
!        read(5,'(a)')                                                  
        goto 10 
       end if 
                                                                        
       if(index(nameth_as(:ln),ntheo(:l)).gt.0)then 
!        write(6,'(i4,2x,a,/,i4,2x,a)')ln,nameth_as,l,ntheo             
!        read(5,'(a)')                                                  
        if(ntheo(l-1:l-1).eq.'_') goto 10 
       end if 
       if(l.eq.ln.and.nameth_as(:ln-3).eq.ntheo(:ln-3))then 
!        write(6,'(i4,2x,a,/,i4,2x,a)')ln,nameth_as,l,ntheo             
        ct=nameth_as(l-1:l) 
        ch=ntheo(l-1:l) 
        if(ch(2:2).eq.'b') then 
         ch(2:2)='1' 
         if(ch.eq.ct) goto 10 
         ch(2:2)='2' 
         if(ch.eq.ct) goto 10 
        end if 
        if(ch(2:2).eq.'c') then 
         ch(2:2)='1' 
         if(ch.eq.ct) goto 10 
         ch(2:2)='3' 
         if(ch.eq.ct) goto 10 
        end if 
        if(ch(2:2).eq.'d') then 
         ch(2:2)='2' 
         if(ch.eq.ct) goto 10 
         ch(2:2)='3' 
         if(ch.eq.ct) goto 10 
        end if 
       end if 
      end do 
      goto 11 
   10 continue 
      name_eq_ntheo=.true. 
   11 continue 
      return 
      END                                           
                                                                        
      integer function number_device(lstruct1) 
      use comstr, only: m_device,mdevf
      implicit none 
      integer lstruct1,ldevice,jdevice 
                                                                        
      ldevice=lstruct1 
      if(m_device.gt.0)then 
       jdevice=mdevf-1+m_device 
       if(lstruct1.ge.m_device)ldevice=m_device 
       if(lstruct1.gt.jdevice)ldevice=lstruct1-(mdevf-1) 
      end if 
      number_device=ldevice 
      return 
      END                                           
