      program cvtomms 
      implicit none 

      character*80      localhepath 
      common/localpath/ localhepath 
                                                                        
      integer len,i,ka,kb,i0,nn,ml,nu_channels,kwin,icol,miy,may,       &
             ncountbase,nchan(512),ncount(512),indx(512)               
      real    va,vb,v_max,vmax,vmin,yq,dyq,bg,ee,chds,out(32),          &
             estimate_chi2,estimate_slope,h,value,effect,chan(512)     
      logical b_nn1,b_nn4,b_norm 
      character(len=132) ::ch132,querytype,deffile,chcom
      character  filetype*32,ch1*1,chbold*6,chnorm*6,form*7         
      integer   nrd,nwr,ncl,ld,                                        &
                id1,npl,ncol,nrows,ixpixel,iypixel,led   
      character(len=16):: winfile,exten
      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led       


       localhepath='/cvtomms.help' 
                                                                        
       b_nn1=.false. 
       b_nn4=.false. 
                                                                        
       nwr=6 
       nrd=5 
       icol=79 
       ncl=80 
       kwin=1 
       call window(kwin) 
       npl=ncol(kwin) 
       chbold=char(27)//'[1m' 
       chnorm=char(27)//'[0m' 
                                                                        
                                                                        
    1  len=2 
       deffile='coordinates.lst' 
       filetype='coordinates taken from a figure.ps' 
       exten='lst' 
       chcom='gv_spectrum' 
       call readfile(filetype,deffile,exten,len,chcom,icol,nrd,nwr) 
       if(len.eq.0)goto 1 
                                                                        
                                                                        
       OPEN(UNIT=11,FILE=deffile,FORM='FORMATTED',                      &
     &                STATUS='unknown')                                 
                                                                        
    2  continue 
       read(11,'(a)',end=3)ch132 
       call trlch(80,ch132,nn,out) 
       if(nn.eq.3)then 
        nu_channels=out(1) 
        nchan(nu_channels)=out(2) 
         chan(nu_channels)=out(2) 
        ncount(nu_channels)=out(3) 
        goto 2 
       else if(nn.eq.1)then 
        b_nn1=.true. 
        ml=out(1) 
       else if(nn.eq.4)then 
        b_nn4=.true. 
        ka=out(1) 
        va=out(2) 
        kb=out(3) 
        vb=out(4) 
       end if 
       goto 2 
                                                                        
    3  if(.not.b_nn1) then 
        write(nwr,'(a)') ' point 2 for calculation of counts is missing' 
        goto 1 
       end if 
       if(.not.b_nn4) then 
        write(nwr,'(a)') ' ka,va  kb,vb are  missing' 
        goto 1 
       end if 
                                                                        
       chcom='cvtomms/normalise' 
       ch1='y' 
       querytype=' normalised spectrum ' 
       call yesno(querytype,ch1,chcom,ncol,nrd,nwr) 
       b_norm=.false. 
       if(ch1.eq.'y') then 
        b_norm=.true. 
        value=0.999 
        querytype=                                                      &
     &  'effect(absorption < 1.0, emission > 1.0 ) of the spectrum'     
        form='f10.4' 
        chcom='cvtoms/effect' 
        call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
        effect=value 
       else 
        value=100000 
        querytype='counts of the baseline' 
        form='i8' 
        chcom='cvtoms/counts' 
        call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
        ncountbase=value 
        value=100000 
        querytype='highest/lowest peak counts' 
        form='i8' 
        chcom='cvtoms/counts' 
        call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
        effect=value/float(ncountbase) 
       end if 
                                                                        
!      calculation of the spectrum from the gv coordinates              
       if(ml.gt.0)then 
        yq=0 
        do i=1,ml 
         yq=yq+float(ncount(i)) 
        end do 
        yq=yq/float(ml) 
       else 
        yq=0 
        do i=nu_channels,nu_channels+ml,-1 
         yq=yq+float(ncount(i)) 
        end do 
        yq=yq/float(-ml) 
       end if 
                                                                        
       may=0 
       do i=1,nu_channels 
        if(may.lt.ncount(i))may=ncount(i) 
       end do 
       miy=10000 
       do i=1,nu_channels 
        if(miy.gt.ncount(i))miy=ncount(i) 
       end do 
       write(6,'(a,4i5)') ' miy,may=',miy,may 
       do i=1,nu_channels 
        ncount(i)=yq-ncount(i)+(may-miy) 
       end do 
       yq=(may-miy) 
       may=0 
       do i=1,nu_channels 
        if(may.lt.ncount(i))may=ncount(i) 
       end do 
       miy=10000 
       do i=1,nu_channels 
        if(miy.gt.ncount(i))miy=ncount(i) 
       end do 
       write(6,'(a,4i5)') ' miy,may,yq=',miy,may,int(yq) 
                                                                        
                                                                        
       if(effect.gt.1.0) then 
!       emission spectrum                                               
        nn=may/effect-yq 
        do i=1,nu_channels 
         ncount(i)=nn+ncount(i) 
        end do 
       else 
!       absorption spectrum                                             
        nn=(yq*effect-miy)/(1.0-effect) 
        do i=1,nu_channels 
         ncount(i)=nn+ncount(i) 
        end do 
       end if 
       yq=yq+nn 
       h=0 
       if(ml.gt.0)then 
        do i=1,ml 
         h=h+float(ncount(i)) 
        end do 
        h=h/float(ml) 
       else 
        do i=nu_channels,nu_channels+ml,-1 
         h=h+float(ncount(i)) 
        end do 
        h=h/float(-ml) 
       end if 
       write(6,'(a,2g15.5)')' yq,h=',yq,h 
                                                                        
                                                                        
                                                                        
       if(b_norm) then 
        value=1.0 
        querytype='estmated correction for chi**2' 
        form='f10.2' 
        chcom='cvtoms/chi2' 
        call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
        estimate_chi2=value 
                                                                        
        dyq=0 
        if(ml.gt.0)then 
         do i=1,ml 
          dyq=dyq+(float(ncount(i))-yq)**2/float(ncount(i)) 
         end do 
         dyq=dyq/float(ml) 
        else 
         do i=nu_channels,nu_channels+ml,-1 
          dyq=dyq+(float(ncount(i))-yq)**2/float(ncount(i)) 
         end do 
         dyq=dyq/float(-ml) 
        end if 
        write(6,'(a,2f10.5)')' dyq=',dyq 
        do i=1,nu_channels 
         ncount(i)= ncount(i)/dyq *estimate_chi2 
        end do 
        yq=yq/dyq*estimate_chi2 
       else 
        h=ncountbase/yq 
        do i=1,nu_channels 
         ncount(i)= ncount(i)*h 
        end do 
       end if 
                                                                        
       value=0.0 
       querytype='estimated correction of the slope of the baseline' 
       form='f12.7' 
       chcom='cvtoms/slope' 
       call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
       estimate_slope=value 
                                                                        
                                                                        
       call INDEXX(nu_channels,chan,indx) 
!      velocity                                                         
                                                                        
       ee=float(kb-ka)/(vb-va) 
       vmin=abs(va+float(nchan(1)-ka)/ee) 
       vmax=va+float(nchan(nu_channels)-ka)/ee 
       if(vmax.gt.vmin) v_max=1.05*vmax 
       if(vmin.gt.vmax) v_max=1.05*vmin 
                                                                        
        filetype='out file, counts/mms' 
        deffile='spectrum.dat' 
        exten='dat' 
        chcom='cvtomms/outfile' 
        call  readfile(filetype,deffile,exten,ld,chcom,ncl,nrd,nwr) 
        if(deffile(1:1).eq.'q') goto 100 
         open (unit=12,file=deffile                                     &
     &                    ,status='unknown'                             &
     &                    ,access='sequential'                          &
     &                    ,form='formatted')                            
                                                                        
       querytype='comment' 
       chcom='comment' 
       ch132='data translated from ' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 100 
       write(12,'(a)')ch132(1:80) 
       write(12,'(a)')'(2x,f10.3,f15.0)   x,y' 
       i=nu_channels 
       write(12,'(a,i4,a,f10.3,a,/,2(a,i4))')'nu_channels=',i,          &
     &  ' v_max =',v_max,' drive_mode=3 ',                              &
     &  ' channel_v0=',i/2,'  channels_vmax=',i/2                       
       do i=1,nu_channels 
        write(12,'(2x,f10.3,f15.0)') va+float(nchan(indx(i))-ka)/ee,    &
     &       float(ncount(indx(i)))*(1+float(i)*estimate_slope)         
       end do 
                                                                        
  100   continue 
       stop 
      END                                           
                                                                        
      SUBROUTINE INDEXX(N,ARRIN,INDX) 
      implicit none
      real  ARRIN(N),Q
      integer N,INDX(N),   &
              I,J,IR,INDXT,L 
      DO J=1,N 
        INDX(J)=J 
      END DO 
      L=N/2+1 
      IR=N 
   10 CONTINUE 
        IF(L.GT.1)THEN 
          L=L-1 
          INDXT=INDX(L) 
          Q=ARRIN(INDXT) 
        ELSE 
          INDXT=INDX(IR) 
          Q=ARRIN(INDXT) 
          INDX(IR)=INDX(1) 
          IR=IR-1 
          IF(IR.EQ.1)THEN 
            INDX(1)=INDXT 
            RETURN 
          ENDIF 
        ENDIF 
        I=L 
        J=L+L 
   20   IF(J.LE.IR)THEN 
          IF(J.LT.IR)THEN 
            IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1 
          ENDIF 
          IF(Q.LT.ARRIN(INDX(J)))THEN 
            INDX(I)=INDX(J) 
            I=J 
            J=J+J 
          ELSE 
            J=IR+1 
          ENDIF 
        GO TO 20 
        ENDIF 
        INDX(I)=INDXT 
      GO TO 10 
      END 

                                          
