      subroutine help(chin) 
      implicit none
       character*80 hepath,utpath,term,editor,shell,localhepath,        &
     &              colfile,workdir*132                                 
       common/path/ hepath,utpath,term,editor,shell,colfile,workdir 
       common/localpath/ localhepath 
                                                                        
       character*132 chin,chcom,helpfile,ch1*1 
       logical b_exist,b_star 
       integer i,l,nwr
                                                                       
       call infopath 
       nwr=6 
      write(6,'(a,/,a,/,a)') ' subroutine help(chin):',chin,hepath               
       chcom='/'//chin 
       ch1=char(0)
       i=index(hepath,ch1)-1 
       helpfile=hepath(:i)//localhepath 
      write(6,'(a,/,a,/,a)') ' subroutine help(chin):',chin,helpfile               

       inquire (file=helpfile,exist=b_exist) 
       if(.not.b_exist) then 
        helpfile='helpfile.help' 
        l=13 
        inquire (file=helpfile,exist=b_exist) 
        if(.not.b_exist) then 
         write(nwr,'(2a,/,a)')' helpfile:',helpfile(:l),                &
     &      ' not found in the current directory '                      
         return 
        end if 
       end if 
       inquire (file=helpfile,exist=b_exist) 
       if(.not.b_exist) then 
         write(nwr,'(a,/,a)')' helpfile not found:',helpfile(:l) 
         return 
       end if 
                                                                        
       call helproutine(chcom,helpfile) 
       return 
      END                                           
                                                                        
      subroutine helproutine(chcom,helpfile) 
      implicit none

      integer,parameter :: maxcom=48,maxco=64,nrd=5,nwr=6
      integer     nwrwin,ld,lw,laenge,lpart

      character(len=132)::queryar,helpar,type, &
                          querytype,chcom,cheader,helpfile,ch132,cp132, &
                          chxdvi,ch80,com80
      character(len=256):: chflen
      character(len=16)::  ext,chterm,ch16,winfile
      character(len=64) :: effihepath

      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)
      common/cmpa/ effihepath,nwrwin,chterm(8)

      character(len=80):: chdf,chdfi(0:4)
      character(len=1) :: chline, bsl,ch1
      character(len=24):: ch24,chl,chr
      character(len=4) :: ch4,chbold,chulin,chnorm
      character           ch6*6,ch2*2,chth*8,chred*5,chblue*5                                  

                    
      real         out(32)
      logical b_star,b_exist 
      character(len=80),dimension(1:32):: que
      integer nuque(0:8),i,ic,ih,ipos,iqloop,j,jj,k,kwin,l,lc,lchx, &
              lines,lk,lkk,lsel,ncl,ncolwin,nrowwin,lpath 

      integer     id1,npl,ncol,nrows,ixpixel,iypixel,led
      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led    

!       write(6,'(2a,/,a)')' helpfile,entry =',helpfile(:60),chcom(:80) 
       bsl=char(92) 
       chred=char(27)//'[31m' 
       chblue=char(27)//'[34m' 
       chbold=char(27)//'[1m' 
       chnorm=char(27)//'[0m' 
       chulin=char(27)//'[4m' 

       nwrwin=nwr 
       kwin=1 
                                                                        
   20  call window(kwin) 
       ncolwin=ncol(kwin) 
       nrowwin=nrows(kwin) 
       if(ncolwin.gt.132) ncolwin=132 
                                                                        
       if(helpfile.eq.' ') then 
        write(nwr,'(a)')'entry of helpfile  could not be identified' 
       if(nwrwin.ne.nwr) close(unit=nwrwin) 
        return 
       end if 
                                                                        
        open(unit=3,file=helpfile                                       &
     &            ,status='old'                                         &
     &            ,access='sequential'                                  &
     &            ,form='formatted'                                     &
     &            ,err=200)                                             
                                                                        
                                                                        
       call stringlength(chcom,lc) 
!       write(6,'(i4,2a)')npl,' help entry =',chcom(:npl-12)            
       com80=chcom 
       b_star=.false. 
       if(com80(lc:lc).eq.'*') then 
        b_star=.true. 
        lc=lc-1 
       end if 
       lsel=0 
       lkk=0 
       do k=0,8 
        nuque(k)=0 
       end do 
                                                                        
       chline=' ' 
       do k=1,maxcom/2 
        queryar(k+maxcom/2)=queryar(k) 
       end do 
  100  continue 
       read(3,'(a)',end=200) ch132 
!       write(6,'(a,a)')' label 100 ', ch132(1:60)                      
        call stringlength(ch132,ic) 
        ch80=ch132 
        if(ch80(6:7).eq.'nn')ch80(6:7)=com80(6:7) 
       j=1 
       do while(ic.ne.lc.or.ch80(:ic).ne.com80(:lc)) 
!        write(6,'(2i4,2x,a)')ic,lc, ch80(:ic)                          
!        if(j.ge.1130) read(5,'(a)')                                    
        j=j+1 
        read(3,'(a)',end=199) ch132 
                                                                        
        call stringlength(ch132,ic) 
        ch80=ch132 
        if(ch80(6:7).eq.'nn')ch80(6:7)=com80(6:7) 
       end do 
!       write(6,'(a)') ch80                                             
!       write(6,'(a)') com80                                            
                                                                        
       if(b_star) then 
        write(nwrwin,'(a)') ch80 
        goto 100 
       end if 
                                                                        
!       write(nwrwin,'(a)')                                             
       read(3,'(a80)',end=200) ch80 
!       write(6,'(a)') ch80                                             
!       write(6,'(a,i4)') 'nrowwin=',nrowwin                            
       lines=nrowwin 
       do while(lines.eq.nrowwin) 
                                                                        
        k=1 
        do while(k.lt.lines.and.ch80(1:1).ne.'/') 
                                                                        
         if(ch80(1:1).eq.bsl) then 
!          if(nwrwin.eq.nwr) then                                       
!           write(nwr,'(a)') ch80(4:ncolwin)                            
!          else                                                         
           i=80 
           if(ch80(2:3).eq.'bf')then 
            ch4=chbold 
           else if(ch80(2:3).eq.'ul')then 
            ch4=chulin 
            ch1=' ' 
            do while(ch1.eq.' ') 
             i=i-1 
             ch1=ch80(i:i) 
            end do 
           end if 
           write(nwrwin,'(a4,a,a4)')ch4,ch80(4:i),chnorm 
!          end if                                                       
         else 
          write(nwrwin,'(a)') ch80(:ncolwin) 
         end if 
         read(3,'(a80)',end=200) ch80 
!         write(6,'(a,a)')' ch80=',ch80                                 
         k=k+1 
        end do 
                                                                        
        if(k.eq.1.and.ch80(1:2).eq.'/>') then 
         ch132='/'//ch80(3:) 
                                                                        
         call stringlength(ch132,lc) 
         com80=ch132 
!         write(6,'(a,a)')' com80=',com80(:lc)                          
         rewind 3 
         goto 100 
        end if 
        lines=k 
!        write(6,'(a,2i4)') ' k,lkk =',k,lkk                            
        if(k.eq.1) then 
         chdf='q' 
        else 
          read(nrd,'(a)') chdf 
          write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        end if 
!        write(6,'(a,a)')' chdf=',chdf(1:10)                            
        if(chdf(1:1).eq.'q'.or.chdf(1:1).eq.'*')lkk=0 
       end do 
                                                                        
       if(ch80(1:2).eq.'/#')then 
        k=1 
        iqloop=0 
        lkk=0 
        do while(ch80(1:2).eq.'/#') 
!         write(6,'(a,a)')' ch80=',ch80                                 
         k=k+1 
         que(k)=ch80(3:) 
         if(ch80(3:6).eq.'more')then 
          ch132=ch80(8:) 
          que(k)='more' 
          call nextchar(ch132,0,ipos,cp132,ih) 
          chxdvi=                                                       &
     &  '$EFFIHEPATH/dvifiles/'//cp132(:ih)//'/'                        &
     &                              //cp132(:ih)//'.dvi &'//char(0)     
         else if(ch80(3:9).eq.'details')then 
          ch132=ch80(11:) 
          que(k)='details' 
          call nextchar(ch132,0,ipos,cp132,ih) 
          chxdvi=effihepath(:lpath)//'/'//cp132(:ih) 
         end if 
         read(3,'(a80)',end=200) ch80 
        end do 
!       k number of lines with /#, iqloop=0 lkk=0                       
!         write(6,'(a,6i3)')'a ',nuque                                  
        j=nuque(0) 
        if(j.gt.0) then 
         do l=nuque(1),1,-1 
          queryar(l+k)=queryar(l) 
         end do 
        end if 
        do l=1,k 
         queryar(l)=que(l) 
        end do 
        nuque(0)=j+1 
        j=nuque(0) 
        if(j.gt.4) then 
         write(nwrwin,'(a)')                                            &
     &    ' there was no way back to the preceeding level'              
         return 
        end if 
        do l=1,j 
         nuque(l)=nuque(l)+k 
        end do 
!        write(6,'(a,6i3)')'b ',nuque                                   
       else 
        if(nuque(0).eq.0) goto 200 
       end if 
!       write(6,'(a,2i4)') ' k.eq.1.and.lkk.eq.0 =',k,lkk               
!       if(k.eq.1.and.lkk.eq.0) goto 200                                
       if(lkk.eq.0) then 
        lk=k 
        lkk=k 
        lsel=k 
        do k=1,lk 
         ext(k)=' ' 
        end do 
                                                                        
        queryar(1)='return' 
        chdfi(nuque(0))=queryar(1) 
!       write(6,'(a,3i4)')' effi_help query ncolwin=',ncolwin           
        cheader='further related information' 
       else 
        lk=lkk 
        if(lsel.lt.lkk) lsel=lsel+1 
        chdfi(nuque(0))=queryar(lsel) 
       end if 
                                                                        
       if(iqloop.eq.1) then 
        lk=lkk 
        lsel=lkk 
        chdfi(nuque(0))=queryar(1) 
        iqloop=0 
       end if 
       lsel=lk 
!       if(chline.ne.' ')                                               
!     & write(nwr,'(1x,a1,a3)') char(27),'['//chline//'A'               
  188  continue 
!       write(6,'(a,a,3i4)')chdf(1:10),' lsel,lk=',lsel,lk,lkk          
!        write(6,'(i3,a)')(ll,queryar(ll)(1:60),ll=1,10)                
       chdf=chdfi(nuque(0)) 
       chdf(80:80)='#' 
       call query(lsel,lk,cheader,chdf) 
       chline=char(ichar(chdf(80:80))+1) 
       chdfi(nuque(0))=queryar(lsel+1) 
!       write(6,'(i3,a)')nuque(0),chdfi(nuque(0))(:30)                  
!       write(6,'(a,a,3i4)')chdf(1:10),' lsel,lk,lkk=',lsel,lk,lkk      
       if(lsel.gt.1) then 
        call stringlength(queryar(lsel),lc) 
        com80='/'//queryar(lsel)(:lc) 
        lc=lc+1 
        if(queryar(lsel)(1:4).eq.'more') then 
          call viewdvi(chxdvi) 
          goto 200 
        else if(queryar(lsel)(1:7).eq.'details') then 
         call stringlength(chxdvi,lchx) 
         inquire(file=chxdvi,exist=b_exist) 
         if(b_exist) then 
          open(unit=2                                                   &
     &           ,file=chxdvi                                           &
     &           ,status='unknown'                                      &
     &           ,access='sequential'                                   &
     &           ,form='formatted'                                      &
     &           ,err=200)                                              
         else 
          write(nwr,'(3a)')' file ',chxdvi(:lchx),                      &
     &                            ' for details not found'              
          goto 200 
         end if 
                                                                        
  189    read(2,'(a)',end=190) ch132 
         write(nwrwin,'(a)')ch132(:80) 
         goto 189 
  190    close(unit=2) 
         goto 200 
        end if 
        write(nwrwin,'(/)') 
!        write(6,'(a,a)')'selected com80=',com80(1:50)                  
        if(lsel.eq.lkk)iqloop=1 
                                                                        
!        write(6,'(4(i3,2x,a))')(l,queryar(l)(1:24),l=1,24)             
                                                                        
        rewind 3 
        goto 100 
       else 
!        write(6,'(a,6i3)')' a200 ',nuque                               
        j=nuque(0) 
        if(j.gt.1) then 
                                                                        
         jj=nuque(j) 
         do l=1,nuque(1)-jj 
          queryar(l)=queryar(l+jj) 
!          write(6,'(i3,a)')l,queryar(l)(1:60)                          
         end do 
         do l=1,j-1 
          nuque(l)=nuque(l)-jj 
         end do 
                                                                        
         nuque(j)=0 
         nuque(0)=j-1 
         lk=nuque(j-1) 
         lkk=lk 
         lsel=nuque(j-1) 
!        write(6,'(i2,a,6i3)')lk,' b200 ',nuque                         
                                                                        
         cheader='related information ' 
         chdfi(j)=chdfi(j-1) 
         goto 188 
        end if 
        goto 200 
       end if 
                                                                        
  199  continue 
       ch132=com80 
       lc=132 
       call stringend(ch132,lc) 
       write(nwr,'(3a,/a)') 'no entry found for ',com80(:lc),           &
     &     ' in helpfile:',helpfile                                     
       goto 201 
  200  continue 
       write(nwrwin,'(a5,1x,a1,a3)') chred,char(27),'[1A' 
       write(nwrwin,'(2x,2a,a5)')' from help-file:',helpfile(:64),chnorm 
  201  close(unit=3) 
       do k=1,maxcom/2 
        queryar(k)=queryar(k+maxcom/2) 
       end do 
!        write(6,'(i3,a)')(ll,queryar(ll)(1:60),ll=1,10)                
       if(nwrwin.ne.nwr) close(unit=nwrwin) 
       return 
      END                                           

      subroutine query(lq,lk,cheader,chdf) 
      implicit none
      integer,parameter :: maxcom=48,maxco=64,nrd=5,nwr=6,i_stmp=8469
                                                                        
                                                                        
      integer     lq,lk,key, &
                  nwrwin,ld,lw,lpart,laenge

      character(len=80)::  chdf,chin80,cp80
      character(len=132):: queryar,helpar,type,   &
                           cheader,chin,ch132,cp132,chout,chblank
      character(len=256):: chflen
      character(len=16)::  ext,chterm,winfile
      character(len=64) :: effihepath
      common/cmpa/effihepath,nwrwin,chterm(8)
                                                                     
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)
                                                                        
      logical block 
      character     chh*1,wrb*1,ch2*2,ch8*8,                     &
                     chbold*4,chred*5,chnorm*4,chx*2,go*1                

      integer i,i0,i1,i10,ii,ikey,iquit,iwrl,iz,j,jj,jjq,jk, &
              jq,jqh,jsec,jz,k,l,laengez,lapl,lcol,le,lkin,ll,lqin,  &
              npl_i,npx,lr
      integer     id1,npl,ncol,nrows,ixpixel,iypixel,led
      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led    
                                                                 
       chbold=char(27)//'[1m' 
       chred=char(27)//'[31m' 
       chnorm=char(27)//'[0m' 
       lqin=lq 
       lkin=lq 
       chin80=chdf 
       jqh=0 
       wrb=cheader(132:132) 
!       write(6,'(a,a1)')' subroutine query wrb=',wrb                   
       go=' ' 
       if(cheader(131:131).eq.'g') go='g' 
       cheader(132:132)=' ' 
    1  npx=npl-3 
                                                                        
       if(wrb.eq.'w'.or.wrb.eq.'r'.or.wrb.eq.'l') npx=ncol(1)-3 
       if(npx.gt.130) npx=130 
!       write(6,'(a,8i4)') ' query lq,nwr,nrd,npl,ncol(1),npx=',        
!     &                            lq,nwr,nrd,npl,ncol(1),npx           
!      write(6,'(a)') (queryar(iq)(:80),iq=1,lq)                        
!      write(6,'(a)') (type(iq)(:80),iq=1,lq)                           
!      write(6,'(a)') cheader(:80)                                      
      i0=ichar('0') 
      iquit=0 
      chblank=' ' 
      npl_i=ncol(1)-3 
      if(npl_i.gt.129) npl_i=129 
      block=.false. 
      if(chdf(80:80).eq.'#') block=.true. 
      chin=chdf(:79) 
      call stringlength(chin,ll) 
      le=ll 
      if(le.eq.0) lk=lq 
      chdf=chin 
!       write(6,'(a1,a)')'1', cheader(:80)                              
      if(cheader.eq.' ') then 
       do k=1,npx 
        chflen(k:k)='-' 
       end do 
      else 
       chh='-' 
       if(ncol(1).lt.131) cheader(ncol(1)+1:)=' ' 
       call stringlength(cheader,l) 
       if(index(cheader,'information').eq.0)then 
        chflen=cheader(:l)//' (help:he)' 
        l=l+10 
       else 
        chflen=cheader(:l) 
       end if 
       i=(npx-l)/2 
       do k=l,1,-1 
        chflen(i+k:i+k)=chflen(k:k) 
       end do 
       do k=1,i 
        chflen(k:k)=chh 
       end do 
       k=i+l+1 
       do while(k.le.npx) 
        chflen(k:k)=chh 
        k=k+1 
       end do 
      end if 
                                                                        
      iwrl=0 
      write(nwr,'(a)')chnorm//chflen(:npx) 
      iwrl=iwrl+1 
      if(wrb.eq.'w')write(10,'(a)') chflen(:npx) 
      if(wrb.eq.'r') then 
       read(10,'(a)')chflen 
!       write(nwr,'(2a)') ' query_b ',chflen(:npx-10)                   
      end if 
                                                                        
      do k=1,npx 
       chflen(k:k)='-' 
      end do 
    5 continue 
!      write(6,'(a)') ' query  label 5'                                 
      laengez=0 
      do k=1,lq 
       if(ext(k).eq.' ') then 
        ld(k)=0 
       else 
        chin=ext(k) 
        if(ncol(1).lt.131)chin(ncol(1)+1:)=' ' 
        call stringlength(chin,ld(k)) 
       end if 
       chin=queryar(k) 
       if(ncol(1).lt.131)chin(ncol(1)+1:)=' ' 
       call stringlength(chin,ll) 
       lw(k)=ll 
       queryar(k)=chin 
       if(chin(1:1).eq.'q') iquit=1 
!       write(6,'(a)') ch132(1:ll)                                      
       ll=ll+ld(k)+3 
       if(ll.gt.laengez) laengez=ll 
      end do 
!      block=.false.                                                    
      lpart(0)=0 
      lapl=0 
      if(block) then 
                            ! 3                                         
       laengez=laengez+2 
       lapl=npx/laengez 
       if(lapl.eq.0) then 
        iz=0 
       else 
        iz=lq/lapl 
       end if 
       if(iz*lapl.lt.lq) iz=iz+1 
!       write(6,'(a,2i4)') ' lapl,iz',lapl,iz                           
   10  if(lapl.eq.0) goto 20 
       lr=lapl*iz-lq 
!       if(lr.ge.((lapl+1)/2)) then                                     
       if(lr.ge.(iz-1)) then 
        lapl=lapl-1 
        goto 10 
       end if 
       if(lr.lt.0) lapl=lapl+1 
       lr=lapl*iz-lq 
!      write(6,'(a,2i4)') ' lapl,lr',lapl,lr                            
      end if 
                                                                        
   20 if(lapl.eq.0) then 
       iz=1 
       laengez=0 
       lpart(iz)=0 
       do k=1,lq 
        laenge(k)=((lw(k)+5)/10+1)*10+ld(k) 
        if(laenge(k).lt.npx) then 
         laengez=laengez+laenge(k)+6 
!         write(6,'(a,i4)') ' laengez=',laengez                         
         lpart(iz)=lpart(iz)+1 
         if(laengez.ge.npx) then 
          if(laengez.gt.npx) then 
           laengez=laenge(k)+4 
           lpart(iz)=lpart(iz)-1 
           lpart(iz+1)=1 
          else 
           laengez=0 
           lpart(iz+1)=0 
!         write(6,'(a,i4)') ' *laengez=',laengez                        
          end if 
           if(k.le.lq) iz=iz+1 
!         write(6,'(a,2i4)') ' *k,iz=',k,iz                             
         end if 
        else 
         laenge(iz+1)=laenge(k) 
         lpart(iz+1)=1 
         if(k.le.lq) iz=iz+1 
        end if 
       end do 
      else 
       do k=1,lq 
        laenge(k)=laengez+5 
       end do 
       do k=1,iz-1 
        lpart(k)=lapl 
       end do 
       lpart(iz)=lapl-lr 
      end if 
                                                                        
!       write(6,'(a,8i3)')  '    iz=',iz                                
!       write(6,'(a,16i3)') ' lpart=',(lpart(i),i=1,iz)                 
!       write(6,'(a,24i3)') '    lw=',(lw(i),i=1,lq)                    
!       write(6,'(a,24i3)') 'laenge=',(laenge(i),i=1,lq)                
!       write(6,'(a,i3)')   '   jqh=',jqh                               
      if(jqh.gt.0) goto 42 
       jjq=0 
       jq=0 
       jk=0 
       ikey=0 
   40 continue 
!      write(6,'(a)') ' query  label 40'                                
                                                                        
      if(le.gt.0.and.ikey.eq.0)then 
       k=jjq+1 
!       write(6,'(a,/,a)')queryar(k)(1:60)//'yy',chdf(:le)//'xx'        
       do while(index(queryar(k),chdf(:le)).eq.0                       &
     &                                   .and.le.gt.0.and.k.le.lq)  
        k=k+1 
       end do 
       if(k.gt.lq) then 
        k=1 
!        do while(chdf(:le).ne.queryar(k)(:le).and.le.gt.0.and.k.le.lq) 
        do while(index(queryar(k),chdf(:le)).eq.0                      &
     &                                      .and.le.gt.0.and.k.le.lq) 
         k=k+1 
        end do 
       end if 
       jj=k 
      else if(ikey.eq.1)then 
       jj=jjq+1 
       if(jj.gt.lq) jj=1 
      else if(ikey.eq.-1)then 
       jj=jjq-1 
       if(jj.lt.1) jj=lq 
      else 
       jj=0 
      end if 
                                                                        
      jz=0 
      do k=1,lq 
       if(jj.eq.k)then 
        jjq=k 
        jz=1 
        if(ld(k).gt.0) then 
         if(jq.eq.0) then 
          type(k)=chred//                                               &
     &    '['//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k))//']'            
          jq=k 
         end if 
        else 
         if(jq.eq.0) then 
          type(k)=chred//'['//queryar(k)(1:lw(k))//']' 
!          write(6,'(a)')type(k)                                        
          jq=k 
         end if 
        end if 
        chdf=queryar(k) 
       else 
        if(ld(k).gt.0) then 
         type(k)=chnorm//' '//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k)) 
        else 
         if(jq.eq.k) then 
          type(k)=chred//                                               &
     &    '['//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k))//']'            
         else 
          type(k)=chnorm//' '//queryar(k)(1:lw(k)) 
         end if 
        end if 
       end if 
      end do 
                                                                        
      if(wrb.eq.'r') then 
!       write(6,'(a)')'combuff query wrb.eq.r)'                         
        ch132=' ' 
        do while(ch132(3:5).ne.'---') 
         read(10,'(a)') ch132 
         lcol=ncol(1) 
         if(lcol.gt.132)lcol=132 
         write(nwr,'(2a)')chnorm//ch132(:lcol) 
         iwrl=iwrl+1 
       end do 
       lq=ichar(ch132(1:1))-i0 
       chh=ch132(2:2) 
       if(chh.ne.'-') lq=10*lq+ichar(chh)-i0 
!       write(6,'(a,i4)')'combuff query --------------end',lq           
       goto 100 
      end if 
                                                                        
   42 continue 
                                                                        
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
!      write(6,'(a,4i4)')                                               
!     &    ' maxco,ii,lpart(jz-1)=',maxco,ii,lpart(jz-1),npl_i          
       if(abs(ii).lt.maxco-lpart(jz)) then 
       if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
        write(nwr,'(a,/,1x,a)')                                         &
     &          type(ii+1)(1:npl_i-3),type(ii+1)(npl_i-2:)              
        iwrl=iwrl+2 
       else 
        call itoc8(ch8,lpart(jz)) 
        ch2=ch8(:2) 
!       write(ch2,'(i2)')lpart(jz)                                      
        write(nwr,'('//ch2//'(a))')                                     &
     &          (type(ii+j)(1:laenge(j+ii)),j=1,lpart(jz))              
        iwrl=iwrl+1 
       end if 
       end if 
      end do 
      write(nwr,'(a4,a4)')chnorm,char(27)//'[1A' 
                                                                        
!      write(nwr,'(2a)')'----------------------------------------',     
!     &'----------------------------------------'                       
      do k=1,npx 
       chflen(k:k)='-' 
      end do 
      write(nwr,'(a)')chnorm//chflen(1:npx) 
      iwrl=iwrl+1 
      jsec=0 
                                                                        
      if(jqh.gt.0) goto 43 
      if(le.eq.0) goto 100 
   43 continue 
!      write(6,'(a)') ' query  label 41'                                
      if(lq.gt.1) then 
       if(go.eq.'g') then 
        ch132=' ' 
       else 
   44   ikey=key() 
        if(ikey.lt.0) then 
         if(ikey.eq.-65) ikey=-1 
         if(ikey.eq.-66) ikey=+1 
!         if(ikey.gt.-67) goto 44                                       
         if(ikey.eq.-67) ikey=+1 
         if(ikey.eq.-68) ikey=-1 
          ch132='shift' 
          write(nwr,'(a1)')' ' 
        else 
         if(char(ikey).eq.'@')then 
          ch132=' ' 
          write(nwr,'(a1)')' ' 
         else 
          ch132(1:1)=char(ikey) 
                                                       ! for choice     
          read(nrd,'(a)') ch132(2:) 
         end if 
         ikey=0 
        end if 
       end if 
       jqh=0 
      else 
       ch132=' ' 
       write(nwr,'(a)')chnorm//chflen(1:npx) 
       iwrl=iwrl+1 
      end if 
                                                                        
      if(wrb.eq.'w'.and.ch132(1:1).eq.' ') then 
        ii=0 
        do jz=1,iz 
         ii=ii+lpart(jz-1) 
         if(abs(ii).lt.maxco-lpart(jz)) then 
          if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
           write(10,'(a,/,1x,a)')                                       &
     &               type(ii+1)(1:npl_i-3),type(ii+1)(npl_i-2:)         
          else 
           call itoc8(ch8,lpart(jz)) 
           ch2=ch8(:2) 
!          write(ch2,'(i2)')lpart(jz)                                   
           write(10,'('//ch2//'(a))')                                   &
     &               (type(ii+j)(1:laenge(j+ii)),j=1,lpart(jz))         
          end if 
         end if 
        end do 
        if(jq.le.9) then 
         chflen(1:1)=char(jq+i0) 
        else 
         i10=jq/10 
         i1=jq-10*i10+i0 
         chflen(1:2)=char(i10+i0)//char(i1) 
        end if 
        write(10,'(a)')chflen(1:npx) 
      end if 
                                                                        
      if(jsec.eq.1) then 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       write(nwr,'(a)') chblank(:npx) 
      else 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nwr,'(a)') chblank(:npx) 
      end if 
      write(nwr,'(1x,a1,a3)') char(27),'[2A' 
      jsec=0 
      chin=ch132 
      chin(81:)=' ' 
      call stringlength(chin,le) 
      if(le.eq.0)then 
       chdf=' ' 
      else 
       chdf=chin(1:le) 
      end if 
      cp132=' ' 
                                                                        
      if(chdf(1:2).eq.'he') then 
       write(nwr,'(a,a)') ' select by typing a substring, RET',         &
     & ' or by repeatedly using left/right shift keys'                  
      end if 
!      read(nrd,'(a)') chout                                            
       if(le.gt.80) le=80 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he'.and.                                       &
     &          index(cheader,'further related').eq.0) then             
        if(jq.gt.0) then 
         call help(helpar(jq)) 
         jq=0 
!         write(6,'(a,i4)')'call help(helpar(jq)) jq=',jq               
         lq=lqin 
         lk=lq 
         chdf=chin80 
         jqh=jq 
         le=2 
        end if 
!        write(nwr,'(a)') chflen(:npx)                                  
        iwrl=iwrl+1 
                                                                        
        goto 1 
                                                                        
!        goto 40                                                        
       end if 
       chh=chdf(1:1) 
       if(chh.eq.' ') then 
        lk=jk 
        lq=jq 
!         write(6,'(a,2i4)') ' query lq,lk=',lq,lk                      
        if(lq.eq.0) then 
          goto 40 
        else 
         goto 100 
        end if 
       end if 
       if(iquit.eq.0.and.chh.eq.'q') chh='*' 
       if(chh.eq.'*') then 
        lq=0 
        lk=0 
        goto 100 
       end if 
                                                                        
   50 ii=0 
      write(nwr,'(1x,a1,a3)') char(27),'[2A' 
      iwrl=iwrl-1 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(a,/,a)') chblank(:npl_i),chblank(:npl_i) 
         iwrl=iwrl+2 
        else 
         write(nwr,'(a)') chblank(:npl_i) 
         iwrl=iwrl+1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      jq=0 
      goto 40 
  100 continue 
      chdf(80:80)=char(iwrl+i0) 
      write(nwr,'(a5,a1,a3)') chnorm,char(27),'[1A' 
      return 
      END                                           

