      program euler 

      implicit none
     integer,parameter :: maxco=64
     character(len=132):: queryar,helpar,type,                        &
                          querytype,chin,chcom,ch132,cp132,ct132
     character(len=16) :: ext,winfile
     character(len=80) :: ch80,localhepath
     character(len=3),dimension(1:3):: eai,ebi
     character          ch1*1,ch2*2    
      integer           ld,lw,laenge,lpart
      character(len=132):: infotext
      character(len=4)  :: enwr  
      character(len=6)  :: chbold,chnorm                       

      common/infenw/ enwr(16),infotext(8)
      common/localpath/ localhepath 
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)

      real      out(32),uveca(3,3),uvecb(3,3),uvec(3),                 &
                uvec1(3),uvec2(3),uvec3(3),d1(-1:1,-1:1),d2(-2:2,-2:2),&
                hi,AX(3,3),VX(3,3),DV(3),bx(3,3)

      real      arcos,ax_theta,ax_phi,                                 &
                omega,oalpha,obeta,ogamma,omx,omy,omz                
      complex   hc,dsxct,t2m,v1m,t2mC,hc1,dclv,v1mL,dj1,dj2,drt 
      dimension dsxct(-2:2,-2:2),t2m(-2:2),t2mC(-2:2),                  &
                v1m(-1:1),v1mL(-1:1),dclv(-1:1,-1:1),                   &
                dj1(-1:1,-1:1),dj2(-1:1,-1:1),drt(-1:1,-1:1)

      real    alpha,beta,ax_phi2,ax_theta2,c2,cm,cosa,cosb,cosg,        &
              cp,dx,dy,dz,eta,fm,fn,gamma,h,hh,hx,hy,hz,omcosg,         &
              omega2,phi,phiH,pi,q62,rad,s2,sina,sinb,sing,sint,        &
              sino,sm,sp,st,phiH_r,theta,thetaH,thetaH_r,tpII,          &
              thick,vxx,vyy,vzz,vxy,vxz,vyz,xx0,xx2,zz
      integer i,i3,iax,iay,iaz,ibc,ibx,iby,ibz,icase,icol,info,         &
              j,k,kwin,lj,lk,lp,l,lq,lqb,n,ncl,nn,NP,nrot,m,            &
              id1,npl,ncol,nrows,ixpixel,iypixel,led,nwr,nrd   

      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led 
 
    chbold=char(27)//'[1m' 
    chnorm=char(27)//'[0m' 

      localhepath='/euler.help' 
      ncl=80 
      nwr=6 
      nrd=5 
      kwin=1 
      call window(kwin) 
      npl=ncol(kwin) 
      icol=npl 
      do k=1,3 
       do j=1,3 
        uvecb(k,j)=0.0 
       end do 
      end do 
      do k=1,3 
       do j=1,3 
        uveca(k,j)=0.0 
       end do 
      end do 
                                                                        
      eai(1)='eax' 
      eai(2)='eay' 
      eai(3)='eaz' 
      ebi(1)='ebx' 
      ebi(2)='eby' 
      ebi(3)='ebz' 
                                                                        
      pi=4.0*atan(1.0) 
      rad=pi/180.0 
                                                                        
    5 lqb=10
       lk=lqb 
       do k=1,lqb 
        ext(k)=' ' 
       end do 
       ch80='unit' 
       ch80(80:80)='#' 
       helpar(1)='read/angle/euler' 
       helpar(2)='read/angle/unitvectors' 
       helpar(3)='read/angle/product' 
       helpar(4)='read/angle/invers' 
       helpar(5)='read/angle/rotationaxes' 
       helpar(6)='read/angle/rot_from_trans' 
       helpar(7)='read/angle/rot_from_2rot' 
       helpar(8)='read/angle/rot_trans' 
       helpar(9)='read/angle/trans_rot' 
       helpar(10)='read/angle/pas_tensor' 
                                                                        
       queryar(1)='1 Euler angles from unit vectors' 
       queryar(2)='2 unit vectors from Euler angles' 
       queryar(3)='3 Euler angles for a sequence of two transformations' 
       queryar(4)='4 Euler angles of invers transformation' 
       queryar(5)='5 Euler angles from rotation angles' 
       queryar(6)='6 rotation angles from Euler angles' 
       queryar(7)='7 rotation angles for a sequence of two rotations' 
       queryar(8)='8 Euler angles of a sequence of rotation and transformation' 
       queryar(9)='9 Euler angles of invers transf. x invers rot.' 
       queryar(10)='10 Euler angles of PAS of 2. rank tensor' 
       chin='Euler angle/unitvectors' 
       call query(lqb,lk,chin,ch80) 
       if(lqb.eq.0) goto 1000 
    1  if(lqb.eq.1) goto 10 
       if(lqb.eq.3) goto 40 
       if(lqb.eq.4) goto 50 
       if(lqb.eq.5) goto 30 
       if(lqb.eq.6) goto 70 
       if(lqb.eq.7) goto 80 
       if(lqb.eq.9) goto 60 
       if(lqb.eq.10) goto 90
       if(lqb.eq.8) then
        call Nrottrans; goto 5
       end if 
                                                                        
       querytype='Three Euler angles (alpha,beta,gamma):' 
       chcom='read/euler_angles' 
       ch132='0,0,0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
                                                                        
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 5 
       alpha=out(1)*rad 
       beta=out(2)*rad 
       gamma=out(3)*rad 
                                                                        
       c2=cos(beta/2)**2 
       s2=1.0-c2 
       cp=cos(alpha+gamma) 
       sp=sin(alpha+gamma) 
       cm=cos(alpha-gamma) 
       sm=sin(alpha-gamma) 
                                                                        
       uvecb(1,1)= c2*cp-s2*cm 
       uvecb(1,2)= c2*sp-s2*sm 
       uvecb(1,3)=-sin(beta)*cos(gamma) 
                                                                        
       uvecb(2,1)=-c2*sp-s2*sm 
       uvecb(2,2)= c2*cp+s2*cm 
       uvecb(2,3)= sin(beta)*sin(gamma) 
                                                                        
       uvecb(3,1)= sin(beta)*cos(alpha) 
       uvecb(3,2)= sin(beta)*sin(alpha) 
       uvecb(3,3)= cos(beta) 
                                                                        

       write(nwr,'(/,a)') 'unit vectors of system Sb in S' 

      do k=1,3 
          if(abs(uvecb(k,3)).lt.0.0001) then
             theta=pi/2.
          else   
           sint=sqrt(1.-uvecb(k,3)**2)/uvecb(k,3)                               
           theta=atan(sint)
          end if
          if(sint.lt.0.) theta=pi+theta                                      
          if(abs(sint).lt.0.0001)then
             theta=0.; phi=0.
          else
           if(abs(uvecb(k,1)).gt.0.0001)then
              phi=atan(uvecb(k,2)/uvecb(k,1))
           else
              phi=0.
           end if
          end if 
          if(uvecb(k,1).lt.0.) phi=phi+pi                                    
       write(nwr,'(6x,a3,a1,3(f8.3,a5),3x,2f6.1)')ebi(k),'=',        &
             uvecb(k,1),' ex +',uvecb(k,2),' ey +',uvecb(k,3),' ez',&
             theta/rad,phi/rad    
      end do 
                                                                        
                                                                        
       write(nwr,'(/,a)')                                               &
      'polar angles (theta,phi) of unit vectors of system Sb in S'     
       do k=1,3 
        theta=arcos(uvecb(k,3)) 
        h=1.0-uvecb(k,3)**2 
        if(h.le.0.0) then 
         phi=0.0 
        else 
         h=sqrt(h) 
         phi=arcos(uvecb(k,1)/h) 
         if(uvecb(k,2).lt.0) phi=2.0*pi-phi 
        end if 
        write(nwr,'(6x,a3,a,2(f8.3,a1))')ebi(k),'=(',theta/rad,',',phi/rad,')'
                             
       end do 
       write(nwr,'(/,a,/)')'-----------------------------------------'

       ch1='n' 
       chcom='transformation of vectors' 
       write(nwr,'(a)') chbold
       querytype='transformation of vectors ' 
       call yesno(querytype,ch1,chcom,icol,nrd,nwr)
       write(nwr,'(a)') chnorm
       if(ch1.eq.'n') goto 1 
       

       querytype='read vector V(theta,phi)= lV,theta,phi:' 
       chcom='read/vector' 
       ch132='1.0, 0.0, 0.0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 5
       hh=out(1)
       beta=out(2)*rad 
       gamma=out(3)*rad
       
       uvec(1)=cos(gamma)*sin(beta)      
       uvec(2)=sin(gamma)*sin(beta)
       uvec(3)=cos(beta)

       do k=1,3
        h=0.0
        do i=1,3
           h=h+uvecb(i,k)*uvec(i)
        end do
         uvec1(k)=h
        end do
        write(nwr,'(/,a)')'transformed vector components'
        write(nwr,'(6x,a,3(f8.3,a1))')'vec=(',&
        uvec1(1)*hh,',',uvec1(2)*hh,',',uvec1(3)*hh,')'

        
       write(nwr,'(/,a)')'polar angles (theta,phi) of transformed vector'     
       theta=arcos(uvec1(3)) 
       h=1.0-uvec1(3)**2 
       if(h.le.0.0) then 
        phi=0.0 
       else 
        h=sqrt(h) 
        phi=arcos(uvec1(1)/h) 
        if(uvec1(2).lt.0) phi=2.0*pi-phi 
       end if 
       write(nwr,'(6x,a,2(f8.3,a1),/)')'vec=(',theta/rad,',',phi/rad,')'
                             
       
        do k=1,3
        h=0.0
        do i=1,3
           h=h+uvecb(k,i)*uvec(i)
        end do
         uvec1(k)=h
       end do
        write(nwr,'(/,a)')'invers transformed vector components'
        write(nwr,'(6x,a,3(f8.3,a1))')'vec=(',&
        uvec1(1)*hh,',',uvec1(2)*hh,',',uvec1(3)*hh,')'

       write(nwr,'(/,a)')'(theta,phi) of invers transformed vector'     
       
        theta=arcos(uvec1(3)) 
        h=1.0-uvec1(3)**2 
        if(h.le.0.0) then 
         phi=0.0 
        else 
         h=sqrt(h) 
         phi=arcos(uvec1(1)/h) 
         if(uvec1(2).lt.0) phi=2.0*pi-phi 
        end if 
        write(nwr,'(6x,a,2(f8.3,a1),/)')'vec=(',theta/rad,',',phi/rad,')'


       querytype='read vector components: (v1,v2,v3)' 
       chcom='read/vector' 
       ch132='0, 0, 0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 5
       uvec(1)=out(1)
       uvec(2)=out(2)
       uvec(3)=out(3)
       hh=sqrt(uvec(1)**2+uvec(2)**2+uvec(3)**2)
        do k=1,3
        h=0.0
        do i=1,3
           h=h+uvecb(i,k)*uvec(i)
        end do
         uvec1(k)=h
       end do
        write(nwr,'(/,a)')'transformed vector components'
        write(nwr,'(6x,a,3(f8.3,a1))')'vec=(',&
        uvec1(1),',',uvec1(2),',',uvec1(3),')'

       write(nwr,'(/,a)')'lV(theta,phi) of transformed vector'     
       uvec1=uvec1/hh
       theta=arcos(uvec1(3)) 
       h=1.0-uvec1(3)**2 
       if(h.le.0.0) then 
        phi=0.0 
       else 
        h=sqrt(h) 
        phi=arcos(uvec1(1)/h) 
        if(uvec1(2).lt.0) phi=2.0*pi-phi 
       end if 
       write(nwr,'(6x,a,f8.2,a1,2(f8.3,a1))')'vec=',hh,'(',theta/rad,',',phi/rad,')'

        do k=1,3
        h=0.0
        do i=1,3
           h=h+uvecb(k,i)*uvec(i)
        end do
         uvec1(k)=h
       end do
        write(nwr,'(/,a)')'invers transformed vector components'
        write(nwr,'(6x,a,3(f8.3,a1))')'vec=(',&
        uvec1(1),',',uvec1(2),',',uvec1(3),')'

       write(nwr,'(/,a)')'(theta,phi) of invers transformed vector'     
        uvec1=uvec1/hh      
        theta=arcos(uvec1(3)) 
        h=1.0-uvec1(3)**2 
        if(h.le.0.0) then 
         phi=0.0 
        else 
         h=sqrt(h) 
         phi=arcos(uvec1(1)/h) 
         if(uvec1(2).lt.0) phi=2.0*pi-phi 
        end if 
        write(nwr,'(6x,a,2(f8.3,a1))')'vec=(',theta/rad,',',phi/rad,')'

                                   write(nwr,'(/,a,/)')'-----------------------------------------' 

       
       goto 1 
                                                                        
                                ! rotation angel                        
   30 continue 
       querytype='rotation axes (theta,phi) and rotation angle (omega):' 
       chcom='read/rotation_axes' 
       ch132='54.7356,45.0,120.0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
                                                                        
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 10 
       alpha=out(2)*rad 
       beta=out(1)*rad 
       gamma=out(3)*rad 

       uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
 
       cosa=cos(alpha) 
       sina=sin(alpha) 
       cosb=cos(beta) 
       sinb=sin(beta) 
                                                                        
       cosg=cos(gamma) 
       sing=sin(gamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
       uvecb(1,1)=dx**2*omcosg +cosg 
       uvecb(1,2)=dx*dy*omcosg+dz*sing 
       uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uvecb(2,1)=dx*dy*omcosg-dz*sing 
       uvecb(2,2)=dy**2*omcosg+cosg 
       uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uvecb(3,1)=dx*dz*omcosg+dy*sing 
       uvecb(3,2)=dy*dz*omcosg-dx*sing 
       uvecb(3,3)=dz**2*omcosg+cosg 
                                                                        
       goto 100 
   40  j=1 
   41  if(j.eq.1) then 
       querytype=                                                       &
     &  'Three Euler angles (alpha,beta,gamma) 1. transformation:'      
       else 
       querytype=                                                       &
     &  'Three Euler angles (alpha,beta,gamma) 2. transformation:'      
       end if 
       chcom='read/euler_angles' 
       ch132='0,0,0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 41 
       alpha=out(1) 
       beta=out(2) 
       gamma=out(3) 
       if(j.eq.1) then 
        call dewigner(1,beta*rad,d1) 
        do m=-1,1 
         do n=-1,1 
          fm=float(m)*alpha*rad 
          fn=float(n)*gamma*rad 
          dj1(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 
        j=j+1 
        goto 41 
       else 

        call dewigner(1,beta*rad,d1) 
        do m=-1,1 
         do n=-1,1 
          fm=float(m)*alpha*rad 
          fn=float(n)*gamma*rad 
          dj2(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 
       end if 
       
        do m=-1,1 
         do n=-1,1 
          hc=(0.,0.) 
          do k=-1,1 
           hc=hc+dj1(m,k)*dj2(k,n) 
          end do 
          drt(m,n)=hc 
         end do 
        end do 
       uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
                                                                        
       uvecb(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1)) 
       uvecb(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1)) 
       uvecb(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1)) 
                                                                        
       uvecb(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1)) 
       uvecb(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1)) 
       uvecb(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1)) 
                                                                        
       uvecb(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0)) 
       uvecb(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0)) 
       uvecb(3,3)=real(drt(0,0)) 
       goto 100 
                                                                        
   50 continue 
       querytype='Three Euler angles (alpha,beta,gamma):' 
       chcom='read/euler_angles' 
       ch132='0,0,0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
                                                                        
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 5 
       alpha=out(1) 
       beta=out(2) 
       gamma=out(3) 
!      inverse transformation
                                                  
       call inverstr(alpha,beta,gamma,nwr)
       write(nwr,'(/)')
       goto 5
                                                                        
   10  lq=3 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       ch80='unit' 
       ch80(80:80)='#' 
       helpar(1)='read/angle/abS' 
       helpar(2)='read/angle/bSa' 
       helpar(3)='read/angle/aSb' 
       queryar(1)='unit vectors eb(n),ea(m) in system S ' 
       queryar(2)='unit vectors eb(n) in system Sa' 
       queryar(3)='unit vectors ea(n) in system Sb' 
       chin='Euler angle: eb(n)=Sum;m ea(m)D1,mn(alpha,beta,gamma)' 
       call query(lq,lk,chin,ch80) 
       if(lq.eq.0) goto 1000 
                                                                        
       lp=2 
       lj=lp 
       do k=1,lp 
        ext(k)=' ' 
       end do 
       ch80='unit' 
       ch80(80:80)='#' 
       helpar(1)='read/unitvector/numbers' 
       helpar(2)='read/unitvector/angle' 
       queryar(1)='unit vectors:(x,y,z)' 
       queryar(2)='unit vectors: theta,phi' 
       chin='unit vectors representation' 
       call query(lp,lj,chin,ch80) 
       if(lp.eq.0) goto 1000 
                                                                        
                                                                        
       if(lp.eq.1) then 
        if(lq.eq.1) then 
         chcom='read/unitvectors/format11' 
   11    querytype='two pairs of unitvectors, ea:' 
         cp132='eax=(1,0,0) eaz=(0,0,1)' 
         call askstring(querytype,cp132,chcom,ncl,nrd,nwr) 
         ch1=cp132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
         call stringlength(cp132,l) 
         querytype='second unitvector eb:' 
         ct132='ebx=(1,0,0) ebz=(0,0,1)' 
         call askstring(querytype,ct132,chcom,ncl,nrd,nwr) 
         ch1=ct132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
         ch132=cp132(1:l+1)//ct132 
         if(index(ch132,'eax')+index(ch132,'ebx').lt.2)then 
          write(nwr,'(a)')cp132(1:l+1) 
          call stringlength(ct132,l) 
          write(nwr,'(a)')ct132(1:l+1) 
          write(nwr,'(a)')'two vectors: ea and eb' 
          goto 11 
         end if 
        else if(lq.eq.2) then 
         querytype='one pair of unitvectors:' 
         chcom='read/unitvectors/format12' 
         ch132='ebx=(1,0,0) ebz=(0,0,1)' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
        else if(lq.eq.3) then 
         querytype='one pair of unitvectors:' 
         chcom='read/unitvectors/format13' 
         ch132='eax=(1,0,0) eaz=(0,0,1)' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
        end if 
       else if(lp.eq.2) then 
        if(lq.eq.1) then 
         querytype='two pairs of unitvectors:' 
         chcom='read/unitvectors/format21' 
         ch132='eax=(90,0) eaz=(0,0) ebx=(90,0) ebz=(0,0)' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
        else if(lq.eq.2) then 
         querytype='one pair of unitvectors:' 
         chcom='read/unitvectors/format22' 
         ch132='ebx=(90,0) ebz=(0,0)' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
        else if(lq.eq.3) then 
         querytype='one pair of unitvectors:' 
         chcom='read/unitvectors/format23' 
         ch132='eax=(90,0) eaz=(0,0)' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
        end if 
       end if 
                                                                        
!      evaluation of ch132                                              
       if(lp.eq.1) then 
        if(lq.eq.1) then 
!        ch132='eax=(1,0,*) eaz=(*,0,1) ebx=(1,0,*) ebz=(*,0,1)'        
         iax=index(ch132,'eax') 
         iay=index(ch132,'eay') 
         iaz=index(ch132,'eaz') 
         ibx=index(ch132,'ebx') 
         iby=index(ch132,'eby') 
         ibz=index(ch132,'ebz') 
                                                                        
                                                                        
        else if(lq.eq.2) then 
!        ch132='ebx=(1,0,*) ebz=(*,0,1)'                                
         uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
         iax=0; iay=0; iaz=0 
         ibx=index(ch132,'ebx') 
         iby=index(ch132,'eby') 
         ibz=index(ch132,'ebz') 
                                                                        
        else if(lq.eq.3) then 
!        ch132='eax=(1,0,*) eaz=(*,0,1)'                                

         uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.

         iax=index(ch132,'eax') 
         iay=index(ch132,'eay') 
         iaz=index(ch132,'eaz') 
         ibx=0; iby=0; ibz=0 
        end if 
                                                                        
        i3=0 
        if(iax.gt.0) then 
         ibc=index(ch132(iax:),')') 
         cp132=ch132(iax+5:iax+ibc-2) 
         call uvector(cp132,uvec) 
         do k=1,3 
          uveca(1,k)=uvec(k) 
         end do 
         i3=i3+1 
               ! iax                                                    
        end if 
                                                                        
        if(iay.gt.0) then 
         ibc=index(ch132(iay:),')') 
         cp132=ch132(iay+5:iay+ibc-2) 
!         write(6,'(a,a)')'vector eay=',cp132(:60)                      
         call uvector(cp132,uvec) 
         do k=1,3 
          uveca(2,k)=uvec(k) 
         end do 
         i3=i3+1 
        end if ! iay  
                                                                        
        if(iaz.gt.0) then 
         ibc=index(ch132(iaz:),')') 
         cp132=ch132(iaz+5:iaz+ibc-2) 
         call uvector(cp132,uvec) 
         do k=1,3 
          uveca(3,k)=uvec(k) 
         end do 
         i3=i3+1 
        end if  ! iaz   
                                                                        
        if(i3.lt.3.and.i3.gt.0) then 
         if(i3.eq.1) then 
          write(nwr,'(a)') 'at least two unit vectors ea neeeded' 
          goto 10 
         end if 
         if(iax.gt.0.and.iay.gt.0) then 
          do k=1,3 
           uvec1(k)=uveca(1,k) 
           uvec2(k)=uveca(2,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
                                                                        
          do k=1,3 
           uveca(3,k)=uvec3(k) 
           uveca(2,k)=uvec2(k) 
          end do 
         end if 
         if(iax.gt.0.and.iaz.gt.0) then 
          do k=1,3 
           uvec1(k)=uveca(3,k) 
           uvec2(k)=uveca(1,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uveca(2,k)=uvec3(k) 
           uveca(1,k)=uvec2(k) 
          end do 
         end if 
         if(iay.gt.0.and.iaz.gt.0) then 
          do k=1,3 
           uvec1(k)=uveca(2,k) 
           uvec2(k)=uveca(3,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uveca(1,k)=uvec3(k) 
           uveca(3,k)=uvec2(k) 
          end do 
         end if 
        end if 
                                                                        
        i3=0 
        if(ibx.gt.0) then 
         ibc=index(ch132(ibx:),')') 
         cp132=ch132(ibx+5:ibx+ibc-2) 
!         write(6,'(a,a)')'vector ebx=',cp132(:60)                      
         call uvector(cp132,uvec) 
         do k=1,3 
          uvecb(1,k)=uvec(k) 
         end do 
         i3=i3+1 
        end if  ! ibx     
                                                                        
        if(iby.gt.0) then 
         ibc=index(ch132(iby:),')') 
         cp132=ch132(iby+5:iby+ibc-2) 
!         write(6,'(a,a)')'vector eby=',cp132(:60)                      
         call uvector(cp132,uvec) 
         do k=1,3 
          uvecb(2,k)=uvec(k) 
         end do 
         i3=i3+1 
        end if  ! iby   
                                                                        
        if(ibz.gt.0) then 
         ibc=index(ch132(ibz:),')') 
         cp132=ch132(ibz+5:ibz+ibc-2) 
!         write(6,'(a,a)')'vector ebz=',cp132(:60)                      
         call uvector(cp132,uvec) 
         do k=1,3 
          uvecb(3,k)=uvec(k) 
         end do 
         i3=i3+1 
        end if   ! ibz  
                                                                        
        if(i3.lt.3.and.i3.gt.0) then 
         if(i3.eq.1) then 
          write(nwr,'(a)') 'at least two unit vectors eb needed' 
          goto 10 
         end if 
         if(ibx.gt.0.and.iby.gt.0) then 
          do k=1,3 
           uvec1(k)=uvecb(1,k) 
           uvec2(k)=uvecb(2,k) 
          end do 
!         write(6,'(a,3f15.2)')'uvec1=',(uvec1(j),j=1,3)                
!         write(6,'(a,3f15.2)')'uvec2=',(uvec2(j),j=1,3)                
          call crospr(uvec1,uvec2,uvec3) 
!         write(6,'(a,3f15.2)')'uvec3=',(uvec3(j),j=1,3)                
          call crospr(uvec3,uvec1,uvec2) 
!         write(6,'(a,3f15.2)')'uvec2=',(uvec2(j),j=1,3)                
                                                                        
          do k=1,3 
           uvecb(3,k)=uvec3(k) 
           uvecb(2,k)=uvec2(k) 
          end do 
         end if 
         if(ibx.gt.0.and.ibz.gt.0) then 
          do k=1,3 
           uvec1(k)=uvecb(3,k) 
           uvec2(k)=uvecb(1,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uvecb(2,k)=uvec3(k) 
           uvecb(1,k)=uvec2(k) 
          end do 
         end if 
                                                                        
         if(iby.gt.0.and.ibz.gt.0) then 
          do k=1,3 
           uvec1(k)=uvecb(2,k) 
           uvec2(k)=uvecb(3,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uvecb(1,k)=uvec3(k) 
           uvecb(3,k)=uvec2(k) 
          end do 
         end if 
        end if 
                                                                        
!        write(6,'(a)')'uvecb(k,j),j=1,3)'                              
!        do k=1,3                                                       
!         write(6,'(3f15.2)')(uvecb(k,j),j=1,3)                         
!        end do                                                         
                                                                        
       else if(lp.eq.2) then 
        if(lq.eq.1) then 
!        ch132='eax=(90,0) eaz=(0,0) ebx=(90,0) ebz=(0,0)'              
         iax=index(ch132,'eax') 
         iay=index(ch132,'eay') 
         iaz=index(ch132,'eaz') 
         ibx=index(ch132,'ebx') 
         iby=index(ch132,'eby') 
         ibz=index(ch132,'ebz') 
                                                                        
        else if(lq.eq.2) then 
!        ch132='ebx=(90,0) ebz=(0,0)'                                   
         uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.

         iax=0 
         iay=0 
         iaz=0 
         ibx=index(ch132,'ebx') 
         iby=index(ch132,'eby') 
         ibz=index(ch132,'ebz') 
                                                                        
        else if(lq.eq.3) then 
!        ch132='eax=(90,0) eaz=(0,0)'                                   
         do k=1,3 
          do i=1,3 
           uvecb(k,1)=0.0 
          end do 
          uvecb(k,k)=1.0 
         end do 
         iax=index(ch132,'eax') 
         iay=index(ch132,'eay') 
         iaz=index(ch132,'eaz') 
         ibx=0 
         iby=0 
         ibz=0 
        end if 
                                                                        
        i3=0 
        if(iax.gt.0) then 
         ibc=index(ch132(iax:),')') 
         cp132=ch132(iax+5:iax+ibc-2) 
!         write(6,'(a,a)')'angle eax=',cp132(:60)                       
         call trlch(ibc,cp132,nn,out) 
         st=sin(out(1)*rad) 
         uveca(1,1)=st*cos(out(2)*rad) 
         uveca(1,2)=st*sin(out(2)*rad) 
         uveca(1,3)=cos(out(1)*rad) 
         i3=i3+1 
        end if  ! iax 
                                                                        
        if(iay.gt.0) then 
         ibc=index(ch132(iay:),')') 
         cp132=ch132(iay+5:iay+ibc-2) 
!         write(6,'(a,a)')'angle eay=',cp132(:60)                       
         call trlch(ibc,cp132,nn,out) 
         st=sin(out(1)*rad) 
         uveca(2,1)=st*cos(out(2)*rad) 
         uveca(2,2)=st*sin(out(2)*rad) 
         uveca(2,3)=cos(out(1)*rad) 
         i3=i3+1 
        end if  ! iay  
                                                                        
        if(iaz.gt.0) then 
         ibc=index(ch132(iaz:),')') 
         cp132=ch132(iaz+5:iaz+ibc-2) 
!         write(6,'(a,a)')'angle eaz=',cp132(:60)                       
         call trlch(ibc,cp132,nn,out) 
         st=sin(out(1)*rad) 
         uveca(3,1)=st*cos(out(2)*rad) 
         uveca(3,2)=st*sin(out(2)*rad) 
         uveca(3,3)=cos(out(1)*rad) 
         i3=i3+1 
        end if   ! iaz      
!        write(6,'(a)')'uveca(k,j),j=1,3)'                              
!        do k=1,3                                                       
!         write(6,'(3f15.2)')(uveca(k,j),j=1,3)                         
!        end do                                                         
                                                                        
        if(i3.lt.3.and.i3.gt.0) then 
         if(i3.eq.1) then 
          write(nwr,'(a)') 'at least two unit vectors ea neeeded' 
          goto 10 
         end if 
         if(iax.gt.0.and.iay.gt.0) then 
          do k=1,3 
           uvec1(k)=uveca(1,k) 
           uvec2(k)=uveca(2,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
                                                                        
          do k=1,3 
           uveca(3,k)=uvec3(k) 
           uveca(2,k)=uvec2(k) 
          end do 
         end if 
         if(iax.gt.0.and.iaz.gt.0) then 
          do k=1,3 
           uvec1(k)=uveca(3,k) 
           uvec2(k)=uveca(1,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uveca(2,k)=uvec3(k) 
           uveca(1,k)=uvec2(k) 
          end do 
         end if 
         if(iay.gt.0.and.iaz.gt.0) then 
          do k=1,3 
           uvec1(k)=uveca(2,k) 
           uvec2(k)=uveca(3,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uveca(1,k)=uvec3(k) 
           uveca(3,k)=uvec2(k) 
          end do 
         end if 
        end if 
                                                                        
        i3=0 
        if(ibx.gt.0) then 
         ibc=index(ch132(ibx:),')') 
         cp132=ch132(ibx+5:ibx+ibc-2) 
!         write(6,'(a,a)')'angle ebx=',cp132(:60)                       
         call trlch(ibc,cp132,nn,out) 
         st=sin(out(1)*rad) 
         uvecb(1,1)=st*cos(out(2)*rad) 
         uvecb(1,2)=st*sin(out(2)*rad) 
         uvecb(1,3)=cos(out(1)*rad) 
         i3=i3+1 
        end if   ! ibx  
                                                                        
        if(iby.gt.0) then 
         ibc=index(ch132(iby:),')') 
         cp132=ch132(iby+5:iby+ibc-2) 
!         write(6,'(a,a)')'angle eby=',cp132(:60)                       
         call trlch(ibc,cp132,nn,out) 
         st=sin(out(1)*rad) 
         uvecb(2,1)=st*cos(out(2)*rad) 
         uvecb(2,2)=st*sin(out(2)*rad) 
         uvecb(2,3)=cos(out(1)*rad) 
         i3=i3+1 
        end if  ! iby   
                                                                        
        if(ibz.gt.0) then 
         ibc=index(ch132(ibz:),')') 
         cp132=ch132(ibz+5:ibz+ibc-2) 
!         write(6,'(a,a)')'angle ebz=',cp132(:60)                       
         call trlch(ibc,cp132,nn,out) 
         st=sin(out(1)*rad) 
         uvecb(3,1)=st*cos(out(2)*rad) 
         uvecb(3,2)=st*sin(out(2)*rad) 
         uvecb(3,3)=cos(out(1)*rad) 
         i3=i3+1 
        end if   ! ibz 
                                                                        
!        write(6,'(a)')'uvecb(k,j),j=1,3)'                              
!        do k=1,3                                                       
!         write(6,'(3f15.2)')(uvecb(k,j),j=1,3)                         
!        end do                                                         
                                                                        
        if(i3.lt.3.and.i3.gt.0) then 
         if(i3.eq.1) then 
          write(nwr,'(a)') 'at least two unit vectors eb neeeded' 
          goto 10 
         end if 
         if(ibx.gt.0.and.iby.gt.0) then 
                                                                        
          do k=1,3 
           uvec1(k)=uvecb(1,k) 
           uvec2(k)=uvecb(2,k) 
          end do 
                                                                        
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
                                                                        
          do k=1,3 
           uvecb(3,k)=uvec3(k) 
           uvecb(2,k)=uvec2(k) 
          end do 
         end if 
         if(ibx.gt.0.and.ibz.gt.0) then 
          do k=1,3 
           uvec1(k)=uvecb(3,k) 
           uvec2(k)=uvecb(1,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uvecb(2,k)=uvec3(k) 
           uvecb(1,k)=uvec2(k) 
          end do 
         end if 
         if(iby.gt.0.and.ibz.gt.0) then 
          do k=1,3 
           uvec1(k)=uvecb(2,k) 
           uvec2(k)=uvecb(3,k) 
          end do 
          call crospr(uvec1,uvec2,uvec3) 
          call crospr(uvec3,uvec1,uvec2) 
          do k=1,3 
           uvecb(1,k)=uvec3(k) 
           uvecb(3,k)=uvec2(k) 
          end do 
         end if 
        end if 
       end if 
      hi=0.                                                                  
      goto 100 
                                                                        
   90 continue 
       write(nwr,'(a)')&
       chbold//'2. rank tensor components with reference to system S:'//chnorm
       querytype='txx,txy,txz,tyy,tyz,tzz' 
       chcom='read/tensorcomponents' 
       ch132='0 1 0 0 1 0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
       call trlch(ncl,ch132,nn,out)
       AX=0.
       AX(1,1)=out(1) 
       AX(1,2)=out(2) 
       AX(1,3)=out(3) 
       AX(2,2)=out(4) 
       AX(2,3)=out(5) 
       AX(3,3)=out(6) 
                                                                        
       AX(2,1)=out(2) 
       AX(3,1)=out(3) 
       AX(3,2)=out(5) 
 
       bx=AX      
       uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
                                                                        
       N=3 
       call JACOBI(AX,N,DV,VX,NROT) 
!       WRITE(6,'(a)') 
!       WRITE(6,'(a,3F10.5,a1)')' eigen values =(',DV(1),DV(2),DV(3),')' 
       hi=(DV(1)+DV(2)+DV(3))/3. 
!      uvecb(i,k), VX(k,i) eigenvector number i                         

       do k=1,3 
        do i=1,3 
        uvecb(i,k)=VX(k,i) 
        end do 
       end do 
       if(abs(DV(3)-hi).gt.0.0) then 
        if(Abs((DV(1)-DV(2))/(DV(3)-hi)).gt.1.) then 
!       permutation of axes 1 2 3 -> 2 3 1                              
         hh=DV(1) 
         DV(1)=DV(2) 
         DV(2)=DV(3) 
         DV(3)=hh 
         do i=1,3 
          uvec1(i)=uvecb(1,i) 
         end do 
         do i=1,3 
         uvecb(1,i)=uvecb(2,i) 
         end do 
         do i=1,3 
         uvecb(2,i)=uvecb(3,i) 
         uvecb(3,i)=uvec1(i) 
         end do 
        end if 
       else 
!       permutation of axes 1 2 3 -> 2 3 1                              
         hh=DV(1) 
         DV(1)=DV(2) 
         DV(2)=DV(3) 
         DV(3)=hh 
         do i=1,3 
          uvec1(i)=uvecb(1,i) 
         end do 
         do i=1,3 
         uvecb(1,i)=uvecb(2,i) 
         end do 
         do i=1,3 
         uvecb(2,i)=uvecb(3,i) 
         uvecb(3,i)=uvec1(i) 
         end do 
       end if 
       if(abs(DV(3)-hi).gt.0.0) then 
        if(Abs((DV(1)-DV(2))/(DV(3)-hi)).gt.1.) then 
!       permutation of axes 1 2 3 -> 2 3 1                              
         hh=DV(1) 
         DV(1)=DV(2) 
         DV(2)=DV(3) 
         DV(3)=hh 
         do i=1,3 
          uvec1(i)=uvecb(1,i) 
         end do 
         do i=1,3 
         uvecb(1,i)=uvecb(2,i) 
         end do 
         do i=1,3 
         uvecb(2,i)=uvecb(3,i) 
         uvecb(3,i)=uvec1(i) 
         end do 
        end if 
       else 
!       permutation of axes 1 2 3 -> 2 3 1                              
         hh=DV(1) 
         DV(1)=DV(2) 
         DV(2)=DV(3) 
         DV(3)=hh 
         do i=1,3 
          uvec1(i)=uvecb(1,i) 
         end do 
         do i=1,3 
         uvecb(1,i)=uvecb(2,i) 
         end do 
         do i=1,3 
         uvecb(2,i)=uvecb(3,i) 
         uvecb(3,i)=uvec1(i) 
         end do 
       end if
       zz= DV(3)-hi      
       if(abs(zz).gt.0.0)then       
       if((DV(1)-DV(2))/(DV(3)-hi).lt.0.) then 
         hh=DV(1) 
         DV(1)=DV(2) 
         DV(2)=hh 
         do i=1,3 
         uvec1(i)=uvecb(1,i) 
         end do 
         do i=1,3 
         uvecb(1,i)=uvecb(2,i) 
         end do 
         do i=1,3 
         uvecb(2,i)=uvec1(i) 
         end do 
       end if 
       end if
       WRITE(nwr,'(a)')                                                                 
       WRITE(nwr,'(a)')' in system Sb the tensor is diagonal with' 
       WRITE(nwr,'(a,3F10.5,a1)')' eigen values =(',DV(1),DV(2),DV(3),')' 
       WRITE(nwr,'(a,F10.5,a,3F10.4,a1)')'             := ',hi,' * 1_ + (',&
            &                   DV(1)-hi,DV(2)-hi,DV(3)-hi,')'
       if(abs(zz).gt.0.0)then          
        eta=(DV(1)-DV(2))/(DV(3)-hi)
        tpII=zz*sqrt(1.+eta**2/3.)/2. 
        WRITE(nwr,'(a,F10.5,a,2F10.5,a1)')'             := ',hi,           &
         ' * 1_ + (zz,eta)= (',zz,eta,')'                        
        WRITE(nwr,'(a,f10.5,a)')' sqrt(PHII)  := ',abs(tpII),'  (of invariant PHII)' 
       end if                                                                 
       if(uvecb(3,3).lt.0.)then  ! zz-axis in +z direction
        do k=1,3 
         uvecb(3,k)=-uvecb(3,k) 
        end do
       end if       
       if(uvecb(1,1).lt.0.)then  ! xx-axis in +ex direction
        do k=1,3 
         uvecb(1,k)=-uvecb(1,k) 
        end do
       end if       
       do k=1,3 
        uvec1(k)=uvecb(1,k) 
        uvec3(k)=uvecb(3,k) 
       end do
         
       call crospr(uvec3,uvec1,uvec2) 
       do k=1,3 
        uvecb(2,k)=uvec2(k) 
       end do 
                                                                        
  100  continue 
       call angle_uvecab(uveca,uvecb,alpha,beta,gamma)

       write(nwr,'(/,a)') 'unit vectors of system Sa in system S' 
      do k=1,3 
!       write(nwr,'(6x,a3,a2,3(f8.3,a1))')eai(k),'=(',                  
!     &            uveca(k,1),',',uveca(k,2),',',uveca(k,3),')'         
       write(nwr,'(6x,a3,a,3(f8.3,a5))')eai(k),'=',                     &
                 uveca(k,1),' ex +',uveca(k,2),' ey +',uveca(k,3),' ez'
      end do 
                                                                        
                                                                        
       write(nwr,'(/,a)') 'unit vectors of system Sb in system S ' 
       do k=1,3
          if(abs(uvecb(k,3)).lt.0.0001) then
             theta=pi/2.
          else   
           sint=sqrt(1.-uvecb(k,3)**2)/uvecb(k,3)                               
           theta=atan(sint)
          end if
          if(sint.lt.0.) theta=pi+theta
          if(abs(sint).lt.0.0001)then
             theta=0.; phi=0.
          else
           if(abs(uvecb(k,1)).gt.0.0001)then
            phi=atan(uvecb(k,2)/uvecb(k,1))                                      
           else
              phi=0.
           end if
          end if 
          if(uvecb(k,1).lt.0.) phi=phi+pi                                    
       write(nwr,'(6x,a3,a,3(f8.3,a5),3x,2f6.1)')ebi(k),'=',        &
             uvecb(k,1),' ex +',uvecb(k,2),' ey +',uvecb(k,3),' ez',&
             theta/rad,phi/rad    
!       write(nwr,'(6x,a3,a,3(f8.3,a5))')ebi(k),'=',                     &
!                 uvecb(k,1),' ex +',uvecb(k,2),' ey +',uvecb(k,3),' ez'
      end do 
                                                                        
       write(nwr,'(/,20x,a,/,a,3(f7.2,a))')                           &
       'Euler angles alpha,beta,gamma',                                 &
       'eb(n)=Sum;m ea(m) D1,mn(alpha=',                                &
         alpha,',beta=',beta,',gamma=',gamma,')'                       
       call inverstr(alpha,beta,gamma,nwr)
!    --------------------------spezial tests ---------------------------
       ch1='n' 
       chcom='spezial/tensor' 
       write(nwr,'(a)') chbold
       querytype='back transformation of the tensor and vectors (Sb to S=Sa)' 
       call yesno(querytype,ch1,chcom,icol,nrd,nwr)
       write(nwr,'(a)') chnorm
       if(ch1.eq.'n') goto 1 

       
       querytype='of tensor principal values (tr/3,zz,eta):' 
       chcom='read/pr_values' 
       write(ch132,'(3f10.2)')hi,zz,eta
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 5 
       hi=out(1) 
       zz=out(2) 
       eta=out(3) 
       tpII=zz*sqrt(1.+eta**2/3.)/2. 

       querytype='with the Euler angles (alpha,beta,gamma):' 
       chcom='read/euler_angles' 
       write(ch132,'(3f10.2)')alpha,beta,gamma
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 5 
       alpha=out(1) 
       beta=out(2) 
       gamma=out(3) 


                                                                        
      if(lqb.eq.10) then 
!      tzz,eta  -> t2m -> t2m(m)*D2(m,n) -> AX                          
       write(nwr,'(/,2a,/,a,/)')' control printout of',             &
       ' t(m,l)*D2(-gamma,-beta,-alpha)(l,n):  ',                      &
     ' t(m,l) are the spherical components of the diagonal tensor tqq.'
   
                                                                        
       call dewigner(2,-beta*rad,d2) 
       do m=-2,2 
       do n=-2,2 
        fm=-float(n)*alpha*rad 
        fn=-float(m)*gamma*rad 
        dsxct(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d2(m,n) 
       end do 
       end do 
!      tpII is the square root of the second invariant of a 2.rank tenso
!      tpII**2 =1/4*[zz**2+(xx-yy)**2+4/3*(xy**2+xz**2+yz**2)]         
                                                                        
       xx0=1./sqrt(1.0+eta**2/3.)*tpII 
       xx2=eta*xx0/sqrt(6.) 
                                                                        
       t2m(0)=cmplx(xx0,0.0) 
       t2m(-1)=(0.,0.) 
       t2m(1)=(0.,0.) 
       t2m(-2)=cmplx(xx2,0.) 
       t2m(2)=cmplx(xx2,0.) 
                                                                        
       q62=sqrt(6.0)/2.0 
       vxx=real(-t2m(0)+q62*(t2m(2)+t2m(-2))) 
       vyy=real(-t2m(0)-q62*(t2m(2)+t2m(-2))) 
       vzz=2*real(t2m(0)) 
       vxy=-real(q62*(t2m(2)-t2m(-2))*cmplx(0.,1.)) 
       vxz=-real(q62*(t2m(1)-t2m(-1))) 
       vyz=real(q62*(t2m(1)+t2m(-1))*cmplx(0.,1.)) 
                                                                        
       write(nwr,'(8x,a,/)')                                            &
        '        vxx       vxy        vxz     vyy       vyz     vzz'          
       write(nwr,'(a,6f10.3)')'system Sb:', vxx,vxy,vxz,vyy,vyz,vzz 
                                                                        
       do n=-2,2 
        hc1=(0.,0.) 
        do m=-2,2 
         hc1=hc1+t2m(m)*dsxct(m,n) 
        end do 
        t2mC(n)=hc1 
       end do 
!      write(6,'(10f10.3)')t2mC                                         
                                                                        
       vxx=real(-t2mC(0)+q62*(t2mC(2)+t2mC(-2))) 
       vyy=real(-t2mC(0)-q62*(t2mC(2)+t2mC(-2))) 
       vzz=2*real(t2mC(0)) 
       vxy=-real(q62*(t2mC(2)-t2mC(-2))*cmplx(0.,1.)) 
       vxz=-real(q62*(t2mC(1)-t2mC(-1))) 
       vyz=real(q62*(t2mC(1)+t2mC(-1))*cmplx(0.,1.)) 
                                                                        
        write(nwr,'(a,6f10.3)')'system S :', vxx,vxy,vxz,vyy,vyz,vzz 
        write(nwr,'(a,6f10.3)')' +tr/3   :', vxx+hi,vxy,vxz,vyy+hi,vyz,vzz+hi 
       lqb=1
      end if 
                                                                        
       if(lqb.eq.1.or.lqb.eq.3.or.lqb.eq.4.) then 
                                                                        
        write(nwr,'(/,a,a)')' Components v_i of vector sum_i v_i*eai ',& 
        'from q_i of vector sum_i q_i*ebi'                          

        chcom='read/tensorcomponents' 
        ch132='theta=0 , phi=0'                                                                       
  101   write(nwr,'(a)') chbold
        querytype=' polar angles of the vector (q_x,q_y,q_z) in Sb:'  

        call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
        write(nwr,'(a)') chnorm    
        ch1=ch132(1:1) 
        if(ch1.eq.'*') goto 5
        if(ch1.eq.'q') goto 102 
        call trlch(ncl,ch132,nn,out) 
                                                                        
        phiH=out(2) 
        thetaH=out(1) 
        phiH_r=phiH*rad 
        thetaH_r=thetaH*rad 
         v1m(1) =-cmplx(cos(phiH_r),sin(phiH_r))*                       &
                        sin(thetaH_r)/sqrt(2.0)                         
         v1m(0) = cmplx(cos(thetaH_r),0.0) 
         v1m(-1)=-conjg(v1m(1)) 
                                                                        
         hx=-real(v1m(1)-v1m(-1))/sqrt(2.0) 
         hy=-aimag((v1m(1)+v1m(-1)))/sqrt(2.0) 
         hz=real(v1m(0)) 
         write(nwr,'(/,3(a,f8.3),a6)')                                  &
                  ' vector in Sb:',hx,' ebx +',hy,' eby +',hz,' ebz'       
                                                                        
        call dewigner(1,-beta*rad,d1) 
        do m=-1,1 
        do n=-1,1 
         fm=-float(n)*alpha*rad 
         fn=-float(m)*gamma*rad 
         dclv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
        end do 
        end do 
                                                                                          
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+v1m(m)*dclv(m,n) 
        end do 
        v1mL(n)=hc1 
       end do 
        hx=-real(v1mL(1)-v1mL(-1))/sqrt(2.0) 
        hy=-aimag((v1mL(1)+v1mL(-1)))/sqrt(2.0) 
        hz=real(v1mL(0)) 
         write(nwr,'(/,3(a,f8.3),a6,/)')                                  &
                  ' vector in Sa:',hx,' eax +',hy,' eay +',hz,' eaz' 
        goto 101 
       end if 
  102  continue 
                                                                        
       if(lqb.eq.5) then 
        ch1='n' 
        chcom='spezial' 
        querytype='spezial test of tensor transformation' 
        call yesno(querytype,ch1,chcom,icol,nrd,nwr) 
        if(ch1.ne.'n') goto 1 
        write(nwr,'(2a)')'  T(m,l)*D1(-gamma,-beta,-alpha)(l,n)' 
                                                                        
        querytype='txx,txy,txz,tyy,tyz,tzz' 
        chcom='read/tensorcomponents' 
        ch132='-1.0  0  0  -1.0  0  2.0  ' 
  103   call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
        ch1=ch132(1:1) 
        if(ch1.eq.'*'.or.ch1.eq.'q') goto 104 
        call trlch(ncl,ch132,nn,out) 
        vxx=out(1) 
        vxy=out(2) 
        vxz=out(3) 
        vyy=out(4) 
        vyz=out(5) 
        vzz=out(6) 
        t2m(0)=cmplx(vzz/2.,0.) 
        t2m(1)=-cmplx(vxz,vyz)/sqrt(6.) 
        t2m(-1)=cmplx(vxz,-vyz)/sqrt(6.) 
        t2m(2)=cmplx(vxx-vyy,2*vxy)/sqrt(6.)/2. 
        t2m(-2)=cmplx(vxx-vyy,-2*vxy)/sqrt(6.)/2. 
                                                                        
        call dewigner(2,-beta*rad,d2) 
        do m=-2,2 
        do n=-2,2 
         fm=-float(n)*alpha*rad 
         fn=-float(m)*gamma*rad 
         dsxct(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d2(m,n) 
        end do 
        end do 
                                                                        
        do n=-2,2 
         hc1=(0.,0.) 
         do m=-2,2 
          hc1=hc1+t2m(m)*dsxct(m,n) 
         end do 
         t2mC(n)=hc1 
        end do 
                                                                        
        q62=sqrt(6.0)/2.0 
        vxx=real(-t2mC(0)+q62*(t2mC(2)+t2mC(-2))) 
        vyy=real(-t2mC(0)-q62*(t2mC(2)+t2mC(-2))) 
        vzz=2*real(t2mC(0)) 
        vxy=-real(q62*(t2mC(2)-t2mC(-2))*cmplx(0.,1.)) 
        vxz=-real(q62*(t2mC(1)-t2mC(-1))) 
        vyz=real(q62*(t2mC(1)+t2mC(-1))*cmplx(0.,1.)) 
                                                                        
        write(nwr,'(6f10.3,//)') vxx,vxy,vxz,vyy,vyz,vzz 
        goto 103 
       end if 
  104  continue 
                                                                        
       write(nwr,'(/,a,/)')'-----------------------------------------' 
       goto 1 
                                                                        
   60 continue 
                                                                        
         querytype='Euler angle (alpha,beta,gamma):' 
         chcom='read/unitvectors/format11' 
         ch132='90,0,0' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
         call trlch(ncl,ch132,nn,out) 
         oalpha=out(1) 
         obeta=out(2) 
         ogamma=out(3) 
                                                                        
        querytype='rotation axis(ax_theta,ax_phi) anle (omega):' 
         chcom='read/unitvectors/format11' 
         ch132='54.7356 45.0 120.0' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
         call trlch(ncl,ch132,nn,out) 
         ax_theta=out(1) 
         ax_phi=out(2) 
         omega=out(3) 
      write(nwr,'(a)') 
      ch80=enwr(7) 
      enwr(7)='eulr' 
      icase=0 
      call euler_omega(ax_theta,ax_phi,omega,oalpha,obeta,ogamma,       &
     &                        alpha,beta,gamma,thick,icase,info)        
      enwr(7)= ch80 
                                                                        
       write(nwr,'(/,a,/)')'-----------------------------------------' 
      goto 1 
                                                                        
   70 continue 
      querytype='three Euler angles (alpha,beta,gamma):' 
       chcom='read/euler_angles' 
       ch132='0,0,0' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
                                                                        
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) goto 70 
       alpha=out(1) 
       beta=out(2) 
       gamma=out(3) 
                                                                        
   71  call dewigner(1,beta*rad,d1) 
       do m=-1,1 
        do n=-1,1 
         fm=float(m)*alpha*rad 
         fn=float(n)*gamma*rad 
         drt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
        end do 
       end do 
                                                                        
       uvecb(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1)) 
       uvecb(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1)) 
       uvecb(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1)) 
                                                                        
       uvecb(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1)) 
       uvecb(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1)) 
       uvecb(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1)) 
                                                                        
       uvecb(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0)) 
       uvecb(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0)) 
       uvecb(3,3)=real(drt(0,0)) 
                                                                        
       write(nwr,'(/,a)') ' unit vectors of system Sb in S'

       
      do k=1,3 
          if(abs(uvecb(k,3)).lt.0.0001) then
             theta=pi/2.
          else   
           sint=sqrt(1.-uvecb(k,3)**2)/uvecb(k,3)                               
           theta=atan(sint)
          end if
          if(sint.lt.0.) theta=pi+theta                                      
          if(abs(sint).lt.0.0001)then
             theta=0.; phi=0.
          else
           if(abs(uvecb(k,1)).gt.0.0001)then
            phi=atan(uvecb(k,2)/uvecb(k,1))                                      
           else
              phi=0.
           end if
          end if 
          if(uvecb(k,1).lt.0.) phi=phi+pi                                    
       write(nwr,'(6x,a3,a,3(f8.3,a5),3x,2f6.1)')ebi(k),'=',        &
             uvecb(k,1),' ex +',uvecb(k,2),' ey +',uvecb(k,3),' ez',&
             theta/rad,phi/rad    
!       write(nwr,'(6x,a3,a1,3(f8.3,a5))')ebi(k),'=',                    &
!            uvecb(k,1),' ex +',uvecb(k,2),' ey +',uvecb(k,3),' ez'     
      end do 
                                                                        
       h=(uvecb(1,2)-uvecb(2,1))**2+(uvecb(1,3)-uvecb(3,1))**2+         &
     &   (uvecb(2,3)-uvecb(3,2))**2                                     
       sino=sqrt(h/4) 
       h=sqrt(abs(1.0-h/4.0)) 
                                                                        
       omega=arcos(h) 
   75  continue 
       if(sino.gt.0.001) then 
        omx= (uvecb(2,3)-uvecb(3,2))/2.0/sino 
        omy=-(uvecb(1,3)-uvecb(3,1))/2.0/sino 
        omz= (uvecb(1,2)-uvecb(2,1))/2.0/sino 
                                                                        
         omcosg=1.0-cos(omega) 
                                                                        
        h= abs((uvecb(1,2)+uvecb(2,1))/2.0-omx*omy*omcosg)              &
     &    +abs((uvecb(1,3)+uvecb(3,1))/2.0-omx*omz*omcosg)              &
     &    +abs((uvecb(2,3)+uvecb(3,2))/2.0-omy*omz*omcosg)              
        if(h.gt.0.001) then 
         omega=pi-omega 
         goto 75 
        end if 
       else 
!       omega=0 or pi                                                   
        if(abs(uvecb(1,1)+ uvecb(2,2)+uvecb(3,3)-3).lt.0.001) then 
         omega=0 
         omx=0.0 
         omy=0.0 
         omz=1.0 
        else 
         omega=pi 
         omx=sqrt(abs(1.0+uvecb(1,1))/2.0) 
         omy=sqrt(abs(1.0+uvecb(2,2))/2.0) 
         omz=sqrt(abs(1.0+uvecb(3,3))/2.0) 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
!        - + +                                                          
         omx=-omx 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
!        + - +                                                          
         omx=-omx 
         omy=-omy 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
!        + + -                                                          
         omy=-omy 
         omz=-omz 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
!        --+                                                            
         omx=-omx 
         omy=-omy 
         omz=-omz 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
!        -+-                                                            
         omy=-omy 
         omz=-omz 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
!        +--                                                            
         omx=-omx 
         omy=-omy 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
!        ---                                                            
         omx=-omx 
         h= abs((uvecb(1,2)/2.0-omx*omy))+abs((uvecb(1,3)/2.0-omx*omz)) &
           +abs((uvecb(2,1)/2.0-omx*omy))+abs((uvecb(2,3)/2.0-omy*omz)) &
           +abs((uvecb(3,1)/2.0-omx*omz))+abs((uvecb(3,2)/2.0-omy*omz)) 
         if(h.lt.0.001) goto 72 
         omega=pi-omega 
         goto 75 
   72    continue 
                                                                        
        end if 
       end if 
                                                                        
                                                                        
!       write(6,'(a,3f10.3)')' omx,omy,omz=',omx,omy,omz                
       ax_theta=arcos(omz) 
       sint=sin(ax_theta) 
       if(abs(sint).lt.0.001) then 
        ax_phi=0.0 
       else 
        ax_phi=arcos(omx/sint) 
        if(omy/sint.lt.0.0) ax_phi=2.0*pi-ax_phi 
       end if 
       ax_theta=ax_theta/rad 
       ax_phi=ax_phi/rad 
       write(nwr,'(/,5x,2(a,f10.2),/,5x,a,f10.2)')                      &
     & 'polar angel of rotation axes: theta=',ax_theta,' phi=',ax_phi,  &
     & 'rotation angle omega=',omega/rad                                
                                                                        
       write(nwr,'(/,a,/)')'-----------------------------------------' 
       goto 1 
                                                                        
   80  continue 
                                                                        
        querytype='ax_theta1,ax_phi1,omega1:' 
         chcom='read/unitvectors/format11' 
         ch132='54.7356 45.0 120.0' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
         call trlch(ncl,ch132,nn,out) 
         ax_theta=out(1) 
         ax_phi=out(2) 
         omega=out(3) 
                                                                        
        querytype='ax_theta2,ax_phi2,omega2:' 
         chcom='read/unitvectors/format11' 
         ch132='54.7356 45.0 120.0' 
         call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
         ch1=ch132(1:1) 
         if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
         call trlch(ncl,ch132,nn,out) 
         ax_theta2=out(1) 
         ax_phi2=out(2) 
         omega2=out(3) 
      write(nwr,'(a)') 
      call euler_omega2(ax_theta,ax_phi,omega,ax_theta2,ax_phi2,omega2, &
     &                        alpha,beta,gamma )                        
      goto 71 
                                                                        
 1000 continue 
      stop 
      END                                           
                                                                        
!#####################################################################  
    subroutine inverstr(al,be,gam,nwr)
    implicit none
    integer, intent(in)::nwr
    real, intent(in)::al,be,gam
    real  uveca(3,3),uvecb(3,3),d1(-1:1,-1:1),fm,fn,alpha,beta,gamma
    integer m,n
    real, parameter:: pi=3.14159265, rad=pi/180.0
    complex drt(-1:1,-1:1)
       call dewigner(1,-be*rad,d1) 
       do m=-1,1 
        do n=-1,1 
         fm=-float(n)*al*rad 
         fn=-float(m)*gam*rad 
         drt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
        end do 
       end do 
       uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
                                                                        
       uvecb(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1)) 
       uvecb(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1)) 
       uvecb(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1)) 
                                                                        
       uvecb(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1)) 
       uvecb(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1)) 
       uvecb(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1)) 
                                                                        
       uvecb(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0)) 
       uvecb(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0)) 
       uvecb(3,3)=real(drt(0,0)) 
       call angle_uvecab(uveca,uvecb,alpha,beta,gamma)
       write(nwr,'(a,a,3(f7.2,a))')                           &
       'invers transformation  ',                            &
        '(alpha=',alpha,',beta=',beta,',gamma=',gamma,')'    
     return
    End
    subroutine angle_uvecab(uveca,uvecb,alpha,beta,gamma)
    implicit none
    real, intent(in):: uveca(3,3),uvecb(3,3)
    real, intent(out)::alpha,beta,gamma
    real h,st,arcos
    integer k
    real, parameter:: pi=3.14159265, rad=pi/180.0

!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
     return
     END

      real function arcos(h) 
                                                                        
      pi2=2.0*atan(1.0) 
      hh=h*h 
      if(hh.ge.1) then 
       arcos=0.0 
       if(h.lt.0.0) arcos=2.0*pi2 
      else 
       s=sqrt(1.0-hh) 
       if(abs(h).lt.0.0001) then 
        arcos=pi2 
       else 
        arcos=atan(s/h) 
        if(h.lt.0) arcos=2.0*pi2+arcos 
       end if 
      end if 
      return 
      END                                           
                                                                        
      subroutine uvector(cp132,uvec) 
                                                                        
      character cp132*132 
      dimension uvec(3),out(32) 
                                                                        
       call stringlength(cp132,il) 
       do k=2,il-1 
        if(cp132(k:k).eq.' ') then 
         do i=k,il-1 
          cp132(i:i)=cp132(i+1:i+1) 
         end do 
        end if 
       end do 
       call trlch(il,cp132,nn,out) 
       uvec(1)=out(1) 
       uvec(2)=out(2) 
       uvec(3)=out(3) 
      return 
      END                                           
                                                                        
      subroutine crospr(uvec1,uvec2,uvec3) 
      dimension uvec1(3),uvec2(3),uvec3(3) 
!      write(6,'(3f12.3)')uvec1 
!      write(6,'(3f12.3)')uvec2
      uvec3(1)= uvec1(2)*uvec2(3)-uvec1(3)*uvec2(2) 
      uvec3(2)=-uvec1(1)*uvec2(3)+uvec1(3)*uvec2(1) 
      uvec3(3)= uvec1(1)*uvec2(2)-uvec1(2)*uvec2(1) 
!      write(6,'(/,3f12.3)')uvec3
      h=0.0 
      do k=1,3 
       h=h+ uvec3(k)**2 
      end do 
      h=sqrt(h) 
      do k=1,3 
       uvec3(k)=uvec3(k)/h 
      end do 
!      write(6,'(3f12.3)')(uvec1(k),k=1,3)                              
!      write(6,'(3f12.3)')(uvec2(k),k=1,3)                              
!      write(6,'(3f12.3)')(uvec3(k),k=1,3)                              
      return 
      END                                           
                                                                        
       subroutine euler_omega(ax_theta,ax_phi,omega,oalpha,obeta,ogamma,&
     &                        alpha,beta,gamma,thickness,case,info)     

       integer case 
       character(len=132):: infotext
       character(len=4)  :: enwr                                                                        
       common/infenw/ enwr(16),infotext(8)
       real ax_theta,ax_phi,omega,oalpha,obeta,ogamma,alpha,beta,gamma, &
            thickness                                                   
       real uveca(3,3),uvecb(3,3),dj(-1:1,-1:1),uvec(3,3) 
       complex drt(-1:1,-1:1) 
       parameter (pi=3.141592654,rad=0.017453293) 
       character*6 eai(3),ebi(3),text(3)*8 
       logical b_error 
                                                                        
!       write(6,'(a,3f10.1)')' alpha,beta,gamma=',oalpha,obeta,ogamma   
!      oalpha,obeta,ogamma is the transformation of the crystal system t
!      absorber system.                                                 
!      omega rotation around the axis ax_theta,ax_phi in the absorbersys
                                                                        
!      inverse matrix uveca                                             
       call dewigner(1,obeta*rad,dj) 
       do m=-1,1 
        do n=-1,1 
         fm=float(m)*oalpha*rad 
         fn=float(n)*ogamma*rad 
         drt(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n) 
        end do 
       end do 
                                                                        
       uveca(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1)) 
       uveca(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1)) 
       uveca(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1)) 
                                                                        
       uveca(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1)) 
       uveca(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1)) 
       uveca(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1)) 
                                                                        
       uveca(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0)) 
       uveca(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0)) 
       uveca(3,3)=real(drt(0,0)) 
                                                                        
                                                                        
       xalpha=ax_phi*rad 
       xbeta=ax_theta*rad 
       xgamma=omega*rad 
                                                                        
       cosa=cos(xalpha) 
       sina=sin(xalpha) 
       cosb=cos(xbeta) 
       sinb=sin(xbeta) 
                                                                        
       cosg=cos(xgamma) 
       sing=sin(xgamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
                                                                        
       uvecb(1,1)=dx**2*omcosg +cosg 
       uvecb(1,2)=dx*dy*omcosg+dz*sing 
       uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uvecb(2,1)=dx*dy*omcosg-dz*sing 
       uvecb(2,2)=dy**2*omcosg+cosg 
       uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uvecb(3,1)=dx*dz*omcosg+dy*sing 
       uvecb(3,2)=dy*dz*omcosg-dx*sing 
       uvecb(3,3)=dz**2*omcosg+cosg 
                                                                        
       do l=1,3 
       do m=1,3 
        h=0. 
        do i=1,3 
         h=h+uvecb(l,i)*uveca(i,m) 
        end do 
        uvec(l,m)=h 
       end do 
       end do 
       uvecb=uvec
       uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
                                                                        
       b_error=.false. 
       if(case.eq.3)then 
!       1. case: Rotation axis (defined with respect to the lab. system 
!               is the g-direction) is normal to the surface of the samp
!               The thickness of the sample increases by the factor 1/co
!       2. case: rotation axis lies in the sample plane (ax_theta=90°) 
!               The sample is rotated out of the position orthonormal to
!               g-direction by the rotation angle omega. The thickness o
!               sample increases by the factor 1/cos(omega)             
!       Which case is decided by theta<90°.                            
        b_error=.true. 
        if(abs(ax_theta-90).lt.0.01) then 
         if(cosg.gt.0.05)then 
          thickness=1./cosg 
          b_error=.false. 
         end if 
        else 
         if(cosb.gt.0.05)then 
          thickness=1./cosb 
          b_error=.false. 
         end if 
        end if 
        if(b_error)then 
         info=1 
         infotext(1)='sample/rotation/axis' 
         infotext(2)(1:17)=' Rotation axis is ill defined' 
         infotext(3)=' ' 
         goto 10 
        end if 
       end if 
                                                                        
!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
                                                                        
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
                                                                        
!       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'      
!      caution! vector a is the transpose matrix in order to print the  
!      unit vectors of the rotated system in the original system.       
                                                                        
   10 if(enwr(7).eq.'eulr'.or.b_error) then 
       write(nwr,'(/,a,/,3(a,f10.2),/)')                                &
     &              ' unit vectors of system Sa and system Sb',         &
     & ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega          
                                                                        
       eai(1)='      x' 
       eai(2)='e_C = y' 
       eai(3)='      z' 
       ebi(1)='      x' 
       ebi(2)='r_ax= y' 
       ebi(3)='      z' 
       text(1)=' in the  ' 
       text(2)=' Lab.    ' 
       text(3)=' system  ' 
                                                                        
        do k=1,3 
         write(nwr,'(a12,x,2(a6,a3,3(f7.3,a1),3x))') text(k),           &
     &   eai(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'      
        end do 
                                                                        
        write(nwr,'(/,20x,a,/,a,3(f7.2,a),/)')                          &
     &  'Euler angles alpha,beta,gamma',                                &
     &  ' eb(n)=Sum;m ea(m) D1,mn(alpha=',                              &
     &    alpha,',beta=',beta,',gamma=',gamma,')'                       
        if(b_error) return 
       end if 
       return 
      END                                           
                                                                        
       subroutine  euler_dir(x_theta,x_phi,z_theta,z_phi,               &
     &                        alpha,beta,gamma,thickness,info)          

      character(len=132):: infotext
      character(len=4)  :: enwr                                                                        
      common/infenw/ enwr(16),infotext(8)
       real uveca(3,3),uvecb(3,3),uvec1(3),uvec2(3),uvec3(3) 
                                                                        
       parameter (pi=3.141592654,rad=0.017453293) 
       character*3 eai(3),ebi(3) 
       logical b_error 
                                                                        
         st=sin(x_theta*rad) 
         uvecb(1,1)=st*cos(x_phi*rad) 
         uvecb(1,2)=st*sin(x_phi*rad) 
         uvecb(1,3)=cos(x_theta*rad) 
                                                                        
                                                                        
         st=sin(z_theta*rad) 
         uvecb(3,1)=st*cos(z_phi*rad) 
         uvecb(3,2)=st*sin(z_phi*rad) 
         uvecb(3,3)=cos(z_theta*rad) 
                                                                        
!       zeta=arcos(uvecb(3,3)) is the angle between old and new z-axes  
!       1/ uvecb(3,3)> 1 is the increase of the thickness of the        
!       absorber with respect to the  g-direction parallel to the old z-
       b_error=.false. 
       thickness=1./abs(uvecb(3,3)) 
       if(thickness.gt.100) then 
        write(nwr,'(a)')' orientation of the scatterer is such that',   &
     &  ' the z-axis lies in the plan of the scatterer'                 
        b_error=.true. 
       end if 
                                                                        
         do k=1,3 
          uvec1(k)=uvecb(3,k) 
          uvec2(k)=uvecb(1,k) 
         end do 
         call crospr(uvec1,uvec2,uvec3) 
         do k=1,3 
          uvecb(2,k)=uvec3(k) 
         end do 
                                                                        
!      calculation of Euler angle alpha,beta,gamma                      
                                                                        
       beta=arcos(uvecb(3,3)) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        alpha=arcos(uvecb(1,1)) 
        h=uvecb(2,1) 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=uvecb(1,1) 
         gamma=0.0 
         alpha=arcos(-h) 
         h=uvecb(2,1) 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=uvecb(3,1) 
         alpha=arcos(h/st) 
         h=uvecb(3,2) 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
         h=uvecb(1,3) 
         gamma=arcos(-h/st) 
         h=uvecb(2,3) 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
                                                                        
      if(enwr(7).eq.'eulr') then 
                                                                        
   10  write(nwr,'(/,a,/,3(a,f10.2))')                                  &
     &              ' unit vectors of system Sb in system S',           &
     & ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega          
       eai(1)='eax' 
       eai(2)='eay' 
       eai(3)='eaz' 
       ebi(1)='ebx' 
       ebi(2)='eby' 
       ebi(3)='ebz' 
       do k=1,3 
        write(nwr,'(6x,a3,a1,3(f8.3,a5))')ebi(k),'=',                   &
     &        uvecb(k,1),' ex +',uvecb(k,2),' ey +',uvecb(k,3),' ez'    
       end do 
                                                                        
       write(nwr,'(/,a)') 'unit vectors of system Sa in system S' 
       do k=1,3 
        write(nwr,'(6x,a3,a1,3(f8.3,a6))')eai(k),'=',                   &
     &       uveca(k,1),' eax +',uveca(k,2),' eay +',uveca(k,3),' eaz'  
       end do 
                                                                        
       write(nwr,'(/,20x,a,/,a,3(f7.2,a),/)')                           &
     & 'Euler angles alpha,beta,gamma',                                 &
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',                                &
     &    alpha,',beta=',beta,',gamma=',gamma,')'                       
                                                                        
       if(b_error) return 
      end if 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
       subroutine euler_omega2(ax_theta,ax_phi,omega,                   &
     &                         ax_theta2,ax_phi2,omega2,                &
     &                        alpha,beta,gamma )                        
                                                                        
      character(len=132):: infotext
      character(len=4)  :: enwr                                                                        
      common/infenw/ enwr(16),infotext(8)
       real uveca(3,3),uvecb(3,3),uvec(3,3) 
       parameter (pi=3.141592654,rad=0.017453293) 
       character*6 eai(3),ebi(3),text(3)*8 
                                                                        
       xalpha=ax_phi2*rad 
       xbeta=ax_theta2*rad 
       xgamma=omega2*rad 
                                                                        
       cosa=cos(xalpha) 
       sina=sin(xalpha) 
       cosb=cos(xbeta) 
       sinb=sin(xbeta) 
                                                                        
       cosg=cos(xgamma) 
       sing=sin(xgamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
       uveca(1,1)=dx**2*omcosg +cosg 
       uveca(1,2)=dx*dy*omcosg+dz*sing 
       uveca(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uveca(2,1)=dx*dy*omcosg-dz*sing 
       uveca(2,2)=dy**2*omcosg+cosg 
       uveca(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uveca(3,1)=dx*dz*omcosg+dy*sing 
       uveca(3,2)=dy*dz*omcosg-dx*sing 
       uveca(3,3)=dz**2*omcosg+cosg 
                                                                        
                                                                        
                                                                        
       xalpha=ax_phi*rad 
       xbeta=ax_theta*rad 
       xgamma=omega*rad 
                                                                        
       cosa=cos(xalpha) 
       sina=sin(xalpha) 
       cosb=cos(xbeta) 
       sinb=sin(xbeta) 
                                                                        
       cosg=cos(xgamma) 
       sing=sin(xgamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
       uvecb(1,1)=dx**2*omcosg +cosg 
       uvecb(1,2)=dx*dy*omcosg+dz*sing 
       uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uvecb(2,1)=dx*dy*omcosg-dz*sing 
       uvecb(2,2)=dy**2*omcosg+cosg 
       uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uvecb(3,1)=dx*dz*omcosg+dy*sing 
       uvecb(3,2)=dy*dz*omcosg-dx*sing 
       uvecb(3,3)=dz**2*omcosg+cosg 
                                                                        
       do l=1,3 
       do m=1,3 
        h=0. 
        do i=1,3 
         h=h+uvecb(l,i)*uveca(i,m) 
        end do 
        uvec(l,m)=h 
       end do 
       end do 
       do l=1,3 
       do m=1,3 
        uvecb(l,m)=uvec(l,m) 
       end do 
       end do 
       
       uvec=uveca
       uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
                                                                        
!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
                                                                        
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
                                                                        
      eai(1)='     x' 
      eai(2)='e1 = y' 
      eai(3)='     z' 
      ebi(1)='     x' 
      ebi(2)='e21= y' 
      ebi(3)='     z' 
      text(1)='        ' 
      text(2)='        ' 
      text(3)='        ' 
!       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'      
!      caution! vector a is the transpose matrix in order to print the  
!      unit vectors of the rotatet system in the original system.       
                                                                        
       do k=1,3 
        write(nwr,'(a8,x,2(a6,a3,3(f7.3,a1),3x))') text(k),             &
     &  eai(k),' ( ',uvec(k,1),',',uvec(k,2),',',uvec(k,3),')',         &
     &  ebi(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'       
       end do 
       write(nwr,'(a)') 
                                                                        
       write(nwr,'(/,20x,a,/,a,3(f7.2,a),/)')                           &
     & 'Euler angles alpha,beta,gamma',                                 &
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',                                &
     &    alpha,',beta=',beta,',gamma=',gamma,')'                       
                                                                        
        return 
      END                                           
                                                                        
      SUBROUTINE JACOBI(A,N,D,V,NROT) 
      DIMENSION A(N,N),D(N),V(N,N)
      real, dimension(N):: B,Z  
       D=0.
       V=0.
       DO IQ=1,N 
        V(IQ,IQ)=1. 
       END DO
       DO IP=1,N 
        B(IP)=A(IP,IP) 
       END DO 
      D=B
      Z=0.
      NROT=0 
      DO I=1,50 
        SM=0. 
        DO  IP=1,N-1 
         DO IQ=IP+1,N 
           SM=SM+ABS(A(IP,IQ)) 
         END DO 
        END DO 
        IF(SM.EQ.0.)RETURN 
        IF(I.LT.4)THEN 
          TRESH=0.2*SM/N**2 
        ELSE 
          TRESH=0. 
        ENDIF 
        DO IP=1,N-1 
          DO IQ=IP+1,N 
            G=100.*ABS(A(IP,IQ)) 
            IF((I.GT.4).AND.(ABS(D(IP))+G.EQ.ABS(D(IP)))                &
              .AND.(ABS(D(IQ))+G.EQ.ABS(D(IQ))))THEN                   
              A(IP,IQ)=0. 
            ELSE IF(ABS(A(IP,IQ)).GT.TRESH)THEN 
              H=D(IQ)-D(IP) 
              IF(ABS(H)+G.EQ.ABS(H))THEN 
                T=A(IP,IQ)/H 
              ELSE 
                THETA=0.5*H/A(IP,IQ) 
                T=1./(ABS(THETA)+SQRT(1.+THETA**2)) 
                IF(THETA.LT.0.)T=-T 
              ENDIF 
              C=1./SQRT(1+T**2) 
              S=T*C 
              TAU=S/(1.+C) 
              H=T*A(IP,IQ) 
              Z(IP)=Z(IP)-H 
              Z(IQ)=Z(IQ)+H 
              D(IP)=D(IP)-H 
              D(IQ)=D(IQ)+H 
              A(IP,IQ)=0. 
              DO  J=1,IP-1 
                G=A(J,IP) 
                H=A(J,IQ) 
                A(J,IP)=G-S*(H+G*TAU) 
                A(J,IQ)=H+S*(G-H*TAU) 
              END DO
              DO  J=IP+1,IQ-1 
                G=A(IP,J) 
                H=A(J,IQ) 
                A(IP,J)=G-S*(H+G*TAU) 
                A(J,IQ)=H+S*(G-H*TAU) 
              END DO
              DO J=IQ+1,N 
                G=A(IP,J) 
                H=A(IQ,J) 
                A(IP,J)=G-S*(H+G*TAU) 
                A(IQ,J)=H+S*(G-H*TAU) 
              END DO
              DO J=1,N 
                G=V(J,IP) 
                H=V(J,IQ) 
                V(J,IP)=G-S*(H+G*TAU) 
                V(J,IQ)=H+S*(G-H*TAU) 
              END DO
              NROT=NROT+1 
            ENDIF 
         END DO
        END DO
          D=B+Z 
          B=D 
          Z=0. 
      END DO 
      RETURN 
      END                                           
                                                                        
      subroutine exyz(phi,theta,psi,invers,nwr) 
      implicit none 
      integer invers,m,n,nwr 
      real    phi,theta,psi,d1(-1:1,-1:1),hx,hy,hz,fn,fm 
      complex djv(-1:1,-1:1),ev(-1:1),evt(-1:1),hc1 
                                                                        
       if(invers.eq.-1) then 
        call dewigner(1,-theta,d1) 
        do m=-1,1 
         do n=-1,1 
          fm=-float(n)*phi 
          fn=-float(m)*psi 
          djv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 
       else 
        call dewigner(1,theta,d1) 
        do m=-1,1 
         do n=-1,1 
          fm=float(m)*phi 
          fn=float(n)*psi 
          djv(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 
       end if 
                                                                        
       ev(1)=-cmplx(1,0)/sqrt(2.) 
       ev(0)=(0.,0.) 
       ev(-1)=-conjg(ev(1)) 
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+ev(m)*djv(m,n) 
        end do 
        evt(n)=hc1 
       end do 
       hx=-real(evt(1)-evt(-1))/sqrt(2.0) 
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0) 
       hz= real(evt(0)) 
       write(nwr,'(a,3f8.3,a1)') ' ex= (',hx,hy,hz,')' 
                                                                        
       ev(1)=-cmplx(0,1)/sqrt(2.) 
       ev(0)=(0.,0.) 
       ev(-1)=-conjg(ev(1)) 
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+ev(m)*djv(m,n) 
        end do 
        evt(n)=hc1 
       end do 
       hx=-real(evt(1)-evt(-1))/sqrt(2.0) 
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0) 
       hz= real(evt(0)) 
       write(nwr,'(a,3f8.3,a1)') ' ey= (',hx,hy,hz,')' 
                                                                        
       ev(1)=(0.,0.) 
       ev(0)=(1.,0.) 
       ev(-1)=-conjg(ev(1)) 
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+ev(m)*djv(m,n) 
        end do 
        evt(n)=hc1 
       end do 
       hx=-real(evt(1)-evt(-1))/sqrt(2.0) 
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0) 
       hz= real(evt(0)) 
       write(nwr,'(a,3f8.3,a1)') ' ez= (',hx,hy,hz,')' 
                                                                        
       return 
      END                                            
                                                                        
      subroutine dewigner(j,bet,dd) 
!     integral j=0,1,2,4                                                
      dimension dd(-j:j,-j:j) 
                                                                        
       c=cos(bet) 
       s=sin(bet) 
       cp=1.0+c 
       cm=1.0-c 
       sq2=sqrt(2.) 
                                                                        
       if (j.eq.0) then 
        dd(0,0)=1. 
                                                                        
       else if (j.eq.1) then 
       dd(1,1) =cos(bet/2.)**2 
       dd(1,-1)=sin(bet/2.)**2 
       dd(1,0) =-s/sq2 
       dd(0,0) =c 
                                                                        
       else if (j.eq.2) then 
       sq6=sqrt(6.0)/2.0 
       dd(2,2) = cp**2/4.0 
       dd(2,-2)= cm**2/4.0 
       dd(2,1) = -s*cp/2.0 
       dd(2,-1)= -s*cm/2.0 
       dd(2,0) = sq6/2.0*s**2 
       dd(1,1) = cp*(2.0*c-1.0)/2.0 
       dd(1,-1)= cm*(2.*c+1.)/2. 
       dd(1,0) = -sq6*s*c 
       dd(0,0) = (3.*c**2-1.)/2. 
                                                                        
       else if (j.eq.4) then 
       sq5=sqrt(5.) 
       sq7=sqrt(7.) 
       cp2=cp**2 
       cp3=cp2*cp 
       cm2=cm**2 
       cm3=cm2*cm 
       dd(4,4) =cp*cp3/16. 
       dd(4,-4)=cm*cm3/16. 
       h=sq2/8.*s 
       dd(4,3) =-h*cp3 
       dd(4,-3)=-h*cm3 
       h=sq7/8.*s**2 
       dd(4,2) =h*cp2 
       dd(4,-2)=h*cm2 
       h=h*s*sq2 
       dd(4,1) =-h*cp 
       dd(4,-1)=-h*cm 
       dd(4,0) =h*s*sq5/2. 
       dd(3,3) =cp3/8.*(4.*c-3.) 
       dd(3,-3)=cm3/8.*(4.*c+3.) 
       h=sq7*s/8. 
       dd(3,2) =-h*sq2*cp2*(2.*c-1.) 
       dd(3,-2)=-h*sq2*cm2*(2.*c+1.) 
       h=h*s 
       dd(3,1) =h*cp*(4.*c-1.) 
       dd(3,-1)=h*cm*(4.*c+1.) 
       dd(3,0) =-h*sq5*2.*s*c 
       c2=c**2 
       dd(2,2) =cp2/4.*(7.*(c2-c)+1.) 
       dd(2,-2)=cm2/4.*(7.*(c2+c)+1.) 
       h=sq2/8.*s 
       dd(2,1) =-h*cp*(7.*(2.*c2-c)-1.) 
       dd(2,-1)=-h*cm*(7.*(2.*c2+c)-1.) 
       dd(2,0) =h*sq5*s*(7.*c2-1.) 
       dd(1,1) =cp/8.*(c*(28.*c2-6.)-21.*c2+3.) 
       dd(1,-1)=cm/8.*(c*(28.*c2-6.)+21.*c2-3.) 
       dd(1,0) =-sq5/4.*s*c*(7.*c2-3.) 
       dd(0,0) =(c2*(35.*c2-30.)+3.)/8. 
       end if 
                                                                        
!      point mirror at index (0,0)                                      
       do mpt=j,1,-1 
       do m=mpt,-mpt,-1 
        l=mod(mpt-m,2) 
        dd(-mpt,-m)=dd(mpt,m)*(-1)**l 
       end do 
       end do 
                                                                        
!      diagonal mirror - indices (m,m)                                  
       do mpt=-1,-j,-1 
       do m=-mpt-1,mpt+1,-1 
        l=mod(mpt-m,2) 
        dd(m,mpt)=dd(mpt,m)*(-1)**l 
       end do 
       end do 
       do mpt=j,1,-1 
       do m=mpt-1,-mpt+1,-1 
        l=mod(mpt-m,2) 
        dd(m,mpt)=dd(mpt,m)*(-1)**l 
       end do 
       end do 
                                                                        
      return 
      END                                           


