      program line 

     implicit none
     character(len=132):: infotext(8)
     integer,parameter :: maxco=64
     character(len=132):: queryar,helpar,type,deffile,filetype,         &
                          querytype,chin,chcom,ch132,chstart
     character(len=16) :: ext,winfile
     character(len=80) :: localhepath,chdf
     integer             ld,lw,laenge,lpart
      character(len=80), dimension(3):: chst
      common/localpath/ localhepath 
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco), &
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)

      real      out(32),                                                &
                QAS,eta,Is,L1,L2,L5,L6,haeu,Phi_H,Teta_H,dDq,deta,Dl,rad              


      LOGICAL   b_exist
      character ch1*1  

      integer   ncl,nwr,nrd,kwin,icol,i,k,j,nn,                         &       
                ioct,il,info,lk,lq,neta,                                &
                id1,npl,ncol,nrows,ixpixel,iypixel,led  
      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led       

                                                                        
      localhepath='/Mossbauer_spectrum.help' 
                                                                        
      ncl=80 
      nwr=6 
      nrd=5 
      kwin=1 
      call window(kwin) 
      npl=ncol(kwin) 
      icol=npl 
      rad=atan(1.)/45. 
                                                                        
        filetype='results of hypfields' 
        deffile='hypfields.lst' 
        ext='lst' 
        chcom='hypfields/outfile' 
        call  readfile(filetype,deffile,ext,ld,chcom,ncl,nrd,nwr) 
        if(deffile(1:1).eq.'q') goto 100 
         open (unit=12,file=deffile                                     &
     &                    ,status='unknown'                             &
     &                    ,access='sequential'                          &
     &                    ,form='formatted')                            
                                                                        
      write(nwr,'(/)') 
     chst(1)='-6.551 -4.2325  2.9495   5.834 ' 
     chst(2)='-6.551 -4.2325 5.834  Is=-0.5' 
     chst(3)=' L=-6.5509 R=5.8341  Is=-0.5 Deq=-4.0' 
                                                                        
    1 lq=3 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf='a' 
       chdf(80:80)='#' 
       chin=                                                            &
     & 'hyperfine fields from line positions of a 3/2<->1/2 transition' 
       helpar(1)='hypfields' 
       helpar(2)='hypfields' 
       helpar(3)='hypfields' 
       queryar(1)='a:L1,L2,L5,L6' 
       queryar(2)='b:L1,L2,L6,Is' 
       queryar(3)='c:L1,L6,Is,Deq' 
       call query(lq,lk,chin,chdf) 
       if(lq.eq.0) then 
        info=1 
        infotext(1)='query' 
        infotext(2)='no substring selected or exited with (q/*)' 
        infotext(3)=' ' 
         goto 100 
       end if 
      chstart=chst(lq)                                                                  
      goto(1000,2000,3000)lq 
 1000 continue 
                                                                        
 1005 querytype='line position L1,L2,L5 and L6:' 
       chcom='hypfields' 
       call askstring(querytype,chstart,chcom,ncl,nwr)
       chst(1)=chstart
       ch1=chstart(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 100 
            
       call trlch(80,chstart,nn,out) 
       if(nn.ne.4)then 
        write(nwr,'(a)') ' 4 numbers are expected' 
        goto 1005 
       end if 
       L1=out(1) 
       L2=out(2) 
       L5=out(3) 
       L6=out(4)
       Print*,L1,l2,l5,l6
       Is=(L1+L2+L5+L6)/4. 
       print'(a,f10.3)', ' Is=',Is 
                                                                        
 1004  querytype='octant dDq d_eta:' 
       chcom='hypfields' 
       ch132='octant=1 dDq=-0.1  d_eta=0.1' 
       call askstring(querytype,ch132,chcom,ncl,nwr) 
       ch1=chstart(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1005 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) then 
        write(nwr,'(a)') ' 3 numbers are expected' 
        goto 1004 
       end if 
       ioct=out(1) 
       dDq=out(2) 
       deta=out(3) 
       neta=1./deta 
                                                                        
       write(nwr,'(a)')                                                 &
     &   '     EFG        eta      H [kG]      phi     theta'           
       write(12,'(a)')                                                  &
     &   '     EFG        eta      H [kG]      phi     theta'           
       QAS=0. 
       il=(L6-L1)/2./abs(dDq) 
       do i=1,il 
        QAS=QAS+dDq 
!        write(6,'(f10.3)')L2                                           
        j=0 
        do k=1,neta+1 
         eta=deta*k 
         b_exist=.false. 
         call lines_L_H(QAS,eta,Is,L1,L2,L6,ioct,                       &
                           haeu,Phi_H,Teta_H,b_exist)                  
        if(b_exist) then 
          if(j.eq.0)then 
           write(nwr,'(a)') 
           write(12,'(a)') 
          end if 
          write(nwr,'(2f10.3,3f10.2)')QAS,eta,haeu,Phi_H/rad,Teta_H/rad 
          write(12,'(2f10.3,3f10.2)')QAS,eta,haeu,Phi_H/rad,Teta_H/rad 
          j=k 
        end if 
        end do 
       end do 
!       write(nwr,'(1x,a1,a3)') char(27),'[2A'                          
       goto 1 
                                                                        
 2000  continue 
 2005  querytype='line position L1,L2,L6, and shift IS:' 
       chcom='hypfields' 
       call askstring(querytype,chstart,chcom,ncl,nwr) 
       ch1=chstart(1:1) 
       chst(2)=chstart
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 100 
                                                                        
       call trlch(80,chstart,nn,out) 
       if(nn.ne.4)then 
        write(nwr,'(a)') ' 4 numbers are expected' 
        goto 2005 
       end if 
       L1=out(1) 
       L6=out(3) 
       Is=out(4) 
       L2=out(2) 
                                                                        
 2004  querytype='octant dDq d_eta:' 
       chcom='hypfields' 
       ch132='octant=1 dDq=-0.1  d_eta=0.1' 
       call askstring(querytype,ch132,chcom,ncl,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 2005 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) then 
        write(nwr,'(a)') ' 3 numbers are expected' 
        goto 2004 
       end if 
       ioct=out(1) 
       dDq=out(2) 
       deta=out(3) 
       neta=1./deta 
                                                                        
                                                                        
       write(nwr,'(a)')                                                 &
     &   '     EFG        eta      H [kG]      phi     theta'           
       write(12,'(a)')                                                  &
     &   '     EFG        eta      H [kG]      phi     theta'           
                                                                        
       QAS=0. 
       il=(L6-L1)/2./abs(dDq) 
       do i=1,il 
        QAS=QAS+dDq 
!        write(6,'(f10.3)')L2                                           
        j=0 
        do k=1,neta+1 
         eta=deta*k 
         b_exist=.false. 
         call lines_L_H(QAS,eta,Is,L1,L2,L6,ioct,                       &
     &                      haeu,Phi_H,Teta_H,b_exist)                  
                                                                        
        if(b_exist) then 
          if(j.eq.0)then 
           write(nwr,'(a)') 
           write(12,'(a)') 
          end if 
          write(nwr,'(2f10.3,3f10.2)')QAS,eta,haeu,Phi_H/rad,Teta_H/rad 
          write(12,'(2f10.3,3f10.2)')QAS,eta,haeu,Phi_H/rad,Teta_H/rad 
          j=k 
        end if 
        end do 
       end do 
!       write(nwr,'(1x,a1,a3)') char(27),'[2A'                          
       goto 1 
 3000  continue 
 3005  querytype='line position L1,L6, shift IS,and  Deq:' 
       chcom='hypfields' 
       call askstring(querytype,chstart,chcom,ncl,nwr) 
       ch1=chstart(1:1) 
       chst(3)=chstart
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 100 
                                                                        
       call trlch(80,chstart,nn,out) 
       if(nn.ne.4)then 
        write(nwr,'(a)') ' 4 numbers are expected' 
        goto 3005 
       end if 
       L1=out(1) 
       L6=out(2) 
       Is=out(3) 
       QAS=out(4) 
                                                                        
 3004  querytype='octant dL d_eta:' 
       chcom='hypfields' 
       ch132='octant=1 dL=-0.1  d_eta=0.1' 
       call askstring(querytype,ch132,chcom,ncl,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 3005 
       call trlch(80,ch132,nn,out) 
       if(nn.ne.3) then 
        write(nwr,'(a)') ' 3 numbers are expected' 
        goto 3004 
       end if 
       ioct=out(1) 
       Dl=out(2) 
       deta=out(3) 
       neta=1./deta 
                                                                        
                                                                        
       write(nwr,'(a)')                                                 &
        '     L2        eta      H [kG]      phi     theta'            
       write(12,'(a)')                                                  &
        '     L2        eta      H [kG]      phi     theta'            
                                                                        
       L2=L1 
       il=(L6-L1)/2./Dl 
       do i=1,il 
        L2=L2+dl 
!        write(6,'(f10.3,i5)')L2,il                                           
        j=0 
        do k=1,neta+1 
         eta=deta*k 
         b_exist=.false. 
         call lines_L_H(QAS,eta,Is,L1,L2,L6,ioct,                       &
                           haeu,Phi_H,Teta_H,b_exist)                  
        if(b_exist) then 
          if(j.eq.0)then 
           write(nwr,'(a)') 
           write(12,'(a)') 
          end if 
          write(nwr,'(2f10.3,3f10.2)')L2,eta,haeu,Phi_H/rad,Teta_H/rad 
          write(12,'(2f10.3,3f10.2)')L2,eta,haeu,Phi_H/rad,Teta_H/rad 
          j=k 
        end if 
        end do 
       end do 
!       write(nwr,'(1x,a1,a3)') char(27),'[2A'                          
       goto 1 
                                                                        
  100  continue 
       close(unit=12) 
       stop 
      END                                           
                                                                        
       subroutine lines_L_H(QAS,eta,Is,L1,L2,L6,ioct,                   &
     &                      haeu,Phi_H,Teta_H,b_exist)                  
                                                                        
       real,    intent(in):: QAS,eta,Is,L1,L2,L6
       integer, intent(in):: ioct
       real,   intent(out):: haeu,Phi_H,Teta_H
       logical, intent(out):: b_exist 
       
       real  arcos 
       real, parameter :: cTms=15.2502, amuea=-0.15531, amueg=0.090604 
                                                                        
!      Fe_kGm/mm/s = 15.2502      6                                     
!      #ground state J(Fe)=1/2, exited state J(Fe)=3/2                  
!      Fe_jg = 0.5                7                                     
!      Fe_je = 1.5                8                                     
!      #  magnetic moments / nuclear magneton ( mue_n)                  
!      Fe_mueg = 0.090604         9                                     
!      Fe_muee = -0.15531         10                                    
                                                                        
       nwr=6 
!      if eta<0 the theoretical spectrum with haeu=0 (zero magnetic     
!                                        field is calculated)           
      pi = atan(1.)*4. 
      rad=pi/180.
      
      beta = 10.0/9.0*(amuea/amueg)**2-2.0 
      aL1 = L1-IS 
      aL2 = L2-IS 
      aL6 = L6-IS 
      hh = (aL1+aL2)**2 + (aL2+aL6)**2 + (aL1+aL6)**2 - QAS**2 
      h = hh*beta/2.0 + (aL2+aL1)**2 
      IF (h.lt.0.0) then 
!        write(nwr,'(3(a,f8.3,/),a,/)')                                 
!     &' h = (aL1+aL2)**2 + (aL2+aL6)**2 + (aL1+aL6)**2 - QAS**2 =',hh, 
!     &' beta/2.     =',beta/2.0,                                       
!     &' (aL2+aL1)**2=',(aL1+aL2)**2,                                   
!     &' h*beta/2.0 + (aL2+aL1)**2=',h,' is not > 0.!'                  
        goto 999 
      end if 
      h = (sqrt(h) + (aL1+aL2))/beta 
                                                                        
      haeu = h*cTms/amueg 
                                                                        
      QUAD =abs(QAS/2.) 
      h = h/QUAD 
      X = aL2/QUAD 
      aL= aL1/QUAD 
      R = aL6/QUAD 
                                                                        
      h1 = X+aL 
      h2 = X+R 
      h3 = R+aL 
      h0 = -(h3+2.0*h)/2.0 
      IF (X.gt.h0) then 
!        write(nwr,'(2(a,f8.3,/),a,/)')                                 
!     &'            X=aL2/abs(QAS/2)  =',X,                             
!     &' h0=-(aL6+aL1+h)/abs(QAS/4.)  =',h0,                            
!     &' X is not < h0 !'                                               
        goto 999 
      end if 
      c1 = 2.0*R+h1 
      c2 = X-aL 
      d  = -(h1+2.0*h) 
      h1 = c1**2 
      h2 = c2**2 
      h3 = d**2 
      a2 = -(2.0*h3+h1+h2)/4.0 
      a1 = -d/4.0*(h1-h2) 
       if (QAS.lt.0.0) a1=-a1 
      a0 = (h3-h1)*(h3-h2)/16.0 
                                                                        
      am2 = -(a2+2.0)/10.0 
      IF (am2.lt.0.00001) then 
         write(nwr,'(a,f8.3,a,/)')' am2=-(a2++2)/10 =',am2,' is < 0.00001'
        goto 999 
      end if 
      eta2 = eta**2 
      h1 = 1.0+eta2/3.0 
      h2 = sqrt(h1)*a1/8.0/am2+2.0 
                                                                        
        sint2 = ((a0-9.0*am2*am2+2.0*am2*(5.0-eta2)/h1-1.0)             &
     &        /4.0/am2*h1+2.0*h2)/(9.0-eta2)                            
        if (sint2.lt.0.0.or.sint2.gt.1.) then 
!           write(nwr,'(a,f8.3,a,/)')' sin(theta)**2 =',sint2,'  < 0.0'
        goto 999 
        end if 
        if (sint2.lt.0.00001.or.eta.lt.0.0001) then 
          cos2p = 1. 
        else 
          cos2p = (3.0-h2/sint2)/eta 
          if (abs(cos2p).gt.1.0) then 
!           write(nwr,'(a,f8.3,a,/)')                                   
!     &     ' cos(2*phi) =',cos2p,' is out of range  '                  
           goto 999 
          end if 
        end if 
                                                                        
       teta=arcos(sqrt(1.-sint2)) 
       phi =arcos(cos2p)/2. 
                                                                        
        if(ioct.gt.4) then 
         teta=pi-teta 
         i_oct=ioct-4 
        else 
         i_oct=ioct 
        end if 
                                                                        
      goto(101,102,103,104) i_oct 
  101 Phi_H  = phi 
      Teta_H = teta 
      goto 105 
  102 Phi_H  = pi-phi 
      Teta_H = teta 
      goto 105 
  103 Phi_H  = pi+phi 
      Teta_H = teta 
      goto 105 
  104 Phi_H  = -phi 
      Teta_H = teta 
      goto 105 
  105 continue 
      b_exist=.true. 
  999 continue 
                                                                        
      return 
      END                                           
                                                                        
      real function arcos(h) 
                                                                        
      pi2=2.0*atan(1.0) 
      hh=h*h 
      if(hh.ge.1) then 
       arcos=0.0 
       if(h.lt.0.0) arcos=2.0*pi2 
      else 
       s=sqrt(1.0-hh) 
       if(abs(h).lt.0.0001) then 
        arcos=pi2 
       else 
        arcos=atan(s/h) 
        if(h.lt.0) arcos=2.0*pi2+arcos 
       end if 
      end if 
      return 
      END                                           
