     program main
      implicit none
     integer,parameter :: maxco=64
     character(len=132):: queryar,helpar,type,                        &
                          querytype,chin,chcom,ch132,cp132,ct132
     character(len=16) :: ext,winfile,element
     character(len=80) :: ch80,localhepath
     character(len=3),dimension(1:3):: eai,ebi
     character          ch1*1,ch2*2    
      integer           ld,lw,laenge,lpart
      character(len=132):: infotext
      character(len=8)  :: ch8  
      character(len=6)  :: chbold,chnorm                       
      character(len=7)  :: form
      character(len=4)  :: enwr      
      character(len=2), dimension(82) :: ES
      character(len=12),dimension(82) :: Ename
      character(len=12) :: name
      real,    dimension(82) :: Emolweight
      integer, dimension(12) :: indx, mult
      real,    dimension(12) :: atcoef
 
      common/infenw/ enwr(16),infotext(8)
      common/localpath/ localhepath 
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)
      integer     id1,npl,ncol,nrows,ixpixel,iypixel,led,              &
                  ncl,nwr,nrd,kwin,icol
      
      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led 
      integer i,l,lq,lk,j,k,nZ,mZ,iout,indxp,istep,nn
      real value,energy,atc,atc1,atc2,thick,density,hmol,pfr,uthick_w,  &
           act1,act2,bg0,t_eff,effect,f_factor,at_mossb,at_122,bessi0,  &
           bessi1,start,end,dinc,h0,h1,hn,hd,spl,bg,f_source
      real      out(32)
      
    chbold=char(27)//'[1m' 
    chnorm=char(27)//'[0m' 
      ncl=80 
      nwr=6 
      nrd=5 
      kwin=1 
      call window(kwin) 
      npl=ncol(kwin) 
      icol=npl

      write(nwr,'(/,7(a,/),//)')' The program uses the tables:', &
      ' X-Ray Mass Attenuation Coefficients', &
      ' published by National Institute of Standards and Technology (NIST)',&
      ' 1996 copyright by the U.S. Secretary of Commerce',&
      ' and',&
      ' Das Periodensystem der Elemente online:Dichte der Elemente im Festzustand',&
      ' Copyright 2010-2015 by René Rausch'

      
     open (unit=1, file='elements.dat')
     do i=1,82
      read(1,'(a)')ch80
!42      Mo      Molybdenum        95.95      
      ES(i)=ch80(9:10)
      Ename(i)=ch80(17:28)
      ch132=ch80(30:)
      call trlch(20,ch132,iout,out)
      Emolweight(i)=out(1)
     end do
     close(unit=1)
!     do i=1,82
!    write(6,'(i3,2x,a2,2x,a12,4x,f10.2)')i,ES(i),Ename(i),Emolweight(i)
!     end do

      localhepath='/attenuation.help'       
5      lq=4
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       ch80='alpha' 
       ch80(80:80)='#' 
       helpar(1)='effect/alpha-iron' 
       helpar(2)='effect/sodiumnitrop' 
       helpar(3)='effect/fas' 
       helpar(4)='effect/compound' 
                                                                         
       queryar(1)='1 alpha-iron foil' 
       queryar(2)='2 Na_2Fe[(CN)_5NO]2H2O' 
       queryar(3)='3 FAS' 
       queryar(4)='4 compound' 
 
       chin='select ' 
       call query(lq,lk,chin,ch80) 
       if(lq.eq.0) goto 5
       

       act1=0.; act2=0.
       density=0.0
       select case(lq)
       case(1)
       indxp=1
       j=1
       indx(1)=26; mult(1)=1
       density= 7.8748   !g/cm**3
       uthick_w = 0.5907 
       f_factor=0.80 

       case(2)    
        ! Na_2Fe[(CN)_5NO]2H_2O,   1,72 g/cm3
        indxp=2
        j=6; indx(1)=11; mult(1)=2; indx(2)=26; mult(2)=1
             indx(3)=6; mult(3)=5;  indx(4)=7; mult(4)=6
             indx(5)=8; mult(5)=3;  indx(6)=1; mult(6)=2
        density=1.72; value=14.4
        uthick_w = 0.5907 
        f_factor=0.38 
        print'(a,a2)','Mossbauer nucleus: ',ES(indx(indxp))
       case(3) 
        ! (NH_4)_2Fe(SO_4)_2·6H_2O,   1,72 g/cm3
        indxp=3
        j=5; indx(1)=7; mult(1)=2; indx(2)=1; mult(2)=20
             indx(3)=26; mult(3)=1;  indx(4)=16; mult(4)=2
             indx(5)=8; mult(5)=14
        density=1.86; value=14.4
        uthick_w = 0.5907
        f_factor=0.27  
        print'(a,a2)','Mossbauer nucleus: ',ES(indx(indxp))
       case(4)
        querytype='formula of the compound'
        chin='N_2H_8Fe_1S_2O_8H_12O_6'
        chcom='effect/compound' 
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 

        value=1; form='i4'
        querytype='index of the Mossbauer nuclei'; chcom='effect/indxp'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        indxp=value
        call contentformula(chin,ES,j,indx,mult)
        print'(a,a2)','Mossbauer nucleus: ',ES(indx(indxp))

        querytype='f-factor of the sample, uthick_w:' 
        chcom='effect/datanulceus' 
        ch132='0.30  0.5907' 
 6      call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
        call trlch(80,ch132,nn,out) 
        if(nn.ne.2) goto 6 
        f_factor=out(1); uthick_w=out(2)

        value=0.0; form='f8.2'
        querytype='density of the compound g/cm3'; chcom='effect/density'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        density=value; 
      end select
      call fractiom(nrd,nwr,j,indxp,indx,mult,Ename,Emolweight,pfr)      
      print'(a,f8.3)','weight fraction of Mossbauer nulei',pfr 

      f_source=0.75; form='f8.3'
      querytype='f-factor of the source '; chcom='effect/f_source'
      call askvalue(querytype,form,f_source,chcom,ncol,nrd,nwr)

      energy=14.4; form='f8.2'
      querytype='Mossbauer transition energy '; chcom='effect/energy'
      call askvalue(querytype,form,energy,chcom,ncol,nrd,nwr)
      print'(a)'
      call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,energy,atc)

      if(indx(indxp).eq.26) then 
       value=122.01
       call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc1)
       value=136.46
       call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc2)
      end if

      if(density.gt.0.0)then
       lq=2
       ch80='thickness in mue' 
      else
       lq=1
       ch80='thickness mg' 
      end if
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       ch80(80:80)='#' 
       helpar(1)='effect/mgcm2' 
       helpar(2)='read/thickness' 
       queryar(1)='thickness mg/cm2' 
       queryar(2)='thickness in mue'
       chin='thickness of the sample' 
       call query(lq,lk,chin,ch80) 

       bg0=0.05;  spl=1.0
       ch132='10,10,190' 
 20    if(lq.eq.1)then
        querytype='do loop for istep,(start,end)[mg/cm2]:' 
        chcom='effect/do_loop' 
10      call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
        if(ch132(1:1).eq.'q') goto 100        
        call trlch(80,ch132,nn,out) 
        if(nn.ne.3) goto 10 
        istep=out(1); start=out(2); end=out(3) 
       else !lq=2
        querytype='do loop for istep,(start,end)[mue]:' 
        chcom='effect/do_loop' 
11      call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
        if(ch132(1:1).eq.'q') goto 100
        call trlch(80,ch132,nn,out)
        if(nn.ne.3) goto 11 
        istep=out(1); start=out(2); end=out(3) 
       end if

       form='f8.3'
       querytype='background fraction without sample'; chcom='effect/bg_fr'
       call askvalue(querytype,form,bg0,chcom,ncol,nrd,nwr)
       form='f8.1'
       querytype='hyperfine field splitting, intensity fraction'; 
       chcom='effect/splitting'
       call askvalue(querytype,form,spl,chcom,ncol,nrd,nwr)
       dinc=(end-start)/float(istep-1)
       if(lq.eq.1)then
        print'(a)','    mg/cm2     effect    G/G_nat    bg       effect/time'
       else
        print'(a)','      mue      effect    G/G_nat    bg       effect/time'
       end if

       do i=1,istep
        thick=start+dinc*(i-1)
        if(lq.eq.1) thick=thick/1.e3 
        if(lq.eq.2) thick=thick*density/1.e4 
        t_eff=thick*pfr*uthick_w*f_factor*1.e3*spl
       ! thick in g/cm2; t_eff in mg/cm2

!      print'(a,6f8.3)',' t_eff=',t_eff,thick,pfr,uthick_w,f_factor,atc
        at_mossb=exp(-thick*atc)
        at_122=0.111*exp(-thick*atc2)+0.889*exp(-thick*atc1)
        h0=BESSI0(t_eff/2.)
        h1=BESSI1(t_eff/2.)
        hn=t_eff*EXP(-t_eff/2)*(h0+h1)
        hd=1.-EXP(-t_eff/2.)*h0
        bg=bg0/(1-bg0);
!        base=I_14*(bg*at_122+at_mossb)
        bg=bg*at_122/(bg*at_122+at_mossb)
        effect=f_source*at_mossb/(bg0/(1-bg0)*at_122+at_mossb)*hd  

        print'(5f10.3)',start+dinc*(i-1),effect,hn/hd,bg,effect*sqrt(at_mossb)
       end do
      ch1='y'
      querytype='new values for "do loop", bg(0) and intensity fraction'; chcom='effect/repeat'
      call yesno(querytype,ch1,chcom,ncol,nrd,nwr)   
      if(ch1.eq.'y') goto 20
 100 continue     
end program main
     


    subroutine contentformula(formula,ES,j,indx,mult)
   implicit none
   
   character(len=132), intent(in):: formula
   character(len=2), dimension(82), intent(in):: ES
   integer, intent(out):: j
   integer, dimension(12), intent(out):: indx,mult

   character(len=132) :: ch132,cp132 
   character(len=2)   :: ch2
   integer i,l,k,m,mu
Print*,TRIM(formula)
    j=1
    ch132=ADJUSTL(formula)

100 if(ch132(2:2).eq.'_') then
     ch2=ch132(1:1)
     l=ichar(ch132(3:3))-48; m=ichar(ch132(4:4))-48
     k=4; mu=l
     if(m.le.9.and.m.ge.0)then
      k=5; mu=mu*10+m
     end if
    else
     ch2=ch132(1:2)
     l=ichar(ch132(4:4))-48; m=ichar(ch132(5:5))-48
     k=5; mu=l
     if(m.le.9.and.m.ge.0)then
      k=6; mu=mu*10+m
     end if
    end if
    cp132=ch132(k:)
    ch132=cp132
!print*,TRIM(ch132)
        i=1
        do while(ES(i).ne.ch2)
         i=i+1
        end do
      indx(j)=i; mult(j)=mu
      j=j+1
    if(ch132.ne.' ') goto 100
    j=j-1
!print'(2i5)',(indx(k),mult(k),k=1,j)
    return 
    end

  
  subroutine fractiom(nrd,nwr,j,indxp,indx,mult,Ename,Emolweight,pfr)
   implicit none
   integer, intent(in):: j,indxp,nrd,nwr
   integer, dimension(12), intent(in):: indx,mult
   character(len=12), dimension(82), intent(in):: Ename 
   real,              dimension(82), intent(in):: Emolweight   
   real, intent(out) :: pfr
   integer i
   real  hmol
        hmol=0.
        do i=1,j
         hmol=hmol+mult(i)*Emolweight(indx(i))
        end do
        i=indxp
        pfr=mult(i)*Emolweight(indx(i))/hmol
      return
     end

subroutine attenuation(energy,atc)
!====================================================================
!base on the code of spline interpolation described in
!http://ww2.odu.edu/~agodunov/computing/programs/book2/Ch01/spline.f90
! Spline interpolation
! Comments: values of function f(x) are calculated in n base points
! then: spline coefficients are computed
!       spline interpolation is computed in 2n-1 points, 
!       a difference sum|f(u)-vspline(u)| 
!====================================================================
   implicit none
   real, intent(in):: energy
   real, intent(out):: atc   
integer, parameter :: n=100      ! base points for interpolation
integer, parameter :: nint=21   ! compute interpolation in nint points
double precision xmin, xmax     ! given interval of x()
double precision, dimension (n) :: xi(0:n), yi(n), zi(n)
double precision, dimension (n) :: xs(4), ys(4), zs(4), b(4), c(4), d(4)
double precision x, y, step, error, errav
integer i,ns
double precision f, vspline
character*80 input

do i=1,6
   read(1,'(a)')input
!   print'(a)',input
end do
! step 1: generate xi and yi from f(x), xmin, xmax, n
i=0
xi(0)=0
do while(xi(i).lt.20)
   i=i+1
!   1.00000E-03  5.210E+03  5.197E+03 
   read(1,'(3x,e11.5,2x,e9.3,2x,e9.3)')xi(i),yi(i),zi(i)
!   print*,i,xi(i),yi(i)
end do

x=energy*1.0e-3
 i=1
do while(x.ge.xi(i))
!   print*,i,xi(i),yi(i)
   i=i+1
end do
if(xi(i).eq.x) then
  atc=yi(i)
   write (*,'(3f12.5)') x, atc
   goto 100
end if
i=i-1
if(xi(i-1).lt.xi(i))then
   ns=4
   xs(1)=xi(i-1); xs(2)=xi(i); xs(3)=xi(i+1); xs(4)=xi(i+2) 
   ys(1)=yi(i-1); ys(2)=yi(i); ys(3)=yi(i+1); ys(4)=yi(i+2) 
   if(xi(i+2).eq.xi(i+1))ns=3
else
  ns=3
  xs(1)=xi(i); xs(2)=xi(i+1); xs(3)=xi(i+2)
  ys(1)=yi(i); ys(2)=yi(i+1); ys(3)=yi(i+2)
  if(xi(i+2).eq.xi(i+1))ns=2
end if
!  write(6,'(3x,e11.5,2x,e9.3)')(xs(i),ys(i),i=1,ns)
!  step 2: call spline to calculate spline coeficients
call spline (xs, ys, b, c, d, ns) 

!  step 3: interpolation at nint points
  atc = vspline(x, xs, ys, b, c, d, ns)
!  write (*,'(3f12.5)') x, atc
100 continue

end subroutine attenuation


   subroutine atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,energy,atc)
   implicit none
   integer, intent(in):: j,nrd,nwr
   integer, dimension(12), intent(in):: indx,mult
   character(len=12), dimension(82), intent(in):: Ename 
   real,              dimension(82), intent(in):: Emolweight   
   real, intent(in)  :: energy
   real, intent(out) :: atc

   character(len=132):: chcom,querytype
   character(len=12):: name,element
   character(len=7) :: form
   real,    dimension(12) :: atcoef
   real    hmol
   integer ncol,i,l

!        ncol=80
!        chcom='read/compound' 
!        form='f8.2'
!        querytype='Photon energy in keV'; chcom='read/energy'
!        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
!        energy=value

        do i=1,j
         name=Ename(indx(i))
         open (unit=1, file='attenuation.coefficients')
         l=LEN_TRIM(name)+1
         element=' '  
         do while(element(2:l).ne.name)
          read(1,'(a)')element
         end do
         read(1,'(a)')element
         call attenuation(energy,atc)
         close(unit=1)       
         atcoef(i)=atc
        end do
        hmol=0.
        do i=1,j
         hmol=hmol+mult(i)*Emolweight(indx(i))
        end do
        atc=0.
        do i=1,j
         atc=atc+mult(i)*Emolweight(indx(i))*atcoef(i)
        end do
        atc=atc/hmol
        print'(f7.2,a,f7.3,a)',energy,'keV    mue/rho=',atc,' [cm2/g]'
      return
     end

     FUNCTION BESSI0(X) 
     REAL(kind=8):: Y,P1,P2,P3,P4,P5,P6,P7,                            &
                    Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9                                    
     DATA P1,P2,P3,P4,P5,P6,P7/1.0D0,3.5156229D0,3.0899424D0,  &
                               1.2067492D0,                    &
                               0.2659732D0,0.360768D-1,0.45813D-2/                           
     DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1,        &
         0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,           &
         0.2635537D-1,-0.1647633D-1,0.392377D-2/                       
     IF (ABS(X).LT.3.75) THEN 
       Y=(X/3.75)**2 
       BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))) 
     ELSE 
       AX=ABS(X) 
       Y=3.75/AX 
       BESSI0=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4                 &
           +Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))                       
     ENDIF 
     RETURN 
     END                                           

     FUNCTION BESSI1(X)
      REAL*8 Y,P1,P2,P3,P4,P5,P6,P7,&
         Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9
      DATA P1,P2,P3,P4,P5,P6,P7/0.5D0,0.87890594D0,0.51498869D0,&
         0.15084934D0,0.2658733D-1,0.301532D-2,0.32411D-3/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,-0.3988024D-1,&
         -0.362018D-2,0.163801D-2,-0.1031555D-1,0.2282967D-1,&
         -0.2895312D-1,0.1787654D-1,-0.420059D-2/
      IF (ABS(X).LT.3.75) THEN
        Y=(X/3.75)**2
        BESSI1=X*(P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))))
      ELSE
        AX=ABS(X)
        Y=3.75/AX
        BESSI1=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+  &
           Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))
      ENDIF
      RETURN
      END
