      program model2sym
      implicit none
      integer NPL,NWR,NRD,lfn,i,j,k,nn,ixmax,indx,
     &        ix(75),iy(75),jx(24,75),jy(24,75),isnumber(34),is(75),
     &        isymbol(75)
      real out(32),value

      character*132 chcom,infile,exten*16,filetype*32,chin,
     &              querytype,form*7
   


       NPL=80
       NRD=5
       NWR=6

      infile='MODEL_.SYM'
      lfn=10
      chcom='MODEL/datafile'
      filetype='MODEL.SYM to be translated'
      exten='dat'

 80   call readfile(filetype,infile,exten,lfn,
     &                                     chcom,NPL,NRD,NWR)

      OPEN (UNIT=2,FILE=infile,STATUS='old')
      i=1
      do while(.true.)
       read(2,'(a)',end=100)chin
       write(NWR,'(a)')chin(:30)
       j=index(chin,'#')
       if(j.gt.0) then
       call trlch(NPL,chin,nn,out)
      
        isnumber(i)=out(2)
        j=ichar(chin(1:1))-ichar('0')
        is(i)=j+1
        read(2,'(a)',end=100)chin
        call trlch(NPL,chin,nn,out)
         jx(1,i)=out(1)
         jy(1,i)=out(2)
         jx(2,i)=out(3)
         jy(2,i)=out(4)
        do k=2,j
         read(2,'(a)',end=100)chin
         call trlch(NPL,chin,nn,out)
         jx(k+1,i)=out(3)
         jy(k+1,i)=out(4)
        end do        
        i=i+1
       end if
      end do

 100  continue
      do k=1,i-1
        write(NWR,'(a,2i2)') '##',k
        write(NWR,'(i2,4x,2i6)')34,jx(1,k),jy(1,k)
        write(NWR,'(i2,4x,2i6)')(0,jx(j,k),jy(j,k),j=2,is(k))
      end do
      read(nrd,'(a)')
      querytype='smallest integer value for ix'
      form='i3'
      value=-1
      chcom='transform/limits'
      call askvalue(querytype,form,value,chcom,NPL,nrd,nwr)

      do k=1,i-1
        ix(k)=ix(k)-value
      end do

      querytype='smallest integer value for iy'
      form='i3'
      chcom='transform/limits'
      value=-3
      call askvalue(querytype,form,value,chcom,NPL,nrd,nwr)

       do k=1,i-1
        iy(k)=iy(k)-value
      end do
      do k=1,i-1
        write(NWR,'(i2,5x,3i4)')k,is(k),ix(k),iy(k)
      end do

      ixmax=0
      do k=1,i-1
       if(ixmax.lt.ix(k))ixmax=ix(k)     
      end do

      isymbol(1)=ixmax+4
      isymbol(2)=ix(1)+2+100*iy(1)
      j=2
      do k=2,i-1
       j=j+1
       if(is(k).eq.34)then        
        isymbol(j)=50
        j=j+1
        isymbol(j)=ix(k)+2+100*iy(k)
       end if             
       isymbol(j)=ix(k)+2+100*iy(k)      
      end do
      j=j+1 
      isymbol(j)=5050

      do k=1,j
        write(NWR,'(i2,5x,4i5)')k,isymbol(k)
      end do

      querytype='first index of k-array'
      form='i4'
      value=800
      chcom='transform/index'
      call askvalue(querytype,form,value,chcom,NPL,nrd,nwr)
      i=j/4
      indx=value
      do k=1,i      
       write(NWR,'(6x,a4,1x,3(a2,i3,a2),a2,i3,a2,3(i5,a1),i5,a1)')
     &    'DATA','K(',indx+4*(k-1),'),',
     &           'K(',indx+4*(k-1)+1,'),', 
     &           'K(',indx+4*(k-1)+2,'),', 
     &           'K(',indx+4*(k-1)+3,')/',isymbol(4*(k-1)+1),',',
     &           isymbol(4*(k-1)+2),',',isymbol(4*(k-1)+3),',',  
     &           isymbol(4*(k-1)+4),'/'

       end do
       i=j-4*i
       if(i.eq.1)then
        write(NWR,'(6x,a4,1x,a2,i3,a2i5,a1)')
     &    'DATA','K(',indx+4*(k-1),')/',isymbol(4*(k-1)+1),'/'
       else if(i.eq.2)then     
        write(NWR,'(6x,a4,1x,a2,i3,a2,a2,i3,a2,i5,a1,i5,a1)')
     &    'DATA','K(',indx+4*(k-1),'),',
     &           'K(',indx+4*(k-1)+1,')/',isymbol(4*(k-1)+1),',',
     &           isymbol(4*(k-1)+2),'/'
      else if(i.eq.3)then 
       write(NWR,'(6x,a4,1x,2(a2,i3,a2),a2,i3,a2,2(i5,a1),i5,a1)')
     &    'DATA','K(',indx+4*(k-1),'),',
     &           'K(',indx+4*(k-1)+1,'),', 
     &           'K(',indx+4*(k-1)+2,')/',isymbol(4*(k-1)+1),',',
     &           isymbol(4*(k-1)+2),',',isymbol(4*(k-1)+3),'/'
       end if


      stop 
      end

      subroutine readfile(filetype,deffile,exten,ld,chcom,ncol,nrd,nwr)
      character*80 user,logname,date,hostid,host,
     &              net,disksize,hepath,utpath,term,edt
      common/info/user,logname,date,hostid,host,net,
     &            disksize,hepath,utpath,term,edt
      character*132 ch132,chblank,deffile,chcom,exten*16,filetype*32,
     &              ch0*1,prompt*4
      integer mch(132),i,readaline
      logical ask

       ch0=char(0)
       ask=.true.
       if(ld.lt.0) ask=.false.
       lcol=ncol
       if(lcol.gt.132)lcol=132
       ch132=filetype
       call stringlength(ch132,lf)
       ch132=exten
       call stringlength(ch132,le)
       deffile(ncol:)=' '
       call stringlength(deffile,ld)
       
       nf=ncol-(27+lf)
  2    if(ld.lt.nf) then
         write(nwr,'(4a,a1)') '/directory/',filetype(1:lf),
     &                              '_file.exten:  [',deffile(1:ld),']'
       else
         write(nwr,'(3a,/,a1,a,a1)')'/directory/',filetype(1:lf),
     &    '_file.exten:','[',deffile(1:ld),']'
       end if
      
       if(ask) then
        call addhist(deffile(1:ld)//ch0)
        ch132=' '
        prompt='>'//ch0
        i=readaline(mch,prompt)
        if(i.gt.0) then
         do j=1,i
          ch132(j:j)=char(mch(j))
         end do
         call addhist(ch132(:i)//ch0)
        end if

c        read(nrd,'(a)') ch132
       else
        ch132=' '
       end if
       write(nwr,'(1x,a1,a3)') char(27),'[2A'
c       call lc_character(ch132)
       if(ch132(1:2).eq.'he') then
c        call help(chcom)
        goto 2
       end if
       if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then
        ld=0
        return
       end if
       if(ch132.ne.' ') then
        deffile=ch132
        ldl=ld
        call nextchar(deffile,0,ipos,ch132,ld)

        if(ch132(1:5).eq.'$HOME'.or.ch132(1:5).eq.'$home') then
         deffile=logname
         call nextchar(deffile,0,ipos,chblank,ll)
         deffile='/home/'//chblank(1:ll)//ch132(6:)
         call stringlength(deffile,ld)
        else if(ch132(1:11).eq.'$EFFIUTPATH') then
         deffile=utpath
         call nextchar(deffile,0,ipos,chblank,ll)
         deffile=chblank(1:ll)//ch132(12:)
         call stringlength(deffile,ld) 
        else if(ch132(1:2).eq.'~/') then
         deffile=logname
         call nextchar(deffile,0,ipos,chblank,ll)
         deffile='/home/'//chblank(1:ll)//ch132(2:)
         call stringlength(deffile,ld)
        else 
         deffile=ch132
        end if
        
c        write(6,'(a)')deffile(:80)
c        read(5,'(a)')
        chblank=' '
        i=index(deffile,'.')
        if(i.eq.0) then
         deffile=deffile(:ld)//'.'//exten(1:le)
         ld=ld+le+1
        else
         i=132
         ii=0
         do while(ii.eq.0.and.i.gt.0)
          if(deffile(i:i).eq.'.') ii=i
          i=i-1
         end do
         exten=deffile(ii+1:)
        end if
        if(ldl.gt.nf) write(nwr,'(1x,a1,a3)') char(27),'[2A'
        write(nwr,'(1x,a1,a3)') char(27),'[2A'
        write(nwr,'(a,/,a)') chblank(:lcol),chblank(:lcol)
        if(ldl.gt.nf) then
        write(nwr,'(a,/,a)') chblank(:lcol),chblank(:lcol)
        write(nwr,'(1x,a1,a3)') char(27),'[3A'
        end if
        write(nwr,'(1x,a1,a3)') char(27),'[3A'
        goto 2
       end if
c       call history(deffile)
       return
       end
      
