#define plotexita plotexita_
#define plotexit plotexit_
#define plot plot_
#define win win_
#define wptr wptr_
#define xmosplo xmosplo_
#define updatetst updatetst_
#define updatefit updatefit_
#define xplot3d xplot3d_ 

#define VERSION "10-Jan-1994"

#define MAXSP 32
#define MAXSUB 8
#define MAXN   1024
#define MAX8   MAXN*8
#define MAX16   MAXN*16
#define MAXSUBN (MAXSUB*MAX8)
#define INFPLOT (MAXSUB+6)
#define MDBPLFT MAXN*388
#define IDUMPLOT (MDBPLFT*2-176*MAXN-8*39-5*INFPLOT-MAXSUB-202)*4
#define stwinsizex 400
#define stwinsizey 250
#define cmpixel (10.0/0.29)
#define pixwin_cm  (stwinsizex/cmpixel)

 typedef struct {
           float x, y;
       } Xyarr;
 typedef struct {
           float phix,phiz,phiy, xp,yp,zp,strsx,strsy;
       } Xombg;
 typedef struct {
           float x,y,z;
       } DrawPosition;
DrawPosition pdraw[16];
/* fortran units for main program 
      parameter  (idumplot=MDBPLFT*2-176*maxn-8*39-5*infplot-maxsub-189)
      common/plot/ parray(maxn*112),xyzdz(8),vtxt(2,max16),vtxtp(8,32),
     &             int3d(max16),npnt3d(16),ifeder(max16),ltext(32),
     &             npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &             n_subspectra,logx,logy,logf,                 
     &             namechan(infplot),kform(infplot),axisformat(3),
     &             axesname(3),title,plotstrdef,plotstrpu,
     &             bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &             auxcolor1,auxcolor2,auxcolor3,datfile,txtu,chardum(idumplot)*/

extern struct plot{
    float    array[MAXN*112],xyzdz[8];
     Xyarr   vtxt[MAX16];
     Xombg   op[32];
      int    int3d[MAX16],npnt3d[16],ifeder[MAX16],ltext[32],
             npntplot[INFPLOT],nchanplot[INFPLOT],ncolor[MAXSUB],
             n_subspectra,logx,logy,logf;
      char   namechan[4][INFPLOT],kform[8][INFPLOT],axisformat[16][3],
             axes[3][24],title[132],strdef[264],
             bgcolor[24],fgcolor[24],datacolor[24],thcolor[24],rescolor[24],
             auxcolor1[24],auxcolor2[24],auxcolor3[24],datfile[80],txtu[4],
             chardum[IDUMPLOT];
} plot;


extern struct win{
      int    ksphandle,hold,whandle[MAXSP],sizex[MAXSP],sizey[MAXSP],
	     posx[MAXSP],posy[MAXSP],plotyp[MAXSP],v_plot[MAXSP][3],
             b_plot[MAXSP][2];
     float   r_plot[MAXSP][8];
      char   wdescript[80],tabcolor[64][24];
} win;

extern struct wptr{
 long int  intptr[MAXSP];
} wptr;

