

#define MAXBUF (MAXSUB+2)

typedef enum Scaling {SC_EXACT,SC_ROUND,SC_OFF,SC_AXIS} Scaling;

typedef struct plotstruct{
   float last_xmin, last_xmax, last_ymin, last_ymax;
   float xxmin,xxmax,yymin,yymax;
   float xmin, xmax, ymin, ymax, rmax;
   float xstart, xstep, ystart, ystep;
   float alpha0, beta0, alpha, beta;
   int errorbars, autoaxis, residue,zoomed;
   int vectplot,zoomv,ixoffset,iyoffset,sx,sy,f1,f2,netl, netr;   
   enum Scaling scaling;   
   int xtics, ytics;
   int selected[MAXBUF];
   char wdescript[80];
   char title[80];
   char xlabel[24], xformat[16];
   char ylabel[24], y2label[24], yformat[16];
}plotstruct;

/*plotstruct *get_plotconfig();*/
