      subroutine frstr_syndoubleSC(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      use comstr, only: ntheory,nstruct,istruct,strcmt,ndev,  &
                        thco,ntrmt,ctrmt,thpa,thvr
      implicit none

      integer,intent(in):: l_nfrtheo,lstruct1,lstruct2
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      character(len=8)  :: chth 
      integer   jc,jv,jm,jp,number_device,id         
                                                                 
      if(cmch.eq.'name') then 
!####################################################                   
       nhelpentry='Synchrotron spectrum of two scatterers' 
       ntheory(1)='Synchrotron source-double scattering' 
       ntheory(2)=' '
       
       ndev(1)='1  (12=GF or FG as selected)' 
       ndev(2)='2  (12=FG or GF as selected)' 
       ndev(3)=' '
!####################################################                   
       return 
      end if 
                                                                        
!      calling by l_nfrtheo=1,2,3,4                                     
!      nameth(1)='Nuclear forward/specular scattering'                  
!      nameth(2)='Nuclear specular/forward scattering'                  
!      nameth(3)='Nuclear forward/Forward scattering'                  
!      nameth(4)='Nuclear Forward/forward scattering' 

!      write(6,'(a,6i3)')'l_nfrtheo,lstruct1,lstruct2,device=',&
!              l_nfrtheo,lstruct1,lstruct2,number_device(lstruct1)+1 
      chth='fr'//nhelpentry(1:6)
      id=number_device(lstruct1)+1 

     if(l_nfrtheo.eq.2) then
      goto(100,300,200)id
     else if(l_nfrtheo.eq.1)then     
      goto(100,200,300)id
     else if(l_nfrtheo.gt.2)then     
      goto(100,200,200)id
     end if
!-----------------------------------------------------------------------
  100 continue 
                                                                        
!      common/acstrf/acsp,wavelength,uthick,uthick_A,                   
!     &              unit_chi,aiT_max,v_max,                            
!     &              ak_extension,T_bunch,dastr,channels,               
!     &              ch_angle,graz_beg,graz_end,t0_norm,                
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=4   chth='//chth 
!      reading wavelength                                               
       return 
      end if 
                                                                        
!     variables: source,absorber and detector orientation               
!      common/cvsptrf/ counts,backgrounddum0,,Pxsi,Peta,Pzeta                
!                      PA0,PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z      
                                                                        
       call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!                    1        0         012345                          
      ntrmt(jm+1)='counts     matrix=(1,1)   include= y  ' 
      ctrmt(jm+1)='frame parameter total counts' 
                                                             ! sum of co
       thpa(jp+1)='counts            , 10000.0  0.0 0.0 10.0' 
       thvr(jv+1)='counts                    1    1   ' 
                                                                        
      ntrmt(jm+2)='background   matrix=(1,1) from_data=[n]' 
      ctrmt(jm+2)='(1) variable background' 
                                                         ! background/ch
       thpa(jp+2)='background        , 0.0 0.0 0.0 1.0' 
       thvr(jv+2)='background                2    1  ' 
                                                                        
      ntrmt(jm+3)='Poincare_beam  matrix=(3,3) from_data=[n]' 
      ctrmt(jm+3)='(3) Poincare vector of the Synchrotron beam' 
       thpa(jp+3)='P_xsi           , -1.0  0.0 1.0  0.05' 
       thpa(jp+4)='P_eta           , 0.0  0.0 0.0   0.05' 
       thpa(jp+5)='P_zeta          , 0.0  0.0 0.0   0.05' 
       thvr(jv+3)='P_xsi                     4    1 0 0 ' 
       thvr(jv+4)='P_eta                     5    0 1 0 ' 
       thvr(jv+5)='P_zeta                    6    0 0 1 ' 
      jm=jm+3 
      jp=jp+5 
      jv=jv+5 
                                                                        
      ntrmt(jm+1)='Poincare_analyser   matrix=(4,4) from_data=[n]' 
      ctrmt(jm+1)='(4) Poincare vector of the analyser ' 
       thpa(jp+1)='PA0             , 1.0  0.0 0.0   0.05' 
       thpa(jp+2)='PAxsi           , 0.0  0.0 0.0   0.05' 
       thpa(jp+3)='PAeta           , 0.0  0.0 0.0   0.05' 
       thpa(jp+4)='PAzeta          , 0.0  0.0 0.0   0.05' 
       thvr(jv+1)='PA0                       7    1 0 0 0 ' 
       thvr(jv+2)='PAxsi                     8    0 1 0 0 ' 
       thvr(jv+3)='PAeta                     9    0 0 1 0 ' 
       thvr(jv+4)='PAzeta                   10    0 0 0 1 ' 
      jm=jm+1 
      jp=jp+4 
      jv=jv+4 
                                                                        
      if(l_nfrtheo.eq.1)strcmt(1)='forward_grazing_scatterer   n_set=[fg]   2  0'
      if(l_nfrtheo.eq.2)strcmt(1)='grazing_forward_scatterer   n_set=[gf]   2  0' 
      if(l_nfrtheo.eq.3)strcmt(1)='Forward_forward_scatterer   n_set=[Ff]   2  0' 
      if(l_nfrtheo.eq.4)strcmt(1)='forward_Forward_scatterer   n_set=[fF]   2  0' 
      strcmt(2)='global name of the spectrum ' 
      strcmt(3)='xxx ' 
      strcmt(4)='theory/'//chth//'/forward_grazing_scatterer/go' 
      strcmt(5)='theory/'//chth//'/grazing_forward_scatterer/layer' 
                                                                        
      call convarmatpar('0110',jc,jv,jm,jp,chth) 
      return 
!-----------------------------------------------------------------------
  200 continue 
!     forward scattering device                                           
      if(cmch.eq.'hdbk') then 
        nstruct=' ' 
       return 
      end if 
      if(lstruct2.gt.0) goto 210 
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/cfr1trf/ inc_frac,Hext,thetaHe,phiHe,phi,theta,psi        
                                                                        
                                                                        
!      if(l_nfrtheo.eq.1) then 
       strcmt(1)='forward_scatterer  n_device=[fs] mijk=co;sw;su [1] 1' 
!                                           cover sandwich substrate    
       strcmt(2)='two letters for the forward scatterer' 
       strcmt(3)='number of layers of the  forward scatterer ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/forward_scatterer/layer' 
!      end if 
                                                                        
      call convarmatpar('__07',jc,jv,jm,jp,chth) 
      return 
!     --------------------------------------------------                
  210 continue 
!     layers of device  common/acfr2trf/    /avfr2trf/                  
!     for common/acfritrf/    /avfritrf/                                
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
!     common/acfr2trf/ repeat_group                                     
!     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,eta_d
                                                                        
       call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='iset_powder     i_pos=2 include=n  0 ' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
       thco(jc+2)='isymmetry       i_pos=3 include=n  10 ' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
       thco(jc+3)='n_psi_powder    i_pos=4 include=n  0 ' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)              
       jc=jc+3 
       ! forward scattering
       ntrmt(jm+1)='Hextern   matrix=(3,3)   include=[n]' 
       ctrmt(jm+1)='external magnetic field (Lab) at the forward scatterer'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0' 
        thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     6    1 0 0  ' 
        thvr(jv+2)='thetaHe                  7    0 1 0 ' 
        thvr(jv+3)='phiHe                    8    0 0 1' 
                                                                        
       ntrmt(jm+2)='orientation    matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the forward scatterer in the LAB' 
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0' 
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+4)='phi                      9    1 0 0' 
        thvr(jv+5)='theta                   10    0 1 0' 
        thvr(jv+6)='psi                     11    0 0 1' 
       jm=jm+2 
       jp=jp+6 
       jv=jv+6 
                                                                 
       strcmt(1)='scatterer_layer  n_cmpt=[s]  [1]  0' 
       strcmt(2)=' one letter for name of the site ' 
       strcmt(3)='number of inequivalent sites of the scatterer layer' 
       strcmt(4)='distribution of parameters of site number' 
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites' 
                                                                        
      call convarmatpar('0411',jc,jv,jm,jp,chth) 
      return 
!-----------------------------------------------------------------------
  300 continue 
!     grazing scattering device                                          
      if(cmch.eq.'hdbk') then 
        nstruct=' ' 
       return 
      end if 
      if(lstruct2.gt.0) goto 310 
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       strcmt(1)='grazing_incidence  n_device=[gs] mijk=co;sw;su [2] 1' 
!                                           cover sandwich substrate    
       strcmt(2)='two letters for the grazing incidence scatterer' 
       strcmt(3)='number of layers of the scatterer ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/grazing_scatterer/layer' 
                                                                        
!      common/cfr1trf/ inc_frac,Hext,thetaHe,phiHe,phi,theta,psi        
                                                                        
!                                                              def/llimi
!      the external field and orientation for the scatterer are defined 
!      on level fr1: one field and orientation for all layers           
!      !! transfer of fr1 values to all layers(fr2) in the loop lstruct2
!         in the scattering theories                                    
       ntrmt(jm+1)='H_extern    matrix=(3,3)   include=[n]' 
       ctrmt(jm+1)='external magnetic field at the scatterer' 
        thpa(jp+1)='Hext            , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe         , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe           , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                    2       1 0 0 ' 
        thvr(jv+2)='thetaHe                 3       0 1 0 ' 
        thvr(jv+3)='phiHe                   4       0 0 1 ' 
                                                                        
                                                                        
       ntrmt(jm+2)='orientation  matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the scatterer in the LAB' 
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0' 
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+4)='phi                     5    1 0 0' 
        thvr(jv+5)='theta                   6    0 1 0' 
        thvr(jv+6)='psi                     7    0 0 1' 
       jm=jm+2 
       jp=jp+6 
       jv=jv+6 
                                                                        
       call convarmatpar('0007',jc,jv,jm,jp,chth) 
      return 
!     --------------------------------------------------                
  310 continue 
!     layers of device  common/acfr2trf/    /avfr2trf/                  
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
!     common/acfr2trf/ repeat_group                                     
!     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,eta_d
!                                                                             
       call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='rep.grp       i_pos=1    include= y     1.1 ' 
           ! layer belongs to a group which repeat with period          
       jc=jc+1 
                                                                        
!                    1        0         01234567                        
       ntrmt(jm+1)='thickn_lay   matrix=(1,1)   include= y ' 
       ctrmt(jm+1)='thickness of the layer' 
        thpa(jp+1)='thicklay        , 100.0  0.0 0.0  0.1' 
        thvr(jv+1)='thicklay                1    , 1  ' 
                                                                        
       ntrmt(jm+2)='chi_electronic  matrix=(2,2)   include= y ' 
       ctrmt(jm+2)='chi_electronic of the layer  ' 
        thpa(jp+2)='r_chilay        , -14.50  0.0 0.0  0.1'  ! iron 
        thpa(jp+3)='i_chilay        ,   0.70  0.0 0.0  0.1' ! iron
        thvr(jv+2)='r_chilay                2    1 0' 
        thvr(jv+3)='i_chilay                3    0 1' 
                                                                        
       ntrmt(jm+3)='roughness     matrix=(1,1)   include=[y]' 
       ctrmt(jm+3)='roughness of the layer  ' 
        thpa(jp+4)='roughness        , 0.0  0.0 0.0  0.1' 
        thvr(jv+4)='roughness               4    1 ' 
       jm=jm+3 
       jp=jp+4 
       jv=jv+4 
                                                                        
                                                                        
       strcmt(1)='scatterer_layer   n_cmpt=[s]  [1]  0' 
       strcmt(2)='one letter for name of the site ' 
       strcmt(3)='number of inequivalent sites of the scatterer layer' 
       strcmt(4)='distribution of parameters of site number' 
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites' 
                                                                        
      call convarmatpar('0111',jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
!    ###################################################################
!                                thstr                                  
                                                                        
                                                                        
      subroutine thstr_syndoubleSC(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory 
      implicit none
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Synchrotron source-double scattering (distribute)' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='Nuclear forward/specular scattering' 
       nameth(2)='Nuclear specular/forward scattering' 
       nameth(3)='Nuclear forward/forward scattering' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Synchrotron source-double scattering' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=3 
      end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_synFGscattering(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,istruct,ndev,     &
                        thco,thpa,thvr,ntrmt,ctrmt
      implicit none

!     scattering forward -scpecular grazing incidence                   
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth 
      integer   jc,jv,jm,jp
      
      ndev(1)='forward scatterer' 
      ndev(2)='grazing incidence scatterer' 
      ndev(3)=' '
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Nuclear forward/specular scattering (distribute)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='Nuclear double FG scattering' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear forward/specular scattering' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=1,2   chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/acstrf/ acsp,wavelength,uthick,uthick_A,                  
!     &               unit_chi,                                        1
!     &               aiT_max,v_max,ak_extension,                      4
!     &               T_bunch,dastr,                                   6
!     &               channels,ch_angle,graz_beg,graz_end,            10
!     &               t0_norm,flag_basis                              12
                                                                        
       thco(jc+1)='i_T_max          i_pos=2 include= y    0 ' 
                ! Time window for display                               
       thco(jc+2)='v_max[mm/s]     i_pos=3 include= y    8 ' 
                ! v_max of the nuclear energies                         
       thco(jc+3)='k_extension_2**k i_pos=4  include= y   0 ' 
                ! times v_max                                           
       jc=jc+3 
       thco(jc+1)='T0_NormInt       i_pos=11 include= y   10' 
                 ! integration for normalizing from t0                  
       thco(jc+2)='T_bunch          i_pos=5  from_data=[y] 160' 
                 ! bunch distance in ns                                 
       thco(jc+3)='nu_channels      i_pos=7  from_data=y 256' 
                ! number of channels for for angles                     
       thco(jc+4)='dastr            i_pos=6  from_data=[y] 1' 
                ! determines function for channel to time conversion    
       thco(jc+5)='unit_chi         i_pos=1   include= y   1.0e-6 ' 
               ! susceptibility multiplied by                           
                                                                        
       thco(jc+6)='flag_basis       i_pos=12  include= y   1 ' 
                 ! switch for circular-linear basis                     
       jc=jc+6 
                                                                        
!      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,               
!                      t_shif                                           
       ntrmt(jm+1)='calibration    matrix=(1,1) from_data=[y]' 
       ctrmt(jm+1)='frame parameter t_shift' 
        thpa(jp+1)='t_shift           , 0.0 0.0 0.0 0.1' 
        thvr(jv+1)='t_shift                  1     1  ' 
                                                                        
       ntrmt(jm+2)='orientation    matrix=(2,2) from_data=[y]' 
       ctrmt(jm+2)='(2) grazing angles of the scatterer' 
        thpa(jp+2)='graz_angle        , 5.0 0.0 0.0   1.0' 
        thpa(jp+3)='phi_z             , 0.0  0.0 0.0  1.0' 
        thvr(jv+2)='graz_angle                2    1 0 ' 
        thvr(jv+3)='phi_z                     3    0 1 ' 
       jm=jm+2 
       jp=jp+3 
       jv=jv+3 
                                                                        
      ntrmt(jm+1)='placeholders    matrix=(2,2) from_data= y' 
      ctrmt(jm+2)='(2) variables detekt_eff,counts_bunch' 
       thpa(jp+1)='detekt_eff             , 0.9 0.0 0.0 0.1' 
       thpa(jp+2)='counts_bunch           , 1.0 0.0 0.0 0.1' 
       thvr(jv+1)='detekt_eff                4     1 0 ' 
       thvr(jv+2)='counts_bunch              5     0 1 ' 
      jm=jm+1 
      jp=jp+2 
      jv=jv+2 
                                                                        
      call convarmatpar('1405',jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_synGFscattering(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,istruct,ndev,   &
                        thco,thpa,thvr,ntrmt,ctrmt
      implicit none
!     scattering: scpecular grazing incidence-forward                   

      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth 
      integer   jc,jv,jm,jp
      
      ndev(2)='forward scatterer' 
      ndev(1)='grazing incidence scatterer' 
      ndev(3)=' '

      if(cmch.eq.'name')then 
       nhelpentry='Nuclear specular/forward scattering (distribute)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='Nuclear double GF scattering' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear specular/forward scattering' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=1,2   chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/acstrf/ acsp,wavelength,uthick,uthick_A,                  
!     &               unit_chi,                                        1
!     &               aiT_max,v_max,ak_extension,                      4
!     &               T_bunch,dastr,                                   6
!     &               channels,ch_angle,graz_beg,graz_end,            10
!     &               t0_norm,flag_basis                              12
                                                                        
       thco(jc+1)='i_T_max          i_pos=2 include= y    0 ' 
                ! Time window for display                               
       thco(jc+2)='v_max[mm/s]     i_pos=3 include= y    8 ' 
                ! v_max of the nuclear energies                         
       thco(jc+3)='k_extension_2**k i_pos=4  include= y   0 ' 
                ! times v_max                                           
       jc=jc+3 
       thco(jc+1)='T0_NormInt       i_pos=11 include= y   10' 
                 ! integration for normalizing from t0                  
       thco(jc+2)='T_bunch          i_pos=5  from_data=[y] 160' 
                 ! bunch distance in ns                                 
       thco(jc+3)='nu_channels      i_pos=7  from_data=y 256' 
                ! number of channels for for angles                     
       thco(jc+4)='dastr            i_pos=6  from_data=[y] 1' 
                ! determines function for channel to time conversion    
       thco(jc+5)='unit_chi         i_pos=1   include= y   1.0e-6 ' 
               ! susceptibility multiplied by                           
                                                                        
       thco(jc+6)='flag_basis       i_pos=12  include= y   1 ' 
                 ! switch for circular-linear basis                     
       jc=jc+6 
                                                                        
!      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,               
!                      t_shif                                           
       ntrmt(jm+1)='calibration    matrix=(1,1) from_data=[y]' 
       ctrmt(jm+1)='(1) variable t_shift' 
        thpa(jp+1)='t_shift           , 0.0 0.0 0.0 0.1' 
        thvr(jv+1)='t_shift                  1     1  ' 
                                                                        
       ntrmt(jm+2)='orientation    matrix=(2,2) from_data=[y]' 
       ctrmt(jm+2)='(2) grazing angles of the scatterer' 
        thpa(jp+2)='graz_angle        , 5.0 0.0 0.0   1.0' 
        thpa(jp+3)='phi_z             , 0.0  0.0 0.0  1.0' 
        thvr(jv+2)='graz_angle                2    1 0 ' 
        thvr(jv+3)='phi_z                     3    0 1 ' 
       jm=jm+2 
       jp=jp+3 
       jv=jv+3 
                                                                        
      ntrmt(jm+1)='placeholders    matrix=(2,2) from_data= y' 
      ctrmt(jm+2)='(2) variables detekt_eff,counts_bunch' 
       thpa(jp+1)='detekt_eff             , 0.9 0.0 0.0 0.1' 
       thpa(jp+2)='counts_bunch           , 1.0 0.0 0.0 0.1' 
       thvr(jv+1)='detekt_eff                4     1 0 ' 
       thvr(jv+2)='counts_bunch              5     0 1 ' 
      jm=jm+1 
      jp=jp+2 
      jv=jv+2 
                                                                        
      call convarmatpar('1405',jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           


      subroutine thstr_synFFscattering(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,istruct,ndev,   &
                        thco,thpa,thvr,ntrmt,ctrmt
      implicit none
!     scattering: forward-forward                   

      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth 
      integer   jc,jv,jm,jp
      
      ndev(1)='forward scatterer' 
      ndev(2)='forward scatterer' 
      ndev(3)=' '
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Nuclear forward/forward scattering (distribute)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='Nuclear double Ff scattering'
       nameth(2)='Nuclear double fF scattering'
      return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear forward/forward scattering' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=2
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=1,2   chth='//chth 
       return 
      end if 
                                                                   

      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/acstrf/ acsp,wavelength,uthick,                           
!     &               unit_chi,                                        1
!     &               aiT_max,v_max,ak_extension,                      4
!     &               T_bunch,dastr,                                   6
!     &               channels,ch_angle,graz_beg,graz_end,            10
!     &               t0_norm,flag_basis                              12
                                                                        
       thco(jc+1)='i_T_max          i_pos=2 include=y   0 ' 
                ! Time window for display                               
       thco(jc+2)='v_max[mm/s]     i_pos=3 include=y   8 ' 
                ! v_max of the nuclear energies                         
       thco(jc+3)='k_extension_2**k i_pos=4 include=y   0 ' 
                ! times v_max                                           
       jc=jc+3 
       thco(jc+1)='T0_NormInt       i_pos=11 include=y  10' 
                 ! integration for normalizing from t0                  
       thco(jc+2)='T_bunch          i_pos=5 from_data=[y] 160' 
                 ! bunch distance in ns                                 
       thco(jc+3)='nu_channels      i_pos=7  from_data=y 256' 
                ! number of channels for for angles                     
       thco(jc+4)='dastr            i_pos=6  from_data=[y] 1' 
                ! determines function for channel to time conversion    
       thco(jc+5)='flag_basis       i_pos=12  include=y   1 ' 
                 ! switch for circular-linear basis                     
       jc=jc+5 
                                                                        
!      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,               
!                      t_shif                                           
                                                                        
        ntrmt(jm+1)='calibration    matrix=(1,1) from_data=[y]' 
        ctrmt(jm+1)='(1) variable t_shift' 
         thpa(jp+1)='t_shift           , 0.0 0.0 0.0 0.1' 
         thvr(jv+1)='t_shift                 1     1  ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1 
                                                                        
      call convarmatpar('1405',jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
