    subroutine analysestr(nfrtheo,l_theo,idev,b_tofile,info) 
    use glbconst, only: nwr
    use comstr,   only: ntheory
    implicit none 
                                                               
    integer   nfrtheo,l_theo,idev,nwra,info 
    logical   b_tofile 
    character(len=132):: property,nametheory,dstring
    character(len=80) :: font
    character(len= 8) :: chform(2)
    character(len= 6) :: chnorm,chbold
    character(len= 4) :: cmch,SPI 
    character(len= 1) :: cj
                         
    integer   ia,ka,ja,i0,l,id,il,n,nj,lstruct1,lstruct2,lnfrtheo,i1
                                                                      
    chbold=char(27)//'[1m' 
    chnorm=char(27)//'[0m' 
    nwra=nwr 
                                                                      
    if(nfrtheo.eq.-1) then 
      call input_analyse(ia,ka,ja,b_tofile,info) 
                                                                      
      nfrtheo=ia 
      l_theo=ka 
      idev=ja 
    end if 
!   write(6,'(a,3i4)')'nfrtheo,l_theo,idev=',nfrtheo,l_theo,idev              
                                                                      
    if(b_tofile) then 
     nwra=11 
                                                                      
     open (unit=nwra,file='routine_tree.ps'                           &
                        ,status='unknown'                             &
                        ,access='sequential'                          &
                        ,form='formatted')                            
     write(nwra,'(17(a,/))')                                          &
     '%!PS',                                                          &
     '%%BoundingBox: 1  1  590 840',                                  &
     '/cm {72.00 mul 2.54 div} def',                                  &
     '/SP',                                                           &
     '{',                                                             &
     '    /Blue exch def',                                            &
     '    /Green exch def',                                           &
     '    /Red  exch def',                                            &
     ' Red Green Blue  setrgbcolor',                                  &
     '} def',                                                         &
     '/SP0{0.03 cm setlinewidth 0.0 0.0 0.0 setrgbcolor }def %black', &
     '/SP1{0.03 cm setlinewidth 1.0 1.0 1.0 setrgbcolor }def %white', &
     '/SP2{0.03 cm setlinewidth 1.0 0.0 0.0 setrgbcolor }def %red',   &
     '/SP3{0.03 cm setlinewidth 0.0 1.0 0.0 setrgbcolor }def %green', &
     '/SP4{0.03 cm setlinewidth 0.0 0.0 1.0 setrgbcolor }def %blue',  &
     '/SP5{0.03 cm setlinewidth 0.0 0.6 0.6 setrgbcolor }def %yellow',&
     '/Times-Roman  findfont 14 scalefont setfont',                   &
     'newpath 0 820 moveto'                                           
!     if(nfrtheo.gt.0.and.idev.gt.0)                                  
!   &      write(nwra,'(3(a,i2))') 'frame theory ',nfrtheo,           
!   &   '  option number',l_theo,' device number',idev                
                                                                       
     end if 
      dstring=' '
      i0=ichar('0') 
      cj='1' 
      il=0 
      cmch='name' 
      if(nfrtheo.eq.0) then 
       nj=1 
       do while(nfrtheo.lt.nj) 
        nfrtheo=nfrtheo+1 
        n=nfrtheo 
        lnfrtheo=1 
        call getfrstring(n,lnfrtheo,lstruct1,lstruct2,cmch,property)
        nj=n 
!        write(6,'(a)')property(:80)                                    
        lnfrtheo=1 
        n=nfrtheo 
        call getfrstring(n,lnfrtheo,lstruct1,lstruct2,cmch,property)
         chform(1)='( 2x,a)' 
         chform(2)='( 4x,a)' 
         nametheory=ntheory(1)
         l=LEN_TRIM(nametheory) 
         if(b_tofile)then 
          font='/Times-Bold  findfont 16 scalefont setfont' 
          SPI='SP0 ' 
          call wlineps(nwra,chform(1),nametheory,SPI,font) 
         else 
          write(nwr,chform(1))chbold//TRIM(nametheory)//chnorm 
         end if 
         il=il+1 
         id=1 
         call getfurther(nwra,chform,id,il,nametheory,0,l_theo,cj) 
         if(.not.b_tofile)write(nwr,'(a)') 
        if(b_tofile)call wlineps(nwra,chform(1),dstring,SPI,font) 
!        if(b_tofile)call wlineps(nwra,chform(1),dstring,SPI,font) 
       end do 
      else 
       n=nfrtheo 
       lnfrtheo=1 
       call getfrstring(n,lnfrtheo,lstruct1,lstruct2,cmch,property)
       if(lnfrtheo.eq.0) then 
        write(nwr,'(a,i2,a,/,a)')' global theory with number ',nfrtheo, &
        ' does not exist',                                              &
       ' see for numbers subroutine getfrstring() in frth_distribute.f' 
        return 
       end if 
                                                                        
       if(idev.gt.3)then 
        write(nwr,'(a)')' EFFI provides 3 devices, device number set to 3'
        idev=3 
       else if(idev.eq.0)then 
        write(nwr,'(a)')' no device selected, device number set to 1' 
        idev=1 
       end if 
       cj=char(i0+idev) 
                                                                        
        i1=1 
        chform(1)='( 2x,a)' 
        chform(2)='( 4x,a)' 
        nametheory=ntheory(1) 
        l=LEN_TRIM(nametheory)                                                                
         if(b_tofile)then 
          write(nwra,'(a)')'newpath 0 830 moveto'                      
          font='/Times-Bold  findfont 14 scalefont setfont' 
          SPI='SP0 ' 
          call wlineps(nwra,chform(1),nametheory,SPI,font) 
         else 
          write(nwr,chform(1))chbold//TRIM(nametheory)//chnorm 
         end if 
!        il=il+1                                                        
        id=1 
        call getfurther(nwra,chform,id,il,nametheory,i1,l_theo,cj) 
      end if 
      if(b_tofile)then 
       write(nwra,'(a)')'showpage' 
       close(unit=nwra) 
       call ps2pdfroutinetree 
      end if 
      return 
      END                                           
                                                                        
      subroutine getfurther(nwra,chform,id,il,nametheory,i1,l_theo,cj) 
      use glbconst, only: nwr
      use comstr,   only: nameth_as, ndev,ndevice,nameth
      implicit none 
                                                                        
      character(len=132):: property,nametheory,device
      character(len=80) :: font,namethid(8,8),nameth_asid(8)
      character(len= 8) :: ch8,chform(2),chf(2)
      character(len= 6) :: chblue,chnorm,chcol
      character(len= 4) :: cmch,SPI 
      character(len= 1) :: cj

      integer   i,i0,ith,j,jth,id,il,nj,ll,ld,lnn,ljth,       &
                nwra,l_jth,i1,l_theo,imore,ntrimto0 
      logical   b_write,b_tofile 
                                                                        
      ndevice=ndev
      imore=0 
      if(l_theo.eq.0) then 
       il=0 
       imore=1 
      end if 
      b_tofile=nwr.ne.nwra 
      b_write=.true. 
      chblue=char(27)//'[34m' 
      chnorm=char(27)//'[0m' 
      chcol=char(27)//'[43m' 
                                                                        
      i0=ichar('0') 
      chf(1)=chform(1) 
      chf(2)=chform(2) 
      nameth_asid(id)=nametheory 
                                                                        
      do j=1,2 
       ch8=chf(j)(2:3) 
       call c8toi(ch8,i) 
       i=i+2 
       call itoc8(ch8,i) 
       if(i.le.9) then 
        chf(j)(2:3)=ch8(1:2) 
       else 
        chf(j)(2:3)=ch8(2:3) 
       end if 
      end do 
                                                                        
                                                                        
      lnn=ntrimto0(nametheory) 
      if(nametheory(lnn-1:lnn-1).eq.'_') lnn=lnn-2 
                                                                        
       nj=1 
       jth=0 
       do while(jth.lt.nj) 
        jth=jth+1 
        ith=jth 
        cmch='theo' 
        nameth_as=nameth_asid(id)(:lnn) 
        l_jth=0 
        call getthstring(ith,l_jth,cmch,property) 
                                                                        
        nj=ith 
!        write(6,'(2i4,2x,a)')jth,l_jth                                 
!         read(5,'(a)')                                                 
        if(l_jth.gt.0) then 
!         write(6,'(i3,2a)')id,'  nameth_as=',nameth_as(:60)            
!         write(6,'(2i4,2x,a)')jth,l_jth                                
         ith=jth 
         ljth=1 
         cmch='name' 
         call getthstring(ith,ljth,cmch,property) 
                                                                        
          device='device:'//ndevice(ichar(cj)-i0)
          ld=80 
          do while(device(ld:ld).eq.' ') 
           ld=ld-1 
          end do 
                                                                        
!         write(6,'(2i4,2x,a)')jth,l_jth,property(:70)                  
         chform(1)=chf(1) 
!         write(6,chform(1))property(:70)                               
         do i=1,l_jth 
          namethid(i,id)=nameth(i) 
         end do 
                                                                        
         if(b_tofile)then 
          write(nwra,'(a)')'currentpoint -14 add 0 exch moveto' 
          il=il+1 
         else 
          write(nwr,'(a)') 
         end if 
                                                                        
                                                                        
         do i=1,l_jth 
          if(imore.eq.0)il=0 
          chform(2)=chf(2) 
!          chfo='(i3,'//chform(2)(2:8)                                  
          property=namethid(i,id) 
          ll=ntrimto0(property) 
          if(property(ll-1:ll-1).eq.'_') ll=ll-2 
          il=il+1 
          if(l_theo.gt.0)b_write=i.eq.l_theo 
          if(b_write)then 
           if(b_tofile)then 
            font='/Times-Bold  findfont 14 scalefont setfont' 
            SPI='SP5 ' 
            call wlineps(nwra,chform(2),property,SPI,font) 
           else 
            write(nwr,chform(2))chcol//property(:ll)//chnorm 
           end if 
           if(i1.eq.1)then 
            if(b_tofile)then 
             font='/Times-Roman  findfont 12 scalefont setfont' 
             SPI='SP0 ' 
             call wlineps(nwra,chform(2),device,SPI,font) 
            else 
             write(nwr,chform(2))device(:ld) 
            end if 
           end if 
          end if 
          if(i1.eq.1)                                                   &
           call getfurther1(nwra,chform,id,il,property,b_write,cj)      
         end do 
        end if 
       end do 
                                                                        
      return 
      END                                           
                                                                        
      subroutine getfurther1(nwra,chform,id,il,nametheory,b_write,cj) 
      use glbconst, only: nwr
      use comstr,   only: nameth_as,nameth
      implicit none 
      character(len=132):: property,nametheory
      character(len=80) :: font,namethid(8,8),nameth_asid(8)
      character(len= 8) :: ch8,chform(2),chf(2,8)
      character(len= 6) :: chnorm,chbold,chcol 
      character(len= 4) :: cmch,SPI
      character(len= 3) :: ch(0:3)
      character(len= 1) :: cj
                               
      integer   i,ii,ith,j,jth,id,il,nj,l,lnn,ljth,l_jth,nwra,ntrimto0
      logical   b_write,b_tofile 
                                                                        
      chbold=char(27)//'[1m' 
      chnorm=char(27)//'[0m' 
      chcol=char(27)//'[43m' 
                                                                        
      b_tofile=nwr.ne.nwra 
      chf(1,id)=chform(1) 
      chf(2,id)=chform(2) 
      nameth_asid(id)=nametheory 
      do j=1,2 
       ch8=chf(j,id)(2:3) 
       call c8toi(ch8,i) 
       i=i+2 
       call itoc8(ch8,i) 
       if(i.le.9) then 
        chf(j,id)(2:3)=ch8(1:2) 
       else 
        chf(j,id)(2:3)=ch8(2:3) 
       end if 
!       write(6,'(i3,a,2a10)')id,'=id 1            chform=',chform      
      end do 
                                                                        
      ch(0)='_0' 
      ch(1)='_1'//cj 
      ch(2)='_2'//cj 
      ch(3)='_3'//cj 
      lnn=ntrimto0(nametheory) 
      if(nametheory(lnn-1:lnn-1).eq.'_') lnn=lnn-2 
      do ii=-1,3 
                                                                        
       nj=1 
       jth=0 
       do while(jth.lt.nj) 
        jth=jth+1 
        ith=jth 
        cmch='theo' 
        if(ii.eq.-1) then 
         nameth_as=nameth_asid(id)(:lnn) 
        else 
         nameth_as=nameth_asid(id)(:lnn)//ch(ii) 
        end if 
        l_jth=0 
         property=' ' 
        call getthstring(ith,l_jth,cmch,property) 
        nj=ith 
                                                                        
!        if(ii.eq.3) then                                               
!         write(6,'(2i3,2a)')jth,l_jth,' 1  nameth_as=',nameth_as(:ln)  
!         read(5,'(a)')                                                 
!        end if                                                         
                                                                        
        if(l_jth.gt.0) then 
!         write(6,'(i3,2a)')id,'   1  nameth_as=',nameth_as(:60)        
!         write(6,'(2i4,2x,a)')jth,l_jth,property(:70)                  
!         read(5,'(a)')                                                 
         ith=jth 
         ljth=1 
         cmch='name' 
         property=' ' 
         call getthstring(ith,ljth,cmch,property) 
                                                                        
         chform(1)=chf(1,id) 
!         chfo='(i2,'//chform(1)(2:8)                                   
!         write(nwra,chfo)id,' '//TRIM(property)                          
         do i=1,l_jth 
          namethid(i,id)=nameth(i) 
         end do 
         do i=1,l_jth 
          chform(2)=chf(2,id) 
!          chfo='(i3,'//chform(2)(2:8)                                  
          property=namethid(i,id)
          l=ntrimto0(property) 
          il=il+1 
          if(b_write) then 
           if(b_tofile)then 
            if(id.gt.1)then 
             font='/Times-Italic  findfont 14 scalefont setfont' 
            else 
             font='/Times-Roman  findfont 14 scalefont setfont' 
            end if 
           if(id.eq.1)SPI='SP2 ' 
            if(id.eq.2)SPI='SP4 ' 
            if(id.gt.2)SPI='SP0 ' 
            call wlineps(nwra,chform(2),property,SPI,font) 
           else 
            if(id.eq.1)chcol= char(27)//'[31m' 
            if(id.eq.2)chcol= char(27)//'[34m' 
            if(id.gt.2)chcol= char(27)//'[0m' 
            write(nwr,chform(2))chcol//property(:l)//chnorm 
           end if 
          end if 
                                                                        
          call xx(nwra,chform,id,property,il,b_write,cj) 
         end do 
         if(b_write) then 
          if(il.gt.54) then 
           il=0 
           if(b_tofile)write(nwra,'(a)')'showpage' 
           if(b_tofile)write(nwra,'(a)')'newpath 0 830 moveto' 
          end if 
          if(b_tofile)then 
           write(nwra,'(a)')'currentpoint -14 add 0 exch moveto' 
           il=il+1 
          else 
           write(nwr,'(a)') 
          end if 
         end if 
        end if 
       end do 
      end do 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine xx(nwra,chform,id,name,il,b_write,cj) 
      implicit none 

      character(len=132):: name
      character(len=8), dimension(2)  :: chform 
      character(len=8)  :: ch8 
      character(len=1)  :: cj

      integer   i,j,id,il,nwra 
      logical   b_write 
      do j=1,2 
       ch8=chform(j)(2:3) 
       call c8toi(ch8,i) 
       i=i+2 
       call itoc8(ch8,i) 
       if(i.le.9) then 
        chform(j)(2:3)=ch8(1:2) 
       else 
        chform(j)(2:3)=ch8(2:3) 
       end if 
      end do 
      id=id+1 
      call getfurther1(nwra,chform,id,il,name,b_write,cj) 
      id=id-1 
!      write(6,'(a,i4)')' il=',il                                       
      return 
      END                                           
                                                                        
      subroutine wlineps(nwra,chform,string,SPI,font) 
      implicit none 
      character(len=132):: ch132,string
      character(len=80) :: font
      character(len=8)  :: chform 
      character(len=8)  :: ch8 
      character(len=4)  :: SPI
      integer nwra,i 

!     call checkentry(string)
      write(nwra,'(a)')font 
      write(nwra,'(a)')SPI 
      write(nwra,'(a)')'currentpoint -14 add 0 exch moveto' 
      ch8=chform(2:3) 
      call c8toi(ch8,i) 
      i=i*3/2 
      ch132='(' 
      ch132(i+2:)=trim(string)//') show' 
      write(nwra,'(a)')ch132 
      return 
      END                                           
                                                                        
      subroutine input_analyse(ia,ka,ja,b_tofile,info) 
      use glbconst, only: infotext,nrd,nwr
      use comstr,   only: nameth_as,ntheory,nameth,istruct,ndev,ndevice
      use comscd,   only: helpar,queryar
      use comeff,   only: npl
      implicit none 
      integer, intent(out):: ia,ka,ja,info                                                                      
      logical, intent(out):: b_tofile 

      character(len=132):: chin,chcom
      character(len=80) :: chdf
      character(len=8)  :: chth 
      character(len=4)  :: cmch
      character(len=1)  :: ch1

      integer i0,i10,i1,n,nj,lq,lk,lnn,ith,jth,           &
              n_device,lnfrtheo,lstruct1,lstruct2,nfrtheo,ntrimto0              

                                                                        
       i0=ichar('0') 
       cmch='name' 
       nj=1 
       nfrtheo=0 
       do while(nfrtheo.lt.nj) 
        nfrtheo=nfrtheo+1 
        n=nfrtheo 
        i10=n/10 
        i1=n-i10*10 
        chth='fr'//char(i10+i0)//char(i1+i0) //'00  ' 
        lnfrtheo=1 
        call getfrstring(n,lnfrtheo,lstruct1,lstruct2,cmch,chin) 
        nj=n 
        helpar(nfrtheo)='theory/'//chth//'/'//ntheory(1) 
        queryar(nfrtheo)=ntheory(1) 
       end do 
                                                                        
                                                                        
       lq=nj 
       lk=lq 
       chdf='e' 
       chdf(80:80)='#' 
       chin='select a type of experiment' 
       call query(lq,lk,chin,chdf) 
       if(lq.eq.0)goto 100 
       ia=lq 
                                                                        
       lnfrtheo=1 
       call getfrstring(lq,lnfrtheo,lstruct1,lstruct2,cmch,chin) 
       chin=ntheory(1) 
       ndevice=ndev
       n_device=1
       if(ndev(2).ne.' ')n_device=2
       if(ndev(3).ne.' ')n_device=3

       lnn=ntrimto0(chin) 
       if(chin(lnn-1:lnn-1).eq.'_') lnn=lnn-2 
       nameth_as=chin(:lnn) 
                                                                        
       nj=1 
       jth=0 
       do while(jth.lt.nj) 
         cmch='theo' 
         jth=jth+1 
         ith=jth 
         lq=0 
         i10=ith/10 
         i1=ith-i10*10 
         chth='th'//char(i10+i0)//char(i1+i0) //'00  ' 
         call getthstring(ith,lq,cmch,chin) 
                                                                        
         nj=ith 
         if(lq.gt.0) then 
          ith=jth 
          lk=1 
          cmch='name' 
          call getthstring(ith,lk,cmch,chin) 
          do n=1,lq 
!           write(6,'(i2,a)') n,nameth(n)                               
           helpar(n)='theory/'//chth//'/'//nameth(n) 
           queryar(n)=nameth(n) 
          end do 
          lk=lq 
          chdf='e' 
          chdf(80:80)='#' 
          chin='select experiment' 
          call query(lq,lk,chin,chdf) 
          ka=lq 
         end if 
       end do 
                                                                        
       do n=1,n_device 
        helpar(n)='effi/device/number' 
        queryar(n)=ndevice(n) 
       end do 
       lk=n_device 
       lq=lk 
       chdf='e' 
       chdf(80:80)='#' 
       chin='select device' 
       call query(lq,lk,chin,chdf) 
       ja=lq 
                                                                        
       b_tofile=.false. 
       ch1='n' 
       chcom='effi/routine_tree' 
       chin='write theory tree to file routine_tree.pdf' 
       call yesno(chin,ch1,chcom,npl,nrd,nwr) 
       if(ch1.eq.'y')b_tofile=.true. 
                                                                        
       goto 101 
  100  continue 
       info=1 
       infotext(1)='effi/query' 
       infotext(2)='no substring selected or exited with (q/*)' 
       infotext(3)=' ' 
                                                                        
  101  return 
      END                                           


  subroutine checkentry(string)
  implicit none
  character(len=132), intent(in):: string

  character(len=132)::path,ch132
  character(len=132),dimension(5000)::line
  character(len=48),dimension(24):: hfile
    integer if,i,j,k,kk,ll,lj


   path='/home/spiering/EFFI530/EFFI/helpfiles/'
   hfile(1 )='effi.help'
   hfile(2 )='euler.help'
   hfile(3 )='handbook_nucleus.help'
   hfile(4 )='messages.help'
   hfile(5 )='Mossbauer_geometry.help'
   hfile(6 )='Mossbauer_relaxation.help'
   hfile(7 )='Mossbauer_spectrum.help'
   hfile(8 )='Mossbauer_stroboscopy.help'
   hfile(9 )='Neutron_spectrum.help'
   hfile(10)='Octahedral_tr.help'
   hfile(11)='rectangular_time_windows.help'
   hfile(12)='refraction_index.help'
   hfile(13)='sample_orientation.help'
   hfile(14)='spin_Hamiltonian.help'
   hfile(15)='synchrotron_doubleSC.help'
   hfile(16)='Synchrotron_offspecular.help'
   hfile(17)='Synchrotron_source-double_scattering.help'
   hfile(18)='Synchrotron_source.help'
   hfile(19)='Synchrotron_spectrum.help'
   hfile(20)='Synchrotron_spectrum_of_two_scatterers.help'
   hfile(21)='theory_nucleus.help'


   ch132='/'//TRIM(string)
   ll=LEN_TRIM(ch132)
!write(6,'(2a)')' entry:',TRIM(ch132)
kk=0
  if(ll.gt.2) then
   do if=1,21
    open(unit=3,file=TRIM(path)//hfile(if)                                  &
                ,status='old'                                   &
                ,access='sequential'                            &
                ,form='formatted')


      do i=1,5000
       read(3,'(a)',end=50)line(i)
      end do

  50  continue
      do j=1,i
        k=index(line(j),TRIM(ch132))
       if(k.gt.0)then
       lj=LEN_TRIM(line(j))
       if(ll.eq.lj) then
!         write(6,'(a,2x,a)')TRIM(line(j)),TRIM(hfile(if))
         kk=kk+1
       end if
       end if
      end do
    close(unit=3)

   end do !if
   if(kk.eq.0) print'(2a)',' no file found for ',TRIM(ch132)
  end if
    return

    end

