      subroutine arrayman(ks,iadd,b_const,info) 
      use glbconst, only: maxs,enwr,iwritear
      use comths,   only: nstorSP
      use comeff,   only: jblock,nseqsto,intblock,iblockpt,mblock,nblock
      use comthe,   only: array_fr,iarray_sp,marray_sp,nstorFR
      implicit none
      
      integer, intent(in) :: ks,iadd
      logical, intent(in) :: b_const
      integer, intent(out):: info

      integer   iseqsto,narraysp  
      dimension iseqsto(maxs),narraysp(0:maxs) 
      integer i,it,i2,iarraysp,iblock,iend,j,ji,jmax,jp,k, kk,m,      &
              mpartition,npartition,nstorSP2 
      complex, dimension(:), allocatable :: transfer  
                                                                 
!      write(6,'(i4,i8,a,10(i2,1x,i2,2x))')ks,nstorSP,' arrayman ksk,iblock=',  &      
!                                   (j,jblock(j),j=1,6) 
      info=0              
      nstorSP2=nstorSP+2 
      narraysp(0)=0 
      iblock=jblock(ks) 
      j=iblockpt(nblock) 
      mpartition=intblock(j) 
!      write(6,'(a,3i4)') '****nblock,iblock,mpartition=', &             
!                              nblock,iblock,mpartition                 
      do k=1,mpartition 
       ji=j+k 
       iseqsto(k)=intblock(ji) 
       narraysp(k)=intblock(ji+mpartition) 
      end do 
!      write(6,'(a,2i8)')'arrayman ks,nstorSP2(=0?)=',ks,nstorSP2       
!       write(6,'(a,8i14)')'narraysp=',(narraysp(k),k=1,mpartition)
                              ! ks has no block def yet                 
      if(iblock.eq.0) then 
       if(mpartition.eq.0) then 
!       write(6,'(a)') 'arrayman iblock.eq.0,mpartition.eq.0'           
        jblock(ks)=nblock 
        mpartition=1 
        nseqsto(ks)=mpartition 
        narraysp(1)=nstorSP2 
        iseqsto(1)=ks 
        iarraysp=0 
        iarray_sp=iarraysp+2 
        intblock(1)=1 
        intblock(2)=iseqsto(1) 
        intblock(3)=narraysp(1) 
       else 
!       write(6,'(a,i2)')'arrayman iblock.eq.0,mpartition=',mpartition  
!       write(6,'(a,i8)')'narraysp(mpartition)=',narraysp(mpartition)
!--------------                                                         
!        neuen block holen                                              
         j=0 
         k=1 
         do while(j.eq.0.and.k.le.mblock) 
          m=intblock(iblockpt(k)) 
          m=intblock(iblockpt(k)+2*m) 
!         write(6,'(i3,a,5i8)')k,' arrayman narraysp(m)+nstorSP2=',&
!         intblock(iblockpt(k)),m,nstorSP2  
          if(m+nstorSP2.lt.marray_sp) j=k 
          k=k+1 
         end do 
!        write(6,'(a,2i4)')'arrayman j.eq.0.and.k.le.mblock-k,j=',k,j   
         if(j.eq.0) then 
          call writear(nblock)
          iwritear=iwritear+1 
          nblock=mblock+1 
!         neuen block anlegen                                           
!         write(6,'(a)')'arrayman neuen block anlegen'                  
!         write(6,'(a,12i3)') 'iblockpt(1..12)=',(iblockpt(i),i=1,12)   
          jp=iblockpt(mblock)+2*intblock(iblockpt(mblock))+1 
          mblock=nblock 
          iblockpt(nblock)=jp 
          jblock(ks)=nblock 
          mpartition=1 
          nseqsto(ks)=mpartition 
          narraysp(1)=nstorSP2 
          iseqsto(1)=ks 
          iarraysp=0 
          iarray_sp=iarraysp+2 
          intblock(jp)=1 
          intblock(jp+1)=iseqsto(1) 
          intblock(jp+2)=narraysp(1) 
         else 
          if(j.ne.nblock) then 

!          write(6,'(a,2i4)') 'j.ne.nblock:',j,nblock                  
           call writear(nblock) 
           iwritear=iwritear+1 
           nblock=j 
           call readar(nblock) 
           j=iblockpt(nblock) 
           mpartition=intblock(j) 
           do k=1,mpartition 
            ji=j+k 
            iseqsto(k)=intblock(ji) 
            narraysp(k)=intblock(ji+mpartition) 
           end do 
          else 
           j=iblockpt(nblock) 
           mpartition=intblock(j) 
          end if 
!         aktuellen block erweitern (anhaengen)                         
!         write(6,'(a)')'arrayman aktuellen block erweitern(anhaengen)' 
          jblock(ks)=nblock 
          mpartition=mpartition+1 
          nseqsto(ks)=mpartition 
          narraysp(mpartition)=narraysp(mpartition-1)+nstorSP2 
          iseqsto(mpartition)=ks 
          iarraysp=narraysp(mpartition-1) 
          iarray_sp=iarraysp+2 
          intblock(j)=mpartition 
          ji=j+2*(mpartition-1)+1 
          jmax=iblockpt(mblock)+2*intblock(iblockpt(mblock)) 
          do k=jmax,ji,-1 
           intblock(k+2)=intblock(k) 
          end do 
          do k=nblock+1,mblock 
           iblockpt(k)=iblockpt(k)+2 
          end do 
          do k=1,mpartition 
           ji=j+k 
           intblock(ji)=iseqsto(k) 
           intblock(ji+mpartition)=narraysp(k) 
          end do 
!         write(6,'(a,i2)')'arrayman intblock(..) mpartiti=',mpartition 
!         write(6,'(10i8)') (intblock(i),i=1,20)                        
         end if 
!-----------------                                                      
       end if 
      else 
       if(iblock.ne.nblock) then 
        call writear(nblock) 
        iwritear=iwritear+1 
        call readar(iblock) 
!        write(6,'(a,3i8)') 'arrayman iblock.ne.nblock=',iblock,nblock  
        nblock=iblock 
       end if 
       j=iblockpt(nblock) 
       mpartition=intblock(j) 
!       write(6,'(a,4i5)')'iblockpt=',(iblockpt(i),i=1,4)               
!       write(6,'(a,15i7)')'intblock=',(intblock(i),i=j,j+2*mpartition)
       do k=1,mpartition 
        ji=j+k 
        iseqsto(k)=intblock(ji) 
        narraysp(k)=intblock(ji+mpartition) 
       end do 
!      write(6,'(a,6i12)')'narraysp(mpartition)=',(narraysp(k),k=0,3)
!      write(6,'(a,3i8)')'nseqsto(ks)=',(nseqsto(k),k=1,2)            
                                                                        
       npartition=nseqsto(ks) 
       iarraysp=narraysp(npartition-1) 
       iarray_sp=iarraysp+2 
       i2=narraysp(npartition) 
       kk=i2-iarraysp 
       if(nstorSP.eq.1)then
          nstorSP2=kk 
!        write(6,'(a,3i8)')'iarray_sp,nstorSP2=',iarray_sp,nstorSP2
       end if
       if(kk.ne.nstorSP2.and.b_const) then 
        if(narraysp(mpartition)+nstorSP2-kk.gt.marray_sp)then 
!        ks in nblock loeschen                                          
!        write(6,'(a)')'ks in nblock loeschen'                         
!        write(6,'(a,3i8)')'narraysp(mpartition),nstorSP2,i2=',  &       
!                           narraysp(mpartition),nstorSP2,i2     
         iend=narraysp(mpartition) 
         do i=1,iend-i2 
          array_fr(iarraysp+i)=array_fr(i2+i) 
         end do 
!        write(6,'(a,4i7)')'#iarraysp-.. > i2-..:',iarraysp,iarraysp+iend-i2,i2,iend

         do i=npartition,mpartition-1 
          narraysp(i)=narraysp(i+1)-kk 
          iseqsto(i)=iseqsto(i+1) 
         end do 
                                                                        
         do i=1,mpartition-1 
          nseqsto(iseqsto(i))=i 
         end do 
         j=iblockpt(nblock) 
         mpartition=mpartition-1 
         intblock(j)=mpartition 
                                                                        
         do k=1,mpartition 
          ji=j+k 
          intblock(ji)=iseqsto(k) 
          intblock(ji+mpartition)=narraysp(k) 
         end do 
                                                                        
!         write(6,'(a,4i5)')'iblockpt=',(iblockpt(i),i=1,4)             
!         write(6,'(a)')'2(intblock(i),i=1,40)'                         
!         write(6,'(10i7)')(intblock(i),i=1,40)                         
                                                                        
         if(nblock.lt.mblock) then 
          ji=iblockpt(nblock)+2*mpartition 
          jmax=iblockpt(mblock)+2*intblock(iblockpt(mblock)) 
          do k=ji+1,jmax-2 
           intblock(k)=intblock(k+2) 
          end do 
          intblock(jmax-1)=0 
          intblock(jmax)=0 
          do k=nblock+1,mblock 
           iblockpt(k)=iblockpt(k)-2 
          end do 
         end if 
!        write(6,'(a,i2)') ' intblock(..) mpartition=',mpartition      
!        write(6,'(10i8)') (intblock(i),i=1,30)                        
         call writear(nblock) 
         iwritear=iwritear+1 
!        neuen block holen                                              
         j=0 
         k=1 
         do while(j.eq.0.and.k.le.mblock) 
          m=intblock(iblockpt(k)) 
          m=intblock(iblockpt(k)+2*m) 
          if(m+nstorSP2.lt.marray_sp) j=k 
          k=k+1 
!         write(6,'(i2,a,4i7)')k,'=k m,m+nstorSP2=',m,m+nstorSP2       
         end do 
         if(j.eq.0) then 
          nblock=mblock+1 
!         neuen block anlegen                                           
!         write(6,'(a)') 'neuen block anlegen'                         
!         write(6,'(a,12i3)') 'iblockpt(1..12)=',(iblockpt(i),i=1,12)  
          jp=iblockpt(mblock)+2*intblock(iblockpt(mblock))+1 
          mblock=nblock 
          iblockpt(nblock)=jp 
          jblock(ks)=nblock 
          mpartition=1 
          nseqsto(ks)=mpartition 
          narraysp(1)=nstorSP2 
          iseqsto(1)=ks 
          iarraysp=0 
          iarray_sp=iarraysp+2 
          intblock(jp)=1 
          intblock(jp+1)=iseqsto(1) 
          intblock(jp+2)=narraysp(1) 
         else 
          nblock=j 
          call readar(nblock) 
!         aktuellen block erweitern (anhaengen)                         
!         write(6,'(a)') 'aktuellen block erweitern(anhaengen)'        
          j=iblockpt(nblock) 
          jblock(ks)=nblock 
          mpartition=intblock(j) 
!         narraysp(k). iseqsto(k) neu beschreiben fuer nblock           
          do k=1,mpartition 
           ji=j+k 
           iseqsto(k)=intblock(ji) 
           narraysp(k)=intblock(ji+mpartition) 
          end do 
                                                                        
          mpartition=mpartition+1 
          nseqsto(ks)=mpartition 
          narraysp(mpartition)=narraysp(mpartition-1)+nstorSP2 
          iseqsto(mpartition)=ks 
          iarraysp=narraysp(mpartition-1) 
          iarray_sp=iarraysp+2 
          intblock(j)=mpartition 
          ji=j+2*(mpartition-1)+1 
          jmax=iblockpt(mblock)+2*intblock(iblockpt(mblock)) 
          do k=jmax,ji,-1 
           intblock(k+2)=intblock(k) 
          end do 
          do k=nblock+1,mblock 
           iblockpt(k)=iblockpt(k)+2 
          end do 
          do k=1,mpartition 
           ji=j+k 
           intblock(ji)=iseqsto(k) 
           intblock(ji+mpartition)=narraysp(k) 
          end do 
                                                                        
!         write(6,'(2i2,a,4i5)')nblock,mblock,'=n,m iblockpt=',(iblockpt(i),i=1,4)
!         write(6,'(a)')'#  (intblock(i),i=1,jmax)'                    
!         write(6,'(10i7)')(intblock(i),i=1,jmax)                      
!         write(6,'(a,a,i2)') 'aktuellen block erweitern', &
!                              'intblock(..) mpartition=',mpartition
!         write(6,'(10i8)') (intblock(i),i=1,30)                        
         end if 
        else  ! narraysp(mpartition)+nstorSP2-kk.gt.marray_sp   
!        aktuellen block erweitern (einfuegen)                          
!        write(6,'(a,a,i2)') 'aktuellen block erweitern', &             
!                            ' intblock(..) mpartition=',mpartition
         j=iblockpt(nblock) 
         mpartition=intblock(j) 
!         write(6,'(a,15i7)')'intblock=',(intblock(i),i=j,j+2*mpartition)
         iend=narraysp(mpartition) 
         it=iend-i2
         
!         write(6,'(a,5i8)')'iarraysp,marray_sp,iend,i2=',iarraysp,marray_sp,iend,i2
         if(iend.lt.marray_sp-it.and.it.gt.0) then
!          if(i2.gt.it)write(6,'(a,8i8)')&
!           'transfer it,i2,iarraysp,iend=',it,i2,iarraysp,iend,marray_sp
          allocate(transfer(it))  
          do i=1,it
           transfer(i)=array_fr(iarraysp+i) 
          end do
         end if
         do i=1,it
          array_fr(iarraysp+i)=array_fr(i2+i) 
         end do
         if(iend.lt.marray_sp-it.and.it.gt.0) then
          do i=1,it
           array_fr(iarraysp+it+i)=transfer(i)
          end do
          deallocate(transfer)
         end if

         do i=npartition,mpartition-1 
          narraysp(i)=narraysp(i+1)-kk 
          iseqsto(i)=iseqsto(i+1) 
         end do 
          iseqsto(mpartition)=ks 
         do i=1,mpartition 
          nseqsto(iseqsto(i))=i 
         end do 
         nseqsto(ks)=mpartition 
!        write(6,'(10i7)')(narraysp(i),i=1,mpartition)                 
!        read(5,'(a)')                                                 
         iarraysp=narraysp(mpartition-1) 
         iarray_sp=iarraysp+2 
         narraysp(mpartition)=iarraysp+nstorSP2 
        end if ! narraysp(mpartition)+nstorSP2.gt.marray_sp        
        j=iblockpt(nblock) 
        do k=1,mpartition 
         ji=j+k 
         intblock(ji)=iseqsto(k) 
         intblock(ji+mpartition)=narraysp(k) 
        end do 
!        write(6,'(a,a,i2)') 'aktuellen block erweitern', &
!                            ' intblock(..) mpartition=',mpartition  
         j=iblockpt(nblock) 
         mpartition=intblock(j) 
!        write(6,'(a,15i7)')'intblock=',(intblock(i),i=j,j+2*mpartition)
       end if  ! kk.ne.nstorSP2 
!      write(6,'(a,i2)') ' intblock(..) mpartition=',mpartition        
!      write(6,'(10i8)') (intblock(i),i=1,30)                          
      end if   ! iblock=nblock    
                                                                        
      if(.not.b_const) then 
       npartition=nseqsto(ks) 
       iarraysp=narraysp(npartition-1) 
       iarray_sp=iarraysp+2 
!      write(6,'(a,2i7)')'arrayman npartition,iarray_sp=',npartition,iarray_sp
       goto 1000 
      end if 
      if(b_const.and.enwr(16).eq.'9999') then 
!      write(6,'(a,6i8)') '***b_const=true =',&          
!         iarray_sp,nstorFR,iarray_sp+nstorFR+iadd,iarraysp+nstorSP2     
       do i=iarray_sp+nstorFR+iadd,iarraysp+nstorSP2 
        array_fr(i)=cmplx(9999.,9999.) 
       end do 
      end if 
 1000 continue 
      nstorSP=nstorSP2 
!     write(6,'(i3,a,3i8)')ks,' arrayman iarray_sp,nstorSP=',iarray_sp,nstorSP
      
      return 
      END                                           

