      subroutine list(comline,icom,info) 
      use glbconst, only: maxs,maxthss,maxsto,nwr
      use compar, only: ncolwin,nwrwin
      use comfrm, only: mco,ncor,mc,mr
      use comdat, only: b_datset
      use comdas, only: namedata,ktheo,istrss,nametheory
      use comeff, only: ndispmode,displaymode,npl
      implicit none 
                                                                        
      character(len=132):: comline,ch132,property,name_theo,chin,      &
                           chcom,chstring
      character(len=16) :: ch16
      character(len=4)  :: chnorm,cmch
      character(len=2)  :: cb2
      character(len=1)  :: ch1
      integer       icom,info,ienter,n1,nclw,                          &
                    i,ii,ie,il,i1,i2,imco,jj,lth,nth,nthar,            &
                    k,ks,klev,kss,ntrimto0 
      real, dimension(32):: out 
                                                                        
      nclw=ncolwin 
      if(nclw.gt.132)nclw=132 
                                                                        
      chnorm=char(27)//'[0m' 
      do k=1,npl 
       chstring(k:k)='-' 
      end do 
   10 il=ntrimto0(comline) 
      ienter=1 
      chcom='effi/list' 
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'*'.or.comline(1:1).eq.'q') then 
       return 
      end if 
      cb2=comline 
      i=index(comline,'&&') 
      if(i.eq.0) then 
       ch16=comline(3:) 
      else 
       ch16=comline(3:i-1) 
       ch132=comline(i:) 
       comline=ch132 
      end if
      if(index(ch16,'wi').gt.0) then 
       ch132=' 0' 
       call readyn(ch132,5) 
       return 
      end if 
      i=index(ch16,'da') 
      if(i.gt.0) then 
       chin='data set'//ch16(i+2:) 
       if(index(ch16,'a').gt.0.or.ch16.eq.' ')                          &
             chin='data sets'                                           
       ch1='-' 
       call chcenter(chin,ch1,nclw) 
       write(nwrwin,'(a)') chin(:npl) 
       ch132=ch16(i+2:) 
       call trlch(10,ch132,k,out) 
       if(k.eq.0)then 
        do ks=1,maxs 
         nthar=abs(ktheo(ks,0,0)) 
         if(nthar.gt.0) then 
          write(nwrwin,'(/,a4,a1,a,i3,2a4)') char(27)//'[1m',              &
                      char(27),'[34mset number ',ks,chnorm,char(27)//'[0m' 
          if(b_datset(ks)) write(nwrwin,'(a4,a,a4)')char(27)//'[1m',       &
                              namedata(ks)(:nclw-1),char(27)//'[0m' 
         end if 
        end do 
       else 
        ks=out(1) 
        if(ks.gt.0.and.ks.lt.maxs)then 
         if(b_datset(ks))                                               &
           write(nwrwin,'(1h,a)')namedata(ks)(:nclw-1)                  
        end if 
       end if 
      end if 
      i=index(ch16,'se') 
      if(i.gt.0) then 
                                                                        
       chin='theories and data set'//ch16(i+3:) 
       if(index(ch16,'a').gt.0.or.ch16.eq.' ')                          &
             chin='theories and data sets'                              
                                                                        
       ch1='-' 
       call chcenter(chin,ch1,nclw) 
       write(nwrwin,'(a)') chin(:npl) 
       ch132=ch16(i+2:) 
       call trlch(10,ch132,k,out) 
       k=out(1) 
       do ks=1,maxs 
        nthar=abs(ktheo(ks,0,0)) 
                                                                        
        if(nthar.gt.0.and.(ks.eq.k.or.k.eq.0)) then 
          write(nwrwin,'(/,a4,a1,a,i3,2a4)') char(27)//'[1m',              &
                      char(27),'[34mset number ',ks,chnorm,char(27)//'[0m' 
          if(b_datset(ks)) write(nwrwin,'(a4,a,a4)')char(27)//'[1m',       &
                              namedata(ks)(:nclw-1),char(27)//'[0m' 
          nth=ktheo(ks,0,1) 
          lth=ktheo(ks,0,2) 
          call getname(0,nth,lth,property,name_theo)
           write(nwrwin,'(a,/,a,a2,2i3,a1)')                             &
                TRIM(property),TRIM(name_theo),' (',nth,lth,')'           
          if(nthar.gt.3) then 
           do klev=3,nthar,2 
            nth=ktheo(ks,0,klev) 
            lth=ktheo(ks,0,klev+1) 
            call getname(1,nth,lth,property,name_theo) 
            write(nwrwin,'(3x,a,a2,2i3,a1)')TRIM(name_theo),' (',nth,lth,')'
            end do 
          end if 
          if(icom.eq.1) then 
           i=0 
           do kss=1,maxthss 
            nthar=abs(ktheo(ks,kss,0)) 
            if(nthar.gt.0) then 
!             if(istrss(ks,kss).ne.0) then                              
              ii=1 
              jj=istrss(ks,kss) 
              if(jj.lt.0)ii=0 
              if(ii.gt.0)i=i+1 
              nth=ktheo(ks,kss,1) 
              lth=ktheo(ks,kss,2) 
              call getname(ii,nth,lth,property,name_theo) 
              if(ii.gt.0) then 
               write(nwrwin,'(9x,a,i2,a2,a,a2,2i3,a1)')                 &
                'component ',i,') ',TRIM(name_theo),' (',nth,lth,')'     
              else 
               if(jj.lt.-100) then 
                i1=-jj/100 
                i2=-jj-100*i1 
               else 
                i1=-jj/10 
                i2=-jj-10*i1 
               end if 
               if(i2.eq.0) then 
                write(nwrwin,'(5x,a,i1,a,a,a2,2i3,a1)')                 &
                'device ',i1,' of ',TRIM(name_theo),' (',nth,lth,')'     
               else 
                write(nwrwin,'(7x,a,i2)')                               &
                'module ',i2                                            
               end if 
              end if 
!               write(nwrwin,'(10x,a,/,5x,a)')                          
!                            property(:lp),name_theo(:lt)              
                                                                        
              do klev=3,nthar,2 
               nth=ktheo(ks,kss,klev) 
               lth=ktheo(ks,kss,klev+1) 
               call getname(1,nth,lth,property,name_theo) 
               write(nwrwin,'(18x,a,a2,2i3,a1)')TRIM(name_theo),' (',nth,lth,')'
              end do 
!             end if                                                    
            end if 
           end do 
          end if  ! icom=1   
        end if 
       end do 
                                                                        
       write(nwrwin,'(a)') chstring(:nclw) 
      end if 
                                                                        
      if(index(ch16,'ma').gt.0) then 
       chin='transformation matrices' 
       ch1='-' 
       call chcenter(chin,ch1,nclw) 
       write(nwrwin,'(a)') chin(:nclw) 
                                                                        
       imco=(mco)/2  ! 2 matrices listed per line
       do i=1,imco 
        ii=2*(i-1)+1 
        ie=ii+1 
        write(nwrwin,'(1h ,2(i3,1x,a16,1x,a1,i3,a1,i2,a1,2x))')         &
             (k,ncor(k),'(',mr(k),',',mc(k),')',k=ii,ie)                 
       end do 
       if(mco.gt.ie) then 
        ii=ie+1 
        write(nwrwin,'(1h ,2(i3,1x,a16,1x,a1,i3,a1,i2,a1,2x))')         &
             (k,ncor(k),'(',mr(k),',',mc(k),')',k=ii,ii)                 
       end if 
       write(nwrwin,'(a)') chstring(:nclw) 
       ii=0
       do k=1,mco
        ii=ii+mr(k)*mc(k)
       end do
        write(nwrwin,'(a,i5)') ' total number of elements:',ii
       end if 
                                                                        
      if(index(ch16,'dm').gt.0) then 
       chin='display mode' 
       ch1='-' 
       call chcenter(chin,ch1,npl) 
       write(nwr,'(a)') chin(:npl) 
       do ks=1,maxs 
         if(abs(ktheo(ks,0,0)).gt.0) then 
          k=ndispmode(ks) 
          ch16=displaymode(ks,k) 
          cmch='dmod'
          if(ch16.eq.' ') call frametheory(ks,cmch,n1,info) 
          chin=displaymode(ks,k) 
          ch1=' ' 
          call chcenter(chin,ch1,npl) 
          ch132=chin 
          if(b_datset(ks)) then 
           chin=namedata(ks) 
           ch1='.' 
           call chcenter(chin,ch1,npl) 
           write(nwr,'(a,/,a)') chin(1:npl),ch132(1:npl) 
          else 
           chin=nametheory(ks) 
           ch1='.' 
           call chcenter(chin,ch1,npl) 
           write(nwr,'(a,/,a)') chin(1:npl),ch132(1:npl) 
          end if 
         end if 
       end do 
       write(nwr,'(a)') chstring(:npl) 
      end if 
                                                                        
                                                                        
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline='li '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 10 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
      return 
      END                                           
                                                                        
      subroutine ks_select(comline,info) 
      use glbconst, only: maxs
      use comdas, only: ktheo
      use comscd, only: npanum
      implicit none 
      character(len=132), intent(inout):: comline
      integer, intent(out):: info
   
      character(len=132):: chcom,chin,ch132 
      integer       ic,ienter,j,jj,k,npa,ntrimto0 
      character     ch2*2,cb2*2 
                                                                        
                                                                        
!     write(6,'(2a)') 'ks_se  comline:',comline(1:50)                  
      info=0 
      ic=ntrimto0(comline)
   10 ch2=comline 
      ienter=1 
      chcom='effi/buffer/select/set'
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'q') comline(1:1)='*' 
      if(comline(1:1).eq.'*') return 
!      write(6,'(2a)') 'ks_se 2  comlnine:',comline(1:50)               
      cb2=comline 
      ic=index(comline,'&&') 
      if(ic.eq.0) then 
       ch132=comline(3:) 
        ic=ntrimto0(ch132) 
      else 
       ch132=comline(3:ic-1) 
       ic=ic-4 
      end if 
                                                                        
      if(ienter.eq.3) then 
       chin=comline(3:) 
       comline=ch2//' '//cb2//chin 
       call comln1(comline,chcom,ienter) 
       goto 10 
      end if 
                                                                        
      if(ch2.eq.'ft') ch132(1:2)=' ' 
      chin='p '//ch132 
                                                                        
      do k=1,ic 
       if(ch132(k:k).eq.'s') ch132(k:k)=' ' 
      end do 
      chin=ch132 
!      write(6,'(a,i4,a)') ' ks_se ic,ch132:',ic,ch132(1:50)            
      k=1
      call panum(chin,maxs,npanum,k)
      if(k.ne.1) then
       print'(2a)','error in the list:',TRIM(chin)
       info=k
       return
      end if       
!      write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,npanum(2)+2)       
      jj=npanum(2) 
      do j=1,npanum(2) 
       npa=npanum(j+2) 
       if(ktheo(npa,0,0).eq.0) then 
        npanum(j+2)=0 
        jj=jj-1 
       end if 
      end do 
                                                                        
      if(jj.le.0) then 
!       write(nwr,'(a)' ) '** check for set number'                     
       comline(1:1)='*' 
       return 
      else 
!      write(6,'(a,10i4)') ' ks_select npanum=',(npanum(i),i=1,10)      
       k=npanum(2) 
       j=-1
       call panum(chin,k,npanum,j) 
       if(j.ne.-1) then
        print'(2a)','error in the list:',TRIM(chin)
        info=j
        return
       end if       
!      write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,10)                
       j=-2
       call panum(chin,k,npanum,j) 
       if(j.ne.-2) then
        print'(2a)','error in the list:',TRIM(chin)
        info=j
        return
       end if       
      end if 
                                                                        
       if(ienter.eq.2) then 
        call comln1(comline,chcom,ienter) 
        ienter=0 
       end if 
      if(ienter.eq.0) then 
       ienter=1 
       comline=ch2//'  b1l' 
       call comln1(comline,chcom,ienter) 
      end if 
!      write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,10)                
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine ft_condition(comline,ienter,chft,info) 
      use glbconst, only: infotext,nwr
      use comscd, only: npanum,conwr,nconwr,natcon
      use comths, only: boundary,fixf,ftol,     &
                        i_confine,iBR_DBR,ibx_calc,idf_min,     &
                        iterations,iterbrake,limit,tolimit
      use comeff, only: maxfc,nfitcond,i_file,nftc,pathwidth,converg
      implicit none 
                                                                        
      character(len=132):: comline,chcom,chstr,cp132,             &      
                           chin,chcrd
      character(len=4)  :: chft
      character(len=4),dimension(1:32):: chf
      integer       ienter,nprint,info,jft,                            & 
                    i,k,l,il,im,j,jb,nn,jl,ledit,ntrimto0 
      real          out(32),rn 
      character     chl*24,chr*24,form*7,ch1*1,cb2*2,ch6*6,ch8*8              
      logical b_fit,b_q,nopm

       i=index(comline,'$') 
       if(i.eq.0) then 
!        chend=' ' 
        nopm=.true.                                                                 
       else 
!        chend=comline(i:) 
        comline(i:i)=' ' 
        nopm=.false.
       end if 
       b_fit=.false.         
       b_q=.false.
       i=index(comline,' q ') 
       if(i.gt.0) then
         comline(i+1:i+1)=' '      
         b_q=.true.
       end if
       chcom='effi/fit/conditions' 
                                                                        
       conwr(1)=iterations 
       conwr(2)=pathwidth 
       conwr(3)=converg 
       conwr(4)=tolimit 
       conwr(5)=limit 
       conwr(6)=fixf 
       conwr(7)=idf_min 
       conwr(8)=ftol 
       conwr(9)=iterbrake 
       conwr(10)=iBR_DBR 
       conwr(11)=ibx_calc 
       conwr(12)=boundary 
       conwr(13)=i_confine 
       conwr(14)=i_file 
       nprint=iterations 
       if(chft.eq.'powe'.or.chft.eq.'dfpm') then 
        chin=' 1 8 9 10 11 14' 
       else if(chft.eq.'marq') then 
        chin=' 1-7 14' 
       else if(chft.eq.'grad') then 
        chin=' 1-7 14' 
       else if(chft.eq.'newt') then 
        chin=' 1-7 12 13 14' 
       else if(chft.eq.' ') then 
        chin=' 1-14' 
       end if 
       chstr=chin 
       chcrd=chin 
       jl=maxfc 
       i=1
       call panum(chstr,jl,npanum,i) 
       if(i.ne.1) then
        print'(2a)','error in the list:',TRIM(chstr)
        info=i
        return
       end if       
       jft=npanum(2) 
       if(jft.gt.maxfc) jft=maxfc 
       do k=3,jft+2 
        natcon(k-2)=npanum(k) 
       end do 
       natcon(jft+1)=0 
                                                                        
   10  il=ntrimto0(comline) 
       if(index(comline,'b1l').gt.0) then 
        nprint=0 
        if(ienter.eq.4) b_fit=.true. 
        ienter=-1 
        goto 11 
       end if 
       if(index(comline,'b1').gt.0.and.nopm.and..not.b_q) then 
         write(nwr,'(a)') 
         do i=1,maxfc 
          nconwr(i)=nfitcond(i) 
         end do 
         ledit=0 
         call conread(chcrd,conwr,nconwr,maxfc,chcom,ledit) 
         do i=1,maxfc 
          nfitcond(i)=nconwr(i) 
         end do 
         ienter=1
         if(nopm)ienter=2 
         goto 20 
       end if 
!      write(6,'(a,/,a)') ' 1comsub comline=',comline 
   11  call comln1(comline,chcom,ienter) 
       if(b_q)ienter=1
       if(comline(1:1).eq.'*'.or.comline(1:1).eq.'q') return 
       cb2=comline 
       chin=comline(3:) 
                                                                        
!      istrip=2                                                         
!      call nextchar(comline,istrip,ipos,ch,ih)                         
!      comline=' '                                                      
       l=0 
       call lc_character(chin) 
!       do ih=1,jft                                                     
!        k=natcon(ih)                                                   
       do k=1,maxfc 
        j=index(chin,nftc(k*5-3:k*5)) 
                                                                        
        if(j.gt.0) then 
         l=l+4 
         call itoc8(ch8,k) 
         chcrd(l:l+4)=ch8(1:4) 
!         write(6,'(a,5x,aa)')chcrd(:l+4),nftc(k*5-3:k*5)               
         cp132=chin(j:) 
         i=index(cp132,'=')  
         if(i.eq.0) goto 1000 
          j=index(cp132(i:),' ') 
          chstr=cp132(i+1:i+j) 
          cp132=chstr 
          call fout_a(cp132,chf,nn) 
          ch6=chf(1)(1:3) 
          if(ch6(1:1).eq.'i') then 
           ch6(4:6)=')  ' 
          else 
           ch6(4:6)='.'//chf(1)(4:4)//')' 
          end if 
          nfitcond(k)(33:38)=ch6 
!         write(6,'(2a)')'comsub chstr=',chstr(1:j)                     
          call trlch(10,chstr,nn,out) 
          conwr(k)=out(1) 
        end if 
       end do 
       if(b_fit.or..not.nopm) goto 20 
         write(nwr,'(a)') 
         do i=1,maxfc 
          nconwr(i)=nfitcond(i) 
         end do 
         ienter=1
         if(nopm)ienter=2
         if(b_q) goto 20
         ledit=0 
         call conread(chcrd,conwr,nconwr,maxfc,chcom,ledit) 
         do i=1,maxfc 
          nfitcond(i)=nconwr(i) 
         end do 
                                                                        
   20  continue 
       iterations=conwr(1) 
       pathwidth =conwr(2) 
       converg   =conwr(3) 
       tolimit   =conwr(4) 
       limit     =conwr(5) 
       fixf      =conwr(6) 
       idf_min   =conwr(7) 
       ftol      =conwr(8) 
       iterbrake =conwr(9) 
       iBR_DBR   =conwr(10) 
       ibx_calc  =conwr(11) 
       boundary  =conwr(12) 
       i_confine =conwr(13) 
       i_file    =conwr(14) 
                                                                        
       comline='fc ' 
       jl=2 
       do j=1,maxfc
        rn=conwr(j) 
        form=nfitcond(j)(33:) 
        ch1=form(5:5) 
        if(form(1:1).eq.'i') then 
         form(4:7)=' ' 
        else 
         form(4:)='.'//ch1//'  ' 
        end if 
        call trlnu(form,rn,chr,nn,chl,im) 
        k=1 
        do while(chl(k:k).eq.' '.and.k.lt.im) 
         k=k+1 
        end do 
        jb=jl+1 
        jl=jb+im+6-k 
        i=5*j 
        comline(jb:jl)=' '//nftc(i-3:i)//'='//chl(k:im) 
       end do 
!       comline(jl+1:)=chend 

       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline='fc '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 10 
       end if 
       if(ienter.eq.2) then 
        call comln1(comline,chcom,ienter) 
        ienter=0 
        nprint=0 
       end if 
       if(ienter.eq.0.and.nprint.eq.0) then
!        if(.not.b_q)write(nwr,'(a)')comline(:jl) 
        ienter=1 
       end if 
       return 
                                                                        
 1000  continue 
       info=1 
       infotext(1)=chcom 
       infotext(2)='name and value must be seperated by =  ' 
       infotext(3)=' ' 
       return 

      END                                           
                                                                        
                                                                        
                                                                        
      subroutine ft_excinc(comline,info) 
      use glbconst, only: maxs,infotext,MDBPLFT
      use comscd, only: npanum
      use comdat, only: ichan,checic,b_datset,ibadchan
      use comdas, only: ip_chan,cdata
      implicit none 
                                                                        
      integer       info,i,il,iset,j,ienter,                            &
                     k,kc,kexc,kinc,knp,nchannel,nset,ntrimto0                    
      character(len=132):: comline,ch132,ct132,chin,chstring,chcom
      character(len=4)  :: cmch 
      character(len=2)  :: ch2,cb2 
      dimension     nset(0:maxs) 
      logical     b_dat 
      common/plot/b_dat(MDBPLFT*2) 
                                                                        
       chcom='effi/display/mode' 
   10  il=ntrimto0(comline) 
       ienter=1 
       ch2=comline 
       call comln1(comline,chcom,ienter) 
       if(comline(1:1).eq.'q') comline(1:1)='*' 
       if(comline(1:1).eq.'*') goto 1000 
       cb2=comline 
       i=index(comline,'&&') 
       if(i.eq.0) then 
        ch132=comline(3:) 
        i=ntrimto0(ch132) 
        chstring=' ' 
       else 
        ch132=comline(3:i-1) 
        chstring=comline 
       end if 
                                                                        
      if(ienter.eq.3) then 
       chin=comline(3:) 
       comline=ch2//' '//cb2//chin 
       call comln1(comline,chcom,ienter) 
       goto 10 
      end if 
                                                                        
!       write(6,'(2a)') 'ft_excinc comline=',comline(1:60)              
!       istrip=2                                                        
!       call nextchar(comline,istrip,ipos,ch132,ih)                     
!      write(6,'(2a)') 'ch132=',ch132(1:60)                             
       call lc_character(ch132) 
        kexc=index(ch132,'exc') 
        kinc=index(ch132,'inc') 
        if(kexc*kinc.eq.0)then 
         kc=max(kexc,kinc) 
        else 
         kc=min(kexc,kinc) 
        end if 
       if(kc.eq.0) then 
        info=1 
        infotext(1)='effi/data/region/exic' 
        infotext(2)=comline 
        infotext(3)=' regions to be defined by exc/inc' 
        goto 1000 
       end if 
                                                                        
       i=index(ch132,'s') 
       ct132=ch132(i+1:) 
       chin=ch132(i+1:kc-1) 
       i=1
       call panum(chin,maxs,npanum,i) 
       if(i.ne.1) then
        print'(2a)','error in the list:',TRIM(chin)
        info=i
        return
       end if       
       nset(0)=npanum(2) 
       do k=1,nset(0) 
        nset(k)=npanum(2+k) 
       end do 
!      write(6,'(a,6i4)')' npanum=',(npanum(k),k=1,nset(0)+2)           
                                                                        
       checic=ch132(kc:) 
!      write(6,'(i4,2a)') kc,'=kc checic=',checic(1:60)                 
                                                                        
       do knp=1,nset(0) 
        ct132=checic 
        iset=nset(knp) 
        if(iset.lt.1.or.iset.gt.maxs.or..not.b_datset(iset)) then 
         info=1 
         infotext(1)='effi/structure/set/maxs' 
         infotext(2)=comline 
         infotext(3)=' no data ' 
          goto 1000 
        end if 
        nchannel=cdata(iset,ip_chan(iset)) 
        do i=1,nchannel 
         b_dat(i)=.false. 
        end do 
        do i=1,ichan(0,iset),2 
         do j=ichan(i,iset),ichan(i+1,iset) 
          b_dat(j)=.true. 
         end do 
        end do 
                                                                        
        cmch='ecic'; call frametheory(iset,cmch,j,info) 
                                                                        
        do i=1,ibadchan(0,iset) 
         b_dat(ibadchan(i,iset))=.false. 
        end do 
                                                                        
        nchannel=cdata(iset,ip_chan(iset)) 
        do i=1,ichan(0,iset) 
          ichan(i,iset)=0 
        end do 
        k=1 
        i=1 
        do while(i.lt.nchannel) 
         if(b_dat(i))then 
          ichan(k,iset)=i 
          j=i+1 
          do while(j.le.nchannel.and.b_dat(j)) 
           j=j+1 
          end do 
          ichan(k+1,iset)=j-1 
          i=j-1 
          if(i.lt.nchannel) k=k+2 
         end if 
         i=i+1 
        end do 
        ichan(0,iset)=k+1 
        if(ichan(k,iset).eq.0)ichan(0,iset)=k-1 
!        write(6,'(i3,a,i5)')iset,' ichan=',ichan(0,iset)               
!        write(6,'(10i5)')(ichan(i,iset),i=0,ichan(0,iset))             
       end do 
                                                                        
                                                                        
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
       if(ienter.eq.0) then 
        ienter=1 
        comline='dr b1l' 
        call comln1(comline,chcom,ienter) 
       end if 
       comline=chstring 
                                                                        
 1000  continue 
       return 
      END                                           
                                                                        
                                                                        
      subroutine excinc2d(info) 
      use glbconst, only: infotext,MDBPLFT
      use comscd, only: npanum
      use comdat, only: checic,nchannelsp
      implicit none 
                                                                        
      integer       info,ih,ipos,j,k,kc,kexc,kinc,kk 
      character*132 chstr,ct132 
      logical     b_kc,b_dat 
      common/plot/b_dat(MDBPLFT*2) 
                                                                        
       chstr=checic 
  100  kexc=index(chstr,'exc') 
       kinc=index(chstr,'inc') 
       if(kexc*kinc.eq.0)then 
        kc=max(kexc,kinc) 
       else 
        kc=min(kexc,kinc) 
       end if 
                                                                        
       if(kc.eq.kexc) then 
        b_kc=.false. 
       else 
        b_kc=.true. 
       end if 
                                                                        
       if(kc.eq.0) goto 1000 
       ct132=chstr 
       call nextchar(ct132,kc,ipos,chstr,ih) 
!       write(6,'(i4,2a)') kc,'=kc chstr=',chstr(1:60)                  
                                                                        
       kexc=index(chstr,'exc') 
       kinc=index(chstr,'inc') 
       if(kexc*kinc.eq.0)then 
        kc=max(kexc,kinc) 
       else 
        kc=min(kexc,kinc) 
       end if 
       if(kc.gt.1) then 
        ct132=chstr(:kc-1) 
        chstr(1:kc-1)=' ' 
       else 
        ct132=chstr 
        chstr=' ' 
       end if 
!       write(6,'(i4,2a)') kc,'=kc ct132=',ct132(1:60)                  
                                                                        
       if(index(ct132,'a').gt.0) then 
        if(.not.b_kc.and.kinc.eq.0) then 
         info=nchannelsp 
         infotext(1)='effi/data/exclude' 
         infotext(2)='**error** all data cannot be exclude' 
         infotext(3)=' ' 
         goto 1000 
        end if 
        npanum(2)=nchannelsp 
        do k=1,nchannelsp 
         npanum(2+k)=k 
        end do 
       else 
        k=1
        call panum(ct132,nchannelsp,npanum,k) 
        if(k.ne.1) then
         print'(2a)','error in the list:',TRIM(ct132)
         info=k
         return
        end if       
!       write(6,'(a,i4)') ' npanum=',npanum(2)                         
!       write(6,'(10i4)') (npanum(k),k=3,npanum(2))                    
       end if 
                                                                        
       if(npanum(2).gt.0) then 
        do kk=1,npanum(2) 
         j=npanum(kk+2) 
         b_dat(j)=b_kc 
        end do 
       end if 
        goto 100 
                                                                        
 1000 continue 
       return 
      END                                           
                                                                        
      subroutine excinc3d(info) 
      use glbconst, only: infotext,MDBPLFT
      use comscd, only: npanum
      use comdat, only: mfpt,checic,nchannelsp
      use comthe, only: real_fr
      implicit none 
                                                                        
      integer       info,ih,ipos,j,k,kc,kexc,kinc,kk 
      character*132 chstr,ct132 
      logical     b_kc,b_dat 
      common/plot/b_dat(MDBPLFT*2) 
                                                                        
       chstr=checic 
  100  kexc=index(chstr,'exc') 
       kinc=index(chstr,'inc') 
       if(kexc*kinc.eq.0)then 
        kc=max(kexc,kinc) 
       else 
        kc=min(kexc,kinc) 
       end if 
                                                                        
       if(kc.eq.kexc) then 
        b_kc=.false. 
       else 
        b_kc=.true. 
       end if 
                                                                        
       if(kc.eq.0) goto 1000 
       ct132=chstr 
       call nextchar(ct132,kc,ipos,chstr,ih) 
!       write(6,'(i4,2a)') kc,'=kc chstr=',chstr(1:60)                  
                                                                        
       kexc=index(chstr,'exc') 
       kinc=index(chstr,'inc') 
       if(kexc*kinc.eq.0)then 
        kc=max(kexc,kinc) 
       else 
        kc=min(kexc,kinc) 
       end if 
       if(kc.gt.1) then 
        ct132=chstr(:kc-1) 
        chstr(1:kc-1)=' ' 
       else 
        ct132=chstr 
        chstr=' ' 
       end if 
!       write(6,'(i4,2a)') kc,'=kc ct132=',ct132(1:60)                  
                                                                        
       if(index(ct132,'a').gt.0) then 
        if(.not.b_kc.and.kinc.eq.0) then 
         info=nchannelsp 
         infotext(1)='effi/data/exclude' 
         infotext(2)='**error** all data cannot be exclude' 
         infotext(3)=' ' 
         goto 1000 
        end if 
        npanum(2)=nchannelsp 
        do k=1,nchannelsp 
         npanum(2+k)=k 
        end do 
       else 
        k=1
        call panum(ct132,nchannelsp,npanum,k) 
       if(k.ne.1) then
        print'(2a)','error in the list:',TRIM(ct132)
        info=k
        return
       end if       
!        write(6,'(a,i4)') ' npanum=',npanum(2)                         
!        write(6,'(10i4)') (npanum(i),i=3,npanum(2))                    
       end if 
                                                                        
       if(npanum(2).gt.0) then 
        do kk=1,npanum(2) 
         j=npanum(kk+2) 
         b_dat(j)=b_kc 
        end do 
       end if 
       do j=1,nchannelsp 
        if(real_fr(mfpt+j).eq.-1.)b_dat(j)=.false. 
       end do 
       goto 100 
                                                                        
 1000 continue 
       return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine disp_mode(comline,info) 
      use glbconst, only: maxs,infotext
      use comdas, only: ktheo
      use comscd, only: npanum,queryar,ext,helpar
      use comeff, only: displaymode,ndispmode
      implicit none 
                                                                        
      character(len=132) :: comline,chcom,ch132,cp132,chstr,ct132,chin 
      integer       info,i,id,i10,iset,ienter,i0,il,icomplete,j,k,kk,   &
                    kd,lk,lc,lct,ldisp,nn,ntrimto0                           
      real          out(32) 
      character     chdf*80,cb2*2,ch2*2,ch1*1                                 
                                                                        
                                                                        
       i0=ichar('0') 
       chstr=' ' 
       chcom='effi/display/mode' 
   10  il=ntrimto0(comline) 
       ienter=1 
       cb2=comline 
       ch132=comline(3:) 
                                                                        
!       write(6,'(a,i4,a)')'comsub ienter,comline=',ienter,comline(1:60)
!       write(6,'(2a)') 'ch132=',ch132(1:60)                            
       lc=4 
       call lc_character(ch132) 
  100  continue 
       i=index(ch132,'s') 
!      write(6,'(a,i4)') ' after 100 i=',i                              
       if(i.gt.0) then 
!       write(6,'(2a)') 'ch132=',ch132(1:60)                            
        cp132=ch132(i+1:) 
        j=index(cp132,'s') 
!        write(6,'(i4,2a)') j,'=j dp_md cp132=',cp132(1:60)             
        if(j.gt.0) then 
          ct132=cp132(:j-1) 
        else 
          ct132=cp132 
          lct=ntrimto0(ct132) 
        end if 
        kd=index(ct132,'d') 
!        write(6,'(i4,2a)') kd,'=kd dp_md ct132=',ct132(1:60)           
        if(kd.gt.0) then 
         chstr=ct132(kd:kd+1) 
         ct132(kd:kd+1)='  ' 
         chin=ct132(:kd) 
         call trlch(32,chstr,nn,out) 
         id=out(1) 
!         write(6,'(i4,2a)') kd,'=kd dp_md chstr=',chstr(1:60)          
        else 
         chin=ct132 
         id=0 
        end if 
        ch132=ct132 
!        write(6,'(i4,2a)') kd,'=kd dp_md ch132=',ch132(1:60)           
        icomplete=1 
!        write(6,'(i4,2a)') npl,'=npl chin=',chin(1:60)                 
         i=1
         call panum(chin,maxs,npanum,i) 
         if(i.ne.1) then
          print'(2a)','error in the list:',TRIM(chin)
          info=i
          return
         end if       
!        write(6,'(a,6i4)')' dp_md npanum(1,6)=',(npanum(kk),kk=1,6)    
         do kk=1,npanum(2) 
          iset=npanum(kk+2) 
          if(ktheo(iset,0,0).eq.0) npanum(kk+2)=0 
         end do 
         kk=npanum(2)
         i=-1
         call panum(chin,kk,npanum,i) 
         if(i.ne.-1) then
          print'(2a)','error in the list:',TRIM(chin)
         info=i
         return
         end if       
                                                                        
        do kk=1,npanum(2) 
         iset=npanum(2+kk) 
         if(id.le.0.or.id.gt.8) then 
                                                                        
           k=ktheo(iset,0,1) 
           i10=k/10 
           ch2=char(i10+i0)//char(k-10*i10+i0) 
           id=1 
           do while(displaymode(iset,id).ne.' ') 
             ch1=char(id+i0) 
             queryar(id)='d'//ch1//' '//displaymode(iset,id) 
             helpar(id)=                                                &
             'theory/fr'//ch2//'nn  /display/'//displaymode(iset,id)    
            id=id+1 
           end do 
           id=id-1 
  110      i=ndispmode(iset) 
           if(i.gt.0.and.i.le.id) then 
            chdf=queryar(i) 
           else 
           chdf=queryar(1) 
           end if 
           chdf(80:80)='#' 
           lk=id 
           ldisp=id 
           do k=1,lk 
            ext(k)=' ' 
           end do 
           i10=iset/10 
           if(i10.eq.0)then 
             chin='displaymode set='//char(iset+i0) 
           else 
            ch2=char(i10+i0)//char(iset-10*i10+i0) 
            chin='displaymode set='//ch2 
           end if 
           call query(ldisp,lk,chin,chdf) 
           if(ldisp.eq.0) goto 110 
           ndispmode(iset)=ldisp 
           id=0 
          else 
           ndispmode(iset)=id 
           ldisp=id 
          end if 
!         write(6,'(a,i4)') 'displaymode(iset,ll),iset=',iset           
!          do ll=1,8                                                    
!          write(6,'(a)') displaymode(iset,ll)(1:70)                    
!          end do                                                       
                                                                        
          if(displaymode(iset,ldisp).eq.' ') then 
!           write(nwr,'(a,i1,2a)') ' display mode d',id,                
!     &     ' not available for theory  ',nametheory(iset)              
           info=2 
           infotext(1)='effi/displaymode/selection ' 
           infotext(2)=comline 
           infotext(3)=' display mode not available' 
           infotext(4)=' ' 
           goto 1000 
         end if 
        end do 
                                                                        
        if(ienter.eq.2) then 
         kd=ntrimto0(ch132) 
         lc=lc+kd+4 
!         write(6,'(2a)') ' dp_md comsub chstring(1:40)=',chstring(1:40)
        end if  ! ienter=2 
        ch132=cp132 
        goto 100 
                ! i                                                     
       end if 
                                                                        
!       write(6,'(2a)') ' disp_mode before comline=',comline(1:30)      
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline='dm '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 10 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
!       if(ienter.eq.0) then                                            
!        ienter=1                                                       
!        comline='dm b1l'                                               
!        call comln1(comline,chcom,ienter)                              
!       end if                                                          
 1000  continue 
       return 
      END                                           
                                                                        
      subroutine punch_str(comline,info) 
      use glbconst, only: maxn,maxs,maxsub,infplot,MDBPLFT,infotext,nwr
      use comdat, only: b_datset
      use comdas, only: ktheo
      use comscd, only: npanum
      use comeff, only: npl
      implicit none 
                                                                        
!      common/plot/ plotx(max8),ploty(max8),ploterry(max8),plotres(max8)
!     &             plotxx(max8),plotyy(max8),plotsub(max8subn),        
!     &             xyzdz(8),vtxt(2,max16),vtxtp(8,32),                
!     &             int3d(max16),npnt3d(16),ifeder(max16),ltext(32), 
!     &             npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
!     &             n_subspectra,logx,logy,logf,                        
!     &             namechan(infplot),kform(infplot),axisformat(3),     
!     &             axesname(3),title,plotstrdef,plotstrpu,             
!     &             bgcolor,fgcolor,datacolor,thcolor,rescolor,         
!     &             auxcolor1,auxcolor2,auxcolor3,chardum(idumplot)     
                                                                        
      integer, intent(out):: info
      character(len=132), intent(inout):: comline
      integer, parameter:: maxplotarray=176*maxn+8*39,                  &
                           idumplot=MDBPLFT*2-maxplotarray-5*infplot-maxsub-100   
      integer     jarray,npntplot,nchanplot,n_subspectra,ncolor,logx,logy,logf 
      character(len=132):: title,plotstrdef
      character(len=24) :: axesname
      character(len=16) :: axisformat
      character(len=8)  :: kform
      character(len=4)  :: namechan,chardum
      common/plot/ jarray(maxplotarray),                                &
                   npntplot(infplot),nchanplot(infplot),ncolor(maxsub), &
                   n_subspectra,logx,logy,logf,                         &
                   namechan(infplot),kform(infplot),axisformat(3),      &
                   axesname(3),title,plotstrdef,chardum(idumplot)       
                                                                        
      character(len=132):: chcom,chstring,chstr,ch132,cp132,chin,querytype
      character(len=4)  :: cmch
      character(len=2)  :: cb2,ch2        
      integer  il,ienter,istrip,ipos,ih,i,ib,iset,i0,i10,i1,jbf,k,kk,n1, &
               l,lc,ll,ntrimto0
                                                                        
      chstring=' ' 
      i=index(comline,'&&') 
    5 if(i.gt.0) then 
       ch132=chstring 
       ih=132 
       do while(comline(ih:ih).eq.' ') 
        ih=ih-1 
       end do 
       chstring=comline(i:ih+1)//ch132 
       comline(i:)=' ' 
      end if 
!      write(6,'(/,3a,/)')comline(:i),' __ ',ch132(:30)                 
                                                                        
       chstr=' ' 
       chcom='effi/write/display' 
   10  il=ntrimto0(comline) 
       ienter=1 
       if(index(comline,'b1').gt.0) ienter=0 
       jbf=index(comline,'bf') 
       ib=index(comline,'b') 
       if(il.eq.2.or.jbf.gt.0.or.ienter.eq.0.or.ib.gt.0) then 
!        write(6,'(2a)') 'effi a comline=',comline(1:60)                
         call comln1(comline,chcom,ienter) 
         cb2=comline 
!        write(6,'(2a)') 'punch_str comline=',comline(1:60)             
         if(comline(1:1).eq.'q') comline(1:1)='*' 
         if(comline(1:1).eq.'*') then
           l=-8;il=0; ch132='*'
           goto 1000 
          end if
       end if 
       i=index(comline,'&&') 
       if(i.gt.0) goto 5 
                                                                        
!      write(6,'(2a)') 'effi comline=',comline(1:60)                   
       istrip=2 
       call nextchar(comline,istrip,ipos,ch132,ih) 
       comline(3:)=' ' 
!      write(6,'(2a)') 'effi comline=',comline(1:60)                    
!       write(6,'(2a)') 'ch132=',ch132(1:60)                            
       lc=4 
       call lc_character(ch132) 

       i=index(ch132,'fmt:') 
       if(i.gt.0.) then 
        cp132=ch132(1:i-1) 
!       contains the set numbers                                        
        chstr=ch132(i+4:) 
        i=i-1 
       else 
        cp132=ch132 
        chstr=' ' 
       end if 
       chin= cp132 
                                                                        
       l=ntrimto0(cp132) 
       do k=1,l 
        if(cp132(k:k).eq.'s')cp132(k:k)=' ' 
       end do 
!       write(6,'(2a)') 'cp132=',cp132(1:60)                            
        i=1
        call panum(cp132,maxs,npanum,i) 
        if(i.ne.1) then
         print'(2a)','error in the list:',TRIM(cp132)
         info=i
         return
        end if       
!       write(6,'(a,9i4)')' npanum(1..)=',(npanum(kk),kk=1,2+npanum(2)) 
       if(npanum(2).eq.0) goto 1000 
       do kk=1,npanum(2) 
        iset=npanum(2+kk) 
        if(iset.le.0.or.iset.gt.maxs.or.                                &
           (ktheo(iset,0,0).eq.0.and..not.b_datset(iset))) then         
         info=iset 
         infotext(1)='effi/structure/set/used' 
         infotext(2)='set number unused  or out of range' 
         infotext(3)=' ' 
         goto 1000 
        end if 
       end do 
        i0=ichar('0') 
        iset=npanum(3) 
        if(iset.lt.9) then 
         ch2=char(i0+iset) 
        else 
         i10=iset/10 
         i1=iset-i10*10+i0 
         ch2=char(i10+i0)//char(i1) 
        end if 
                                                                        
        if(chstr.eq.' '.and.ktheo(iset,0,0).gt.0) then 
         n1=0 
         cmch='dmod'; call frametheory(iset,cmch,n1,info) 
         ll=1 
         do while(namechan(ll)(1:1).ne.' ') 
          ll=ll+1 
         end do 
         ll=ll-1 
         write(nwr,'(a)')                                               &
          'structure elements of content of display:'                   
         write(nwr,'(16(a4,1x))') (namechan(kk),kk=1,ll) 
         querytype='set '//ch2 
         if(chstr.eq.' ') chstr=plotstrdef 
         chcom='effi/wd_display/structure' 
         call askstring(querytype,chstr,chcom,npl,nwr) 
        end if 
!       write(6,'(a,i4)') 'iset=',iset                                  
!       write(6,'(a)') chstr                                            
        if(chstr.eq.' ') then 
         info=2 
         infotext(1)='effi/wd_display/buffer/empty' 
         infotext(2)='display buffer empty' 
         infotext(3)=' ' 
         goto 1000 
        end if 
!       comline = s... pu .... s.... pu ....                            
!       write(6,'(2a)') ' comsub chstr(1:40)=',chstr(1:40)              
!       write(6,'(2a)') ' comsub ch132(1:60)=',ch132(1:60)              
!       write(6,'(2a)') 'comsub comline(:60)=',comline(1:60)            
                                                                        
        ch132='wd '//TRIM(chin)//' fmt: '//TRIM(chstr)//' ' 
        comline=ch132 
!       write(6,'(2a)') 'comsub comline=',comline(1:70)                 
                                                                        
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline='wd '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 10 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
       if(ienter.eq.0) then 
        ienter=1 
        comline='wd b1l' 
        call comln1(comline,chcom,ienter) 
       end if 
!      write(6,'(2a)') 'write after comln1(2)=',comline(1:70)           
       if(jbf.gt.0) comline='*' 
 1000  continue 
                                                                        
       comline=TRIM(ch132)//' '//chstring 
       return 
      END                                            
                                                                        
                                                                        
                                                                        
       subroutine plot_punch(comline,info) 
      use glbconst, only: maxs
      use comscd, only: npanum
      use comdat, only: b_datset,b_theoset
      use comdas, only: ktheo
      implicit none 
                                                                        
       character(len=132):: ch132,comline,chin,chcom
       character(len=4)  :: cmch
       character(len=2)  :: ch2,cb2
 
       integer info,i,ienter,j,k,ks,n1,npa,ntrimto0
       integer, dimension(0:maxs) :: nks

       chcom='effi/plot_wdisplay' 
!       write(6,'(2a)') ' mos pl vor comln1:',comline(1:50)             
   10  ienter=1 
       ch2=comline 
       call comln1(comline,chcom,ienter) 
!       write(6,'(i4,a,a)')ienter,                                      
!     &    '=ienter plot_pu after comlin1(1)=',comline(1:30)            
       if(comline(1:1).eq.'q') comline(1:1)='*' 
       if(comline(1:1).eq.'*') goto 1000 
       cb2=comline 
                                                                        
       i=index(comline,'&&') 
       if(i.eq.0) then 
        ch132=comline(3:) 
        i=ntrimto0(ch132) 
       else 
        ch132=comline(3:i-1) 
       end if 
                                                                        
!      if(index(ch132,'a').gt.0) then                                   
!       npanum(2)=maxs                                                  
!       do i=1,maxs                                                     
!        npanum(2+i)=i                                                  
!       end do                                                          
!      else                                                             
                                                                        
       j=1 
       chin=ch132 
       do while(j.gt.0) 
        j=index(chin,'s') 
        if(j.gt.0)chin(j:j)=' ' 
       end do 
!       write(6,'(a,a)') 'plot_punch chin(panum)=',chin(1:30)           
        i=1
        call panum(chin,maxs,npanum,i) 
        if(i.ne.1) then
         print'(2a)','error in the list:',TRIM(chin)
         info=i
         return
        end if       
!       write(6,'(a,10i4)') '+plot_punch npanum=',(npanum(i),i=1,10)    
       if(ch2.eq.'pl'.or.ch2.eq.'wd') then 
        do j=1,npanum(2) 
         npa=npanum(j+2) 
         if(.not.(b_theoset(npa).or.b_datset(npa))) npanum(j+2)=0 
        end do 
       else 
        do j=1,npanum(2) 
         npa=npanum(j+2) 
         if(ktheo(npa,0,0).eq.0) npanum(j+2)=0 
        end do 
       end if
       j=npanum(2); if(j.lt.0) j=1
       i=-1
       call panum(chin,j,npanum,i) 
       if(i.ne.-1) then
        print'(2a)','error in the list:',TRIM(chin)
        info=i
        return
       end if       
       i=-2
       call panum(chin,j,npanum,i) 
       if(i.ne.-2) then
        print'(2a)','error in the list:',TRIM(chin)
        info=i
        return
       end if         
                                                                        
       nks(0)=npanum(2) 
       do k=1,npanum(2) 
        nks(k)=npanum(2+k) 
       end do 
       do k=1,npanum(2) 
        ks=npanum(2+k) 
         cmch='dmod'; call frametheory(ks,cmch,n1,info)  
         npanum(2)=nks(0) 
         do j=1,npanum(2) 
          npanum(2+j)=nks(j) 
         end do 
         if(info.gt.0) goto 1000 
       end do 
                                                                        
!       write(6,'(a,10i4)') '+plot_punch npanum=',(npanum(i),i=1,10)    
!       write(6,'(a,10i4)') ' seqdata=',(nseqdata(i),i=0,maxs)           
!       write(6,'(a,i4)') ' subr plot_punch ienter=',ienter             
       if(ienter.eq.3) then 
        chin=comline(3:) 
        comline=ch2//' '//cb2//chin 
        call comln1(comline,chcom,ienter) 
        goto 10 
       end if 
       if(ienter.eq.2) then 
         call comln1(comline,chcom,ienter) 
         ienter=0 
       end if 
       if(ienter.eq.0) then 
        ienter=1 
        comline=ch2//' b1l' 
        call comln1(comline,chcom,ienter) 
       end if 
 1000  continue 
       return 
      END                                           
                                                                        
                                                                        
      subroutine conread(cpin,value,name,n,chcom,ledit) 
      use glbconst, only: maxc,maxp,maxvaco,nwr
      use comscd, only: npanum,conwr,nconwr,natcon
      use comeff, only: npl
      implicit none  
      integer   n,ledit  
      real,dimension(n),intent(inout):: value
      character(len=40),dimension(n):: name  
      character(len=132):: cpin,chcom,ch132,cp132,ct132,ch_com
      character(len=16),dimension(1:3) :: formpr
      character(len=4), dimension(1:32):: chf
      character(len=24):: cp24,fprint,chl,chr
      character(len=80):: chline
      real         out(32),rn 
      character    ch6*6,cn6*6,form*7,prompt*4,chth*8,                 &
                   ch1*1,ch0*1                   
      integer   mch(132),readaline,&
                i,i0,i1,i10,iconwrj,ih,ii,iline,     &
                im,in,info,ip,ipos,irl,j,jc,jj,jp,k,ki,l,length,liedit, &
                mscr1,mscr2,nak,ni,nn,npa 

      ch_com=chcom  
      do i=1,n
       conwr(i)=value(i)
       nconwr(i)=name(i)
      end do 
                                                                      
      ch0=char(0) 
      formpr(1)='(a1,i1,3x,a24,a,' 
      formpr(2)='(a1,i2,2x,a24,a,' 
      formpr(3)='(a1,i3,1x,a24,a,' 
                                                                        
      mscr1=maxc 
      mscr2=mscr1+maxp 
      jj=maxvaco 
      i=1
      call panum(cpin,jj,npanum,i) 
      if(i.ne.1) then
       print'(2a)','error in the list:',TRIM(cpin)
       return
      end if         
      i0=ichar('0') 
      jc=npanum(2) 
      do k=1,jc+2 
        npanum(k+mscr2)=npanum(k) 
      end do 
      do k=3,jc+2 
        natcon(k-2)=npanum(k) 
        npanum(k)=0 
      end do 
                                                                        
  300 continue 
      if(jc.lt.maxc) natcon(jc+1)=0 
                                                                        
      call fwradjust(length) 
                                                                        
      npa=0 
      do j=1,jc 
       ii=natcon(j) 
       k=ii/100 
       ip=3 
       if(k.eq.0) then 
        ip=2 
        k=ii/10 
       end if 
       if(k.eq.0) ip=1 
!       write(6,'(a,a,g15.5)') ' nconwr=',nconwr(ii),conwr(ii)          
       fprint=formpr(ip)//nconwr(ii)(33:40) 
!       write(6,'(a,a)') 'comsub fprint=',fprint                        
       if(nconwr(ii)(33:33).eq.'i') then 
        iconwrj=conwr(ii) 
        write(nwr,fprint) 'n',ii,nconwr(ii),' = ',iconwrj 
       else 
        write(nwr,fprint) 'n',ii,nconwr(ii),' = ',conwr(ii) 
       end if 
      end do 

      if(ledit.eq.-1) goto 390 
      write(nwr,'(a)') 
      i=0 
      goto 382 
                                                                        
  316 chcom=ch_com
      info=0 
      cp132=' ' 
      prompt='>'//ch0 
      irl=readaline(mch,prompt) 
      if(irl.gt.0) then 
       do j=1,irl 
        cp132(j:j)=char(mch(j)) 
       end do 
       call addhist(cp132(:irl)//ch0) 
      end if 
                                                                        
      ct132=cp132 
!      call history(cp132)                                              
      if(cp132(1:2).eq.'le') then 
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        liedit=mod(liedit+1,2) 
        liedit=0 
        cp132=' ' 
        goto 380 
      end if 
                                                                        
! 316  cp132=' '                                                        
!      read(nrd,'(a)') cp132                                            
!      if(cp132(1:2).eq.'ed') then                                      
!        write(nwr,'(1x,a1,a3)') char(27),'[2A'                         
!        ledit=mod(ledit+1,2)                                           
!        if(ledit.eq.0) write(nwr,'(a)') ' command mode'                
!        if(ledit.eq.1) write(nwr,'(a)') ' replacement mode'            
!        cp132=' '                                                      
!        goto 380                                                       
!      end if                                                           
      call nextchar(cp132,0,ipos,ch132,ih) 
      call lc_character(ch132) 
                                                                        
      ch1=ch132(1:1) 
      if(ch1.eq.'n') then 
       if(ch132(2:2).eq.' ') then 
        npanum(2)=jc 
        do k=1,jc 
         npanum(2+k)=k 
        end do 
        goto 300 
       end if 
      end if 
      if(ch132(1:1).eq.'#') then 
       call fwradjust(length) 
       goto 300 
      end if 
      if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 390 
      if(ch132(1:2).eq.'he') then 
       cp132=ch132(3:npl) 
       call trlch(24,cp132,nn,out) 
       i=out(1) 
       jp=0
       do j=1,jc 
        ii=natcon(j)
        if(i.eq.ii)jp=ii
       end do
!       write(6,'(a,i4,a)')'comsub  jp,cp132=',jp,cp132(:24)            
       if(jp.gt.0) then
        chcom=TRIM(chcom)//'/'//nconwr(jp)(1:24) 
!        write(6,'(i4,a,a)')jp,'=jp comsub nconwr=',nconwr(jp)          
        chth=nconwr(jp)(25:32)
        if(chth(1:2).eq.'va') then 
         chth(1:2)='fr' 
         chcom='theory/'//chth//'/variable/'//nconwr(jp)(1:24) 
        end if 
        if(chth(2:2).eq.'o') then 
         if(chth(1:1).eq.'f')chth(1:2)='fr' 
         if(chth(1:1).eq.'t')chth(1:2)='th' 
         chcom='theory/'//chth//'/constant/'//nconwr(jp)(1:24) 
        end if 
        call help(chcom) 
       else 
        write(nwr,'(6(a,/))')                                           &
        ' input format:               value (of actual ci)',            &
        '               ni (or name)  value ',                          &
        '               ni (or name)  new constant name',               &
        '                                              ',               &
        '               #  listing of constants',                       &
        '               *  back to command level'                       
       end if 
       goto 316 
      end if 
      if(ledit.eq.1) then 
        chline='     '//nconwr(natcon(i))(1:24) 
        iline=29 
        form=nconwr(natcon(i))(33:37) 
        rn=conwr(natcon(i)) 
        call trlnu(form,rn,chr,nn,chl,im) 
        chline=chline(1:iline)//chr(1:nn) 
        iline=iline+nn 
!       analyse cp132                                                   
        jj=0 
        do k=7,iline 
         if(cp132(k:k).ne.' ') then 
          chline(k:k)=cp132(k:k) 
          jj=jj+1 
         end if 
        end do 
        cp132(1:)=chline(6:) 
        if(cp132(6:24).ne.nconwr(natcon(i))(6:24))                      &
                          nconwr(natcon(i))(6:24)=cp132(6:24)           
        cp132(1:24)=' ' 
        if(jj.eq.0) cp132(6:)=' ' 
      end if 
      call nextchar(cp132,0,ipos,ch132,ih) 
                                                                        
      if(ih.eq.0) then 
       i=i+1 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       goto 380 
      else 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
       write(nwr,'(2a)')'                                        ',     &
                        '                                        '      
       write(nwr,'(2a)')'                                        ',     &
                        '                                        '      
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
      end if 
                                                                        
                                                                        
!     character = number ?                                              
      ch1=ch132(1:1) 
      if(ch1.eq.'n') then 
       if(ch132(2:2).eq.' ') then 
        npanum(2)=jc 
        do k=1,jc 
         npanum(2+k)=k 
        end do 
        goto 300 
       end if 
       in=ichar(ch132(2:2))-i0 
       if(in.gt.0.and.in.lt.10) then 
         call trlch(ih,ch132,nn,out) 
         ii=out(1) 
         if(ii.gt.0.and.ii.le.jc) then 
          i=ii 
          call nextchar(ch132,ih,ipos,cp132,ip) 
                                                                        
          ch1=cp132(1:1) 
          if(ch1.eq.' ') goto 378 
          in=ichar(cp132(1:1))-ichar('0') 
          if(in.lt.10) then 
           cpin=cp132 
           call fout_a(cpin,chf,j) 
           ch6=chf(1)(1:3) 
           if(ch6(1:1).eq.'i') then 
             ch6(4:4)=')' 
           else 
             ch6(4:6)='.'//chf(1)(4:4)//')' 
           end if 
           l=10*(ichar(ch6(2:2))-i0)+ichar(ch6(3:3))-i0 
           call trlch(ip,cp132,nn,out) 
           if(nn.eq.1) then 
            conwr(natcon(i))=out(1) 
            nconwr(natcon(i))(33:38)=ch6 
            if(l.ne.length) call fwradjust(length) 
           end if 
          else 
           nconwr(natcon(i))(9:24)=cp132(1:ip) 
          end if 
          goto 378 
         else 
          write(nwr,'(2(a,i2),a)') ' ***error*** ',ii,                  &
                                   ' out of range 1-',jc,               &
          '                                             '               
         end if 
         i=i+1 
         goto 380 
       end if 
                                       ! ci                             
      end if 
      if(i.eq.0) i=1 
                                                                        
      in=ichar(ch1)-i0 
      if(in.ge.-6.and.in.lt.10) then 
       cpin=ch132 
       call fout_a(cpin,chf,j) 
       cn6=nconwr(natcon(i))(33:38) 
       ch6=chf(1)(1:3) 
!       write(6,'(a,2a8)')' const cn6,ch6=',cn6,ch6                     
       if(cn6(1:1).eq.'i') then 
        if(ch6(1:1).eq.'i') then 
          ch6(4:4)=')' 
          nak=0 
        else 
          ch6(4:6)='.'//chf(1)(4:4)//')' 
          nak=ichar(ch6(5:5))-i0 
        end if 
       else 
        if(ch6(1:1).eq.'i') then 
          nak=0 
          ch6=cn6 
        else 
         ch6(4:6)='.'//chf(1)(4:4)//')' 
         nak=ichar(ch6(5:5))-ichar(cn6(5:5)) 
         if(nak.lt.0)ch6=cn6 
        end if 
       end if 
       l=10*(ichar(ch6(2:2))-i0)+ichar(ch6(3:3))-i0 
       call trlch(ih+1,ch132,nn,out) 
       if(nn.eq.1) then 
        if(nak.gt.0) then 
         ch6(5:5)=chf(1)(4:4) 
         l=l+nak 
         i10=l/10 
         i1=l-10*i10 
         ch6(2:3)=char(i10+i0)//char(i1+i0) 
        end if 
        conwr(natcon(i))=out(1) 
        nconwr(natcon(i))(33:38)=ch6 
        if(l.ne.length) call fwradjust(length) 
       end if 
       goto 378 
      end if 
                                                                        
!     character .ne. number, read name                                  
      cp24=ch132(1:ih) 
                                                                        
!     identify name                                                     
      do k=1,jc 
      if(index(nconwr(natcon(k)),cp24(1:ih)).gt.0) then 
       i=k 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch1=cp132(1:1) 
       if(ch1.eq.' ') goto 378 
       in=ichar(ch1)-ichar('0') 
       if(in.lt.10) then 
         cpin=cp132 
         call fout_a(cpin,chf,j) 
         ch6=chf(1)(1:3) 
         if(ch6(1:1).eq.'i') then 
           ch6(4:4)=')' 
         else 
           ch6(4:6)='.'//chf(1)(4:4)//')' 
         end if 
         l=10*(ichar(ch6(2:2))-i0)+ichar(ch6(3:3))-i0 
         call trlch(ip,cp132,nn,out) 
         if(nn.eq.1) then 
          conwr(natcon(k))=out(1) 
          nconwr(natcon(k))(33:38)=ch6 
          if(l.ne.length) call fwradjust(length) 
         end if 
       else 
         nconwr(natcon(k))=cp132(1:ip) 
       end if 
       goto 378 
      end if 
      end do 
                                                                        
  378 ki=0 
      do k=3,npanum(mscr2+2)+2 
       if(npanum(mscr2+k).eq.natcon(i)) ki=k 
      end do 
      if(ki.eq.0) then 
        npanum(npanum(mscr2+2)+mscr2+3)=natcon(i) 
        npanum(mscr2+2)=npanum(mscr2+2)+1 
       do k=2,npanum(mscr2+2)+2 
         npanum(k)=npanum(mscr2+k) 
       end do 
       k=npanum(2)
       i=-1
       call panum(ch132,k,npanum,i) 
       if(i.ne.-1) then
        print'(2a)','error in the list:',TRIM(ch132)
        return
       end if         
       do k=2,npanum(2)+2 
         npanum(mscr2+k)=npanum(k) 
       end do 
      end if 
                                                                        
  380  npa=0 
       do k=1,npanum(mscr2+2) 
         if(natcon(i).eq.npanum(k+mscr2+2)) then 
           npa=k 
           goto 382 
         end if 
       end do 
  382 if(npa.eq.0) then 
       i=i+1 
       if(i.gt.jc) i=1 
       goto 380 
      end if 
                                                                        
      ni=natcon(i) 
!      if(ledit.eq.1)then                                               
        form='i3' 
        rn=i 
        call trlnu(form,rn,chr,nn,chl,im) 
        chline='n'//chl(1:4)//nconwr(ni)(1:24) 
        form=nconwr(ni)(33:37) 
        rn=conwr(ni) 
        call trlnu(form,rn,chr,nn,chl,im) 
        iline=29 
        chline=chline(1:iline)//'= '//chr(1:nn) 
        iline=iline+nn+2 
        call addhist(chr(1:nn)//ch0) 
!        write(nwr,'(a)') chline(1:iline)                               
!      else                                                             
       k=ni/100 
       ip=3 
       if(k.eq.0) then 
        ip=2 
        k=ni/10 
       end if 
       if(k.eq.0) ip=1 
!       write(6,'(a,a,g15.5)') ' nconwr=',nconwr(ni)                    
       fprint=formpr(ip)//nconwr(ni)(33:40) 
       if(nconwr(ni)(33:33).eq.'i') then 
        iconwrj=conwr(ni) 
        write(nwr,fprint) 'n',ni,nconwr(ni),' = ',iconwrj 
       else 
        write(nwr,fprint) 'n',ni,nconwr(ni),' = ',conwr(ni) 
       end if 
!      end if                                                           
      goto 316 
                                                                        
  390 continue 
      do i=1,n
       value(i)=conwr(i)
       name(i)=nconwr(i)
      end do 
      return 
      END                                           
                                                                        
                                                                        
      subroutine errormessage(info) 
      use glbconst, only: infotext,nwr
      use comeff, only: npl
      implicit none 
       integer, intent(in):: info
       integer l,k,kk
       character fpr*8 
       call itoc8(fpr,info) 
       l=80 
       l=LEN_TRIM(infotext(2)) 
       infotext(2)(l+1:)='  ('//TRIM(fpr)//')' 
       k=3 
       do while(infotext(k)(:80).ne.' '.and.k.lt.8) 
        k=k+1 
       end do 
       k=k-1 
       do kk=2,k 
        call history(infotext(kk)) 
        write(nwr,'(a)')infotext(kk)(:npl) 
       end do
       if(infotext(1).ne.' ') call help(infotext(1)) 
       return 
      END                                           
                                                                        
      subroutine history(ch132) 
      use glbconst, only: infotext
      use comeff, only: npl
      implicit none
      integer  info 
      character ch132*132,line*132 
                                                                        
       open(unit=1,file='history.txt'                                   &
                  ,status='old'                                         &
                  ,access='sequential'                                  &
                  ,form='formatted'                                     &
                 ,err=100)                                             
                                                                        
      read(1,'(a)',end=5) line 
      if(line(1:80).eq.infotext(8)(1:80)) infotext(1)(131:132)='99' 
      if(ch132.eq.' ') return 
    1 read(1,'(a)',end=5) line 
!       write(6,'(a)') line(1:80)                                       
       if(line.eq.' ') goto 5 
      goto 1 
    5 backspace 1 
      write(1,'(a)') ch132(:npl) 
!      write(6,'(a)') ch132(1:80)                                       
      close(unit=1) 
      return 
                                                                        
  100 continue 
      info=99 
      infotext(1)='effi/history/file/missing' 
      infotext(2)=' *** fatal error *** no history.txt file' 
      infotext(3)=' ' 
      return 
      END                                           
                                                                        
      subroutine cvdata(ks,b_const,iiq) 
      use comdas, only: n_cdata,n_vdata,i_cdata,i_vdata,b_cdata,b_vdata,   &
                        cdata,vdata
      use comscd, only: conwr,conwro,iconwr,nconwr
      implicit none 
                                                                        
      character(len=132):: chcom,chtext,ch132 
                                                                        
      logical     b_const 
      integer     ks,jc,im,ledit,k,j,i,kc,kv,nn,iiq 
      real        rn 
      character   chl*24,chr*24,form*7 
                                                                        
                                                                        
        chcom='effi/data/cvdata' 
        kc=i_cdata(ks,0) 
        kv=i_vdata(ks,0) 
!        write(6,'(a,4i4)') ' frame01 ks,kc,kv=',ks,kc,kv               
!        write(6,'(a,10L5)') ' frame01 b_cdata(ks,k)=',                 
!     &                      (b_cdata(ks,k),k=1,maxcvsp)                
!        write(6,'(a,10L5)') ' frame01 b_vdata(ks,k)=',                 
!     &                      (b_vdata(ks,k),k=1,maxcvsp)                
        j=0 
        do k=1,kc 
         if(b_cdata(ks,k)) then 
          j=j+1 
          iconwr(j)=k 
          nconwr(j)=n_cdata(ks,k) 
          i=index(nconwr(j),'~') 
          if(i.gt.0)nconwr(j)(i:i)=' ' 
          conwr(j)=cdata(ks,k) 
         end if 
        end do 
        jc=j 
        do k=1,kv 
         if(b_vdata(ks,k)) then 
          j=j+1 
          iconwr(j)=k 
          nconwr(j)=n_vdata(ks,k) 
          conwr(j)=vdata(ks,k) 
         end if 
        end do 
        if(j.eq.0) return 
        ch132=' ' 
        chtext=' ' 
        form='i2' 
        rn=j 
        call trlnu(form,rn,chr,nn,chl,im) 
        chtext=' 1 - '//chl(1:5) 
        do k=1,j 
         conwro(k)=conwr(k) 
        end do 
        ledit=0 
        if(iiq.eq.0)call conread(chtext,conwr,nconwr,j,chcom,ledit) 
        do k=1,j 
         if(conwr(k).ne.conwro(k)) then 
          if(k.le.jc) then 
           cdata(ks,iconwr(k))=conwr(k) 
           n_cdata(ks,iconwr(k))=nconwr(k) 
          else 
           vdata(ks,iconwr(k))=conwr(k) 
           n_vdata(ks,iconwr(k))=nconwr(k) 
          end if 
          b_const=.true. 
         end if 
        end do 
       return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine fwradjust(length) 
      use comscd, only: conwr,nconwr,natcon
      implicit none

      integer  length,i0,i1,i10,iadj,ic0,ic1,ic2,ic4,j,jc,k,l,lo

      character ch2*2 
                                                                        
      iadj=0 
      i0=ichar('0') 
      ic0=33 
      ic1=34 
      ic2=35 
      ic4=ic2+2 
      length=3 
      jc=1 
      do while(natcon(jc).gt.0) 
       jc=jc+1 
      end do 
      jc=jc-1 
      k=natcon(1) 
      lo=10*(ichar(nconwr(k)(ic1:ic1))-i0)+ichar(nconwr(k)(ic2:ic2))-i0 
      do j=1,jc 
       k=natcon(j) 
       i10=abs(conwr(k)) 
!       write(6,'(a,2i4,1x,a)') 'fwradjust jc,i10=',jc,i10,nconwr(k)    
       l=3 
       do while(i10.gt.1) 
        i10=i10/10 
        l=l+1 
       end do 
       if(nconwr(k)(ic0:ic0).eq.'f') then 
        l=l+ichar(nconwr(k)(ic4:ic4))-i0 
       end if 
       if(nconwr(k)(ic0:ic0).eq.'e') then 
        l=6+ichar(nconwr(k)(ic4:ic4))-i0 
       end if 
       if(l.gt.length) length=l 
       if(lo.eq.l) iadj=iadj+1 
      end do 
!      write(6,'(a,3i4)') ' iadj,n,length=',iadj,npanum(mscr2+2),length 
      if(iadj.ne.jc) then 
       i10=length/10 
       i1=length-10*i10+i0 
       ch2=char(i0+i10)//char(i1) 
       do j=1,jc 
        k=natcon(j) 
        nconwr(k)(ic1:ic2)=ch2 
       end do 
      end if 
      return 
    END subroutine fwradjust
                                                                        
      subroutine pcreadyn(jc,wrb,go) 
!     wrb=w, go=' ': user is asked for y,n, written to *.scr
!     wrb=w, go='g': user is not asked    , default (y,n) iswritten to *.scr
!     wrb=r, go=*  : only read from *.scr
        
      use glbconst, only: maxthss,maxcvsp,nrd,nwr
      use comscd, only: npanum,queryar
      use comeff, only: npl
      implicit none   
      integer, intent(in):: jc
      character(len=1),intent(in):: wrb,go    
      character(len=132) :: chcom,ch132,cp132,chin
      logical   b_cvsplimit,b_hash 
                                                                        
      real      out(32) 
      character form10*16,chbold*4,chcol*5,chnorm*5,ch1*1,ch2*2       
      character(len=18),dimension(1:2) :: formpr 
      integer   i,i0,i1,i2,ii,ikc,iko,iout,ip,isumlimit,j,jblank,       &
                jchange,jline,jp,k,nn
      integer   inum(jc)
      
      formpr(1)='(a5,a,i1,2x,a75)' 
      formpr(2)='(a5,a,i2,1x,a75)' 
      chbold=char(27)//'[1m' 
      chcol=char(27)//'[34m' 
      chnorm=char(27)//'[0m' 
      i0=ichar('0') 

      inum=0 
      if(jc.eq.0) goto 390 
!      write(6,'(a,/,a)') 'comsub   queryar(1)=',queryar(1)(:80)        
!      write(6,'(a,/,a)') 'comsub   queryar(1)=',queryar(1)(81:)        
      iko=index(queryar(1)(:16),'(') 
      ikc=index(queryar(1)(:16),')') 
!      write(6,'(a,2i4)') 'comsub iko,ikc=',iko,ikc                     
                                                                        
      if(ikc-iko.ge.2)then 
       chin=queryar(1)(iko:ikc) 
       call trlch(npl,chin,iout,out) 
       b_cvsplimit=.false. 
       if(iout.eq.1) b_cvsplimit=.true. 
!       write(6,'(a,2i4)') 'comsub iout,out(1)=',iout,int(out(1))       
       isumlimit=0 
       if( b_cvsplimit) then 
        do j=1,jc 
         ikc=index(queryar(j)(:16),')') 
         iko=index(queryar(j)(:16),'(') 
         if(iko.gt.0.and.ikc.gt.iko)then 
          chin=queryar(j)(iko:ikc) 
          call trlch(npl,chin,iout,out) 
          isumlimit=isumlimit+out(1) 
          inum(j)=out(1) 
         else 
          inum(j)=0 
         end if 
!         write(6,'(a,3i4)') 'comsub isum=',inum(j)                     
        end do 
       end if 
!       write(6,'(a,2i4)')'comsub isumlimit,maxcvsp=',isumlimit,maxcvsp 
       if(isumlimit.lt.maxcvsp) b_cvsplimit=.false. 
      end if 
     
      if(wrb.eq.'r') then 
       do j=1,jc 
        read(10,'(a)') cp132                 !  28.05.07
        i=120 
        do while(cp132(i:i).ne.']'.and.i.gt.1) 
         i=i-1 
        end do 
        i=i-1 
!        i=index(cp132,']')-1                                           
        if(i.gt.0)queryar(j)(74:74)=cp132(i:i) 
        k=j/10 
        ip=2 
        if(k.eq.0) ip=1 
        write(nwr,formpr(ip))  chnorm,'l',j,queryar(j)(:75) 
       end do 
       return 
      end if 

      if(go.eq.'i') goto 380
                                                                        
      jblank=0 
      if(jc.eq.1)jblank=1 
      jline=1 
  300 continue 

!      write(6,'(a,i4)')'comsub pcreadyn after 300'                     
      b_hash=.true. 
      do j=1,jc 
       b_hash=b_hash.and.queryar(j)(74:74).eq.'#' 
       k=j/10 
       ip=2 
       if(k.eq.0) ip=1 
       if(j.eq.jline) then 
        write(nwr,formpr(ip))  chcol,' l',j,queryar(j)(:75) 
       else 
        write(nwr,formpr(ip))  chnorm, 'l',j,queryar(j)(:75) 
       end if 
      end do 

    
      read(nrd,'(a)') cp132 
      write(nwr,'(a4,1x,a1,a3)')  chnorm,char(27),'[2A' 
      write(nwr,'(2a)')'                                        ',      &
                        '                                        '      
      ch1=cp132(1:1) 
                                                                        
      if(cp132(1:2).eq.'he') then 
       ch132=cp132(3:npl) 
       call trlch(24,ch132,nn,out) 
       jp=out(1) 
!       write(6,'(a,i4,a)')'comsub jp,cp132=',jp,cp132(:24)             
       if(jp.gt.0.and.jp.le.jc) then 
        i=90 
        do while(queryar(jp)(i:i).ne.'/') 
         i=i+1 
        end do 
        chcom='theory/'//queryar(jp)(81:88)//queryar(jp)(i:) 
!        write(6,'(a)')trim(queryar(jp)),  &
!             queryar(jp)(81:88),TRIM(queryar(jp)(i:)) 
       else 
        i=130 
        do while(queryar(1)(i:i).ne.'/') 
         i=i-1 
        end do 
        chcom='effi/'//queryar(1)(90:i-1) 
       end if 
       call help(chcom) 
       goto 300 
      end if 
       jchange=0 
                                                                        
       if(ch1.eq.'y'.or.ch1.eq.'n'.or.ch1.eq.'r'                        &
                    .or.ch1.eq.'#'.or.ch1.eq.'d')then                   
                                                                        
        queryar(jline)(74:74)=ch1 
        jline=jline+1 
        jchange=1 
       else 
        do k=1,80 
         if(cp132(k:k).eq.'l') cp132(k:k)=' ' 
        end do 
        chin=cp132 
!       capital Y/N changes all members to y/n                          
        if(ch1.eq.'Y'.or.ch1.eq.'N')chin='a' 
                                                                        
        k=jc 
        i=1
        call panum(chin,k,npanum,i) 
        if(i.ne.1) then
         print'(2a)','error in the list:',TRIM(chin)
         return
        end if         
!       write(6,'(a,2x,8i4)') cp132(1:30),(npanum(i),i=1,8)             
                                                                        
        if(npanum(2).gt.0) then 
         jchange=1 
         do k=1,npanum(2) 
          ii=npanum(2+k) 
          if(ii.gt.0.and.ii.le.jc) then 
           i=ii 
           jline=i 
           if(ch1.eq.'Y') then 
            queryar(i)(74:74)='y' 
            jchange=1 
           else if(ch1.eq.'N') then 
            queryar(i)(74:74)='n' 
            jchange=1 
           else 
            ch1=queryar(i)(74:74) 
            if(ch1.eq.'n') queryar(i)(74:74)='y' 
            if(ch1.eq.'y') queryar(i)(74:74)='n' 
           end if 
          else 
           write(nwr,'(2(a,i2),a)') ' ***error*** ',ii,                 &
                                   ' out of range 1-',jc,               &
           '                                             '               
          end if 
         end do 
        end if
       end if 
                                                                        
       if(ch1.eq.' '.or.ch1.eq.'0') then 
        jchange=1 
        jline=jline+1 
        if(jline.eq.jc)jblank=jblank+1 
        if(jblank.gt.1.and.jline.eq.jc+1)ch1='q' 
       end if 
       if(ch1.eq.'q'.or.ch1.eq.'*')jchange=0
       if(jchange.eq.1) then 
        if(jc.lt.8) then 
         ch1=char(i0+jc+2) 
         write(nwr,'(1x,a1,a3)') char(27),'['//ch1//'A' 
        else 
         i1=(jc+2)/10 
         i2=jc+2-10*i1 
         ch2=char(i1+i0)//char(i2+i0) 
         write(nwr,'(1x,a1,a4)') char(27),'['//ch2//'A' 
        end if 
        if(jline.eq.jc+1.or.jline.eq.0) then 
         jblank=jblank+1 
         jline=1 
        end if 
        goto 300 
                                        ! ci                            
       end if 
!      write(6,'(a,i4)')'comsub jchange=',jchange                       
                                                                        
                                                                        
 380  if(b_cvsplimit) then 
       i=0 
       do j=1,jc 
        if(queryar(j)(74:74).eq.'n')i=i+inum(j) 
       end do 
                                                                        
       if(i.gt.maxcvsp) then 
        write(nwr,'(a3,i2,2a,/,a,/,a,i2,a,/)')                          &
         ' n=',maxcvsp,' is the size of the buffer',                    &
         ' for constants/parameters read from the data file',           &
         ' (to be inserted in the constant/parameter list);',           &
         ' with the default answers [n] a too alarge number=',i,        &
         ' has been selected'                                           
         goto 300 
       end if 
      end if 
                                                                        
!      do jline=1,jc                                                    
!       if(queryar(jline)(74:74).eq.'d') then                           
!        queryar(jline)(74:74)='#'                                      
!        queryar(jline)(73:73)='d'                                      
!       end if                                                          
!      end do                                                           
                                                                        
  390 continue 
!      write(6,'(a1,a,i4)')wrb,'=wrb comsub pcreadyn before return'     
      if(wrb.eq.'w')then 
       do j=1,jc 
        k=j/10 
        ip=2 
        if(k.eq.0) ip=1 
        form10='('//formpr(ip)(5:) 
!        if(queryar(j)(73:73).eq.'d') then            !                 
!         queryar(jline)(74:74)='d'                                     
!         queryar(jline)(73:7)='['                                      
!        end if                                                         
        write(10,form10) 'l',j,queryar(j)(:75) 
       end do 
      end if
      return 
    END subroutine pcreadyn
                                                                        
                                                                        
      subroutine readyn(chin,jl) 
      use glbconst, only: nrd,nwr
      use compar, only: nwrwin
      use comscd, only: npanum,queryar
      implicit none                                                                         
                                                                        
      character(len=132) :: chcom,chin,cp132 
      character(len=18),dimension(1:2) :: formpr 
      character  ch1*1,ch2*2,chbold*4,chcol*5,chnorm*5 

      integer    jl,i,i0,i1,i2,ib,ii,iiq,ip,j,jchange,jline,k 
                                                                        
                                                                        
      chbold=char(27)//'[1m' 
      chcol=char(27)//'[34m' 
      chnorm=char(27)//'[0m' 
      formpr(1)='(a5,a,i1,2x,a75)' 
      formpr(2)='(a5,a,i2,1x,a75)' 
      i0=ichar('0') 
      if(jl.eq.0) goto 390 
      ib=1 
      cp132=chin(4:) 
      if(cp132.eq.' ') ib=0 
      iiq=index(cp132,' q') 
      i0=ichar('0') 
      jline=1 
  300 continue 
      if(queryar(1)(1:1).eq.'l')then 
       queryar(1)(1:1)=' ' 
       ib=2 
      end if 
      do j=1,jl 
       k=j/10 
       ip=2 
       if(k.eq.0) ip=1 
       if(j.eq.jline) then 
        write(nwrwin,formpr(ip))  chcol,' l',j,queryar(j)(:75) 
       else 
        write(nwrwin,formpr(ip))  chnorm,'l',j,queryar(j)(:75) 
       end if 
      end do 
      if(nwr.ne.nwrwin)write(nwrwin,'(a)')'-' 
      if(ib.eq.2) then 
       goto 390 
      end if 
      if(ib.eq.0.and.nwr.eq.nwrwin) then 
       if(iiq.eq.0) then 
        read(nrd,'(a)') cp132 
       else 
        cp132=' ' 
        write(nwr,'(a)') 
       end if 
       write(nwr,'(a5,1x,a1,a3)') chnorm,char(27),'[2A' 
       write(nwr,'(2a)')'                                        ',     &
                       '                                        '      
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
                                                                        
      else 
       ib=2 
      end if 
      call lc_character(cp132)
      cp132=ADJUSTL(cp132)
      ch1=cp132(1:1) 
                                                                        
      if(cp132(1:2).eq.'he') then 
       chcom='effi/window/output' 
       call help(chcom) 
       goto 300 
      end if 
      if(ch1.eq.' '.and.jline.lt.jl)ch1=queryar(jline)(74:74) 
       jchange=0 
       if(ch1.eq.'y'.or.ch1.eq.'n') then 
        queryar(jline)(74:74)=ch1 
        jline=jline+1 
        jchange=1 
       else 
        do k=1,80 
         if(cp132(k:k).eq.'l') cp132(k:k)=' ' 
        end do 
                                                                        
        chin=cp132 
                                                                        
        i=1
        call panum(chin,jl,npanum,i) 
        if(i.ne.1) then
         print'(2a)','error in the list:',TRIM(chin)
         return
        end if         
!       write(6,'(a,8i4)') 'pcread npanum=',(npanum(i),i=1,8)           
                                                                        
        if(npanum(2).gt.0) then 
         jchange=1 
         do k=1,npanum(2) 
          ii=npanum(2+k) 
          if(ii.gt.0.and.ii.le.jl) then 
           i=ii 
           ch1=queryar(i)(74:74) 
           if(ch1.eq.'n') queryar(i)(74:74)='y' 
           if(ch1.eq.'y') queryar(i)(74:74)='n' 
           if(ch1.eq.'d') queryar(i)(74:74)='d' 
          else 
           write(nwr,'(2(a,i2),a)') ' ***error*** ',ii,                 &
                                   ' out of range 1-',jl,               &
         '                                             '               
          end if 
         end do 
        end if 
       end if 
                                                                        
       if(jchange.eq.1.and.nwr.eq.nwrwin) then 
        if(jl.lt.8) then 
         ch1=char(i0+jl+1) 
         write(nwr,'(1x,a1,a3)') char(27),'['//ch1//'A' 
        else 
         i1=(jl+2)/10 
         i2=jl+2-10*i1 
         ch2=char(i1+i0)//char(i2+i0) 
         write(nwr,'(1x,a1,a3)') char(27),'['//ch2//'A' 
        end if 
        if(jline.eq.jl+1) jline=1 
        ib=0 
        goto 300 
       end if ! ci 
                                                                        
  390 continue 
      return 

    END subroutine readyn
                                                                        
                                                                        
      subroutine remove(ks,lq,info) 
      use glbconst, only: maxthss
      use compar, only: ncolwin
      use comdas, only: ktheo,istrss
      use comscd, only: queryar,helpar,ext
      use comeff, only: npl
      implicit none 

      integer, intent(in)   :: ks
      integer, intent(inout):: lq
      integer, intent(out)  :: info

                                                                        
      character(len=132):: chstring,property,name_theo,chin
      character(len=80) :: chdf
      character(len=4)  :: chnorm
      character(len=1)  :: ch1

      integer:: nclw,i0,iA,ja,                          & 
                i,ii,i1,i2,jj,lth,nth,nthar,lk,k,kss        

      info=0
      i0=ichar('0') 
      iA=ichar('A')-10 
      ja=ichar('a')-36 
      nclw=ncolwin 
      if(nclw.gt.132)nclw=132 
                                                                        
      chnorm=char(27)//'[0m' 
      do k=1,npl 
       chstring(k:k)='-' 
      end do 
      i=0 
        do kss=1,maxthss 
         nthar=abs(ktheo(ks,kss,0)) 
         if(nthar.gt.0) then 
!          if(istrss(ks,kss).ne.0) then                              
           ii=1 
           jj=istrss(ks,kss) 
           if(jj.lt.0)ii=0 
           if(ii.gt.0)i=i+1 
           nth=ktheo(ks,kss,1) 
           lth=ktheo(ks,kss,2) 
           call getname(ii,nth,lth,property,name_theo) 
           if(ii.gt.0) then 
            ch1=char(i0+i) 
            if(i.gt.9)ch1=char(iA+i) 
            if(i.gt.35)ch1=char(ja+i) 
            queryar(kss)='component  '//ch1//') '//TRIM(name_theo) 
!            write(6,'(9x,a,i2,a2,a,a2,2i3,a1)')                 &
!             'component ',i,') ',TRIM(name_theo),' (',nth,lth,')'    
           else 
            if(jj.lt.-100) then 
             i1=-jj/100 
             i2=-jj-100*i1 
            else 
             i1=-jj/10 
             i2=-jj-10*i1 
            end if 
            if(i2.eq.0) then 
             queryar(kss)=                                           &
             'device '//char(i1+i0)//' of '//TRIM(name_theo)          
!             write(6,'(5x,a,i1,a,a,a2,2i3,a1)')                     
!            'device ',i1,' of ',TRIM(name_theo),' (',nth,lth,')'    
            else 
!             write(6,'(7x,a,i2)')                                   
             ch1=char(i0+i2) 
             if(i2.gt.9)ch1=char(iA+i2) 
             if(i2.gt.35)ch1=char(ja+i2) 
             queryar(kss)='module '//ch1 
            end if 
           end if 
!            write(nwrwin,'(10x,a,/,5x,a)')                          
!                          property(:lp),name_theo(:lt)              
            queryar(kss+1)=' ' 
            lq=kss 
            end if 
           end do 
                                                                        
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf='device' 
       chdf(80:80)='#' 
       chin='select component or empty module - device' 
       do k=1,lq 
        helpar(k)='effi/remove/'//queryar(k)(:6) 
       end do 
                                                                        
       call query(lq,lk,chin,chdf) 
       if(lq.eq.0) then 
         goto 10 
       else 
        if(index(queryar(lq),'device').gt.0)lq=-lq 
       end if 
                                                                        
   10  return 

     END subroutine remove

  subroutine decide(topic,n,inquiry,help_entries,l)
  use comscd, only: helpar,queryar,ext
  implicit none
  character(len=80),dimension(n)::inquiry,help_entries
  character(len=80):: topic,chdf
  character(len=132):: chin
  integer n,l,lk,i
       lk=n
       l=n 
      chdf=inquiry(1)(1:4) 
      chdf(80:80)='#' 
      do i=1,n
       ext(i)=' '
       helpar(i)=help_entries(i)
       queryar(i)=inquiry(i)
      end do
      chin=topic
      call query(l,lk,chin,chdf) 
  return
  end
