      character(len=6) function chentry(n,l)
      implicit none
      integer n,l,i0,i1,i10
      i0=ichar('0') 
      i10=n/10 
      i1=n-10*i10 
      chentry(1:2)=char(i10+i0)//char(i1+i0) 
      i10=l/10 
      i1=l-10*i10 
      chentry(3:6)=char(i10+i0)//char(i1+i0)//'  ' 
      return
      end

       subroutine chcenter(ch,ch1,ncol) 
       implicit none
       integer ncol,l,ncl,k,i
       character(len=132):: ch
       character(len=1)  :: ch1
        l=LEN_TRIM(ch) 
        ncl=ncol 
        if(ncl.gt.132)ncl=132 
        i=(ncl-l)/2 
        if(i.lt.2)i=2 
        if(l+i.gt.132)l=132-i
        do k=l,1,-1 
         ch(i+k:i+k)=ch(k:k) 
        end do 
        do k=1,i 
         ch(k:k)=ch1 
        end do 
        k=i+l+1 
        do while(k.le.ncl) 
         ch(k:k)=ch1 
         k=k+1 
        end do 
        return 
      END                                           
                                                                        
      subroutine trlnu(formatch,rn,chr,nn,chl,im) 
      implicit none
      real rn,z,e10
      integer nn,im                                                           
!     M. Alflen  13.9.89, H. Spiering Mai 1995                          
                                                                        
!     translates number rn to characters of given format written on ch  
!     inn,     integer                                                  
!     fnn.mm   real f - format                                          
!     enn.mm   real e - format                                          
!     ann.mm   real allplo format = e-format 10**k                      
!     sign is printed for a leading '+' (+i, +f, +e, and +ann.mm)       
                                                                       
      integer, dimension(-2:32):: ii 
      character(len=7):: formatch
      character(len=24):: chr,chl
      character(len=32):: chf
      character(len=4) :: chexp
      character(len=1) :: fch
      logical bi,bf,be,ba 
      integer i,ij,iueb,i0,ip,k,mm,ipex,iex,ibex,iep,j,jex,k10 

      z=0.
      e10=1.0e9
      if(abs(rn).gt.e10)formatch='e15.5  '  
      bi=.false. 
      bf=.false. 
      be=.false. 
      ba=.false. 
      chf=' ' 
      chl=' ' 
      chr=' ' 
      z=rn      
!     analyse formatch                                                  
      i0=ichar('0') 
      ip=0 
      do k=1,7 
       if(formatch(k:k).ne.' ') goto 10 
      end do 
   10 nn=0 
      mm=0 
      if(formatch(k:k).eq.'+') ip=1 
       k=k+ip 
       fch=formatch(k:k) 
       k=k+1 
      nn=ichar(formatch(k:k))-i0 
       k=k+1 
      if(formatch(k:k).eq.' '.or.k.gt.7) goto 20 
      if(formatch(k:k).ne.'.') then 
        nn=10*nn+ichar(formatch(k:k))-i0 
        k=k+1 
      end if 
      if(formatch(k:k).eq.'.') then 
       k=k+1 
       mm=ichar(formatch(k:k))-i0 
       k=k+1 
       if(k.gt.7) goto 20 
       if(formatch(k:k).ne.' ') then 
        mm=10*mm+ichar(formatch(k:k))-i0 
       end if 
      end if 
   20 continue 
      if(nn.gt.24) then 
       chl='************************' 
       chr='************************' 
       return 
      end if 
                                                                        
      if(fch.eq.'i'.or.fch.eq.'I') bi=.true. 
      if(fch.eq.'f'.or.fch.eq.'F') bf=.true. 
      if(fch.eq.'e'.or.fch.eq.'E') be=.true. 
      if(fch.eq.'a'.or.fch.eq.'A') ba=.true. 
                                                                        
      ipex=ip 
      j=0 
      if(z.lt.0.0) then 
        z=-z 
        chf(1:1)='-' 
        j=1 
        ip=1 
      else 
       if(ip.eq.1) then 
        chf(1:1)='+' 
        j=1 
       end if 
      end if 
                                                                        
      if(z.eq.0.) then 
       iex=0 
      else 
       iex=int(log10(z)+0.00001) 
      end if 
      if(iex.lt.-15)iex=-15 
      if(iex.gt.15)iex=15 
!       write(6,'(a,i3,2x,g15.6)')' iex,z=',iex,z                       
      if(z.lt.1.0) iex=iex-1 
      e10=10.**iex 
                                                                        
      if(bi) im=iex 
      if(bf)  im=mm+iex 
      if(im.lt.0) im=-1 
      if(be.or.ba) im=mm 
                                                                        
       ii(-1)=0 
       do k=0,im+1 
        i=int(z/e10+0.000001)
        if(i.eq.10)i=9 
        z=z-e10*float(i) 
        e10=e10/10. 
        ii(k)=i 
       end do 
       if(ii(im+1).gt.5) then 
        ii(im)=ii(im)+1 
        do k=im,0,-1 
         if(ii(k).gt.9) then 
          ii(k-1)=ii(k-1)+1 
          ii(k)=0 
         end if 
        end do 
       end if 
       iueb=0 
       if(ii(-1).gt.0) then 
        iueb=-1 
        if(be.or.ba) iex=iex+1 
        if(bi.or.bf) ip=ip+1 
       end if 
!       write(6,'(a,10i3)')' trlnu ii=',(ii(k),k=-1,9)                  
                                                                        
!     e-formatch and allplo-formatch                                    
      if(be.or.ba) then 
      jex=0 
      chexp=' ' 
      if(iex.lt.0) then 
        ibex=-iex 
        chexp(1:1)='-' 
        jex=1 
      else 
       ibex=iex 
       if(ipex.eq.1) then 
        chexp(1:1)='+' 
        jex=1 
       end if 
      end if 
      if(ibex.eq.0) then 
       ij=0 
      else 
       ij=int(log10(float(ibex))) 
      end if 
       do k=ij,0,-1 
        k10=10**k 
        i=int(ibex/k10) 
        jex=jex+1 
        chexp(jex:jex)=char(i+i0) 
        ibex=ibex-k10*i 
       end do 
                                                                        
       do k=iueb,mm 
        j=j+1 
        chf(j:j)=char(ii(k)+i0) 
       end do 
                                                                        
       im=ip+1+mm 
       if(mm.eq.0) then 
         chl=chf(1:ip+1)//'.' 
       else 
         chl=chf(1:ip+1)//'.'//chf(ip+2:im) 
       end if 
       if(be) then 
        chl=chl(1:im+1)//fch//chexp(1:jex) 
        im=im+2+jex 
       else 
        chl=chl(1:im+1)//'*10$^'//chexp(1:jex)//'$ ' 
        im=im+8+jex 
       end if 
       goto 100 
      end if 
                                                                        
!     i-formatch                                                        
      if(bi) then 
       if(iex.ge.iueb) then 
        do k=iueb,iex 
         j=j+1 
         chf(j:j)=char(ii(k)+i0) 
        end do 
         chl(1:j)=chf(1:j) 
        im=iex+ip+1 
       else 
        im=nn 
        chl(nn:nn)='0' 
       end if 
       goto 100 
      end if 
                                                                        
!     f-formatch                                                        
      if(bf) then 
       if(iex.ge.0) then 
        do k=iueb,mm+iex 
         j=j+1 
         chf(j:j)=char(ii(k)+i0) 
        end do 
        iep=iex+ip+1 
        im=iep+1+mm 
        chl=chf(1:iep)//'.'//chf(iep+1:im) 
       else 
        do k=1,iueb-iex 
         j=j+1 
         chf(j:j)='0' 
        end do 
        do k=iueb,mm+iex 
         j=j+1 
         chf(j:j)=char(ii(k)+i0) 
        end do 
        im=ip+1+mm 
        if(iueb.eq.-1) then 
         ip=ip-1 
        else 
         im=im+1 
        end if 
        if(mm.eq.0) then 
          chl=chf(1:ip+1)//'.' 
        else 
          chl=chf(1:ip+1)//'.'//chf(ip+2:im) 
        end if 
       end if 
      end if 
                                                                        
  100 continue 
       k=nn-im 
       if(k.lt.0) then 
         chr='***'//chl(1:im)//'***' 
         chl='***'//chl(1:im)//'***' 
       else 
         chr(k+1:nn)=chl(1:im) 
       end if 
!      write(6,'(4a)')'trlnu chr=',chr,'...chl=',chl                    
                                                                        
      return 
      END                                           
                                                                        
      subroutine itoc8(ch,nn)
      implicit none
!     H. Spiering 1.2000                                                
!     translates integer n to characters written on ch                  
      integer nn,n,m,i,im,i10,i0,k 
      character ch*8 
      ch=' ' 
      n=nn 
      i0=ichar('0') 
      ch=' ' 
      m=n 
      im=0 
      do while(m.ne.0) 
       m=m/10 
       im=im+1 
      end do 
      i10=10**(im-1) 
      if(n.lt.0) then 
       ch(1:1)='-' 
       n=-n 
      end if
      if(im.gt.7)then
       im=7
       print '(a)','integer more than 8 digits - cut'
      end if
      do k=2,im+1 
       i=n/i10 
       n=n-i10*i 
       i10=i10/10 
       ch(k:k)=char(i+i0) 
      end do 
                                                                        
      return 
      END                                           
                                                                        
      subroutine c8toi(ch,n) 
      implicit none
!     H. Spiering 12.2009                                               
!     translates character of integer n to integer
      character ch*8 
      integer n,ich(8),i0,iv,k 
      i0=ichar('0') 
      do k=1,8 
       ich(k)=ichar(ch(k:k))-i0 
      end do 
      do k=1,8 
       if(ich(k).ge.0.and.ich(k).le.9) goto 10 
      end do 
   10 k=k-1 
!      write(6,'(2a,i4)')' comtool k,ch=',ch,k                          
      iv=1 
      if(k.gt.0) then 
       if(ich(k).eq.-3) iv=-1 
      end if 
      k=k+1 
      n=0 
                                               !                        
      do while(k.le.8) 
       if(ich(k).ge.0.and.ich(k).le.9) n=n*10+ich(k) 
       k=k+1 
      end do 
      n=n*iv 
!     write(6,'(a,a8,2x,i5)')' ch,n=',ch,n                              
      return 
      END                                           
                                                                        
      character*2 function ci2(i) 
      implicit none
      integer i,i0,i1,i10 
       i0=ichar('0') 
       i10=i/10 
       i1=i-10*i10 
       ci2=char(i10+i0)//char(i1+i0) 
      return 
      END 
                                          
      integer function ic2(c2) 
      implicit none
      integer i0,i1,i10 
      character*2 c2 
       i0=ichar('0') 
       i10=ichar(c2(1:1))-i0 
       i1=ichar(c2(2:2))-i0 
       ic2=10*i10+i1 
      return 
      END                                           
                                                                        
      subroutine trlch(n_ch,chin,iout,out) 
      implicit none

      character(len=132):: chin,ch
      real out,pt 
      dimension out(32) 
      integer nch,n_ch,i,ic,i0,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given as ch*13
!     to iout real numbers (max.32) stored in the vector out.           
!     nch characters of ch(1:nch) are analysed.                         
      nch=n_ch 
      if(nch.gt.132) nch=132 
      ch=chin 
      i0=ichar('0') 
      nsig=1 
      pt=1. 
      k1=0 
      k2=0 
      nex=0 
      nnum=0 
      iout=0 
      do k=1,32 
       out(k)=0. 
      end do 
                                                                        
      k=0 
   10 k=k+1 
      i=ichar(ch(k:k))-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.nch) goto 50 
       goto 100 
      end if 
                                                                        
      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(ch(i:i).eq.'.') then 
         nex=-1 
         goto 50 
        end if 
        ic=ichar(ch(i:i))-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (ch(k:k).eq.'.') then 
        pt =0.1 
        goto 100 
      end if 
      if(ch(k:k).eq.'-') then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60
      if(out(iout+1).lt.-30) then
!print*,iout, out(iout), out(iout+1)
       out(iout)=0.0
      else   
       out(iout)=out(iout)*10.**out(iout+1)
      end if
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.32) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.nch) goto 10 
  110 return 
      END                                           
                                                                        
      subroutine lc_character(ch)
      implicit none 
      character(len=132):: ch 
      integer i,l,in
       l=LEN_TRIM(ch) 
       do i=1,l 
        in=ichar(ch(i:i)) 
        if(in.lt.91.and.in.gt.64) in=in+32 
        ch(i:i)=char(in) 
       end do 
      return 
      END                                           
                                                                        
       subroutine nextchar(chl,il,ip,cha,ia) 
       implicit none 
       character(len=132):: chl,cha
       character(len=1)  :: ch0 
       integer    i,il,ip,ia,j,k,kj,npl 
       ch0=char(0)                                                                 
       if(il.gt.130)il=130 
       do k=131,il+1,-1 
        if(chl(k:k).ne.' '.and.chl(k:k).ne.ch0) goto 5 
       end do 
    5  npl=k+1 
!       write(6,'(2i4,2a)') il,npl,' nextchar chl=',chl(1:20)           
                                                                        
       cha=' ' 
       if(il.gt.0) then 
        do k=il+1,npl 
          if(chl(k:k).eq.' '.or.chl(k:k).eq.',') then 
          i=k 
          goto 10 
          end if 
        end do 
        i=npl 
   10   continue 
       else 
         i=1 
       end if 
!       write(6,'(3i3,2a)') il,npl,i,' nextchar chl=',chl(1:20)         
                                                                        
       j=npl 
       do k=i,npl 
        if(chl(k:k).ne.' '.and.chl(k:k).ne.',') then 
         j=k 
         goto 20 
        end if 
       end do 
   20  continue 
       ip=k 
                                                                        
       do k=j,npl 
        kj=k-j+1 
        cha(kj:kj)=chl(k:k) 
       end do 
!    the first character is stripped, cha starts with the second symbol 
!       write(6,'(i3,2a)') j,' nextchar cha=',cha(1:20)                 
       ia=npl-1 
       do k=1,npl 
        if(cha(k:k).eq.' '.or.cha(k:k).eq.',') then 
         ia=k-1 
         goto 30 
        end if 
       end do 
   30  return 
      END                                           
                                                                        

      integer function ntrimto0(ch)
      implicit none 
      character(len=132), intent(inout):: ch
      integer   i,k,j
      character(len=1), parameter:: ch0=char(0)

      if(ch.eq.' '.or.ch(1:1).eq.ch0) then 
       ntrimto0=0 
       return 
      end if 
      do k=1,131 
       if(ch(k:k).ne.' ') goto 10 
      end do 
   10 j=index(ch,ch0)
      if(j.eq.0)then
       do j=131,k,-1
        if(ch(j:j).ne.' ') goto 20 
       end do 
   20  continue
      else
       j=j-1
      end if
      ntrimto0=j-k+1 
      j=k-1 
      do i=1,ntrimto0 
       ch(i:i)=ch(j+i:j+i) 
      end do
      ch(ntrimto0+1:)=' ' 
      return 
      END                                 

      subroutine fout_a(ch132,chf,n) 
      implicit none 
      integer n,i0,i1,i10,ie,ink,ip,ml,k,l,l24,m
      character(len=132):: ch132
      character(len=24) :: ch24
      character(len=4)  :: chfh 
      character(len=4),dimension(1:32) :: chf  
      n=0 
      i0=ichar('0') 
      if(ch132.ne.' ') then 
       ml=132 
       do while(ch132(ml:ml).eq.' ') 
        ml=ml-1 
       end do 
       do k=1,ml 
        if(ch132(k:k).eq.','.or.ch132(k:k).eq.'y'                       &
                       .or.ch132(k:k).eq.'n') ch132(k:k)=' '           
       end do 
      else 
       ml=0 
      end if 
!      write(6,'(2a)') 'fout_a:',ch132(:ml)                             
                                                                        
  100 if(ml.le.0) goto 1000 
      l=1 
      do while(ch132(l:l).eq.' '.and.l.le.ml) 
       l=l+1 
      end do 
                                                                        
!      write(6,'(a,i03,f05.1,4x,a)') ' L100 ',l,float(ml),ch132(l:ml)   
      if(l.le.ml) then 
       n=n+1 
       m=l+1 
       do while(ch132(m:m).ne.' '.and.m.le.ml) 
        m=m+1 
       end do 

       m=m-1       ! l-m 
       ch24=ch132(l:m) 
!       write(6,'(a,2i3,4x,a24)') 'l,m,ch24=',l,m,ch24                  
       ml=ml-m 
       if(ml.gt.0) then 
        do k=1,ml 
         ch132(k:k)=ch132(k+m:k+m) 
        end do 
!       write(6,'(2a)') 'ch132(:ml)=',ch132(:ml)                        
       end if 
                                                                        
       l24=m-l+1 
       ip=index(ch24,'.') 
       if(ip.gt.0) then 
        ip=ip-1 
        ie=index(ch24,'e')+index(ch24,'E') 
        if(ie.gt.0) then 
!        exponent                                                       
         chfh(1:2)='e0' 
         l24=l24+2 
         ink=ie-ip-2 
        else 
         chfh(1:2)='f0' 
         ink=l24-ip-1 
        end if 
        if(l24.lt.10) then 
         chfh(3:3)=char(i0+l24) 
        else 
         i10=l24/10 
         i1=l24-10*i10+i0 
         chfh(2:3)=char(i0+i10)//char(i1) 
        end if 
        chfh(4:4)=char(i0+ink) 
        if(chfh(1:1).eq.'e'.and.chfh(4:4).eq.'0')chfh(4:4)='1'
       else 
         chfh(1:2)='i0' 
         l24=l24 
         if(l24.lt.10) then 
          chfh(3:3)=char(i0+l24) 
         else 
          i10=l24/10 
          i1=l24-10*i10+i0 
          chfh(2:3)=char(i0+i10)//char(i1) 
         end if 
         chfh(4:4)=' ' 
        end if  ! ip=0  
       else 
        goto 1000 
       end if 
       chf(n)=chfh 
!       write(6,'(a,5i3,4x,a24,2x,a4)')                                 
!     &            'l,m,ip,ie,ink,ch24=',l,m,ip,ie,ch24,chfh            
       goto 100 
 1000  continue 
       return 
      END                                           
                                                                        
      subroutine fout_c(ch132,chfmt,j) 
      implicit none 
      integer i0,i1,i10,ie,ink,ip,j,j1,k,l24,m,n,ml,l
      character(len=132):: ch132,chfmt
      character(len=24) :: ch24
      character(len=5)  :: chfh 
      character(len=5),dimension(1:16):: chf
                                                                        
      n=0 
      i0=ichar('0') 
      if(ch132.eq.' ') then 
       ml=4 
       ch132='0.0' 
      else 
       ml=132 
      end if 
      do while(ch132(ml:ml).eq.' ') 
       ml=ml-1 
      end do 
      do k=1,ml 
       if(ch132(k:k).eq.',') ch132(k:k)=' ' 
      end do 

!      write(6,'(2a)') 'fout_c:',ch132(:ml)                             
      k=2
      do while(k.le.ml) 
       k=k+1
       if(ch132(k:k).eq.'-')then
        if(ch132(k-1:k-1).ne.' '.and.ch132(k-1:k-1).ne.'E'   &
                                .and.ch132(k-1:k-1).ne.'e')then
        do j=ml,k+1,-1
         ch132(j+1:j+1)=ch132(j:j)
        end do
        ch132(k:k+1)=' -'
        k=k+2
        ml=ml+1
       end if 
       end if
      end do 
      
!      write(6,'(2a)') 'fout_c:',ch132(:ml)                             
                                                                        
  100 if(ml.le.0) goto 1000 
      l=1 
!      write(6,'(a,2i3,4x,a)') ' L100 ',l,ml                            
      do while(ch132(l:l).eq.' '.and.l.le.ml) 
       l=l+1 
      end do 
                                                                        
!      write(6,'(a,2i3,4x,a)') ' L100 ',l,ml,ch132(l:ml)                
      if(l.le.ml) then 
       n=n+1 
       chfh=' ' 
       m=l+1 
       do while(ch132(m:m).ne.' '.and.m.le.ml) 
        m=m+1 
       end do 
                   ! l-m                                                
       m=m-1 
       ch24=ch132(l:m) 
!       write(6,'(a,2i3,4x,a24)') 'l,m,ch24=',l,m,ch24                  
       ml=ml-m 
       if(ml.gt.0) then 
        do k=1,ml 
         ch132(k:k)=ch132(k+m:k+m) 
        end do 
!       write(6,'(2a)') 'ch132(:ml)=',ch132(:ml)                        
       end if 
                                                                        
       l24=m-l+1 
       ip=index(ch24,'.') 
       if(ip.gt.0) then 
        ip=ip-1 
        ie=index(ch24,'e')+index(ch24,'E') 
        if(ie.gt.0) then 
!        exponent                                                       
         l24=l24+2 
         chfh(1:2)='e0' 
         ink=ie-ip-2 
        else 
         chfh(1:2)='f0' 
         ink=l24-ip-1 
        end if 
        l24=l24+1 
        if(l24.lt.10) then 
         chfh(3:5)=char(i0+l24)//'.'//char(i0+ink) 
        else 
         i10=l24/10 
         i1=l24-10*i10+i0 
         chfh(2:5)=char(i0+i10)//char(i1)//'.'//char(i0+ink) 
        end if 
                ! ip>0                                                  
       else 
         chfh(1:2)='f0' 
         l24=l24+1 
         if(l24.lt.10) then 
          chfh(3:5)=char(i0+l24)//'.0' 
         else 
          i10=l24/10 
          i1=l24-10*i10+i0 
          chfh(2:5)=char(i0+i10)//char(i1)//'.0' 
         end if 
               ! ip=0                                                   
        end if 
       else 
        goto 1000 
       end if 
       chf(n)=chfh 
!       write(6,'(2i4,a,a5)')n,lf(n),' chf(n)=',chf(n)                  
       goto 100 
 1000  continue 
!       write(6,'(i4,a)') n,' L1000'                                    
       j=1 
       do k=1,n 
        j1=j 
        j=j1+9 
!        write(6,'(a,2i4)')' j1,j=',j1,j                                
        chfmt(j1:j-1)=',1x,'//chf(k)(1:5) 
!       write(6,'(i4,a,a)')k,' chfmt=',chfmt(:60)                       
       end do 
       chfmt(j:j)=')' 
       return 
      END                                           
                                                                        
      subroutine fcolumn(chf,lf,chfmt) 
      implicit none 
      integer lf,i0,i1,i10,lmin,k,l
      character chf(24)*4,chfmt(24)*5 
                                                                        
      i0=ichar('0') 
      lmin=3 
      do k=1,lf 
       if(chf(k)(2:2).eq.' ') then 
        l=ichar(chf(k)(3:3))-i0 
       else 
        l=(ichar(chf(k)(2:2))-i0)*10+ichar(chf(k)(3:3))-i0 
       end if 
!       write(6,'(a,2i4)')' lmin,l=',lmin,l                             
       if(l.gt.lmin) lmin=l 
      end do 
                                                                        
      do k=1,lf 
       if(chf(k)(1:1).eq.'i') then 
        if(lmin.lt.10) then 
         chfmt(k)=chf(k)(1:1)//char(i0+lmin) 
        else 
         i10=lmin/10 
         i1=lmin-10*i10+i0 
         chfmt(k)=chf(k)(1:1)//char(i0+i10)//char(i1) 
        end if 
       else 
        if(lmin.lt.10) then 
         chfmt(k)=chf(k)(1:1)//char(i0+lmin)//'.'//chf(k)(4:4) 
        else 
         i10=lmin/10 
         i1=lmin-10*i10+i0 
         chfmt(k)=chf(k)(1:1)//char(i0+i10)//char(i1)//'.'//chf(k)(4:4) 
        end if 
       end if 
      end do 
      return 
      END                                           
                                                                        
                                                                        
      subroutine termprocess(chwindim,chkill,kwin) 
      use glbconst, only:nwr
      use compar, only: chterm
      implicit none
      integer kwin,i,j,j1,j2,k
      character(len=80):: ch 
      character(len=64):: ch64 
      character(len=48):: chwindim
      character(len=16):: chkill,ch16 
      character(len=1) :: ch1 
   
!      character(len=64):: effishell                                                                        
!xterm -geo 80x36+750+10 -bg Yellow1 -e cmd_he_li                       
                                                                        
      ch1=' ' 
      ch64=' ' 
      if(kwin.eq.2) then 
       ch=' -e ./cmd_sh & ' 
       ch16='cmd_sh' 
      else if(kwin.eq.3) then 
       ch=' -e ./cmd_tr & ' 
       ch16='cmd_tr' 
      else if(kwin.eq.4) then 
       ch=' -e ./cmd_li & ' 
       ch16='cmd_li' 
      else if(kwin.eq.5) then 
       ch=' -e ./cmd_he & ' 
       ch16='cmd_he'
      else if(kwin.eq.6) then 
       ch=' -e ./cmd_ft & ' 
       ch16='cmd_ft'  
      else if(kwin.eq.7) then 
       ch=' -e ./cmd_gr & ' 
       ch16='cmd_$g' 
      end if 
                                                                        
      i=48 
      do while(ch1.eq.' ') 
       i=i-1 
       ch1=chwindim(i:i) 
      end do 
      ch64='xterm  -geo '//chwindim(:i)//ch 
      j=11+i 
!      write(6,'(a)')ch64                                               
      call openterm(ch64) 
                                                                        
      open(9,file='terminfo'                                            &
                  ,status='old'                                         &
                  ,access='sequential'                                  &
                  ,form='formatted')                                    
                                                                        
! /dev/ttyp3                                                            
!   PID  TT STAT   TIME COMMAND                                         
! 31944  p3 S      0:00 /bin/sh ./termin                                
! 31946  p3 S      0:00 /bin/bash                                       
!       CALL GET_ENVIRONMENT_VARIABLE(NAME='SHELL',value=effishell,STATUS=i)
!       ch1=' ' 
!       i=17 
!       do while(ch1.eq.' ') 
!        i=i-1 
!        ch1=effishell(i:i) 
!       end do 
       chterm(kwin)=' ' 
       read(9,'(a)')ch 
!       write(6,'(a)')ch                                                
       chterm(kwin)=ch 
       read(9,'(a)',err=100) ch 
!       write(6,'(a)')ch                                                
       read(9,'(a)',err=100) ch 
!       write(6,'(a)')ch                                                
       j1=index(ch,'sleep') 
       k=index(ch,'p') 
                                                                        
       if(j1.gt.0) then 
        chkill(1:8)=ch(1:k-1) 
       else 
        chkill(9:16)=ch(1:k-1) 
       end if 
       read(9,'(a)',err=100)ch 
!       write(6,'(a)')ch                                                
       j2=index(ch,'sleep') 
       k=index(ch,'p') 
       if(j2.gt.0) then 
        chkill(1:8)=ch(1:k-1) 
       else 
        chkill(9:16)=ch(1:k-1) 
       end if 
                                                                        
!       write(6,'(a,a)')'terminfo ll=',ch(:60)                          
!       write(6,'(a,a16)')'chkill   =',chkill                           
!       write(6,'(a,a)')'effishell  =',effishell(:60)                   
!       write(6,'(a,i4,a,a2)')'comtool i,shell,E=',i,effishell,' E'     
                                                                        
                                                                        
       if(j1+j2.eq.0) then 
        chterm(kwin)=' ' 
       end if 
       goto 110 
  100  chterm(kwin)=' ' 
       chkill=' ' 
       write(nwr,'(a,a)')'open window procedure was not successful',   &
       ' kill window: '//ch16                                          
  110  close(unit=9) 
       return 
      END                                           
                                                                        
     subroutine procstore(ch2) 
     use glbconst,only: maxfr1,maxco,maxs,maxss,maxsub,maxprd,         &
                        marray_sp,max_ctrf,max_vtrf,maxsto,maxp,maxpl, &
                        maxp_sp,maxc_sp,maxcvsp,maxthss,maxc,maxthlv,  &
                          icstrf,icfr1trf,icfr2trf,icsstrf,            &
                          ivstrf,ivfr1trf,ivfr2trf,ivsstrf
     use comdat, only: n_cdatas,n_vdatas,readform,cdatas,vdatas
     use comeff, only: contrf,ocontrf,mvadds,mcadds,nblockstr
     use comthe, only: vartrf,ovartrf
     use comdas, only: ktheo
     implicit none 
     character(len=2),intent(in):: ch2

      real   cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,csstrf,vsstrf
      common/acstrf/ cstrf(icstrf) 
      common/avstrf/ vstrf(ivstrf) 
      common/acfr1trf/ cfr1trf(icfr1trf) 
      common/avfr1trf/ vfr1trf(ivfr1trf) 
      common/acfr2trf/ cfr2trf(icfr2trf) 
      common/avfr2trf/ vfr2trf(ivfr2trf) 
      common/acsstrf/ csstrf(icsstrf) 
      common/avsstrf/ vsstrf(ivsstrf) 
! 1+maxco*2+maxprd+maxp+1+maxs+2+6*maxco+1+2*maxco+maxp+2+
! 3*(1+maxs)+3*maxs*(1+maxthss)+1+maxc+3*(1+maxs)+7*maxs*(1+maxthss)+
! maxp+4*maxpl+2*maxc+2*maxs*(1+maxp_sp)+18

     character(len=4) :: cifrm,crfrm,ccfrm
     integer,parameter:: nfrmi=1+2*maxco+maxprd+maxp+1+maxs+2+8*maxco+ &
                       1+maxp+2+(1+maxs+maxs*(1+maxthss))*3+1+maxc+    &
                       (1+maxs+maxs*(1+maxthss))*3+1+maxc+3*(1+maxs)+  &
                       7*maxs*(1+maxthss)+maxp+4*maxpl+2*maxc+         &
                       maxs*(1+maxp_sp)+maxs*(1+maxc_sp)+18,           &
                 nfrmr=9*maxp+maxsto+maxpl+maxc+6,                     &
                 nfrmc=8*maxpl+15*maxp+10*maxc+4*maxco+maxsto+6*6*maxs
     common/frmi/cifrm(nfrmi) 
     common/frmr/crfrm(nfrmr) 
     common/frmc/ccfrm(nfrmc) 

!   common/datai/mfpt,mdfpt,mxpt,mdxpt,mypt,mdypt,mgrpt,mvpt,mgpt,mdgpt,&
!                nchannelsp,nuofdatas,nuofdata(maxs),ichan(0:256,maxs), &
!                i3dgroup(0:256,maxs),ibadchan(0:maxbaddata,maxs),      &
!                ichanks(0:256),i3dgroupks(0:256),nunitdata,nchandata(maxs)
                                                                       
     character(len=4) :: cidata,ccdata,cbdata 
     integer,parameter:: maxbaddata=64,                                &
                  idatai=12+maxs+257*maxs*2+(1+maxbaddata)*maxs+       &
                          2*257+1+maxs,                                &
                  idatac=176,                                          &
                  idatab=2+2*maxs+128*maxs+30                         
     common/datai/cidata(idatai) 
     common/datac/ccdata(idatac) 
     common/datab/cbdata(idatab) 
                                                                       
                                                                       
     character(len=4) :: cidas,crdas,ccdas,cbdas 
     integer,parameter:: idasi=2*(1+maxcvsp)*maxs+maxs*(1+maxthss)+      &
                         maxs*(1+maxthss)*(1+maxthlv)+2*(1+maxcvsp)+maxs,&
                 idasr=maxs*maxcvsp*2,                                   &
                 idasc=(maxs+1)*maxcvsp*20+maxs*99,                      &
                 idasb=maxs*maxcvsp*2                              
     common/dasi/cidas(idasi) 
     common/dasr/crdas(idasr) 
     common/dasc/ccdas(idasc) 
     common/dasb/cbdas(idasb) 
                                                                        
     character(len=4) :: carray_fr,cplt,cblockstr
     common/store/carray_fr(2*marray_sp) 
                                                                       
     integer,parameter:: iplt=9+3*(maxss+1)+maxsub*(maxthss+1)+256+132+maxsub
     common /plt/cplt(iplt) 
                                                                       
     common/blockstr/cblockstr(nblockstr) 
                                                                 
!     integer,parameter:: ipnt=maxs*(1+maxthss)*2 
!     common/pnt/  cipnt(ipnt) 
     open(unit=1,file='storage.cb'                                     &
                 ,status='unknown'                                     &
                 ,form='unformatted')                                  
                                                                        
    if(ch2.eq.'wr')then 
     write(1)cifrm,crfrm,ccfrm,cidata,ccdata,cbdata,                     &
          cidas,crdas,ccdas,cbdas,carray_fr,cblockstr,                   &
           contrf,ocontrf,vartrf,ovartrf,mvadds,mcadds,                  &
           n_cdatas,n_vdatas,readform,cdatas,vdatas,ktheo,               &
           cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,csstrf,vsstrf

    end if 
    if(ch2.eq.'rd')then 
      read(1)cifrm,crfrm,ccfrm,cidata,ccdata,cbdata,                     &
         cidas,crdas,ccdas,cbdas,carray_fr,cblockstr,                    &
         contrf,ocontrf,vartrf,ovartrf,mvadds,mcadds,                    &
         n_cdatas,n_vdatas,readform,cdatas,vdatas,ktheo,                 &
         cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,csstrf,vsstrf
    end if 
    close(unit=1) 
    return 
    END                                           

    function chistring(chisq)
    real, intent(in)::chisq
    character(len=8) :: chistring
    integer i

    i=int(alog10(chisq))
!    print*,'i,chisq=',i,chisq
!   i<10 : n.abcd           f8.4
!   i>10 & i<100 : nn.abc   f8.3
!   i>100 & i<1000 : nnn.ab f8.2
!   i>1000  : g8.0
    if(i.lt.10) then
     write(chistring,'(f8.4)')chisq
    else if(i.gt.10.and.i.lt.100) then
     write(chistring,'(f8.3)')chisq 
    else if(i.gt.100.and.i.lt.1000) then
     write(chistring,'(f8.2)')chisq 
    else if(i.gt.1000) then
     write(chistring,'(g8.0)')chisq 
    end if
    return
    end


      subroutine trlch16(jnstr,len,out,iout) 
      implicit none
        
      integer, dimension(132), intent(in) :: jnstr
      integer, intent(in):: len
      real,    dimension(16),  intent(out):: out
      real :: pt
      integer:: i0,ie,ice,ib,im,ip, &
              i,ic,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given by ascii
!     numbers jnstr(i) , i=1,...,len , len<132
!     to iout real numbers (max.16) stored in the vector out.           

      i0=ichar('0'); ie=ichar('e'); ice=ichar('E') 
      im=ichar('-'); ip=ichar('.'); ib=ichar(' ')

      nsig=1; pt=1.0; k1=0; k2=0; nex=0; nnum=0; iout=0 
      out=0.0
     
      k=0 
   10 k=k+1 
      i=jnstr(k)-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.len) goto 50 
       goto 100 
      end if 
                                                                        
      if(jnstr(k).eq.ie.or.jnstr(k).eq.ice) then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(jnstr(i).eq.ip) then 
         nex=-1 
         goto 50 
        end if 
        ic=jnstr(i)-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (jnstr(k).eq.ip) then 
        pt =0.1 
        goto 100 
      end if 
      if(jnstr(k).eq.im) then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.jnstr(k).eq.ib) nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.16) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.len) goto 10 
  110 return     
    END subroutine trlch16
