      subroutine cpdistribute(icase,ht,jco,kwin) 
      use glbconst, only: nwr
      use compar, only: ncolwin,nwrwin
      use comfrm, only: p,np,ncor,fpstor,cpstor,kcp,kco,mc,mrs,mcs,mrces
      use comscd, only: nmkcp,pp_sc,fp_sc,nmr,nmc
      use comeff, only: ncol
      implicit none
      integer   icase,jco,kwin,jf,j,jm,i,ic,i0,inp,jr,jst,      &
                kk,mcsk,mrsk,nmc2,nmr2 
      real      ht 
      character(len=3)  :: ch3
      character(len=1)  :: ch1

                                                                         
        call window(kwin) 
        ncolwin=ncol(kwin) 
        if(nwrwin.ne.nwr) write(nwrwin,'(/,a1,a3,a,a1,a3)')             &
     &          char(27),'[1m',ncor(kco(jco)),char(27),'[0m'            
                                                                        
        i0=ichar('0') 
        kk=kco(jco) 
        mrsk=mrs(kk) 
        mcsk=mcs(kk) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
        do i=1,nmc2 
         nmkcp(i)=kcp(mcsk+nmc(i+2)) 
        end do 
        jf=0 
        jm=10 
        if(icase.eq.0) then 
         ht=0. 
         do ic=1,nmc2 
          inp=nmkcp(ic) 
!1absZ__mg/cm2xf         1x,f06.3,1x,f04.1,1x,f04.1,1x,f05.2)           
!          write(6,'(a,f12.5)')TRIM(np(inp)),p(inp)
!          fp_sc(ic)=np(inp)(28:30)//np(inp)(32:32)                     
          ht=ht+p(inp) 
          pp_sc(ic)=p(inp) 
          j=(ichar(np(inp)(29:29))-i0)*10+ichar(np(inp)(30:30))-i0 
          if(j.gt.jf)then 
           jf=j 
           ch3=np(inp)(28:30)
          end if 
          j=ichar(np(inp)(32:32))-i0 
          if(j.lt.jm)jm=j 
         end do 
!         if(ht.eq.0)ht=1.
!         ch1=char(jf-1-jm+i0)
         ch1=char(jm+i0)
          do ic=1,nmc2 
          fp_sc(ic)=ch3//ch1
          if(abs(ht).gt.0.)then
             pp_sc(ic)=pp_sc(ic)/ht
          else
            ht=p(nmkcp(1))*nmc2 
            pp_sc(ic)=p(nmkcp(ic))  
          end if   
         end do 
         p(nmkcp(1))=ht/nmc2 
        else 
         p(nmkcp(1))=ht 
         do j=1,nmr2 
          jr=nmr(j+2) 
          jst=mrces(jco)+(jr-1)*mc(jco) 
!         jk=kpl(mrsk+jr)nmr(j+2)                                       
!          nthpl(jk)                                                    
!         fpstor(jst+nmc(ic+2))='f020'                                  
!          write(6,'(a)')fp_sc(j)                                       
          fpstor(jst+nmc(1+2))=fp_sc(j) 
          cpstor(jst+nmc(1+2))=pp_sc(j) 
         end do 
        end if 
      return 
      END                                           
                                                                        
       subroutine printcp(jco,kwin,ledit) 
       use glbconst, only: nwr
       use compar, only: ncolwin,nwrwin
       use comfrm, only: fpstor,np,nthpl,kcp,kpl,kco,mc,mrs,mcs,mrces,ncor
       use comscd, only: chflen,nmkcp,np_sc,np_nm,l_nm,l_sc,lencl,nmr,nmc
       use comeff, only: ncol,ixpixel
       implicit none

       integer, parameter :: flen=256 
       integer        jco,kwin,ledit,i,i0,i1,i10,i_,i_1,ibl,ic,icol,   &
                      inp,is,iu,j,jk,jr,jst,kk,l,l_nthpl,lcol,lcolumn, &
                      length,mcsk,mrsk,mskf,nit,nmc2,nmr2
       character(len=132):: ch132
       character(len=8)  :: ch8
       character(len=2)  :: chfm
       character(len=1)  :: ch0


        ch0=char(0)                                                                
        call window(kwin) 
        ncolwin=ncol(kwin) 
        if(nwrwin.ne.nwr) write(nwrwin,'(/,a1,a3,a,a1,a3)')             &
                char(27),'[1m',ncor(kco(jco)),char(27),'[0m'            
                                                                        
        kk=kco(jco) 
        mrsk=mrs(kk) 
        mcsk=mcs(kk) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
        if(nmr2+nmc2.eq.0)return
        do i=1,nmc2 
         nmkcp(i)=kcp(mcsk+nmc(i+2)) 
        end do 
                                                                        
        chflen=' ' 
        i0=ichar('0') 
        mskf=0 
        lcol=0 
                                                                        
        do ic=1,nmc2 
         length=8 
         do j=1,nmr2 
          jst=mrces(kk)+(j-1)*mc(kk) 
          l=10*(ichar(fpstor(jst+ic)(2:2))-i0)                          &
     &         +ichar(fpstor(jst+ic)(3:3))-i0                           
          if(l.gt.length) length=l 
         end do 
         inp=nmkcp(ic) 
         is=index(np(inp),'*') 
!         if(is.gt.0) then                                              
!          iu=24                                                        
!          do while(np(inp)(iu:iu).eq.' ')                              
!           iu=iu-1                                                     
!          end do                                                       
!          l=iu-is+1                                                    
!          if(l.gt.length) length=l                                     
!          l_nm(ic)=l                                                   
!          if(is.gt.length) length=is                                   
!          l_sc(ic)=is                                                  
!          np_sc(ic)=np(inp)(:is)                                       
!          np_nm(ic)=np(inp)(is+1:iu)                                   
!         else                                                          
          i_=index(np(inp),'_') 
          i_1=i_ 
          do while(np(inp)(i_:i_).eq.'_') 
           i_=i_+1 
          end do 
          np_sc(ic)=np(inp)(:i_1-1) 
          iu=24 
          do while(np(inp)(iu:iu).eq.' ') 
           iu=iu-1 
          end do 
          np_nm(ic)=np(inp)(i_:iu) 
          l=iu-i_+1 
          if(l.gt.length) length=l 
          l_nm(ic)=l 
          l_sc(ic)=i_1-1 
          l=i_1-1 
          if(l.gt.length) length=l 
!         end if                                                        
         lencl(ic)=length 
         lcol=lcol+length+2 
        end do 
        l_nthpl=8 
        do j=1,nmr2 
         jr=nmr(j+2) 
         jk=kpl(mrsk+jr) 
         iu=24 
         do while(nthpl(jk)(iu:iu).eq.' ') 
          iu=iu-1 
         end do 
         if(iu.gt.l_nthpl)l_nthpl=iu 
        end do 
!        write(6,'(a,20i3)')' lencl(1-)=',(lencl(ic),ic=1,mc(kk))       
!        write(6,'(a,20i3)')' l_nm(1-)=',(l_nm(ic),ic=1,mc(kk))         
!        write(6,'(a,20i3)')' l_sc(1-)=',(l_sc(ic),ic=1,mc(kk))         
!        write(6,'(a,20i3)')' lcol+29,ncolwin=',lcol+29,ncolwi          
        nit=nwrwin 
        if(ledit.gt.10) then 
         open(unit=9                                                    &
     &            ,file='editor.pa'                                     &
     &            ,status='unknown'                                     &
     &            ,access='sequential'                                  &
     &            ,form='formatted'                                     &
     &            ,err=10)                                              
         nit=9 
        end if 
        goto 20 
   10   continue 
        write(nwr,'(a)')'**fatal error** editor file could not be opend' 
   20   continue 
                                                                        
        i10=l_nthpl/10 
        i1=l_nthpl-10*i10 
        chfm=char(i0+i10)//char(i0+i1) 
!        write(6,'(a,i3,3x,a2)')' l_nthpl,chfm=',l_nthpl,chfm           
        length=l_nthpl+4 
        icol=0 
        ibl=0 
!        write(6,'(a,5i4)')'lcol,length,l_nthpl,ncolwin=',              
!     &           lcol,length,l_nthpl,ncolwin                           
        if(lcol+length.ge.ncolwin) then 
         ic=0 
         do while(ic.lt.nmc2.and.length.le.ncolwin) 
          ic=ic+1 
          length=length+lencl(ic)+1 
         end do 
         if(length.ge.ncolwin-2) ic=ic-1 
         lcolumn=ic 
         i=(flen-8)/9-1 
         if(ic.gt.i) lcolumn=i 
!        write(6,'(a,i3,3x,a2)')                                        
!     &    'lcol+length.ge.ncolwin lcolumn=',lcolumn                    
         ibl=ibl+1 
         call prmatrix(nit,mskf,lcolumn,nmr2,kk,mrsk,chfm) 
                                                                        
         icol=icol+lcolumn 
         do while(icol.le.nmc2.and.lcolumn.gt.0) 
          length=l_nthpl+4 
          lcolumn=0 
          ic=icol 
          do while(ic.lt.nmc2.and.length.le.ncolwin) 
           ic=ic+1 
           length=length+lencl(ic)+1 
           lcolumn= lcolumn+1 
          end do 
          if(length.ge.ncolwin-2) lcolumn= lcolumn-1 
          i=(flen-9)/9-1 
                                          !lcolumn of new block         
          if(lcolumn.gt.i) lcolumn=i 
!          write(6,'(a,10i4)')' lencl=',(lencl(i),i=icol+1,icol+10)     
!          write(6,'(a,4i4)')'length,lcolumn,ic,icol=',length,lcolumn,ic
          if(lcolumn.gt.0) then 
           write(nit,'(a)') 
           icol=icol+lcolumn 
!           write(6,'(a,3i4)')'nmc2,icol,lcolumn=',nmc2,icol,lcolumn    
!          write(nit,'(a)')                             
           ibl=ibl+1 
           call prmatrix(nit,mskf,lcolumn,nmr2,kk,mrsk,chfm) 
          end if 
         end do 
        else 
!        simple block ------------------------------------------------  
!         write(nit,'(a)') 
         ibl=ibl+1 
         call prmatrix(nit,mskf,nmc2,nmr2,kk,mrsk,chfm) 
        end if 
                                                                        
       if(nit.eq.9) then 
!        write(6,'(a,3i4)')' lcol,ncolwin,mskf=',lcol,ncolwin,mskf      
        if(ledit.eq.21) then 
         l=16+lcol 
         if(lcol.gt.ncolwin)l=16+ncolwin 
         call itoc8(ch8,l) 
         i=4 
         if(l.gt.99)i=5 
         ch8(i:i)='x' 
         ch132='-geometry '//ch8(:i) 
         j=(nmr2+4)*ibl+6 
         if(j.gt.65)j=65 
         call itoc8(ch8,j) 
         ch132(11+i:)=ch8(2:3) 
         call itoc8(ch8,ixpixel(1)+10) 
         ch8(1:1)='+' 
         ch132(13+i:)=ch8(1:4)//'+0'//ch0 
!         write(6,'(2a)')' ch132=',ch132(:30)                           
        else 
         ch132=' '//ch0 
        end if 
        close(unit=nit) 
        call openeditor(ledit,ch132) 

        open(unit=nit                                                  &
                ,file='editor.pa'                                      &
                ,status='unknown'                                      &
                ,access='sequential'                                   &
                ,form='formatted')                                     
         mskf=0 
         length=l_nthpl+4 
         icol=0 
         if(lcol+length.ge.ncolwin) then 
          ic=0 
          do while(ic.lt.nmc2.and.length.le.ncolwin) 
           ic=ic+1 
           length=length+lencl(ic)+1 
          end do 
          if(length.ge.ncolwin-2) ic=ic-1 
          lcolumn=ic 
          i=(flen-8)/9-1 
          if(ic.gt.i) lcolumn=i 
                                                                        
          call rdmatrix(nit,mskf,lcolumn,nmr2,kk,mrsk) 
          icol=icol+lcolumn 
          do while(icol.le.nmc2.and.lcolumn.gt.0) 
           length=l_nthpl+4 
           lcolumn=0 
           ic=icol 
           do while(ic.lt.nmc2.and.length.le.ncolwin) 
            ic=ic+1 
            length=length+lencl(ic)+1 
            lcolumn= lcolumn+1 
           end do 
           if(length.ge.ncolwin-2) lcolumn= lcolumn-1 
           i=(flen-9)/9-1 
                                           !lcolumn of new block        
           if(lcolumn.gt.i) lcolumn=i 
           if(lcolumn.gt.0) then 
            icol=icol+lcolumn 
            call rdmatrix(nit,mskf,lcolumn,nmr2,kk,mrsk) 
           end if 
          end do 
         else 
!            simple block ----------------------------------------------
          call rdmatrix(nit,mskf,nmc2,nmr2,kk,mrsk) 
         end if 
         close(unit=nit) 
        call systemcmd("rm  editor.pa"//char(0)) 
       end if 
      return 
      END                                           
                                                                       
      subroutine rdmatrix(nit,mskf,lcolumn,lrow,lco,mrsk) 
       use comfrm, only: np,cpstor,fpstor,kpl,mc,mrces
       use comscd, only: nmkcp,nmr,nmc    
      implicit none 
      integer   nit,mskf,lcolumn,lrow,lco,mrsk                                                                   
      character(len=4),dimension(1:32) :: chf
      character(len=264) :: ch264
      character(len=132) :: cp132
      real      out(32) 
      integer   i,i0,ic,inp,j,jk,jr,jst,k,mski,nn,lf                                                                        
                                                                        
      i0=ichar('0') 
      mski=mskf+1 
      mskf=mskf+lcolumn 
!     parameter number line                                          
      ch264=' ' 
      do while(ch264.eq.' ') 
       read(nit,'(a)') ch264 
      end do 
!      write(6,'(a)')ch264(:80)                                      
      read(nit,'(a)') ch264 
!      write(6,'(a)')ch264(:80)                                      
!     parameter name line                                            
      read(nit,'(a)') ch264 
!      write(6,'(a)')ch264(:80)                                      
      i=10 
      do ic=mski,mskf 
       k=i 
       do while(k.lt.264.and.ch264(k:k).eq.' ') 
        k=k+1 
       end do 
       i=k 
       do while(i.lt.264.and.ch264(i:i).ne.' ') 
        i=i+1 
       end do 
       inp=nmkcp(ic) 
       j=index(np(inp),'_') 
       do while(j.lt.33.and.np(inp)(j:j).eq.'_') 
        j=j+1 
       end do 
!      write(6,'(2i8,2x,2a)')mskf,ic,ch264(k:i),np(inp)(j:j+i-k)   
       np(inp)(j:j+i-k)=ch264(k:i) 
      end do 
                                                                     
      do j=1,lrow 
       jr=nmr(j+2) 
       jk=kpl(mrsk+jr) 
       jst=mrces(lco)+(jr-1)*mc(lco) 
       read(nit,'(a)') ch264 
!       write(6,'(a)')ch264(:100)                                    
       i=index(ch264,'_') 
       do while(ch264(i:i).ne.' ') 
        i=i+1 
       end do 
       do ic=mski,mskf 
        k=i 
        do while(k.lt.264.and.ch264(k:k).eq.' ') 
         k=k+1 
        end do 
        i=k 
        do while(i.lt.264.and.ch264(i:i).ne.' ') 
         i=i+1 
        end do 
        cp132=ch264(k:i) 
        call fout_a(cp132,chf,lf) 
        call trlch(i+1,cp132,nn,out) 
        cpstor(jst+nmc(ic+2))=out(1) 
        fpstor(jst+nmc(ic+2))=chf(1) 
       end do 
      end do 
      return 
      END                                           

      subroutine prmatrix(nit,mskf,lcolumn,lrow,lco,mrsk,chfm) 
      use comfrm, only: fpstor,cpstor,kpl,mc,mrces,nthpl
      use comscd, only: chflen,lencl,nmc,nmr,l_sc,l_nm,np_nm,np_sc
      implicit none 
      integer   nit,mskf,lcolumn,lrow,lco,mrsk,i0,i1,i10,ic,lcol,l2,  &
                ix,j,jk,jr,jst,mski,nmic                                                                        
      character ch1*1,ch2*2,ch8*8,chfm*2 
                                                                        
         i0=ichar('0') 
         mski=mskf+1 
         mskf=mskf+lcolumn 
!        parameter number line                                          
         chflen=' ' 
         chflen(1:10)='(4x,'//chfm//'x,' 
         lcol=11 
         do ic=mski,mskf 
          l2=lencl(ic)-2 
          if(l2.gt.9) then 
           i10=l2/10 
           i1=l2-10*i10+i0 
           ch8=char(i10+i0)//char(i1)//'x,i3,' 
           chflen(lcol:lcol+7)=ch8(:7) 
           lcol=lcol+7 
          else 
           ch8=char(l2+i0)//'x,i3,' 
           chflen(lcol:lcol+6)=ch8(:6) 
           lcol=lcol+6 
          end if 
!         write(6,'(a,5i4)')'ic,l2,mski,mskf=',ic,l2,mski,mskf          
!         write(6,'(a)') chflen(:80)                                    
         end do 
         chflen(lcol-1:)=')' 
!         write(6,'(a)') chflen(:80)                                    
         write(nit,chflen) (nmc(ic+2),ic=mski,mskf) 
                                                                        
!        parameter abcd___ line                                         
         chflen=' ' 
         chflen(1:8)='(4x,'//chfm//'x,' 
         lcol=9 
         do ic=mski,mskf 
!          write(6,'(a,3i4)') ' ic,lencl,l_sc=',ic,lencl(ic),l_sc(ic)   
          l2=lencl(ic)-l_sc(ic)+1 
          if(l2.gt.9) then 
           i10=l2/10 
           i1=l2-10*i10+i0 
           ch2=char(i10+i0)//char(i1) 
           ix=2 
          else 
           ch2=char(l2+i0) 
           ix=1 
          end if 
          if(l_sc(ic).gt.9) then 
           i10=l_sc(ic)/10 
           i1=l_sc(ic)-10*i10+i0 
           ch8=ch2(:ix)//'x,a'//char(i10+i0)//char(i1)//',' 
           if(ix.eq.2)then 
            chflen(lcol:lcol+8)=ch8(:8) 
            lcol=lcol+8 
           else 
            chflen(lcol:lcol+7)=ch8(:7) 
            lcol=lcol+7 
           end if 
          else 
           ch1=char(l_sc(ic)+i0) 
           ch8=ch2(:ix)//'x,a'//ch1//',' 
           if(ix.eq.2) then 
            chflen(lcol:lcol+7)=ch8(:7) 
            lcol=lcol+7 
           else 
            chflen(lcol:lcol+6)=ch8(:6) 
            lcol=lcol+6 
           end if 
          end if 
         end do 
         chflen(lcol-1:)=')' 
!         write(6,'(a)') chflen(:100)                                   
         write(nit,chflen) (np_sc(ic),ic=mski,mskf) 
                                                                        
!        parameter name line                                            
         chflen(1:8)='(4x,'//chfm//'x,' 
         lcol=9 
         do ic=mski,mskf 
!          write(6,'(a,3i4)') ' ic,lencl,l_nm=',ic,lencl(ic),l_nm(ic)   
          l2=lencl(ic)-l_nm(ic)+1 
          if(l2.gt.9) then 
           i10=l2/10 
           i1=l2-10*i10+i0 
           ch2=char(i10+i0)//char(i1) 
           ix=2 
          else 
           ch2=char(l2+i0) 
           ix=1 
          end if 
          if(l_nm(ic).gt.9) then 
           i10=l_nm(ic)/10 
           i1=l_nm(ic)-10*i10+i0 
           ch8=ch2(:ix)//'x,a'//char(i10+i0)//char(i1)//',' 
           chflen(lcol:lcol+7)=ch8(:7) 
           lcol=lcol+7 
          else 
           ch1=char(l_nm(ic)+i0) 
           ch8=ch2(:ix)//'x,a'//ch1//',' 
           chflen(lcol:lcol+6)=ch8(:6) 
           lcol=lcol+6 
          end if 
         end do 
         chflen(lcol-1:)=')' 
!         write(6,'(a)') chflen(:100)                                   
         write(nit,chflen) (np_nm(ic),ic=mski,mskf) 
                                                                        
         do j=1,lrow 
          jr=nmr(j+2) 
          jk=kpl(mrsk+jr) 
          jst=mrces(lco)+(jr-1)*mc(lco) 
                                                                        
          chflen(1:11)='(i3,1x,a'//chfm//',' 
          lcol=12 
          do ic=mski,mskf 
           nmic=nmc(ic+2) 
           i10=lencl(ic)/10 
           i1=lencl(ic)-10*i10 
           ch2=char(i0+i10)//char(i0+i1) 
           ch1=fpstor(jst+nmic)(1:1) 
           if(ch1.eq.'i') then 
            chflen(lcol:lcol+8)='1x,'//'f'//ch2//'.0,' 
           else 
            chflen(lcol:lcol+8)=                                        &
     &                '1x,'//ch1//ch2//'.'//fpstor(jst+nmic)(4:4)//','  
           end if 
           lcol=lcol+9 
          end do 
!          write(6,'(20a5)') (fpstor(jst+nmc(ic+2)),ic=mski,mskf)       
          chflen(lcol-1:)=')' 
!          write(6,'(a)') chflen(:lcol)                                 
          write(nit,chflen)                                             &
     &          jr,nthpl(jk),(cpstor(jst+nmc(ic+2)),ic=mski,mskf)       
         end do 
                                                                        
      return 
      END                                           

      subroutine selmat(jco,ch1) 
       use glbconst, only: nrd,nwr
       use comfrm, only: ncor,mcon,kco,mr,mc
       use comscd, only: npanum,helpar,ext,queryar,nmr,nmc
      implicit none 
      integer       jco,k,kk,jm,lq,lk,i,il,im,ir,l,nn,ntrimto0
      character*132 ch132,cp132,ch64
      character     chl*24,chr*24,form*7,ch16*16,ch1*1,ch3*3 
      real          rn 
!      write(6,'(a,3i3,4x,0i4)') 'selmat jco,mcon,mco,kco(1..mco)=',    
!     &       jco,mcon,mco                                              

      if(jco.gt.mcon) then 
       ch1='*' 
       return 
      end if 
      ch1=' ' 
      do k=1,mcon 
        helpar(k)='effi/transformation/matrix' 
      end do 
    1 form='i3' 
      do k=1,mcon 
       kk=kco(k) 
       ch132=ncor(kk) 
       l=ntrimto0(ch132) 
       rn=mr(kk) 
       if(mr(kk).eq.0)form='i1' 
       call trlnu(form,rn,chr,nn,chl,im) 
       form='i3' 
       ch3=chl(1:im) 
       jm=im 
       rn=mc(kk) 
       if(mc(kk).eq.0)form='i1' 
       call trlnu(form,rn,chr,nn,chl,im)
       form='i3' 
       ext(k)='('//ch3(1:jm)//'x'//chl(1:im)//')' 
       queryar(k)=ch132 
      end do 
      lq=mcon 
      lk=lq 
      ch16=ncor(kco(jco)) 
      ch16(16:16)='#' 
      ch132=' ' 
      ch132(132:132)='l' 
      call query2(lq,lk,ch132,ch16) 
      if(ch16(1:1).eq.'r') goto 1 
      if(ch16(1:1).eq.'y') then 
       do k=1,mcon 
        kk=kco(k) 
        ncor(kk)=queryar(k)(:16) 
       end do 
      end if 
      if(lq.gt.0) then 
       jco=lq 
      else 
       ch1='*' 
       return 
      end if 
                                                                        
!      write(nwr,'(a)')                                                 
      kk=kco(jco) 
      form='i3' 
      rn=mr(kk) 
      call trlnu(form,rn,chr,nn,chl,im) 
      ch132='1-'//chl(1:im) 
  150 ir=ntrimto0(ch132) 
      ch64=ch132 
      write(nwr,'(2a,a1)')' row numbers [',ch132(1:ir),']'
      read(nrd,'(a)') cp132 
      if(cp132.eq.' ') then
       i=1 
       call panum(ch132,mr(kk),npanum,i)
       if(i.ne.1) goto 170
       do i=1,npanum(2)+2 
        nmr(i)=npanum(i) 
       end do 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       write(nwr,'(2a)')'                                        ',     &
     &                  '                                        '      
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
      else 
       if(index(cp132,'*')+index(cp132,'q').gt.0) goto 170 
       ch132=cp132 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       write(nwr,'(2a)')'                                        ',     &
     &                  '                                        '      
       write(nwr,'(2a)')'                                        ',     &
     &                  '                                        '      
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       goto 150 
      end if 
                                                                        
      rn=mc(kk) 
      call trlnu(form,rn,chr,nn,chl,im) 
      ch132='1-'//chl(1:im) 
  160 il=ntrimto0(ch132) 
      write(nwr,'(4a,a1)')' row numbers (',ch64(1:ir),   &
                       ') , column numbers [',ch132(1:il),']' 
      read(nrd,'(a)') cp132 
      if(cp132.eq.' ') then 
        i=1
        call panum(ch132,mc(kk),npanum,i) 
       if(i.ne.1) goto 170
        do i=1,npanum(2)+2 
         nmc(i)=npanum(i) 
        end do 
!       write(nwr,'(1x,a1,a3)') char(27),'[1A'                          
      else 
       if(index(cp132,'*')+index(cp132,'q').gt.0) goto 170 
       ch132=cp132 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       write(nwr,'(2a)')'                                        ',     &
     &                  '                                        '      
       write(nwr,'(2a)')'                                        ',     &
     &                  '                                        '      
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
       goto 160 
      end if 
                                                                        
      if(nmr(2).eq.0) then 
        nmr(2)=mr(kk) 
        do i=1,mr(kk) 
         nmr(i+2)=i 
        end do 
      end if 
      if(nmc(2).eq.0) then 
        nmc(2)=mc(kk) 
        do i=1,mc(kk) 
         nmc(i+2)=i 
        end do 
      end if 
                                                                        
  170 write(nwr,'(1x,a1,a3)') char(27),'[2A' 

      return 
                                                                        
      END                                           

      subroutine coexam(nmco,info) 
      use glbconst, only: maxco,infotext,nwr
      use comfrm, only: mprd,mprdn,mprds,np,p,up,op,ddp,kp,mprds,mco,   &
                        kcp,mc,mcs,kcp,mr  
      implicit none 
      integer   nmco,info,jca,jco,ipg,i,i0,i1,i2,ica,ipa,ipc,k,    &
                is,istn,j,jb,jf,jj,l,lb,lf,ls,ipar,jcor,max,nd 
      character ch24*24,cp24*24,ch2*2,ci2*2,cb10*10,cf10*10 
      integer   ipanum(64) 
                                                                        
!      nmco = number of transformation matrix                           
!            = 0 run over all matrices                                  
!      info > 0  *** error in the structure ***                         
!      calculates products of parameter values                          
                                                                        
       if(nmco.gt.0) then 
         jca=nmco 
         jco=nmco 
       else 
        ipg=mprds(maxco)+mprd(maxco) 
        do k=1,ipg 
          mprdn(k)=0 
        end do 
        do k=1,maxco 
         mprds(k)=0 
         mprd(k)=0 
        end do 
        jca=1 
        jco=mco 
        ipg=0 
       end if 
                                                                        
!       do k=1,mp                                                       
!        if(kp(k).eq.2)kp(k)=1                                          
!       end do                                                          
                                                                        
!      write(6,'(a,i4)') 'coexam kcp'                                   
       do jcor=jca,jco 
        ica=mcs(jcor) 
!       write(6,'(i5,2x,15i4)')jcor,(kcp(ica+i),i=1,mc(jcor))           
       end do 
                                                                        
       do jcor=jca,jco 
        ipa=mprds(jcor) 
        ipc=mprd(jcor) 
        ipg=mprds(maxco)+mprd(maxco) 
         do k=1,ipg-ipa-ipc 
          i=ipa+k 
          mprdn(i)=mprdn(i+ipc) 
         end do 
         ipg=ipg-ipc 
         do k=1,ipc 
          mprdn(ipg+k)=0 
         end do 
                                                                        
        istn=0 
        ipc=0 
        ica=mcs(jcor) 

        do i=1,mc(jcor) 
          cp24=np(kcp(ica+i)) 
          is=index(cp24,'*') 
          if(is.gt.0) then 
           istn=istn+1 
           lf=1 
           do while(cp24(lf:lf).ne.'_') 
            lf=lf+1 
           end do 
           do while(cp24(lf:lf).eq.'_') 
            lf=lf+1 
           end do 
           ch24=cp24(lf:is-1) 
           cf10=cp24(lf:is-1)
           
           lf=16 
           do while(ch24(lf:lf).eq.' ') 
            lf=lf-1 
           end do 
           ch24=cp24(is+1:) 
           cb10=cp24(is+1:) 
!          write(6,'(/,3i4,a,3a24,3i4,/)')jcor,mc(jcor),mr(jcor),       
!           ' corrsub cp24=',cp24,cf10,cb10                            
           lb=16 
           do while(ch24(lb:lb).eq.' ') 
            lb=lb-1 
         end do
           if(lf+lb.gt.14) then 
            info=lf 
            if(lb.gt.lf) info=lb 
            infotext(1)='effi/transmatrix/ip/error/sn' 
            infotext(2)='**error** length of names of the factors to long'
            if(info.gt.10)then 
             infotext(3)='length exceeds the number of 10' 
             infotext(4)=' ' 
            else 
             infotext(3)=' ' 
            end if 
            goto 100 
           end if 
                                                                        
            k=0 
            do l=1,mc(jcor) 
             ch24=np(kcp(ica+l)) 
             ls=index(ch24,'*') 
!             write(6,'(2a,2(2x,a))')  &                                  
!              ' corrsub ch24,cf10,cb10=',ch24,cf10(:lf),cb10(:lb)     
             if(ls.eq.0) then 
              jj=1 
              do while(ch24(jj:jj).ne.'_') 
               jj=jj+1 
              end do 
              do while(ch24(jj:jj).eq.'_') 
               jj=jj+1 
              end do 
              jf=1 
              if(ch24(jj:jj+lf-1).ne.cf10(1:lf).or.ch24(jj+lf:22).ne.' ')jf=0
              jb=1 
              if(ch24(jj:jj+lb-1).ne.cb10(1:lb).or.ch24(jj+lb:22).ne.' ')jb=0      
!             write(6,'(2i3,2a,2(2x,a))')jf,jb, &
!               ' corrsub ch24,cf10,cb10= ',ch24(jj:jj+lb-1),cf10(:lf),cb10(:lb)
              if(jf.gt.0.or.jb.gt.0) then
                 k=k+1 
                 ipanum(k+2)=l 
              end if 
             end if 
            end do 
            ipanum(2)=k 

!           write(6,'(i3,a,10i4)')jcor,' corr ipanum(2:)=', &
!                                          (ipanum(j),j=2,ipanum(2)+2)          
            max=1 
            nd=-1 
!           call panum(chin,max,nd)                                     
            ch2=ci2(jcor) 
             l=24 
             do while(cp24(l:l).eq.' ') 
              l=l-1 
             end do 
            if(k.lt.2) then 
              infotext(1)='effi/transmatrix/ip/error/sn' 
              infotext(2)='structure error of transformation matrix '//ch2 
              if(k.eq.1)then 
               infotext(3)='parameter '//np(kcp(ica+ipanum(3))) 
               infotext(4)='of the product '//cp24(:l)//' is missing' 
               infotext(5)=' ' 
              else if(k.eq.0)then 
               infotext(3)='parameters of the product '//cp24//' are missing'
               infotext(4)=' ' 
              end if 
              info=1 
              goto 100 
            end if 
                                                                        
            if(k.gt.2) then 
             infotext(1)='effi/transmatrix/ip/error/mult' 
             infotext(2)='structure error of transformation matrix '//ch2 
             k=ipanum(2)-2 
             ch2=ci2(k) 
             infotext(2)=ch2//' parameters of the product '//cp24(:l)// &
                              ' have the same name'
             jj=ipanum(2)
             if(jj.gt.7)jj=7                   
             do l=3,jj 
              infotext(l)=np(kcp(ica+ipanum(l)))(1:24) 
             end do 
             infotext(1+jj)=' ' 
             info=2 
             goto 100 
            end if 
                                                                        
            if(k.eq.2) then 
              i0=kcp(ica+i) 
              i1=kcp(ica+ipanum(3)) 
              i2=kcp(ica+ipanum(4)) 
             p(i0)=p(i1)*p(i2) 
             up(i0)=up(i1)*up(i2) 
             op(i0)=op(i1)*op(i2) 
             ddp(i0)=ddp(i1)*ddp(i2) 
             do j=ipg,ipa+1,-1 
              mprdn(j+3)=mprdn(j) 
             end do 
             ipc=ipc+3 
             ipg=ipg+3 
             kp(i0)=2           ! product parameter 
             mprdn(ipa+1)=i0 
             mprdn(ipa+2)=i1 
             mprdn(ipa+3)=i2 
             do j=ipa+3,ipg,3 
               if(i1.eq.mprdn(j+2).and.i2.eq.mprdn(j+3)) then 
              write(nwr,'(a,/,a,i2,a,/,2(a,a5),a)')                     &
       ' **matrix**',                                              &
       ' structure of transformation matrix ',jcor,                     &
       ' may not be meaningful',                                        &
       ' two products use the  parameters:...',cf10,' and ',cb10,'...'  
             write(nwr,'(2a22,/)') (np(kcp(ica+ipanum(l))),l=3,4) 
               end if 
             end do 
            end if 
          end if  ! is>0 * in the name  
        end do 
        mprd(jcor)=ipc 
        mprds(1)=0 
        do k=2,maxco 
         mprds(k)=mprds(k-1)+mprd(k-1) 
        end do 
        ipar=mc(jcor)-istn 
        if(ipar.gt.mr(jcor)) then 
              write(nwr,'(a,i2,/,a,i2,a,i2/)')                          &
       ' **matrix**  structure of transformation matrix ',jcor,      &
       ' number of parameters (',ipar,                                  &
       ') exceeds number of variables',mr(jcor)                         
        end if 
       end do 
       ipg=mprds(maxco)+mprd(maxco) 
!      write(6,'(20(x,3i3))') (mprdn(k),k=1,ipg)                        
  100 continue 
       return 
      END                                           

      subroutine store_temp(ijstore) 
      use glbconst, only: maxs,maxc,maxp,maxthss,maxpl,maxco,    &
                          maxprd,marray_sp,MDBPLFT
      use compar, only: maxp_sp,maxc_sp,maxsto
      implicit none  
      integer    ijstore,ifrm,istore,idum,k 
      real       rfrm,rstore 
      character  cfrm*4,cstore*4 
     integer,parameter:: nfrmi=1+maxco*2+maxprd+maxp+1+maxs+2+6*maxco+1+ &
                           2*maxco+maxp+2+3*(1+maxs)+3*maxs*(1+maxthss)+ &
                           1+maxc+3*(1+maxs)+7*maxs*(1+maxthss)+maxp+4*maxpl+ &
                           2*maxc+maxs*(1+maxp_sp)+maxs*(1+maxc_sp)+18,&
                    nfrmr=9*maxp+6+maxsto+maxpl+maxc,                    &
                    nfrmc=maxpl*8+maxp*15+maxc*10+maxco*4+maxsto+6*maxs*6 
      common/frmi/ifrm(nfrmi) 
      common/frmr/rfrm(nfrmr) 
      common/frmc/cfrm(nfrmc) 
      integer, parameter :: idumarsp=2*MDBPLFT-nfrmi-nfrmr-nfrmc 
      common/plot/istore(nfrmi),rstore(nfrmr),cstore(nfrmc),           &
                   idum(idumarsp)                                       
                                                                        
      if(ijstore.eq.21) then 
       do k=1,nfrmi 
        istore(k)=ifrm(k) 
       end do 
       do k=1,nfrmr 
        rstore(k)=rfrm(k) 
       end do 
       do k=1,nfrmc 
        cstore(k)=cfrm(k) 
       end do 
      end if 
                                                                        
      if(ijstore.eq.12) then 
       do k=1,nfrmi 
        ifrm(k)=istore(k) 
       end do 
       do k=1,nfrmr 
        rfrm(k)=rstore(k) 
       end do 
       do k=1,nfrmc 
        cfrm(k)=cstore(k) 
       end do 
      end if 
                                                                        
      return 
      END                                           

      subroutine query2(lq,lk,cheader,ch16) 
!     warning: cheader(132) contain information (wrb)
!              controlling the subroutine
!     selection of two entries (matrices  {} & [])
      use glbconst,only: nwr,nrd 
      use compar,  only: maxco 
      use comscd , only: chflen,ld,lw,queryar,lpart,laenge,ext,         &
                         helpar,type                                                                        
      use comeff, only: npl,ncol  
      implicit none
      integer    lq,lk,key
      logical    block,two,b_chname 
                                                                        
      character(len=132):: ch132,cp132,chout,cheader,chin
      character(len=264):: chblank             
      character(len=16) :: chin16,cp16,ch16 
      character(len=5)  :: chred,chblue,chnorm  
      character            chh*1,wrb*1,ch2*2,ch8*8 

        integer i,i0,i1,i10,ii,ikey,iquit,iz,j,jj,jjq,jk,jq,jqh,jz,      &
                iwrl,jsec,k,l,laengez,lapl,le,lkin,ll,lqin,lr,           &
               ipos,jtwo,lp,lpgt,lxx,npx,npl_i,ntrimto0

      chred=char(27)//'[31m' 
      chblue=char(27)//'[34m' 
      chnorm=char(27)//'[0m' 
                                                                        
       b_chname=.false. 
       lxx=16 
       lqin=lq 
       lkin=lk 
       chin16=ch16 
       jqh=0 
       wrb=cheader(132:132) 
       cheader(132:132)=' ' 
       npx=npl-3 
                                                                        
       if(wrb.eq.'w'.or.wrb.eq.'r'.or.wrb.eq.'l') npx=ncol(1)-3 
       if(npx.gt.130) npx=130 
!      write(6,'(a,4i4)') ' subr query lq,nwr,nrd,npl=',lq,nwr,nrd,npl  
!      write(6,'(a)') (queryar(iq)(:npl),iq=1,lq)                       
!      write(6,'(a)') (helpar(iq)(:npl),iq=1,lq)                        
!      write(6,'(a)') cheader(:80)                                      
      i0=ichar('0') 
      iquit=0 
      chblank=' ' 
      npl_i=ncol(1)-3 
      block=.false. 
      if(ch16(16:16).eq.'#') block=.true. 
      chin=ch16(:15) 
      ll=ntrimto0(chin) 
      le=ll 
      if(le.eq.0) lk=lq 
      ch16=chin 
      two=.false. 
      if(lk.ne.lq) two=.true. 
      if(cheader.eq.' ') then 
       do k=1,npx 
        chflen(k:k)='-' 
       end do 
      else 
       chh='-' 
       l=ntrimto0(cheader) 
       chflen=cheader 
       i=(npx-l)/2 
       do k=l,1,-1 
        chflen(i+k:i+k)=chflen(k:k) 
       end do 
       do k=1,i 
        chflen(k:k)=chh 
       end do 
       k=i+l+1 
       do while(k.le.npx) 
        chflen(k:k)=chh 
        k=k+1 
       end do 
      end if 
                                                                        
      iwrl=0 
      write(nwr,'(a)') chflen(:npx) 
      iwrl=iwrl+1 
      if(wrb.eq.'w')write(10,'(a)') chflen(:npx) 
      if(wrb.eq.'r') then 
       read(10,'(a)')chflen 
!       write(nwr,'(2a)') ' query_b ',chflen(:npx-10)                   
      end if 
                                                                        
                                                                        
      do k=1,npx 
       chflen(k:k)='-' 
      end do 
    5 continue 
!      write(6,'(a)') ' query  label 5'                                 
      laengez=0 
      do k=1,lq 
       if(ext(k).eq.' ') then 
        ld(k)=0 
       else 
        chin=ext(k) 
        ld(k)=ntrimto0(chin) 
       end if 
       chin=queryar(k) 
       ll=ntrimto0(chin) 
       lw(k)=ll 
       queryar(k)=chin 
       if(chin(1:1).eq.'q') iquit=1 
!       write(6,'(a)') ch132(1:ll)                                      
       ll=ll+ld(k)+6                       !  28.11.05  
       if(ll.gt.laengez) laengez=ll 
      end do 

      lpart(0)=0 
      lapl=0 
      if(block) then 
       laengez=laengez+2   ! 3   
       lapl=npx/laengez 
       if(lapl.eq.0) then 
        iz=0 
       else 
        iz=lq/lapl 
       end if 
       if(iz*lapl.lt.lq) iz=iz+1 
!       write(6,'(a,2i4)') ' lapl,iz',lapl,iz                           
   10  if(lapl.eq.0) goto 20 
       lr=lapl*iz-lq 
!       if(lr.ge.((lapl+1)/2)) then                                     
       if(lr.ge.(iz-1)) then 
        lapl=lapl-1 
        goto 10 
       end if 
       if(lr.lt.0) lapl=lapl+1 
       lr=lapl*iz-lq 
!      write(6,'(a,2i4)') ' lapl,lr',lapl,lr                            
      end if 
                                                                        
   20 if(lapl.eq.0) then 
       iz=1 
       laengez=0 
       lpart(iz)=0 
       do k=1,lq 
        laenge(k)=((lw(k)+5)/10+1)*10-2+ld(k) 
        if(laenge(k).lt.npx) then 
         laengez=laengez+laenge(k)+6 
!         write(6,'(a,i4)') ' laengez=',laengez                         
         lpart(iz)=lpart(iz)+1 
         if(laengez.ge.npx) then 
          if(laengez.gt.npx) then 
           laengez=laenge(k)+4 
           lpart(iz)=lpart(iz)-1 
           lpart(iz+1)=1 
          else 
           laengez=0 
           lpart(iz+1)=0 
!         write(6,'(a,i4)') ' *laengez=',laengez                        
          end if 
           if(k.le.lq) iz=iz+1 
!         write(6,'(a,2i4)') ' *k,iz=',k,iz                             
         end if 
        else 
         laenge(iz+1)=laenge(k) 
         lpart(iz+1)=1 
         if(k.le.lq) iz=iz+1 
        end if 
       end do 
      else 
       do k=1,lq 
        laenge(k)=laengez 
       end do 
       do k=1,iz-1 
        lpart(k)=lapl 
       end do 
       lpart(iz)=lapl-lr 
      end if 
                                                                        
!       write(6,'(a,8i4)') ' iz=',iz                                    
!       write(6,'(a,16i4)') ' lpart=',(lpart(i),i=1,iz)                 
!       write(6,'(a,16i4)') ' lw=',(lw(i),i=1,iz)                       
!       write(6,'(a,15i4)') ' ld    =',(ld(i),i=1,lq)                   
!       write(6,'(a,15i4)') ' laenge=',(laenge(i),i=1,lq)               
      if(jqh.gt.0) goto 42 
       jjq=0 
       jq=0 
       jk=0 
       jtwo=0 
       lpgt=0 
       ikey=0 
   40 continue 
!      write(6,'(a)') ' query  label 40'                                
      jtwo=jtwo+1 
      lpgt=lpgt-1 
                                                                        
      if(le.gt.0.and.ikey.eq.0)then 
       k=jjq+1 
!       do while(ch16(:le).ne.queryar(k)(:le).and.le.gt.0.and.k.le.lq)  
       do while(index(queryar(k),ch16(:le)).eq.0.and.le.gt.0.and.k.le.lq) 
        k=k+1 
       end do 
       if(k.gt.lq) then 
        k=1 
!        do while(ch16(:le).ne.queryar(k)(:le).and.le.gt.0.and.k.le.lq) 
        do while(index(queryar(k),ch16(:le)).eq.0.and.le.gt.0.and.k.le.lq)
         k=k+1 
        end do 
       end if 
       jj=k 
      else if(ikey.ge.1)then 
       jj=jjq+1 
       if(jj.gt.lq) jj=1 
      else if(ikey.le.-1)then 
       jj=jjq-1 
       if(jj.lt.1) jj=lq 
      else 
       jj=0 
      end if 
      if(abs(ikey).eq.1)then 
       jq=0 
       if(jtwo.eq.2)jtwo=1 
      end if 
      if(abs(ikey).eq.2)then 
       jk=0 
       if(jtwo.eq.2)jtwo=1 
      end if 
!     ikey=-1   ! ->   red colour                                       
!     ikey=1    ! <-   red colour                                       
!     ikey=+2   ! up-arrow  blue                                        
!     ikey=-2   ! down-arrow  blue                                      
                                                                        
      jz=0 
      do k=1,lq 
       if(jj.eq.k)then 
        jjq=k 
        jz=1 
        if(ld(k).gt.0) then 
         if(jq.eq.0) then 
          type(k)=chred//                                               &
     &            '['//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k))//']'    
          jq=k 
         end if 
!        write(6,'(a,8i4)') ' 40 jtwo,jq,jk=',jtwo,jq,jk                
         if(jq.ne.k.and.jq.ne.jk) then 
          type(k)=chblue//                                              &
     &           '{'//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k))//'}'     
          jk=k 
         end if 
        else 
         if(jq.eq.0) then 
          type(k)=chred//'['//queryar(k)(1:lw(k))//']' 
          jq=k 
         end if 
         if(jq.ne.k.and.jq.ne.jk) then 
          type(k)=chblue//'{'//queryar(k)(1:lw(k))//'}' 
          jk=k 
         end if 
        end if 
        ch16=queryar(k) 
       else 
        if(ld(k).gt.0.and.(.not.two)) then 
         type(k)=chnorm//' '//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k)) 
        else 
         if(jq.eq.k) then 
          type(k)=chred//                                               &
     &       '['//queryar(k)(1:lw(k))//' '//ext(k)(:ld(k))//']'         
         else if(jk.eq.k) then 
          type(k)=chblue//'{'//queryar(k)(1:lw(k))//'}' 
         else 
          type(k)=chnorm//' '//queryar(k)(1:lw(k)) 
         end if 
        end if 
       end if 
      end do 
                                                                        
      if(jz.eq.0) jtwo=0 
      if(wrb.eq.'r') then 
!       write(6,'(a)')'combuff query wrb.eq.r)'                         
        ch132=' ' 
        do while(ch132(3:5).ne.'---') 
         read(10,'(a)') ch132 
         write(nwr,'(2a)')ch132(:ncol(1)) 
         iwrl=iwrl+1 
       end do 
       lq=ichar(ch132(1:1))-i0 
       chh=ch132(2:2) 
       if(chh.ne.'-') lq=10*lq+ichar(chh)-i0 
!       write(6,'(a,i4)')'combuff query --------------end',lq           
       goto 100 
      end if 
                                                                        
   42 continue 
                                                                        
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
!      write(6,'(a,4i4)')                                               
!     &    ' ii,lpart(jz)=',ii,lpart(jz),laenge(ii+1),npl_i             
       if(abs(ii).lt.maxco-lpart(jz)) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(a,/,1x,a)')                                        &
     &               type(ii+1)(1:npl_i-3),type(ii+1)(npl_i-2:)         
         iwrl=iwrl+2 
        else 
         call itoc8(ch8,lpart(jz)) 
         ch2=ch8(:2) 
!        write(ch2,'(i2)')lpart(jz)                                     
         write(nwr,'('//ch2//'(a))')                                    &
     &               (type(ii+j)(1:laenge(j+ii)),j=1,lpart(jz))         
         iwrl=iwrl+1 
        end if 
       end if 
      end do 
                                                                        
!      write(nwr,'(2a)')'----------------------------------------',     
!     &'----------------------------------------'                       
!      write(6,'(a,8i4)')                                               
!     & ' query npl,le,lq,lpgt,jsec=',npl,le,lq,lpgt,jsec               
      do k=1,npx 
       chflen(k:k)='-' 
      end do 
      write(nwr,'(a)') chflen(1:npx) 
      iwrl=iwrl+1 
      jsec=0 
                                                                        
      if(jqh.gt.0) goto 43 
      if(le.eq.0) goto 100 
      if(lpgt.gt.0) goto 50 
   43 continue 
!      write(6,'(a)') ' query  label 41'                                
      if(lq.gt.1) then 
        ikey=key() 
        if(ikey.lt.0) then 
                                   ! ->   red colour                    
         if(ikey.eq.-65) ikey=-1 
                                   ! <-   red colour                    
         if(ikey.eq.-66) ikey=1 
                                   ! up-arrow  blue                     
         if(ikey.eq.-67) ikey=+2 
                                   ! down-arrow  blue                   
         if(ikey.eq.-68) ikey=-2 
          ch132='shift' 
          write(nwr,'(a1)')' ' 
        else 
         if(char(ikey).eq.'@')then 
          ch132=' ' 
          write(nwr,'(a1)')' ' 
         else 
          ch132(1:1)=char(ikey) 
                                                       ! for choice     
          read(nrd,'(a)') ch132(2:) 
         end if 
         ikey=0 
        end if 
       jqh=0 
      else 
       ch132=' ' 
       write(nwr,'(a)') chflen(1:npx) 
       iwrl=iwrl+1 
      end if 
                                                                        
      if(wrb.eq.'w'.and.ch132(1:1).eq.' ') then 
        ii=0 
        do jz=1,iz 
         ii=ii+lpart(jz-1) 
         if(abs(ii).lt.maxco-lpart(jz)) then 
          if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
           write(10,'(a,/,1x,a)')                                       &
     &               type(ii+1)(1:npl_i-3),type(ii+1)(npl_i-2:)         
          else 
           call itoc8(ch8,lpart(jz)) 
           ch2=ch8(:2) 
!          write(ch2,'(i2)')lpart(jz)                                   
           write(10,'('//ch2//'(a))')                                   &
     &               (type(ii+j)(1:laenge(j+ii)),j=1,lpart(jz))         
          end if 
         end if 
        end do 
        if(jq.le.9) then 
         chflen(1:1)=char(jq+i0) 
        else 
         i10=jq/10 
         i1=jq-10*i10+i0 
         chflen(1:2)=char(i10+i0)//char(i1) 
        end if 
        write(10,'(a)') chflen(1:npx) 
      end if 
                                                                        
      if(jsec.eq.1) then 
       write(nwr,'(1x,a1,a3)') char(27),'[3A' 
!       iwrl=iwrl-2                                                     
      write(nwr,'(a)') chblank(:npl_i) 
      else 
       write(nwr,'(1x,a1,a3)') char(27),'[2A' 
!       iwrl=iwrl-1                                                     
       write(nwr,'(a)') chblank(:npl_i) 
      end if 
      write(nwr,'(1x,a1,a3)') char(27),'[2A' 
!      iwrl=iwrl-1                                                      
      jsec=0 
      chin=ch132 
      call nextchar(chin,0,ipos,chout,l) 
      if(l.eq.0)l=1 
      ch16=chout(1:l) 
      call nextchar(chin,1,ipos,chout,lp) 
      cp132=chout 
!      write(6,'(a,i4,2a)') ' query label 41 lp=',lp,' ch16=',ch16      
                                                                        
      if(ch16(1:3).eq.'he ') then 
       write(nwr,'(a,a)') ' selection by typing a substring/RET',       &
     & ' or by repeatedly using shift keys//'                           
       write(nwr,'(2a,/,a)')' selection of two matrices: by substrings',&
     & ' or by repeatedly using shift keys;',                           &
     & ' first matrix by left,right-key; second matrix by up,down-key//'
       write(nwr,'(a,a,/)') ' two strings: the first string selects,',  &
     & ' the second replaces the name'                                  
      end if 
!      read(nrd,'(a)') chout                                            
      if(lp.gt.0) then 
       if(two)then 
        if(lp.gt.16) lp=16 
        cp16=cp132(:lp) 
        jq=0 
        lpgt=2 
        jtwo=0 
       else 
        jj=0 
        do k=1,lq 
!         if(ch16(:l).eq.queryar(k)(:l).and.jj.eq.0) jj=k               
         if(index(queryar(k),ch16(:l)).gt.0.and.jj.eq.0) jj=k 
        end do 
        if(jj.eq.0) then 
         lp=0 
        else 
         le=lp 
         if(le.gt.16) le=16 
         queryar(jj)=cp132 
         ch16=cp132(1:le) 
         b_chname=.true. 
        end if 
       end if 
      else 
       le=l 
       if(le.gt.16) le=16 
       call lc_character(ch132) 
                                                                        
                                            !  300307                   
       if(ch132(1:3).eq.'he ') then 
        if(jq.gt.0) then 
         call help(helpar(jq)) 
         ch16(1:1)='r' 
         goto 101 
        end if 
       end if 
                                                                        
       chh=ch16(1:1) 
       if(chh.eq.' ') then 
        lk=jk 
        if(two.and.lk.eq.0) then 
         write(nwr,'(a)') ' second matrix ?' 
         jsec=1 
         goto 43 
        end if 
        lq=jq 
!         write(6,'(a,2i4)') ' query lq,lk=',lq,lk                      
        if(lq.eq.0) then 
          goto 40 
        else 
         goto 100 
        end if 
       end if 
!       if(iquit.eq.0.and.chh.eq.'q') chh='*'                           
       if(chh.eq.'*'.or.chh.eq.'q') then 
        lq=0 
        lk=0 
        goto 100 
       end if 
      end if 
                                                                        
   50 ii=0 
      write(nwr,'(1x,a1,a3)') char(27),'[2A' 
      iwrl=iwrl-1 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(a,/,a)') chblank(:npl_i),chblank(:npl_i) 
         iwrl=iwrl+2 
        else 
         write(nwr,'(a)') chblank(:npl_i) 
         iwrl=iwrl+1 
        end if 
       end if 
      end do 
      ii=0 
      do jz=1,iz 
       ii=ii+lpart(jz-1) 
       if(ii+1.lt.maxco) then 
        if(lpart(jz).eq.1.and.laenge(ii+1).gt.npl_i) then 
         write(nwr,'(1x,a1,a3)') char(27),'[3A' 
         iwrl=iwrl-2 
        else 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         iwrl=iwrl-1 
        end if 
       end if 
      end do 
      if(.not.two) then 
       jq=0 
       jtwo=0 
       if(lp.gt.0) goto 5 
      else 
!       write(6,'(a,8i4)') ' lp,lpgt,jtwo=',lp,lpgt,jtwo                
       if(jtwo.eq.2) then 
        jq=0 
        jk=0 
        jtwo=0 
       end if 
       if(lpgt.eq.1) then 
!       write(6,'(a,a)') ' cp16=',cp16                                  
        ch16=cp16 
        le=lp 
        if(jq.eq.0) jtwo=0 
        jk=0 
       end if 
      end if 
      goto 40 
  100 continue 
      ch16(16:16)=char(iwrl+i0) 
      ch16(1:1)='n' 
      if(b_chname) ch16(1:1)='y' 
  101 continue 
      write(nwr,'(1x,a1,a3,a5)') char(27),'[1A',chnorm 
      return 
      END                                           


      subroutine decorunit(jco,info) 
      use comfrm, only: kcp,np,p,up,op,ddp,kp,pst,plast,pold,pmin,      &
                        cpstor,fpstor,mc,mrce,mcs,mrces, mco,mp,mrcet,  &
                        kco,mr,mrs,kpl,nthpl
      use comscd, only: nmkcp,fp_sc,pp_sc,scratch,fscratch,nmc,nmkcp,   &
                        nmr,nmc
      implicit none 
      integer jco,kk,mrsk,mcsk,nmr2,nmc2,k,i,ii,ie,jc,js,jr,jst,        &
     &        i1,mpu,i0,ni,j,jk,numi1,info                              
                                                                        
       kk=kco(jco) 
       mrsk=mrs(kk) 
       mcsk=mcs(kk) 
       nmr2=nmr(2) 
       nmc2=nmc(2) 
       do i=1,nmc2 
        nmkcp(i)=kcp(mcsk+nmc(i+2)) 
       end do 
       i0=ichar('0') 
        do j=1,nmr2 
         jr=nmr(j+2) 
         jst=mrces(jco)+(jr-1)*mc(jco) 
         fp_sc(j)=fpstor(jst+nmc(1+2)) 
         pp_sc(j)=cpstor(jst+nmc(1+2)) 
!        write(6,'(a)')fp_sc(j)                                         
        end do 
                                                                        
        numi1=0 
        DO i1=1,nmr2-1 
         j=0 
         do i=1,nmc2 
           if(i1.eq.nmc(i+2)) then 
             j=j+1 
             numi1=i 
           end if 
         end do 
         k=mcs(kk)+i1 
         mpu=kcp(k) 
                                                                        
         if(numi1.eq.0)then 
          info=1 
          return 
         end if 
                                                                        
         do i=mp+1,k+2,-1 
          kcp(i)=kcp(i-1) 
         end do 
         do i=1,mp+1 
          if(kcp(i).gt.mpu) kcp(i)=kcp(i)+1 
         end do 
         kcp(k+1)=mpu+1 
                                                                        
          do i=mp+1,mpu+1,-1 
             ii=i-1 
             ie=i 
             np(ie)=np(ii) 
              p(ie)=p(ii) 
             up(ie)=up(ii) 
             op(ie)=op(ii) 
             ddp(ie)=ddp(ii) 
             kp(ie)=kp(ii) 
          pst(ie)  =   pst(ii) 
          plast(ie)= plast(ii) 
          pold(ie) =  pold(ii) 
          pmin(ie) =  pmin(ii) 
          end do 
                                                                        
         jc=mrces(kk) 
         do i=1,mr(kk) 
          do k=1,mc(kk) 
           jc=jc+1 
           if(k.eq.i1) then 
            cpstor(jc)=cpstor(jc) 
            ni=(ichar(fpstor(jc)(2:2))-i0)*10+ichar(fpstor(jc)(3:3))-i0 
            if(ni.le.4)fpstor(jc)(3:3)='5' 
            if(ichar(fpstor(jc)(4:4)).eq.i0)fpstor(jc)(4:4)='1' 
           end if 
          end do 
         end do 
         js=mrces(kk) 
         jc=js 
         do i=1,mr(kk) 
          do k=1,mc(kk) 
           jc=jc+1 
           js=js+1 
           scratch(js)=cpstor(jc) 
           fscratch(js)=fpstor(jc) 
           if(k.eq.i1) then 
            js=js+1 
            scratch(js)=cpstor(jc) 
            fscratch(js)=fpstor(jc) 
           end if 
          end do 
         end do 
                                                                        
         if(kk.lt.mco) then 
          do i=mrces(kk+1)+1,mrcet 
            js=js+1 
           scratch(js)=cpstor(i) 
           fscratch(js)=fpstor(i) 
          end do 
         end if 
                                                                        
          mp=mp+1 
          mc(kk)=mc(kk)+1 
          mcsk=mcs(kk) 
          mrce(kk)=mr(kk)*mc(kk) 
          do j=2,mco 
           mcs(j)=mcs(j-1)+mc(j-1) 
           mrces(j)=mrces(j-1)+mrce(j-1) 
          end do 
           mrcet=mrcet+mr(kk) 
          do i=mrces(kk)+1,mrcet 
           cpstor(i)=scratch(i) 
           fpstor(i)=fscratch(i) 
           end do 
                                                                        
         nmc2=nmc2+1 
         if(nmc2.lt.numi1+2) then 
           nmc(3+numi1)=nmc(2+numi1)+1 
         else 
          do j=nmc2,numi1+2,-1 
           nmc(j+2)=nmc(j+1)+1 
          end do 
         end if 
                                                                        
!        write(6,'(2a)')'np(nmkcp(1))=',np(nmkcp(1))                    
         do i=1,nmc2 
          nmkcp(i)=kcp(mcsk+nmc(i+2)) 
!          write(6,'(i4,a)') i,np(nmkcp(i))                             
         end do 
!         write(6,'(a,16i4)')'nmkcp(1..)=',(nmkcp(i),i=1,nmc2)          
         ie=nmkcp(numi1+1) 
         ii=nmkcp(numi1) 
         p(ie)=p(ii) 
         up(ie)=up(ii) 
         op(ie)=op(ii) 
         ddp(ie)=ddp(ii) 
         pst(ie)  =   pst(ii) 
         plast(ie)= plast(ii) 
         pold(ie) =  pold(ii) 
         pmin(ie) =  pmin(ii) 
                                                                        
         nmc(2)=nmc2 
         j=i1+1 
         jk=kpl(mrsk+nmr(j+2)) 
         np(nmkcp(numi1+1))(1:24)=nthpl(jk) 
!         np(nmkcp(numi1+1))(28:32)=fp_sc(j)(1:3)//'.'//fp_sc(j)(4:4)   
         np(nmkcp(numi1+1))(28:32)=np(nmkcp(1))(28:33) 
         p(nmkcp(numi1+1))=pp_sc(j)*p(nmkcp(1)) 
         mcsk=mcs(kk) 
         do i=1,nmc2 
          nmkcp(i)=kcp(mcsk+nmc(i+2)) 
         end do 
        END DO 
!       write(6,'(2a)')'np(nmkcp(1))=',np(nmkcp(1))                     
!       write(6,'(af12.4)')'p(nmkcp(1))=',p(nmkcp(1))                   
        p(nmkcp(1))=pp_sc(1)*p(nmkcp(1)) 
!       write(6,'(af12.4)')'p(nmkcp(1))=',p(nmkcp(1))                   
                                                                        
        do j=1,nmr2 
         jr=nmr(j+2) 
!        jk=kpl(mrsk+jr)                                                
         jst=mrces(jco)+(jr-1)*mc(jco) 
                                                                        
         do i=1,nmr2 
          fpstor(jst+nmc(i+2))='f020' 
          cpstor(jst+nmc(i+2))=0.0 
          if(i.eq.j)                                                    &
     &    cpstor(jst+nmc(i+2))=1.0                                      
         end do 
        end do 
       return 
      END                                           

      subroutine combinerm(icase,jco,kwin,l_edit) 
       use glbconst, only: maxc,maxp,maxss,maxco,maxpl,maxvaco,nrd,nwr
       use compar, only: maxsto,maxscr
       use comfrm, only: ncor,kcp,kpl,kco,mc,mr,mrce,mrs,mcs,    &
                         mrces,cpstor,fpstor,mco,mcon,mp,mpl,mrcet 
       use comscd, only: npanum,kcpst,nmr,nmc,scratch,helpar,  &
                         queryar,ext,fscratch
       use comeff, only: npl 
      implicit none
      integer, intent(in):: icase,kwin,l_edit
      integer, intent(inout):: jco

      integer, dimension(maxco) :: i1ar
      integer, dimension(maxco,16) :: i2ar

      character(len=16),dimension(maxco):: ncor_h
      character(len=132):: ch132,querytype,chcom
      character(len=80) :: chdf 
      character(len=24) :: ch24,cp24
      character(len=1)  :: ch1 

       integer i,i0,i1,i2,ic,ic1,ic2,ih,ip,ir,j,jh,jjna,jna,js,         &
               ki1,kk,kk1,kk2,kkn,kn,knc,k,knr,l,l1,l2,lh,lk,lq,lp,m,   &
               mkk,mkk2,mkki,mkkn,nk1,nk2,nmc2,nmr2,npak,npa2,ntrimto0 

       i0=ichar('0') 
                                                                        
!      icbrm=1 only rm                                                  
!      icbrm=0 combine matrices nm_name with matrices nmsname           
!      where n,m are numbers and integer s is a set number              
!      nm_name is taken as the common name                              
       if(icase.eq.0) goto 100 
                                                                        
       lq=3 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf='m' 
       chdf(80:80)='#' 
       querytype='combining matrices' 
       helpar(1)='effi/combine/abname' 
       helpar(2)='effi/combine/name' 
       helpar(3)='effi/combine/name/ask' 
       helpar(4)='effi/combine/distribute' 
       queryar(1)='matrices of equal ab__name' 
       queryar(2)='equal __name ' 
       queryar(3)='equal __name (enquire)' 
       queryar(4)='combine for distributed parameters' 
       call query(lq,lk,querytype,chdf) 
       if(lq.eq.0) lq=1 
                                                                        
                                                                        
       do i=1,maxco 
        do k=1,4 
         i2ar(i,k)=0 
        end do 
       end do 
                                                                        
       if(lq.eq.1)then 
        jna=0 
        do k=1,mcon 
         kk=kco(k) 
         ch132=ncor(kk) 
         ic1=ichar(ch132(1:1))-i0 
         ic2=ichar(ch132(2:2))-i0 
         l=ntrimto0(ch132) 
!         if(ch132(3:3).eq.'_'.and.ic1.ge.0.and.ic1.le.9                
!      &                      .and.ic2.ge.0.and.ic2.le.9                
!      &                      .and.mc(kk).lt.mr(kk) )then               
          ch24=ch132 
          jna=jna+1 
          i1ar(jna)=k 
          jjna=0 
          do m=k+1,mcon 
           kk=kco(m) 
           ch132=ncor(kk) 
           l=ntrimto0(ch132) 
!           if(ch132(3:3).ne.'_') then                                  
            cp24=ch132 
!            cp24(3:3)='_'                                              
!            write(6,'(a,2a24)')' ch24.eq.cp24=',ch24,cp24              
            if(ch24.eq.cp24)then 
             jjna=jjna+1 
             i2ar(jna,jjna)=m 
            end if 
!           end if                                                      
          end do 
!        end if                                                         
        end do 
       else if(lq.eq.2)then 
        jna=0 
        do k=1,mcon 
         kk=kco(k) 
         ch132=ncor(kk) 
         ic1=index(ch132,'_')+1 
         do while(ch132(ic1:ic1).eq.'_') 
          ic1=ic1+1 
         end do 
         ch24=ch132(ic1:) 
         jna=jna+1 
         i1ar(jna)=k 
         jjna=0 
         do m=k+1,mcon 
           kk=kco(m) 
           ch132=ncor(kk) 
           ic1=index(ch132,'_')+1 
           do while(ch132(ic1:ic1).eq.'_') 
            ic1=ic1+1 
           end do 
           cp24=ch132(ic1:) 
           if(ch24.eq.cp24)then 
            jjna=jjna+1 
            i2ar(jna,jjna)=m 
           end if 
         end do 
        end do 
       else if(lq.eq.3)then 
        jna=0 
        do k=1,mcon 
         ih=kco(k) 
         ch132=ncor(ih) 
         lh=ntrimto0(ch132) 
         ic1=index(ch132,'_')+1 
         do while(ch132(ic1:ic1).eq.'_') 
          ic1=ic1+1 
         end do 
         ch24=ch132(ic1:) 
         jna=jna+1 
         i1ar(jna)=k 
         jjna=0 
         do m=k+1,mcon 
           ip=kco(m) 
           ch132=ncor(ip) 
           lp=ntrimto0(ch132) 
           ic1=index(ch132,'_')+1 
           do while(ch132(ic1:ic1).eq.'_') 
            ic1=ic1+1 
           end do 
           cp24=ch132(ic1:) 
           if(ch24.eq.cp24)then 
            querytype=ncor(ih)(:lh)//' with '//ncor(ip)(:lp) 
            ch1='y' 
            chcom='effi/combine/ask' 
            call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
            if(ch1.eq.'y')then 
             jjna=jjna+1 
             i2ar(jna,jjna)=m 
            end if 
           end if 
         end do 
        end do 
       else if(lq.eq.4)then 
        jna=0 
        do k=1,mcon 
         kk=kco(k) 
         ch132=ncor(kk) 
         ic1=ichar(ch132(1:1))-i0 
         ic2=ichar(ch132(2:2))-i0 
         l=LEN_TRIM(ch132) 
!         write(6,'(a,2x,4i3)')ch132(:l),ic1,ic2                        
         if(ch132(3:3).eq.'_'.and.ic1.ge.0.and.ic1.le.9                 &
                             .and.ic2.ge.0.and.ic2.le.9                 &
                             .and.mc(kk).lt.mr(kk) )then                 
          ch24=ch132 
          jna=jna+1 
          i1ar(jna)=k 
          jjna=0 
          do m=k+1,mcon 
           kk=kco(m) 
           ch132=ncor(kk) 
           l=ntrimto0(ch132) 
           if(ch132(3:3).ne.'_') then 
            cp24=ch132 
            cp24(3:3)='_' 
            if(ch24.eq.cp24)then 
             jjna=jjna+1 
             i2ar(jna,jjna)=m 
            end if 
           end if 
          end do 
         end if 
        end do 
       end if ! icase 
                                                                        
!       write(6,'(a,2i3)') 'combine j,jj=',jna,jjna                     
!       write(6,'(23i3)') (i1ar(k),k=1,jna)                             
!       do i=1,jna                                                      
!        write(6,'(23i3)') (i2ar(i,k),k=1,jjna)                         
!       end do                                                          
                                                                        
       jco=jco+1 
       do l1=1,jna 
        i1=i1ar(l1) 
        l2=1 
        jco=i1 
        do while(i2ar(l1,l2).gt.0) 
         i2=i2ar(l1,l2) 
         l2=l2+1 
                                                                        
!         write(6,'(a,3x,2i3)')ncor(kco(i1)),i1,i2                      
!          write(6,'(a,3x,20i4)')' nmc2=',(nmc(i),i=1,20) 
                                                                             
         nmr2=nmr(2) 
         nmc2=nmc(2) 
                                                                        
          kk=kco(i1) 
          kk2=kco(i2) 
          nmc2=nmc2+mc(kk2) 
           i=0 
          do j=nmc(2)+3,nmc2+2 
           i=i+1 
           nmc(j)=mc(kk)+i 
          end do 
          nmr2=nmr2+mr(kk2) 
          i=0 
          do j=nmr(2)+3,nmr2+2 
           i=i+1 
           nmr(j)=mr(kk)+i 
          end do 
                                                                        
          nmc(2)=nmc2 
          nmr(2)=nmr2 
                                                                        
          do i=1,mp 
           kcpst(i)=kcp(i) 
          end do 
          nk1=mcs(kk+1) 
          nk2=nk1+mc(kk2) 
          j=mcs(kk2) 
          do i=nk1+1,nk2 
           j=j+1 
           kcp(i)=kcpst(j) 
          end do 
                                                                        
         j=nk2 
         ki1=kco(i1) 
         do k=i1+1,mcon 
            kk1=kco(k) 
          if(k.ne.i2) then 
            do i=1,mc(kk1) 
             j=j+1 
             kcp(j)=kcpst(mcs(kk1)+i) 
            end do 
           end if 
         end do 
                                                                        
          do i=1,mpl 
           kcpst(i)=kpl(i) 
          end do 
          nk1=mrs(kk+1) 
          nk2=nk1+mr(kk2) 
          j=mrs(kk2) 
          do i=nk1+1,nk2 
           j=j+1 
           kpl(i)=kcpst(j) 
          end do 
                                                                        
         j=nk2 
         do k=i1+1,mcon 
            kk1=kco(k) 
          if(k.ne.i2) then 
            do i=1,mr(kk1) 
             j=j+1 
             kpl(j)=kcpst(mrs(kk1)+i) 
            end do 
           end if 
         end do 
                                                                        
        mkk=mrces(kk) 
        js=mkk 
        do ir=1,mr(kk) 
         mkki=mkk+(ir-1)*mc(kk) 
         do ic=1,mc(kk) 
          js=js+1 
          scratch(js)=cpstor(mkki+ic) 
          fscratch(js)=fpstor(mkki+ic) 
         end do 
         do ic=1,mc(kk2) 
          js=js+1 
          scratch(js)=0.0 
          fscratch(js)='f031' 
         end do 
        end do 
                                                                        
        mkk2=mrces(kk2) 
        do ir=1,mr(kk2) 
        do ic=1,mc(kk) 
         js=js+1 
         scratch(js)=0.0 
         fscratch(js)='f031' 
        end do 
        mkki=mkk2+(ir-1)*mc(kk2) 
        do ic=1,mc(kk2) 
         js=js+1 
         scratch(js)=cpstor(mkki+ic) 
         fscratch(js)=fpstor(mkki+ic) 
        end do 
        end do 
                                                                        
        do k=kk+1,mco 
        if(k.ne.kk2) then 
          mkk=mrces(k) 
          do j=mkk+1,mkk+mrce(k) 
           js=js+1 
           scratch(js)=cpstor(j) 
           fscratch(js)=fpstor(j) 
          end do 
        end if 
        end do 
                                                                        
         mc(kk)=mc(kk)+mc(kk2) 
         mc(kk2)=0 
         mr(kk)=mr(kk)+mr(kk2) 
         mr(kk2)=0 
         mrce(kk)=mr(kk)*mc(kk) 
         mrce(kk2)=0 
         do j=2,mco 
          mrs(j)=mrs(j-1)+mr(j-1) 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
         mrcet=mrces(mco)+mrce(mco) 
         do i=mrces(kk)+1,mrcet 
          cpstor(i)=scratch(i) 
          fpstor(i)=fscratch(i) 
         end do 
                                                                        
         do i=1,maxco 
          kco(i)=0 
         end do 
                                                                        
         do i=1,mco 
         kco(i)=i 
         end do 
         mcon=mco 
                                                                        
                                                                        
      nmr(2)=mr(kk) 
      do i=1,mr(kk) 
       nmr(i+2)=i 
      end do 
      nmc(2)=mc(kk) 
      do i=1,mc(kk) 
       nmc(i+2)=i 
      end do 
!     write(6,'(a,i4)')' corr jco=',jco                                 
      call  printcp(jco,kwin,l_edit) 
!      read(5,'(a)')                                                    
!      write(nwr,'(a)')                                                 
      end do 
      end do 
!     jump to rm 0x0 matrices                                           
  100 continue 
                                                                        
       jna=2 
       do k=1,mcon 
        kk=kco(k) 
        if(mc(kk).gt.0) then 
         jna=jna+1 
         npanum(jna)=k 
        end if 
       end do 
       npa2=jna-2 
!-------------------------------------                                  
        jh=2 
        do i=1,mcon 
         j=0 
         do k=3,npa2+2 
          if(npanum(k).eq.i) j=j+1 
         end do 
          if(j.eq.0) then 
           jh=jh+1 
           npanum(npa2+jh)=i 
          end if 
        end do 
        npanum(2)=mcon 
                                                                        
        do i=1,mp 
         kcpst(i)=kcp(i) 
        end do 
                                                                        
        jh=0 
        do i=1,mcon 
          kn=kco(npanum(2+i)) 
          knc=mc(kn) 
          do k=1,knc 
           jh=jh+1 
           kcp(jh)=kcpst(mcs(kn)+k) 
          end do 
        end do 
        do i=1,mpl 
         kcpst(i)=kpl(i) 
        end do 
                                                                        
        jh=0 
        do i=1,mcon 
          kn=kco(npanum(2+i)) 
          knr=mr(kn) 
          do k=1,knr 
           jh=jh+1 
           kpl(jh)=kcpst(mrs(kn)+k) 
          end do 
        end do 
                                                                        
        js=0 
        do k=1,mcon 
           npak=npanum(2+k) 
           kk=kco(k) 
           kkn=kco(npak) 
           mkkn=mrces(kkn) 
           do j=mkkn+1,mkkn+mrce(kkn) 
            js=js+1 
            scratch(js)=cpstor(j) 
            fscratch(js)=fpstor(j) 
           end do 
         end do 
                                                                        
        do i=1,mcon 
         kcpst(i)=mc(kco(i)) 
        end do 
        do i=1,mcon 
         mc(kco(i))=kcpst(npanum(i+2)) 
        end do 
        do i=1,mcon 
         kcpst(i)=mr(kco(i)) 
        end do 
        do i=1,mcon 
         mr(kco(i))=kcpst(npanum(i+2)) 
        end do 
        do i=1,mcon 
         ncor_h(i)=ncor(kco(i)) 
        end do 
        do i=1,mcon 
         ncor(kco(i))=ncor_h(npanum(i+2)) 
        end do 
                                                                        
         do j=1,mco 
          mrce(j)=mr(j)*mc(j) 
         end do 
         do j=2,mco 
          mrs(j)=mrs(j-1)+mr(j-1) 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
         mrcet=mrces(mco)+mrce(mco) 
         do i=1,mrcet 
          cpstor(i)=scratch(i) 
          fpstor(i)=fscratch(i) 
         end do 
                                                                        
!----------------------------------------                               
      k=mcon 
      i2=0 
      do while(k.gt.1.and.i2.eq.0) 
       i1=kco(k) 
       i2=mc(i1) 
       if(i2.eq.0)mcon=mcon-1 
       k=k-1 
!       write(6,'(a,i3)')' mcon=',mcon                                  
      end do 
      mco=mcon 
      jco=0 
                                                                        
      return 
      END                                           

      subroutine mergeparameter(jco,icase,lq,n_merge,condition,info) 
      use glbconst, only: maxc,maxp,maxss,maxco,maxpl,maxvaco,nrd,nwr
      use compar, only: maxsto,maxscr
      use comfrm, only: kcp,mc,mr,mrce,mcs,    &
                        mrces,cpstor,fpstor,mco,mp,mrcet,     &
                        np,p,up,op,ddp,kp,pst,plast,pmin,pold         
      use comscd, only: ext,helpar,queryar,nmkcp,nmc,scratch,fscratch
      use comeff, only: npl  
      implicit none 
      integer, intent(in):: jco,icase
      integer, intent(inout):: lq,n_merge
      integer, intent(out):: info
      character(len=80), intent(out):: condition 

      character(len=132):: querytype,chcom
      character(len=80) :: chdf
      character(len=24) :: chl,chr,ch24,cp24,chh1,chh2
      character(len=2)  :: ch2 
      character(len=1)  :: ch1,chh  

 
      integer nmc2,i0,k,kk,i,ii,ie,i1,i2,j,jc,js,numi1,numi2,lpp1,lpp2, &
              mkk,mp1,mpu,ic2,lk,iii,igo,jj  
                             
       i0=ichar('0') 
                                                                       
       if(icase.eq.1.and.lq.eq.0) then 
        lq=4 
        lk=lq 
        do k=1,lq 
         ext(k)=' ' 
        end do 
        chdf='m' 
        chdf(80:80)='#' 
        querytype='merge parameters' 
        helpar(1)='effi/merge/names' 
        helpar(2)='effi/merge/names' 
        helpar(3)='effi/merge/abnames' 
        helpar(4)='effi/merge/abcdnames' 
        queryar(1)='merge equal __names ' 
        queryar(2)='equal __names  (enquire)' 
        queryar(3)='equal ab__names' 
        queryar(4)='equal a..b__names' 
        call query(lq,lk,querytype,chdf) 
        if(lq.eq.0) lq=1 
        condition=queryar(lq) 
       end if 

       if(icase.eq.2.and.lq.eq.0) then 
        lq=3
        lk=lq 
        do k=1,lq 
         ext(k)=' ' 
        end do 
        chdf='m' 
        chdf(80:80)='#' 
        querytype='merge parameters' 
        helpar(1)='effi/merge/names' 
        helpar(2)='effi/merge/anames' 
        helpar(3)='effi/merge/abnames' 
        queryar(1)='merge parameter of equal __names ' 
        queryar(2)='equal a__names' 
        queryar(3)='equal ab__names' 
        call query(lq,lk,querytype,chdf) 
        if(lq.eq.0) lq=1 
        condition=queryar(lq) 
       end if  

                                                                      
     iii=0                                                           
 111 continue   
     iii=iii+1   
                                                                
      kk=jco 
      nmc2=mc(kk) 
      i1=1 
      if(nmc(3).eq.0)return 

      do while(i1.lt.nmc2) 
       igo=0
 5     continue
       if(icase.eq.1) then
         if(igo.eq.1) goto 15
                                                               
         nmc2=mc(kk) 
         do i=1,nmc2 
          nmkcp(i)=kcp(mcs(kk)+nmc(i+2)) 
         end do 
                                                                        
         do i=1,nmc2 
          if(i1.eq.nmc(i+2)) then 
           numi1=i 
          end if 
         end do 
         ch24=np(nmkcp(numi1)) 

         i=index(ch24,'_') 
         ii=i-1 
         do while(ch24(i:i).eq.'_') 
          i=i+1 
         end do 
         chr=ch24(i:)         !  chr=name
         chl=ch24(:ii)        !  chl= #abs1, 21abs5 etc 
         ch2=ch24(ii-1:ii)
!        write(6,'(2i3,2x,a,a2,3x,a)')i1,nmc2,ch2,TRIM(chl)//'..'//TRIM(chr)
         if(lq.le.2) ch24=chr
         if(lq.eq.3) ch24=ch2//'..'//TRIM(chr)
         if(lq.eq.4) then
          jj=2
          j=ichar(chl(2:2))-i0
          if(j.gt.0.and.j.lt.9)jj=3
          if(jj.lt.ii)jj=ii
          ch24=chl(jj:ii)//'..'//TRIM(chr)
         end if

         i2=i1+1 
   15    continue 
         j=0 
         do i=1,nmc2 
          if(i2.eq.nmc(i+2)) then 
           j=j+1 
           numi2=i 
          end if 
         end do 
!        write(6,'(a,5i3)')'  i2,j,nmc2,lq =',i2,j,nmc2,lq 
         if(j.eq.0) goto 100 
         cp24=np(nmkcp(numi2)) 
         
         i=index(cp24,'_') 
         ii=i-1 
         do while(cp24(i:i).eq.'_') 
          i=i+1 
         end do 
         chr=cp24(i:)         !  chr=name
         chl=cp24(:ii)        !  chl= #abs1, 21abs5 etc 
         ch2=cp24(ii-1:ii)
!        write(6,'(a1,2i3,2x,a2,3x,a)')'B',i1,nmc2,ch2,TRIM(chl)//'..'//TRIM(chr)
         if(lq.le.2) cp24=chr
         if(lq.eq.3) cp24=ch2//'..'//TRIM(chr)
         if(lq.eq.4) then
          jj=2
          j=ichar(chl(2:2))-i0
          if(j.gt.0.and.j.lt.9)jj=3
          if(jj.lt.ii)jj=ii
          cp24=chl(jj:ii)//'..'//TRIM(chr)
         end if

!         several lq frm query                                          
          if(lq.eq.2)then 
            chh1=np(nmkcp(numi1))(:23)
            chh2=np(nmkcp(numi2))(:23)
            querytype=TRIM(chh1)//' with '//TRIM(chh2)
            ch1='n' 
            if(chh1.eq.chh2)then 
             ch1='N' 
             nrd=-nrd 
            end if 
            chcom='effi/merge/ask' 
            call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
            if(ch1.eq.'b')then 
             i2=i2-1 
             goto 15 
            end if 
            if(ch1.eq.'n') cp24=' ' 
          end if 
         if(ch24.ne.cp24)then 
          i2=i2+1 
          goto 15 
         end if 

       else if(icase.eq.2) then
         if(igo.eq.1)goto 25
                                                                  
         nmc2=mc(kk) 
         do i=1,nmc2 
          nmkcp(i)=kcp(mcs(kk)+nmc(i+2)) 
         end do 
                                                                        
         do i=1,nmc2 
          if(i1.eq.nmc(i+2)) then 
           numi1=i 
          end if 
         end do 
         ch24=np(nmkcp(numi1)) 
         chh=ch24(1:1)

         i=index(ch24,'_') 
         ii=i-1 
         do while(ch24(i:i).eq.'_') 
          i=i+1 
         end do 
         chr=ch24(i:)         !  chr=name
         chl=ch24(:ii)        !  chl= #abs1, 21abs5 etc 
         ch2=ch24(ii-1:ii)
!        write(6,'(2i3,2x,a2,3x,a)')i1,nmc2,ch2,TRIM(chl)//'..'//TRIM(chr)
         if(lq.le.1) ch24=chr
         if(lq.eq.2) ch24=ch2(2:2)//'..'//TRIM(chr)
         if(lq.eq.3) ch24=ch2//'..'//TRIM(chr)

         i2=i1+1 
   25    continue 
         j=0 
         do i=1,nmc2 
          if(i2.eq.nmc(i+2)) then 
           j=j+1 
           numi2=i 
          end if 
         end do 
!        write(6,'(a,5i3)')'  i2,j,nmc2,lq =',i2,j,nmc2,lq 
         if(j.eq.0) goto 100 
         cp24=np(nmkcp(numi2)) 
         if(chh.ne.'#')chh=cp24

         i=index(cp24,'_') 
         ii=i-1 
         do while(cp24(i:i).eq.'_') 
          i=i+1 
         end do 
         chr=cp24(i:)         !  chr=name
         chl=cp24(:ii)        !  chl= #abs1, 21abs5 etc 
         ch2=cp24(ii-1:ii)
!         write(6,'(a1,2i3,2x,a,a2,3x,a)')'B',i1,nmc2,ch2,TRIM(chl)//'..'//TRIM(chr)
         if(lq.le.1) cp24=chr
         if(lq.eq.2) cp24=ch2(2:2)//'..'//TRIM(chr)
         if(lq.eq.3) cp24=ch2//'..'//TRIM(chr)

         if(chh.ne.'#')cp24=' '
         ! only parameter with a # as first character in the name are merged 

         if(ch24.ne.cp24)then 
          i2=i2+1 
          goto 25 
         end if 
         ch2=np(nmkcp(numi1))
         if(ch2(1:1).ne.'#')then
          np(nmkcp(numi1))(1:1)='#'
          j=ichar(ch2(2:2))-i0
          if(j.gt.0.and.j.lt.9)then
           np(nmkcp(numi1))(1:2)=' #'
           np(nmkcp(numi1))=ADJUSTL(np(nmkcp(numi1)))
          end if
         end if
         ch2=np(nmkcp(numi2))
         if(ch2(1:1).ne.'#')then
          np(nmkcp(numi2))(1:1)='#'
          j=ichar(ch2(2:2))-i0
          if(j.gt.0.and.j.lt.9)then
           np(nmkcp(numi2))(1:2)=' #'
           np(nmkcp(numi2))=ADJUSTL(np(nmkcp(numi2)))
          end if
         end if
       end if
                                                                   
         n_merge=n_merge+1 
         do i=1,mr(kk) 
           mkk=mrces(kk)+(i-1)*mc(kk) 
           cpstor(mkk+i1)=cpstor(mkk+i1)+cpstor(mkk+i2) 
           lpp1=10*(ichar(fpstor(mkk+i1)(2:2))-i0)+                     &
                   ichar(fpstor(mkk+i1)(3:3))-i0                       
           lpp2=10*(ichar(fpstor(mkk+i2)(2:2))-i0)+                     &
                    ichar(fpstor(mkk+i2)(3:3))-i0                       
           if(lpp1.lt.lpp2) fpstor(mkk+i1)(2:3)=fpstor(mkk+i2)(2:3) 
           lpp1=ichar(fpstor(mkk+i1)(4:4)) 
           lpp2=ichar(fpstor(mkk+i2)(4:4)) 
           if(lpp1.lt.lpp2) fpstor(mkk+i1)(4:4)=fpstor(mkk+i2)(4:4) 
         end do 
         mp1=kcp(mcs(kk)+i1) 
         ic2=mcs(kk)+i2 
         mpu=kcp(ic2) 
!        p(mp1)=p(mp1)+p(mpu)                                           
         do i=mpu+1,mp 
            ii=i-1 
            ie=i 
            np(ii)=np(ie) 
             p(ii)=p(ie) 
            up(ii)=up(ie) 
            op(ii)=op(ie) 
           ddp(ii)=ddp(ie) 
            kp(ii)=kp(ie) 
           pst(ii)=pst(ie) 
          plast(ii)=plast(ie) 
          pold(ii)=pold(ie) 
          pmin(ii)=pmin(ie) 
         end do 
         do i=ic2,mp-1 
          kcp(i)=kcp(i+1) 
         end do 
          do i=1,mp-1 
            if(kcp(i).gt.mpu) kcp(i)=kcp(i)-1 
          end do 
          kcp(mp)=0 
          kp(mp)=0 
                                                                        
          js=mrces(kk) 
          jc=js 
         do i=1,mr(kk) 
          do k=1,mc(kk) 
            jc=jc+1 
            js=js+1 
            fscratch(js)=fpstor(jc) 
            scratch(js)=cpstor(jc) 
            if(k.eq.i2) js=js-1 
          end do 
         end do 
         if(kk.lt.mco) then 
          do i=mrces(kk+1)+1,mrcet 
            js=js+1 
           fscratch(js)=fpstor(i) 
           scratch(js)=cpstor(i) 
           end do 
         end if 
                                                                        
         mp=mp-1 
         mc(kk)=mc(kk)-1 
         mrce(kk)=mr(kk)*mc(kk) 
         do j=2,mco 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
          mrcet=mrcet-mr(kk) 
         do i=mrces(kk)+1,mrcet 
          fpstor(i)=fscratch(i) 
          cpstor(i)=scratch(i) 
         end do 
                                                                        
                                                                        
         nmc2=nmc2-1 
         do j=numi2,nmc2 
          nmc(j+2)=nmc(j+3)-1 
         end do 
         nmc(2)=nmc2 
         call coexam(kk,info) 
         do i=1,nmc2 
          nmkcp(i)=kcp(mcs(kk)+nmc(i+2)) 
         end do
         igo=1 
         goto 5
  100    continue 
         i1=i1+1 
        end do
        if(iii.eq.1) goto 111 
       return 
      END                                           
                                                                        
