      subroutine dataheaderinput(n1,ks,nread,info) 
      use glbconst, only: maxthss,infotext,max8,nrd,nwr
      use compar, only: maxcvsp
      use comdat, only: maxbaddata,b_datset,ibadchan,cdata_str,      &
                        nchannelsp,nchandata,readform
      use comdas, only: namedata,cdata,b_cdata,n_cdata,     &
                        vdata,n_vdata,b_vdata,ip_chan,i_cdata,       &
                        i_vdata
      use comeff, only: ocontrf,mcadds
      use comscd, only: npanum,nconwr,conwr,iconwr,conwro
      implicit none 
                                                                        
      integer   n1,ks,nread,info
      integer,dimension(0:16) :: ifdcon,ifdpar 
      character(len=132):: chnext,chtext,chcom,ch132,cp132
      character(len=24) :: chl,chr
      character(len=7)  :: form
      character(len=1)  :: ch1
      character(len=6)  :: ch6
      character(len=8)  :: chset
      character(len=132),dimension(1:4) :: chardata 
      character(len=20), dimension(1:16):: chcova 
      character(len=4),  dimension(1:32):: chf   
      real       out(32),rn 

      integer i,ii,ipos,i0,ia,im,iout,j,jnext,jf,jc,jj,k,kk,kc,kv,   &
              kchardata,ledit,lnext,l132,nn,nd2,ndhf,kii,ntrimto0
                                                                        
!     write(6,'(a,2i5)')'i_cdata(ks,0)=',i_cdata(ks,0)
      if(i_cdata(ks,0).lt.1) then 
        info=ks 
        infotext(1)='effi/cmdfile/data/ks' 
        infotext(2)='read data was not successfull' 
        infotext(3)='no theory for set ks=(info)' 
        infotext(4)='to be defined by the rs command in session.cmd' 
        infotext(5)=' ' 
        return 
       end if 
       ip_chan(ks)=0 
       do i=1,i_cdata(ks,0) 
        if(index(n_cdata(ks,i),'nu_channel').gt.0) ip_chan(ks)=i 
       end do 
       if(ip_chan(ks).eq.0) then 
        info=11 
        infotext(1)='effi/data/nu_channels' 
        infotext(2)(1:17)='** fatal error **' 
        infotext(3)='structure of .par file is wrong' 
        infotext(4)='The parameter file should define the constant: "nu_channel"' 
        infotext(5)='The str_.f90 routine has to contain its definition.'
        infotext(6)=' '
        return
       end if 

!     n1 = input unit                                                   
!     istortype = 1...8 storage modi in common block                    
                                                                        
!      write(6,'(a,2i5)') ' ks,nread=',ks,nread                         
      i0=ichar('0') 
      if(ks.gt.9)then 
       ii=ks/10 
       jj=ks-ii*10 
       chset='set '//char(ii+i0)//char(jj+i0)//':' 
      else 
       chset='set '//char(ks+i0)//':' 
      end if 
      goto(10,240,260,350,290),nread 
                                                                        
   10 readform='(10f8.0)' 
                                                                        
      nd2=0 
      if(b_datset(ks)) nd2=1 
!     nd2 is 1, reading of new data                                     
      kk=0 
      jnext=0 
      read(n1,'(a)',end=100) namedata(ks) 
      read(n1,'(a)',end=100) chtext 
!      write(6,'(a,a)') ' chtext=',chtext(:60)                          
      i=index(chtext,')') 
       call nextchar(chtext,i,ipos,chnext,lnext) 
       readform=chtext(1:i) 
!       write(6,'(a,a)') '1 readform=',readform                         
       cdata_str=chnext 
!       write(6,'(a,a)') ' chnext=',chnext                              
                                                                        
      do k=1,4 
       read(n1,'(a)',end=100) chardata(k) 
!       write(6,'(i4,2x,a)')k,chardata(k)                               
       if(index(chardata(k),'=').eq.0) then 
        backspace n1 
        kchardata=k-1 
        goto 200 
       end if 
      end do 
!                                                                       
  100 write(nwr,'(a)') '***** error ***** eof reached' 
      kc=i_cdata(ks,0) 
      kv=i_vdata(ks,0) 
      do k=1,kc 
       b_cdata(ks,k)=.true. 
      end do 
      do k=1,kv 
       b_vdata(ks,k)=.true. 
      end do 
      b_datset(ks)=.false. 
      return 
                                                                        
200   continue
       ii=0
       do i=1,kchardata 
        if(index( chardata(i),'nu_channel').gt.0) ii=i 
       end do
       if(ii.eq.0) then 
        info=11 
        infotext(1)='effi/data/nu_channels' 
        infotext(2)(1:17)='** fatal error **' 
        infotext(3)='structure of .dat file is wrong' 
        infotext(4)='The dat file  defines the constant: "nu_channel", ' 
        infotext(5)='the number of data to be read'
        infotext(6)=' '
        return
       end if

     ch132=chardata(1) 
      j=index(ch132,'=') 
      do k=1,maxcvsp 
       b_cdata(ks,k)=.false. 
       b_vdata(ks,k)=.false. 
      end do 
      do i=0,16 
       ifdcon(i)=i 
       ifdpar(i)=i 
      end do 
      ndhf=0 

      do ii=1,kchardata 
       cp132=chardata(ii) 
       ch132=cp132 
!      number of constants in line ii                                  
       j=index(ch132,'=') 
       kii=0 
       do while(j.gt.0) 
        kii=kii+1 
        ch132(j:j)='#' 
        j=index(ch132,'=') 
       end do 

!       write(6,'(a,i3)')' kii constants in line ii:',kii
       
       j=index(cp132,'=') 
!      write(6,'(i3,2a)')j,' cp132=',cp132(1:60)                      
       if(j.gt.0) then 
        ! kii>0 if j> 0
202     continue 
        kii=kii-1 
        call nextchar(cp132,0,ipos,ch132,l132) 
!        write(6,'(2a,i4)')'ch132,l132=',TRIM(ch132(1:80)),l132
        j=index(ch132,'=') 
!        write(6,'(a,2i5)') ' j,l132=',j,l132                          
        if(l132.gt.0.and.j.gt.0) then
         if(l132.ge.j.or.l132.lt.j-2) l132=j-1 
         k=1 
         chtext=ch132(1:l132) 
         l132=ntrimto0(chtext)
!         write(6,'(2a,i4)')'chtext=',TRIM(chtext),l132
         kc=0 
         k=1 
         kk=0 
!        write(6,'(a,2i5)')' i_cdata(ks,0)=',i_cdata(ks,0)             
         do while(k.le.i_cdata(ks,0).and.kk.eq.0) 
          kk=index(n_cdata(ks,k),chtext(1:l132))
!          write(6,'(i5,2a)')kk,TRIM(n_cdata(ks,k)),TRIM(chtext(1:l132))
          if(kk.gt.0)then 
            kc=k 
            ifdcon(k)=-1 
          end if 
          k=k+1 
         end do 
                                                                       
         if(k.eq.1) then 
          i=0 
         else 
          i=index(n_cdata(ks,k-1),'~')-1 
         end if 
         kv=0 
         k=1 
         kk=0 
         do while(k.le.i_vdata(ks,0).and.kk.eq.0) 
          kk=index(n_vdata(ks,k),chtext(1:l132)) 
          if(kk.gt.0)then 
            kv=k 
            ifdpar(k)=-1 
          end if 
!          write(6,'(2i5,2(5x,a))')k,kv,n_vdata(ks,k)(1:16),chtext(1:l132)
          k=k+1 
         end do 
         if(k.eq.1) then 
          i=0 
         else 
          i=index(n_vdata(ks,k-1),'~')-1 
         end if 
         if(kv.eq.0.and.i.gt.0.and.ifdpar(k-1).eq.k-1) then 
!         write(6,'(a,6i3)')' i,kc,kv,k,ifdcon=',i,kc,k,ifdpar(k-1)    
          info=13 
          infotext(1)='effi/data/header/required' 
          infotext(2)='read data was not successfull' 
          infotext(3)='constant '//n_cdata(ks,k-1)(1:i)//' is missing' 
          infotext(4)='in the header of the data file' 
          infotext(5)=' ' 
          return 
         end if                                                                        
         ch132(j:j)=' ' 
         chtext=ch132(j:) 
         call nextchar(chtext,0,ipos,chnext,lnext) 
          chtext=chnext(1:lnext) 
          call fout_a(chtext,chf,jf) 
          ch6=chf(1)(1:3) 
          if(ch6(1:1).eq.'i') then 
           ch6(4:6)=')  ' 
          else 
           ch6(4:6)='.'//chf(1)(4:4)//')' 
          end if 
                                                                       
         call trlch(lnext,chnext,iout,out) 
         cp132=chnext(lnext+1:) 
!       write(6,'(a)') ' chtext='                                      
!       write(6,'(a)')   chtext(1:80)                                  
!       write(6,'(a)')   chnext(1:80)                                  
!       write(6,'(a,10f10.3)')' out=',(out(i),i=1,iout)                
!       write(6,'(a,2i5)') ' ipos,lnext=',ipos,lnext                   
                                                                       
                                                                       
         if(kc+kv.eq.0) then 
          ndhf=ndhf+1 
          chcova(ndhf)=ch132(1:l132) 
         else 
          i0=ichar('0') 
          iA=ichar('A') 
          ch1=char(ks+i0) 
          if(ks.gt.9) ch1=char(ks-10+iA) 
          if(kc.gt.0) then 
           cdata(ks,kc)=out(1) 
           b_cdata(ks,kc)=.true. 
           n_cdata(ks,kc)(33:38)=ch6 
           n_cdata(ks,kc)(1:1)=ch1
          end if 
          if(kv.gt.0) then 
           vdata(ks,kv)=out(1) 
           b_vdata(ks,kv)=.true. 
           n_vdata(ks,kv)(33:38)=ch6 
           n_vdata(ks,kv)(1:1)=ch1 
          end if 
         end if 
         goto 202 
        end if 
       end if 
      end do   ! ii=1,kchardata 

       namedata(ks)=ADJUSTL(namedata(ks))
       write(nwr,'(a)')char(27)//'[1m'//TRIM(namedata(ks))//char(27)//'[0m'
       if(ndhf.ge.1) then
        write(nwr,'(a)')'the variables/constants found in the header:'  
        write(nwr,'(3a22)')(chcova(i),i=1,ndhf) 
        write(nwr,'(a)')                                              &
          'are omitted as their parameters belong to the parameter/constant list'
                                                                        
       end if 
       ndhf=0 
       do i=1,i_cdata(ks,0) 
        if(ifdcon(i).eq.i) then 
         ndhf=ndhf+1 
         b_cdata(ks,i)=.true. 
         k=index(n_cdata(ks,i),'__') 
         j=index(n_cdata(ks,i),'  ') 
         do while(n_cdata(ks,i)(k:k).eq.'_') 
          k=k+1 
         end do 
         chcova(ndhf)=n_cdata(ks,i)(k:j) 
        end if 
       end do 
       jj=0 
       if(ndhf.ge.1) then 
        jj=jj+1 
        write(nwr,'(a)')'the constants:' 
        write(nwr,'(3a22)')(chcova(i),i=1,ndhf) 
       end if 
       ndhf=0 
       do i=1,i_vdata(ks,0) 
        if(ifdpar(i).eq.i) then 
         ndhf=ndhf+1 
         b_vdata(ks,i)=.true. 
         k=index(n_vdata(ks,i),'__') 
         j=index(n_vdata(ks,i),'  ') 
         do while(n_vdata(ks,i)(k:k).eq.'_') 
          k=k+1 
         end do 
         chcova(ndhf)=n_vdata(ks,i)(k:j) 
        end if 
       end do 
       if(ndhf.ge.1) then 
        jj=jj+1 
        write(nwr,'(a,a)')'the variables:' 
        write(nwr,'(3a22)')(chcova(i),i=1,ndhf) 
       end if 
       if(jj.ge.1) &                                                      
       print'(a)','are not found in the header -> default values are inserted'
!       write(6,'(a,8f8.1)')'vdata(ks,1..)=',(vdata(ks,i),i=1,6)        
!       write(6,'(a,8f8.1)')'cdata(ks,1..)=',(cdata(ks,i),i=1,6)        
!       write(6,'(a,i4)')'i_cdata(ks,0)=',i_cdata(ks,0)                 
!       write(6,'(l5,i4,2x,a)')(b_cdata(ks,i),i_cdata(ks,i),n_cdata(ks,i),i=1,8)
!       write(6,'(a,2i6)')'int-cdata(ks,1),max8=',int(cdata(ks,1)),max8 

       nchannelsp=cdata(ks,ip_chan(ks)) 
       nchandata(ks)=nchannelsp
!       write(6,'(a,8i5)')' xdataheaderinput nchannel=',nchannelsp                        
                                                                        
      if (nchannelsp.gt.max8) then 
       form='i6' 
       rn=nchannelsp 
       call trlnu(form,rn,chr,nn,chl,im) 
       info=12 
       infotext(1)='effi/data/nu_channels' 
       infotext(2)='number of channels '//chl(1:7)//' larger than' 
       infotext(3)=' ' 
       form='i6' 
       rn=max8 
       call trlnu(form,rn,chr,nn,chl,im) 
       infotext(2)(40:46)=chl(1:7) 
       cdata(ks,ip_chan(ks))=max8 
       b_datset(ks)=.false. 
       kc=i_cdata(ks,0) 
       kv=i_vdata(ks,0) 
       do k=1,kc 
        b_cdata(ks,k)=.true. 
       end do 
       do k=1,kv 
        b_vdata(ks,k)=.true. 
       end do 
       nread=-1 
       return 
      end if 
                                                                        
                                                                        
      ledit=-1 
      kc=i_cdata(ks,0) 
      kv=i_vdata(ks,0) 
      j=0 
      do k=1,kc 
       if(b_cdata(ks,k)) then 
        j=j+1 
        nconwr(j)=n_cdata(ks,k) 
        i=index(nconwr(j),'~') 
        if(i.gt.0)nconwr(j)(i:i)=' ' 
        conwr(j)=cdata(ks,k) 
       end if 
      end do 
      do k=1,kv 
       if(b_vdata(ks,k)) then 
        j=j+1 
        nconwr(j)=n_vdata(ks,k) 
        conwr(j)=vdata(ks,k) 
       end if 
      end do 
                                                                        
      ch132=' ' 
      chtext=' ' 
      form='i2' 
      rn=j 
      call trlnu(form,rn,chr,nn,chl,im) 
      chtext=' 1 - '//chl(1:5) 
!      write(6,'(1h ,a)') chtext                                        
!      write(6,'(a,a,g15.5)') 'effisub  nconwr=',nconwr(1),conwr(1)     
      if(j.gt.0)  call conread(chtext,conwr,nconwr,j,chcom,ledit) 
!     reading of data                                                   
                                                                        
      call mapspfr(ks) 
      do k=mcadds(ks,0)+1,mcadds(ks,1) 
       ocontrf(k)=9999.99 
      end do 
      call mapcopa(0) 
!      write(6,'(a)')'(vartrf(j),j=1,1600)'                             
!      write(6,'(10f10.2)')(vartrf(j),j=1,1600)                         
      return 
                                                                        
  240 continue 
      write(nwr,'(a)') 'effisub  no execution' 
      return 
! change header information                                             
  260  continue 
                                                                        
      chcom='effi/data/cvdata' 
      kc=i_cdata(ks,0) 
      kv=i_vdata(ks,0) 
      j=0 
      do k=1,kc 
       if(b_cdata(ks,k)) then 
        j=j+1 
        iconwr(j)=k 
        nconwr(j)=n_cdata(ks,k) 
        i=index(nconwr(j),'~') 
        if(i.gt.0)nconwr(j)(i:i)=' ' 
        conwr(j)=cdata(ks,k) 
       end if 
      end do 
      jc=j 
      do k=1,kv 
       if(b_vdata(ks,k)) then 
        j=j+1 
        iconwr(j)=k 
        nconwr(j)=n_vdata(ks,k) 
        conwr(j)=vdata(ks,k) 
       end if 
      end do 
       ch132=' ' 
       chtext=' ' 
       form='i2' 
       rn=j 
       call trlnu(form,rn,chr,nn,chl,im) 
       chtext=' 1 - '//chl(1:5) 
       do k=1,j 
        conwro(k)=conwr(k) 
       end do 
       ledit=0 
       call conread(chtext,conwr,nconwr,j,chcom,ledit) 
       jj=0 
       do k=1,j 
        if(conwr(k).ne.conwro(k)) then 
         jj=1 
         if(k.le.jc) then 
          cdata(ks,iconwr(k))=conwr(k) 
          n_cdata(ks,iconwr(k))=nconwr(k) 
         else 
          vdata(ks,iconwr(k))=conwr(k) 
          n_vdata(ks,iconwr(k))=nconwr(k) 
         end if 
        end if 
       end do 
       if(jj.eq.1) then 
        do k=mcadds(ks,0)+1,mcadds(ks,maxthss) 
         ocontrf(k)=11111.11111 
        end do 
       end if 
      goto 500 
                                                                        
!     remove bad data channels                                          
                                                                        
  290 continue 
      nchannelsp=cdata(ks,ip_chan(ks)) 
      write(nwr,'(a)')'channels with bad data indicator:' 
      write(nwr,'(16i5)')(ibadchan(j,ks),j=1,ibadchan(0,ks)) 
                                                                        
      write(nwr,'(a)')                                                  &
     &        ' remove bad data indicator for channel numbers'          
       read(nrd,'(a)',end=290) ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
         chcom='effi/read/data/rm bad dat' 
         call help(chcom) 
         goto 290 
       end if 
      if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 500 
      chnext=ch132 
      i=1
      call panum(chnext,nchannelsp,npanum,1) 
      if(i.ne.1) then
       print'(2a)','error in the list:',TRIM(chnext)
       info=i
       return
      end if         

!      write(6,'(16i5)')(npanum(2+j),j=0,npanum(2))                     
       k=0 
  291  k=k+1 
       j=0 
  292  j=j+1 
       if(ibadchan(k,ks).eq.npanum(2+j))then 
        do i=j,npanum(2)-1 
         npanum(2+i)=npanum(3+i) 
        end do 
        npanum(2)=npanum(2)-1 
        do i=k,ibadchan(0,ks)-1 
         ibadchan(i,ks)=ibadchan(i+1,ks) 
        end do 
        ibadchan(0,ks)=ibadchan(0,ks)-1 
        j=j-1 
        k=k-1 
       end if 
       if(npanum(2).gt.0.and.j.lt.npanum(2))then 
        k=k+1 
        goto 292 
       end if 
       if(k.lt.ibadchan(0,ks)) goto 291 
      goto 290 
                                                                        
  350 continue 
      nchannelsp=cdata(ks,ip_chan(ks)) 
      if(ibadchan(0,ks).gt.0) then 
       write(nwr,'(a)') 'channels with bad data indicator:' 
       write(nwr,'(16i5)')(ibadchan(j,ks),j=1,ibadchan(0,ks)) 
      end if 
                                                                        
      write(nwr,'(a)')                                                  &
     &        ' bad data indicator for channel numbers'                 
       read(nrd,'(a)',end=290) ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
         chcom='effi/read/data/rm bad dat' 
         call help(chcom) 
         goto 290 
       end if 
      if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 500 
      chnext=ch132 
      i=1
      call panum(chnext,nchannelsp,npanum,i) 
      if(i.ne.1) then
       print'(2a)','error in the list:',TRIM(chnext)
       info=i
       return
      end if         
!      write(6,'(16i5)')(npanum(2+j),j=0,npanum(2))                     
       k=0 
  351  k=k+1 
       j=0 
  352  j=j+1 
       if(ibadchan(k,ks).eq.npanum(2+j))then 
        do i=j,npanum(2)-1 
         npanum(2+i)=npanum(3+i) 
        end do 
        npanum(2)=npanum(2)-1 
        j=j-1 
       end if 
       if(j.lt.npanum(2)) goto 352 
       if(k.lt.ibadchan(0,ks)) goto 351 
       if(j.gt.0) then 
        k=npanum(2)+ibadchan(0,ks) 
        if(k.gt.maxbaddata)npanum(2)=maxbaddata-ibadchan(0,ks) 
        k=ibadchan(0,ks) 
        do i=1,npanum(2) 
         ibadchan(k+i,ks)=npanum(2+i) 
        end do 
        ibadchan(0,ks)=ibadchan(0,ks)+npanum(2) 
       end if 
      goto 350 
                                                                        
  500 continue 
      return 
      END                                           
                                                                        
      subroutine zerotrf 
      use glbconst, only: maxtrf,maxprd,max_ctrf,max_vtrf,             &
                          icfr1trf,icfr2trf,icsstrf,icstrf,             &
                          ivfr1trf,ivfr2trf,ivsstrf,ivstrf
      use comeff, only: contrf,ocontrf
      use comthe, only: vartrf,ovartrf
      implicit none
      integer  inf_tr
      real     array_tr,cstrf,vstrf,cfr1trf,vfr1trf,cfr2trf,vfr2trf,   &
               csstrf,vsstrf
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 
                                                                        
      common/acstrf/ cstrf(icstrf) 
      common/avstrf/ vstrf(ivstrf) 
      common/acfr1trf/ cfr1trf(icfr1trf) 
      common/avfr1trf/ vfr1trf(ivfr1trf) 
      common/acfr2trf/ cfr2trf(icfr2trf) 
      common/avfr2trf/ vfr2trf(ivfr2trf) 
      common/acsstrf/ csstrf(icsstrf) 
      common/avsstrf/ vsstrf(ivsstrf) 
                                                                        
      logical b_cstrf,b_vstrf,b_cfr1trf,b_vfr1trf,                      &
              b_cfr2trf,b_vfr2trf,b_csstrf,b_vsstrf                     
      common/bcstrf/ b_cstrf(icstrf) 
      common/bvstrf/ b_vstrf(ivstrf) 
      common/bcfr1trf/ b_cfr1trf(icfr1trf) 
      common/bvfr1trf/ b_vfr1trf(ivfr1trf) 
      common/bcfr2trf/ b_cfr2trf(icfr2trf) 
      common/bvfr2trf/ b_vfr2trf(ivfr2trf) 
      common/bcsstrf/ b_csstrf(icsstrf) 
      common/bvsstrf/ b_vsstrf(ivsstrf) 

       contrf=0.0 
       ocontrf=22222.222 
       vartrf=0.0 
       ovartrf=22222.222 
       b_cstrf=.true. 
       b_vstrf=.true. 
       b_cfr1trf=.true. 
       b_vfr1trf=.true. 
       b_cfr2trf=.true. 
       b_vfr2trf=.true. 
       b_csstrf=.true. 
       b_vsstrf=.true. 
                                                                        
       cstrf=0.0 
       vstrf=0.0 
       cfr1trf=0.0 
       vfr1trf=0.0 
       cfr2trf=0.0 
       vfr2trf=0.0 
       csstrf=0.0 
       vsstrf=0.0 
       array_tr=0.0 
       inf_tr=0 
      return 
      END                                           
                                                                       
      subroutine contrue 
      use glbconst, only: icfr1trf,icfr2trf,icsstrf,icstrf,             &
                          ivfr1trf,ivfr2trf,ivsstrf,ivstrf
      implicit none 
      logical b_cstrf,b_cfr1trf,b_cfr2trf,b_csstrf,                  &
              b_vstrf,b_vfr1trf,b_vfr2trf,b_vsstrf                      
      common/bcstrf/ b_cstrf(icstrf) 
      common/bvstrf/ b_vstrf(ivstrf) 
      common/bcfr1trf/ b_cfr1trf(icfr1trf) 
      common/bvfr1trf/ b_vfr1trf(ivfr1trf) 
      common/bcfr2trf/ b_cfr2trf(icfr2trf) 
      common/bvfr2trf/ b_vfr2trf(ivfr2trf) 
      common/bcsstrf/ b_csstrf(icsstrf) 
      common/bvsstrf/ b_vsstrf(ivsstrf) 

       b_cstrf=.true. 
       b_cfr1trf=.true. 
       b_cfr2trf=.true. 
       b_csstrf=.true. 
       b_vstrf=.true. 
       b_vfr1trf=.true. 
       b_vfr2trf=.true. 
       b_vsstrf=.true. 
      return 
      END                                           
                                                                        
      subroutine status(comline) 
      use glbconst, only: marray_sp,maxfr1,maxfr2,maxs,maxthss,enwr,nrd,nwr
      use comfrm, only: mpl,ipladd,ivaddsp,mplths,mplthsp,mplthss,     &
                        mplths,mpaddsp,mpaddss,mpadds,mvaddsp,mvaddss, &
                        ivadd,mcthsp,mcthss,mcths,mkaddsp,mkadds,      &
                        mkaddss,mcaddsp,mcaddss,icaddsp,icladd,icadd
      use comdas, only: ktheo,istrss
      use comeff, only: mvadds,mcadds,contrf,npl
      use comthe, only: vartrf,real_fr
      use comths, only: nstorSP
      implicit none 
                                                                        
      integer,parameter :: maxenwr=24
      character(len=132):: ch132,comline,chcom
      character(len=2)  :: ch2
      character(len=8)  :: ch8
      character(len=7)  :: form
      character(len=24),dimension(1:maxenwr):: infabout 

      integer   kststr,kvp,kpv,itype,istruct1,istruct2,infab
      dimension kststr(maxthss),kvp(0:maxthss),kpv(0:maxthss),          &
                itype(0:maxthss),istruct1(0:maxfr1),istruct2(0:maxfr2), &
                infab(maxenwr)

      logical   b_vaco
      real      out(32),value
      integer   i,il,iss,issv,ienter,i0,ip,ih,ipos,dstr,ipt,iaddr,       &
                j,k,ks,mstruct1,l,li,label,maxhss,mss,ntrimto0                
      integer, dimension(:), allocatable:: p99,z99  

      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      common/struct/dstr(istr),ipt,iaddr(7)
      
!     write(6,'(a,10i3)') ' ktheo(1..,0)=',(ktheo(k,0,0),k=1,maxs)      
      infabout(1) ='constant_s       01_ynnn' 
      infabout(2) ='constant_fr1     01_nynn' 
      infabout(3) ='constant_fr2     01_nnyn' 
      infabout(4) ='constant_ss      01_nnny' 
      infabout(5) ='variable_s       02_ynnn' 
      infabout(6) ='variable_fr1     02_nynn' 
      infabout(7) ='variable_fr2     02_nnyn' 
      infabout(8) ='variable_ss      02_nnny' 
      infabout(9) ='theory           03_ynnn' 
      infabout(23)='no_version       03_nynn' 
      infabout(10)='pointer          03_nnyn' 
      infabout(22)='common           03_nnny' 
      infabout(24)='9999             16_9999' 
                                                                        
      infabout(11)='mapc_s           04_ynnn' 
      infabout(12)='mapc_fr1         04_nynn' 
      infabout(13)='mapc_fr2         04_nnyn' 
      infabout(14)='mapc_ss          04_nnny' 
      infabout(15)='mapv_s           05_ynnn' 
      infabout(16)='mapv_fr1         05_nynn' 
      infabout(17)='mapv_fr2         05_nnyn' 
      infabout(18)='mapv_ss          05_nnny' 
      infabout(19)='variable_su      16_ynn@' 
      infabout(20)='constant_su      16_nyn@' 
      infabout(21)='warning          06_ynnn' 
                                                                        
      infab(1)=10 
      infab(2)=12 
      infab(3)=12 
      infab(4)=11 
      infab(5)=10 
      infab(6)=12 
      infab(7)=12 
      infab(8)=11 
      infab(9)=6 
      infab(10)=7 
                                                                        
      infab(11)=6 
      infab(12)=8 
      infab(13)=8 
      infab(14)=7 
      infab(15)=6 
      infab(16)=8 
      infab(17)=8 
      infab(18)=7 
                                                                        
      infab(19)=11 
      infab(20)=11 
      infab(21)=7 
                                                                        
      infab(22)=6 
      infab(23)=10 
      infab(24)=4 
                                                                        
                                                                        
      chcom='effi/command/write' 
      ch2=comline 
                                                                        
!      write(6,'(2a)') 'effisub status comline=',comline(1:50)          
!      call lc_character(comline) 
      il=ntrimto0(comline) 
      ienter=1 
      call comln1(comline,chcom,ienter) 
      if(comline(1:1).eq.'*'.or.comline(1:1).eq.'q') goto 300 
!      write(6,'(2a)') 'effisub status comline=',comline(1:50)          
                                                                        
      if(ienter.eq.3) then 
       call comln1(comline,chcom,ienter) 
       goto 50 
      end if 
      if(ienter.eq.2) then 
       call comln1(comline,chcom,ienter) 
       ienter=0 
      end if 
      if(ienter.eq.0) then 
       ienter=1 
       ch132=ch2//' b1l' 
       call comln1(ch132,chcom,ienter) 
      end if 
   50 continue 
!      write(6,'(2a)') 'effisub status comline=',comline(1:70)          
      ch132='  '//comline(3:) 
      b_vaco=.true. 
      if(index(ch132(1:20),'all').gt.0) then 
        maxhss=40 
        label=3 
        ks=1 
        b_vaco=.false. 
        goto 100 
      end if 
        maxhss=10 
                                                                        
      i0=ichar('0') 
      if(index(ch132(1:60),' pr ').gt.0) then 
         write(nwr,'(4(3x,i2,a1,a4))')(i,'_',enwr(i),i=1,16) 
         return 
      end if 
!      write(6,'(2a)') 'ch132=',ch132(1:60)                             
                                                                        
      if(index(ch132,'remove')+index(ch132,'rm').gt.0) then 
       do i=1,16 
         enwr(i)='nnnn' 
       end do 
      end if 
                                                                        
      do i=1,maxenwr 
       j=index(ch132,infabout(i)(1:infab(i))) 
       if(j.gt.0) then 
        k=10*(ichar(infabout(i)(18:18))-i0)+ichar(infabout(i)(19:19))-i0 
        if( enwr(k).eq.'nnnn') then 
         enwr(k)=infabout(i)(21:24) 
        else 
         do l=1,4 
          if(infabout(i)(20+l:20+l).eq.'y') enwr(k)(l:l)='y' 
         end do 
        end if
        goto 51 
       end if 
      end do 

 51   ip=1 
      ih=1 
      do while(ip.gt.0.and.ip.lt.132) 
       call nextchar(ch132,ih,ipos,chcom,ip) 
       i=index(chcom,'_') 
       if(i.gt.0) then 
        ch8=chcom(:i-1) 
!        write(6,'(a,a8)')' effisub status ch8=',ch8                    
        call c8toi(ch8,j) 
        if(j.gt.0.and.j.le.16) then 
                                                     !  10.11.06        
         if(j.gt.9) ip=ip-1 
         if(ip-2.gt.4) then
          print'(a,a4)',' enwr cut to 4 characters:',chcom(i+1:i+4) 
          ip=6
         end if
         if( enwr(j).eq.'nnnn') then 
          enwr(j)(1:ip-2)=chcom(i+1:i+4) 
         else 
          do l=1,4 
           if(chcom(i+l:i+l).ne.'n') enwr(j)(l:l)=chcom(i+l:i+l) 
          end do 
         end if 
         if(chcom(i+1:i+4).eq.'nnnn') enwr(j)='nnnn' 
                                                                        
!        write(6,'(i2,2a)')j,' effisub status enwr=',enwr(j)            
        end if 
       end if 
       ch132=chcom 
!       write(6,'(i2,2a)')i,' effisub status chcom=',chcom              
      end do 
!      write(6,'(2i4,2a)')ip,ih,' ch132=',ch132(1:60)                   
                                                                        
!       write(6,'(6g12.3)') (array_fr(i),i=1,120,8)                     
!       write(6,'(5(f8.1,a8))') (cpstor(i),fpstor(i),i=1,100)           
!       write(6,'(10a8)') (fpstor(i),i=1,100)                           
!       write(6,'(a,a4)') 'enwr(16)=',enwr(16)                          
      label=0 
 
      if(enwr(16).eq.'ynn@') label=1 
      if(enwr(16).eq.'nyn@') label=2 
      if(enwr(16)(1:1).eq.'@') label=3 
      if(enwr(16).eq.'9999') goto 250 
      if(label.eq.0) return 
                                                                        
      if(label.eq.3) then 
       maxhss=20 
       ch132='number of values to be printed (multiple of 20)' 
       form='i5' 
       chcom='develop/enwr' 
       value=1 
       call askvalue(ch132,form,value,chcom,npl,nrd,nwr) 
       maxhss=20*value 
       if(maxhss.gt.maxthss) maxhss=maxthss 
      else 
       maxhss=maxthss 
      end if 
                                                                        
      j=1 
      do k=1,maxs 
       if(ktheo(k,0,0).gt.0) then 
         out(j)=k 
         j=j+1 
       end if 
      end do 
      j=j-1 
      if(j.le.20)write(nwr,'(a,20i3)')'set:',(int(out(k)),k=1,j) 
      if(j.gt.20)write(nwr,'(a,20i3)')'    ',(int(out(k)),k=21,j) 
      ch132='number of the set' 
      form='i5' 
      chcom='develop/enwr' 
      value=out(1) 
      call askvalue(ch132,form,value,chcom,npl,nrd,nwr) 
      ks=value 
                                                                        
      goto (100,200,100), label 
  100 continue 
      mss=1 
      do while(istrss(ks,mss).ne.0) 
       write(nwr,'(a,i1,a1,i2,a,10i3)') 'ktheo(',ks,',',mss,',0..)=',   &
     &                          (ktheo(ks,mss,k),k=0,ktheo(ks,mss,0))   
       mss=mss+1 
      end do 
                                                                        
      write(nwr,'(/,a,i2,a,i2)') 'istrss(',ks,',0)=',istrss(ks,0) 
      write(nwr,'(20i4)') (istrss(ks,k),k=1,maxhss) 
                                                                        
      mss=mss-1 
      do k=1,maxthss 
       kststr(k)=istrss(ks,k) 
       kvp(k)=0 
       kpv(k)=0 
      end do 
      call strkvp(kststr,kvp,kpv,itype,mstruct1,istruct1,istruct2) 
      write(nwr,'(a,20i4)')'kvp=', (kvp(k),k=0,16) 
      write(nwr,'(a,20i4)')'kpv=',(kpv(k),k=0,16) 
      write(nwr,'(/,a,20i4)')'istruct1=',(istruct1(k),k=0,mstruct1) 
      write(nwr,'(a,20i4)')'istruct2=',                                 &
     &                          (istruct2(k),k=0,istruct1(mstruct1))    
                                                                        
                                                                        
       do iss=0,mss 
        issv=kvp(iss) 
        li=mvadds(ks,issv)-mvadds(ks,0) 
        do i=1,mplths(ks,maxthss)-mplths(ks,0) 
         j=ivaddsp(ks,i) 
         if(j.gt.mvadds(ks,issv).and.j.le.mvadds(ks,issv+1))then 
          ipladd(i)=j-li 
         end if 
        end do 
!        li=mcadds(ks,issv)-mcadds(ks,0)                  29.08.07      
!        do i=1,mcths(ks,maxthss)-mcths(ks,0)                           
!         j=icaddsp(ks,i)                                               
!         if(j.gt.mcadds(ks,issv).and.j.le.mcadds(ks,issv+1))then       
!          icladd(i)=j-li                                               
!         end if                                                        
!        end do                                                         
       end do 
                                                                        
      write(nwr,'(2a)')'--------------------- variables and parameter', &
     &                 ' ---------------------'                         
                                                                        
      write(nwr,'(a,i2,a2,i2)') 'mplthsp(',ks,')=',mplthsp(ks) 
      write(nwr,'(a,i2,a,i2)')'mplthss(',ks,',0)=',mplthss(ks,0) 
      write(nwr,'(20i4)') (mplthss(ks,k),k=1,maxhss) 
      write(nwr,'(a,i2,a,i2)')'mplths(',ks,',0)=',mplths(ks,0) 
      write(nwr,'(20i4)') (mplths(ks,k),k=1,maxhss) 
                                                                        
      write(nwr,'(/,a,i2,a2,i2)') 'mpaddsp(',ks,')=',mpaddsp(ks) 
      write(nwr,'(a,i2,a,i2)')'mpaddss(',ks,',0)=',mpaddss(ks,0) 
      write(nwr,'(20i4)')(mpaddss(ks,k),k=1,maxhss) 
      write(nwr,'(a,i2,a,i2)')'mpadds(',ks,',0)=',mpadds(ks,0) 
      write(nwr,'(20i4)')(mpadds(ks,k),k=1,maxhss) 
                                                                        
                                                                        
      write(nwr,'(/,a,i2,a2,i2)') 'mvaddsp(',ks,')=',mvaddsp(ks) 
      write(nwr,'(a,i2,a,i2)')'mvaddss(',ks,',0)=',mvaddss(ks,0) 
      write(nwr,'(20i4)')(mvaddss(ks,k),k=1,maxhss) 
      write(nwr,'(a,i2,a,i2)')'mvadds(',ks,',0)=',mvadds(ks,0) 
      write(nwr,'(20i4)')(mvadds(ks,k),k=1,maxhss) 
                                                                        
      write(nwr,'(/,a,i2,a,i2)')'ivaddsp(',ks,',0)=',ivaddsp(ks,0) 
      write(nwr,'(20i4)') (ivaddsp(ks,k),k=1,maxhss) 
      write(nwr,'(a)') '->ipladd(1...)=' 
      write(nwr,'(20i4)') (ipladd(k),k=1,maxhss) 
                                                                        
      write(nwr,'(/,a)') 'gloabal ivadd(1...mpl+1)=' 
      i=mpl/20 
      do j=1,i 
       write(nwr,'(20i5,2x,i5)') (ivadd(k+(j-1)*20),k=1,20),j*20 
      end do 
      write(nwr,'(20i5)') (ivadd(k+i*20),k=1,20) 
                                                                        
      b_vaco=.false. 
      if(b_vaco) then 
       write(nwr,'(a)') 'vartrf ' 
       write(nwr,'(8g10.2)') (vartrf(k),k=1,4*maxhss) 
      end if 
       if(label.eq.3) goto 200 
       goto 300 
  200  continue 
!---------------------------------------------------------------        
      write(nwr,'(/,2a)')'------------------------------ constants',    &
     &                 ' --------------------------------'              
      write(nwr,'(a,i2,a2,i2)') 'mcthsp(',ks,')=',mcthsp(ks) 
      write(nwr,'(a,i2,a,i2)')'mcthss(',ks,',0)=',mcthss(ks,0) 
      write(nwr,'(20i4)')(mcthss(ks,k),k=1,maxhss) 
      write(nwr,'(a,i2,a,i2)')'mcths(',ks,',0)=',mcths(ks,0) 
      write(nwr,'(20i4)')(mcths(ks,k),k=1,maxhss) 
                                                                        
                                                                        
      write(nwr,'(/,a,i2,a2,i2)') 'mkaddsp(',ks,')=',mkaddsp(ks) 
      write(nwr,'(a,i2,a,i2)')'mkadds(',ks,',0)=',mkadds(ks,0) 
      write(nwr,'(20i4)')(mkadds(ks,k),k=1,maxhss) 
      write(nwr,'(a,i2,a,i2)')'mkaddss(',ks,',0)=',mkaddss(ks,0) 
      write(nwr,'(20i4)')(mkaddss(ks,k),k=1,maxhss) 
                                                                        
      write(nwr,'(/,a,i2,a2,i2)') 'mcaddsp(',ks,')=',mcaddsp(ks) 
      write(nwr,'(a,i2,a,i2)')'mcaddss(',ks,',0)=',mcaddss(ks,0) 
      write(nwr,'(20i4)')(mcaddss(ks,k),k=1,maxhss) 
      write(nwr,'(a,i2,a,i2)')'mcadds(',ks,',0)=',mcadds(ks,0) 
      write(nwr,'(20i4)')(mcadds(ks,k),k=1,maxhss) 
                                                                        
      write(nwr,'(/,a,i2,a,i2)') 'icaddsp(',ks,',0)=',icaddsp(ks,0) 
      write(nwr,'(20i4)') (icaddsp(ks,k),k=1,maxhss) 
      write(nwr,'(a)') '->icladd(1...)=' 
      write(nwr,'(20i4)') (icladd(k),k=1,maxhss) 
                                                                        
      write(nwr,'(/,a)') 'global icadd(1...maxc)=' 
      write(nwr,'(20i4)') (icadd(k),k=1,maxhss) 
                                                                        
      if(b_vaco)then 
       write(nwr,'(a)') 'contrf ' 
       write(nwr,'(10f8.2)') (contrf(i),i=1,4*maxhss) 
      end if 
      goto 300

 250 continue 
     allocate(p99(1000),z99(1000))
     i=1
     j=0
     do k=ipt*2,(ipt+nstorSP)*2,2
      if(real_fr(k).eq.9999.) then
        p99(i)=k        
        if(real_fr(k-2).ne.9999.) i=i+1
       j=j+1
       z99(i)=j
      else
       j=0
      end if
     end do 

     print'(a,i7,/,a,i7,a1,i7)','complex array elements occupied:',nstorSP, &
          '  N elements not used (eq to "9999") in the range',ipt,'-',(ipt+nstorSP)
     print'(a)','                          array  positions'   
     print'(a)','   i          N          from         to'        
     do k=1,i-1
     print'(i4,3(3x,i10))',k,z99(k+1), p99(k)/2,p99(k)/2+z99(k+1)-1
     end do

     deallocate(p99,z99)
!---------------------------------------------------------------        
  300  continue 

       return 
      END                                           

      subroutine zeroall 
      use glbconst, only: maxc,maxpl,maxs,maxp,maxthlv,maxprd,maxco,  &
                          maxthss,infotext
      use compar, only: maxsto,maxp_sp,maxc_sp,maxcvsp
      use comthe, only: array_fr,marray_sp
      use comeff, only: nint,n_subspect,ndispmode,displaymode,nintset
      use comeff, only: nseqsto 
      use comdat, only: n_cdatas,n_vdatas,readform,cdatas,vdatas
     implicit none 
                                                                        
      integer    ifrm 
      real       rfrm 
      character(len=4):: cfrm
     integer,parameter:: nfrmi=1+maxco*2+maxprd+maxp+1+maxs+2+        &
                         6*maxco+1+2*maxco+maxp+2+3*(1+maxs)+         &
                         3*maxs*(1+maxthss)+1+maxc+3*(1+maxs)+        &
                         7*maxs*(1+maxthss)+maxp+4*maxpl+2*maxc+      &
                         maxs*(1+maxp_sp)+maxs*(1+maxc_sp)+18,        &
                       nfrmr=9*maxp+6+maxsto+maxpl+maxc,              &
                       nfrmc=maxpl*8+maxp*15+maxc*10+maxco*4+maxsto+6*maxs*6 
      common/frmi/ifrm(nfrmi) 
      common/frmr/rfrm(nfrmr) 
      common/frmc/cfrm(nfrmc) 
                                                                        
      integer            idata
      character(len=4):: c_data 
      logical            bdata 
      integer,parameter :: maxbaddata=64,                               &
     &              idatai=12+maxs+257*maxs*2+(1+maxbaddata)*maxs+      &
     &                     2*257+1+maxs,                                &
     &              idatac=176,                                         &
     &              idatab=2+2*maxs+128*maxs+30                        
      common/datai/idata(idatai) 
      common/datac/c_data(idatac) 
      common/datab/bdata(idatab) 
                                                                        
!      common/dasi/nchndata(0:maxs),nseqdata(0:maxs),                   
!     &            i_cdata(maxs,0:maxcvsp),i_vdata(maxs,0:maxcvsp),     
!     &            ip_chan(maxs),istrss(maxs,0:maxthss),                
!     &            ktheo(maxs,0:maxthss,0:maxthlv),                     
!     &            icdata(0:maxcvsp),ivdata(0:maxcvsp)                  
                                                                        
!      common/dasr/cdata(maxs,maxcvsp),vdata(maxs,maxcvsp),             
!     &            cdatas(maxcvsp),vdatas(maxcvsp)                      
                                                                        
!      character   n_cdata*40,n_vdata*40,n_cdatas*24,n_vdatas*24,       
!     &            cdatastr*24,cstorestr*24,readform*24,                
!     &            namedata*132,datfilesp*132,nametheory*132,           
!     &            ncdata*40,nvdata*40                                  
!      common/dasc/n_cdata(maxs,maxcvsp),n_vdata(maxs,maxcvsp),         
!     &            n_cdatas(maxcvsp),n_vdatas(maxcvsp),                 
!     &            cdatastr(maxs),cstorestr(maxs),readform,             
!     &            namedata(maxs),datfilesp(maxs),nametheory(maxs),     
!     &            ncdata(maxcvsp),nvdata(maxcvsp)                      
                                                                        
!      common/dasb/b_cdata(maxs,maxcvsp),b_vdata(maxs,maxcvsp)          
      integer      idas,k 
      real         rdas 
      character(len=4):: cdas 
      logical      bdas 
      integer,parameter:: idasi=2*(1+maxcvsp)*maxs+    &
     &                    maxs*(1+maxthss)+maxs*(1+maxthss)*(1+maxthlv)+&
     &                    2*(1+maxcvsp)+maxs,                             &
     &              idasr=maxs*maxcvsp*2,                     &
     &              idasc=(maxs+1)*maxcvsp*20+maxs*99, &
     &              idasb=maxs*maxcvsp*2                               
      common/dasi/idas(idasi) 
      common/dasr/rdas(idasr) 
      common/dasc/cdas(idasc) 
      common/dasb/bdas(idasb) 
                                                                        
      n_cdatas=' '
      n_vdatas=' '
      readform=' '
      cdatas=0.0
      vdatas=0.0
      infotext=' ' 
      n_subspect=0 
      ndispmode=1 
      displaymode=' ' 
      nseqsto=0 
      nintset=0
      do k=1,maxs 
       nintset(k)=maxs+k 
      end do 
      nintset(0)=maxs*2 
                                                                        
      do k=25,marray_sp 
       array_fr(k)=cmplx(float(k),-float(k)) 
      end do 

      call zerotrf 
                                                                        
      idata=0 
      c_data=' ' 
      bdata=.false. 

      idas=0 
      rdas=0.0 
      cdas=' ' 
      bdas=.false. 
                                                                       
      ifrm=0 
      rfrm=0.0 
      cfrm=' ' 
                                                                        
      return 
      END                                           

 subroutine wall_time(wt)
  implicit none
  real, intent(out):: wt
  integer,dimension(8) :: value  

  call date_and_time(VALUES=value)
  wt=value(5)*3600.+ value(6)*60.+float(value(7))+float(value(8))/1000.
 return
end subroutine wall_time
                                                                         

      
