     program main
      implicit none
     integer,parameter :: maxco=64
     character(len=132):: queryar,helpar,type,                        &
                          querytype,chin,chcom,ch132,cp132,ct132
     character(len=16) :: ext,winfile,element
     character(len=80) :: ch80,localhepath
     character(len=3),dimension(1:3):: eai,ebi
     character          ch1*1,ch2*2    
      integer           ld,lw,laenge,lpart
      character(len=132):: infotext
      character(len=8)  :: ch8  
      character(len=6)  :: chbold,chnorm                       
      character(len=7)  :: form
      character(len=4)  :: enwr      
      character(len=2), dimension(82) :: ES
      character(len=12),dimension(82) :: Ename
      character(len=12) :: name
      real,    dimension(82) :: Emolweight
      integer, dimension(12) :: indx, mult
      real,    dimension(12) :: atcoef
 
      common/infenw/ enwr(16),infotext(8)
      common/localpath/ localhepath 
      common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)
      integer     id1,npl,ncol,nrows,ixpixel,iypixel,led,              &
                  ncl,nwr,nrd,kwin,icol
      
      common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led 
      integer i,l,lq,lk,j,k,nZ,mZ,iout,indxp,istep,nn
      real value,energy,atc,atc1,atc2,thick,density,hmol,pfr,uthick_w,  &
           act1,act2,bg0,t_eff,effect,f_factor,at_mossb,at_122,bessi0,  &
           bessi1,start,end,dinc,h0,h1,hn,hd,spl,bg,f_source
      real      out(32)
      character(len=16):: factorS, uthick57
      
    chbold=char(27)//'[1m' 
    chnorm=char(27)//'[0m' 
      ncl=80 
      nwr=6 
      nrd=5 
      kwin=1 
      call window(kwin) 
      npl=ncol(kwin) 
      icol=npl

      write(nwr,'(/,7(a,/),//)')' The program uses the tables:', &
      ' X-Ray Mass Attenuation Coefficients', &
      ' published by National Institute of Standards and Technology (NIST)',&
      ' 1996 copyright by the U.S. Secretary of Commerce',&
      ' and',&
      ' Das Periodensystem der Elemente online:Dichte der Elemente im Festzustand',&
      ' Copyright 2010-2015 by René Rausch'

      
     open (unit=1, file='elements.dat')
     do i=1,82
      read(1,'(a)')ch80
!42      Mo      Molybdenum        95.95      
      ES(i)=ch80(9:10)
      Ename(i)=ch80(17:28)
      ch132=ch80(30:)
      call trlch(20,ch132,iout,out)
      Emolweight(i)=out(1)
     end do
     close(unit=1)
!     do i=1,82
!    write(6,'(i3,2x,a2,2x,a12,4x,f10.2)')i,ES(i),Ename(i),Emolweight(i)
!     end do

      localhepath='/attenuation.help'       
5      lq=4
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       ch80='alpha' 
       ch80(80:80)='#' 
       helpar(1)='effect/alpha-iron' 
       helpar(2)='effect/sodiumnitrop' 
       helpar(3)='effect/fas' 
       helpar(4)='effect/compound' 
                                                                         
       queryar(1)='1 alpha-iron foil' 
       queryar(2)='2 Na_2Fe[(CN)_5NO]2H2O' 
       queryar(3)='3 FAS' 
       queryar(4)='4 compound' 
 
       chin='select ' 
       call query(lq,lk,chin,ch80) 
       if(lq.eq.0) goto 5
       
       factorS='0.80'
       uthick57=' 0.5907'
       act1=0.; act2=0.
       density=0.0

       select case(lq)
       case(1)
       indxp=1
       j=1
       indx(1)=26; mult(1)=1
       density= 7.8748   !g/cm**3
!       uthick_w = 0.5907 
!       f_factor=0.80 

       case(2)    
        ! Na_2Fe[(CN)_5NO]2H_2O,   1,72 g/cm3
        indxp=2
        j=6; indx(1)=11; mult(1)=2; indx(2)=26; mult(2)=1
             indx(3)=6; mult(3)=5;  indx(4)=7; mult(4)=6
             indx(5)=8; mult(5)=3;  indx(6)=1; mult(6)=2
        density=1.72; value=14.4
        uthick_w = 0.5907 
        f_factor=0.38 
        print'(a,a2)','Mossbauer nucleus: ',ES(indx(indxp))
       case(3) 
        ! (NH_4)_2Fe(SO_4)_2·6H_2O,   1,72 g/cm3
        indxp=3
        j=5; indx(1)=7; mult(1)=2; indx(2)=1; mult(2)=20
             indx(3)=26; mult(3)=1;  indx(4)=16; mult(4)=2
             indx(5)=8; mult(5)=14
        density=1.86; value=14.4
        uthick_w = 0.5907
        factorS=' 0.27'  
        print'(a,a2)','Mossbauer nucleus: ',ES(indx(indxp))
       case(4)
        querytype='formula of the compound'
        chin='N_2H_8Fe_1S_2O_8H_12O_6'
        chcom='effect/compound' 
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 

        value=1; form='i4'
        querytype='index of the Mossbauer nuclei'; chcom='effect/indxp'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        indxp=value
        call contentformula(chin,ES,j,indx,mult)
        print'(a,a2)','Mossbauer nucleus: ',ES(indx(indxp))
        factorS='0.30'

        value=0.0; form='f8.2'
        querytype='density of the compound g/cm3'; chcom='effect/density'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        density=value; 
      end select

        querytype=' uthick_w, f-factor of the sample:' 
        chcom='effect/datanulceus' 
        ch132=TRIM(uthick57)//'  '//factorS 
 6      call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
        call trlch(80,ch132,nn,out) 
        if(nn.ne.2) goto 6 
        f_factor=out(2); uthick_w=out(1)

      call fractiom(nrd,nwr,j,indxp,indx,mult,Ename,Emolweight,pfr)      
      print'(a,f8.3)','weight fraction of Mossbauer nulei',pfr 

      f_source=0.75; form='f8.3'
      querytype='f-factor of the source '; chcom='effect/f_source'
      call askvalue(querytype,form,f_source,chcom,ncol,nrd,nwr)

      energy=14.4; form='f8.2'
      querytype='Mossbauer transition energy '; chcom='effect/energy'
      call askvalue(querytype,form,energy,chcom,ncol,nrd,nwr)
      print'(a)'
      call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,energy,atc)

      if(indx(indxp).eq.26) then 
       value=122.01
       call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc1)
       value=136.46
       call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc2)
      end if

      if(density.gt.0.0)then
       lq=2
       ch80='thickness in mue' 
      else
       lq=1
       ch80='thickness mg' 
      end if
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       ch80(80:80)='#' 
       helpar(1)='effect/mgcm2' 
       helpar(2)='read/thickness' 
       queryar(1)='thickness mg/cm2' 
       queryar(2)='thickness in mue'
       chin='thickness of the sample' 
       call query(lq,lk,chin,ch80) 

       bg0=0.10;  spl=0.25
       ch132='10,0,27' 
 20    if(lq.eq.1)then
        querytype='do loop for istep,(start,end)[mg/cm2]:' 
        chcom='effect/do_loop' 
10      call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
        if(ch132(1:1).eq.'q') goto 100        
        call trlch(80,ch132,nn,out) 
        if(nn.ne.3) goto 10 
        istep=out(1); start=out(2); end=out(3) 
       else !lq=2
        querytype='do loop for istep,(start,end)[mue]:' 
        chcom='effect/do_loop' 
11      call askstring(querytype,ch132,chcom,ncl,nrd,nwr)
        if(ch132(1:1).eq.'q') goto 100
        call trlch(80,ch132,nn,out)
        if(nn.ne.3) goto 11 
        istep=out(1); start=out(2); end=out(3) 
       end if

       form='f8.3'
       querytype='background fraction without sample'; chcom='effect/bg_fr'
       call askvalue(querytype,form,bg0,chcom,ncol,nrd,nwr)
       form='f8.4'
       querytype='hyperfine field splitting, intensity fraction'; 
       chcom='effect/splitting'
       call askvalue(querytype,form,spl,chcom,ncol,nrd,nwr)
       dinc=(end-start)/float(istep)
       if(lq.eq.1)then
        print'(a)','    mg/cm2     effect    G/G_nat    bg       ~time'
       else
        print'(a)','      mue      effect    G/G_nat    bg       ~time'
       end if

       do i=1,istep+1
        thick=start+dinc*(i-1)
        if(lq.eq.1) thick=thick/1.e3 
        if(lq.eq.2) thick=thick*density/1.e4 
        t_eff=thick*pfr*uthick_w*f_factor*1.e3*spl
        ! thick in g/cm2; t_eff in mg/cm2 

        ! the attenuation of the 14.4 keV and 122/136 keV radiation
        at_mossb=exp(-thick*atc)
        at_122=0.111*exp(-thick*atc2)+0.889*exp(-thick*atc1)
        h0=BESSI0(t_eff/2.)
        h1=BESSI1(t_eff/2.)
        hn=t_eff*EXP(-t_eff/2.)*(h0+h1)
        hd=1.-EXP(-t_eff/2.)*h0
!       print'(a,8f8.3)',' t_eff=',t_eff,thick,pfr,uthick_w,f_factor,atc,spl
!       print'(a,8f8.3)',' t_eff=',t_eff/2.,hd,at_122,at_mossb

        ! bg0 is the fraction without absorber. Only the empty container is
        ! measured.
        ! bg0=(background_c)/total_counts,
        ! background_c= background/at_122(container) is the corrected background
        ! at_122(container) is typically very close to 1 (can be neglected)
        
        ! calculation of bg fraction with absorber of thickness thick
        ! and attenuations of at_mossb(14.4 keV), at_122(absorber)
        ! The measured background becomes background(container)*at_122(absorber)
        ! after correction it is again the value  background_c
        ! The total_counts change by the attenuation of the 14.4keV, so that
        ! total_counts(container+sample)=
        ! (total_counts(container)-background_c)*at_mossb + background_c
        ! The new  fraction is bg=background_c/total_counts(container+sample)
        
        ! bg=bg0*total_counts(container)/
        ! [(total_counts(container)-background_c)*at_mossb + background_c]
        !   = bg0/[(1-bg0)*at_mossb+bg0]
        bg=bg0/((1-bg0)*at_mossb+bg0)
        ! The effect decreases with increasing background. In "Mossbauer Effect und
        ! seine Anwendungen ..." (Horst Wegener) eq. 1.40 the effect (zero background)
        ! is calculated for source and absorber with natural linewidth:
        ! effect_0=f_source*(1.-EXP(-t_eff/2.)*BESSI0(t_eff/2.))
        ! teff= f_absorber*N*beta*sigma_0*d (N*beta: density of 57Fe, d[cm]: thickness)
        ! effect_0=(Z_oo-Z_0)/Z_oo
        ! The background(container+sample) inreases the counts to Z+ background/N_channel
        ! the Z are decreased by at_mossb
        ! effect=(Z_oo-Z_0)/(Z_oo*atmoss+background/N_channel)
        !       =effect_0* Z_oo(container)*at_mossb/
        !                  [Z_oo(container)*at_mossb+background(container+sample)/N_channel]
        !  Z_oo(container)=total_counts(container)/N_channel
        ! 
        effect=f_source*hd/(1+bg0/at_mossb)
        h0=sqrt(at_mossb/(1.-effect))*effect
        ! to have the largest effect or the largest effect in shortest time
        ! is a different question. If bg0 > 0 there is a maximum of effect(thick).
        ! The time comes in if the extremum of the counts=effect*Z_0*at_moss devided
        ! by the the error the square_root(counts) ~ sqrt(effect*at_moss)
        ! The maximum of sqrt(effect*at_mossb) is at much smaller thickness
        ! The linewidth in units of the natural width is also only true for
        ! natural widths of source and absorber.
        if(i.eq.1)then
         print'(4f10.3,a)',start+dinc*(i-1),effect,2.0,bg,'      oo'
        else
        print'(8f10.3)',start+dinc*(i-1),effect,hn/hd,bg,1/h0
        
        end if
       end do
      ch1='y'
      querytype='new values for "do loop", bg(0) and intensity fraction'
      chcom='effect/repeat'
      call yesno(querytype,ch1,chcom,ncol,nrd,nwr)   
      if(ch1.eq.'y') goto 20
 100 continue     
end program main
     


    subroutine contentformula(formula,ES,j,indx,mult)
   implicit none
   
   character(len=132), intent(in):: formula
   character(len=2), dimension(82), intent(in):: ES
   integer, intent(out):: j
   integer, dimension(12), intent(out):: indx,mult

   character(len=132) :: ch132,cp132 
   character(len=2)   :: ch2
   integer i,l,k,m,mu
Print*,TRIM(formula)
    j=1
    ch132=ADJUSTL(formula)

100 if(ch132(2:2).eq.'_') then
     ch2=ch132(1:1)
     l=ichar(ch132(3:3))-48; m=ichar(ch132(4:4))-48
     k=4; mu=l
     if(m.le.9.and.m.ge.0)then
      k=5; mu=mu*10+m
     end if
    else
     ch2=ch132(1:2)
     l=ichar(ch132(4:4))-48; m=ichar(ch132(5:5))-48
     k=5; mu=l
     if(m.le.9.and.m.ge.0)then
      k=6; mu=mu*10+m
     end if
    end if
    cp132=ch132(k:)
    ch132=cp132
!print*,TRIM(ch132)
        i=1
        do while(ES(i).ne.ch2)
         i=i+1
        end do
      indx(j)=i; mult(j)=mu
      j=j+1
    if(ch132.ne.' ') goto 100
    j=j-1
!print'(2i5)',(indx(k),mult(k),k=1,j)
    return 
    end

  
  subroutine fractiom(nrd,nwr,j,indxp,indx,mult,Ename,Emolweight,pfr)
   implicit none
   integer, intent(in):: j,indxp,nrd,nwr
   integer, dimension(12), intent(in):: indx,mult
   character(len=12), dimension(82), intent(in):: Ename 
   real,              dimension(82), intent(in):: Emolweight   
   real, intent(out) :: pfr
   integer i
   real  hmol
        hmol=0.
        do i=1,j
         hmol=hmol+mult(i)*Emolweight(indx(i))
        end do
        i=indxp
        pfr=mult(i)*Emolweight(indx(i))/hmol
      return
     end

 subroutine attenuation(energy,atc)
!====================================================================
!parabola interpolation described 
!====================================================================
   implicit none
   real, intent(in):: energy
   real, intent(out):: atc
   integer, parameter:: n=64
double precision, dimension (n) :: xi,yi,zi
double precision, dimension (4) :: xs, ys, zs, b,c,d
double precision x, y, step
integer i,ns
double precision f
character*80 input

do i=1,6
   read(1,'(a)')input
!   print'(a)',input
end do
! step 1: generate xi and yi from f(x), xmin, xmax, n
i=0
do while(i.lt.n)
   i=i+1
   read(1,'(3x,e11.5,2x,e9.3,2x,e9.3)',err=10)xi(i),yi(i),zi(i)
!   print*,i,xi(i),yi(i)
end do
10 continue

 x=energy*1.0e-3
 i=1
do while(x.ge.xi(i))
! print*,i,xi(i),yi(i)
   i=i+1
end do
! print*,i,xi(i),yi(i)
i=i-1
! print*,'i=',i
if(xi(i).eq.x) then
  atc=yi(i)
  goto 100
end if

if(xi(i+1).eq.xi(i+2)) then
! print*,'case xi(i+1).eq.xi(i+2)'
  ns=3
  xs(1)=xi(i-1); xs(2)=xi(i); xs(3)=xi(i+1)
  ys(1)=yi(i-1); ys(2)=yi(i); ys(3)=yi(i+1)
  goto 100
end if

if(xi(i-1).eq.xi(i)) then
! print*,'case xi(i-1).eq.xi(i)'
  ns=3
  xs(1)=xi(i); xs(2)=xi(i+1); xs(3)=xi(i+2)
  ys(1)=yi(i); ys(2)=yi(i+1); ys(3)=yi(i+2)
  goto 100
end if
! print*,'case ns=4'
  ns=4
  xs(1)=xi(i-1); xs(2)=xi(i); xs(3)=xi(i+1); xs(4)=xi(i+2) 
  ys(1)=yi(i-1); ys(2)=yi(i); ys(3)=yi(i+1); ys(4)=yi(i+2) 

100 continue
!   print'(4f12.3)',xs*1000.
!   print'(4f12.3)',ys
   call parabel(ns,xs,ys,x,atc)
end subroutine attenuation

       subroutine parabel(ns,xs,ys,us,att)
        real*8, dimension(4), intent(inout)::xs,ys
        integer, intent(in):: ns
        real*8,    intent(in):: us
        real,   intent(out):: att 
        real*8, dimension(3,3) :: c
        real*8,   dimension(3) :: y,ak
        real*8 :: u,x1,x2,x3,x4,f1,f3,f4,hf,ha,h12,h43,a,b
        
        xs=xs*1000.0

       if(ns.eq.4) then  
!        eq-system
!        ys(i) = Sum_k a_k*xs(i)**k      (k=3,2,1,0)   
!        ys(i)-ys(2)= Sum_k a_k*(xs(i)**k-xs(2)**k)        k=3,2,1         
        u=us*1000.-xs(2)
        x1=xs(1)-xs(2); x2=0.0; x3=xs(3)-xs(2); x4=xs(4)-xs(2);
        f1=ys(1)-ys(2); f3=ys(3)-ys(2); f4=ys(4)-ys(2);
        h13=(x1-x3)*x1; h43=(x4-x3)*x4
        hf=f1*h13+f4*h43 - f3*(h13*x1+h43*x4)/x3
        ha=h13**2+h43**2
        a=hf/ha
        b=f3/x3-a*x3
        att=a*u**2+b*u+ys(2)
       else if(ns.eq.3)then
         u=us*1000.
         y(1)=ys(1);y(2)=ys(2);y(3)=ys(3) 
         x1=xs(1); x2=xs(2); x3=xs(3)         
         a11=x1**2; a12=x1; a13=1.d0
         a21=x2**2; a22=x2; a23=1.d0         
         a31=x3**2; a32=x3; a33=1.d0
         det=a11*(a22*a33-a32*a23)-a12*(a21*a33-a31*a23)+a13*(a21*a32-a31*a22)
         c(1,1)=(a22*a33-a32*a23); c(1,2)=(a13*a32-a33*a12); c(1,3)=(a12*a23-a22*a13)
         c(2,1)=(a23*a31-a33*a21); c(2,2)=(a11*a33-a31*a13); c(2,3)=(a13*a21-a23*a11)
         c(3,1)=(a21*a32-a31*a22); c(3,2)=(a12*a31-a32*a11); c(3,3)=(a11*a22-a21*a12)
         c=c/det
         ak=matmul(c,y)
         att=ak(1)*u**2+ak(2)*u+ak(3)
        end if
        return
        end


   subroutine atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,energy,atc)
   implicit none
   integer, intent(in):: j,nrd,nwr
   integer, dimension(12), intent(in):: indx,mult
   character(len=12), dimension(82), intent(in):: Ename 
   real,              dimension(82), intent(in):: Emolweight   
   real, intent(in)  :: energy
   real, intent(out) :: atc

   character(len=132):: chcom,querytype
   character(len=12):: name,element
   character(len=7) :: form
   real,    dimension(12) :: atcoef
   real    hmol
   integer ncol,i,l

!        ncol=80
!        chcom='read/compound' 
!        form='f8.2'
!        querytype='Photon energy in keV'; chcom='read/energy'
!        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
!        energy=value

        do i=1,j
         name=Ename(indx(i))
         open (unit=1, file='attenuation.coefficients')
         l=LEN_TRIM(name)+1
         element=' '  
         do while(element(2:l).ne.name)
          read(1,'(a)')element
         end do
         read(1,'(a)')element
         call attenuation(energy,atc)
         close(unit=1)       
         atcoef(i)=atc
        end do
        hmol=0.
        do i=1,j
         hmol=hmol+mult(i)*Emolweight(indx(i))
        end do
        atc=0.
        do i=1,j
         atc=atc+mult(i)*Emolweight(indx(i))*atcoef(i)
        end do
        atc=atc/hmol
        print'(f7.2,a,f7.3,a)',energy,'keV    mue/rho=',atc,' [cm2/g]'
      return
     end

     FUNCTION BESSI0(X)
!     real, intent(in):: XX  
     REAL(kind=8):: Y,P1,P2,P3,P4,P5,P6,P7,                            &
                    Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9                                    
     DATA P1,P2,P3,P4,P5,P6,P7/1.0D0,3.5156229D0,3.0899424D0,  &
                               1.2067492D0,                    &
                               0.2659732D0,0.360768D-1,0.45813D-2/                           
     DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1,        &
         0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,           &
         0.2635537D-1,-0.1647633D-1,0.392377D-2/
     !X=XX
     IF (ABS(X).LT.3.75) THEN 
       Y=(X/3.75)**2 
       BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))) 
     ELSE 
       AX=ABS(X) 
       Y=3.75/AX 
       BESSI0=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4                 &
           +Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))                       
     ENDIF 
     RETURN 
     END                                           

     FUNCTION BESSI1(X)
      REAL*8 Y,P1,P2,P3,P4,P5,P6,P7,&
         Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9
      DATA P1,P2,P3,P4,P5,P6,P7/0.5D0,0.87890594D0,0.51498869D0,&
         0.15084934D0,0.2658733D-1,0.301532D-2,0.32411D-3/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,-0.3988024D-1,&
         -0.362018D-2,0.163801D-2,-0.1031555D-1,0.2282967D-1,&
         -0.2895312D-1,0.1787654D-1,-0.420059D-2/
      IF (ABS(X).LT.3.75) THEN
        Y=(X/3.75)**2
        BESSI1=X*(P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))))
      ELSE
        AX=ABS(X)
        Y=3.75/AX
        BESSI1=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+  &
           Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))
      ENDIF
      RETURN
      END
